/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/types","vs/base/common/errors","vs/base/common/network","vs/platform/log/common/log","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/base/common/map","fs","os","vs/base/common/process","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/base/common/errorMessage","vs/base/common/extpath","vs/base/common/performance","vs/editor/common/core/range","vs/base/parts/ipc/common/ipc","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/codicons","vs/base/common/marshalling","vs/base/common/uriIpc","child_process","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/common/mime","vs/base/common/processes","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/decorators","vs/base/common/functional","vs/base/common/json","vs/base/common/lazy","path","net","vs/base/common/glob","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/workspace/common/workspace","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/node/zip","vs/base/common/amd","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/themables","vs/editor/common/core/position","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/environmentService","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/server/node/extensionsScannerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/common/labels","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remote/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostTestItem","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","fs/promises","readline","util","minimist","assert","graceful-fs","https","yauzl","yazl","http","vs/server/node/server.main"],be=function(ue){for(var e=[],D=0,R=ue.length;D<R;D++)e[D]=pe[ue[D]];return e};define(pe[94],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const r=new Map,I=new Map,P=new Map,C=new Map;function v(u,g){u.has(g.detail)||u.set(g.detail,-g.timestamp)}function b(u,g){const d=u.get(g.detail);d&&(d>=0||u.set(g.detail,d+g.timestamp))}let A=[];typeof ue=="function"&&typeof ue.getStats=="function"&&(A=ue.getStats().slice(0).sort((u,g)=>u.timestamp-g.timestamp));for(const u of A)switch(u.type){case 10:v(r,u);break;case 11:case 12:b(r,u);break;case 21:v(I,u);break;case 22:b(I,u);break;case 33:v(P,u);break;case 34:b(P,u);break;case 31:v(C,u);break;case 32:b(C,u);break}let S=0;P.forEach(u=>S+=u);function y(u){const g=[];return u.forEach((d,f)=>g.push([f,d])),g}return{amdLoad:y(r),amdInvoke:y(I),nodeRequire:y(P),nodeEval:y(C),nodeRequireTotal:S}}static toMarkdownTable(r,I){let P="";const C=[];return r.forEach((v,b)=>{C[b]=v.length}),I.forEach(v=>{v.forEach((b,A)=>{typeof b>"u"&&(b=v[A]="-");const S=b.toString().length;C[A]=Math.max(S,C[A])})}),r.forEach((v,b)=>{P+=`| ${v+" ".repeat(C[b]-v.toString().length)} `}),P+=`|
`,r.forEach((v,b)=>{P+=`| ${"-".repeat(C[b])} `}),P+=`|
`,I.forEach(v=>{v.forEach((b,A)=>{typeof b<"u"&&(P+=`| ${b+" ".repeat(C[A]-b.toString().length)} `)}),P+=`|
`}),P}}e.$U=D}),define(pe[141],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function D(d,f,h){const p=R(d,f);if(p!==-1)return d[p]}e.$fb=D;function R(d,f,h=d.length-1){for(let p=h;p>=0;p--){const l=d[p];if(f(l))return p}return-1}e.$gb=R;function r(d,f){const h=I(d,f);return h===-1?void 0:d[h]}e.$hb=r;function I(d,f,h=0,p=d.length){let l=h,m=p;for(;l<m;){const c=Math.floor((l+m)/2);f(d[c])?l=c+1:m=c}return l-1}e.$ib=I;function P(d,f){const h=C(d,f);return h===d.length?void 0:d[h]}e.$jb=P;function C(d,f,h=0,p=d.length){let l=h,m=p;for(;l<m;){const c=Math.floor((l+m)/2);f(d[c])?m=c:l=c+1}return l}e.$kb=C;function v(d,f,h=0,p=d.length){const l=C(d,f,h,p);return l===d.length?-1:l}e.$lb=v;class b{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(b.assertInvariants){if(this.d){for(const p of this.e)if(this.d(p)&&!f(p))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const h=I(this.e,f,this.c);return this.c=h+1,h===-1?void 0:this.e[h]}}e.$mb=b;function A(d,f){if(d.length===0)return;let h=d[0];for(let p=1;p<d.length;p++){const l=d[p];f(l,h)>0&&(h=l)}return h}e.$nb=A;function S(d,f){if(d.length===0)return;let h=d[0];for(let p=1;p<d.length;p++){const l=d[p];f(l,h)>=0&&(h=l)}return h}e.$ob=S;function y(d,f){return A(d,(h,p)=>-f(h,p))}e.$pb=y;function u(d,f){if(d.length===0)return-1;let h=0;for(let p=1;p<d.length;p++){const l=d[p];f(l,d[h])>0&&(h=p)}return h}e.$qb=u;function g(d,f){for(const h of d){const p=f(h);if(p!==void 0)return p}}e.$rb=g}),define(pe[142],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function D(P,C){const v=Object.create(null);for(const b of P){const A=C(b);let S=v[A];S||(S=v[A]=[]),S.push(b)}return v}e.$J=D;function R(P,C){const v=[],b=[];for(const A of P)C.has(A)||v.push(A);for(const A of C)P.has(A)||b.push(A);return{removed:v,added:b}}e.$K=R;function r(P,C){const v=[],b=[];for(const[A,S]of P)C.has(A)||v.push(S);for(const[A,S]of C)P.has(A)||b.push(S);return{removed:v,added:b}}e.$L=r;function I(P,C){const v=new Set;for(const b of C)P.has(b)&&v.add(b);return v}e.$M=I}),define(pe[73],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function D(P){return(C,v,b)=>{let A=null,S=null;if(typeof b.value=="function"?(A="value",S=b.value):typeof b.get=="function"&&(A="get",S=b.get),!S)throw new Error("not supported");b[A]=P(S,v)}}function R(P,C,v){let b=null,A=null;if(typeof v.value=="function"?(b="value",A=v.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(b="get",A=v.get),!A)throw new Error("not supported");const S=`$memoize$${C}`;v[b]=function(...y){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,y)}),this[S]}}e.$ih=R;function r(P,C,v){return D((b,A)=>{const S=`$debounce$${A}`,y=`$debounce$result$${A}`;return function(...u){this[y]||(this[y]=v?v():void 0),clearTimeout(this[S]),C&&(this[y]=C(this[y],...u),u=[this[y]]),this[S]=setTimeout(()=>{b.apply(this,u),this[y]=v?v():void 0},P)}})}e.$jh=r;function I(P,C,v){return D((b,A)=>{const S=`$throttle$timer$${A}`,y=`$throttle$result$${A}`,u=`$throttle$lastRun$${A}`,g=`$throttle$pending$${A}`;return function(...d){if(this[y]||(this[y]=v?v():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),C&&(this[y]=C(this[y],...d)),this[g])return;const f=this[u]+P;f<=Date.now()?(this[u]=Date.now(),b.apply(this,[this[y]]),this[y]=v?v():void 0):(this[g]=!0,this[S]=setTimeout(()=>{this[g]=!1,this[u]=Date.now(),b.apply(this,[this[y]]),this[y]=v?v():void 0},f-Date.now()))}})}e.$kh=I}),define(pe[11],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class D{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?l.isErrorNoTelemetry(n)?new l(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(i=>{i(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$W=D,e.$X=new D;function R(c){e.$X.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=R;function r(c){if(!c||typeof c!="object")return!1;const n=c;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}e.$Z=r;function I(c){b(c)||e.$X.onUnexpectedError(c)}e.$1=I;function P(c){b(c)||e.$X.onUnexpectedExternalError(c)}e.$2=P;function C(c){if(c instanceof Error){const{name:n,message:i}=c,o=c.stacktrace||c.stack;return{$isError:!0,name:n,message:i,stack:o,noTelemetry:l.isErrorNoTelemetry(c)}}return c}e.$3=C;const v="Canceled";function b(c){return c instanceof A?!0:c instanceof Error&&c.name===v&&c.message===v}e.$4=b;class A extends Error{constructor(){super(v),this.name=this.message}}e.$5=A;function S(){const c=new Error(v);return c.name=c.message,c}e.$6=S;function y(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.$7=y;function u(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.$8=u;class g extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=g;function d(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.$0=d;class f extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$$=f;class h extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$_=h;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=p;class l extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof l)return n;const i=new l;return i.message=n.message,i.stack=n.stack,i}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$bb=l;class m extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}e.$cb=m}),define(pe[18],be([1,0,11,141]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function r(T,q=0){return T[T.length-(1+q)]}e.$sb=r;function I(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.$tb=I;function P(T,q,z=(te,H)=>te===H){if(T===q)return!0;if(!T||!q||T.length!==q.length)return!1;for(let te=0,H=T.length;te<H;te++)if(!z(T[te],q[te]))return!1;return!0}e.$ub=P;function C(T,q){const z=T.length-1;q<z&&(T[q]=T[z]),T.pop()}e.$vb=C;function v(T,q,z){return b(T.length,te=>z(T[te],q))}e.$wb=v;function b(T,q){let z=0,te=T-1;for(;z<=te;){const H=(z+te)/2|0,Y=q(H);if(Y<0)z=H+1;else if(Y>0)te=H-1;else return H}return-(z+1)}e.$xb=b;function A(T,q,z){if(T=T|0,T>=q.length)throw new TypeError("invalid index");const te=q[Math.floor(q.length*Math.random())],H=[],Y=[],V=[];for(const Q of q){const se=z(Q,te);se<0?H.push(Q):se>0?Y.push(Q):V.push(Q)}return T<H.length?A(T,H,z):T<H.length+V.length?V[0]:A(T-(H.length+V.length),Y,z)}e.$yb=A;function S(T,q){const z=[];let te;for(const H of T.slice(0).sort(q))!te||q(te[0],H)!==0?(te=[H],z.push(te)):te.push(H);return z}e.$zb=S;function*y(T,q){let z,te;for(const H of T)te!==void 0&&q(te,H)?z.push(H):(z&&(yield z),z=[H]),te=H;z&&(yield z)}e.$Ab=y;function u(T,q){for(let z=0;z<=T.length;z++)q(z===0?void 0:T[z-1],z===T.length?void 0:T[z])}e.$Bb=u;function g(T,q){for(let z=0;z<T.length;z++)q(z===0?void 0:T[z-1],T[z],z+1===T.length?void 0:T[z+1])}e.$Cb=g;function d(T,q,z){const te=[];function H(Q,se,me){if(se===0&&me.length===0)return;const Ee=te[te.length-1];Ee&&Ee.start+Ee.deleteCount===Q?(Ee.deleteCount+=se,Ee.toInsert.push(...me)):te.push({start:Q,deleteCount:se,toInsert:me})}let Y=0,V=0;for(;;){if(Y===T.length){H(Y,0,q.slice(V));break}if(V===q.length){H(Y,T.length-Y,[]);break}const Q=T[Y],se=q[V],me=z(Q,se);me===0?(Y+=1,V+=1):me<0?(H(Y,1,[]),Y+=1):me>0&&(H(Y,0,[se]),V+=1)}return te}e.$Db=d;function f(T,q,z){const te=d(T,q,z),H=[],Y=[];for(const V of te)H.push(...T.slice(V.start,V.start+V.deleteCount)),Y.push(...V.toInsert);return{removed:H,added:Y}}e.$Eb=f;function h(T,q,z){if(z===0)return[];const te=T.slice(0,z).sort(q);return l(T,q,te,z,T.length),te}e.top=h;function p(T,q,z,te,H){return z===0?Promise.resolve([]):new Promise((Y,V)=>{(async()=>{const Q=T.length,se=T.slice(0,z).sort(q);for(let me=z,Ee=Math.min(z+te,Q);me<Q;me=Ee,Ee=Math.min(Ee+te,Q)){if(me>z&&await new Promise(Ce=>setTimeout(Ce)),H&&H.isCancellationRequested)throw new D.$5;l(T,q,se,me,Ee)}return se})().then(Y,V)})}e.$Gb=p;function l(T,q,z,te,H){for(const Y=z.length;te<H;te++){const V=T[te];if(q(V,z[Y-1])<0){z.pop();const Q=(0,R.$kb)(z,se=>q(V,se)<0);z.splice(Q,0,V)}}}function m(T){return T.filter(q=>!!q)}e.$Hb=m;function c(T){let q=0;for(let z=0;z<T.length;z++)T[z]&&(T[q]=T[z],q+=1);T.length=q}e.$Ib=c;function n(T,q,z){T.splice(z,0,T.splice(q,1)[0])}e.$Jb=n;function i(T){return!Array.isArray(T)||T.length===0}e.$Kb=i;function o(T){return Array.isArray(T)&&T.length>0}e.$Lb=o;function s(T,q=z=>z){const z=new Set;return T.filter(te=>{const H=q(te);return z.has(H)?!1:(z.add(H),!0)})}e.$Mb=s;function t(T){const q=new Set;return z=>{const te=T(z);return q.has(te)?!1:(q.add(te),!0)}}e.$Nb=t;function a(T,q){return T.length>0?T[0]:q}e.$Ob=a;function $(T,q){return T.length>0?T[T.length-1]:q}e.$Pb=$;function w(T,q,z=(te,H)=>te===H){let te=0;for(let H=0,Y=Math.min(T.length,q.length);H<Y&&z(T[H],q[H]);H++)te++;return te}e.$Qb=w;function k(T){return[].concat(...T)}e.$Rb=k;function E(T,q){let z=typeof q=="number"?T:0;typeof q=="number"?z=T:(z=0,q=T);const te=[];if(z<=q)for(let H=z;H<q;H++)te.push(H);else for(let H=z;H>q;H--)te.push(H);return te}e.$Sb=E;function L(T,q,z){return T.reduce((te,H)=>(te[q(H)]=z?z(H):H,te),Object.create(null))}e.$Tb=L;function j(T,q){return T.push(q),()=>x(T,q)}e.$Ub=j;function x(T,q){const z=T.indexOf(q);if(z>-1)return T.splice(z,1),q}e.$Vb=x;function ce(T,q,z){const te=T.slice(0,q),H=T.slice(q);return te.concat(z,H)}e.$Wb=ce;function X(T,q){let z;if(typeof q=="number"){let te=q;z=()=>{const H=Math.sin(te++)*179426549;return H-Math.floor(H)}}else z=Math.random;for(let te=T.length-1;te>0;te-=1){const H=Math.floor(z()*(te+1)),Y=T[te];T[te]=T[H],T[H]=Y}}e.$Xb=X;function ie(T,q){const z=T.indexOf(q);z>-1&&(T.splice(z,1),T.unshift(q))}e.$Yb=ie;function he(T,q){const z=T.indexOf(q);z>-1&&(T.splice(z,1),T.push(q))}e.$Zb=he;function _(T,q){for(const z of q)T.push(z)}e.$1b=_;function de(T,q){return Array.isArray(T)?T.map(q):q(T)}e.$2b=de;function Z(T){return Array.isArray(T)?T:[T]}e.$3b=Z;function ne(T){return T[Math.floor(Math.random()*T.length)]}e.$4b=ne;function J(T,q,z){const te=oe(T,q),H=T.length,Y=z.length;T.length=H+Y;for(let V=H-1;V>=te;V--)T[V+Y]=T[V];for(let V=0;V<Y;V++)T[V+te]=z[V]}e.$5b=J;function W(T,q,z,te){const H=oe(T,q);let Y=T.splice(H,z);return Y===void 0&&(Y=[]),J(T,H,te),Y}e.$6b=W;function oe(T,q){return q<0?Math.max(q+T.length,0):Math.min(q,T.length)}var le;(function(T){function q(Y){return Y<0}T.isLessThan=q;function z(Y){return Y<=0}T.isLessThanOrEqual=z;function te(Y){return Y>0}T.isGreaterThan=te;function H(Y){return Y===0}T.isNeitherLessOrGreaterThan=H,T.greaterThan=1,T.lessThan=-1,T.neitherLessOrGreaterThan=0})(le||(e.CompareResult=le={}));function re(T,q){return(z,te)=>q(T(z),T(te))}e.$7b=re;function ee(...T){return(q,z)=>{for(const te of T){const H=te(q,z);if(!le.isNeitherLessOrGreaterThan(H))return H}return le.neitherLessOrGreaterThan}}e.$8b=ee;const B=(T,q)=>T-q;e.$9b=B;const K=(T,q)=>(0,e.$9b)(T?1:0,q?1:0);e.$0b=K;function N(T){return(q,z)=>-T(q,z)}e.$$b=N;class O{constructor(q){this.g=q,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(q){let z=this.c;for(;z<this.g.length&&q(this.g[z]);)z++;const te=z===this.c?null:this.g.slice(this.c,z);return this.c=z,te}takeFromEndWhile(q){let z=this.d;for(;z>=0&&q(this.g[z]);)z--;const te=z===this.d?null:this.g.slice(z+1,this.d+1);return this.d=z,te}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const q=this.g[this.c];return this.c++,q}removeLast(){const q=this.g[this.d];return this.d--,q}takeCount(q){const z=this.g.slice(this.c,this.c+q);return this.c+=q,z}}e.$_b=O;class U{static{this.empty=new U(q=>{})}constructor(q){this.iterate=q}forEach(q){this.iterate(z=>(q(z),!0))}toArray(){const q=[];return this.iterate(z=>(q.push(z),!0)),q}filter(q){return new U(z=>this.iterate(te=>q(te)?z(te):!0))}map(q){return new U(z=>this.iterate(te=>z(q(te))))}some(q){let z=!1;return this.iterate(te=>(z=q(te),!z)),z}findFirst(q){let z;return this.iterate(te=>q(te)?(z=te,!1):!0),z}findLast(q){let z;return this.iterate(te=>(q(te)&&(z=te),!0)),z}findLastMaxBy(q){let z,te=!0;return this.iterate(H=>((te||le.isGreaterThan(q(H,z)))&&(te=!1,z=H),!0)),z}}e.$ac=U}),define(pe[95],be([1,0,11]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function R(v,b){if(!v)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=R;function r(v,b="Unreachable"){throw new Error(b)}e.$4c=r;function I(v){if(!v)throw new D.$cb("Assertion Failed")}e.$5c=I;function P(v){if(!v()){debugger;v(),(0,D.$1)(new D.$cb("Assertion Failed"))}}e.$6c=P;function C(v,b){let A=0;for(;A<v.length-1;){const S=v[A],y=v[A+1];if(!b(S,y))return!1;A++}return!0}e.$7c=C}),define(pe[74],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function D(R){const r=this;let I=!1,P;return function(){return I||(I=!0,P=R.apply(r,arguments)),P}}e.$db=D}),define(pe[47],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(R){function r(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}R.is=r;const I=Object.freeze([]);function P(){return I}R.empty=P;function*C(c){yield c}R.single=C;function v(c){return r(c)?c:C(c)}R.wrap=v;function b(c){return c||I}R.from=b;function*A(c){for(let n=c.length-1;n>=0;n--)yield c[n]}R.reverse=A;function S(c){return!c||c[Symbol.iterator]().next().done===!0}R.isEmpty=S;function y(c){return c[Symbol.iterator]().next().value}R.first=y;function u(c,n){for(const i of c)if(n(i))return!0;return!1}R.some=u;function g(c,n){for(const i of c)if(n(i))return i}R.find=g;function*d(c,n){for(const i of c)n(i)&&(yield i)}R.filter=d;function*f(c,n){let i=0;for(const o of c)yield n(o,i++)}R.map=f;function*h(...c){for(const n of c)for(const i of n)yield i}R.concat=h;function p(c,n,i){let o=i;for(const s of c)o=n(o,s);return o}R.reduce=p;function*l(c,n,i=c.length){for(n<0&&(n+=c.length),i<0?i+=c.length:i>c.length&&(i=c.length);n<i;n++)yield c[n]}R.slice=l;function m(c,n=Number.POSITIVE_INFINITY){const i=[];if(n===0)return[i,c];const o=c[Symbol.iterator]();for(let s=0;s<n;s++){const t=o.next();if(t.done)return[i,R.empty()];i.push(t.value)}return[i,{[Symbol.iterator](){return o}}]}R.consume=m})(D||(e.Iterable=D={}))}),define(pe[75],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var R;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var r;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(r||(e.ParseErrorCode=r={}));var I;(function(n){n.DEFAULT={allowTrailingComma:!0}})(I||(e.ParseOptions=I={}));function P(n,i=!1){let o=0;const s=n.length;let t="",a=0,$=16,w=0;function k(ie){let he=0,_=0;for(;he<ie;){const de=n.charCodeAt(o);if(de>=48&&de<=57)_=_*16+de-48;else if(de>=65&&de<=70)_=_*16+de-65+10;else if(de>=97&&de<=102)_=_*16+de-97+10;else break;o++,he++}return he<ie&&(_=-1),_}function E(ie){o=ie,t="",a=0,$=16,w=0}function L(){const ie=o;if(n.charCodeAt(o)===48)o++;else for(o++;o<n.length&&b(n.charCodeAt(o));)o++;if(o<n.length&&n.charCodeAt(o)===46)if(o++,o<n.length&&b(n.charCodeAt(o)))for(o++;o<n.length&&b(n.charCodeAt(o));)o++;else return w=3,n.substring(ie,o);let he=o;if(o<n.length&&(n.charCodeAt(o)===69||n.charCodeAt(o)===101))if(o++,(o<n.length&&n.charCodeAt(o)===43||n.charCodeAt(o)===45)&&o++,o<n.length&&b(n.charCodeAt(o))){for(o++;o<n.length&&b(n.charCodeAt(o));)o++;he=o}else w=3;return n.substring(ie,he)}function j(){let ie="",he=o;for(;;){if(o>=s){ie+=n.substring(he,o),w=2;break}const _=n.charCodeAt(o);if(_===34){ie+=n.substring(he,o),o++;break}if(_===92){if(ie+=n.substring(he,o),o++,o>=s){w=2;break}switch(n.charCodeAt(o++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const Z=k(4);Z>=0?ie+=String.fromCharCode(Z):w=4;break}default:w=5}he=o;continue}if(_>=0&&_<=31)if(v(_)){ie+=n.substring(he,o),w=2;break}else w=6;o++}return ie}function x(){if(t="",w=0,a=o,o>=s)return a=s,$=17;let ie=n.charCodeAt(o);if(C(ie)){do o++,t+=String.fromCharCode(ie),ie=n.charCodeAt(o);while(C(ie));return $=15}if(v(ie))return o++,t+=String.fromCharCode(ie),ie===13&&n.charCodeAt(o)===10&&(o++,t+=`
`),$=14;switch(ie){case 123:return o++,$=1;case 125:return o++,$=2;case 91:return o++,$=3;case 93:return o++,$=4;case 58:return o++,$=6;case 44:return o++,$=5;case 34:return o++,t=j(),$=10;case 47:{const he=o-1;if(n.charCodeAt(o+1)===47){for(o+=2;o<s&&!v(n.charCodeAt(o));)o++;return t=n.substring(he,o),$=12}if(n.charCodeAt(o+1)===42){o+=2;const _=s-1;let de=!1;for(;o<_;){if(n.charCodeAt(o)===42&&n.charCodeAt(o+1)===47){o+=2,de=!0;break}o++}return de||(o++,w=1),t=n.substring(he,o),$=13}return t+=String.fromCharCode(ie),o++,$=16}case 45:if(t+=String.fromCharCode(ie),o++,o===s||!b(n.charCodeAt(o)))return $=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=L(),$=11;default:for(;o<s&&ce(ie);)o++,ie=n.charCodeAt(o);if(a!==o){switch(t=n.substring(a,o),t){case"true":return $=8;case"false":return $=9;case"null":return $=7}return $=16}return t+=String.fromCharCode(ie),o++,$=16}}function ce(ie){if(C(ie)||v(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function X(){let ie;do ie=x();while(ie>=12&&ie<=15);return ie}return{setPosition:E,getPosition:()=>o,scan:i?X:x,getToken:()=>$,getTokenValue:()=>t,getTokenOffset:()=>a,getTokenLength:()=>o-a,getTokenError:()=>w}}e.$Vm=P;function C(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function v(n){return n===10||n===13||n===8232||n===8233}function b(n){return n>=48&&n<=57}var A;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(A||(A={}));function S(n,i){const o=[],s=new Object;let t;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let $=!1;function w(k,E,L,j){a.value=k,a.offset=E,a.length=L,a.type=j,a.colonOffset=void 0,t=a}try{l(n,{onObjectBegin:(k,E)=>{if(i<=k)throw s;t=void 0,$=i>k,o.push("")},onObjectProperty:(k,E,L)=>{if(i<E||(w(k,E,L,"property"),o[o.length-1]=k,i<=E+L))throw s},onObjectEnd:(k,E)=>{if(i<=k)throw s;t=void 0,o.pop()},onArrayBegin:(k,E)=>{if(i<=k)throw s;t=void 0,o.push(0)},onArrayEnd:(k,E)=>{if(i<=k)throw s;t=void 0,o.pop()},onLiteralValue:(k,E,L)=>{if(i<E||(w(k,E,L,c(k)),i<=E+L))throw s},onSeparator:(k,E,L)=>{if(i<=E)throw s;if(k===":"&&t&&t.type==="property")t.colonOffset=E,$=!1,t=void 0;else if(k===","){const j=o[o.length-1];typeof j=="number"?o[o.length-1]=j+1:($=!0,o[o.length-1]=""),t=void 0}}})}catch(k){if(k!==s)throw k}return{path:o,previousNode:t,isAtPropertyKey:$,matches:k=>{let E=0;for(let L=0;E<k.length&&L<o.length;L++)if(k[E]===o[L]||k[E]==="*")E++;else if(k[E]!=="**")return!1;return E===k.length}}}e.$Wm=S;function y(n,i=[],o=I.DEFAULT){let s=null,t=[];const a=[];function $(k){Array.isArray(t)?t.push(k):s!==null&&(t[s]=k)}return l(n,{onObjectBegin:()=>{const k={};$(k),a.push(t),t=k,s=null},onObjectProperty:k=>{s=k},onObjectEnd:()=>{t=a.pop()},onArrayBegin:()=>{const k=[];$(k),a.push(t),t=k,s=null},onArrayEnd:()=>{t=a.pop()},onLiteralValue:$,onError:(k,E,L)=>{i.push({error:k,offset:E,length:L})}},o),t[0]}e.$Xm=y;function u(n,i=[],o=I.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(k){s.type==="property"&&(s.length=k-s.offset,s=s.parent)}function a(k){return s.children.push(k),k}l(n,{onObjectBegin:k=>{s=a({type:"object",offset:k,length:-1,parent:s,children:[]})},onObjectProperty:(k,E,L)=>{s=a({type:"property",offset:E,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:k,offset:E,length:L,parent:s})},onObjectEnd:(k,E)=>{s.length=k+E-s.offset,s=s.parent,t(k+E)},onArrayBegin:(k,E)=>{s=a({type:"array",offset:k,length:-1,parent:s,children:[]})},onArrayEnd:(k,E)=>{s.length=k+E-s.offset,s=s.parent,t(k+E)},onLiteralValue:(k,E,L)=>{a({type:c(k),offset:E,length:L,parent:s,value:k}),t(E+L)},onSeparator:(k,E,L)=>{s.type==="property"&&(k===":"?s.colonOffset=E:k===","&&t(E))},onError:(k,E,L)=>{i.push({error:k,offset:E,length:L})}},o);const w=s.children[0];return w&&delete w.parent,w}e.$Ym=u;function g(n,i){if(!n)return;let o=n;for(const s of i)if(typeof s=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let t=!1;for(const a of o.children)if(Array.isArray(a.children)&&a.children[0].value===s){o=a.children[1],t=!0;break}if(!t)return}else{const t=s;if(o.type!=="array"||t<0||!Array.isArray(o.children)||t>=o.children.length)return;o=o.children[t]}return o}e.$Zm=g;function d(n){if(!n.parent||!n.parent.children)return[];const i=d(n.parent);if(n.parent.type==="property"){const o=n.parent.children[0].value;i.push(o)}else if(n.parent.type==="array"){const o=n.parent.children.indexOf(n);o!==-1&&i.push(o)}return i}e.$1m=d;function f(n){switch(n.type){case"array":return n.children.map(f);case"object":{const i=Object.create(null);for(const o of n.children){const s=o.children[1];s&&(i[o.children[0].value]=f(s))}return i}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.$2m=f;function h(n,i,o=!1){return i>=n.offset&&i<n.offset+n.length||o&&i===n.offset+n.length}e.$3m=h;function p(n,i,o=!1){if(h(n,i,o)){const s=n.children;if(Array.isArray(s))for(let t=0;t<s.length&&s[t].offset<=i;t++){const a=p(s[t],i,o);if(a)return a}return n}}e.$4m=p;function l(n,i,o=I.DEFAULT){const s=P(n,!1);function t(re){return re?()=>re(s.getTokenOffset(),s.getTokenLength()):()=>!0}function a(re){return re?ee=>re(ee,s.getTokenOffset(),s.getTokenLength()):()=>!0}const $=t(i.onObjectBegin),w=a(i.onObjectProperty),k=t(i.onObjectEnd),E=t(i.onArrayBegin),L=t(i.onArrayEnd),j=a(i.onLiteralValue),x=a(i.onSeparator),ce=t(i.onComment),X=a(i.onError),ie=o&&o.disallowComments,he=o&&o.allowTrailingComma;function _(){for(;;){const re=s.scan();switch(s.getTokenError()){case 4:de(14);break;case 5:de(15);break;case 3:de(13);break;case 1:ie||de(11);break;case 2:de(12);break;case 6:de(16);break}switch(re){case 12:case 13:ie?de(10):ce();break;case 16:de(1);break;case 15:case 14:break;default:return re}}}function de(re,ee=[],B=[]){if(X(re),ee.length+B.length>0){let K=s.getToken();for(;K!==17;){if(ee.indexOf(K)!==-1){_();break}else if(B.indexOf(K)!==-1)break;K=_()}}}function Z(re){const ee=s.getTokenValue();return re?j(ee):w(ee),_(),!0}function ne(){switch(s.getToken()){case 11:{let re=0;try{re=JSON.parse(s.getTokenValue()),typeof re!="number"&&(de(2),re=0)}catch{de(2)}j(re);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return _(),!0}function J(){return s.getToken()!==10?(de(3,[],[2,5]),!1):(Z(!1),s.getToken()===6?(x(":"),_(),le()||de(4,[],[2,5])):de(5,[],[2,5]),!0)}function W(){$(),_();let re=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(re||de(4,[],[]),x(","),_(),s.getToken()===2&&he)break}else re&&de(6,[],[]);J()||de(4,[],[2,5]),re=!0}return k(),s.getToken()!==2?de(7,[2],[]):_(),!0}function oe(){E(),_();let re=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(re||de(4,[],[]),x(","),_(),s.getToken()===4&&he)break}else re&&de(6,[],[]);le()||de(4,[],[4,5]),re=!0}return L(),s.getToken()!==4?de(8,[4],[]):_(),!0}function le(){switch(s.getToken()){case 3:return oe();case 1:return W();case 10:return Z(!0);default:return ne()}}return _(),s.getToken()===17?o.allowEmptyContent?!0:(de(4,[],[]),!1):le()?(s.getToken()!==17&&de(9,[],[]),!0):(de(4,[],[]),!1)}e.$5m=l;function m(n,i){const o=P(n),s=[];let t,a=0,$;do switch($=o.getPosition(),t=o.scan(),t){case 12:case 13:case 17:a!==$&&s.push(n.substring(a,$)),i!==void 0&&s.push(o.getTokenValue().replace(/[^\r\n]/g,i)),a=o.getPosition();break}while(t!==17);return s.join("")}e.$6m=m;function c(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.$7m=c}),define(pe[76],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class D{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=D}),define(pe[96],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(I){this.element=I,this.next=D.Undefined,this.prev=D.Undefined}}class R{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let I=this.a;for(;I!==D.Undefined;){const P=I.next;I.prev=D.Undefined,I.next=D.Undefined,I=P}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(I){return this.d(I,!1)}push(I){return this.d(I,!0)}d(I,P){const C=new D(I);if(this.a===D.Undefined)this.a=C,this.b=C;else if(P){const b=this.b;this.b=C,C.prev=b,b.next=C}else{const b=this.a;this.a=C,C.next=b,b.prev=C}this.c+=1;let v=!1;return()=>{v||(v=!0,this.e(C))}}shift(){if(this.a!==D.Undefined){const I=this.a.element;return this.e(this.a),I}}pop(){if(this.b!==D.Undefined){const I=this.b.element;return this.e(this.b),I}}e(I){if(I.prev!==D.Undefined&&I.next!==D.Undefined){const P=I.prev;P.next=I.next,I.next.prev=P}else I.prev===D.Undefined&&I.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):I.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):I.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let I=this.a;for(;I!==D.Undefined;)yield I.element,I=I.next}}e.$2c=R}),define(pe[26],be([1,0]),function(ue,e){"use strict";var D,R,r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function I(p,l,m){let c=p.get(l);return c===void 0&&(c=m,p.set(l,c)),c}e.$xc=I;function P(p){const l=[];return p.forEach((m,c)=>{l.push(`${c} => ${m}`)}),`Map(${p.size}) {${l.join(", ")}}`}e.$yc=P;function C(p){const l=[];return p.forEach(m=>{l.push(m)}),`Set(${p.size}) {${l.join(", ")}}`}e.$zc=C;class v{constructor(l,m){this.uri=l,this.value=m}}function b(p){return Array.isArray(p)}class A{static{this.a=l=>l.toString()}constructor(l,m){if(this[D]="ResourceMap",l instanceof A)this.b=new Map(l.b),this.c=m??A.a;else if(b(l)){this.b=new Map,this.c=m??A.a;for(const[c,n]of l)this.set(c,n)}else this.b=new Map,this.c=l??A.a}set(l,m){return this.b.set(this.c(l),new v(l,m)),this}get(l){return this.b.get(this.c(l))?.value}has(l){return this.b.has(this.c(l))}get size(){return this.b.size}clear(){this.b.clear()}delete(l){return this.b.delete(this.c(l))}forEach(l,m){typeof m<"u"&&(l=l.bind(m));for(const[c,n]of this.b)l(n.value,n.uri,this)}*values(){for(const l of this.b.values())yield l.value}*keys(){for(const l of this.b.values())yield l.uri}*entries(){for(const l of this.b.values())yield[l.uri,l.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,l]of this.b)yield[l.uri,l.value]}}e.$Ac=A;class S{constructor(l,m){this[R]="ResourceSet",!l||typeof l=="function"?this.a=new A(l):(this.a=new A(m),l.forEach(this.add,this))}get size(){return this.a.size}add(l){return this.a.set(l,l),this}clear(){this.a.clear()}delete(l){return this.a.delete(l)}forEach(l,m){this.a.forEach((c,n)=>l.call(m,n,n,this))}has(l){return this.a.has(l)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=S;var y;(function(p){p[p.None=0]="None",p[p.AsOld=1]="AsOld",p[p.AsNew=2]="AsNew"})(y||(e.Touch=y={}));class u{constructor(){this[r]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(l){return this.a.has(l)}get(l,m=0){const c=this.a.get(l);if(c)return m!==0&&this.j(c,m),c.value}set(l,m,c=0){let n=this.a.get(l);if(n)n.value=m,c!==0&&this.j(n,c);else{switch(n={key:l,value:m,next:void 0,previous:void 0},c){case 0:this.h(n);break;case 1:this.g(n);break;case 2:this.h(n);break;default:this.h(n);break}this.a.set(l,n),this.d++}return this}delete(l){return!!this.remove(l)}remove(l){const m=this.a.get(l);if(m)return this.a.delete(l),this.i(m),this.d--,m.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const l=this.b;return this.a.delete(l.key),this.i(l),this.d--,l.value}forEach(l,m){const c=this.e;let n=this.b;for(;n;){if(m?l.bind(m)(n.value,n.key,this):l(n.value,n.key,this),this.e!==c)throw new Error("LinkedMap got modified during iteration.");n=n.next}}keys(){const l=this,m=this.e;let c=this.b;const n={[Symbol.iterator](){return n},next(){if(l.e!==m)throw new Error("LinkedMap got modified during iteration.");if(c){const i={value:c.key,done:!1};return c=c.next,i}else return{value:void 0,done:!0}}};return n}values(){const l=this,m=this.e;let c=this.b;const n={[Symbol.iterator](){return n},next(){if(l.e!==m)throw new Error("LinkedMap got modified during iteration.");if(c){const i={value:c.value,done:!1};return c=c.next,i}else return{value:void 0,done:!0}}};return n}entries(){const l=this,m=this.e;let c=this.b;const n={[Symbol.iterator](){return n},next(){if(l.e!==m)throw new Error("LinkedMap got modified during iteration.");if(c){const i={value:[c.key,c.value],done:!1};return c=c.next,i}else return{value:void 0,done:!0}}};return n}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(l){if(l>=this.size)return;if(l===0){this.clear();return}let m=this.b,c=this.size;for(;m&&c>l;)this.a.delete(m.key),m=m.next,c--;this.b=m,this.d=c,m&&(m.previous=void 0),this.e++}g(l){if(!this.b&&!this.c)this.c=l;else if(this.b)l.next=this.b,this.b.previous=l;else throw new Error("Invalid list");this.b=l,this.e++}h(l){if(!this.b&&!this.c)this.b=l;else if(this.c)l.previous=this.c,this.c.next=l;else throw new Error("Invalid list");this.c=l,this.e++}i(l){if(l===this.b&&l===this.c)this.b=void 0,this.c=void 0;else if(l===this.b){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this.b=l.next}else if(l===this.c){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this.c=l.previous}else{const m=l.next,c=l.previous;if(!m||!c)throw new Error("Invalid list");m.previous=c,c.next=m}l.next=void 0,l.previous=void 0,this.e++}j(l,m){if(!this.b||!this.c)throw new Error("Invalid list");if(!(m!==1&&m!==2)){if(m===1){if(l===this.b)return;const c=l.next,n=l.previous;l===this.c?(n.next=void 0,this.c=n):(c.previous=n,n.next=c),l.previous=void 0,l.next=this.b,this.b.previous=l,this.b=l,this.e++}else if(m===2){if(l===this.c)return;const c=l.next,n=l.previous;l===this.b?(c.previous=void 0,this.b=c):(c.previous=n,n.next=c),l.next=void 0,l.previous=this.c,this.c.next=l,this.c=l,this.e++}}}toJSON(){const l=[];return this.forEach((m,c)=>{l.push([c,m])}),l}fromJSON(l){this.clear();for(const[m,c]of l)this.set(m,c)}}e.$Cc=u;class g extends u{constructor(l,m=1){super(),this.k=l,this.l=Math.min(Math.max(0,m),1)}get limit(){return this.k}set limit(l){this.k=l,this.m()}get ratio(){return this.l}set ratio(l){this.l=Math.min(Math.max(0,l),1),this.m()}get(l,m=2){return super.get(l,m)}peek(l){return super.get(l,0)}set(l,m){return super.set(l,m,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=g;class d{constructor(){this.a=new Map}add(l){return this.a.set(l,(this.a.get(l)||0)+1),this}delete(l){let m=this.a.get(l)||0;return m===0?!1:(m--,m===0?this.a.delete(l):this.a.set(l,m),!0)}has(l){return this.a.has(l)}}e.$Ec=d;class f{constructor(l){if(this.a=new Map,this.b=new Map,l)for(const[m,c]of l)this.set(m,c)}clear(){this.a.clear(),this.b.clear()}set(l,m){this.a.set(l,m),this.b.set(m,l)}get(l){return this.a.get(l)}getKey(l){return this.b.get(l)}delete(l){const m=this.a.get(l);return m===void 0?!1:(this.a.delete(l),this.b.delete(m),!0)}forEach(l,m){this.a.forEach((c,n)=>{l.call(m,c,n,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=f;class h{constructor(){this.a=new Map}add(l,m){let c=this.a.get(l);c||(c=new Set,this.a.set(l,c)),c.add(m)}delete(l,m){const c=this.a.get(l);c&&(c.delete(m),c.size===0&&this.a.delete(l))}forEach(l,m){const c=this.a.get(l);c&&c.forEach(m)}get(l){const m=this.a.get(l);return m||new Set}}e.$Gc=h}),define(pe[2],be([1,0,18,142,26,74,47]),function(ue,e,D,R,r,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const C=!1;let v=null;class b{constructor(){this.b=new Map}static{this.a=0}c(L){let j=this.b.get(L);return j||(j={parent:null,source:null,isSingleton:!1,value:L,idx:b.a++},this.b.set(L,j)),j}trackDisposable(L){const j=this.c(L);j.source||(j.source=new Error().stack)}setParent(L,j){const x=this.c(L);x.parent=j}markAsDisposed(L){this.b.delete(L)}markAsSingleton(L){this.c(L).isSingleton=!0}f(L,j){const x=j.get(L);if(x)return x;const ce=L.parent?this.f(this.c(L.parent),j):L;return j.set(L,ce),ce}getTrackedDisposables(){const L=new Map;return[...this.b.entries()].filter(([,x])=>x.source!==null&&!this.f(x,L).isSingleton).flatMap(([x])=>x)}computeLeakingDisposables(L=10,j){let x;if(j)x=j;else{const _=new Map,de=[...this.b.values()].filter(ne=>ne.source!==null&&!this.f(ne,_).isSingleton);if(de.length===0)return;const Z=new Set(de.map(ne=>ne.value));if(x=de.filter(ne=>!(ne.parent&&Z.has(ne.parent))),x.length===0)throw new Error("There are cyclic diposable chains!")}if(!x)return;function ce(_){function de(ne,J){for(;ne.length>0&&J.some(W=>typeof W=="string"?W===ne[0]:ne[0].match(W));)ne.shift()}const Z=_.source.split(`
`).map(ne=>ne.trim().replace("at ","")).filter(ne=>ne!=="");return de(Z,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Z.reverse()}const X=new r.$Gc;for(const _ of x){const de=ce(_);for(let Z=0;Z<=de.length;Z++)X.add(de.slice(0,Z).join(`
`),_)}x.sort((0,D.$7b)(_=>_.idx,D.$9b));let ie="",he=0;for(const _ of x.slice(0,L)){he++;const de=ce(_),Z=[];for(let ne=0;ne<de.length;ne++){let J=de[ne];J=`(shared with ${X.get(de.slice(0,ne+1).join(`
`)).size}/${x.length} leaks) at ${J}`;const oe=X.get(de.slice(0,ne).join(`
`)),le=(0,R.$J)([...oe].map(re=>ce(re)[ne]),re=>re);delete le[de[ne]];for(const[re,ee]of Object.entries(le))Z.unshift(`    - stacktraces of ${ee.length} other leaks continue with ${re}`);Z.unshift(J)}ie+=`


==================== Leaking disposable ${he}/${x.length}: ${_.value.constructor.name} ====================
${Z.join(`
`)}
============================================================

`}return x.length>L&&(ie+=`


... and ${x.length-L} more leaking disposables

`),{leaks:x,details:ie}}}e.$Hc=b;function A(E){v=E}if(e.$Ic=A,C){const E="__is_disposable_tracked__";A(new class{trackDisposable(L){const j=new Error("Potentially leaked disposable").stack;setTimeout(()=>{L[E]||console.log(j)},3e3)}setParent(L,j){if(L&&L!==n.None)try{L[E]=!0}catch{}}markAsDisposed(L){if(L&&L!==n.None)try{L[E]=!0}catch{}}markAsSingleton(L){}})}function S(E){return v?.trackDisposable(E),E}e.$Jc=S;function y(E){v?.markAsDisposed(E)}e.$Kc=y;function u(E,L){v?.setParent(E,L)}function g(E,L){if(v)for(const j of E)v.setParent(j,L)}function d(E){return v?.markAsSingleton(E),E}e.$Lc=d;function f(E){return typeof E.dispose=="function"&&E.dispose.length===0}e.$Mc=f;function h(E){if(P.Iterable.is(E)){const L=[];for(const j of E)if(j)try{j.dispose()}catch(x){L.push(x)}if(L.length===1)throw L[0];if(L.length>1)throw new AggregateError(L,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}e.$Nc=h;function p(E){for(const L of E)f(L)&&L.dispose();return[]}e.$Oc=p;function l(...E){const L=m(()=>h(E));return g(E,L),L}e.$Pc=l;function m(E){const L=S({dispose:(0,I.$db)(()=>{y(L),E()})});return L}e.$Qc=m;class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,S(this)}dispose(){this.g||(y(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(L){if(!L)return L;if(L===this)throw new Error("Cannot register a disposable on itself!");return u(L,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(L),L}delete(L){if(L){if(L===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(L),L.dispose()}}deleteAndLeak(L){L&&this.f.has(L)&&(this.f.delete(L),u(L,null))}}e.$Rc=c;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,S(this),u(this.q,this)}dispose(){y(this),this.q.dispose()}B(L){if(L===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(L)}}e.$Sc=n;class i{constructor(){this.b=!1,S(this)}get value(){return this.b?void 0:this.a}set value(L){this.b||L===this.a||(this.a?.dispose(),L&&u(L,this),this.a=L)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const L=this.a;return this.a=void 0,L&&u(L,null),L}}e.$Tc=i;class o{constructor(L){this.b=L,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=o;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(L){let j=L;return this.unset=()=>j=void 0,this.isset=()=>j!==void 0,this.dispose=()=>{j&&(j(),j=void 0,y(this))},this}}e.$Vc=s;class t{constructor(){this.a=new Map}acquire(L,...j){let x=this.a.get(L);x||(x={counter:0,object:this.b(L,...j)},this.a.set(L,x));const{object:ce}=x,X=(0,I.$db)(()=>{--x.counter===0&&(this.c(L,x.object),this.a.delete(L))});return x.counter++,{object:ce,dispose:X}}}e.$Wc=t;class a{constructor(L){this.a=L}async acquire(L,...j){const x=this.a.acquire(L,...j);try{return{object:await x.object,dispose:()=>x.dispose()}}catch(ce){throw x.dispose(),ce}}}e.$Xc=a;class ${constructor(L){this.object=L}dispose(){}}e.$Yc=$;function w(E){const L=new c;try{E(L)}finally{L.dispose()}}e.$Zc=w;class k{constructor(){this.a=new Map,this.b=!1,S(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(L){return this.a.has(L)}get size(){return this.a.size}get(L){return this.a.get(L)}set(L,j,x=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),x||this.a.get(L)?.dispose(),this.a.set(L,j)}deleteAndDispose(L){this.a.get(L)?.dispose(),this.a.delete(L)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=k}),function(ue,e){typeof define=="function"&&define.amd?define(pe[143],be([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ue=typeof globalThis<"u"?globalThis:ue||self,e(ue.marked={}))}(this,function(ue){"use strict";function e(q,z){for(var te=0;te<z.length;te++){var H=z[te];H.enumerable=H.enumerable||!1,H.configurable=!0,"value"in H&&(H.writable=!0),Object.defineProperty(q,H.key,H)}}function D(q,z,te){return z&&e(q.prototype,z),te&&e(q,te),Object.defineProperty(q,"prototype",{writable:!1}),q}function R(q,z){if(q){if(typeof q=="string")return r(q,z);var te=Object.prototype.toString.call(q).slice(8,-1);if(te==="Object"&&q.constructor&&(te=q.constructor.name),te==="Map"||te==="Set")return Array.from(q);if(te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(te))return r(q,z)}}function r(q,z){(z==null||z>q.length)&&(z=q.length);for(var te=0,H=new Array(z);te<z;te++)H[te]=q[te];return H}function I(q,z){var te=typeof Symbol<"u"&&q[Symbol.iterator]||q["@@iterator"];if(te)return(te=te.call(q)).next.bind(te);if(Array.isArray(q)||(te=R(q))||z&&q&&typeof q.length=="number"){te&&(q=te);var H=0;return function(){return H>=q.length?{done:!0}:{done:!1,value:q[H++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function P(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ue.defaults=P();function C(q){ue.defaults=q}var v=/[&<>"']/,b=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,y={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},u=function(z){return y[z]};function g(q,z){if(z){if(v.test(q))return q.replace(b,u)}else if(A.test(q))return q.replace(S,u);return q}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(q){return q.replace(d,function(z,te){return te=te.toLowerCase(),te==="colon"?":":te.charAt(0)==="#"?te.charAt(1)==="x"?String.fromCharCode(parseInt(te.substring(2),16)):String.fromCharCode(+te.substring(1)):""})}var h=/(^|[^\[])\^/g;function p(q,z){q=typeof q=="string"?q:q.source,z=z||"";var te={replace:function(Y,V){return V=V.source||V,V=V.replace(h,"$1"),q=q.replace(Y,V),te},getRegex:function(){return new RegExp(q,z)}};return te}var l=/[^\w:]/g,m=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(q,z,te){if(q){var H;try{H=decodeURIComponent(f(te)).replace(l,"").toLowerCase()}catch{return null}if(H.indexOf("javascript:")===0||H.indexOf("vbscript:")===0||H.indexOf("data:")===0)return null}z&&!m.test(te)&&(te=t(z,te));try{te=encodeURI(te).replace(/%25/g,"%")}catch{return null}return te}var n={},i=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function t(q,z){n[" "+q]||(i.test(q)?n[" "+q]=q+"/":n[" "+q]=k(q,"/",!0)),q=n[" "+q];var te=q.indexOf(":")===-1;return z.substring(0,2)==="//"?te?z:q.replace(o,"$1")+z:z.charAt(0)==="/"?te?z:q.replace(s,"$1")+z:q+z}var a={exec:function(){}};function $(q){for(var z=1,te,H;z<arguments.length;z++){te=arguments[z];for(H in te)Object.prototype.hasOwnProperty.call(te,H)&&(q[H]=te[H])}return q}function w(q,z){var te=q.replace(/\|/g,function(V,Q,se){for(var me=!1,Ee=Q;--Ee>=0&&se[Ee]==="\\";)me=!me;return me?"|":" |"}),H=te.split(/ \|/),Y=0;if(H[0].trim()||H.shift(),H.length>0&&!H[H.length-1].trim()&&H.pop(),H.length>z)H.splice(z);else for(;H.length<z;)H.push("");for(;Y<H.length;Y++)H[Y]=H[Y].trim().replace(/\\\|/g,"|");return H}function k(q,z,te){var H=q.length;if(H===0)return"";for(var Y=0;Y<H;){var V=q.charAt(H-Y-1);if(V===z&&!te)Y++;else if(V!==z&&te)Y++;else break}return q.slice(0,H-Y)}function E(q,z){if(q.indexOf(z[1])===-1)return-1;for(var te=q.length,H=0,Y=0;Y<te;Y++)if(q[Y]==="\\")Y++;else if(q[Y]===z[0])H++;else if(q[Y]===z[1]&&(H--,H<0))return Y;return-1}function L(q){q&&q.sanitize&&!q.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function j(q,z){if(z<1)return"";for(var te="";z>1;)z&1&&(te+=q),z>>=1,q+=q;return te+q}function x(q,z,te,H){var Y=z.href,V=z.title?g(z.title):null,Q=q[1].replace(/\\([\[\]])/g,"$1");if(q[0].charAt(0)!=="!"){H.state.inLink=!0;var se={type:"link",raw:te,href:Y,title:V,text:Q,tokens:H.inlineTokens(Q)};return H.state.inLink=!1,se}return{type:"image",raw:te,href:Y,title:V,text:g(Q)}}function ce(q,z){var te=q.match(/^(\s+)(?:```)/);if(te===null)return z;var H=te[1];return z.split(`
`).map(function(Y){var V=Y.match(/^\s+/);if(V===null)return Y;var Q=V[0];return Q.length>=H.length?Y.slice(H.length):Y}).join(`
`)}var X=function(){function q(te){this.options=te||ue.defaults}var z=q.prototype;return z.space=function(H){var Y=this.rules.block.newline.exec(H);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},z.code=function(H){var Y=this.rules.block.code.exec(H);if(Y){var V=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?V:k(V,`
`)}}},z.fences=function(H){var Y=this.rules.block.fences.exec(H);if(Y){var V=Y[0],Q=ce(V,Y[3]||"");return{type:"code",raw:V,lang:Y[2]?Y[2].trim():Y[2],text:Q}}},z.heading=function(H){var Y=this.rules.block.heading.exec(H);if(Y){var V=Y[2].trim();if(/#$/.test(V)){var Q=k(V,"#");(this.options.pedantic||!Q||/ $/.test(Q))&&(V=Q.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:V,tokens:this.lexer.inline(V)}}},z.hr=function(H){var Y=this.rules.block.hr.exec(H);if(Y)return{type:"hr",raw:Y[0]}},z.blockquote=function(H){var Y=this.rules.block.blockquote.exec(H);if(Y){var V=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(V,[]),text:V}}},z.list=function(H){var Y=this.rules.block.list.exec(H);if(Y){var V,Q,se,me,Ee,Ce,Le,Fe,$e,ke,ye,Me,Ue=Y[1].trim(),Ze=Ue.length>1,We={type:"list",raw:"",ordered:Ze,start:Ze?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=Ze?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=Ze?Ue:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+Ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");H&&(Me=!1,!(!(Y=Xe.exec(H))||this.rules.block.hr.test(H)));){if(V=Y[0],H=H.substring(V.length),Fe=Y[2].split(`
`,1)[0],$e=H.split(`
`,1)[0],this.options.pedantic?(me=2,ye=Fe.trimLeft()):(me=Y[2].search(/[^ ]/),me=me>4?1:me,ye=Fe.slice(me),me+=Y[1].length),Ce=!1,!Fe&&/^ *$/.test($e)&&(V+=$e+`
`,H=H.substring($e.length+1),Me=!0),!Me)for(var Qe=new RegExp("^ {0,"+Math.min(3,me-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ge=new RegExp("^ {0,"+Math.min(3,me-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Pe=new RegExp("^ {0,"+Math.min(3,me-1)+"}(?:```|~~~)"),Ie=new RegExp("^ {0,"+Math.min(3,me-1)+"}#");H&&(ke=H.split(`
`,1)[0],Fe=ke,this.options.pedantic&&(Fe=Fe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Pe.test(Fe)||Ie.test(Fe)||Qe.test(Fe)||ge.test(H)));){if(Fe.search(/[^ ]/)>=me||!Fe.trim())ye+=`
`+Fe.slice(me);else if(!Ce)ye+=`
`+Fe;else break;!Ce&&!Fe.trim()&&(Ce=!0),V+=ke+`
`,H=H.substring(ke.length+1)}We.loose||(Le?We.loose=!0:/\n *\n *$/.test(V)&&(Le=!0)),this.options.gfm&&(Q=/^\[[ xX]\] /.exec(ye),Q&&(se=Q[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),We.items.push({type:"list_item",raw:V,task:!!Q,checked:se,loose:!1,text:ye}),We.raw+=V}We.items[We.items.length-1].raw=V.trimRight(),We.items[We.items.length-1].text=ye.trimRight(),We.raw=We.raw.trimRight();var Ne=We.items.length;for(Ee=0;Ee<Ne;Ee++){this.lexer.state.top=!1,We.items[Ee].tokens=this.lexer.blockTokens(We.items[Ee].text,[]);var ze=We.items[Ee].tokens.filter(function(Be){return Be.type==="space"}),He=ze.every(function(Be){for(var Ve=Be.raw.split(""),Je=0,Ge=I(Ve),Ye;!(Ye=Ge()).done;){var it=Ye.value;if(it===`
`&&(Je+=1),Je>1)return!0}return!1});!We.loose&&ze.length&&He&&(We.loose=!0,We.items[Ee].loose=!0)}return We}},z.html=function(H){var Y=this.rules.block.html.exec(H);if(Y){var V={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var Q=this.options.sanitizer?this.options.sanitizer(Y[0]):g(Y[0]);V.type="paragraph",V.text=Q,V.tokens=this.lexer.inline(Q)}return V}},z.def=function(H){var Y=this.rules.block.def.exec(H);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var V=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:V,raw:Y[0],href:Y[2],title:Y[3]}}},z.table=function(H){var Y=this.rules.block.table.exec(H);if(Y){var V={type:"table",header:w(Y[1]).map(function(Le){return{text:Le}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(V.header.length===V.align.length){V.raw=Y[0];var Q=V.align.length,se,me,Ee,Ce;for(se=0;se<Q;se++)/^ *-+: *$/.test(V.align[se])?V.align[se]="right":/^ *:-+: *$/.test(V.align[se])?V.align[se]="center":/^ *:-+ *$/.test(V.align[se])?V.align[se]="left":V.align[se]=null;for(Q=V.rows.length,se=0;se<Q;se++)V.rows[se]=w(V.rows[se],V.header.length).map(function(Le){return{text:Le}});for(Q=V.header.length,me=0;me<Q;me++)V.header[me].tokens=this.lexer.inline(V.header[me].text);for(Q=V.rows.length,me=0;me<Q;me++)for(Ce=V.rows[me],Ee=0;Ee<Ce.length;Ee++)Ce[Ee].tokens=this.lexer.inline(Ce[Ee].text);return V}}},z.lheading=function(H){var Y=this.rules.block.lheading.exec(H);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},z.paragraph=function(H){var Y=this.rules.block.paragraph.exec(H);if(Y){var V=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:V,tokens:this.lexer.inline(V)}}},z.text=function(H){var Y=this.rules.block.text.exec(H);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},z.escape=function(H){var Y=this.rules.inline.escape.exec(H);if(Y)return{type:"escape",raw:Y[0],text:g(Y[1])}},z.tag=function(H){var Y=this.rules.inline.tag.exec(H);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):g(Y[0]):Y[0]}},z.link=function(H){var Y=this.rules.inline.link.exec(H);if(Y){var V=Y[2].trim();if(!this.options.pedantic&&/^</.test(V)){if(!/>$/.test(V))return;var Q=k(V.slice(0,-1),"\\");if((V.length-Q.length)%2===0)return}else{var se=E(Y[2],"()");if(se>-1){var me=Y[0].indexOf("!")===0?5:4,Ee=me+Y[1].length+se;Y[2]=Y[2].substring(0,se),Y[0]=Y[0].substring(0,Ee).trim(),Y[3]=""}}var Ce=Y[2],Le="";if(this.options.pedantic){var Fe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ce);Fe&&(Ce=Fe[1],Le=Fe[3])}else Le=Y[3]?Y[3].slice(1,-1):"";return Ce=Ce.trim(),/^</.test(Ce)&&(this.options.pedantic&&!/>$/.test(V)?Ce=Ce.slice(1):Ce=Ce.slice(1,-1)),x(Y,{href:Ce&&Ce.replace(this.rules.inline._escapes,"$1"),title:Le&&Le.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},z.reflink=function(H,Y){var V;if((V=this.rules.inline.reflink.exec(H))||(V=this.rules.inline.nolink.exec(H))){var Q=(V[2]||V[1]).replace(/\s+/g," ");if(Q=Y[Q.toLowerCase()],!Q||!Q.href){var se=V[0].charAt(0);return{type:"text",raw:se,text:se}}return x(V,Q,V[0],this.lexer)}},z.emStrong=function(H,Y,V){V===void 0&&(V="");var Q=this.rules.inline.emStrong.lDelim.exec(H);if(Q&&!(Q[3]&&V.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var se=Q[1]||Q[2]||"";if(!se||se&&(V===""||this.rules.inline.punctuation.exec(V))){var me=Q[0].length-1,Ee,Ce,Le=me,Fe=0,$e=Q[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for($e.lastIndex=0,Y=Y.slice(-1*H.length+me);(Q=$e.exec(Y))!=null;)if(Ee=Q[1]||Q[2]||Q[3]||Q[4]||Q[5]||Q[6],!!Ee){if(Ce=Ee.length,Q[3]||Q[4]){Le+=Ce;continue}else if((Q[5]||Q[6])&&me%3&&!((me+Ce)%3)){Fe+=Ce;continue}if(Le-=Ce,!(Le>0)){if(Ce=Math.min(Ce,Ce+Le+Fe),Math.min(me,Ce)%2){var ke=H.slice(1,me+Q.index+Ce);return{type:"em",raw:H.slice(0,me+Q.index+Ce+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}var ye=H.slice(2,me+Q.index+Ce-1);return{type:"strong",raw:H.slice(0,me+Q.index+Ce+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},z.codespan=function(H){var Y=this.rules.inline.code.exec(H);if(Y){var V=Y[2].replace(/\n/g," "),Q=/[^ ]/.test(V),se=/^ /.test(V)&&/ $/.test(V);return Q&&se&&(V=V.substring(1,V.length-1)),V=g(V,!0),{type:"codespan",raw:Y[0],text:V}}},z.br=function(H){var Y=this.rules.inline.br.exec(H);if(Y)return{type:"br",raw:Y[0]}},z.del=function(H){var Y=this.rules.inline.del.exec(H);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},z.autolink=function(H,Y){var V=this.rules.inline.autolink.exec(H);if(V){var Q,se;return V[2]==="@"?(Q=g(this.options.mangle?Y(V[1]):V[1]),se="mailto:"+Q):(Q=g(V[1]),se=Q),{type:"link",raw:V[0],text:Q,href:se,tokens:[{type:"text",raw:Q,text:Q}]}}},z.url=function(H,Y){var V;if(V=this.rules.inline.url.exec(H)){var Q,se;if(V[2]==="@")Q=g(this.options.mangle?Y(V[0]):V[0]),se="mailto:"+Q;else{var me;do me=V[0],V[0]=this.rules.inline._backpedal.exec(V[0])[0];while(me!==V[0]);Q=g(V[0]),V[1]==="www."?se="http://"+Q:se=Q}return{type:"link",raw:V[0],text:Q,href:se,tokens:[{type:"text",raw:Q,text:Q}]}}},z.inlineText=function(H,Y){var V=this.rules.inline.text.exec(H);if(V){var Q;return this.lexer.state.inRawBlock?Q=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(V[0]):g(V[0]):V[0]:Q=g(this.options.smartypants?Y(V[0]):V[0]),{type:"text",raw:V[0],text:Q}}},q}(),ie={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ie._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ie._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ie.def=p(ie.def).replace("label",ie._label).replace("title",ie._title).getRegex(),ie.bullet=/(?:[*+-]|\d{1,9}[.)])/,ie.listItemStart=p(/^( *)(bull) */).replace("bull",ie.bullet).getRegex(),ie.list=p(ie.list).replace(/bull/g,ie.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ie.def.source+")").getRegex(),ie._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ie._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ie.html=p(ie.html,"i").replace("comment",ie._comment).replace("tag",ie._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ie.paragraph=p(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.blockquote=p(ie.blockquote).replace("paragraph",ie.paragraph).getRegex(),ie.normal=$({},ie),ie.gfm=$({},ie.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ie.gfm.table=p(ie.gfm.table).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.gfm.paragraph=p(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ie.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.pedantic=$({},ie.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ie._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:p(ie.normal._paragraph).replace("hr",ie.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ie.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var he={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};he._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",he.punctuation=p(he.punctuation).replace(/punctuation/g,he._punctuation).getRegex(),he.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,he.escapedEmSt=/\\\*|\\_/g,he._comment=p(ie._comment).replace("(?:-->|$)","-->").getRegex(),he.emStrong.lDelim=p(he.emStrong.lDelim).replace(/punct/g,he._punctuation).getRegex(),he.emStrong.rDelimAst=p(he.emStrong.rDelimAst,"g").replace(/punct/g,he._punctuation).getRegex(),he.emStrong.rDelimUnd=p(he.emStrong.rDelimUnd,"g").replace(/punct/g,he._punctuation).getRegex(),he._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,he._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,he._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,he.autolink=p(he.autolink).replace("scheme",he._scheme).replace("email",he._email).getRegex(),he._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,he.tag=p(he.tag).replace("comment",he._comment).replace("attribute",he._attribute).getRegex(),he._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,he._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,he._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,he.link=p(he.link).replace("label",he._label).replace("href",he._href).replace("title",he._title).getRegex(),he.reflink=p(he.reflink).replace("label",he._label).replace("ref",ie._label).getRegex(),he.nolink=p(he.nolink).replace("ref",ie._label).getRegex(),he.reflinkSearch=p(he.reflinkSearch,"g").replace("reflink",he.reflink).replace("nolink",he.nolink).getRegex(),he.normal=$({},he),he.pedantic=$({},he.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",he._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",he._label).getRegex()}),he.gfm=$({},he.normal,{escape:p(he.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),he.gfm.url=p(he.gfm.url,"i").replace("email",he.gfm._extended_email).getRegex(),he.breaks=$({},he.gfm,{br:p(he.br).replace("{2,}","*").getRegex(),text:p(he.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function _(q){return q.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function de(q){var z="",te,H,Y=q.length;for(te=0;te<Y;te++)H=q.charCodeAt(te),Math.random()>.5&&(H="x"+H.toString(16)),z+="&#"+H+";";return z}var Z=function(){function q(te){this.tokens=[],this.tokens.links=Object.create(null),this.options=te||ue.defaults,this.options.tokenizer=this.options.tokenizer||new X,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var H={block:ie.normal,inline:he.normal};this.options.pedantic?(H.block=ie.pedantic,H.inline=he.pedantic):this.options.gfm&&(H.block=ie.gfm,this.options.breaks?H.inline=he.breaks:H.inline=he.gfm),this.tokenizer.rules=H}q.lex=function(H,Y){var V=new q(Y);return V.lex(H)},q.lexInline=function(H,Y){var V=new q(Y);return V.inlineTokens(H)};var z=q.prototype;return z.lex=function(H){H=H.replace(/\r\n|\r/g,`
`),this.blockTokens(H,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},z.blockTokens=function(H,Y){var V=this;Y===void 0&&(Y=[]),this.options.pedantic?H=H.replace(/\t/g,"    ").replace(/^ +$/gm,""):H=H.replace(/^( *)(\t+)/gm,function(Le,Fe,$e){return Fe+"    ".repeat($e.length)});for(var Q,se,me,Ee;H;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Le){return(Q=Le.call({lexer:V},H,Y))?(H=H.substring(Q.raw.length),Y.push(Q),!0):!1}))){if(Q=this.tokenizer.space(H)){H=H.substring(Q.raw.length),Q.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(Q);continue}if(Q=this.tokenizer.code(H)){H=H.substring(Q.raw.length),se=Y[Y.length-1],se&&(se.type==="paragraph"||se.type==="text")?(se.raw+=`
`+Q.raw,se.text+=`
`+Q.text,this.inlineQueue[this.inlineQueue.length-1].src=se.text):Y.push(Q);continue}if(Q=this.tokenizer.fences(H)){H=H.substring(Q.raw.length),Y.push(Q);continue}if(Q=this.tokenizer.heading(H)){H=H.substring(Q.raw.length),Y.push(Q);continue}if(Q=this.tokenizer.hr(H)){H=H.substring(Q.raw.length),Y.push(Q);continue}if(Q=this.tokenizer.blockquote(H)){H=H.substring(Q.raw.length),Y.push(Q);continue}if(Q=this.tokenizer.list(H)){H=H.substring(Q.raw.length),Y.push(Q);continue}if(Q=this.tokenizer.html(H)){H=H.substring(Q.raw.length),Y.push(Q);continue}if(Q=this.tokenizer.def(H)){H=H.substring(Q.raw.length),se=Y[Y.length-1],se&&(se.type==="paragraph"||se.type==="text")?(se.raw+=`
`+Q.raw,se.text+=`
`+Q.raw,this.inlineQueue[this.inlineQueue.length-1].src=se.text):this.tokens.links[Q.tag]||(this.tokens.links[Q.tag]={href:Q.href,title:Q.title});continue}if(Q=this.tokenizer.table(H)){H=H.substring(Q.raw.length),Y.push(Q);continue}if(Q=this.tokenizer.lheading(H)){H=H.substring(Q.raw.length),Y.push(Q);continue}if(me=H,this.options.extensions&&this.options.extensions.startBlock&&function(){var Le=1/0,Fe=H.slice(1),$e=void 0;V.options.extensions.startBlock.forEach(function(ke){$e=ke.call({lexer:this},Fe),typeof $e=="number"&&$e>=0&&(Le=Math.min(Le,$e))}),Le<1/0&&Le>=0&&(me=H.substring(0,Le+1))}(),this.state.top&&(Q=this.tokenizer.paragraph(me))){se=Y[Y.length-1],Ee&&se.type==="paragraph"?(se.raw+=`
`+Q.raw,se.text+=`
`+Q.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=se.text):Y.push(Q),Ee=me.length!==H.length,H=H.substring(Q.raw.length);continue}if(Q=this.tokenizer.text(H)){H=H.substring(Q.raw.length),se=Y[Y.length-1],se&&se.type==="text"?(se.raw+=`
`+Q.raw,se.text+=`
`+Q.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=se.text):Y.push(Q);continue}if(H){var Ce="Infinite loop on byte: "+H.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return this.state.top=!0,Y},z.inline=function(H,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:H,tokens:Y}),Y},z.inlineTokens=function(H,Y){var V=this;Y===void 0&&(Y=[]);var Q,se,me,Ee=H,Ce,Le,Fe;if(this.tokens.links){var $e=Object.keys(this.tokens.links);if($e.length>0)for(;(Ce=this.tokenizer.rules.inline.reflinkSearch.exec(Ee))!=null;)$e.includes(Ce[0].slice(Ce[0].lastIndexOf("[")+1,-1))&&(Ee=Ee.slice(0,Ce.index)+"["+j("a",Ce[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ce=this.tokenizer.rules.inline.blockSkip.exec(Ee))!=null;)Ee=Ee.slice(0,Ce.index)+"["+j("a",Ce[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ce=this.tokenizer.rules.inline.escapedEmSt.exec(Ee))!=null;)Ee=Ee.slice(0,Ce.index)+"++"+Ee.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;H;)if(Le||(Fe=""),Le=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(Q=ye.call({lexer:V},H,Y))?(H=H.substring(Q.raw.length),Y.push(Q),!0):!1}))){if(Q=this.tokenizer.escape(H)){H=H.substring(Q.raw.length),Y.push(Q);continue}if(Q=this.tokenizer.tag(H)){H=H.substring(Q.raw.length),se=Y[Y.length-1],se&&Q.type==="text"&&se.type==="text"?(se.raw+=Q.raw,se.text+=Q.text):Y.push(Q);continue}if(Q=this.tokenizer.link(H)){H=H.substring(Q.raw.length),Y.push(Q);continue}if(Q=this.tokenizer.reflink(H,this.tokens.links)){H=H.substring(Q.raw.length),se=Y[Y.length-1],se&&Q.type==="text"&&se.type==="text"?(se.raw+=Q.raw,se.text+=Q.text):Y.push(Q);continue}if(Q=this.tokenizer.emStrong(H,Ee,Fe)){H=H.substring(Q.raw.length),Y.push(Q);continue}if(Q=this.tokenizer.codespan(H)){H=H.substring(Q.raw.length),Y.push(Q);continue}if(Q=this.tokenizer.br(H)){H=H.substring(Q.raw.length),Y.push(Q);continue}if(Q=this.tokenizer.del(H)){H=H.substring(Q.raw.length),Y.push(Q);continue}if(Q=this.tokenizer.autolink(H,de)){H=H.substring(Q.raw.length),Y.push(Q);continue}if(!this.state.inLink&&(Q=this.tokenizer.url(H,de))){H=H.substring(Q.raw.length),Y.push(Q);continue}if(me=H,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,Me=H.slice(1),Ue=void 0;V.options.extensions.startInline.forEach(function(Ze){Ue=Ze.call({lexer:this},Me),typeof Ue=="number"&&Ue>=0&&(ye=Math.min(ye,Ue))}),ye<1/0&&ye>=0&&(me=H.substring(0,ye+1))}(),Q=this.tokenizer.inlineText(me,_)){H=H.substring(Q.raw.length),Q.raw.slice(-1)!=="_"&&(Fe=Q.raw.slice(-1)),Le=!0,se=Y[Y.length-1],se&&se.type==="text"?(se.raw+=Q.raw,se.text+=Q.text):Y.push(Q);continue}if(H){var ke="Infinite loop on byte: "+H.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return Y},D(q,null,[{key:"rules",get:function(){return{block:ie,inline:he}}}]),q}(),ne=function(){function q(te){this.options=te||ue.defaults}var z=q.prototype;return z.code=function(H,Y,V){var Q=(Y||"").match(/\S*/)[0];if(this.options.highlight){var se=this.options.highlight(H,Q);se!=null&&se!==H&&(V=!0,H=se)}return H=H.replace(/\n$/,"")+`
`,Q?'<pre><code class="'+this.options.langPrefix+g(Q,!0)+'">'+(V?H:g(H,!0))+`</code></pre>
`:"<pre><code>"+(V?H:g(H,!0))+`</code></pre>
`},z.blockquote=function(H){return`<blockquote>
`+H+`</blockquote>
`},z.html=function(H){return H},z.heading=function(H,Y,V,Q){if(this.options.headerIds){var se=this.options.headerPrefix+Q.slug(V);return"<h"+Y+' id="'+se+'">'+H+"</h"+Y+`>
`}return"<h"+Y+">"+H+"</h"+Y+`>
`},z.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},z.list=function(H,Y,V){var Q=Y?"ol":"ul",se=Y&&V!==1?' start="'+V+'"':"";return"<"+Q+se+`>
`+H+"</"+Q+`>
`},z.listitem=function(H){return"<li>"+H+`</li>
`},z.checkbox=function(H){return"<input "+(H?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},z.paragraph=function(H){return"<p>"+H+`</p>
`},z.table=function(H,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+H+`</thead>
`+Y+`</table>
`},z.tablerow=function(H){return`<tr>
`+H+`</tr>
`},z.tablecell=function(H,Y){var V=Y.header?"th":"td",Q=Y.align?"<"+V+' align="'+Y.align+'">':"<"+V+">";return Q+H+("</"+V+`>
`)},z.strong=function(H){return"<strong>"+H+"</strong>"},z.em=function(H){return"<em>"+H+"</em>"},z.codespan=function(H){return"<code>"+H+"</code>"},z.br=function(){return this.options.xhtml?"<br/>":"<br>"},z.del=function(H){return"<del>"+H+"</del>"},z.link=function(H,Y,V){if(H=c(this.options.sanitize,this.options.baseUrl,H),H===null)return V;var Q='<a href="'+g(H)+'"';return Y&&(Q+=' title="'+Y+'"'),Q+=">"+V+"</a>",Q},z.image=function(H,Y,V){if(H=c(this.options.sanitize,this.options.baseUrl,H),H===null)return V;var Q='<img src="'+H+'" alt="'+V+'"';return Y&&(Q+=' title="'+Y+'"'),Q+=this.options.xhtml?"/>":">",Q},z.text=function(H){return H},q}(),J=function(){function q(){}var z=q.prototype;return z.strong=function(H){return H},z.em=function(H){return H},z.codespan=function(H){return H},z.del=function(H){return H},z.html=function(H){return H},z.text=function(H){return H},z.link=function(H,Y,V){return""+V},z.image=function(H,Y,V){return""+V},z.br=function(){return""},q}(),W=function(){function q(){this.seen={}}var z=q.prototype;return z.serialize=function(H){return H.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},z.getNextSafeSlug=function(H,Y){var V=H,Q=0;if(this.seen.hasOwnProperty(V)){Q=this.seen[H];do Q++,V=H+"-"+Q;while(this.seen.hasOwnProperty(V))}return Y||(this.seen[H]=Q,this.seen[V]=0),V},z.slug=function(H,Y){Y===void 0&&(Y={});var V=this.serialize(H);return this.getNextSafeSlug(V,Y.dryrun)},q}(),oe=function(){function q(te){this.options=te||ue.defaults,this.options.renderer=this.options.renderer||new ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new J,this.slugger=new W}q.parse=function(H,Y){var V=new q(Y);return V.parse(H)},q.parseInline=function(H,Y){var V=new q(Y);return V.parseInline(H)};var z=q.prototype;return z.parse=function(H,Y){Y===void 0&&(Y=!0);var V="",Q,se,me,Ee,Ce,Le,Fe,$e,ke,ye,Me,Ue,Ze,We,Xe,Qe,ge,Pe,Ie,Ne=H.length;for(Q=0;Q<Ne;Q++){if(ye=H[Q],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Ie=this.options.extensions.renderers[ye.type].call({parser:this},ye),Ie!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){V+=Ie||"";continue}switch(ye.type){case"space":continue;case"hr":{V+=this.renderer.hr();continue}case"heading":{V+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,f(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{V+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for($e="",Fe="",Ee=ye.header.length,se=0;se<Ee;se++)Fe+=this.renderer.tablecell(this.parseInline(ye.header[se].tokens),{header:!0,align:ye.align[se]});for($e+=this.renderer.tablerow(Fe),ke="",Ee=ye.rows.length,se=0;se<Ee;se++){for(Le=ye.rows[se],Fe="",Ce=Le.length,me=0;me<Ce;me++)Fe+=this.renderer.tablecell(this.parseInline(Le[me].tokens),{header:!1,align:ye.align[me]});ke+=this.renderer.tablerow(Fe)}V+=this.renderer.table($e,ke);continue}case"blockquote":{ke=this.parse(ye.tokens),V+=this.renderer.blockquote(ke);continue}case"list":{for(Me=ye.ordered,Ue=ye.start,Ze=ye.loose,Ee=ye.items.length,ke="",se=0;se<Ee;se++)Xe=ye.items[se],Qe=Xe.checked,ge=Xe.task,We="",Xe.task&&(Pe=this.renderer.checkbox(Qe),Ze?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=Pe+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=Pe+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:Pe}):We+=Pe),We+=this.parse(Xe.tokens,Ze),ke+=this.renderer.listitem(We,ge,Qe);V+=this.renderer.list(ke,Me,Ue);continue}case"html":{V+=this.renderer.html(ye.text);continue}case"paragraph":{V+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(ke=ye.tokens?this.parseInline(ye.tokens):ye.text;Q+1<Ne&&H[Q+1].type==="text";)ye=H[++Q],ke+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);V+=Y?this.renderer.paragraph(ke):ke;continue}default:{var ze='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(ze);return}else throw new Error(ze)}}}return V},z.parseInline=function(H,Y){Y=Y||this.renderer;var V="",Q,se,me,Ee=H.length;for(Q=0;Q<Ee;Q++){if(se=H[Q],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[se.type]&&(me=this.options.extensions.renderers[se.type].call({parser:this},se),me!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(se.type))){V+=me||"";continue}switch(se.type){case"escape":{V+=Y.text(se.text);break}case"html":{V+=Y.html(se.text);break}case"link":{V+=Y.link(se.href,se.title,this.parseInline(se.tokens,Y));break}case"image":{V+=Y.image(se.href,se.title,se.text);break}case"strong":{V+=Y.strong(this.parseInline(se.tokens,Y));break}case"em":{V+=Y.em(this.parseInline(se.tokens,Y));break}case"codespan":{V+=Y.codespan(se.text);break}case"br":{V+=Y.br();break}case"del":{V+=Y.del(this.parseInline(se.tokens,Y));break}case"text":{V+=Y.text(se.text);break}default:{var Ce='Token with "'+se.type+'" type was not found.';if(this.options.silent){console.error(Ce);return}else throw new Error(Ce)}}}return V},q}();function le(q,z,te){if(typeof q>"u"||q===null)throw new Error("marked(): input parameter is undefined or null");if(typeof q!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(q)+", string expected");if(typeof z=="function"&&(te=z,z=null),z=$({},le.defaults,z||{}),L(z),te){var H=z.highlight,Y;try{Y=Z.lex(q,z)}catch(Ee){return te(Ee)}var V=function(Ce){var Le;if(!Ce)try{z.walkTokens&&le.walkTokens(Y,z.walkTokens),Le=oe.parse(Y,z)}catch(Fe){Ce=Fe}return z.highlight=H,Ce?te(Ce):te(null,Le)};if(!H||H.length<3||(delete z.highlight,!Y.length))return V();var Q=0;le.walkTokens(Y,function(Ee){Ee.type==="code"&&(Q++,setTimeout(function(){H(Ee.text,Ee.lang,function(Ce,Le){if(Ce)return V(Ce);Le!=null&&Le!==Ee.text&&(Ee.text=Le,Ee.escaped=!0),Q--,Q===0&&V()})},0))}),Q===0&&V();return}function se(Ee){if(Ee.message+=`
Please report this to https://github.com/markedjs/marked.`,z.silent)return"<p>An error occurred:</p><pre>"+g(Ee.message+"",!0)+"</pre>";throw Ee}try{var me=Z.lex(q,z);if(z.walkTokens){if(z.async)return Promise.all(le.walkTokens(me,z.walkTokens)).then(function(){return oe.parse(me,z)}).catch(se);le.walkTokens(me,z.walkTokens)}return oe.parse(me,z)}catch(Ee){se(Ee)}}le.options=le.setOptions=function(q){return $(le.defaults,q),C(le.defaults),le},le.getDefaults=P,le.defaults=ue.defaults,le.use=function(){for(var q=arguments.length,z=new Array(q),te=0;te<q;te++)z[te]=arguments[te];var H=$.apply(void 0,[{}].concat(z)),Y=le.defaults.extensions||{renderers:{},childTokens:{}},V;z.forEach(function(Q){if(Q.extensions&&(V=!0,Q.extensions.forEach(function(me){if(!me.name)throw new Error("extension name required");if(me.renderer){var Ee=Y.renderers?Y.renderers[me.name]:null;Ee?Y.renderers[me.name]=function(){for(var Ce=arguments.length,Le=new Array(Ce),Fe=0;Fe<Ce;Fe++)Le[Fe]=arguments[Fe];var $e=me.renderer.apply(this,Le);return $e===!1&&($e=Ee.apply(this,Le)),$e}:Y.renderers[me.name]=me.renderer}if(me.tokenizer){if(!me.level||me.level!=="block"&&me.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[me.level]?Y[me.level].unshift(me.tokenizer):Y[me.level]=[me.tokenizer],me.start&&(me.level==="block"?Y.startBlock?Y.startBlock.push(me.start):Y.startBlock=[me.start]:me.level==="inline"&&(Y.startInline?Y.startInline.push(me.start):Y.startInline=[me.start]))}me.childTokens&&(Y.childTokens[me.name]=me.childTokens)})),Q.renderer&&function(){var me=le.defaults.renderer||new ne,Ee=function(Fe){var $e=me[Fe];me[Fe]=function(){for(var ke=arguments.length,ye=new Array(ke),Me=0;Me<ke;Me++)ye[Me]=arguments[Me];var Ue=Q.renderer[Fe].apply(me,ye);return Ue===!1&&(Ue=$e.apply(me,ye)),Ue}};for(var Ce in Q.renderer)Ee(Ce);H.renderer=me}(),Q.tokenizer&&function(){var me=le.defaults.tokenizer||new X,Ee=function(Fe){var $e=me[Fe];me[Fe]=function(){for(var ke=arguments.length,ye=new Array(ke),Me=0;Me<ke;Me++)ye[Me]=arguments[Me];var Ue=Q.tokenizer[Fe].apply(me,ye);return Ue===!1&&(Ue=$e.apply(me,ye)),Ue}};for(var Ce in Q.tokenizer)Ee(Ce);H.tokenizer=me}(),Q.walkTokens){var se=le.defaults.walkTokens;H.walkTokens=function(me){var Ee=[];return Ee.push(Q.walkTokens.call(this,me)),se&&(Ee=Ee.concat(se.call(this,me))),Ee}}V&&(H.extensions=Y),le.setOptions(H)})},le.walkTokens=function(q,z){for(var te=[],H=function(){var se=V.value;switch(te=te.concat(z.call(le,se)),se.type){case"table":{for(var me=I(se.header),Ee;!(Ee=me()).done;){var Ce=Ee.value;te=te.concat(le.walkTokens(Ce.tokens,z))}for(var Le=I(se.rows),Fe;!(Fe=Le()).done;)for(var $e=Fe.value,ke=I($e),ye;!(ye=ke()).done;){var Me=ye.value;te=te.concat(le.walkTokens(Me.tokens,z))}break}case"list":{te=te.concat(le.walkTokens(se.items,z));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[se.type]?le.defaults.extensions.childTokens[se.type].forEach(function(Ue){te=te.concat(le.walkTokens(se[Ue],z))}):se.tokens&&(te=te.concat(le.walkTokens(se.tokens,z)))}},Y=I(q),V;!(V=Y()).done;)H();return te},le.parseInline=function(q,z){if(typeof q>"u"||q===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof q!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(q)+", string expected");z=$({},le.defaults,z||{}),L(z);try{var te=Z.lexInline(q,z);return z.walkTokens&&le.walkTokens(te,z.walkTokens),oe.parseInline(te,z)}catch(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,z.silent)return"<p>An error occurred:</p><pre>"+g(H.message+"",!0)+"</pre>";throw H}},le.Parser=oe,le.parser=oe.parse,le.Renderer=ne,le.TextRenderer=J,le.Lexer=Z,le.lexer=Z.lex,le.Tokenizer=X,le.Slugger=W,le.parse=le;var re=le.options,ee=le.setOptions,B=le.use,K=le.walkTokens,N=le.parseInline,O=le,U=oe.parse,T=Z.lex;ue.Lexer=Z,ue.Parser=oe,ue.Renderer=ne,ue.Slugger=W,ue.TextRenderer=J,ue.Tokenizer=X,ue.getDefaults=P,ue.lexer=T,ue.marked=le,ue.options=re,ue.parse=O,ue.parseInline=N,ue.parser=U,ue.setOptions=ee,ue.use=B,ue.walkTokens=K,Object.defineProperty(ue,"__esModule",{value:!0})}),define(pe[97],be([1,0,26]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=e.$pl=void 0;const R=new D.$Dc(1e4);function r(b){return v(b,"NFC",R)}e.$pl=r;const I=new D.$Dc(1e4);function P(b){return v(b,"NFD",I)}e.$ql=P;const C=/[^\u0000-\u0080]/;function v(b,A,S){if(!b)return b;const y=S.get(b);if(y)return y;let u;return C.test(b)?u=b.normalize(A):u=b,S.set(b,u),u}e.$rl=function(){const b=/[\u0300-\u036f]/g;return function(A){return P(A).replace(b,"")}}()}),define(pe[144],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=e.$Rl=e.rot=e.$Pl=void 0;function D(C,v,b){return Math.min(Math.max(C,v),b)}e.$Pl=D;function R(C,v){return(v+C%v)%v}e.rot=R;class r{constructor(){this.a=0}getNext(){return this.a++}}e.$Rl=r;class I{constructor(){this.a=1,this.b=0}update(v){return this.b=this.b+(v-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Sl=I;class P{constructor(v){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(v),this.c.fill(0,0,v)}update(v){const b=this.c[this.d];return this.c[this.d]=v,this.d=(this.d+1)%this.c.length,this.e-=b,this.e+=v,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Tl=P}),function(){function ue(r){const I=[];typeof r=="number"&&I.push("code/timeOrigin",r);function P(v){I.push(v,Date.now())}function C(){const v=[];for(let b=0;b<I.length;b+=2)v.push({name:I[b],startTime:I[b+1]});return v}return{mark:P,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ue():{mark(r){performance.mark(r)},getMarks(){let r=performance.timeOrigin;typeof r!="number"&&(r=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(r)}];for(const P of performance.getEntriesByType("mark"))I.push({name:P.name,startTime:Math.round(r+P.startTime)});return I}};if(typeof process=="object"){const r=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ue(r)}else return console.trace("perf-util loaded in UNKNOWN environment"),ue()}function D(r){return r.MonacoPerformanceMarks||(r.MonacoPerformanceMarks=e()),r.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=D(R))}(),function(ue,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var R in D)(typeof exports=="object"?exports:ue)[R]=D[R]}}(typeof self<"u"?self:this,function(){return function(ue){var e={};function D(R){if(e[R])return e[R].exports;var r=e[R]={i:R,l:!1,exports:{}};return ue[R].call(r.exports,r,r.exports,D),r.l=!0,r.exports}return D.m=ue,D.c=e,D.d=function(R,r,I){D.o(R,r)||Object.defineProperty(R,r,{enumerable:!0,get:I})},D.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},D.t=function(R,r){if(1&r&&(R=D(R)),8&r||4&r&&typeof R=="object"&&R&&R.__esModule)return R;var I=Object.create(null);if(D.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:R}),2&r&&typeof R!="string")for(var P in R)D.d(I,P,function(C){return R[C]}.bind(null,P));return I},D.n=function(R){var r=R&&R.__esModule?function(){return R.default}:function(){return R};return D.d(r,"a",r),r},D.o=function(R,r){return Object.prototype.hasOwnProperty.call(R,r)},D.p="",D(D.s=0)}([function(ue,e,D){(function(R){var r;e=ue.exports=B,r=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var $e=Array.prototype.slice.call(arguments,0);$e.unshift("SEMVER"),console.log.apply(console,$e)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var I=256,P=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],v=e.src=[],b=0,A=b++;v[A]="0|[1-9]\\d*";var S=b++;v[S]="[0-9]+";var y=b++;v[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var u=b++;v[u]="("+v[A]+")\\.("+v[A]+")\\.("+v[A]+")";var g=b++;v[g]="("+v[S]+")\\.("+v[S]+")\\.("+v[S]+")";var d=b++;v[d]="(?:"+v[A]+"|"+v[y]+")";var f=b++;v[f]="(?:"+v[S]+"|"+v[y]+")";var h=b++;v[h]="(?:-("+v[d]+"(?:\\."+v[d]+")*))";var p=b++;v[p]="(?:-?("+v[f]+"(?:\\."+v[f]+")*))";var l=b++;v[l]="[0-9A-Za-z-]+";var m=b++;v[m]="(?:\\+("+v[l]+"(?:\\."+v[l]+")*))";var c=b++,n="v?"+v[u]+v[h]+"?"+v[m]+"?";v[c]="^"+n+"$";var i="[v=\\s]*"+v[g]+v[p]+"?"+v[m]+"?",o=b++;v[o]="^"+i+"$";var s=b++;v[s]="((?:<|>)?=?)";var t=b++;v[t]=v[S]+"|x|X|\\*";var a=b++;v[a]=v[A]+"|x|X|\\*";var $=b++;v[$]="[v=\\s]*("+v[a]+")(?:\\.("+v[a]+")(?:\\.("+v[a]+")(?:"+v[h]+")?"+v[m]+"?)?)?";var w=b++;v[w]="[v=\\s]*("+v[t]+")(?:\\.("+v[t]+")(?:\\.("+v[t]+")(?:"+v[p]+")?"+v[m]+"?)?)?";var k=b++;v[k]="^"+v[s]+"\\s*"+v[$]+"$";var E=b++;v[E]="^"+v[s]+"\\s*"+v[w]+"$";var L=b++;v[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=b++;v[j]="(?:~>?)";var x=b++;v[x]="(\\s*)"+v[j]+"\\s+",C[x]=new RegExp(v[x],"g");var ce=b++;v[ce]="^"+v[j]+v[$]+"$";var X=b++;v[X]="^"+v[j]+v[w]+"$";var ie=b++;v[ie]="(?:\\^)";var he=b++;v[he]="(\\s*)"+v[ie]+"\\s+",C[he]=new RegExp(v[he],"g");var _=b++;v[_]="^"+v[ie]+v[$]+"$";var de=b++;v[de]="^"+v[ie]+v[w]+"$";var Z=b++;v[Z]="^"+v[s]+"\\s*("+i+")$|^$";var ne=b++;v[ne]="^"+v[s]+"\\s*("+n+")$|^$";var J=b++;v[J]="(\\s*)"+v[s]+"\\s*("+i+"|"+v[$]+")",C[J]=new RegExp(v[J],"g");var W=b++;v[W]="^\\s*("+v[$]+")\\s+-\\s+("+v[$]+")\\s*$";var oe=b++;v[oe]="^\\s*("+v[w]+")\\s+-\\s+("+v[w]+")\\s*$";var le=b++;v[le]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)r(re,v[re]),C[re]||(C[re]=new RegExp(v[re]));function ee($e,ke){if($e instanceof B)return $e;if(typeof $e!="string"||$e.length>I||!(ke?C[o]:C[c]).test($e))return null;try{return new B($e,ke)}catch{return null}}function B($e,ke){if($e instanceof B){if($e.loose===ke)return $e;$e=$e.version}else if(typeof $e!="string")throw new TypeError("Invalid Version: "+$e);if($e.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof B))return new B($e,ke);r("SemVer",$e,ke),this.loose=ke;var ye=$e.trim().match(ke?C[o]:C[c]);if(!ye)throw new TypeError("Invalid Version: "+$e);if(this.raw=$e,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>P||this.major<0)throw new TypeError("Invalid major version");if(this.minor>P||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>P||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var Ue=+Me;if(Ue>=0&&Ue<P)return Ue}return Me}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=ee,e.valid=function($e,ke){var ye=ee($e,ke);return ye?ye.version:null},e.clean=function($e,ke){var ye=ee($e.trim().replace(/^[=v]+/,""),ke);return ye?ye.version:null},e.SemVer=B,B.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},B.prototype.toString=function(){return this.version},B.prototype.compare=function($e){return r("SemVer.compare",this.version,this.loose,$e),$e instanceof B||($e=new B($e,this.loose)),this.compareMain($e)||this.comparePre($e)},B.prototype.compareMain=function($e){return $e instanceof B||($e=new B($e,this.loose)),N(this.major,$e.major)||N(this.minor,$e.minor)||N(this.patch,$e.patch)},B.prototype.comparePre=function($e){if($e instanceof B||($e=new B($e,this.loose)),this.prerelease.length&&!$e.prerelease.length)return-1;if(!this.prerelease.length&&$e.prerelease.length)return 1;if(!this.prerelease.length&&!$e.prerelease.length)return 0;var ke=0;do{var ye=this.prerelease[ke],Me=$e.prerelease[ke];if(r("prerelease compare",ke,ye,Me),ye===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(ye===void 0)return-1;if(ye!==Me)return N(ye,Me)}while(++ke)},B.prototype.inc=function($e,ke){switch($e){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ke);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ke);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ke),this.inc("pre",ke);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ke),this.inc("pre",ke);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}ke&&(this.prerelease[0]===ke?isNaN(this.prerelease[1])&&(this.prerelease=[ke,0]):this.prerelease=[ke,0]);break;default:throw new Error("invalid increment argument: "+$e)}return this.format(),this.raw=this.version,this},e.inc=function($e,ke,ye,Me){typeof ye=="string"&&(Me=ye,ye=void 0);try{return new B($e,ye).inc(ke,Me).version}catch{return null}},e.diff=function($e,ke){if(q($e,ke))return null;var ye=ee($e),Me=ee(ke);if(ye.prerelease.length||Me.prerelease.length){for(var Ue in ye)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ye[Ue]!==Me[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in ye)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ye[Ue]!==Me[Ue])return Ue},e.compareIdentifiers=N;var K=/^[0-9]+$/;function N($e,ke){var ye=K.test($e),Me=K.test(ke);return ye&&Me&&($e=+$e,ke=+ke),ye&&!Me?-1:Me&&!ye?1:$e<ke?-1:$e>ke?1:0}function O($e,ke,ye){return new B($e,ye).compare(new B(ke,ye))}function U($e,ke,ye){return O($e,ke,ye)>0}function T($e,ke,ye){return O($e,ke,ye)<0}function q($e,ke,ye){return O($e,ke,ye)===0}function z($e,ke,ye){return O($e,ke,ye)!==0}function te($e,ke,ye){return O($e,ke,ye)>=0}function H($e,ke,ye){return O($e,ke,ye)<=0}function Y($e,ke,ye,Me){var Ue;switch(ke){case"===":typeof $e=="object"&&($e=$e.version),typeof ye=="object"&&(ye=ye.version),Ue=$e===ye;break;case"!==":typeof $e=="object"&&($e=$e.version),typeof ye=="object"&&(ye=ye.version),Ue=$e!==ye;break;case"":case"=":case"==":Ue=q($e,ye,Me);break;case"!=":Ue=z($e,ye,Me);break;case">":Ue=U($e,ye,Me);break;case">=":Ue=te($e,ye,Me);break;case"<":Ue=T($e,ye,Me);break;case"<=":Ue=H($e,ye,Me);break;default:throw new TypeError("Invalid operator: "+ke)}return Ue}function V($e,ke){if($e instanceof V){if($e.loose===ke)return $e;$e=$e.value}if(!(this instanceof V))return new V($e,ke);r("comparator",$e,ke),this.loose=ke,this.parse($e),this.semver===Q?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}e.rcompareIdentifiers=function($e,ke){return N(ke,$e)},e.major=function($e,ke){return new B($e,ke).major},e.minor=function($e,ke){return new B($e,ke).minor},e.patch=function($e,ke){return new B($e,ke).patch},e.compare=O,e.compareLoose=function($e,ke){return O($e,ke,!0)},e.rcompare=function($e,ke,ye){return O(ke,$e,ye)},e.sort=function($e,ke){return $e.sort(function(ye,Me){return e.compare(ye,Me,ke)})},e.rsort=function($e,ke){return $e.sort(function(ye,Me){return e.rcompare(ye,Me,ke)})},e.gt=U,e.lt=T,e.eq=q,e.neq=z,e.gte=te,e.lte=H,e.cmp=Y,e.Comparator=V;var Q={};function se($e,ke){if($e instanceof se)return $e.loose===ke?$e:new se($e.raw,ke);if($e instanceof V)return new se($e.value,ke);if(!(this instanceof se))return new se($e,ke);if(this.loose=ke,this.raw=$e,this.set=$e.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+$e);this.format()}function me($e){return!$e||$e.toLowerCase()==="x"||$e==="*"}function Ee($e,ke,ye,Me,Ue,Ze,We,Xe,Qe,ge,Pe,Ie,Ne){return((ke=me(ye)?"":me(Me)?">="+ye+".0.0":me(Ue)?">="+ye+"."+Me+".0":">="+ke)+" "+(Xe=me(Qe)?"":me(ge)?"<"+(+Qe+1)+".0.0":me(Pe)?"<"+Qe+"."+(+ge+1)+".0":Ie?"<="+Qe+"."+ge+"."+Pe+"-"+Ie:"<="+Xe)).trim()}function Ce($e,ke){for(var ye=0;ye<$e.length;ye++)if(!$e[ye].test(ke))return!1;if(ke.prerelease.length){for(ye=0;ye<$e.length;ye++)if(r($e[ye].semver),$e[ye].semver!==Q&&$e[ye].semver.prerelease.length>0){var Me=$e[ye].semver;if(Me.major===ke.major&&Me.minor===ke.minor&&Me.patch===ke.patch)return!0}return!1}return!0}function Le($e,ke,ye){try{ke=new se(ke,ye)}catch{return!1}return ke.test($e)}function Fe($e,ke,ye,Me){var Ue,Ze,We,Xe,Qe;switch($e=new B($e,Me),ke=new se(ke,Me),ye){case">":Ue=U,Ze=H,We=T,Xe=">",Qe=">=";break;case"<":Ue=T,Ze=te,We=U,Xe="<",Qe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Le($e,ke,Me))return!1;for(var ge=0;ge<ke.set.length;++ge){var Pe=ke.set[ge],Ie=null,Ne=null;if(Pe.forEach(function(ze){ze.semver===Q&&(ze=new V(">=0.0.0")),Ie=Ie||ze,Ne=Ne||ze,Ue(ze.semver,Ie.semver,Me)?Ie=ze:We(ze.semver,Ne.semver,Me)&&(Ne=ze)}),Ie.operator===Xe||Ie.operator===Qe||(!Ne.operator||Ne.operator===Xe)&&Ze($e,Ne.semver)||Ne.operator===Qe&&We($e,Ne.semver))return!1}return!0}V.prototype.parse=function($e){var ke=this.loose?C[Z]:C[ne],ye=$e.match(ke);if(!ye)throw new TypeError("Invalid comparator: "+$e);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new B(ye[2],this.loose):this.semver=Q},V.prototype.toString=function(){return this.value},V.prototype.test=function($e){return r("Comparator.test",$e,this.loose),this.semver===Q||(typeof $e=="string"&&($e=new B($e,this.loose)),Y($e,this.operator,this.semver,this.loose))},V.prototype.intersects=function($e,ke){if(!($e instanceof V))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new se($e.value,ke),Le(this.value,ye,ke);if($e.operator==="")return ye=new se(this.value,ke),Le($e.semver,ye,ke);var Me=!(this.operator!==">="&&this.operator!==">"||$e.operator!==">="&&$e.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||$e.operator!=="<="&&$e.operator!=="<"),Ze=this.semver.version===$e.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||$e.operator!==">="&&$e.operator!=="<="),Xe=Y(this.semver,"<",$e.semver,ke)&&(this.operator===">="||this.operator===">")&&($e.operator==="<="||$e.operator==="<"),Qe=Y(this.semver,">",$e.semver,ke)&&(this.operator==="<="||this.operator==="<")&&($e.operator===">="||$e.operator===">");return Me||Ue||Ze&&We||Xe||Qe},e.Range=se,se.prototype.format=function(){return this.range=this.set.map(function($e){return $e.join(" ").trim()}).join("||").trim(),this.range},se.prototype.toString=function(){return this.range},se.prototype.parseRange=function($e){var ke=this.loose;$e=$e.trim(),r("range",$e,ke);var ye=ke?C[oe]:C[W];$e=$e.replace(ye,Ee),r("hyphen replace",$e),$e=$e.replace(C[J],"$1$2$3"),r("comparator trim",$e,C[J]),$e=($e=($e=$e.replace(C[x],"$1~")).replace(C[he],"$1^")).split(/\s+/).join(" ");var Me=ke?C[Z]:C[ne],Ue=$e.split(" ").map(function(Ze){return function(We,Xe){return r("comp",We),We=function(Qe,ge){return Qe.trim().split(/\s+/).map(function(Pe){return function(Ie,Ne){r("caret",Ie,Ne);var ze=Ne?C[de]:C[_];return Ie.replace(ze,function(He,Be,Ve,Je,Ge){var Ye;return r("caret",Ie,He,Be,Ve,Je,Ge),me(Be)?Ye="":me(Ve)?Ye=">="+Be+".0.0 <"+(+Be+1)+".0.0":me(Je)?Ye=Be==="0"?">="+Be+"."+Ve+".0 <"+Be+"."+(+Ve+1)+".0":">="+Be+"."+Ve+".0 <"+(+Be+1)+".0.0":Ge?(r("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Ye=Be==="0"?Ve==="0"?">="+Be+"."+Ve+"."+Je+Ge+" <"+Be+"."+Ve+"."+(+Je+1):">="+Be+"."+Ve+"."+Je+Ge+" <"+Be+"."+(+Ve+1)+".0":">="+Be+"."+Ve+"."+Je+Ge+" <"+(+Be+1)+".0.0"):(r("no pr"),Ye=Be==="0"?Ve==="0"?">="+Be+"."+Ve+"."+Je+" <"+Be+"."+Ve+"."+(+Je+1):">="+Be+"."+Ve+"."+Je+" <"+Be+"."+(+Ve+1)+".0":">="+Be+"."+Ve+"."+Je+" <"+(+Be+1)+".0.0"),r("caret return",Ye),Ye})}(Pe,ge)}).join(" ")}(We,Xe),r("caret",We),We=function(Qe,ge){return Qe.trim().split(/\s+/).map(function(Pe){return function(Ie,Ne){var ze=Ne?C[X]:C[ce];return Ie.replace(ze,function(He,Be,Ve,Je,Ge){var Ye;return r("tilde",Ie,He,Be,Ve,Je,Ge),me(Be)?Ye="":me(Ve)?Ye=">="+Be+".0.0 <"+(+Be+1)+".0.0":me(Je)?Ye=">="+Be+"."+Ve+".0 <"+Be+"."+(+Ve+1)+".0":Ge?(r("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Ye=">="+Be+"."+Ve+"."+Je+Ge+" <"+Be+"."+(+Ve+1)+".0"):Ye=">="+Be+"."+Ve+"."+Je+" <"+Be+"."+(+Ve+1)+".0",r("tilde return",Ye),Ye})}(Pe,ge)}).join(" ")}(We,Xe),r("tildes",We),We=function(Qe,ge){return r("replaceXRanges",Qe,ge),Qe.split(/\s+/).map(function(Pe){return function(Ie,Ne){Ie=Ie.trim();var ze=Ne?C[E]:C[k];return Ie.replace(ze,function(He,Be,Ve,Je,Ge,Ye){r("xRange",Ie,He,Be,Ve,Je,Ge,Ye);var it=me(Ve),_e=it||me(Je),st=_e||me(Ge);return Be==="="&&st&&(Be=""),it?He=Be===">"||Be==="<"?"<0.0.0":"*":Be&&st?(_e&&(Je=0),st&&(Ge=0),Be===">"?(Be=">=",_e?(Ve=+Ve+1,Je=0,Ge=0):st&&(Je=+Je+1,Ge=0)):Be==="<="&&(Be="<",_e?Ve=+Ve+1:Je=+Je+1),He=Be+Ve+"."+Je+"."+Ge):_e?He=">="+Ve+".0.0 <"+(+Ve+1)+".0.0":st&&(He=">="+Ve+"."+Je+".0 <"+Ve+"."+(+Je+1)+".0"),r("xRange return",He),He})}(Pe,ge)}).join(" ")}(We,Xe),r("xrange",We),We=function(Qe,ge){return r("replaceStars",Qe,ge),Qe.trim().replace(C[le],"")}(We,Xe),r("stars",We),We}(Ze,ke)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(Ze){return!!Ze.match(Me)})),Ue=Ue.map(function(Ze){return new V(Ze,ke)})},se.prototype.intersects=function($e,ke){if(!($e instanceof se))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(Me){return $e.set.some(function(Ue){return Ue.every(function(Ze){return Me.intersects(Ze,ke)})})})})},e.toComparators=function($e,ke){return new se($e,ke).set.map(function(ye){return ye.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},se.prototype.test=function($e){if(!$e)return!1;typeof $e=="string"&&($e=new B($e,this.loose));for(var ke=0;ke<this.set.length;ke++)if(Ce(this.set[ke],$e))return!0;return!1},e.satisfies=Le,e.maxSatisfying=function($e,ke,ye){var Me=null,Ue=null;try{var Ze=new se(ke,ye)}catch{return null}return $e.forEach(function(We){Ze.test(We)&&(Me&&Ue.compare(We)!==-1||(Ue=new B(Me=We,ye)))}),Me},e.minSatisfying=function($e,ke,ye){var Me=null,Ue=null;try{var Ze=new se(ke,ye)}catch{return null}return $e.forEach(function(We){Ze.test(We)&&(Me&&Ue.compare(We)!==1||(Ue=new B(Me=We,ye)))}),Me},e.validRange=function($e,ke){try{return new se($e,ke).range||"*"}catch{return null}},e.ltr=function($e,ke,ye){return Fe($e,ke,"<",ye)},e.gtr=function($e,ke,ye){return Fe($e,ke,">",ye)},e.outside=Fe,e.prerelease=function($e,ke){var ye=ee($e,ke);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function($e,ke,ye){return $e=new se($e,ye),ke=new se(ke,ye),$e.intersects(ke)},e.coerce=function($e){if($e instanceof B)return $e;if(typeof $e!="string")return null;var ke=$e.match(C[L]);return ke==null?null:ee((ke[1]||"0")+"."+(ke[2]||"0")+"."+(ke[3]||"0"))}}).call(this,D(1))},function(ue,e){var D,R,r=ue.exports={};function I(){throw new Error("setTimeout has not been defined")}function P(){throw new Error("clearTimeout has not been defined")}function C(f){if(D===setTimeout)return setTimeout(f,0);if((D===I||!D)&&setTimeout)return D=setTimeout,setTimeout(f,0);try{return D(f,0)}catch{try{return D.call(null,f,0)}catch{return D.call(this,f,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:I}catch{D=I}try{R=typeof clearTimeout=="function"?clearTimeout:P}catch{R=P}})();var v,b=[],A=!1,S=-1;function y(){A&&v&&(A=!1,v.length?b=v.concat(b):S=-1,b.length&&u())}function u(){if(!A){var f=C(y);A=!0;for(var h=b.length;h;){for(v=b,b=[];++S<h;)v&&v[S].run();S=-1,h=b.length}v=null,A=!1,function(p){if(R===clearTimeout)return clearTimeout(p);if((R===P||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(p);try{R(p)}catch{try{return R.call(null,p)}catch{return R.call(this,p)}}}(f)}}function g(f,h){this.fun=f,this.array=h}function d(){}r.nextTick=function(f){var h=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)h[p-1]=arguments[p];b.push(new g(f,h)),b.length!==1||A||C(u)},g.prototype.run=function(){this.fun.apply(null,this.array)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=d,r.addListener=d,r.once=d,r.off=d,r.removeListener=d,r.removeAllListeners=d,r.emit=d,r.prependListener=d,r.prependOnceListener=d,r.listeners=function(f){return[]},r.binding=function(f){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(f){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}}])}),define(pe[145],be([1,0]),function(ue,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=void 0;class R{constructor(C,v,b){this.level=C,this.key=v,this.value=b,this.forward=[]}}const r=void 0;class I{constructor(C,v=2**16){this.comparator=C,this[D]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(v)|0),this.e=new R(this.c,r,r)}get size(){return this.f}clear(){this.e=new R(this.c,r,r),this.f=0}has(C){return!!I.g(this,C,this.comparator)}get(C){return I.g(this,C,this.comparator)?.value}set(C,v){return I.h(this,C,v,this.comparator)&&(this.f+=1),this}delete(C){const v=I.k(this,C,this.comparator);return v&&(this.f-=1),v}forEach(C,v){let b=this.e.forward[0];for(;b;)C.call(v,b.value,b.key,this),b=b.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this.e.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this.e.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this.e.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",v=this.e.forward[0];for(;v;)C+=`node(${v.key}, ${v.value}, lvl:${v.level})`,v=v.forward[0];return C}static g(C,v,b){let A=C.e;for(let S=C.d-1;S>=0;S--)for(;A.forward[S]&&b(A.forward[S].key,v)<0;)A=A.forward[S];if(A=A.forward[0],A&&b(A.key,v)===0)return A}static h(C,v,b,A){const S=[];let y=C.e;for(let u=C.d-1;u>=0;u--){for(;y.forward[u]&&A(y.forward[u].key,v)<0;)y=y.forward[u];S[u]=y}if(y=y.forward[0],y&&A(y.key,v)===0)return y.value=b,!1;{const u=I.j(C);if(u>C.d){for(let g=C.d;g<u;g++)S[g]=C.e;C.d=u}y=new R(u,v,b);for(let g=0;g<u;g++)y.forward[g]=S[g].forward[g],S[g].forward[g]=y;return!0}}static j(C,v=.5){let b=1;for(;Math.random()<v&&b<C.c;)b+=1;return b}static k(C,v,b){const A=[];let S=C.e;for(let y=C.d-1;y>=0;y--){for(;S.forward[y]&&b(S.forward[y].key,v)<0;)S=S.forward[y];A[y]=S}if(S=S.forward[0],!S||b(S.key,v)!==0)return!1;for(let y=0;y<C.d&&A[y].forward[y]===S;y++)A[y].forward[y]=S.forward[y];for(;C.d>0&&C.e.forward[C.d-1]===r;)C.d-=1;return!0}}e.$Cr=I}),define(pe[59],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class R{static create(I){return new R(I)}constructor(I){this.c=D&&I===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Kd=R}),define(pe[5],be([1,0,11,74,2,96,59]),function(ue,e,D,R,r,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.Event=void 0;const C=!1,v=!1;var b;(function(k){k.None=()=>r.$Sc.None;function E(Y){if(v){const{onDidAddListener:V}=Y,Q=g.create();let se=0;Y.onDidAddListener=()=>{++se===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Q.print()),V?.()}}}function L(Y,V){return ne(Y,()=>{},0,void 0,!0,void 0,V)}k.defer=L;function j(Y){return(V,Q=null,se)=>{let me=!1,Ee;return Ee=Y(Ce=>{if(!me)return Ee?Ee.dispose():me=!0,V.call(Q,Ce)},null,se),me&&Ee.dispose(),Ee}}k.once=j;function x(Y,V,Q){return de((se,me=null,Ee)=>Y(Ce=>se.call(me,V(Ce)),null,Ee),Q)}k.map=x;function ce(Y,V,Q){return de((se,me=null,Ee)=>Y(Ce=>{V(Ce),se.call(me,Ce)},null,Ee),Q)}k.forEach=ce;function X(Y,V,Q){return de((se,me=null,Ee)=>Y(Ce=>V(Ce)&&se.call(me,Ce),null,Ee),Q)}k.filter=X;function ie(Y){return Y}k.signal=ie;function he(...Y){return(V,Q=null,se)=>{const me=(0,r.$Pc)(...Y.map(Ee=>Ee(Ce=>V.call(Q,Ce))));return Z(me,se)}}k.any=he;function _(Y,V,Q,se){let me=Q;return x(Y,Ee=>(me=V(me,Ee),me),se)}k.reduce=_;function de(Y,V){let Q;const se={onWillAddFirstListener(){Q=Y(me.fire,me)},onDidRemoveLastListener(){Q?.dispose()}};V||E(se);const me=new l(se);return V?.add(me),me.event}function Z(Y,V){return V instanceof Array?V.push(Y):V&&V.add(Y),Y}function ne(Y,V,Q=100,se=!1,me=!1,Ee,Ce){let Le,Fe,$e,ke=0,ye;const Me={leakWarningThreshold:Ee,onWillAddFirstListener(){Le=Y(Ze=>{ke++,Fe=V(Fe,Ze),se&&!$e&&(Ue.fire(Fe),Fe=void 0),ye=()=>{const We=Fe;Fe=void 0,$e=void 0,(!se||ke>1)&&Ue.fire(We),ke=0},typeof Q=="number"?(clearTimeout($e),$e=setTimeout(ye,Q)):$e===void 0&&($e=0,queueMicrotask(ye))})},onWillRemoveListener(){me&&ke>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,Le.dispose()}};Ce||E(Me);const Ue=new l(Me);return Ce?.add(Ue),Ue.event}k.debounce=ne;function J(Y,V=0,Q){return k.debounce(Y,(se,me)=>se?(se.push(me),se):[me],V,void 0,!0,void 0,Q)}k.accumulate=J;function W(Y,V=(se,me)=>se===me,Q){let se=!0,me;return X(Y,Ee=>{const Ce=se||!V(Ee,me);return se=!1,me=Ee,Ce},Q)}k.latch=W;function oe(Y,V,Q){return[k.filter(Y,V,Q),k.filter(Y,se=>!V(se),Q)]}k.split=oe;function le(Y,V=!1,Q=[],se){let me=Q.slice(),Ee=Y(Fe=>{me?me.push(Fe):Le.fire(Fe)});se&&se.add(Ee);const Ce=()=>{me?.forEach(Fe=>Le.fire(Fe)),me=null},Le=new l({onWillAddFirstListener(){Ee||(Ee=Y(Fe=>Le.fire(Fe)),se&&se.add(Ee))},onDidAddFirstListener(){me&&(V?setTimeout(Ce):Ce())},onDidRemoveLastListener(){Ee&&Ee.dispose(),Ee=null}});return se&&se.add(Le),Le.event}k.buffer=le;function re(Y,V){return(se,me,Ee)=>{const Ce=V(new B);return Y(function(Le){const Fe=Ce.evaluate(Le);Fe!==ee&&se.call(me,Fe)},void 0,Ee)}}k.chain=re;const ee=Symbol("HaltChainable");class B{constructor(){this.f=[]}map(V){return this.f.push(V),this}forEach(V){return this.f.push(Q=>(V(Q),Q)),this}filter(V){return this.f.push(Q=>V(Q)?Q:ee),this}reduce(V,Q){let se=Q;return this.f.push(me=>(se=V(se,me),se)),this}latch(V=(Q,se)=>Q===se){let Q=!0,se;return this.f.push(me=>{const Ee=Q||!V(me,se);return Q=!1,se=me,Ee?me:ee}),this}evaluate(V){for(const Q of this.f)if(V=Q(V),V===ee)break;return V}}function K(Y,V,Q=se=>se){const se=(...Le)=>Ce.fire(Q(...Le)),me=()=>Y.on(V,se),Ee=()=>Y.removeListener(V,se),Ce=new l({onWillAddFirstListener:me,onDidRemoveLastListener:Ee});return Ce.event}k.fromNodeEventEmitter=K;function N(Y,V,Q=se=>se){const se=(...Le)=>Ce.fire(Q(...Le)),me=()=>Y.addEventListener(V,se),Ee=()=>Y.removeEventListener(V,se),Ce=new l({onWillAddFirstListener:me,onDidRemoveLastListener:Ee});return Ce.event}k.fromDOMEventEmitter=N;function O(Y){return new Promise(V=>j(Y)(V))}k.toPromise=O;function U(Y){const V=new l;return Y.then(Q=>{V.fire(Q)},()=>{V.fire(void 0)}).finally(()=>{V.dispose()}),V.event}k.fromPromise=U;function T(Y,V,Q){return V(Q),Y(se=>V(se))}k.runAndSubscribe=T;function q(Y,V){let Q=null;function se(Ee){Q?.dispose(),Q=new r.$Rc,V(Ee,Q)}se(void 0);const me=Y(Ee=>se(Ee));return(0,r.$Qc)(()=>{me.dispose(),Q?.dispose()})}k.runAndSubscribeWithStore=q;class z{constructor(V,Q){this._observable=V,this.f=0,this.g=!1;const se={onWillAddFirstListener:()=>{V.addObserver(this)},onDidRemoveLastListener:()=>{V.removeObserver(this)}};Q||E(se),this.emitter=new l(se),Q&&Q.add(this.emitter)}beginUpdate(V){this.f++}handlePossibleChange(V){}handleChange(V,Q){this.g=!0}endUpdate(V){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function te(Y,V){return new z(Y,V).emitter.event}k.fromObservable=te;function H(Y){return V=>{let Q=0,se=!1;const me={beginUpdate(){Q++},endUpdate(){Q--,Q===0&&(Y.reportChanges(),se&&(se=!1,V()))},handlePossibleChange(){},handleChange(){se=!0}};return Y.addObserver(me),Y.reportChanges(),{dispose(){Y.removeObserver(me)}}}}k.fromObservableLight=H})(b||(e.Event=b={}));class A{static{this.all=new Set}static{this.f=0}constructor(E){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${E}_${A.f++}`,A.all.add(this)}start(E){this.g=new P.$Kd,this.listenerCount=E}stop(){if(this.g){const E=this.g.elapsed();this.durations.push(E),this.elapsedOverall+=E,this.invocationCount+=1,this.g=void 0}}}e.$Md=A;let S=-1;function y(k){const E=S;return S=k,{dispose(){S=E}}}e.$Nd=y;class u{constructor(E,L=Math.random().toString(18).slice(2,5)){this.threshold=E,this.name=L,this.g=0}dispose(){this.f?.clear()}check(E,L){const j=this.threshold;if(j<=0||L<j)return;this.f||(this.f=new Map);const x=this.f.get(E.value)||0;if(this.f.set(E.value,x+1),this.g-=1,this.g<=0){this.g=j*.5;let ce,X=0;for(const[ie,he]of this.f)(!ce||X<he)&&(ce=ie,X=he);console.warn(`[${this.name}] potential listener LEAK detected, having ${L} listeners already. MOST frequent listener (${X}):`),console.warn(ce)}return()=>{const ce=this.f.get(E.value)||0;this.f.set(E.value,ce-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(E){this.value=E}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let d=0;class f{constructor(E){this.value=E,this.id=d++}}const h=2,p=(k,E)=>{if(k instanceof f)E(k);else for(let L=0;L<k.length;L++){const j=k[L];j&&E(j)}};class l{constructor(E){this.w=0,this.f=E,this.g=S>0||this.f?.leakWarningThreshold?new u(this.f?.leakWarningThreshold??S):void 0,this.j=this.f?._profName?new A(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(C){const E=this.t;queueMicrotask(()=>{p(E,L=>L.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(E,L,j)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$Sc.None;if(this.m)return r.$Sc.None;L&&(E=E.bind(L));const x=new f(E);let ce,X;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(x.stack=g.create(),ce=this.g.check(x.stack,this.w+1)),C&&(x.stack=X??g.create()),this.t?this.t instanceof f?(this.u??=new c,this.t=[this.t,x]):this.t.push(x):(this.f?.onWillAddFirstListener?.(this),this.t=x,this.f?.onDidAddFirstListener?.(this)),this.w++;const ie=(0,r.$Qc)(()=>{ce?.(),this.x(x)});return j instanceof r.$Rc?j.add(ie):Array.isArray(j)&&j.push(ie),ie},this.q}x(E){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const L=this.t,j=L.indexOf(E);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,L[j]=void 0;const x=this.u.current===this;if(this.w*h<=L.length){let ce=0;for(let X=0;X<L.length;X++)L[X]?L[ce++]=L[X]:x&&(this.u.end--,ce<this.u.i&&this.u.i--);L.length=ce}}y(E,L){if(!E)return;const j=this.f?.onListenerError||D.$1;if(!j){E.value(L);return}try{E.value(L)}catch(x){j(x)}}z(E){const L=E.current.t;for(;E.i<E.end;)this.y(L[E.i++],E.value);E.reset()}fire(E){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof f)this.y(this.t,E);else{const L=this.u;L.enqueue(this,E,this.t.length),this.z(L)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Od=l;const m=()=>new c;e.$Pd=m;class c{constructor(){this.i=-1,this.end=0}enqueue(E,L,j){this.i=0,this.end=j,this.current=E,this.value=L}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends l{async fireAsync(E,L,j){if(this.t)for(this.h||(this.h=new I.$2c),p(this.t,x=>this.h.push([x.value,E]));this.h.size>0&&!L.isCancellationRequested;){const[x,ce]=this.h.shift(),X=[],ie={...ce,token:L,waitUntil:he=>{if(Object.isFrozen(X))throw new Error("waitUntil can NOT be called asynchronous");j&&(he=j(he,x)),X.push(he)}};try{x(ie)}catch(he){(0,D.$1)(he);continue}Object.freeze(X),await Promise.allSettled(X).then(he=>{for(const _ of he)_.status==="rejected"&&(0,D.$1)(_.reason)})}}}e.$Qd=n;class i extends l{get isPaused(){return this.h!==0}constructor(E){super(E),this.h=0,this.s=new I.$2c,this.A=E?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const E=Array.from(this.s);this.s.clear(),super.fire(this.A(E))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(E){this.w&&(this.h!==0?this.s.push(E):super.fire(E))}}e.$Rd=i;class o extends i{constructor(E){super(E),this.k=E.delay??100}fire(E){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(E)}}e.$Sd=o;class s extends l{constructor(E){super(E),this.h=[],this.k=E?.merge}fire(E){this.hasListeners()&&(this.h.push(E),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(L=>super.fire(L)),this.h=[]}))}}e.$Td=s;class t{constructor(){this.g=!1,this.h=[],this.f=new l({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(E){const L={event:E,listener:null};this.h.push(L),this.g&&this.m(L);const j=()=>{this.g&&this.o(L);const x=this.h.indexOf(L);this.h.splice(x,1)};return(0,r.$Qc)((0,R.$db)(j))}j(){this.g=!0,this.h.forEach(E=>this.m(E))}k(){this.g=!1,this.h.forEach(E=>this.o(E))}m(E){E.listener=E.event(L=>this.f.fire(L))}o(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.f.dispose()}}e.$Ud=t;class a{constructor(E,L,j,x){this.f=new r.$Rc;const ce=this.f.add(new t),X=this.f.add(new r.$1c);function ie(he){X.set(he,ce.add(x(he)))}for(const he of E)ie(he);this.f.add(L(he=>{ie(he)})),this.f.add(j(he=>{X.deleteAndDispose(he)})),this.event=ce.event}dispose(){this.f.dispose()}}e.$Vd=a;class ${constructor(){this.f=[]}wrapEvent(E){return(L,j,x)=>E(ce=>{const X=this.f[this.f.length-1];X?X.push(()=>L.call(j,ce)):L.call(j,ce)},void 0,x)}bufferEvents(E){const L=[];this.f.push(L);const j=E();return this.f.pop(),L.forEach(x=>x()),j}}e.$Wd=$;class w{constructor(){this.f=!1,this.g=b.None,this.h=r.$Sc.None,this.j=new l({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(E){this.g=E,this.f&&(this.h.dispose(),this.h=E(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Xd=w}),define(pe[20],be([1,0,5]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yd=e.CancellationToken=void 0;const R=Object.freeze(function(C,v){const b=setTimeout(C.bind(v),0);return{dispose(){clearTimeout(b)}}});var r;(function(C){function v(b){return b===C.None||b===C.Cancelled||b instanceof I?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}C.isCancellationToken=v,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(r||(e.CancellationToken=r={}));class I{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new D.$Od),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class P{constructor(v){this.f=void 0,this.g=void 0,this.g=v&&v.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new I),this.f}cancel(){this.f?this.f instanceof I&&this.f.cancel():this.f=r.Cancelled}dispose(v=!1){v&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof I&&this.f.dispose():this.f=r.None}}e.$Yd=P}),define(pe[146],be([1,0,20]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=void 0;class R{constructor(C){this.b=C,this.a=null}get(){if(this.a)return this.a;const C=new D.$Yd,v=this.b(C.token);return this.a={promise:v,dispose:()=>{this.a=null,C.cancel(),C.dispose()}},this.a}}e.$xe=R;class r{constructor(C){this.c=C,this.a=void 0,this.b=void 0}get(C){const v=JSON.stringify(C);return this.b!==v&&(this.b=v,this.a=this.c(C)),this.a}}e.$ye=r;class I{get cachedValues(){return this.a}constructor(C){this.b=C,this.a=new Map}get(C){if(this.a.has(C))return this.a.get(C);const v=this.b(C);return this.a.set(C,v),v}}e.$ze=I}),define(pe[48],be([1,0,11,2]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=void 0;function r(m){const c=m;return c?typeof c.read=="function":!1}e.$Zd=r;function I(m){const c=m;return c?[c.on,c.pause,c.resume,c.destroy].every(n=>typeof n=="function"):!1}e.$1d=I;function P(m){const c=m;return c?I(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.$2d=P;function C(m,c){return new v(m,c)}e.$3d=C;class v{constructor(c,n){this.e=c,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(n=>n(c))}h(c){this.c.error.length===0?(0,D.$1)(c):this.c.error.slice(0).forEach(n=>n(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,n){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(c,n){if(this.a.destroyed)return;let i;switch(c){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const o=i.indexOf(n);o>=0&&i.splice(o,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(m,c){const n=[];let i;for(;(i=m.read())!==null;)n.push(i);return c(n)}e.$4d=b;function A(m,c,n){const i=[];let o;for(;(o=m.read())!==null&&i.length<n;)i.push(o);return o===null&&i.length>0?c(i):{read:()=>{if(i.length>0)return i.shift();if(typeof o<"u"){const s=o;return o=void 0,s}return m.read()}}}e.$5d=A;function S(m,c){return new Promise((n,i)=>{const o=[];y(m,{onData:s=>{c&&o.push(s)},onError:s=>{c?i(s):n(void 0)},onEnd:()=>{n(c?c(o):void 0)}})})}e.$6d=S;function y(m,c,n){m.on("error",i=>{n?.isCancellationRequested||c.onError(i)}),m.on("end",()=>{n?.isCancellationRequested||c.onEnd()}),m.on("data",i=>{n?.isCancellationRequested||c.onData(i)})}e.$7d=y;function u(m,c){return new Promise((n,i)=>{const o=new R.$Rc,s=[],t=w=>{if(s.push(w),s.length>c)return o.dispose(),m.pause(),n({stream:m,buffer:s,ended:!1})},a=w=>(o.dispose(),i(w)),$=()=>(o.dispose(),n({stream:m,buffer:s,ended:!0}));o.add((0,R.$Qc)(()=>m.removeListener("error",a))),m.on("error",a),o.add((0,R.$Qc)(()=>m.removeListener("end",$))),m.on("end",$),o.add((0,R.$Qc)(()=>m.removeListener("data",t))),m.on("data",t)})}e.$8d=u;function g(m,c){const n=C(c);return n.end(m),n}e.$9d=g;function d(){const m=C(()=>{throw new Error("not supported")});return m.end(),m}e.$0d=d;function f(m){let c=!1;return{read:()=>c?null:(c=!0,m)}}e.$$d=f;function h(m,c,n){const i=C(n);return y(m,{onData:o=>i.write(c.data(o)),onError:o=>i.error(c.error?c.error(o):o),onEnd:()=>i.end()}),i}e.$_d=h;function p(m,c,n){let i=!1;return{read:()=>{const o=c.read();return i?o:(i=!0,o!==null?n([m,o]):m)}}}e.$ae=p;function l(m,c,n){let i=!1;const o=C(n);return y(c,{onData:s=>i?o.write(s):(i=!0,o.write(n([m,s]))),onError:s=>o.error(s),onEnd:()=>{i||(i=!0,o.write(m)),o.end()}}),o}e.$be=l}),define(pe[15],be([1,0,76,48]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=void 0;const r=typeof Buffer<"u",I=new D.$V(()=>new Uint8Array(256));let P,C;class v{static alloc(L){return r?new v(Buffer.allocUnsafe(L)):new v(new Uint8Array(L))}static wrap(L){return r&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new v(L)}static fromString(L,j){return!(j?.dontUseNodeBuffer||!1)&&r?new v(Buffer.from(L)):(P||(P=new TextEncoder),new v(P.encode(L)))}static fromByteArray(L){const j=v.alloc(L.length);for(let x=0,ce=L.length;x<ce;x++)j.buffer[x]=L[x];return j}static concat(L,j){if(typeof j>"u"){j=0;for(let X=0,ie=L.length;X<ie;X++)j+=L[X].byteLength}const x=v.alloc(j);let ce=0;for(let X=0,ie=L.length;X<ie;X++){const he=L[X];x.set(he,ce),ce+=he.byteLength}return x}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=v.alloc(this.byteLength);return L.set(this),L}toString(){return r?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(L,j){return new v(this.buffer.subarray(L,j))}set(L,j){if(L instanceof v)this.buffer.set(L.buffer,j);else if(L instanceof Uint8Array)this.buffer.set(L,j);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),j);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return y(this.buffer,L)}writeUInt32BE(L,j){u(this.buffer,L,j)}readUInt32LE(L){return g(this.buffer,L)}writeUInt32LE(L,j){d(this.buffer,L,j)}readUInt8(L){return f(this.buffer,L)}writeUInt8(L,j){h(this.buffer,L,j)}indexOf(L,j=0){return b(this.buffer,L instanceof v?L.buffer:L,j)}}e.$ce=v;function b(E,L,j=0){const x=L.byteLength,ce=E.byteLength;if(x===0)return 0;if(x===1)return E.indexOf(L[0]);if(x>ce-j)return-1;const X=I.value;X.fill(L.length);for(let de=0;de<L.length;de++)X[L[de]]=L.length-de-1;let ie=j+L.length-1,he=ie,_=-1;for(;ie<ce;)if(E[ie]===L[he]){if(he===0){_=ie;break}ie--,he--}else ie+=Math.max(L.length-he,X[E[ie]]),he=L.length-1;return _}e.$de=b;function A(E,L){return E[L+0]<<0>>>0|E[L+1]<<8>>>0}e.$ee=A;function S(E,L,j){E[j+0]=L&255,L=L>>>8,E[j+1]=L&255}e.$fe=S;function y(E,L){return E[L]*2**24+E[L+1]*2**16+E[L+2]*2**8+E[L+3]}e.$ge=y;function u(E,L,j){E[j+3]=L,L=L>>>8,E[j+2]=L,L=L>>>8,E[j+1]=L,L=L>>>8,E[j]=L}e.$he=u;function g(E,L){return E[L+0]<<0>>>0|E[L+1]<<8>>>0|E[L+2]<<16>>>0|E[L+3]<<24>>>0}e.$ie=g;function d(E,L,j){E[j+0]=L&255,L=L>>>8,E[j+1]=L&255,L=L>>>8,E[j+2]=L&255,L=L>>>8,E[j+3]=L&255}e.$je=d;function f(E,L){return E[L]}e.$ke=f;function h(E,L,j){E[j]=L}e.$le=h;function p(E){return R.$4d(E,L=>v.concat(L))}e.$me=p;function l(E){return R.$$d(E)}e.$ne=l;function m(E){return R.$6d(E,L=>v.concat(L))}e.$oe=m;async function c(E){return E.ended?v.concat(E.buffer):v.concat([...E.buffer,await m(E.stream)])}e.$pe=c;function n(E){return R.$9d(E,L=>v.concat(L))}e.$qe=n;function i(E){return R.$_d(E,{data:L=>typeof L=="string"?v.fromString(L):v.wrap(L)},L=>v.concat(L))}e.$re=i;function o(E){return R.$3d(L=>v.concat(L),E)}e.$se=o;function s(E,L){return R.$ae(E,L,j=>v.concat(j))}e.$te=s;function t(E,L){return R.$be(E,L,j=>v.concat(j))}e.$ue=t;function a(E){let L=0,j=0,x=0;const ce=new Uint8Array(Math.floor(E.length/4*3)),X=he=>{switch(j){case 3:ce[x++]=L|he,j=0;break;case 2:ce[x++]=L|he>>>2,L=he<<6,j=3;break;case 1:ce[x++]=L|he>>>4,L=he<<4,j=2;break;default:L=he<<2,j=1}};for(let he=0;he<E.length;he++){const _=E.charCodeAt(he);if(_>=65&&_<=90)X(_-65);else if(_>=97&&_<=122)X(_-97+26);else if(_>=48&&_<=57)X(_-48+52);else if(_===43||_===45)X(62);else if(_===47||_===95)X(63);else{if(_===61)break;throw new SyntaxError(`Unexpected base64 character ${E[he]}`)}}const ie=x;for(;j>0;)X(0);return v.wrap(ce).slice(0,ie)}e.$ve=a;const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:E},L=!0,j=!1){const x=j?w:$;let ce="";const X=E.byteLength%3;let ie=0;for(;ie<E.byteLength-X;ie+=3){const he=E[ie+0],_=E[ie+1],de=E[ie+2];ce+=x[he>>>2],ce+=x[(he<<4|_>>>4)&63],ce+=x[(_<<2|de>>>6)&63],ce+=x[de&63]}if(X===1){const he=E[ie+0];ce+=x[he>>>2],ce+=x[he<<4&63],L&&(ce+="==")}else if(X===2){const he=E[ie+0],_=E[ie+1];ce+=x[he>>>2],ce+=x[(he<<4|_>>>4)&63],ce+=x[_<<2&63],L&&(ce+="=")}return ce}e.$we=k}),define(pe[17],be([1,0,146,76]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yf=e.$xf=e.$wf=e.$vf=e.GraphemeBreakType=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=void 0;function r(ge){return!ge||typeof ge!="string"?!0:ge.trim().length===0}e.$Ce=r;const I=/{(\d+)}/g;function P(ge,...Pe){return Pe.length===0?ge:ge.replace(I,function(Ie,Ne){const ze=parseInt(Ne,10);return isNaN(ze)||ze<0||ze>=Pe.length?Ie:Pe[ze]})}e.$De=P;const C=/{([^}]+)}/g;function v(ge,Pe){return Object.keys(Pe).length===0?ge:ge.replace(C,(Ie,Ne)=>Pe[Ne]??Ie)}e.$Ee=v;function b(ge){return ge.replace(/[<>&]/g,function(Pe){switch(Pe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Pe}})}e.$Fe=b;function A(ge){return ge.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ge=A;function S(ge,Pe){let Ie=0;const Ne=Pe.charCodeAt(0);for(let ze=ge.length-1;ze>=0;ze--)ge.charCodeAt(ze)===Ne&&Ie++;return Ie}e.$He=S;function y(ge,Pe,Ie="\u2026"){return ge.length<=Pe?ge:`${ge.substr(0,Pe)}${Ie}`}e.$Ie=y;function u(ge,Pe=" "){const Ie=g(ge,Pe);return d(Ie,Pe)}e.$Je=u;function g(ge,Pe){if(!ge||!Pe)return ge;const Ie=Pe.length;if(Ie===0||ge.length===0)return ge;let Ne=0;for(;ge.indexOf(Pe,Ne)===Ne;)Ne=Ne+Ie;return ge.substring(Ne)}e.$Ke=g;function d(ge,Pe){if(!ge||!Pe)return ge;const Ie=Pe.length,Ne=ge.length;if(Ie===0||Ne===0)return ge;let ze=Ne,He=-1;for(;He=ge.lastIndexOf(Pe,ze-1),!(He===-1||He+Ie!==ze);){if(He===0)return"";ze=He}return ge.substring(0,ze)}e.$Le=d;function f(ge){return ge.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Me=f;function h(ge){return ge.replace(/\*/g,"")}e.$Ne=h;function p(ge,Pe,Ie={}){if(!ge)throw new Error("Cannot create regex from empty string");Pe||(ge=A(ge)),Ie.wholeWord&&(/\B/.test(ge.charAt(0))||(ge="\\b"+ge),/\B/.test(ge.charAt(ge.length-1))||(ge=ge+"\\b"));let Ne="";return Ie.global&&(Ne+="g"),Ie.matchCase||(Ne+="i"),Ie.multiline&&(Ne+="m"),Ie.unicode&&(Ne+="u"),new RegExp(ge,Ne)}e.$Oe=p;function l(ge){return ge.source==="^"||ge.source==="^$"||ge.source==="$"||ge.source==="^\\s*$"?!1:!!(ge.exec("")&&ge.lastIndex===0)}e.$Pe=l;function m(ge){return ge.split(/\r\n|\r|\n/)}e.$Qe=m;function c(ge){for(let Pe=0,Ie=ge.length;Pe<Ie;Pe++){const Ne=ge.charCodeAt(Pe);if(Ne!==32&&Ne!==9)return Pe}return-1}e.$Re=c;function n(ge,Pe=0,Ie=ge.length){for(let Ne=Pe;Ne<Ie;Ne++){const ze=ge.charCodeAt(Ne);if(ze!==32&&ze!==9)return ge.substring(Pe,Ne)}return ge.substring(Pe,Ie)}e.$Se=n;function i(ge,Pe=ge.length-1){for(let Ie=Pe;Ie>=0;Ie--){const Ne=ge.charCodeAt(Ie);if(Ne!==32&&Ne!==9)return Ie}return-1}e.$Te=i;function o(ge,Pe,Ie){const Ne=[];let ze=0;for(const He of ge.matchAll(Pe)){if(Ne.push(ge.slice(ze,He.index)),He.index===void 0)throw new Error("match.index should be defined");ze=He.index+He[0].length,Ne.push(Ie(He[0],...He.slice(1),He.index,ge,He.groups))}return Ne.push(ge.slice(ze)),Promise.all(Ne).then(He=>He.join(""))}e.$Ue=o;function s(ge,Pe){return ge<Pe?-1:ge>Pe?1:0}e.$Ve=s;function t(ge,Pe,Ie=0,Ne=ge.length,ze=0,He=Pe.length){for(;Ie<Ne&&ze<He;Ie++,ze++){const Je=ge.charCodeAt(Ie),Ge=Pe.charCodeAt(ze);if(Je<Ge)return-1;if(Je>Ge)return 1}const Be=Ne-Ie,Ve=He-ze;return Be<Ve?-1:Be>Ve?1:0}e.$We=t;function a(ge,Pe){return $(ge,Pe,0,ge.length,0,Pe.length)}e.$Xe=a;function $(ge,Pe,Ie=0,Ne=ge.length,ze=0,He=Pe.length){for(;Ie<Ne&&ze<He;Ie++,ze++){let Je=ge.charCodeAt(Ie),Ge=Pe.charCodeAt(ze);if(Je===Ge)continue;if(Je>=128||Ge>=128)return t(ge.toLowerCase(),Pe.toLowerCase(),Ie,Ne,ze,He);k(Je)&&(Je-=32),k(Ge)&&(Ge-=32);const Ye=Je-Ge;if(Ye!==0)return Ye}const Be=Ne-Ie,Ve=He-ze;return Be<Ve?-1:Be>Ve?1:0}e.$Ye=$;function w(ge){return ge>=48&&ge<=57}e.$Ze=w;function k(ge){return ge>=97&&ge<=122}e.$1e=k;function E(ge){return ge>=65&&ge<=90}e.$2e=E;function L(ge,Pe){return ge.length===Pe.length&&$(ge,Pe)===0}e.$3e=L;function j(ge,Pe){const Ie=Pe.length;return Pe.length>ge.length?!1:$(ge,Pe,0,Ie)===0}e.$4e=j;function x(ge,Pe){const Ie=Math.min(ge.length,Pe.length);let Ne;for(Ne=0;Ne<Ie;Ne++)if(ge.charCodeAt(Ne)!==Pe.charCodeAt(Ne))return Ne;return Ie}e.$5e=x;function ce(ge,Pe){const Ie=Math.min(ge.length,Pe.length);let Ne;const ze=ge.length-1,He=Pe.length-1;for(Ne=0;Ne<Ie;Ne++)if(ge.charCodeAt(ze-Ne)!==Pe.charCodeAt(He-Ne))return Ne;return Ie}e.$6e=ce;function X(ge){return 55296<=ge&&ge<=56319}e.$7e=X;function ie(ge){return 56320<=ge&&ge<=57343}e.$8e=ie;function he(ge,Pe){return(ge-55296<<10)+(Pe-56320)+65536}e.$9e=he;function _(ge,Pe,Ie){const Ne=ge.charCodeAt(Ie);if(X(Ne)&&Ie+1<Pe){const ze=ge.charCodeAt(Ie+1);if(ie(ze))return he(Ne,ze)}return Ne}e.$0e=_;function de(ge,Pe){const Ie=ge.charCodeAt(Pe-1);if(ie(Ie)&&Pe>1){const Ne=ge.charCodeAt(Pe-2);if(X(Ne))return he(Ne,Ie)}return Ie}class Z{get offset(){return this.e}constructor(Pe,Ie=0){this.c=Pe,this.d=Pe.length,this.e=Ie}setOffset(Pe){this.e=Pe}prevCodePoint(){const Pe=de(this.c,this.e);return this.e-=Pe>=65536?2:1,Pe}nextCodePoint(){const Pe=_(this.c,this.d,this.e);return this.e+=Pe>=65536?2:1,Pe}eol(){return this.e>=this.d}}e.$$e=Z;class ne{get offset(){return this.c.offset}constructor(Pe,Ie=0){this.c=new Z(Pe,Ie)}nextGraphemeLength(){const Pe=ke.getInstance(),Ie=this.c,Ne=Ie.offset;let ze=Pe.getGraphemeBreakType(Ie.nextCodePoint());for(;!Ie.eol();){const He=Ie.offset,Be=Pe.getGraphemeBreakType(Ie.nextCodePoint());if(Fe(ze,Be)){Ie.setOffset(He);break}ze=Be}return Ie.offset-Ne}prevGraphemeLength(){const Pe=ke.getInstance(),Ie=this.c,Ne=Ie.offset;let ze=Pe.getGraphemeBreakType(Ie.prevCodePoint());for(;Ie.offset>0;){const He=Ie.offset,Be=Pe.getGraphemeBreakType(Ie.prevCodePoint());if(Fe(Be,ze)){Ie.setOffset(He);break}ze=Be}return Ne-Ie.offset}eol(){return this.c.eol()}}e.$_e=ne;function J(ge,Pe){return new ne(ge,Pe).nextGraphemeLength()}e.$af=J;function W(ge,Pe){return new ne(ge,Pe).prevGraphemeLength()}e.$bf=W;function oe(ge,Pe){Pe>0&&ie(ge.charCodeAt(Pe))&&Pe--;const Ie=Pe+J(ge,Pe);return[Ie-W(ge,Ie),Ie]}e.$cf=oe;function le(ge){const Pe=new ne(ge);let Ie=0;for(;!Pe.eol();)Ie++,Pe.nextGraphemeLength();return Ie}e.$df=le;let re;function ee(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function B(ge){return re||(re=ee()),re.test(ge)}e.$ef=B;const K=/^[\t\n\r\x20-\x7E]*$/;function N(ge){return K.test(ge)}e.$ff=N,e.$gf=/[\u2028\u2029]/;function O(ge){return e.$gf.test(ge)}e.$hf=O;function U(ge){return ge>=11904&&ge<=55215||ge>=63744&&ge<=64255||ge>=65281&&ge<=65374}e.$if=U;function T(ge){return ge>=127462&&ge<=127487||ge===8986||ge===8987||ge===9200||ge===9203||ge>=9728&&ge<=10175||ge===11088||ge===11093||ge>=127744&&ge<=128591||ge>=128640&&ge<=128764||ge>=128992&&ge<=129008||ge>=129280&&ge<=129535||ge>=129648&&ge<=129782}e.$jf=T;function q(ge,Pe){if(ge.length<Pe)return ge;const Ie=/\b/g;let Ne=0;for(;Ie.test(ge)&&!(ge.length-Ie.lastIndex<Pe);)Ne=Ie.lastIndex,Ie.lastIndex+=1;return ge.substring(Ne).replace(/^\s/,"")}e.$kf=q;const z=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,te=/\x1b\].*?\x07/g;function H(ge){return ge&&(ge=ge.replace(z,"").replace(te,"")),ge}e.$lf=H,e.$mf=String.fromCharCode(65279);function Y(ge){return!!(ge&&ge.length>0&&ge.charCodeAt(0)===65279)}e.$nf=Y;function V(ge){return Y(ge)?ge.substr(1):ge}e.$of=V;function Q(ge,Pe){if(!ge||!Pe||ge.length<Pe.length)return!1;const Ie=Pe.length,Ne=ge.toLowerCase();let ze=0,He=-1;for(;ze<Ie;){const Be=Ne.indexOf(Pe[ze],He+1);if(Be<0)return!1;He=Be,ze++}return!0}e.$pf=Q;function se(ge,Pe=!1){return ge?(Pe&&(ge=ge.replace(/\\./g,"")),ge.toLowerCase()!==ge):!1}e.$qf=se;function me(ge){return ge.charAt(0).toUpperCase()+ge.slice(1)}e.$rf=me;function Ee(ge,Pe=1){if(Pe===0)return"";let Ie=-1;do Ie=ge.indexOf(`
`,Ie+1),Pe--;while(Pe>0&&Ie>=0);return Ie===-1?ge:(ge[Ie-1]==="\r"&&Ie--,ge.substr(0,Ie))}e.$sf=Ee;function Ce(ge){return ge=ge%(2*26),ge<26?String.fromCharCode(97+ge):String.fromCharCode(65+ge-26)}e.$tf=Ce;function Le(ge){return ke.getInstance().getGraphemeBreakType(ge)}e.$uf=Le;function Fe(ge,Pe){return ge===0?Pe!==5&&Pe!==7:ge===2&&Pe===3?!1:ge===4||ge===2||ge===3||Pe===4||Pe===2||Pe===3?!0:!(ge===8&&(Pe===8||Pe===9||Pe===11||Pe===12)||(ge===11||ge===9)&&(Pe===9||Pe===10)||(ge===12||ge===10)&&Pe===10||Pe===5||Pe===13||Pe===7||ge===1||ge===13&&Pe===14||ge===6&&Pe===6)}var $e;(function(ge){ge[ge.Other=0]="Other",ge[ge.Prepend=1]="Prepend",ge[ge.CR=2]="CR",ge[ge.LF=3]="LF",ge[ge.Control=4]="Control",ge[ge.Extend=5]="Extend",ge[ge.Regional_Indicator=6]="Regional_Indicator",ge[ge.SpacingMark=7]="SpacingMark",ge[ge.L=8]="L",ge[ge.V=9]="V",ge[ge.T=10]="T",ge[ge.LV=11]="LV",ge[ge.LVT=12]="LVT",ge[ge.ZWJ=13]="ZWJ",ge[ge.Extended_Pictographic=14]="Extended_Pictographic"})($e||(e.GraphemeBreakType=$e={}));class ke{static{this.c=null}static getInstance(){return ke.c||(ke.c=new ke),ke.c}constructor(){this.d=ye()}getGraphemeBreakType(Pe){if(Pe<32)return Pe===10?3:Pe===13?2:4;if(Pe<127)return 0;const Ie=this.d,Ne=Ie.length/3;let ze=1;for(;ze<=Ne;)if(Pe<Ie[3*ze])ze=2*ze;else if(Pe>Ie[3*ze+1])ze=2*ze+1;else return Ie[3*ze+2];return 0}}function ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Me(ge,Pe){if(ge===0)return 0;const Ie=Ue(ge,Pe);if(Ie!==void 0)return Ie;const Ne=new Z(Pe,ge);return Ne.prevCodePoint(),Ne.offset}e.$vf=Me;function Ue(ge,Pe){const Ie=new Z(Pe,ge);let Ne=Ie.prevCodePoint();for(;Ze(Ne)||Ne===65039||Ne===8419;){if(Ie.offset===0)return;Ne=Ie.prevCodePoint()}if(!T(Ne))return;let ze=Ie.offset;return ze>0&&Ie.prevCodePoint()===8205&&(ze=Ie.offset),ze}function Ze(ge){return 127995<=ge&&ge<=127999}var We;(function(ge){ge[ge.zwj=8205]="zwj",ge[ge.emojiVariantSelector=65039]="emojiVariantSelector",ge[ge.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),e.$wf="\xA0";class Xe{static{this.c=new R.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$ye(Pe=>{function Ie(Ye){const it=new Map;for(let _e=0;_e<Ye.length;_e+=2)it.set(Ye[_e],Ye[_e+1]);return it}function Ne(Ye,it){const _e=new Map(Ye);for(const[st,ot]of it)_e.set(st,ot);return _e}function ze(Ye,it){if(!Ye)return it;const _e=new Map;for(const[st,ot]of Ye)it.has(st)&&_e.set(st,ot);return _e}const He=this.c.value;let Be=Pe.filter(Ye=>!Ye.startsWith("_")&&Ye in He);Be.length===0&&(Be=["_default"]);let Ve;for(const Ye of Be){const it=Ie(He[Ye]);Ve=ze(Ve,it)}const Je=Ie(He._common),Ge=Ne(Je,Ve);return new Xe(Ge)})}static getInstance(Pe){return Xe.d.get(Array.from(Pe))}static{this.e=new R.$V(()=>Object.keys(Xe.c.value).filter(Pe=>!Pe.startsWith("_")))}static getLocales(){return Xe.e.value}constructor(Pe){this.f=Pe}isAmbiguous(Pe){return this.f.has(Pe)}getPrimaryConfusable(Pe){return this.f.get(Pe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$xf=Xe;class Qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Qe.c())),this.d}static isInvisibleCharacter(Pe){return Qe.e().has(Pe)}static get codePoints(){return Qe.e()}}e.$yf=Qe}),define(pe[147],be([1,0,26,17]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.FuzzyScore=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.or=void 0;function r(...V){return function(Q,se){for(let me=0,Ee=V.length;me<Ee;me++){const Ce=V[me](Q,se);if(Ce)return Ce}return null}}e.or=r,e.$Dj=I.bind(void 0,!1),e.$Ej=I.bind(void 0,!0);function I(V,Q,se){if(!se||se.length<Q.length)return null;let me;return V?me=R.$4e(se,Q):me=se.indexOf(Q)===0,me?Q.length>0?[{start:0,end:Q.length}]:[]:null}function P(V,Q){const se=Q.toLowerCase().indexOf(V.toLowerCase());return se===-1?null:[{start:se,end:se+V.length}]}e.$Fj=P;function C(V,Q){return v(V.toLowerCase(),Q.toLowerCase(),0,0)}e.$Gj=C;function v(V,Q,se,me){if(se===V.length)return[];if(me===Q.length)return null;if(V[se]===Q[me]){let Ee=null;return(Ee=v(V,Q,se+1,me+1))?h({start:me,end:me+1},Ee):null}return v(V,Q,se,me+1)}function b(V){return 97<=V&&V<=122}function A(V){return 65<=V&&V<=90}e.$Hj=A;function S(V){return 48<=V&&V<=57}function y(V){return V===32||V===9||V===10||V===13}const u=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(V=>u.add(V.charCodeAt(0)));function g(V){return y(V)||u.has(V)}function d(V,Q){return V===Q||g(V)&&g(Q)}function f(V){return b(V)||A(V)||S(V)}function h(V,Q){return Q.length===0?Q=[V]:V.end===Q[0].start?Q[0].start=V.start:Q.unshift(V),Q}function p(V,Q){for(let se=Q;se<V.length;se++){const me=V.charCodeAt(se);if(A(me)||S(me)||se>0&&!f(V.charCodeAt(se-1)))return se}return V.length}function l(V,Q,se,me){if(se===V.length)return[];if(me===Q.length)return null;if(V[se]!==Q[me].toLowerCase())return null;{let Ee=null,Ce=me+1;for(Ee=l(V,Q,se+1,me+1);!Ee&&(Ce=p(Q,Ce))<Q.length;)Ee=l(V,Q,se+1,Ce),Ce++;return Ee===null?null:h({start:me,end:me+1},Ee)}}function m(V){let Q=0,se=0,me=0,Ee=0,Ce=0;for(let ye=0;ye<V.length;ye++)Ce=V.charCodeAt(ye),A(Ce)&&Q++,b(Ce)&&se++,f(Ce)&&me++,S(Ce)&&Ee++;const Le=Q/V.length,Fe=se/V.length,$e=me/V.length,ke=Ee/V.length;return{upperPercent:Le,lowerPercent:Fe,alphaPercent:$e,numericPercent:ke}}function c(V){const{upperPercent:Q,lowerPercent:se}=V;return se===0&&Q>.6}function n(V){const{upperPercent:Q,lowerPercent:se,alphaPercent:me,numericPercent:Ee}=V;return se>.2&&Q<.8&&me>.6&&Ee<.2}function i(V){let Q=0,se=0,me=0,Ee=0;for(let Ce=0;Ce<V.length;Ce++)me=V.charCodeAt(Ce),A(me)&&Q++,b(me)&&se++,y(me)&&Ee++;return(Q===0||se===0)&&Ee===0?V.length<=30:Q<=5}function o(V,Q){if(!Q||(Q=Q.trim(),Q.length===0)||!i(V)||Q.length>60)return null;const se=m(Q);if(!n(se)){if(!c(se))return null;Q=Q.toLowerCase()}let me=null,Ee=0;for(V=V.toLowerCase();Ee<Q.length&&(me=l(V,Q,0,Ee))===null;)Ee=p(Q,Ee+1);return me}e.$Ij=o;function s(V,Q,se=!1){if(!Q||Q.length===0)return null;let me=null,Ee=0;for(V=V.toLowerCase(),Q=Q.toLowerCase();Ee<Q.length&&(me=t(V,Q,0,Ee,se))===null;)Ee=a(Q,Ee+1);return me}e.$Jj=s;function t(V,Q,se,me,Ee){if(se===V.length)return[];if(me===Q.length)return null;if(d(V.charCodeAt(se),Q.charCodeAt(me))){let Ce=null,Le=me+1;if(Ce=t(V,Q,se+1,me+1,Ee),!Ee)for(;!Ce&&(Le=a(Q,Le))<Q.length;)Ce=t(V,Q,se+1,Le,Ee),Le++;return Ce?V.charCodeAt(se)!==Q.charCodeAt(me)?Ce:h({start:me,end:me+1},Ce):null}else return null}function a(V,Q){for(let se=Q;se<V.length;se++)if(g(V.charCodeAt(se))||se>0&&g(V.charCodeAt(se-1)))return se;return V.length}const $=r(e.$Ej,o,P),w=r(e.$Ej,o,C),k=new D.$Dc(1e4);function E(V,Q,se=!1){if(typeof V!="string"||typeof Q!="string")return null;let me=k.get(V);me||(me=new RegExp(R.$Me(V),"i"),k.set(V,me));const Ee=me.exec(Q);return Ee?[{start:Ee.index,end:Ee.index+Ee[0].length}]:se?w(V,Q):$(V,Q)}e.$Kj=E;function L(V,Q){const se=U(V,V.toLowerCase(),0,Q,Q.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return se?x(se):null}e.$Lj=L;function j(V,Q,se,me,Ee,Ce){const Le=Math.min(13,V.length);for(;se<Le;se++){const Fe=U(V,Q,se,me,Ee,Ce,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Fe)return Fe}return[0,Ce]}e.$Mj=j;function x(V){if(typeof V>"u")return[];const Q=[],se=V[1];for(let me=V.length-1;me>1;me--){const Ee=V[me]+se,Ce=Q[Q.length-1];Ce&&Ce.end===Ee?Ce.end=Ee+1:Q.push({start:Ee,end:Ee+1})}return Q}e.$Nj=x;const ce=128;function X(){const V=[],Q=[];for(let se=0;se<=ce;se++)Q[se]=0;for(let se=0;se<=ce;se++)V.push(Q.slice(0));return V}function ie(V){const Q=[];for(let se=0;se<=V;se++)Q[se]=0;return Q}const he=ie(2*ce),_=ie(2*ce),de=X(),Z=X(),ne=X(),J=!1;function W(V,Q,se,me,Ee){function Ce(Fe,$e,ke=" "){for(;Fe.length<$e;)Fe=ke+Fe;return Fe}let Le=` |   |${me.split("").map(Fe=>Ce(Fe,3)).join("|")}
`;for(let Fe=0;Fe<=se;Fe++)Fe===0?Le+=" |":Le+=`${Q[Fe-1]}|`,Le+=V[Fe].slice(0,Ee+1).map($e=>Ce($e.toString(),3)).join("|")+`
`;return Le}function oe(V,Q,se,me){V=V.substr(Q),se=se.substr(me),console.log(W(Z,V,V.length,se,se.length)),console.log(W(ne,V,V.length,se,se.length)),console.log(W(de,V,V.length,se,se.length))}function le(V,Q){if(Q<0||Q>=V.length)return!1;const se=V.codePointAt(Q);switch(se){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.$jf(se)}}function re(V,Q){if(Q<0||Q>=V.length)return!1;switch(V.charCodeAt(Q)){case 32:case 9:return!0;default:return!1}}function ee(V,Q,se){return Q[V]!==se[V]}function B(V,Q,se,me,Ee,Ce,Le=!1){for(;Q<se&&Ee<Ce;)V[Q]===me[Ee]&&(Le&&(he[Q]=Ee),Q+=1),Ee+=1;return Q===se}e.$Oj=B;var K;(function(V){V[V.Diag=1]="Diag",V[V.Left=2]="Left",V[V.LeftLeft=3]="LeftLeft"})(K||(K={}));var N;(function(V){V.Default=[-100,0];function Q(se){return!se||se.length===2&&se[0]===-100&&se[1]===0}V.isDefault=Q})(N||(e.FuzzyScore=N={}));class O{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Q,se){this.firstMatchCanBeWeak=Q,this.boostFullMatch=se}}e.$Pj=O;function U(V,Q,se,me,Ee,Ce,Le=O.default){const Fe=V.length>ce?ce:V.length,$e=me.length>ce?ce:me.length;if(se>=Fe||Ce>=$e||Fe-se>$e-Ce||!B(Q,se,Fe,Ee,Ce,$e,!0))return;T(Fe,$e,se,Ce,Q,Ee);let ke=1,ye=1,Me=se,Ue=Ce;const Ze=[!1];for(ke=1,Me=se;Me<Fe;ke++,Me++){const Pe=he[Me],Ie=_[Me],Ne=Me+1<Fe?_[Me+1]:$e;for(ye=Pe-Ce+1,Ue=Pe;Ue<Ne;ye++,Ue++){let ze=Number.MIN_SAFE_INTEGER,He=!1;Ue<=Ie&&(ze=q(V,Q,Me,se,me,Ee,Ue,$e,Ce,de[ke-1][ye-1]===0,Ze));let Be=0;ze!==Number.MAX_SAFE_INTEGER&&(He=!0,Be=ze+Z[ke-1][ye-1]);const Ve=Ue>Pe,Je=Ve?Z[ke][ye-1]+(de[ke][ye-1]>0?-5:0):0,Ge=Ue>Pe+1&&de[ke][ye-1]>0,Ye=Ge?Z[ke][ye-2]+(de[ke][ye-2]>0?-5:0):0;if(Ge&&(!Ve||Ye>=Je)&&(!He||Ye>=Be))Z[ke][ye]=Ye,ne[ke][ye]=3,de[ke][ye]=0;else if(Ve&&(!He||Je>=Be))Z[ke][ye]=Je,ne[ke][ye]=2,de[ke][ye]=0;else if(He)Z[ke][ye]=Be,ne[ke][ye]=1,de[ke][ye]=de[ke-1][ye-1]+1;else throw new Error("not possible")}}if(J&&oe(V,se,me,Ce),!Ze[0]&&!Le.firstMatchCanBeWeak)return;ke--,ye--;const We=[Z[ke][ye],Ce];let Xe=0,Qe=0;for(;ke>=1;){let Pe=ye;do{const Ie=ne[ke][Pe];if(Ie===3)Pe=Pe-2;else if(Ie===2)Pe=Pe-1;else break}while(Pe>=1);Xe>1&&Q[se+ke-1]===Ee[Ce+ye-1]&&!ee(Pe+Ce-1,me,Ee)&&Xe+1>de[ke][Pe]&&(Pe=ye),Pe===ye?Xe++:Xe=1,Qe||(Qe=Pe),ke--,ye=Pe-1,We.push(ye)}$e===Fe&&Le.boostFullMatch&&(We[0]+=2);const ge=Qe-Fe;return We[0]-=ge,We}e.$Qj=U;function T(V,Q,se,me,Ee,Ce){let Le=V-1,Fe=Q-1;for(;Le>=se&&Fe>=me;)Ee[Le]===Ce[Fe]&&(_[Le]=Fe,Le--),Fe--}function q(V,Q,se,me,Ee,Ce,Le,Fe,$e,ke,ye){if(Q[se]!==Ce[Le])return Number.MIN_SAFE_INTEGER;let Me=1,Ue=!1;return Le===se-me?Me=V[se]===Ee[Le]?7:5:ee(Le,Ee,Ce)&&(Le===0||!ee(Le-1,Ee,Ce))?(Me=V[se]===Ee[Le]?7:5,Ue=!0):le(Ce,Le)&&(Le===0||!le(Ce,Le-1))?Me=5:(le(Ce,Le-1)||re(Ce,Le-1))&&(Me=5,Ue=!0),Me>1&&se===me&&(ye[0]=!0),Ue||(Ue=ee(Le,Ee,Ce)||le(Ce,Le-1)||re(Ce,Le-1)),se===me?Le>$e&&(Me-=Ue?3:5):ke?Me+=Ue?2:0:Me+=Ue?0:1,Le+1===Fe&&(Me-=Ue?3:5),Me}function z(V,Q,se,me,Ee,Ce,Le){return H(V,Q,se,me,Ee,Ce,!0,Le)}e.$Rj=z;function te(V,Q,se,me,Ee,Ce,Le){return H(V,Q,se,me,Ee,Ce,!1,Le)}e.$Sj=te;function H(V,Q,se,me,Ee,Ce,Le,Fe){let $e=U(V,Q,se,me,Ee,Ce,Fe);if($e&&!Le)return $e;if(V.length>=3){const ke=Math.min(7,V.length-1);for(let ye=se+1;ye<ke;ye++){const Me=Y(V,ye);if(Me){const Ue=U(Me,Me.toLowerCase(),se,me,Ee,Ce,Fe);Ue&&(Ue[0]-=3,(!$e||Ue[0]>$e[0])&&($e=Ue))}}}return $e}function Y(V,Q){if(Q+1>=V.length)return;const se=V[Q],me=V[Q+1];if(se!==me)return V.slice(0,Q)+me+se+V.slice(Q+2)}}),define(pe[60],be([1,0,17]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;function R(h){return r(h,0)}e.$Ei=R;function r(h,p){switch(typeof h){case"object":return h===null?I(349,p):Array.isArray(h)?v(h,p):b(h,p);case"string":return C(h,p);case"boolean":return P(h,p);case"number":return I(h,p);case"undefined":return I(937,p);default:return I(617,p)}}e.$Fi=r;function I(h,p){return(p<<5)-p+h|0}e.$Gi=I;function P(h,p){return I(h?433:863,p)}function C(h,p){p=I(149417,p);for(let l=0,m=h.length;l<m;l++)p=I(h.charCodeAt(l),p);return p}e.$Hi=C;function v(h,p){return p=I(104579,p),h.reduce((l,m)=>r(m,l),p)}function b(h,p){return p=I(181387,p),Object.keys(h).sort().reduce((l,m)=>(l=C(m,l),r(h[m],l)),p)}class A{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=r(p,this.g),this.g}}e.$Ii=A;var S;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function y(h,p,l=32){const m=l-p,c=~((1<<m)-1);return(h<<p|(c&h)>>>m)>>>0}function u(h,p=0,l=h.byteLength,m=0){for(let c=0;c<l;c++)h[p+c]=m}function g(h,p,l="0"){for(;h.length<p;)h=l+h;return h}function d(h,p=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(l=>l.toString(16).padStart(2,"0")).join(""):g((h>>>0).toString(16),p/4)}e.$Ji=d;class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const l=p.length;if(l===0)return;const m=this.p;let c=this.r,n=this.u,i,o;for(n!==0?(i=n,o=-1,n=0):(i=p.charCodeAt(0),o=0);;){let s=i;if(D.$7e(i))if(o+1<l){const t=p.charCodeAt(o+1);D.$8e(t)?(o++,s=D.$9e(i,t)):s=65533}else{n=i;break}else D.$8e(i)&&(s=65533);if(c=this.w(m,c,s),o++,o<l)i=p.charCodeAt(o);else break}this.r=c,this.u=n}w(p,l,m){return m<128?p[l++]=m:m<2048?(p[l++]=192|(m&1984)>>>6,p[l++]=128|(m&63)>>>0):m<65536?(p[l++]=224|(m&61440)>>>12,p[l++]=128|(m&4032)>>>6,p[l++]=128|(m&63)>>>0):(p[l++]=240|(m&1835008)>>>18,p[l++]=128|(m&258048)>>>12,p[l++]=128|(m&4032)>>>6,p[l++]=128|(m&63)>>>0),l>=64&&(this.y(),l-=64,this.t+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),l}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),d(this.h)+d(this.l)+d(this.m)+d(this.n)+d(this.o)}x(){this.p[this.r++]=128,u(this.p,this.r),this.r>56&&(this.y(),u(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=f.g,l=this.q;for(let $=0;$<64;$+=4)p.setUint32($,l.getUint32($,!1),!1);for(let $=64;$<320;$+=4)p.setUint32($,y(p.getUint32($-12,!1)^p.getUint32($-32,!1)^p.getUint32($-56,!1)^p.getUint32($-64,!1),1),!1);let m=this.h,c=this.l,n=this.m,i=this.n,o=this.o,s,t,a;for(let $=0;$<80;$++)$<20?(s=c&n|~c&i,t=1518500249):$<40?(s=c^n^i,t=1859775393):$<60?(s=c&n|c&i|n&i,t=2400959708):(s=c^n^i,t=3395469782),a=y(m,5)+s+o+t+p.getUint32($*4,!1)&4294967295,o=i,i=n,n=y(c,30),c=m,m=a;this.h=this.h+m&4294967295,this.l=this.l+c&4294967295,this.m=this.m+n&4294967295,this.n=this.n+i&4294967295,this.o=this.o+o&4294967295}}e.$Ki=f}),define(pe[61],be([1,0,17]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(r){r[r.Ignore=0]="Ignore",r[r.Info=1]="Info",r[r.Warning=2]="Warning",r[r.Error=3]="Error"})(R||(R={})),function(r){const I="error",P="warning",C="warn",v="info",b="ignore";function A(y){return y?D.$3e(I,y)?r.Error:D.$3e(P,y)||D.$3e(C,y)?r.Warning:D.$3e(v,y)?r.Info:r.Ignore:r.Ignore}r.fromValue=A;function S(y){switch(y){case r.Error:return I;case r.Warning:return P;case r.Info:return v;default:return b}}r.toString=S}(R||(R={})),e.default=R}),define(pe[148],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ld=void 0,e.$Ld=Symbol("MicrotaskDelay")}),define(pe[62],be([1,0,18,17]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=void 0;class r{constructor(){this.b="",this.c=0}reset(u){return this.b=u,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(u){const g=u.charCodeAt(0),d=this.b.charCodeAt(this.c);return g-d}value(){return this.b[this.c]}}e.$Sh=r;class I{constructor(u=!0){this.e=u}reset(u){return this.b=u,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let u=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(u)this.c++;else break;else u=!1;return this}cmp(u){return this.e?(0,R.$We)(u,this.b,0,u.length,this.c,this.d):(0,R.$Ye)(u,this.b,0,u.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Th=I;class P{constructor(u=!0,g=!0){this.f=u,this.g=g}reset(u){this.d=0,this.e=0,this.b=u,this.c=u.length;for(let g=u.length-1;g>=0;g--,this.c--){const d=this.b.charCodeAt(g);if(!(d===47||this.f&&d===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let u=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(u)this.d++;else break;else u=!1}return this}cmp(u){return this.g?(0,R.$We)(u,this.b,0,u.length,this.d,this.e):(0,R.$Ye)(u,this.b,0,u.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Uh=P;var C;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(C||(C={}));class v{constructor(u,g){this.f=u,this.g=g,this.d=[],this.e=0}reset(u){return this.c=u,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new P(!1,!this.f(u)),this.b.reset(u.path),this.b.value()&&this.d.push(3)),this.g(u)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(u){if(this.d[this.e]===1)return(0,R.$Xe)(u,this.c.scheme);if(this.d[this.e]===2)return(0,R.$Xe)(u,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(u);if(this.d[this.e]===4)return(0,R.$Ve)(u,this.c.query);if(this.d[this.e]===5)return(0,R.$Ve)(u,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Vh=v;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(A||(A={}));class S{static forUris(u=()=>!1,g=()=>!1){return new S(new v(u,g))}static forPaths(u=!1){return new S(new P(void 0,!u))}static forStrings(){return new S(new r)}static forConfigKeys(){return new S(new I)}constructor(u){this.b=u}clear(){this.c=void 0}fill(u,g){if(g){const d=g.slice(0);(0,D.$Xb)(d);for(const f of d)this.set(f,u)}else{const d=u.slice(0);(0,D.$Xb)(d);for(const f of d)this.set(f[0],f[1])}}set(u,g){const d=this.b.reset(u);let f;this.c||(this.c=new b,this.c.segment=d.value());const h=[];for(f=this.c;;){const l=d.cmp(f.segment);if(l>0)f.left||(f.left=new b,f.left.segment=d.value()),h.push([-1,f]),f=f.left;else if(l<0)f.right||(f.right=new b,f.right.segment=d.value()),h.push([1,f]),f=f.right;else if(d.hasNext())d.next(),f.mid||(f.mid=new b,f.mid.segment=d.value()),h.push([0,f]),f=f.mid;else break}const p=f.value;f.value=g,f.key=u;for(let l=h.length-1;l>=0;l--){const m=h[l][1];m.updateHeight();const c=m.balanceFactor();if(c<-1||c>1){const n=h[l][0],i=h[l+1][0];if(n===1&&i===1)h[l][1]=m.rotateLeft();else if(n===-1&&i===-1)h[l][1]=m.rotateRight();else if(n===1&&i===-1)m.right=h[l+1][1]=h[l+1][1].rotateRight(),h[l][1]=m.rotateLeft();else if(n===-1&&i===1)m.left=h[l+1][1]=h[l+1][1].rotateLeft(),h[l][1]=m.rotateRight();else throw new Error;if(l>0)switch(h[l-1][0]){case-1:h[l-1][1].left=h[l][1];break;case 1:h[l-1][1].right=h[l][1];break;case 0:h[l-1][1].mid=h[l][1];break}else this.c=h[0][1]}}return p}get(u){return this.d(u)?.value}d(u){const g=this.b.reset(u);let d=this.c;for(;d;){const f=g.cmp(d.segment);if(f>0)d=d.left;else if(f<0)d=d.right;else if(g.hasNext())g.next(),d=d.mid;else break}return d}has(u){const g=this.d(u);return!(g?.value===void 0&&g?.mid===void 0)}delete(u){return this.e(u,!1)}deleteSuperstr(u){return this.e(u,!0)}e(u,g){const d=this.b.reset(u),f=[];let h=this.c;for(;h;){const p=d.cmp(h.segment);if(p>0)f.push([-1,h]),h=h.left;else if(p<0)f.push([1,h]),h=h.right;else if(d.hasNext())d.next(),f.push([0,h]),h=h.mid;else break}if(h){if(g?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const p=this.f(h.right);if(p.key){const{key:l,value:m,segment:c}=p;this.e(p.key,!1),h.key=l,h.value=m,h.segment=c}}else{const p=h.left??h.right;if(f.length>0){const[l,m]=f[f.length-1];switch(l){case-1:m.left=p;break;case 0:m.mid=p;break;case 1:m.right=p;break}}else this.c=p}for(let p=f.length-1;p>=0;p--){const l=f[p][1];l.updateHeight();const m=l.balanceFactor();if(m>1?(l.right.balanceFactor()>=0||(l.right=l.right.rotateRight()),f[p][1]=l.rotateLeft()):m<-1&&(l.left.balanceFactor()<=0||(l.left=l.left.rotateLeft()),f[p][1]=l.rotateRight()),p>0)switch(f[p-1][0]){case-1:f[p-1][1].left=f[p][1];break;case 1:f[p-1][1].right=f[p][1];break;case 0:f[p-1][1].mid=f[p][1];break}else this.c=f[0][1]}}}f(u){for(;u.left;)u=u.left;return u}findSubstr(u){const g=this.b.reset(u);let d=this.c,f;for(;d;){const h=g.cmp(d.segment);if(h>0)d=d.left;else if(h<0)d=d.right;else if(g.hasNext())g.next(),f=d.value||f,d=d.mid;else break}return d&&d.value||f}findSuperstr(u){return this.g(u,!1)}g(u,g){const d=this.b.reset(u);let f=this.c;for(;f;){const h=d.cmp(f.segment);if(h>0)f=f.left;else if(h<0)f=f.right;else if(d.hasNext())d.next(),f=f.mid;else return f.mid?this.h(f.mid):g?f.value:void 0}}hasElementOrSubtree(u){return this.g(u,!0)!==void 0}forEach(u){for(const[g,d]of this)u(d,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(u){const g=[];return this.j(u,g),g[Symbol.iterator]()}j(u,g){u&&(u.left&&this.j(u.left,g),u.value&&g.push([u.key,u.value]),u.mid&&this.j(u.mid,g),u.right&&this.j(u.right,g))}_isBalanced(){const u=g=>{if(!g)return!0;const d=g.balanceFactor();return d<-1||d>1?!1:u(g.left)&&u(g.right)};return u(this.c)}}e.$Wh=S}),define(pe[10],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=void 0;function D(c){return typeof c=="string"}e.$zf=D;function R(c){return Array.isArray(c)&&c.every(n=>D(n))}e.$Af=R;function r(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.$Bf=r;function I(c){const n=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof n}e.$Cf=I;function P(c){return typeof c=="number"&&!isNaN(c)}e.$Df=P;function C(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.$Ef=C;function v(c){return c===!0||c===!1}e.$Ff=v;function b(c){return typeof c>"u"}e.$Gf=b;function A(c){return!S(c)}e.$Hf=A;function S(c){return b(c)||c===null}e.$If=S;function y(c,n){if(!c)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.$Jf=y;function u(c){if(S(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.$Kf=u;function g(...c){const n=[];for(let i=0;i<c.length;i++){const o=c[i];if(S(o))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);n.push(o)}return n}e.$Lf=g;const d=Object.prototype.hasOwnProperty;function f(c){if(!r(c))return!1;for(const n in c)if(d.call(c,n))return!1;return!0}e.$Mf=f;function h(c){return typeof c=="function"}e.$Nf=h;function p(...c){return c.length>0&&c.every(h)}e.$Of=p;function l(c,n){const i=Math.min(c.length,n.length);for(let o=0;o<i;o++)m(c[o],n[o])}e.$Pf=l;function m(c,n){if(D(n)){if(typeof c!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(h(n)){try{if(c instanceof n)return}catch{}if(!S(c)&&c.constructor===n||n.length===1&&n.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Qf=m}),define(pe[49],be([1,0,10]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=e.$Tj=void 0;const R=Object.create(null);function r(C,v){if((0,D.$zf)(v)){const b=R[v];if(b===void 0)throw new Error(`${C} references an unknown codicon: ${v}`);v=b}return R[C]=v,{id:C}}function I(){return R}e.$Tj=I;function P(){return Object.values(e.$Vj)}e.$Uj=P,e.$Vj={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),thumbsDownFilled:r("thumbsdown-filled",60435),thumbsUpFilled:r("thumbsup-filled",60436),coffee:r("coffee",60437),snake:r("snake",60438),game:r("game",60439),vr:r("vr",60440),chip:r("chip",60441),piano:r("piano",60442),music:r("music",60443),micFilled:r("mic-filled",60444),gitFetch:r("git-fetch",60445),copilot:r("copilot",60446),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),define(pe[22],be([1,0,10]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=void 0;function R(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const c=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([n,i])=>{c[n]=i&&typeof i=="object"?R(i):i}),c}e.$8m=R;function r(m){if(!m||typeof m!="object")return m;const c=[m];for(;c.length>0;){const n=c.shift();Object.freeze(n);for(const i in n)if(I.call(n,i)){const o=n[i];typeof o=="object"&&!Object.isFrozen(o)&&!(0,D.$Cf)(o)&&c.push(o)}}return m}e.$9m=r;const I=Object.prototype.hasOwnProperty;function P(m,c){return C(m,c,new Set)}e.$0m=P;function C(m,c,n){if((0,D.$If)(m))return m;const i=c(m);if(typeof i<"u")return i;if(Array.isArray(m)){const o=[];for(const s of m)o.push(C(s,c,n));return o}if((0,D.$Bf)(m)){if(n.has(m))throw new Error("Cannot clone recursive data-structure");n.add(m);const o={};for(const s in m)I.call(m,s)&&(o[s]=C(m[s],c,n));return n.delete(m),o}return m}function v(m,c,n=!0){return(0,D.$Bf)(m)?((0,D.$Bf)(c)&&Object.keys(c).forEach(i=>{i in m?n&&((0,D.$Bf)(m[i])&&(0,D.$Bf)(c[i])?v(m[i],c[i],n):m[i]=c[i]):m[i]=c[i]}),m):c}e.$$m=v;function b(m,c){if(m===c)return!0;if(m==null||c===null||c===void 0||typeof m!=typeof c||typeof m!="object"||Array.isArray(m)!==Array.isArray(c))return!1;let n,i;if(Array.isArray(m)){if(m.length!==c.length)return!1;for(n=0;n<m.length;n++)if(!b(m[n],c[n]))return!1}else{const o=[];for(i in m)o.push(i);o.sort();const s=[];for(i in c)s.push(i);if(s.sort(),!b(o,s))return!1;for(n=0;n<o.length;n++)if(!b(m[o[n]],c[o[n]]))return!1}return!0}e.$_m=b;function A(m){const c=new Set;return JSON.stringify(m,(n,i)=>{if((0,D.$Bf)(i)||Array.isArray(i)){if(c.has(i))return"[Circular]";c.add(i)}return i})}e.$an=A;function S(m,c){const n=Object.create(null);return!m||!c||Object.keys(c).forEach(o=>{const s=m[o],t=c[o];b(s,t)||(n[o]=t)}),n}e.$bn=S;function y(m,c){const n=c.toLowerCase(),i=Object.keys(m).find(o=>o.toLowerCase()===n);return i?m[i]:m[c]}e.$cn=y;function u(m,c){const n=Object.create(null);for(const[i,o]of Object.entries(m))c(i,o)&&(n[i]=o);return n}e.$dn=u;function g(m){let c=[];for(;Object.prototype!==m;)c=c.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return c}e.$en=g;function d(m){const c=[];for(const n of g(m))typeof m[n]=="function"&&c.push(n);return c}e.$fn=d;function f(m,c){const n=o=>function(){const s=Array.prototype.slice.call(arguments,0);return c(o,s)},i={};for(const o of m)i[o]=n(o);return i}e.$gn=f;function h(m,c,n){typeof c=="string"&&m[c]!==void 0&&typeof m[c]!="boolean"&&(m[c]=n)}e.$hn=h;function p(m,c,n){typeof c=="string"&&m[c]!==void 0&&typeof m[c]!="number"&&(m[c]=n)}e.$in=p;function l(m,c,n,i){if(typeof c!="string")return;const o=m[c];o!==void 0&&(typeof o!="string"||!n.includes(o))&&(m[c]=i)}e.$jn=l}),define(pe[98],be([1,0,49]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Wj=e.ThemeColor=void 0;var R;(function(P){function C(v){return v&&typeof v=="object"&&typeof v.id=="string"}P.isThemeColor=C})(R||(e.ThemeColor=R={}));function r(P){return{id:P}}e.$Wj=r;var I;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const C=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function v(p){const l=C.exec(p.id);if(!l)return v(D.$Vj.error);const[,m,c]=l,n=["codicon","codicon-"+m];return c&&n.push("codicon-modifier-"+c.substring(1)),n}P.asClassNameArray=v;function b(p){return v(p).join(" ")}P.asClassName=b;function A(p){return"."+v(p).join(".")}P.asCSSSelector=A;function S(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color>"u"||R.isThemeColor(p.color))}P.isThemeIcon=S;const y=new RegExp(`^\\$\\((${P.iconNameExpression}(?:${P.iconModifierExpression})?)\\)$`);function u(p){const l=y.exec(p);if(!l)return;const[,m]=l;return{id:m}}P.fromString=u;function g(p){return{id:p}}P.fromId=g;function d(p,l){let m=p.id;const c=m.lastIndexOf("~");return c!==-1&&(m=m.substring(0,c)),l&&(m=`${m}~${l}`),{id:m}}P.modify=d;function f(p){const l=p.id.lastIndexOf("~");if(l!==-1)return p.id.substring(l+1)}P.getModifier=f;function h(p,l){return p.id===l.id&&p.color?.id===l.color?.id}P.isEqual=h})(I||(e.ThemeIcon=I={}))}),define(pe[149],be([1,0,147,17,98]),function(ue,e,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=void 0;const I="$(",P=new RegExp(`\\$\\(${r.ThemeIcon.iconNameExpression}(?:${r.ThemeIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(`(\\\\)?${P.source}`,"g");function v(h){return h.replace(C,(p,l)=>l?p:`\\${p}`)}e.$Xj=v;const b=new RegExp(`\\\\${P.source}`,"g");function A(h){return h.replace(b,p=>`\\${p}`)}e.$Yj=A;const S=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function y(h){return h.indexOf(I)===-1?h:h.replace(S,(p,l,m,c)=>m?p:l||c||"")}e.$Zj=y;function u(h){return h?h.replace(/\$\((.*?)\)/g,(p,l)=>` ${l} `).trim():""}e.$1j=u;const g=new RegExp(`\\$\\(${r.ThemeIcon.iconNameCharacter}+\\)`,"g");function d(h){g.lastIndex=0;let p="";const l=[];let m=0;for(;;){const c=g.lastIndex,n=g.exec(h),i=h.substring(c,n?.index);if(i.length>0){p+=i;for(let o=0;o<i.length;o++)l.push(m)}if(!n)break;m+=n[0].length}return{text:p,iconOffsets:l}}e.$2j=d;function f(h,p,l=!1){const{text:m,iconOffsets:c}=p;if(!c||c.length===0)return(0,D.$Kj)(h,m,l);const n=(0,R.$Ke)(m," "),i=m.length-n.length,o=(0,D.$Kj)(h,n,l);if(o)for(const s of o){const t=c[s.start+i]+i;s.start+=t,s.end+=t}return o}e.$3j=f}),define(pe[23],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(r){return D.test(r)}e.$eg=R,e.$fg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let r;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?r=crypto.getRandomValues.bind(crypto):r=function(C){for(let v=0;v<C.length;v++)C[v]=Math.floor(Math.random()*256);return C};const I=new Uint8Array(16),P=[];for(let C=0;C<256;C++)P.push(C.toString(16).padStart(2,"0"));return function(){r(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let v=0,b="";return b+=P[I[v++]],b+=P[I[v++]],b+=P[I[v++]],b+=P[I[v++]],b+="-",b+=P[I[v++]],b+=P[I[v++]],b+="-",b+=P[I[v++]],b+=P[I[v++]],b+="-",b+=P[I[v++]],b+=P[I[v++]],b+="-",b+=P[I[v++]],b+=P[I[v++]],b+=P[I[v++]],b+=P[I[v++]],b+=P[I[v++]],b+=P[I[v++]],b}}()}),define(pe[150],be([1,0,18,47,23]),function(ue,e,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=e.$6s=e.$5s=e.$4s=e.$3s=void 0;function I(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}e.$3s=I;function P(S,y,u){const g={id:(0,r.$fg)(),name:S,uri:y,data:u};return{asString:async()=>"",asFile:()=>g,value:void 0}}e.$4s=P;class C{constructor(){this.a=new Map}get size(){let y=0;for(const u of this.a)y++;return y}has(y){return this.a.has(this.b(y))}matches(y){const u=[...this.a.keys()];return R.Iterable.some(this,([g,d])=>d.asFile())&&u.push("files"),A(v(y),u)}get(y){return this.a.get(this.b(y))?.[0]}append(y,u){const g=this.a.get(y);g?g.push(u):this.a.set(this.b(y),[u])}replace(y,u){this.a.set(this.b(y),[u])}delete(y){this.a.delete(this.b(y))}*[Symbol.iterator](){for(const[y,u]of this.a)for(const g of u)yield[y,g]}b(y){return v(y)}}e.$5s=C;function v(S){return S.toLowerCase()}function b(S,y){return A(v(S),y.map(v))}e.$6s=b;function A(S,y){if(S==="*/*")return y.length>0;if(y.includes(S))return!0;const u=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!u)return!1;const[g,d,f]=u;return f==="*"?y.some(h=>h.startsWith(d+"/")):!1}e.$7s=Object.freeze({create:S=>(0,D.$Mb)(S.map(y=>y.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$7s.split(S).filter(y=>!y.startsWith("#"))})}),function(){"use strict";function ue(e,D,R){function r(u){return new Promise(g=>D.exists(u,g))}function I(u){return new Promise((g,d)=>{const f=new Date;D.utimes(u,f,f,h=>h?d(h):g())})}function P(u){return new Promise((g,d)=>D.mkdir(u,{recursive:!0},f=>f&&f.code!=="EEXIST"?d(f):g(u)))}function C(u){return new Promise((g,d)=>D.rm(u,{recursive:!0,force:!0,maxRetries:3},f=>f?d(f):g()))}function v(u){return new Promise((g,d)=>D.readFile(u,"utf8",(f,h)=>f?d(f):g(h)))}function b(u,g){return new Promise((d,f)=>D.writeFile(u,g,"utf8",h=>h?f(h):d()))}async function A(u){const g=e.join(u,"languagepacks.json");try{return JSON.parse(await v(g))}catch{}}function S(u,g){try{for(;g;){if(u[g])return g;{const d=g.lastIndexOf("-");if(d>0)g=g.substring(0,d);else return}}}catch(d){console.error("Resolving language pack configuration failed.",d)}}function y(u,g,d,f,h){const p=function(m){return R.mark("code/didGenerateNls"),Promise.resolve({locale:m,osLocale:h,availableLanguages:{}})};if(R.mark("code/willGenerateNls"),f==="pseudo")return Promise.resolve({locale:f,osLocale:h,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:f,osLocale:h,availableLanguages:{}});if(f&&(f==="en"||f==="en-us"))return Promise.resolve({locale:f,osLocale:h,availableLanguages:{}});const l=f;try{return u?A(g).then(m=>{if(!m)return p(l);const c=S(m,f);if(!c)return p(l);f=c;const n=m[f];let i;return!n||typeof n.hash!="string"||!n.translations||typeof(i=n.translations.vscode)!="string"?p(l):r(i).then(o=>{if(!o)return p(l);const s=n.hash+"."+f,t=e.join(g,"clp",s),a=e.join(t,u),$=e.join(t,"tcf.json"),w=e.join(t,"corrupted.info"),k={locale:l,osLocale:h,availableLanguages:{"*":f},_languagePackId:s,_translationsConfigFile:$,_cacheRoot:t,_resolvedLanguagePackCoreLocation:a,_corruptedFile:w};return r(w).then(E=>{let L;return E?L=C(t):L=Promise.resolve(void 0),L.then(()=>r(a).then(j=>j?(I(a).catch(()=>{}),R.mark("code/didGenerateNls"),k):P(a).then(()=>Promise.all([v(d),v(i)])).then(x=>{const ce=JSON.parse(x[0]),X=JSON.parse(x[1]).contents,ie=Object.keys(ce.bundles),he=[];for(const _ of ie){const de=ce.bundles[_],Z=Object.create(null);for(const ne of de){const J=ce.keys[ne],W=ce.messages[ne],oe=X[ne];let le;if(oe){le=[];for(let re=0;re<J.length;re++){const ee=J[re],B=typeof ee=="string"?ee:ee.key;let K=oe[B];K===void 0&&(K=W[re]),le.push(K)}}else le=W;Z[ne]=le}he.push(b(e.join(a,_.replace(/\//g,"!")+".nls.json"),JSON.stringify(Z)))}return he.push(b($,JSON.stringify(n.translations))),Promise.all(he)}).then(()=>(R.mark("code/didGenerateNls"),k)).catch(x=>(console.error("Generating translation files failed.",x),p(f)))))})})}):p(l)}catch(m){return console.error("Generating translation files failed.",m),p(f)}}return{getNLSConfiguration:y}}if(typeof define=="function")define(pe[151],be([77,27,41]),function(e,D,R){return ue(e,D,R)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("fs"),R=require("../common/performance");module.exports=ue(e,D,R)}else throw new Error("Unknown context")}(),define(pe[152],be([1,0,28]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function r(P){const C=P.replace(/\-/g,":").toLowerCase();return!R.has(C)}function I(){const P=(0,D.networkInterfaces)();for(const C in P){const v=P[C];if(v){for(const{mac:b}of v)if(r(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Rm=I}),define(pe[153],be([1,0,78]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=e.$ig=e.$hg=void 0;function R(C,v,b,A=1){let S=!1;return new Promise(y=>{const u=setTimeout(()=>{if(!S)return S=!0,y(0)},b);r(C,v,A,g=>{if(!S)return S=!0,clearTimeout(u),y(g)})})}e.$hg=R;function r(C,v,b,A){if(v===0)return A(0);const S=new D.Socket;S.once("connect",()=>(P(S),r(C+b,v-1,b,A))),S.once("data",()=>{}),S.once("error",y=>(P(S),y.code!=="ECONNREFUSED"?r(C+b,v-1,b,A):A(C))),S.connect(C,"127.0.0.1")}e.$ig={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function I(C,v,b,A="127.0.0.1"){let S=!1,y,u=1;const g=D.createServer({pauseOnConnect:!0});function d(f,h){S||(S=!0,g.removeAllListeners(),g.close(),y&&clearTimeout(y),h(f))}return new Promise(f=>{y=setTimeout(()=>{d(0,f)},b),g.on("listening",()=>{d(C,f)}),g.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&u<v?(C++,u++,g.listen(C,A)):d(0,f)}),g.on("close",()=>{d(0,f)}),g.listen(C,A)})}e.$jg=I;function P(C){try{C.removeAllListeners("connect"),C.removeAllListeners("error"),C.end(),C.destroy(),C.unref()}catch(v){console.error(v)}}}),function(){function ue(){function e(){return process.uncHostAllowlist}function D(v){const b=new Set;if(Array.isArray(v))for(const A of v)typeof A=="string"&&b.add(A);return Array.from(b)}function R(){const v=e();return v?Array.from(v):[]}function r(v){if(process.platform!=="win32")return;const b=e();if(b)if(typeof v=="string")b.add(v.toLowerCase());else for(const A of D(v))r(A)}function I(v){if(typeof v!="string")return;const b=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let A;for(const S of b){if(v.indexOf(S)!==0)continue;const u=v.indexOf("\\",S.length);if(u===-1)continue;const g=v.substring(S.length,u);if(g){A=g;break}}return A}function P(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function C(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:R,addUNCHostToAllowlist:r,getUNCHost:I,disableUNCAccessRestrictions:P,isUNCAccessRestrictionsDisabled:C}}typeof define=="function"?define("vs/base/node/unc",[],function(){return ue()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=ue():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(pe[99],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ws=void 0;class D{constructor(r,I){this.lineNumber=r,this.column=I}with(r=this.lineNumber,I=this.column){return r===this.lineNumber&&I===this.column?this:new D(r,I)}delta(r=0,I=0){return this.with(this.lineNumber+r,this.column+I)}equals(r){return D.equals(this,r)}static equals(r,I){return!r&&!I?!0:!!r&&!!I&&r.lineNumber===I.lineNumber&&r.column===I.column}isBefore(r){return D.isBefore(this,r)}static isBefore(r,I){return r.lineNumber<I.lineNumber?!0:I.lineNumber<r.lineNumber?!1:r.column<I.column}isBeforeOrEqual(r){return D.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,I){return r.lineNumber<I.lineNumber?!0:I.lineNumber<r.lineNumber?!1:r.column<=I.column}static compare(r,I){const P=r.lineNumber|0,C=I.lineNumber|0;if(P===C){const v=r.column|0,b=I.column|0;return v-b}return P-C}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new D(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}}e.$ws=D}),define(pe[42],be([1,0,99]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=void 0;class R{constructor(I,P,C,v){I>C||I===C&&P>v?(this.startLineNumber=C,this.startColumn=v,this.endLineNumber=I,this.endColumn=P):(this.startLineNumber=I,this.startColumn=P,this.endLineNumber=C,this.endColumn=v)}isEmpty(){return R.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return R.containsPosition(this,I)}static containsPosition(I,P){return!(P.lineNumber<I.startLineNumber||P.lineNumber>I.endLineNumber||P.lineNumber===I.startLineNumber&&P.column<I.startColumn||P.lineNumber===I.endLineNumber&&P.column>I.endColumn)}static strictContainsPosition(I,P){return!(P.lineNumber<I.startLineNumber||P.lineNumber>I.endLineNumber||P.lineNumber===I.startLineNumber&&P.column<=I.startColumn||P.lineNumber===I.endLineNumber&&P.column>=I.endColumn)}containsRange(I){return R.containsRange(this,I)}static containsRange(I,P){return!(P.startLineNumber<I.startLineNumber||P.endLineNumber<I.startLineNumber||P.startLineNumber>I.endLineNumber||P.endLineNumber>I.endLineNumber||P.startLineNumber===I.startLineNumber&&P.startColumn<I.startColumn||P.endLineNumber===I.endLineNumber&&P.endColumn>I.endColumn)}strictContainsRange(I){return R.strictContainsRange(this,I)}static strictContainsRange(I,P){return!(P.startLineNumber<I.startLineNumber||P.endLineNumber<I.startLineNumber||P.startLineNumber>I.endLineNumber||P.endLineNumber>I.endLineNumber||P.startLineNumber===I.startLineNumber&&P.startColumn<=I.startColumn||P.endLineNumber===I.endLineNumber&&P.endColumn>=I.endColumn)}plusRange(I){return R.plusRange(this,I)}static plusRange(I,P){let C,v,b,A;return P.startLineNumber<I.startLineNumber?(C=P.startLineNumber,v=P.startColumn):P.startLineNumber===I.startLineNumber?(C=P.startLineNumber,v=Math.min(P.startColumn,I.startColumn)):(C=I.startLineNumber,v=I.startColumn),P.endLineNumber>I.endLineNumber?(b=P.endLineNumber,A=P.endColumn):P.endLineNumber===I.endLineNumber?(b=P.endLineNumber,A=Math.max(P.endColumn,I.endColumn)):(b=I.endLineNumber,A=I.endColumn),new R(C,v,b,A)}intersectRanges(I){return R.intersectRanges(this,I)}static intersectRanges(I,P){let C=I.startLineNumber,v=I.startColumn,b=I.endLineNumber,A=I.endColumn;const S=P.startLineNumber,y=P.startColumn,u=P.endLineNumber,g=P.endColumn;return C<S?(C=S,v=y):C===S&&(v=Math.max(v,y)),b>u?(b=u,A=g):b===u&&(A=Math.min(A,g)),C>b||C===b&&v>A?null:new R(C,v,b,A)}equalsRange(I){return R.equalsRange(this,I)}static equalsRange(I,P){return!I&&!P?!0:!!I&&!!P&&I.startLineNumber===P.startLineNumber&&I.startColumn===P.startColumn&&I.endLineNumber===P.endLineNumber&&I.endColumn===P.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(I){return new D.$ws(I.endLineNumber,I.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(I){return new D.$ws(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,P){return new R(this.startLineNumber,this.startColumn,I,P)}setStartPosition(I,P){return new R(I,P,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(I){return new R(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}collapseToEnd(){return R.collapseToEnd(this)}static collapseToEnd(I){return new R(I.endLineNumber,I.endColumn,I.endLineNumber,I.endColumn)}delta(I){return new R(this.startLineNumber+I,this.startColumn,this.endLineNumber+I,this.endColumn)}static fromPositions(I,P=I){return new R(I.lineNumber,I.column,P.lineNumber,P.column)}static lift(I){return I?new R(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,P){return!(I.endLineNumber<P.startLineNumber||I.endLineNumber===P.startLineNumber&&I.endColumn<P.startColumn||P.endLineNumber<I.startLineNumber||P.endLineNumber===I.startLineNumber&&P.endColumn<I.startColumn)}static areIntersecting(I,P){return!(I.endLineNumber<P.startLineNumber||I.endLineNumber===P.startLineNumber&&I.endColumn<=P.startColumn||P.endLineNumber<I.startLineNumber||P.endLineNumber===I.startLineNumber&&P.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,P){if(I&&P){const b=I.startLineNumber|0,A=P.startLineNumber|0;if(b===A){const S=I.startColumn|0,y=P.startColumn|0;if(S===y){const u=I.endLineNumber|0,g=P.endLineNumber|0;if(u===g){const d=I.endColumn|0,f=P.endColumn|0;return d-f}return u-g}return S-y}return b-A}return(I?1:0)-(P?1:0)}static compareRangesUsingEnds(I,P){return I.endLineNumber===P.endLineNumber?I.endColumn===P.endColumn?I.startLineNumber===P.startLineNumber?I.startColumn-P.startColumn:I.startLineNumber-P.startLineNumber:I.endColumn-P.endColumn:I.endLineNumber-P.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}toJSON(){return this}}e.$xs=R}),define(pe[154],be([1,0,42]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=void 0;class R{static insert(I,P){return{range:new D.$xs(I.lineNumber,I.column,I.lineNumber,I.column),text:P,forceMoveMarkers:!0}}static delete(I){return{range:I,text:null}}static replace(I,P){return{range:I,text:P}}static replaceMove(I,P){return{range:I,text:P,forceMoveMarkers:!0}}}e.$ys=R}),define(pe[155],be([1,0,5,2]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=void 0;class r{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$Od,this.onDidChange=this.c.event,this.d=null}handleChange(C){this.c.fire({changedLanguages:C,changedColorMap:!1})}register(C,v){return this.a.set(C,v),this.handleChange([C]),(0,R.$Qc)(()=>{this.a.get(C)===v&&(this.a.delete(C),this.handleChange([C]))})}get(C){return this.a.get(C)||null}registerFactory(C,v){this.b.get(C)?.dispose();const b=new I(this,C,v);return this.b.set(C,b),(0,R.$Qc)(()=>{const A=this.b.get(C);!A||A!==b||(this.b.delete(C),A.dispose())})}async getOrCreate(C){const v=this.get(C);if(v)return v;const b=this.b.get(C);return!b||b.isResolved?null:(await b.resolve(),this.get(C))}isResolved(C){if(this.get(C))return!0;const b=this.b.get(C);return!!(!b||b.isResolved)}setColorMap(C){this.d=C,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$9s=r;class I extends R.$Sc{get isResolved(){return this.c}constructor(C,v,b){super(),this.f=C,this.g=v,this.h=b,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const C=await this.h.tokenizationSupport;this.c=!0,C&&!this.a&&this.B(this.f.register(this.g,C))}}}),define(pe[156],be([8,9]),function(ue,e){return ue.create("vs/base/common/actions",e)}),define(pe[157],be([1,0,5,2,156]),function(ue,e,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=void 0;class I extends R.$Sc{constructor(y,u="",g="",d=!0,f){super(),this.h=this.B(new D.$Od),this.onDidChange=this.h.event,this.w=!0,this.j=y,this.m=u,this.u=g,this.w=d,this.C=f}get id(){return this.j}get label(){return this.m}set label(y){this.D(y)}D(y){this.m!==y&&(this.m=y,this.h.fire({label:y}))}get tooltip(){return this.n||""}set tooltip(y){this.F(y)}F(y){this.n!==y&&(this.n=y,this.h.fire({tooltip:y}))}get class(){return this.u}set class(y){this.G(y)}G(y){this.u!==y&&(this.u=y,this.h.fire({class:y}))}get enabled(){return this.w}set enabled(y){this.H(y)}H(y){this.w!==y&&(this.w=y,this.h.fire({enabled:y}))}get checked(){return this.z}set checked(y){this.I(y)}I(y){this.z!==y&&(this.z=y,this.h.fire({checked:y}))}async run(y,u){this.C&&await this.C(y)}}e.$vi=I;class P extends R.$Sc{constructor(){super(...arguments),this.f=this.B(new D.$Od),this.onWillRun=this.f.event,this.m=this.B(new D.$Od),this.onDidRun=this.m.event}async run(y,u){if(!y.enabled)return;this.f.fire({action:y});let g;try{await this.u(y,u)}catch(d){g=d}this.m.fire({action:y,error:g})}async u(y,u){await y.run(u)}}e.$wi=P;class C{constructor(){this.id=C.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...y){let u=[];for(const g of y)g.length&&(u.length?u=[...u,new C,...g]:u=g);return u}static{this.ID="vs.actions.separator"}async run(){}}e.$xi=C;class v{get actions(){return this.a}constructor(y,u,g,d){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=y,this.label=u,this.class=d,this.a=g}async run(){}}e.$yi=v;class b extends I{static{this.ID="vs.actions.empty"}constructor(){super(b.ID,r.localize(0,null),void 0,!1)}}e.$zi=b;function A(S){return{id:S.id,label:S.label,class:void 0,enabled:S.enabled??!0,checked:S.checked??!1,run:async(...y)=>S.run(...y),tooltip:S.label}}e.$Ai=A}),define(pe[158],be([8,9]),function(ue,e){return ue.create("vs/base/common/date",e)}),define(pe[159],be([1,0,158]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=e.$em=void 0;const R=60,r=R*60,I=r*24,P=I*7,C=I*30,v=I*365;function b(S,y,u,g){typeof S!="number"&&(S=S.getTime());const d=Math.round((new Date().getTime()-S)/1e3);if(d<-30)return(0,D.localize)(0,null,b(new Date().getTime()+d*1e3,!1));if(!g&&d<30)return(0,D.localize)(1,null);let f;return d<R?(f=d,y?f===1?u?(0,D.localize)(2,null,f):(0,D.localize)(3,null,f):u?(0,D.localize)(4,null,f):(0,D.localize)(5,null,f):f===1?u?(0,D.localize)(6,null,f):(0,D.localize)(7,null,f):u?(0,D.localize)(8,null,f):(0,D.localize)(9,null,f)):d<r?(f=Math.floor(d/R),y?f===1?u?(0,D.localize)(10,null,f):(0,D.localize)(11,null,f):u?(0,D.localize)(12,null,f):(0,D.localize)(13,null,f):f===1?u?(0,D.localize)(14,null,f):(0,D.localize)(15,null,f):u?(0,D.localize)(16,null,f):(0,D.localize)(17,null,f)):d<I?(f=Math.floor(d/r),y?f===1?u?(0,D.localize)(18,null,f):(0,D.localize)(19,null,f):u?(0,D.localize)(20,null,f):(0,D.localize)(21,null,f):f===1?u?(0,D.localize)(22,null,f):(0,D.localize)(23,null,f):u?(0,D.localize)(24,null,f):(0,D.localize)(25,null,f)):d<P?(f=Math.floor(d/I),y?f===1?(0,D.localize)(26,null,f):(0,D.localize)(27,null,f):f===1?(0,D.localize)(28,null,f):(0,D.localize)(29,null,f)):d<C?(f=Math.floor(d/P),y?f===1?u?(0,D.localize)(30,null,f):(0,D.localize)(31,null,f):u?(0,D.localize)(32,null,f):(0,D.localize)(33,null,f):f===1?u?(0,D.localize)(34,null,f):(0,D.localize)(35,null,f):u?(0,D.localize)(36,null,f):(0,D.localize)(37,null,f)):d<v?(f=Math.floor(d/C),y?f===1?u?(0,D.localize)(38,null,f):(0,D.localize)(39,null,f):u?(0,D.localize)(40,null,f):(0,D.localize)(41,null,f):f===1?u?(0,D.localize)(42,null,f):(0,D.localize)(43,null,f):u?(0,D.localize)(44,null,f):(0,D.localize)(45,null,f)):(f=Math.floor(d/v),y?f===1?u?(0,D.localize)(46,null,f):(0,D.localize)(47,null,f):u?(0,D.localize)(48,null,f):(0,D.localize)(49,null,f):f===1?u?(0,D.localize)(50,null,f):(0,D.localize)(51,null,f):u?(0,D.localize)(52,null,f):(0,D.localize)(53,null,f))}e.$em=b;function A(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$fm=A}),define(pe[160],be([8,9]),function(ue,e){return ue.create("vs/base/common/errorMessage",e)}),define(pe[39],be([1,0,18,10,160]),function(ue,e,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=void 0;function I(S,y){return y&&(S.stack||S.stacktrace)?r.localize(0,null,C(S),P(S.stack)||P(S.stacktrace)):C(S)}function P(S){return Array.isArray(S)?S.join(`
`):S}function C(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?r.localize(1,null,S.message):S.message||r.localize(2,null)}function v(S=null,y=!1){if(!S)return r.localize(3,null);if(Array.isArray(S)){const u=D.$Hb(S),g=v(u[0],y);return u.length>1?r.localize(4,null,g,u.length):g}if(R.$zf(S))return S;if(S.detail){const u=S.detail;if(u.error)return I(u.error,y);if(u.exception)return I(u.exception,y)}return S.stack?I(S,y):S.message?S.message:r.localize(5,null)}e.$Bi=v;function b(S){const y=S;return y instanceof Error&&Array.isArray(y.actions)}e.$Ci=b;function A(S,y){let u;return typeof S=="string"?u=new Error(S):u=S,u.actions=y,u}e.$Di=A}),define(pe[161],be([8,9]),function(ue,e){return ue.create("vs/base/common/jsonErrorMessages",e)}),define(pe[162],be([1,0,161]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;function R(r){switch(r){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.$Ap=R}),define(pe[163],be([8,9]),function(ue,e){return ue.create("vs/base/common/platform",e)}),define(pe[3],be([1,0,163]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let R=!1,r=!1,I=!1,P=!1,C=!1,v=!1,b=!1,A=!1,S=!1,y=!1,u,g=e.$g,d=e.$g,f,h;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?p=e.$h.vscode.process:typeof process<"u"&&(p=process);const l=typeof p?.versions?.electron=="string",m=l&&p?.type==="renderer";if(typeof navigator=="object"&&!m)h=navigator.userAgent,R=h.indexOf("Windows")>=0,r=h.indexOf("Macintosh")>=0,A=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=h.indexOf("Linux")>=0,y=h?.indexOf("Mobi")>=0,v=!0,u=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,g=u,d=navigator.language;else if(typeof p=="object"){R=p.platform==="win32",r=p.platform==="darwin",I=p.platform==="linux",P=I&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,b=l,S=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.$g,g=e.$g;const w=p.env.VSCODE_NLS_CONFIG;if(w)try{const k=JSON.parse(w),E=k.availableLanguages["*"];u=k.locale,d=k.osLocale,g=E||e.$g,f=k._translationsConfigFile}catch{}C=!0}else console.error("Unable to resolve platform.");var c;(function(w){w[w.Web=0]="Web",w[w.Mac=1]="Mac",w[w.Linux=2]="Linux",w[w.Windows=3]="Windows"})(c||(e.Platform=c={}));function n(w){switch(w){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=n;let i=0;r?i=1:R?i=3:I&&(i=2),e.$j=R,e.$k=r,e.$l=I,e.$m=P,e.$n=C,e.$o=b,e.$p=v,e.$q=v&&typeof e.$h.importScripts=="function",e.$r=A,e.$s=y,e.$t=S,e.$u=i,e.$v=h,e.$w=g;var o;(function(w){function k(){return e.$w}w.value=k;function E(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}w.isDefaultVariant=E;function L(){return e.$w==="en"}w.isDefault=L})(o||(e.Language=o={})),e.$x=u,e.$y=d,e.$z=f,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const w=[];e.$h.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let L=0,j=w.length;L<j;L++){const x=w[L];if(x.id===E.data.vscodeScheduleAsyncWork){w.splice(L,1),x.callback();return}}});let k=0;return E=>{const L=++k;w.push({id:L,callback:E}),e.$h.postMessage({vscodeScheduleAsyncWork:L},"*")}}return w=>setTimeout(w)})();var s;(function(w){w[w.Windows=1]="Windows",w[w.Macintosh=2]="Macintosh",w[w.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=r||A?2:R?1:3;let t=!0,a=!1;function $(){if(!a){a=!0;const w=new Uint8Array(2);w[0]=1,w[1]=2,t=new Uint16Array(w.buffer)[0]===(2<<8)+1}return t}e.$D=$,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(pe[29],be([1,0,3]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let R;if(typeof D.$h.vscode<"u"&&typeof D.$h.vscode.process<"u"){const r=D.$h.vscode.process;R={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return D.$j?"win32":D.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.$dc=R.platform,e.$ec=R.arch}),define(pe[7],be([1,0,29]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const R=65,r=97,I=90,P=122,C=46,v=47,b=92,A=58,S=63;class y extends Error{constructor(i,o,s){let t;typeof o=="string"&&o.indexOf("not ")===0?(t="must not be",o=o.replace(/^not /,"")):t="must be";const a=i.indexOf(".")!==-1?"property":"argument";let $=`The "${i}" ${a} ${t} of type ${o}`;$+=`. Received type ${typeof s}`,super($),this.code="ERR_INVALID_ARG_TYPE"}}function u(n,i){if(n===null||typeof n!="object")throw new y(i,"Object",n)}function g(n,i){if(typeof n!="string")throw new y(i,"string",n)}const d=D.$dc==="win32";function f(n){return n===v||n===b}function h(n){return n===v}function p(n){return n>=R&&n<=I||n>=r&&n<=P}function l(n,i,o,s){let t="",a=0,$=-1,w=0,k=0;for(let E=0;E<=n.length;++E){if(E<n.length)k=n.charCodeAt(E);else{if(s(k))break;k=v}if(s(k)){if(!($===E-1||w===1))if(w===2){if(t.length<2||a!==2||t.charCodeAt(t.length-1)!==C||t.charCodeAt(t.length-2)!==C){if(t.length>2){const L=t.lastIndexOf(o);L===-1?(t="",a=0):(t=t.slice(0,L),a=t.length-1-t.lastIndexOf(o)),$=E,w=0;continue}else if(t.length!==0){t="",a=0,$=E,w=0;continue}}i&&(t+=t.length>0?`${o}..`:"..",a=2)}else t.length>0?t+=`${o}${n.slice($+1,E)}`:t=n.slice($+1,E),a=E-$-1;$=E,w=0}else k===C&&w!==-1?++w:w=-1}return t}function m(n,i){u(i,"pathObject");const o=i.dir||i.root,s=i.base||`${i.name||""}${i.ext||""}`;return o?o===i.root?`${o}${s}`:`${o}${n}${s}`:s}e.$fc={resolve(...n){let i="",o="",s=!1;for(let t=n.length-1;t>=-1;t--){let a;if(t>=0){if(a=n[t],g(a,"path"),a.length===0)continue}else i.length===0?a=D.cwd():(a=D.env[`=${i}`]||D.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==i.toLowerCase()&&a.charCodeAt(2)===b)&&(a=`${i}\\`));const $=a.length;let w=0,k="",E=!1;const L=a.charCodeAt(0);if($===1)f(L)&&(w=1,E=!0);else if(f(L))if(E=!0,f(a.charCodeAt(1))){let j=2,x=j;for(;j<$&&!f(a.charCodeAt(j));)j++;if(j<$&&j!==x){const ce=a.slice(x,j);for(x=j;j<$&&f(a.charCodeAt(j));)j++;if(j<$&&j!==x){for(x=j;j<$&&!f(a.charCodeAt(j));)j++;(j===$||j!==x)&&(k=`\\\\${ce}\\${a.slice(x,j)}`,w=j)}}}else w=1;else p(L)&&a.charCodeAt(1)===A&&(k=a.slice(0,2),w=2,$>2&&f(a.charCodeAt(2))&&(E=!0,w=3));if(k.length>0)if(i.length>0){if(k.toLowerCase()!==i.toLowerCase())continue}else i=k;if(s){if(i.length>0)break}else if(o=`${a.slice(w)}\\${o}`,s=E,E&&i.length>0)break}return o=l(o,!s,"\\",f),s?`${i}\\${o}`:`${i}${o}`||"."},normalize(n){g(n,"path");const i=n.length;if(i===0)return".";let o=0,s,t=!1;const a=n.charCodeAt(0);if(i===1)return h(a)?"\\":n;if(f(a))if(t=!0,f(n.charCodeAt(1))){let w=2,k=w;for(;w<i&&!f(n.charCodeAt(w));)w++;if(w<i&&w!==k){const E=n.slice(k,w);for(k=w;w<i&&f(n.charCodeAt(w));)w++;if(w<i&&w!==k){for(k=w;w<i&&!f(n.charCodeAt(w));)w++;if(w===i)return`\\\\${E}\\${n.slice(k)}\\`;w!==k&&(s=`\\\\${E}\\${n.slice(k,w)}`,o=w)}}}else o=1;else p(a)&&n.charCodeAt(1)===A&&(s=n.slice(0,2),o=2,i>2&&f(n.charCodeAt(2))&&(t=!0,o=3));let $=o<i?l(n.slice(o),!t,"\\",f):"";return $.length===0&&!t&&($="."),$.length>0&&f(n.charCodeAt(i-1))&&($+="\\"),s===void 0?t?`\\${$}`:$:t?`${s}\\${$}`:`${s}${$}`},isAbsolute(n){g(n,"path");const i=n.length;if(i===0)return!1;const o=n.charCodeAt(0);return f(o)||i>2&&p(o)&&n.charCodeAt(1)===A&&f(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let i,o;for(let a=0;a<n.length;++a){const $=n[a];g($,"path"),$.length>0&&(i===void 0?i=o=$:i+=`\\${$}`)}if(i===void 0)return".";let s=!0,t=0;if(typeof o=="string"&&f(o.charCodeAt(0))){++t;const a=o.length;a>1&&f(o.charCodeAt(1))&&(++t,a>2&&(f(o.charCodeAt(2))?++t:s=!1))}if(s){for(;t<i.length&&f(i.charCodeAt(t));)t++;t>=2&&(i=`\\${i.slice(t)}`)}return e.$fc.normalize(i)},relative(n,i){if(g(n,"from"),g(i,"to"),n===i)return"";const o=e.$fc.resolve(n),s=e.$fc.resolve(i);if(o===s||(n=o.toLowerCase(),i=s.toLowerCase(),n===i))return"";let t=0;for(;t<n.length&&n.charCodeAt(t)===b;)t++;let a=n.length;for(;a-1>t&&n.charCodeAt(a-1)===b;)a--;const $=a-t;let w=0;for(;w<i.length&&i.charCodeAt(w)===b;)w++;let k=i.length;for(;k-1>w&&i.charCodeAt(k-1)===b;)k--;const E=k-w,L=$<E?$:E;let j=-1,x=0;for(;x<L;x++){const X=n.charCodeAt(t+x);if(X!==i.charCodeAt(w+x))break;X===b&&(j=x)}if(x!==L){if(j===-1)return s}else{if(E>L){if(i.charCodeAt(w+x)===b)return s.slice(w+x+1);if(x===2)return s.slice(w+x)}$>L&&(n.charCodeAt(t+x)===b?j=x:x===2&&(j=3)),j===-1&&(j=0)}let ce="";for(x=t+j+1;x<=a;++x)(x===a||n.charCodeAt(x)===b)&&(ce+=ce.length===0?"..":"\\..");return w+=j,ce.length>0?`${ce}${s.slice(w,k)}`:(s.charCodeAt(w)===b&&++w,s.slice(w,k))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const i=e.$fc.resolve(n);if(i.length<=2)return n;if(i.charCodeAt(0)===b){if(i.charCodeAt(1)===b){const o=i.charCodeAt(2);if(o!==S&&o!==C)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(p(i.charCodeAt(0))&&i.charCodeAt(1)===A&&i.charCodeAt(2)===b)return`\\\\?\\${i}`;return n},dirname(n){g(n,"path");const i=n.length;if(i===0)return".";let o=-1,s=0;const t=n.charCodeAt(0);if(i===1)return f(t)?n:".";if(f(t)){if(o=s=1,f(n.charCodeAt(1))){let w=2,k=w;for(;w<i&&!f(n.charCodeAt(w));)w++;if(w<i&&w!==k){for(k=w;w<i&&f(n.charCodeAt(w));)w++;if(w<i&&w!==k){for(k=w;w<i&&!f(n.charCodeAt(w));)w++;if(w===i)return n;w!==k&&(o=s=w+1)}}}}else p(t)&&n.charCodeAt(1)===A&&(o=i>2&&f(n.charCodeAt(2))?3:2,s=o);let a=-1,$=!0;for(let w=i-1;w>=s;--w)if(f(n.charCodeAt(w))){if(!$){a=w;break}}else $=!1;if(a===-1){if(o===-1)return".";a=o}return n.slice(0,a)},basename(n,i){i!==void 0&&g(i,"ext"),g(n,"path");let o=0,s=-1,t=!0,a;if(n.length>=2&&p(n.charCodeAt(0))&&n.charCodeAt(1)===A&&(o=2),i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let $=i.length-1,w=-1;for(a=n.length-1;a>=o;--a){const k=n.charCodeAt(a);if(f(k)){if(!t){o=a+1;break}}else w===-1&&(t=!1,w=a+1),$>=0&&(k===i.charCodeAt($)?--$===-1&&(s=a):($=-1,s=w))}return o===s?s=w:s===-1&&(s=n.length),n.slice(o,s)}for(a=n.length-1;a>=o;--a)if(f(n.charCodeAt(a))){if(!t){o=a+1;break}}else s===-1&&(t=!1,s=a+1);return s===-1?"":n.slice(o,s)},extname(n){g(n,"path");let i=0,o=-1,s=0,t=-1,a=!0,$=0;n.length>=2&&n.charCodeAt(1)===A&&p(n.charCodeAt(0))&&(i=s=2);for(let w=n.length-1;w>=i;--w){const k=n.charCodeAt(w);if(f(k)){if(!a){s=w+1;break}continue}t===-1&&(a=!1,t=w+1),k===C?o===-1?o=w:$!==1&&($=1):o!==-1&&($=-1)}return o===-1||t===-1||$===0||$===1&&o===t-1&&o===s+1?"":n.slice(o,t)},format:m.bind(null,"\\"),parse(n){g(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const o=n.length;let s=0,t=n.charCodeAt(0);if(o===1)return f(t)?(i.root=i.dir=n,i):(i.base=i.name=n,i);if(f(t)){if(s=1,f(n.charCodeAt(1))){let j=2,x=j;for(;j<o&&!f(n.charCodeAt(j));)j++;if(j<o&&j!==x){for(x=j;j<o&&f(n.charCodeAt(j));)j++;if(j<o&&j!==x){for(x=j;j<o&&!f(n.charCodeAt(j));)j++;j===o?s=j:j!==x&&(s=j+1)}}}}else if(p(t)&&n.charCodeAt(1)===A){if(o<=2)return i.root=i.dir=n,i;if(s=2,f(n.charCodeAt(2))){if(o===3)return i.root=i.dir=n,i;s=3}}s>0&&(i.root=n.slice(0,s));let a=-1,$=s,w=-1,k=!0,E=n.length-1,L=0;for(;E>=s;--E){if(t=n.charCodeAt(E),f(t)){if(!k){$=E+1;break}continue}w===-1&&(k=!1,w=E+1),t===C?a===-1?a=E:L!==1&&(L=1):a!==-1&&(L=-1)}return w!==-1&&(a===-1||L===0||L===1&&a===w-1&&a===$+1?i.base=i.name=n.slice($,w):(i.name=n.slice($,a),i.base=n.slice($,w),i.ext=n.slice(a,w))),$>0&&$!==s?i.dir=n.slice(0,$-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(d){const n=/\\/g;return()=>{const i=D.cwd().replace(n,"/");return i.slice(i.indexOf("/"))}}return()=>D.cwd()})();e.$gc={resolve(...n){let i="",o=!1;for(let s=n.length-1;s>=-1&&!o;s--){const t=s>=0?n[s]:c();g(t,"path"),t.length!==0&&(i=`${t}/${i}`,o=t.charCodeAt(0)===v)}return i=l(i,!o,"/",h),o?`/${i}`:i.length>0?i:"."},normalize(n){if(g(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===v,o=n.charCodeAt(n.length-1)===v;return n=l(n,!i,"/",h),n.length===0?i?"/":o?"./":".":(o&&(n+="/"),i?`/${n}`:n)},isAbsolute(n){return g(n,"path"),n.length>0&&n.charCodeAt(0)===v},join(...n){if(n.length===0)return".";let i;for(let o=0;o<n.length;++o){const s=n[o];g(s,"path"),s.length>0&&(i===void 0?i=s:i+=`/${s}`)}return i===void 0?".":e.$gc.normalize(i)},relative(n,i){if(g(n,"from"),g(i,"to"),n===i||(n=e.$gc.resolve(n),i=e.$gc.resolve(i),n===i))return"";const o=1,s=n.length,t=s-o,a=1,$=i.length-a,w=t<$?t:$;let k=-1,E=0;for(;E<w;E++){const j=n.charCodeAt(o+E);if(j!==i.charCodeAt(a+E))break;j===v&&(k=E)}if(E===w)if($>w){if(i.charCodeAt(a+E)===v)return i.slice(a+E+1);if(E===0)return i.slice(a+E)}else t>w&&(n.charCodeAt(o+E)===v?k=E:E===0&&(k=0));let L="";for(E=o+k+1;E<=s;++E)(E===s||n.charCodeAt(E)===v)&&(L+=L.length===0?"..":"/..");return`${L}${i.slice(a+k)}`},toNamespacedPath(n){return n},dirname(n){if(g(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===v;let o=-1,s=!0;for(let t=n.length-1;t>=1;--t)if(n.charCodeAt(t)===v){if(!s){o=t;break}}else s=!1;return o===-1?i?"/":".":i&&o===1?"//":n.slice(0,o)},basename(n,i){i!==void 0&&g(i,"ext"),g(n,"path");let o=0,s=-1,t=!0,a;if(i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let $=i.length-1,w=-1;for(a=n.length-1;a>=0;--a){const k=n.charCodeAt(a);if(k===v){if(!t){o=a+1;break}}else w===-1&&(t=!1,w=a+1),$>=0&&(k===i.charCodeAt($)?--$===-1&&(s=a):($=-1,s=w))}return o===s?s=w:s===-1&&(s=n.length),n.slice(o,s)}for(a=n.length-1;a>=0;--a)if(n.charCodeAt(a)===v){if(!t){o=a+1;break}}else s===-1&&(t=!1,s=a+1);return s===-1?"":n.slice(o,s)},extname(n){g(n,"path");let i=-1,o=0,s=-1,t=!0,a=0;for(let $=n.length-1;$>=0;--$){const w=n.charCodeAt($);if(w===v){if(!t){o=$+1;break}continue}s===-1&&(t=!1,s=$+1),w===C?i===-1?i=$:a!==1&&(a=1):i!==-1&&(a=-1)}return i===-1||s===-1||a===0||a===1&&i===s-1&&i===o+1?"":n.slice(i,s)},format:m.bind(null,"/"),parse(n){g(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const o=n.charCodeAt(0)===v;let s;o?(i.root="/",s=1):s=0;let t=-1,a=0,$=-1,w=!0,k=n.length-1,E=0;for(;k>=s;--k){const L=n.charCodeAt(k);if(L===v){if(!w){a=k+1;break}continue}$===-1&&(w=!1,$=k+1),L===C?t===-1?t=k:E!==1&&(E=1):t!==-1&&(E=-1)}if($!==-1){const L=a===0&&o?1:a;t===-1||E===0||E===1&&t===$-1&&t===a+1?i.base=i.name=n.slice(L,$):(i.name=n.slice(L,t),i.base=n.slice(L,$),i.ext=n.slice(t,$))}return a>0?i.dir=n.slice(0,a-1):o&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=d?e.$fc.normalize:e.$gc.normalize,e.$ic=d?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=d?e.$fc.join:e.$gc.join,e.$kc=d?e.$fc.resolve:e.$gc.resolve,e.$lc=d?e.$fc.relative:e.$gc.relative,e.$mc=d?e.$fc.dirname:e.$gc.dirname,e.$nc=d?e.$fc.basename:e.$gc.basename,e.$oc=d?e.$fc.extname:e.$gc.extname,e.$pc=d?e.$fc.format:e.$gc.format,e.$qc=d?e.$fc.parse:e.$gc.parse,e.$rc=d?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=d?e.$fc.sep:e.$gc.sep,e.$tc=d?e.$fc.delimiter:e.$gc.delimiter}),define(pe[40],be([1,0,7,3,17,10]),function(ue,e,D,R,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=void 0;function P(a){return a===47||a===92}e.$Rf=P;function C(a){return a.replace(/[\\/]/g,D.$gc.sep)}e.$Sf=C;function v(a){return a.indexOf("/")===-1&&(a=C(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.$Tf=v;function b(a,$=D.$gc.sep){if(!a)return"";const w=a.length,k=a.charCodeAt(0);if(P(k)){if(P(a.charCodeAt(1))&&!P(a.charCodeAt(2))){let L=3;const j=L;for(;L<w&&!P(a.charCodeAt(L));L++);if(j!==L&&!P(a.charCodeAt(L+1))){for(L+=1;L<w;L++)if(P(a.charCodeAt(L)))return a.slice(0,L+1).replace(/[\\/]/g,$)}}return $}else if(h(k)&&a.charCodeAt(1)===58)return P(a.charCodeAt(2))?a.slice(0,2)+$:a.slice(0,2);let E=a.indexOf("://");if(E!==-1){for(E+=3;E<w;E++)if(P(a.charCodeAt(E)))return a.slice(0,E+1)}return""}e.$Uf=b;function A(a){if(!R.$j||!a||a.length<5)return!1;let $=a.charCodeAt(0);if($!==92||($=a.charCodeAt(1),$!==92))return!1;let w=2;const k=w;for(;w<a.length&&($=a.charCodeAt(w),$!==92);w++);return!(k===w||($=a.charCodeAt(w+1),isNaN($)||$===92))}e.$Vf=A;const S=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(a,$=R.$j){const w=$?S:y;return!(!a||a.length===0||/^\s+$/.test(a)||(w.lastIndex=0,w.test(a))||$&&u.test(a)||a==="."||a===".."||$&&a[a.length-1]==="."||$&&a.length!==a.trim().length||a.length>255)}e.$Wf=g;function d(a,$,w){const k=a===$;return!w||k?k:!a||!$?!1:(0,r.$3e)(a,$)}e.$Xf=d;function f(a,$,w,k=D.sep){if(a===$)return!0;if(!a||!$||$.length>a.length)return!1;if(w){if(!(0,r.$4e)(a,$))return!1;if($.length===a.length)return!0;let L=$.length;return $.charAt($.length-1)===k&&L--,a.charAt(L)===k}return $.charAt($.length-1)!==k&&($+=k),a.indexOf($)===0}e.$Yf=f;function h(a){return a>=65&&a<=90||a>=97&&a<=122}e.$Zf=h;function p(a,$){return R.$j&&a.endsWith(":")&&(a+=D.sep),(0,D.$ic)(a)||(a=(0,D.$jc)($,a)),a=(0,D.$hc)(a),R.$j?(a=(0,r.$Le)(a,D.sep),a.endsWith(":")&&(a+=D.sep)):(a=(0,r.$Le)(a,D.sep),a||(a=D.sep)),a}e.$1f=p;function l(a){const $=(0,D.$hc)(a);return R.$j?a.length>3?!1:m($)&&(a.length===2||$.charCodeAt(2)===92):$===D.$gc.sep}e.$2f=l;function m(a,$=R.$j){return $?h(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.$3f=m;function c(a,$=R.$j){return m(a,$)?a[0]:void 0}e.$4f=c;function n(a,$,w){return $.length>a.length?-1:a===$?0:(w&&(a=a.toLowerCase(),$=$.toLowerCase()),a.indexOf($))}e.$5f=n;function i(a){const $=a.split(":");let w,k,E;for(const L of $){const j=Number(L);(0,I.$Df)(j)?k===void 0?k=j:E===void 0&&(E=j):w=w?[w,L].join(":"):L}if(!w)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:w,line:k!==void 0?k:void 0,column:E!==void 0?E:k!==void 0?1:void 0}}e.$6f=i;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(a,$,w=8){let k="";for(let L=0;L<w;L++){let j;L===0&&R.$j&&!$&&(w===3||w===4)?j=s:j=o,k+=j.charAt(Math.floor(Math.random()*j.length))}let E;return $?E=`${$}-${k}`:E=k,a?(0,D.$jc)(a,E):E}e.$7f=t}),define(pe[63],be([1,0,7]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=e.$Wr=e.$Vr=e.$Ur=e.$Tr=void 0,e.$Tr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},r={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(A){const S=(0,D.$oc)(A),y=R[S.toLowerCase()];return y!==void 0?y:P(A)}e.$Ur=I;function P(A){const S=(0,D.$oc)(A);return r[S.toLowerCase()]}e.$Vr=P;function C(A){for(const S in r)if(r[S]===A)return S}e.$Wr=C;const v=/^(.+)\/(.+?)(;.+)?$/;function b(A,S){const y=v.exec(A);return y?`${y[1].toLowerCase()}/${y[2].toLowerCase()}${y[3]??""}`:S?void 0:A}e.$Xr=b}),define(pe[64],be([1,0,3]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.$Al=e.TerminateResponseCode=e.Source=void 0;var R;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(R||(e.Source=R={}));var r;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(r||(e.TerminateResponseCode=r={}));function I(C,...v){const b=v.reduce((y,u)=>(y[u]=!0,y),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(y=>!b[y]).forEach(y=>{for(let u=0;u<A.length;u++)if(y.search(A[u])!==-1){delete C[y];break}})}e.$Al=I;function P(C){C&&(delete C.DEBUG,D.$k&&delete C.DYLD_LIBRARY_PATH,D.$l&&delete C.LD_PRELOAD)}e.$Bl=P}),define(pe[4],be([1,0,7,3]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const r=/^\w[\w\d+.-]*$/,I=/^\//,P=/^\/\//;function C(s,t){if(!s.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!r.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!I.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(s,t){return!s&&!t?"file":s}function b(s,t){switch(s){case"https":case"http":case"file":t?t[0]!==S&&(t=S+t):t=S;break}return t}const A="",S="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(t){return t instanceof u?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,a,$,w,k,E=!1){typeof t=="object"?(this.scheme=t.scheme||A,this.authority=t.authority||A,this.path=t.path||A,this.query=t.query||A,this.fragment=t.fragment||A):(this.scheme=v(t,E),this.authority=a||A,this.path=b(this.scheme,$||A),this.query=w||A,this.fragment=k||A,C(this,E))}get fsPath(){return m(this,!1)}with(t){if(!t)return this;let{scheme:a,authority:$,path:w,query:k,fragment:E}=t;return a===void 0?a=this.scheme:a===null&&(a=A),$===void 0?$=this.authority:$===null&&($=A),w===void 0?w=this.path:w===null&&(w=A),k===void 0?k=this.query:k===null&&(k=A),E===void 0?E=this.fragment:E===null&&(E=A),a===this.scheme&&$===this.authority&&w===this.path&&k===this.query&&E===this.fragment?this:new f(a,$,w,k,E)}static parse(t,a=!1){const $=y.exec(t);return $?new f($[2]||A,o($[4]||A),o($[5]||A),o($[7]||A),o($[9]||A),a):new f(A,A,A,A,A)}static file(t){let a=A;if(R.$j&&(t=t.replace(/\\/g,S)),t[0]===S&&t[1]===S){const $=t.indexOf(S,2);$===-1?(a=t.substring(2),t=S):(a=t.substring(2,$),t=t.substring($)||S)}return new f("file",a,t,A,A)}static from(t,a){return new f(t.scheme,t.authority,t.path,t.query,t.fragment,a)}static joinPath(t,...a){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let $;return R.$j&&t.scheme==="file"?$=u.file(D.$fc.join(m(t,!0),...a)).path:$=D.$gc.join(t.path,...a),t.with({path:$})}toString(t=!1){return c(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof u)return t;{const a=new f(t);return a._formatted=t.external??null,a._fsPath=t._sep===d?t.fsPath??null:null,a}}else return t}}e.URI=u;function g(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}e.$vc=g;const d=R.$j?1:void 0;class f extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(t=!1){return t?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=d),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(s,t,a){let $,w=-1;for(let k=0;k<s.length;k++){const E=s.charCodeAt(k);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||t&&E===47||a&&E===91||a&&E===93||a&&E===58)w!==-1&&($+=encodeURIComponent(s.substring(w,k)),w=-1),$!==void 0&&($+=s.charAt(k));else{$===void 0&&($=s.substr(0,k));const L=h[E];L!==void 0?(w!==-1&&($+=encodeURIComponent(s.substring(w,k)),w=-1),$+=L):w===-1&&(w=k)}}return w!==-1&&($+=encodeURIComponent(s.substring(w))),$!==void 0?$:s}function l(s){let t;for(let a=0;a<s.length;a++){const $=s.charCodeAt(a);$===35||$===63?(t===void 0&&(t=s.substr(0,a)),t+=h[$]):t!==void 0&&(t+=s[a])}return t!==void 0?t:s}function m(s,t){let a;return s.authority&&s.path.length>1&&s.scheme==="file"?a=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?t?a=s.path.substr(1):a=s.path[1].toLowerCase()+s.path.substr(2):a=s.path,R.$j&&(a=a.replace(/\//g,"\\")),a}e.$wc=m;function c(s,t){const a=t?l:p;let $="",{scheme:w,authority:k,path:E,query:L,fragment:j}=s;if(w&&($+=w,$+=":"),(k||w==="file")&&($+=S,$+=S),k){let x=k.indexOf("@");if(x!==-1){const ce=k.substr(0,x);k=k.substr(x+1),x=ce.lastIndexOf(":"),x===-1?$+=a(ce,!1,!1):($+=a(ce.substr(0,x),!1,!1),$+=":",$+=a(ce.substr(x+1),!1,!0)),$+="@"}k=k.toLowerCase(),x=k.lastIndexOf(":"),x===-1?$+=a(k,!1,!0):($+=a(k.substr(0,x),!1,!0),$+=k.substr(x))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const x=E.charCodeAt(1);x>=65&&x<=90&&(E=`/${String.fromCharCode(x+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const x=E.charCodeAt(0);x>=65&&x<=90&&(E=`${String.fromCharCode(x+32)}:${E.substr(2)}`)}$+=a(E,!0,!1)}return L&&($+="?",$+=a(L,!1,!1)),j&&($+="#",$+=t?j:p(j,!1,!1)),$}function n(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+n(s.substr(3)):s}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(s){return s.match(i)?s.replace(i,t=>n(t)):s}}),define(pe[164],be([1,0,4]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$4p=e.$3p=e.$2p=void 0;function R(b){const A=b;return A&&typeof A.type=="string"&&typeof A.severity=="string"}e.$2p=R;function r(b){const A=[];let S;try{const y=JSON.parse(b.arguments),u=y[y.length-1];u&&u.__$stack&&(y.pop(),S=u.__$stack),A.push(...y)}catch{A.push("Unable to log remote console arguments",b.arguments)}return{args:A,stack:S}}e.$3p=r;function I(b){if(typeof b!="string")return I(r(b).stack);const A=b;if(A){const S=P(A),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(y&&y.length===4)return{uri:D.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.$4p=I;function P(b){if(!b)return b;const A=b.indexOf(`
`);return A===-1?b:b.substring(0,A)}function C(b,A){const{args:S,stack:y}=r(b),u=typeof S[0]=="string"&&S.length===1;let g=P(y);g&&(g=`(${g.trim()})`);let d=[];if(typeof S[0]=="string"?g&&u?d=[`%c[${A}] %c${S[0]} %c${g}`,v("blue"),v(""),v("grey")]:d=[`%c[${A}] %c${S[0]}`,v("blue"),v(""),...S.slice(1)]:d=[`%c[${A}]%`,v("blue"),...S],g&&!u&&d.push(g),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,d)}e.log=C;function v(b){return`color: ${b}`}}),define(pe[50],be([1,0,15,4]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=e.$mh=e.$lh=void 0;function r(v){return JSON.stringify(v,P)}e.$lh=r;function I(v){let b=JSON.parse(v);return b=C(b),b}e.$mh=I;function P(v,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:b.flags}:b}function C(v,b=0){if(!v||b>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return R.URI.revive(v);case 2:return new RegExp(v.source,v.flags);case 17:return new Date(v.source)}if(v instanceof D.$ce||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let A=0;A<v.length;++A)v[A]=C(v[A],b+1);else for(const A in v)Object.hasOwnProperty.call(v,A)&&(v[A]=C(v[A],b+1))}return v}e.$nh=C}),define(pe[12],be([1,0,11,3,4]),function(ue,e,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.Schemas=void 0;var I;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeManagedRemoteResource="vscode-managed-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.vscodeChatSesssion="vscode-chat-editor",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(I||(e.Schemas=I={})),e.$8f="vscode-tkn",e.$9f="tkn";class P{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${I.vscodeRemoteResource}`}setPreferredWebSchema(A){this.d=A}setDelegate(A){this.e=A}setServerRootPath(A){this.f=`${A}/${I.vscodeRemoteResource}`}set(A,S,y){this.a[A]=S,this.b[A]=y}setConnectionToken(A,S){this.c[A]=S}getPreferredWebSchema(){return this.d}rewrite(A){if(this.e)try{return this.e(A)}catch(f){return D.$1(f),A}const S=A.authority;let y=this.a[S];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const u=this.b[S],g=this.c[S];let d=`path=${encodeURIComponent(A.path)}`;return typeof g=="string"&&(d+=`&${e.$9f}=${encodeURIComponent(g)}`),r.URI.from({scheme:R.$p?this.d:I.vscodeRemoteResource,authority:`${y}:${u}`,path:this.f,query:d})}}e.$0f=new P,e.$$f="vs/../../extensions",e.$_f="vs/../../node_modules",e.$ag="vs/../../node_modules.asar",e.$bg="vs/../../node_modules.asar.unpacked",e.$cg="vscode-app";class C{static{this.a=e.$cg}asBrowserUri(A){const S=this.b(A,ue);return this.uriToBrowserUri(S)}uriToBrowserUri(A){return A.scheme===I.vscodeRemote?e.$0f.rewrite(A):A.scheme===I.file&&(R.$n||R.$q&&R.$h.origin===`${I.vscodeFileResource}://${C.a}`)?A.with({scheme:I.vscodeFileResource,authority:A.authority||C.a,query:null,fragment:null}):A}asFileUri(A){const S=this.b(A,ue);return this.uriToFileUri(S)}uriToFileUri(A){return A.scheme===I.vscodeFileResource?A.with({scheme:I.file,authority:A.authority!==C.a?A.authority:null,query:null,fragment:null}):A}b(A,S){return r.URI.isUri(A)?A:r.URI.parse(S.toUrl(A))}}e.$dg=new C;var v;(function(b){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(A.get("3"));const S="vscode-coi";function y(g){let d;typeof g=="string"?d=new URL(g).searchParams:g instanceof URL?d=g.searchParams:r.URI.isUri(g)&&(d=new URL(g.toString(!0)).searchParams);const f=d?.get(S);if(f)return A.get(f)}b.getHeadersFromQuery=y;function u(g,d,f){if(!globalThis.crossOriginIsolated)return;const h=d&&f?"3":f?"2":"1";g instanceof URLSearchParams?g.set(S,h):g[S]=h}b.addSearchParam=u})(v||(e.COI=v={}))}),define(pe[165],be([1,0,94,12,3,4]),function(ue,e,D,R,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zC=void 0;class P{constructor(y,u,g){this.id=y,this.dependencies=u,this.callback=g}}class C{static{this.INSTANCE=new C}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(y,u,g)=>{typeof y!="string"&&(g=u,u=y,y=null),(typeof u!="object"||!Array.isArray(u))&&(g=u,u=null),this.c.push(new P(y,u,g))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(y){if(y.startsWith(window.location.origin)||y.startsWith("vscode-file://vscode-app"))return y;throw new Error(`[trusted_script_src] Invalid script url: ${y}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(y){return y}})))}async load(y){this.g();const u=await(this.a?this.i(y):this.b?this.h(y):this.j(y));if(!u)throw new Error(`Did not receive a define call from script ${y}`);if(Array.isArray(u.dependencies)&&u.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${y}. The dependencies are: ${u.dependencies.join(", ")}`);return typeof u.callback=="function"?u.callback([]):u.callback}h(y){return new Promise((u,g)=>{const d=document.createElement("script");d.setAttribute("async","async"),d.setAttribute("type","text/javascript");const f=()=>{d.removeEventListener("load",h),d.removeEventListener("error",p)},h=l=>{f(),u(this.c.pop())},p=l=>{f(),g(l)};d.addEventListener("load",h),d.addEventListener("error",p),this.f&&(y=this.f.createScriptURL(y)),d.setAttribute("src",y),document.getElementsByTagName("head")[0].appendChild(d)})}i(y){return new Promise((u,g)=>{try{this.f&&(y=this.f.createScriptURL(y)),importScripts(y),u(this.c.pop())}catch(d){g(d)}})}async j(y){try{const u=globalThis._VSCODE_NODE_MODULES.fs,g=globalThis._VSCODE_NODE_MODULES.vm,d=globalThis._VSCODE_NODE_MODULES.module,f=I.URI.parse(y).fsPath,h=u.readFileSync(f).toString(),p=d.wrap(h.replace(/^#!.*/,""));return new g.Script(p).runInThisContext().apply(),this.c.pop()}catch(u){throw u}}}const v=new Map;let b={};typeof globalThis.require=="object"&&(b=globalThis.require.paths??{});async function A(S,y,u){if(D.$T){u===void 0&&(u=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),b[S]&&(S=b[S]);const g=`${S}/${y}`;if(v.has(g))return v.get(g);let d;if(/^\w[\w\d+.-]*:\/\//.test(g))d=g;else{const l=`${u&&!r.$p?R.$ag:R.$_f}/${g}`;d=R.$dg.asBrowserUri(l).toString(!0)}const f=C.INSTANCE.load(d);return v.set(g,f),f}else return await new Promise((g,d)=>{ue([S],g,d)})}e.$zC=A}),define(pe[19],be([1,0,40,12,7,3,17,4]),function(ue,e,D,R,r,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gg=e.DataUri=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=void 0;function v(u){return(0,C.$wc)(u,!0)}e.$kg=v;class b{constructor(g){this.a=g}compare(g,d,f=!1){return g===d?0:(0,P.$Ve)(this.getComparisonKey(g,f),this.getComparisonKey(d,f))}isEqual(g,d,f=!1){return g===d?!0:!g||!d?!1:this.getComparisonKey(g,f)===this.getComparisonKey(d,f)}getComparisonKey(g,d=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,d,f=!1){if(g.scheme===d.scheme){if(g.scheme===R.Schemas.file)return D.$Yf(v(g),v(d),this.a(g))&&g.query===d.query&&(f||g.fragment===d.fragment);if((0,e.$Bg)(g.authority,d.authority))return D.$Yf(g.path,d.path,this.a(g),"/")&&g.query===d.query&&(f||g.fragment===d.fragment)}return!1}joinPath(g,...d){return C.URI.joinPath(g,...d)}basenameOrAuthority(g){return(0,e.$tg)(g)||g.authority}basename(g){return r.$gc.basename(g.path)}extname(g){return r.$gc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let d;return g.scheme===R.Schemas.file?d=C.URI.file(r.$mc(v(g))).path:(d=r.$gc.dirname(g.path),g.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),d="/")),g.with({path:d})}normalizePath(g){if(!g.path.length)return g;let d;return g.scheme===R.Schemas.file?d=C.URI.file(r.$hc(v(g))).path:d=r.$gc.normalize(g.path),g.with({path:d})}relativePath(g,d){if(g.scheme!==d.scheme||!(0,e.$Bg)(g.authority,d.authority))return;if(g.scheme===R.Schemas.file){const p=r.$lc(v(g),v(d));return I.$j?D.$Sf(p):p}let f=g.path||"/";const h=d.path||"/";if(this.a(g)){let p=0;for(const l=Math.min(f.length,h.length);p<l&&!(f.charCodeAt(p)!==h.charCodeAt(p)&&f.charAt(p).toLowerCase()!==h.charAt(p).toLowerCase());p++);f=h.substr(0,p)+f.substr(p)}return r.$gc.relative(f,h)}resolvePath(g,d){if(g.scheme===R.Schemas.file){const f=C.URI.file(r.$kc(v(g),d));return g.with({authority:f.authority,path:f.path})}return d=D.$Tf(d),g.with({path:r.$gc.resolve(g.path,d)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,d){return g===d||g!==void 0&&d!==void 0&&(0,P.$3e)(g,d)}hasTrailingPathSeparator(g,d=r.sep){if(g.scheme===R.Schemas.file){const f=v(g);return f.length>D.$Uf(f).length&&f[f.length-1]===d}else{const f=g.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,d=r.sep){return(0,e.$Cg)(g,d)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,d=r.sep){let f=!1;if(g.scheme===R.Schemas.file){const h=v(g);f=h!==void 0&&h.length===D.$Uf(h).length&&h[h.length-1]===d}else{d="/";const h=g.path;f=h.length===1&&h.charCodeAt(h.length-1)===47}return!f&&!(0,e.$Cg)(g,d)?g.with({path:g.path+"/"}):g}}e.$lg=b,e.$mg=new b(()=>!1),e.$ng=new b(u=>u.scheme===R.Schemas.file?!I.$l:!0),e.$og=new b(u=>!0),e.$pg=e.$mg.isEqual.bind(e.$mg),e.$qg=e.$mg.isEqualOrParent.bind(e.$mg),e.$rg=e.$mg.getComparisonKey.bind(e.$mg),e.$sg=e.$mg.basenameOrAuthority.bind(e.$mg),e.$tg=e.$mg.basename.bind(e.$mg),e.$ug=e.$mg.extname.bind(e.$mg),e.$vg=e.$mg.dirname.bind(e.$mg),e.$wg=e.$mg.joinPath.bind(e.$mg),e.$xg=e.$mg.normalizePath.bind(e.$mg),e.$yg=e.$mg.relativePath.bind(e.$mg),e.$zg=e.$mg.resolvePath.bind(e.$mg),e.$Ag=e.$mg.isAbsolutePath.bind(e.$mg),e.$Bg=e.$mg.isEqualAuthority.bind(e.$mg),e.$Cg=e.$mg.hasTrailingPathSeparator.bind(e.$mg),e.$Dg=e.$mg.removeTrailingPathSeparator.bind(e.$mg),e.$Eg=e.$mg.addTrailingPathSeparator.bind(e.$mg);function A(u,g){const d=[];for(let f=0;f<u.length;f++){const h=g(u[f]);u.some((p,l)=>l===f?!1:(0,e.$qg)(h,g(p)))||d.push(u[f])}return d}e.$Fg=A;var S;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function g(d){const f=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(l=>{const[m,c]=l.split(":");m&&c&&f.set(m,c)});const p=d.path.substring(0,d.path.indexOf(";"));return p&&f.set(u.META_DATA_MIME,p),f}u.parseMetaData=g})(S||(e.DataUri=S={}));function y(u,g,d){if(g){let f=u.path;return f&&f[0]!==r.$gc.sep&&(f=r.$gc.sep+f),u.with({scheme:d,authority:g,path:f})}return u.with({scheme:d})}e.$Gg=y}),define(pe[14],be([1,0,20,11,5,2,19,3,148]),function(ue,e,D,R,r,I,P,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=e.$eh=e.Promises=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=void 0;function b(O){return!!O&&typeof O.then=="function"}e.$Hg=b;function A(O){const U=new D.$Yd,T=O(U.token),q=new Promise((z,te)=>{const H=U.token.onCancellationRequested(()=>{H.dispose(),U.dispose(),te(new R.$5)});Promise.resolve(T).then(Y=>{H.dispose(),U.dispose(),z(Y)},Y=>{H.dispose(),U.dispose(),te(Y)})});return new class{cancel(){U.cancel()}then(z,te){return q.then(z,te)}catch(z){return this.then(void 0,z)}finally(z){return q.finally(z)}}}e.$Ig=A;function S(O,U,T){return new Promise((q,z)=>{const te=U.onCancellationRequested(()=>{te.dispose(),q(T)});O.then(q,z).finally(()=>te.dispose())})}e.$Jg=S;function y(O,U){return new Promise((T,q)=>{const z=U.onCancellationRequested(()=>{z.dispose(),q(new R.$5)});O.then(T,q).finally(()=>z.dispose())})}e.$Kg=y;async function u(O){let U=-1;const T=O.map((q,z)=>q.then(te=>(U=z,te)));try{return await Promise.race(T)}finally{O.forEach((q,z)=>{z!==U&&q.cancel()})}}e.$Lg=u;function g(O,U,T){let q;const z=setTimeout(()=>{q?.(void 0),T?.()},U);return Promise.race([O.finally(()=>clearTimeout(z)),new Promise(te=>q=te)])}e.$Mg=g;function d(O){return new Promise((U,T)=>{const q=O();b(q)?q.then(U,T):U(q)})}e.$Ng=d;class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(U){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=U,!this.b){const T=()=>{if(this.b=null,this.f)return;const q=this.queue(this.d);return this.d=null,q};this.b=new Promise(q=>{this.a.then(T,T).then(q)})}return new Promise((T,q)=>{this.b.then(T,q)})}return this.a=U(),new Promise((T,q)=>{this.a.then(z=>{this.a=null,T(z)},z=>{this.a=null,q(z)})})}dispose(){this.f=!0}}e.$Og=f;class h{constructor(){this.a=Promise.resolve(null)}queue(U){return this.a=this.a.then(()=>U(),()=>U())}}e.$Pg=h;class p{constructor(){this.a=new Map}queue(U,T){const z=(this.a.get(U)??Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.a.get(U)===z&&this.a.delete(U)});return this.a.set(U,z),z}}e.$Qg=p;const l=(O,U)=>{let T=!0;const q=setTimeout(()=>{T=!1,U()},O);return{isTriggered:()=>T,dispose:()=>{clearTimeout(q),T=!1}}},m=O=>{let U=!0;return queueMicrotask(()=>{U&&(U=!1,O())}),{isTriggered:()=>U,dispose:()=>{U=!1}}};class c{constructor(U){this.defaultDelay=U,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(U,T=this.defaultDelay){this.g=U,this.h(),this.b||(this.b=new Promise((z,te)=>{this.d=z,this.f=te}).then(()=>{if(this.b=null,this.d=null,this.g){const z=this.g;return this.g=null,z()}}));const q=()=>{this.a=null,this.d?.(null)};return this.a=T===v.$Ld?m(q):l(T,q),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Rg=c;class n{constructor(U){this.a=new c(U),this.b=new f}trigger(U,T){return this.a.trigger(()=>this.b.queue(U),T)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Sg=n;class i{constructor(){this.a=!1,this.b=new Promise((U,T)=>{this.d=U})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Tg=i;class o extends i{constructor(U){super(),this.f=setTimeout(()=>this.open(),U)}open(){clearTimeout(this.f),super.open()}}e.$Ug=o;function s(O,U){return U?new Promise((T,q)=>{const z=setTimeout(()=>{te.dispose(),T()},O),te=U.onCancellationRequested(()=>{clearTimeout(z),te.dispose(),q(new R.$5)})}):A(T=>s(O,T))}e.$Vg=s;function t(O,U=0,T){const q=setTimeout(()=>{O(),T&&z.dispose()},U),z=(0,I.$Qc)(()=>{clearTimeout(q),T?.deleteAndLeak(z)});return T?.add(z),z}e.$Wg=t;function a(O){const U=[];let T=0;const q=O.length;function z(){return T<q?O[T++]():null}function te(H){H!=null&&U.push(H);const Y=z();return Y?Y.then(te):Promise.resolve(U)}return Promise.resolve(null).then(te)}e.$Xg=a;function $(O,U=q=>!!q,T=null){let q=0;const z=O.length,te=()=>{if(q>=z)return Promise.resolve(T);const H=O[q++];return Promise.resolve(H()).then(V=>U(V)?Promise.resolve(V):te())};return te()}e.$Yg=$;function w(O,U=q=>!!q,T=null){if(O.length===0)return Promise.resolve(T);let q=O.length;const z=()=>{q=-1;for(const te of O)te.cancel?.()};return new Promise((te,H)=>{for(const Y of O)Y.then(V=>{--q>=0&&U(V)?(z(),te(V)):q===0&&te(T)}).catch(V=>{--q>=0&&(z(),H(V))})})}e.$Zg=w;class k{constructor(U){this.a=0,this.d=U,this.f=[],this.b=0,this.g=new r.$Od}get onDrained(){return this.g.event}get size(){return this.a}queue(U){return this.a++,new Promise((T,q)=>{this.f.push({factory:U,c:T,e:q}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const U=this.f.shift();this.b++;const T=U.factory();T.then(U.c,U.e),T.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$1g=k;class E extends k{constructor(){super(1)}}e.$2g=E;class L{constructor(){this.a=new ne,this.b=0}queue(U){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,U())):this.a.run(this.b++,U())}}e.$3g=L;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const U=new oe;return this.b.add(U),U.p}g(){for(const[,U]of this.a)if(U.size>0)return!1;return!0}queueFor(U,T=P.$mg){const q=T.getComparisonKey(U);let z=this.a.get(q);if(!z){z=new E;const te=this.f++,H=r.Event.once(z.onDrained)(()=>{z?.dispose(),this.a.delete(q),this.h(),this.d?.deleteAndDispose(te),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new I.$1c),this.d.set(te,H),this.a.set(q,z)}return z}h(){this.g()&&this.j()}j(){for(const U of this.b)U.complete();this.b.clear()}dispose(){for(const[,U]of this.a)U.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$4g=j;class x{constructor(U,T){this.a=-1,typeof U=="function"&&typeof T=="number"&&this.setIfNotSet(U,T)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(U,T){this.cancel(),this.a=setTimeout(()=>{this.a=-1,U()},T)}setIfNotSet(U,T){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,U()},T))}}e.$5g=x;class ce{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(U,T){this.cancel(),this.a=setInterval(()=>{U()},T)}}e.$6g=ce;class X{constructor(U,T){this.b=-1,this.a=U,this.d=T,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(U=this.d){this.cancel(),this.b=setTimeout(this.f,U)}get delay(){return this.d}set delay(U){this.d=U}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$7g=X;class ie{constructor(U,T){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.a=U,this.b=T,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(U=this.b){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(U/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$8g=ie;class he extends X{constructor(U,T){super(U,T),this.j=[]}work(U){this.j.push(U),this.isScheduled()||this.schedule()}h(){const U=this.j;this.j=[],this.a?.(U)}dispose(){this.j=[],super.dispose()}}e.$9g=he;class _ extends I.$Sc{constructor(U,T){super(),this.g=U,this.h=T,this.a=[],this.b=this.B(new I.$Tc),this.f=!1}get pending(){return this.a.length}work(U){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+U.length>this.g.maxBufferedWork)return!1}else if(this.pending+U.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const T of U)this.a.push(T);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new X(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$0g=_,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$$g=O=>{(0,C.$B)(()=>{if(U)return;const T=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,T-Date.now())}}))});let U=!1;return{dispose(){U||(U=!0)}}}:e.$$g=(O,U)=>{const T=requestIdleCallback(O,typeof U=="number"?{timeout:U}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback(T))}}}}();class de{constructor(U){this.d=!1,this.a=()=>{try{this.f=U()}catch(T){this.g=T}finally{this.d=!0}},this.b=(0,e.$$g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$_g=de;async function Z(O,U,T){let q;for(let z=0;z<T;z++)try{return await O()}catch(te){q=te,await s(U)}throw q}e.$ah=Z;class ne{isRunning(U){return typeof U=="number"?this.a?.taskId===U:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(U,T,q){return this.a={taskId:U,cancel:()=>q?.(),promise:T},T.then(()=>this.d(U),()=>this.d(U)),T}d(U){this.a&&U===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const U=this.b;this.b=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}queue(U){if(this.b)this.b.run=U;else{let T,q;const z=new Promise((te,H)=>{T=te,q=H});this.b={run:U,promise:z,promiseResolve:T,promiseReject:q}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$bh=ne;class J{constructor(U,T=()=>Date.now()){this.d=U,this.f=T,this.a=0,this.b=0}increment(){const U=this.f();return U-this.a>this.d&&(this.a=U,this.b=0),this.b++,this.b}}e.$ch=J;var W;(function(O){O[O.Resolved=0]="Resolved",O[O.Rejected=1]="Rejected"})(W||(W={}));class oe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((U,T)=>{this.a=U,this.b=T})}complete(U){return new Promise(T=>{this.a(U),this.d={outcome:0,value:U},T()})}error(U){return new Promise(T=>{this.b(U),this.d={outcome:1,value:U},T()})}cancel(){return this.error(new R.$5)}}e.$dh=oe;var le;(function(O){async function U(q){let z;const te=await Promise.all(q.map(H=>H.then(Y=>Y,Y=>{z||(z=Y)})));if(typeof z<"u")throw z;return te}O.settled=U;function T(q){return new Promise(async(z,te)=>{try{await q(z,te)}catch(H){te(H)}})}O.withAsyncBody=T})(le||(e.Promises=le={}));var re;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(re||(re={}));class ee{static fromArray(U){return new ee(T=>{T.emitMany(U)})}static fromPromise(U){return new ee(async T=>{T.emitMany(await U)})}static fromPromises(U){return new ee(async T=>{await Promise.all(U.map(async q=>T.emitOne(await q)))})}static merge(U){return new ee(async T=>{await Promise.all(U.map(async q=>{for await(const z of q)T.emitOne(z)}))})}static{this.EMPTY=ee.fromArray([])}constructor(U){this.a=0,this.b=[],this.d=null,this.f=new r.$Od,queueMicrotask(async()=>{const T={emitOne:q=>this.g(q),emitMany:q=>this.h(q),reject:q=>this.k(q)};try{await Promise.resolve(U(T)),this.j()}catch(q){this.k(q)}finally{T.emitOne=void 0,T.emitMany=void 0,T.reject=void 0}})}[Symbol.asyncIterator](){let U=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(U<this.b.length)return{done:!1,value:this.b[U++]};if(this.a===1)return{done:!0,value:void 0};await r.Event.toPromise(this.f.event)}while(!0)}}}static map(U,T){return new ee(async q=>{for await(const z of U)q.emitOne(T(z))})}map(U){return ee.map(this,U)}static filter(U,T){return new ee(async q=>{for await(const z of U)T(z)&&q.emitOne(z)})}filter(U){return ee.filter(this,U)}static coalesce(U){return ee.filter(U,T=>!!T)}coalesce(){return ee.coalesce(this)}static async toPromise(U){const T=[];for await(const q of U)T.push(q);return T}toPromise(){return ee.toPromise(this)}g(U){this.a===0&&(this.b.push(U),this.f.fire())}h(U){this.a===0&&(this.b=this.b.concat(U),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(U){this.a===0&&(this.a=2,this.d=U,this.f.fire())}}e.$eh=ee;class B extends ee{constructor(U,T){super(T),this.l=U}cancel(){this.l.cancel()}}e.$fh=B;function K(O){const U=new D.$Yd,T=O(U.token);return new B(U,async q=>{const z=U.token.onCancellationRequested(()=>{z.dispose(),U.dispose(),q.reject(new R.$5)});try{for await(const te of T){if(U.token.isCancellationRequested)return;q.emitOne(te)}z.dispose(),U.dispose()}catch(te){z.dispose(),U.dispose(),q.reject(te)}})}e.$gh=K;class N{constructor(){this.a=new oe,this.b=new ee(q=>{if(U){q.reject(U);return}return T&&q.emitMany(T),this.d=z=>q.reject(z),this.f=z=>q.emitOne(z),this.a.p});let U,T;this.f=q=>{T||(T=[]),T.push(q)},this.d=q=>{U||(U=q)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(U){this.d(U),this.a.complete()}emitOne(U){this.f(U)}}e.$hh=N}),define(pe[79],be([1,0,18,14,40,26,7,3,17]),function(ue,e,D,R,r,I,P,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=void 0;function b(){return Object.create(null)}e.$sj=b,e.$tj="**",e.$uj="/";const A="[/\\\\]",S="[^/\\\\]",y=/\//g;function u(ne,J){switch(ne){case 0:return"";case 1:return`${S}*?`;default:return`(?:${A}|${S}+${A}${J?`|${A}${S}+`:""})*?`}}function g(ne,J){if(!ne)return[];const W=[];let oe=!1,le=!1,re="";for(const ee of ne){switch(ee){case J:if(!oe&&!le){W.push(re),re="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":le=!0;break;case"]":le=!1;break}re+=ee}return re&&W.push(re),W}e.$vj=g;function d(ne){if(!ne)return"";let J="";const W=g(ne,e.$uj);if(W.every(oe=>oe===e.$tj))J=".*";else{let oe=!1;W.forEach((le,re)=>{if(le===e.$tj){if(oe)return;J+=u(2,re===W.length-1)}else{let ee=!1,B="",K=!1,N="";for(const O of le){if(O!=="}"&&ee){B+=O;continue}if(K&&(O!=="]"||!N)){let U;O==="-"?U=O:(O==="^"||O==="!")&&!N?U="^":O===e.$uj?U="":U=(0,v.$Ge)(O),N+=U;continue}switch(O){case"{":ee=!0;continue;case"[":K=!0;continue;case"}":{const T=`(?:${g(B,",").map(q=>d(q)).join("|")})`;J+=T,ee=!1,B="";break}case"]":{J+="["+N+"]",K=!1,N="";break}case"?":J+=S;continue;case"*":J+=u(1);continue;default:J+=(0,v.$Ge)(O)}}re<W.length-1&&(W[re+1]!==e.$tj||re+2<W.length)&&(J+=A)}oe=le===e.$tj})}return J}const f=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,l=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new I.$Dc(1e4),i=function(){return!1},o=function(){return null};function s(ne,J){if(!ne)return o;let W;typeof ne!="string"?W=ne.pattern:W=ne,W=W.trim();const oe=`${W}_${!!J.trimForExclusions}`;let le=n.get(oe);if(le)return t(le,ne);let re;return f.test(W)?le=$(W.substr(4),W):(re=h.exec(a(W,J)))?le=w(re[1],W):(J.trimForExclusions?l:p).test(W)?le=k(W,J):(re=m.exec(a(W,J)))?le=E(re[1].substr(1),W,!0):(re=c.exec(a(W,J)))?le=E(re[1],W,!1):le=L(W),n.set(oe,le),t(le,ne)}function t(ne,J){if(typeof J=="string")return ne;const W=function(oe,le){return(0,r.$Yf)(oe,J.base,!C.$l)?ne((0,v.$Ke)(oe.substr(J.base.length),P.sep),le):null};return W.allBasenames=ne.allBasenames,W.allPaths=ne.allPaths,W.basenames=ne.basenames,W.patterns=ne.patterns,W}function a(ne,J){return J.trimForExclusions&&ne.endsWith("/**")?ne.substr(0,ne.length-2):ne}function $(ne,J){return function(W,oe){return typeof W=="string"&&W.endsWith(ne)?J:null}}function w(ne,J){const W=`/${ne}`,oe=`\\${ne}`,le=function(ee,B){return typeof ee!="string"?null:B?B===ne?J:null:ee===ne||ee.endsWith(W)||ee.endsWith(oe)?J:null},re=[ne];return le.basenames=re,le.patterns=[J],le.allBasenames=re,le}function k(ne,J){const W=de(ne.slice(1,-1).split(",").map(B=>s(B,J)).filter(B=>B!==o),ne),oe=W.length;if(!oe)return o;if(oe===1)return W[0];const le=function(B,K){for(let N=0,O=W.length;N<O;N++)if(W[N](B,K))return ne;return null},re=W.find(B=>!!B.allBasenames);re&&(le.allBasenames=re.allBasenames);const ee=W.reduce((B,K)=>K.allPaths?B.concat(K.allPaths):B,[]);return ee.length&&(le.allPaths=ee),le}function E(ne,J,W){const oe=P.sep===P.$gc.sep,le=oe?ne:ne.replace(y,P.sep),re=P.sep+le,ee=P.$gc.sep+ne;let B;return W?B=function(K,N){return typeof K=="string"&&(K===le||K.endsWith(re)||!oe&&(K===ne||K.endsWith(ee)))?J:null}:B=function(K,N){return typeof K=="string"&&(K===le||!oe&&K===ne)?J:null},B.allPaths=[(W?"*/":"./")+ne],B}function L(ne){try{const J=new RegExp(`^${d(ne)}$`);return function(W){return J.lastIndex=0,typeof W=="string"&&J.test(W)?ne:null}}catch{return o}}function j(ne,J,W){return!ne||typeof J!="string"?!1:x(ne)(J,void 0,W)}e.$wj=j;function x(ne,J={}){if(!ne)return i;if(typeof ne=="string"||ce(ne)){const W=s(ne,J);if(W===o)return i;const oe=function(le,re){return!!W(le,re)};return W.allBasenames&&(oe.allBasenames=W.allBasenames),W.allPaths&&(oe.allPaths=W.allPaths),oe}return he(ne,J)}e.$xj=x;function ce(ne){const J=ne;return J?typeof J.base=="string"&&typeof J.pattern=="string":!1}e.$yj=ce;function X(ne){return ne.allBasenames||[]}e.$zj=X;function ie(ne){return ne.allPaths||[]}e.$Aj=ie;function he(ne,J){const W=de(Object.getOwnPropertyNames(ne).map(B=>_(B,ne[B],J)).filter(B=>B!==o)),oe=W.length;if(!oe)return o;if(!W.some(B=>!!B.requiresSiblings)){if(oe===1)return W[0];const B=function(O,U){let T;for(let q=0,z=W.length;q<z;q++){const te=W[q](O,U);if(typeof te=="string")return te;(0,R.$Hg)(te)&&(T||(T=[]),T.push(te))}return T?(async()=>{for(const q of T){const z=await q;if(typeof z=="string")return z}return null})():null},K=W.find(O=>!!O.allBasenames);K&&(B.allBasenames=K.allBasenames);const N=W.reduce((O,U)=>U.allPaths?O.concat(U.allPaths):O,[]);return N.length&&(B.allPaths=N),B}const le=function(B,K,N){let O,U;for(let T=0,q=W.length;T<q;T++){const z=W[T];z.requiresSiblings&&N&&(K||(K=(0,P.$nc)(B)),O||(O=K.substr(0,K.length-(0,P.$oc)(B).length)));const te=z(B,K,O,N);if(typeof te=="string")return te;(0,R.$Hg)(te)&&(U||(U=[]),U.push(te))}return U?(async()=>{for(const T of U){const q=await T;if(typeof q=="string")return q}return null})():null},re=W.find(B=>!!B.allBasenames);re&&(le.allBasenames=re.allBasenames);const ee=W.reduce((B,K)=>K.allPaths?B.concat(K.allPaths):B,[]);return ee.length&&(le.allPaths=ee),le}function _(ne,J,W){if(J===!1)return o;const oe=s(ne,W);if(oe===o)return o;if(typeof J=="boolean")return oe;if(J){const le=J.when;if(typeof le=="string"){const re=(ee,B,K,N)=>{if(!N||!oe(ee,B))return null;const O=le.replace("$(basename)",()=>K),U=N(O);return(0,R.$Hg)(U)?U.then(T=>T?ne:null):U?ne:null};return re.requiresSiblings=!0,re}}return oe}function de(ne,J){const W=ne.filter(B=>!!B.basenames);if(W.length<2)return ne;const oe=W.reduce((B,K)=>{const N=K.basenames;return N?B.concat(N):B},[]);let le;if(J){le=[];for(let B=0,K=oe.length;B<K;B++)le.push(J)}else le=W.reduce((B,K)=>{const N=K.patterns;return N?B.concat(N):B},[]);const re=function(B,K){if(typeof B!="string")return null;if(!K){let O;for(O=B.length;O>0;O--){const U=B.charCodeAt(O-1);if(U===47||U===92)break}K=B.substr(O)}const N=oe.indexOf(K);return N!==-1?le[N]:null};re.basenames=oe,re.patterns=le,re.allBasenames=oe;const ee=ne.filter(B=>!B.basenames);return ee.push(re),ee}function Z(ne,J){return(0,D.$ub)(ne,J,(W,oe)=>typeof W=="string"&&typeof oe=="string"?W===oe:typeof W!="string"&&typeof oe!="string"?W.base===oe.base&&W.pattern===oe.pattern:!1)}e.$Bj=Z}),define(pe[100],be([1,0,11,149,19,17,4]),function(ue,e,D,R,r,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.MarkdownStringTextNewlineStyle=void 0;var C;(function(f){f[f.Paragraph=0]="Paragraph",f[f.Break=1]="Break"})(C||(e.MarkdownStringTextNewlineStyle=C={}));class v{constructor(h="",p=!1){if(this.value=h,typeof this.value!="string")throw(0,D.$7)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(h,p=0){return this.value+=y(this.supportThemeIcons?(0,R.$Xj)(h):h).replace(/([ \t]+)/g,(l,m)=>"&nbsp;".repeat(m.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,p){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}appendLink(h,p,l){return this.value+="[",this.value+=this.c(p,"]"),this.value+="](",this.value+=this.c(String(h),")"),l&&(this.value+=` "${this.c(this.c(l,'"'),")")}"`),this.value+=")",this}c(h,p){const l=new RegExp((0,I.$Ge)(p),"g");return h.replace(l,(m,c)=>h.charAt(c-1)!=="\\"?`\\${m}`:m)}}e.$4j=v;function b(f){return A(f)?!f.value:Array.isArray(f)?f.every(b):!0}e.$5j=b;function A(f){return f instanceof v?!0:f&&typeof f=="object"?typeof f.value=="string"&&(typeof f.isTrusted=="boolean"||typeof f.isTrusted=="object"||f.isTrusted===void 0)&&(typeof f.supportThemeIcons=="boolean"||f.supportThemeIcons===void 0):!1}e.$6j=A;function S(f,h){return f===h?!0:!f||!h?!1:f.value===h.value&&f.isTrusted===h.isTrusted&&f.supportThemeIcons===h.supportThemeIcons&&f.supportHtml===h.supportHtml&&(f.baseUri===h.baseUri||!!f.baseUri&&!!h.baseUri&&(0,r.$pg)(P.URI.from(f.baseUri),P.URI.from(h.baseUri)))}e.$7j=S;function y(f){return f.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$8j=y;function u(f){return f.replace(/"/g,"&quot;")}e.$9j=u;function g(f){return f&&f.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$0j=g;function d(f){const h=[],p=f.split("|").map(m=>m.trim());f=p[0];const l=p[1];if(l){const m=/height=(\d+)/.exec(l),c=/width=(\d+)/.exec(l),n=m?m[1]:"",i=c?c[1]:"",o=isFinite(parseInt(i)),s=isFinite(parseInt(n));o&&h.push(`width="${i}"`),s&&h.push(`height="${n}"`)}return{href:f,dimensions:h}}e.$$j=d}),define(pe[166],be([1,0,18,40,7,3,19,17]),function(ue,e,D,R,r,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=void 0;function v(s,t){const{os:a,tildify:$,relative:w}=t;if(w){const L=b(s,w,a);if(typeof L=="string")return L}let k=s.fsPath;if(a===1&&!I.$j?k=k.replace(/\//g,"\\"):a!==1&&I.$j&&(k=k.replace(/\\/g,"/")),a!==1&&$?.userHome){const L=$.userHome.fsPath;let j;s.scheme!==$.userHome.scheme&&s.path.startsWith(r.$gc.sep)?j=$.userHome.with({path:s.path}).fsPath:j=s.fsPath,k=y(j,L,a)}return(a===1?r.$fc:r.$gc).normalize(A(k,a===1))}e.$vv=v;function b(s,t,a){const $=a===1?r.$fc:r.$gc,w=a===3?P.$mg:P.$og,k=t.getWorkspace(),E=(0,D.$Ob)(k.folders);if(!E)return;s.scheme!==E.uri.scheme&&s.path.startsWith(r.$gc.sep)&&(s=E.uri.with({path:s.path}));const L=t.getWorkspaceFolder(s);if(!L)return;let j;if(w.isEqual(L.uri,s)?j="":j=w.relativePath(L.uri,s)??"",j&&(j=$.normalize(j)),k.folders.length>1&&!t.noPrefix){const x=L.name?L.name:w.basenameOrAuthority(L.uri);j=j?`${x} \u2022 ${j}`:x}return j}function A(s,t=I.$j){return(0,R.$3f)(s,t)?s.charAt(0).toUpperCase()+s.slice(1):s}e.$wv=A;let S=Object.create(null);function y(s,t,a=I.OS){if(a===1||!s||!t)return s;let $=S.original===t?S.normalized:void 0;$||($=t,I.$j&&($=(0,R.$Sf)($)),$=`${(0,C.$Le)($,r.$gc.sep)}${r.$gc.sep}`,S={original:t,normalized:$});let w=s;return I.$j&&(w=(0,R.$Sf)(w)),(a===3?w.startsWith($):(0,C.$4e)(w,$))?`~/${w.substr($.length)}`:s}e.$xv=y;function u(s,t){return s.replace(/^~($|\/|\\)/,`${t}$1`)}e.$yv=u;const g="\u2026",d="\\\\",f="~";function h(s,t=r.sep){const a=new Array(s.length);let $=!1;for(let w=0;w<s.length;w++){const k=s[w];if(k===""){a[w]=`.${t}`;continue}if(!k){a[w]=k;continue}$=!0;let E="",L=k;L.indexOf(d)===0?(E=L.substr(0,L.indexOf(d)+d.length),L=L.substr(L.indexOf(d)+d.length)):L.indexOf(t)===0?(E=L.substr(0,L.indexOf(t)+t.length),L=L.substr(L.indexOf(t)+t.length)):L.indexOf(f)===0&&(E=L.substr(0,L.indexOf(f)+f.length),L=L.substr(L.indexOf(f)+f.length));const j=L.split(t);for(let x=1;$&&x<=j.length;x++)for(let ce=j.length-x;$&&ce>=0;ce--){$=!1;let X=j.slice(ce,ce+x).join(t);for(let ie=0;!$&&ie<s.length;ie++)if(ie!==w&&s[ie]&&s[ie].indexOf(X)>-1){const he=ce+x===j.length,_=ce>0&&s[ie].indexOf(t)>-1?t+X:X,de=s[ie].endsWith(_);$=!he||de}if(!$){let ie="";(j[0].endsWith(":")||E!=="")&&(ce===1&&(ce=0,x++,X=j[0]+t+X),ce>0&&(ie=j[0]+t),ie=E+ie),ce>0&&(ie=ie+g+t),ie=ie+X,ce+x<j.length&&(ie=ie+t+g),a[w]=ie}}$&&(a[w]=k)}return a}e.$zv=h;var p;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function l(s,t=Object.create(null)){const a=[];let $=!1,w="";for(const k of s)if(k==="$"||$&&k==="{")w&&a.push({value:w,type:p.TEXT}),w="",$=!0;else if(k==="}"&&$){const E=t[w];if(typeof E=="string")E.length&&a.push({value:E,type:p.VARIABLE});else if(E){const L=a[a.length-1];(!L||L.type!==p.SEPARATOR)&&a.push({value:E.label,type:p.SEPARATOR})}w="",$=!1}else w+=k;return w&&!$&&a.push({value:w,type:p.TEXT}),a.filter((k,E)=>{if(k.type===p.SEPARATOR){const L=a[E-1],j=a[E+1];return[L,j].every(x=>x&&(x.type===p.VARIABLE||x.type===p.TEXT)&&x.value.length>0)}return!0}).map(k=>k.value).join("")}e.$Av=l;function m(s,t){return I.$k||t?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.$k?"&":"&&"):s.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.$Bv=m;function c(s,t){return I.$k||t?s.replace(/\(&&\w\)|&&/g,""):I.$j?s.replace(/&&|&/g,a=>a==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.$Cv=c;function n(s){return s.replace(/&/g,"&&")}e.$Dv=n;function i(s){if(s.endsWith("]")){const t=s.lastIndexOf(" [",s.length-2);if(t!==-1){const a=o(s.substring(0,t));return{name:a.name,parentPath:a.parentPath+s.substring(t)}}}return o(s)}e.$Ev=i;function o(s){const t=s.indexOf("/")!==-1?r.$gc:r.$fc,a=t.basename(s),$=t.dirname(s);return a.length?{name:a,parentPath:$}:{name:$,parentPath:""}}}),define(pe[51],be([1,0,15,4]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=void 0;function r(S){return S.toJSON()}class I{constructor(y){this.a=y}transformIncoming(y){const u=this.a.transformIncoming(y);return u===y?y:r(R.URI.from(u))}transformOutgoing(y){const u=this.a.transformOutgoing(y);return u===y?y:r(R.URI.from(u))}transformOutgoingURI(y){const u=this.a.transformOutgoing(y);return u===y?y:R.URI.from(u)}transformOutgoingScheme(y){return this.a.transformOutgoingScheme(y)}}e.$Mm=I,e.$Nm=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function P(S,y,u){if(!S||u>200)return null;if(typeof S=="object"){if(S instanceof R.URI)return y.transformOutgoing(S);for(const g in S)if(Object.hasOwnProperty.call(S,g)){const d=P(S[g],y,u+1);d!==null&&(S[g]=d)}}return null}function C(S,y){const u=P(S,y,0);return u===null?S:u}e.$Om=C;function v(S,y,u,g){if(!S||g>200)return null;if(typeof S=="object"){if(S.$mid===1)return u?R.URI.revive(y.transformIncoming(S)):y.transformIncoming(S);if(S instanceof D.$ce)return null;for(const d in S)if(Object.hasOwnProperty.call(S,d)){const f=v(S[d],y,u,g+1);f!==null&&(S[d]=f)}}return null}function b(S,y){const u=v(S,y,!1,0);return u===null?S:u}e.$Pm=b;function A(S,y){const u=v(S,y,!0,0);return u===null?S:u}e.$Qm=A}),define(pe[101],be([1,0,28,62,23,152,3]),function(ue,e,D,R,r,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=void 0,e.$Sm=new class{c(y){return this.a||(this.a=R.$Wh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(y)}value(){if(this.b===void 0){let y=0,u=0;const g=(0,D.networkInterfaces)();for(const d in g){const f=g[d];if(f)for(const{mac:h,internal:p}of f)p||(u+=1,this.c(h.toUpperCase())&&(y+=1))}this.b=u>0?y/u:0}return this.b}};let C;async function v(y){return C||(C=(async()=>await b(y)||r.$fg())()),C}e.$Tm=v;async function b(y){try{const u=await new Promise((d,f)=>{ue(["crypto"],d,f)}),g=(0,I.$Rm)();return u.createHash("sha256").update(g,"utf8").digest("hex")}catch(u){y(u);return}}const A="Software\\Microsoft\\SQMClient";async function S(y){if(P.$j){const u=await new Promise((g,d)=>{ue(["@vscode/windows-registry"],g,d)});try{return u.GetStringRegKey("HKEY_LOCAL_MACHINE",A,"MachineId")||""}catch(g){return y(g),""}}return""}e.$Um=S}),define(pe[167],be([1,0,27,294,295,3]),function(ue,e,D,R,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=void 0;async function P(C){if(I.$k||I.$j)return;let v;for(const b of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{v=await(0,R.open)(b,D.constants.R_OK);break}catch{}if(!v){C("Unable to retrieve release information from known identifier paths.");return}try{const b=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),A={id:"unknown"};for await(const S of(0,r.createInterface)({input:v.createReadStream(),crlfDelay:1/0})){if(!S.includes("="))continue;const y=S.split("=")[0].toUpperCase().trim();if(b.has(y)){const u=S.split("=")[1].replace(/"/g,"").toLowerCase().trim();y==="ID"||y==="DISTRIB_ID"?A.id=u:y==="ID_LIKE"?A.id_like=u:(y==="VERSION_ID"||y==="DISTRIB_RELEASE")&&(A.version_id=u)}}return A}catch(b){C(b)}}e.$gg=P}),define(pe[21],be([1,0,27,28,296,14,40,97,7,3,19,4]),function(ue,e,D,R,r,I,P,C,v,b,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(_){_[_.UNLINK=0]="UNLINK",_[_.MOVE=1]="MOVE"})(y||(e.RimRafMode=y={}));async function u(_,de=y.UNLINK,Z){if((0,P.$2f)(_))throw new Error("rimraf - will refuse to recursively delete root");return de===y.UNLINK?d(_):g(_,Z)}async function g(_,de=(0,P.$7f)((0,R.tmpdir)())){try{try{await D.promises.rename(_,de)}catch(Z){return Z.code==="ENOENT"?void 0:d(_)}d(de).catch(Z=>{})}catch(Z){if(Z.code!=="ENOENT")throw Z}}async function d(_){return(0,r.promisify)(D.rm)(_,{recursive:!0,force:!0,maxRetries:3})}function f(_){if((0,P.$2f)(_))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(_,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function h(_,de){return m(await(de?p(_):(0,r.promisify)(D.readdir)(_)))}async function p(_){try{return await(0,r.promisify)(D.readdir)(_,{withFileTypes:!0})}catch(ne){console.warn("[node.js fs] readdir with filetypes failed with error: ",ne)}const de=[],Z=await h(_);for(const ne of Z){let J=!1,W=!1,oe=!1;try{const le=await e.Promises.lstat((0,v.$jc)(_,ne));J=le.isFile(),W=le.isDirectory(),oe=le.isSymbolicLink()}catch(le){console.warn("[node.js fs] unexpected error from lstat after readdir: ",le)}de.push({name:ne,isFile:()=>J,isDirectory:()=>W,isSymbolicLink:()=>oe})}return de}function l(_){return m(D.readdirSync(_))}e.readdirSync=l;function m(_){return _.map(de=>typeof de=="string"?b.$k?(0,C.$pl)(de):de:(de.name=b.$k?(0,C.$pl)(de.name):de.name,de))}async function c(_){const de=await h(_),Z=[];for(const ne of de)await i.existsDirectory((0,v.$jc)(_,ne))&&Z.push(ne);return Z}function n(_,de=1e3){return new Promise(Z=>{let ne=!1;const J=setInterval(()=>{ne||(ne=!0,D.access(_,W=>{ne=!1,W&&(clearInterval(J),Z(void 0))}))},de)})}e.whenDeleted=n;var i;(function(_){async function de(J){let W;try{if(W=await e.Promises.lstat(J),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(J),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(oe){if(oe.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(b.$j&&oe.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(J)),symbolicLink:{dangling:!1}}}catch(le){if(le.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw le}throw oe}}_.stat=de;async function Z(J){try{const{stat:W,symbolicLink:oe}=await _.stat(J);return W.isFile()&&oe?.dangling!==!0}catch{}return!1}_.existsFile=Z;async function ne(J){try{const{stat:W,symbolicLink:oe}=await _.stat(J);return W.isDirectory()&&oe?.dangling!==!0}catch{}return!1}_.existsDirectory=ne})(i||(e.SymlinkSupport=i={}));const o=new I.$4g;function s(_,de,Z){return o.queueFor(S.URI.file(_),A.$ng).queue(()=>{const ne=k(Z);return new Promise((J,W)=>$(_,de,ne,oe=>oe?W(oe):J()))})}let t=!0;function a(_){t=_}e.configureFlushOnWrite=a;function $(_,de,Z,ne){if(!t)return D.writeFile(_,de,{mode:Z.mode,flag:Z.flag},ne);D.open(_,Z.flag,Z.mode,(J,W)=>{if(J)return ne(J);D.writeFile(W,de,oe=>{if(oe)return D.close(W,()=>ne(oe));D.fdatasync(W,le=>(le&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",le),a(!1)),D.close(W,re=>ne(re))))})})}function w(_,de,Z){const ne=k(Z);if(!t)return D.writeFileSync(_,de,{mode:ne.mode,flag:ne.flag});const J=D.openSync(_,ne.flag,ne.mode);try{D.writeFileSync(J,de);try{D.fdatasyncSync(J)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),a(!1)}}finally{D.closeSync(J)}}e.writeFileSync=w;function k(_){return _?{mode:typeof _.mode=="number"?_.mode:438,flag:typeof _.flag=="string"?_.flag:"w"}:{mode:438,flag:"w"}}async function E(_,de,Z=6e4){if(_!==de)try{b.$j&&typeof Z=="number"?await L(_,de,Date.now(),Z):await(0,r.promisify)(D.rename)(_,de)}catch(ne){if(_.toLowerCase()!==de.toLowerCase()&&ne.code==="EXDEV"||_.endsWith("."))await j(_,de,{preserveSymlinks:!1}),await u(_,y.MOVE);else throw ne}}async function L(_,de,Z,ne,J=0){try{return await(0,r.promisify)(D.rename)(_,de)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-Z>=ne)throw console.error(`[node.js fs] rename failed after ${J} retries with error: ${W}`),W;if(J===0){let oe=!1;try{const{stat:le}=await i.stat(de);le.isFile()||(oe=!0)}catch{}if(oe)throw W}return await(0,I.$Vg)(Math.min(100,J*10)),L(_,de,Z,ne,J+1)}}async function j(_,de,Z){return ce(_,de,{root:{source:_,target:de},options:Z,handledSourcePaths:new Set})}const x=511;async function ce(_,de,Z){if(Z.handledSourcePaths.has(_))return;Z.handledSourcePaths.add(_);const{stat:ne,symbolicLink:J}=await i.stat(_);if(J){if(Z.options.preserveSymlinks)try{return await he(_,de,Z)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if(J.dangling)return}return ne.isDirectory()?X(_,de,ne.mode&x,Z):ie(_,de,ne.mode&x)}async function X(_,de,Z,ne){await e.Promises.mkdir(de,{recursive:!0,mode:Z});const J=await h(_);for(const W of J)await ce((0,v.$jc)(_,W),(0,v.$jc)(de,W),ne)}async function ie(_,de,Z){await e.Promises.copyFile(_,de),await e.Promises.chmod(de,Z)}async function he(_,de,Z){let ne=await e.Promises.readlink(_);(0,P.$Yf)(ne,Z.root.source,!b.$l)&&(ne=(0,v.$jc)(Z.root.target,ne.substr(Z.root.source.length+1))),await e.Promises.symlink(ne,de)}e.Promises=new class{get access(){return(0,r.promisify)(D.access)}get stat(){return(0,r.promisify)(D.stat)}get lstat(){return(0,r.promisify)(D.lstat)}get utimes(){return(0,r.promisify)(D.utimes)}get read(){return(_,de,Z,ne,J)=>new Promise((W,oe)=>{D.read(_,de,Z,ne,J,(le,re,ee)=>le?oe(le):W({bytesRead:re,buffer:ee}))})}get readFile(){return(0,r.promisify)(D.readFile)}get write(){return(_,de,Z,ne,J)=>new Promise((W,oe)=>{D.write(_,de,Z,ne,J,(le,re,ee)=>le?oe(le):W({bytesWritten:re,buffer:ee}))})}get appendFile(){return(0,r.promisify)(D.appendFile)}get fdatasync(){return(0,r.promisify)(D.fdatasync)}get truncate(){return(0,r.promisify)(D.truncate)}get copyFile(){return(0,r.promisify)(D.copyFile)}get open(){return(0,r.promisify)(D.open)}get close(){return(0,r.promisify)(D.close)}get symlink(){return(0,r.promisify)(D.symlink)}get readlink(){return(0,r.promisify)(D.readlink)}get chmod(){return(0,r.promisify)(D.chmod)}get mkdir(){return(0,r.promisify)(D.mkdir)}get unlink(){return(0,r.promisify)(D.unlink)}get rmdir(){return(0,r.promisify)(D.rmdir)}get realpath(){return(0,r.promisify)(D.realpath)}async exists(_){try{return await e.Promises.access(_),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return c}get writeFile(){return s}get rm(){return u}get rename(){return E}get copy(){return j}}}),define(pe[168],be([1,0,27,7,3,17,21]),function(ue,e,D,R,r,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=e.$0p=e.$9p=void 0;function C(y){if(r.$l)return y;const u=(0,R.$mc)(y);if(y===u)return y;const g=((0,R.$nc)(y)||y).toLowerCase();try{const f=(0,P.readdirSync)(u).filter(h=>h.toLowerCase()===g);if(f.length===1){const h=C(u);if(h)return(0,R.$jc)(h,f[0])}else if(f.length>1){const h=f.indexOf(g);if(h>=0){const p=C(u);if(p)return(0,R.$jc)(p,f[h])}}}catch{}return null}e.$9p=C;async function v(y){if(r.$l)return y;const u=(0,R.$mc)(y);if(y===u)return y;const g=((0,R.$nc)(y)||y).toLowerCase();try{const f=(await P.Promises.readdir(u)).filter(h=>h.toLowerCase()===g);if(f.length===1){const h=await v(u);if(h)return(0,R.$jc)(h,f[0])}else if(f.length>1){const h=f.indexOf(g);if(h>=0){const p=await v(u);if(p)return(0,R.$jc)(p,f[h])}}}catch{}return null}e.$0p=v;async function b(y){try{return await P.Promises.realpath(y)}catch{const g=S(y);return await P.Promises.access(g,D.constants.R_OK),g}}e.$$p=b;function A(y){try{return D.realpathSync(y)}catch{const g=S(y);return D.accessSync(g,D.constants.R_OK),g}}e.$_p=A;function S(y){return(0,I.$Le)((0,R.$hc)(y),R.sep)}}),define(pe[102],be([1,0,28,7,21]),function(ue,e,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=e.$yl=void 0;const I=/^\d+$/,P=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var v;(function(m){m[m.x64=0]="x64",m[m.x86=1]="x86",m[m.ARM=2]="ARM"})(v||(v={}));let b;switch(process.arch){case"ia32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let A;process.env.PROCESSOR_ARCHITEW6432?A=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?A=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?A=1:A=0;class S{constructor(c,n,i){this.exePath=c,this.displayName=n,this.a=i}async exists(){return this.a===void 0&&(this.a=await r.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:m=!1}={}){return m?b===0?process.env["ProgramFiles(x86)"]||null:A===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function u({useAlternateBitness:m=!1,findPreview:c=!1}={}){const n=y({useAlternateBitness:m});if(!n)return null;const i=R.$jc(n,"PowerShell");if(!await r.SymlinkSupport.existsDirectory(i))return null;let o=-1,s=null;for(const $ of await r.Promises.readdir(i)){let w=-1;if(c){const E=$.indexOf("-");if(E<0)continue;const L=$.substring(0,E);if(!I.test(L)||$.substring(E+1)!=="preview")continue;w=parseInt(L,10)}else{if(!I.test($))continue;w=parseInt($,10)}if(w<=o)continue;const k=R.$jc(i,$,"pwsh.exe");await r.SymlinkSupport.existsFile(k)&&(s=k,o=w)}if(!s)return null;const t=n.includes("x86")?" (x86)":"",a=c?" Preview":"";return new S(s,`PowerShell${a}${t}`,!0)}async function g({findPreview:m}={}){if(!process.env.LOCALAPPDATA)return null;const c=R.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await r.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:n,pwshMsixName:i}=m?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:P,pwshMsixName:"PowerShell (Store)"};for(const o of await r.Promises.readdir(c))if(n.test(o)){const s=R.$jc(c,o,"pwsh.exe");return new S(s,i)}return null}function d(){const m=R.$jc(D.homedir(),".dotnet","tools","pwsh.exe");return new S(m,".NET Core PowerShell Global Tool")}function f(){const m=R.$jc(process.env.windir,b===1&&A!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new S(m,"Windows PowerShell",!0)}async function*h(){let m=await u();m&&(yield m),m=await u({useAlternateBitness:!0}),m&&(yield m),m=await g(),m&&(yield m),m=d(),m&&(yield m),m=await u({findPreview:!0}),m&&(yield m),m=await g({findPreview:!0}),m&&(yield m),m=await u({useAlternateBitness:!0,findPreview:!0}),m&&(yield m),m=f(),m&&(yield m)}async function*p(){for await(const m of h())await m.exists()&&(yield m)}e.$yl=p;async function l(){for await(const m of p())return m;return null}e.$zl=l}),define(pe[103],be([1,0,7,3,29,64,10,21]),function(ue,e,D,R,r,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Dl=e.$Cl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function v(S=r.env){return S.comspec||"cmd.exe"}e.$Cl=v;function b(S){let y=[],u=!1;const g=function(d){if(u){y.push(d);return}(!S.send(d,h=>{if(h&&console.error(h),u=!1,y.length>0){const p=y.slice(0);y=[],p.forEach(l=>g(l))}})||R.$j)&&(u=!0)};return{send:g}}e.$Dl=b;var A;(function(S){async function y(u,g,d){if(D.$ic(u))return u;if(g===void 0&&(g=r.cwd()),D.$mc(u)!=="."||(d===void 0&&P.$zf(r.env.PATH)&&(d=r.env.PATH.split(D.$tc)),d===void 0||d.length===0))return D.$jc(g,u);async function h(p){if(await C.Promises.exists(p)){let l;try{l=await C.Promises.stat(p)}catch(m){m.message.startsWith("EACCES")&&(l=await C.Promises.lstat(p))}return l?!l.isDirectory():!1}return!1}for(const p of d){let l;if(D.$ic(p)?l=D.$jc(p,u):l=D.$jc(g,p,u),await h(l))return l;let m=l+".com";if(await h(m)||(m=l+".exe",await h(m)))return m}return D.$jc(g,u)}S.findExecutable=y})(A||(e.win32=A={}))}),define(pe[104],be([1,0,52,12]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=void 0;function r(P){return new Promise((C,v)=>{let b;const A=new Map;function S(u,g,d,f,h){const p=A.get(g);if(u===P||p){const l={name:y(d),cmd:d,pid:u,ppid:g,load:f,mem:h};A.set(u,l),u===P&&(b=l),p&&(p.children||(p.children=[]),p.children.push(l),p.children.length>1&&(p.children=p.children.sort((m,c)=>m.pid-c.pid)))}}function y(u){const g=/--utility-sub-type=network/i,d=/--ms-enable-electron-run-as-node/i,f=/--crashes-directory/i,h=/\\pipe\\winpty-control/i,p=/conhost\.exe.+--headless/i,l=/--type=([a-zA-Z-]+)/;if(f.exec(u))return"electron-crash-reporter";if(h.exec(u))return"winpty-agent";if(p.exec(u))return"conpty-agent";let m=l.exec(u);if(m&&m.length===2)return m[1]==="renderer"?"window":m[1]==="utility"?g.exec(u)?"utility-network-service":"utility-process":m[1]==="extensionHost"?"extension-host":m[1];const c=/[a-zA-Z-]+\.js/g;let n="";do m=c.exec(u),m&&(n+=m+" ");while(m);return n&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron-nodejs (${n})`:d.exec(u)?`electron-nodejs (${u})`:u}if(process.platform==="win32"){const u=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substring(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substring(5):g;new Promise((g,d)=>{ue(["@vscode/windows-process-tree"],g,d)}).then(g=>{g.getProcessList(P,d=>{if(!d){v(new Error(`Root process ${P} not found`));return}g.getProcessCpuUsage(d,f=>{const h=new Map;f.forEach(p=>{const l=u(p.commandLine||"");h.set(p.pid,{name:y(l),cmd:l,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),b=h.get(P),b?(h.forEach(p=>{const l=h.get(p.ppid);l&&(l.children||(l.children=[]),l.children.push(p))}),h.forEach(p=>{p.children&&(p.children=p.children.sort((l,m)=>l.pid-m.pid))}),C(b)):v(new Error(`Root process ${P} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let u=function(){let g=[b];const d=[];for(;g.length;){const h=g.shift();h&&(d.push(h.pid),h.children&&(g=g.concat(h.children)))}let f=JSON.stringify(R.$dg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);f+=" "+d.join(" "),(0,D.exec)(f,{},(h,p,l)=>{if(h||l)v(h||new Error(l.toString()));else{const m=p.toString().split(`
`);for(let c=0;c<d.length;c++){const n=A.get(d[c]);n.load=parseFloat(m[c])}if(!b){v(new Error(`Root process ${P} not found`));return}C(b)}})};(0,D.exec)("which ps",{},(g,d,f)=>{if(g||f)if(process.platform!=="linux")v(g||new Error(f.toString()));else{const h=JSON.stringify(R.$dg.asFileUri("vs/base/node/ps.sh").fsPath);(0,D.exec)(h,{},(p,l,m)=>{p||m?v(p||new Error(m.toString())):(I(l,S),u())})}else{const h=d.toString().trim(),p="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${h} ${p}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,m,c)=>{l||c&&!c.includes("screen size is bogus")?v(l||new Error(c.toString())):(I(m,S),process.platform==="linux"?u():b?C(b):v(new Error(`Root process ${P} not found`)))})}})}})}e.$Gr=r;function I(P,C){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=P.toString().split(`
`);for(const A of b){const S=v.exec(A.trim());S&&S.length===6&&C(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}}),define(pe[105],be([1,0,28,3,102,103]),function(ue,e,D,R,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=void 0;async function P(S,y){return S===1?R.$j?A():I.$Cl(y):v(S,y)}e.$El=P;let C=null;function v(S,y){if(R.$l&&S===2||R.$k&&S===3)return"/bin/bash";if(!C){let u;if(R.$j)u="/bin/bash";else{if(u=y.SHELL,!u)try{u=(0,D.userInfo)().shell}catch{}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}C=u}return C}let b=null;async function A(){return b||(b=(await(0,r.$zl)()).exePath),b}});var Oe=this&&this.__decorate||function(ue,e,D,R){var r=arguments.length,I=r<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,D):R,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(ue,e,D,R);else for(var C=ue.length-1;C>=0;C--)(P=ue[C])&&(I=(r<3?P(I):r>3?P(e,D,I):P(e,D))||I);return r>3&&I&&Object.defineProperty(e,D,I),I};define(pe[43],be([1,0,18,14,15,20,73,11,5,2,50,17,10]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.ProxyChannel=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.RequestInitiator=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=void 0;var u;(function(J){J[J.Promise=100]="Promise",J[J.PromiseCancel=101]="PromiseCancel",J[J.EventListen=102]="EventListen",J[J.EventDispose=103]="EventDispose"})(u||(u={}));function g(J){switch(J){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(J){J[J.Initialize=200]="Initialize",J[J.PromiseSuccess=201]="PromiseSuccess",J[J.PromiseError=202]="PromiseError",J[J.PromiseErrorObj=203]="PromiseErrorObj",J[J.EventFire=204]="EventFire"})(d||(d={}));function f(J){switch(J){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(J){J[J.Uninitialized=0]="Uninitialized",J[J.Idle=1]="Idle"})(h||(h={}));function p(J){let W=0;for(let oe=0;;oe+=7){const le=J.read(1);if(W|=(le.buffer[0]&127)<<oe,!(le.buffer[0]&128))return W}}const l=o(0);function m(J,W){if(W===0){J.write(l);return}let oe=0;for(let re=W;re!==0;re=re>>>7)oe++;const le=r.$ce.alloc(oe);for(let re=0;W!==0;re++)le.buffer[re]=W&127,W=W>>>7,W>0&&(le.buffer[re]|=128);J.write(le)}class c{constructor(W){this.b=W,this.a=0}read(W){const oe=this.b.slice(this.a,this.a+W);return this.a+=oe.byteLength,oe}}e.$oh=c;class n{constructor(){this.a=[]}get buffer(){return r.$ce.concat(this.a)}write(W){this.a.push(W)}}e.$ph=n;var i;(function(J){J[J.Undefined=0]="Undefined",J[J.String=1]="String",J[J.Buffer=2]="Buffer",J[J.VSBuffer=3]="VSBuffer",J[J.Array=4]="Array",J[J.Object=5]="Object",J[J.Int=6]="Int"})(i||(i={}));function o(J){const W=r.$ce.alloc(1);return W.writeUInt8(J,0),W}const s={Undefined:o(i.Undefined),String:o(i.String),Buffer:o(i.Buffer),VSBuffer:o(i.VSBuffer),Array:o(i.Array),Object:o(i.Object),Uint:o(i.Int)},t=typeof Buffer<"u";function a(J,W){if(typeof W>"u")J.write(s.Undefined);else if(typeof W=="string"){const oe=r.$ce.fromString(W);J.write(s.String),m(J,oe.byteLength),J.write(oe)}else if(t&&Buffer.isBuffer(W)){const oe=r.$ce.wrap(W);J.write(s.Buffer),m(J,oe.byteLength),J.write(oe)}else if(W instanceof r.$ce)J.write(s.VSBuffer),m(J,W.byteLength),J.write(W);else if(Array.isArray(W)){J.write(s.Array),m(J,W.length);for(const oe of W)a(J,oe)}else if(typeof W=="number"&&(W|0)===W)J.write(s.Uint),m(J,W);else{const oe=r.$ce.fromString(JSON.stringify(W));J.write(s.Object),m(J,oe.byteLength),J.write(oe)}}e.$qh=a;function $(J){switch(J.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return J.read(p(J)).toString();case i.Buffer:return J.read(p(J)).buffer;case i.VSBuffer:return J.read(p(J));case i.Array:{const oe=p(J),le=[];for(let re=0;re<oe;re++)le.push($(J));return le}case i.Object:return JSON.parse(J.read(p(J)).toString());case i.Int:return p(J)}}e.$rh=$;class w{constructor(W,oe,le=null,re=1e3){this.h=W,this.j=oe,this.k=le,this.l=re,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ee=>this.q(ee)),this.m({type:200})}registerChannel(W,oe){this.b.set(W,oe),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case 200:{const oe=this.o([W.type]);this.k?.logOutgoing(oe,0,1,f(W.type));return}case 201:case 202:case 204:case 203:{const oe=this.o([W.type,W.id],W.data);this.k?.logOutgoing(oe,W.id,1,f(W.type),W.data);return}}}o(W,oe=void 0){const le=new n;return a(le,W),a(le,oe),this.p(le.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const oe=new c(W),le=$(oe),re=$(oe),ee=le[0];switch(ee){case 100:return this.k?.logIncoming(W.byteLength,le[1],1,`${g(ee)}: ${le[2]}.${le[3]}`,re),this.s({type:ee,id:le[1],channelName:le[2],name:le[3],arg:re});case 102:return this.k?.logIncoming(W.byteLength,le[1],1,`${g(ee)}: ${le[2]}.${le[3]}`,re),this.t({type:ee,id:le[1],channelName:le[2],name:le[3],arg:re});case 101:return this.k?.logIncoming(W.byteLength,le[1],1,`${g(ee)}`),this.u({type:ee,id:le[1]});case 103:return this.k?.logIncoming(W.byteLength,le[1],1,`${g(ee)}`),this.u({type:ee,id:le[1]})}}s(W){const oe=this.b.get(W.channelName);if(!oe){this.v(W);return}const le=new I.$Yd;let re;try{re=oe.call(this.j,W.name,W.arg,le.token)}catch(K){re=Promise.reject(K)}const ee=W.id;re.then(K=>{this.m({id:ee,data:K,type:201})},K=>{K instanceof Error?this.m({id:ee,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:ee,data:K,type:203})}).finally(()=>{B.dispose(),this.d.delete(W.id)});const B=(0,b.$Qc)(()=>le.cancel());this.d.set(W.id,B)}t(W){const oe=this.b.get(W.channelName);if(!oe){this.v(W);return}const le=W.id,ee=oe.listen(this.j,W.name,W.arg)(B=>this.m({id:le,data:B,type:204}));this.d.set(W.id,ee)}u(W){const oe=this.d.get(W.id);oe&&(oe.dispose(),this.d.delete(W.id))}v(W){let oe=this.g.get(W.channelName);oe||(oe=[],this.g.set(W.channelName,oe));const le=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);oe.push({request:W,timeoutTimer:le})}w(W){const oe=this.g.get(W);if(oe){for(const le of oe)switch(clearTimeout(le.timeoutTimer),le.request.type){case 100:this.s(le.request);break;case 102:this.t(le.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.$Nc)(this.d.values()),this.d.clear()}}e.$sh=w;var k;(function(J){J[J.LocalSide=0]="LocalSide",J[J.OtherSide=1]="OtherSide"})(k||(e.RequestInitiator=k={}));class E{constructor(W,oe=null){this.l=W,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new v.$Od,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(le=>this.s(le)),this.j=oe}getChannel(W){const oe=this;return{call(le,re,ee){return oe.a?Promise.reject(new C.$5):oe.m(W,le,re,ee)},listen(le,re){return oe.a?v.Event.None:oe.o(W,le,re)}}}m(W,oe,le,re=I.CancellationToken.None){const ee=this.g++,K={id:ee,type:100,channelName:W,name:oe,arg:le};if(re.isCancellationRequested)return Promise.reject(new C.$5);let N;return new Promise((U,T)=>{if(re.isCancellationRequested)return T(new C.$5);const q=()=>{const Y=V=>{switch(V.type){case 201:this.f.delete(ee),U(V.data);break;case 202:{this.f.delete(ee);const Q=new Error(V.data.message);Q.stack=Array.isArray(V.data.stack)?V.data.stack.join(`
`):V.data.stack,Q.name=V.data.name,T(Q);break}case 203:this.f.delete(ee),T(V.data);break}};this.f.set(ee,Y),this.p(K)};let z=null;this.b===h.Idle?q():(z=(0,R.$Ig)(Y=>this.u()),z.then(()=>{z=null,q()}));const te=()=>{z?(z.cancel(),z=null):this.p({id:ee,type:101}),T(new C.$5)},H=re.onCancellationRequested(te);N=(0,b.$Pc)((0,b.$Qc)(te),H),this.d.add(N)}).finally(()=>{N.dispose(),this.d.delete(N)})}o(W,oe,le){const re=this.g++,B={id:re,type:102,channelName:W,name:oe,arg:le};let K=null;const N=new v.$Od({onWillAddFirstListener:()=>{K=(0,R.$Ig)(U=>this.u()),K.then(()=>{K=null,this.d.add(N),this.p(B)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(N),this.p({id:re,type:103}))}}),O=U=>N.fire(U.data);return this.f.set(re,O),N.event}p(W){switch(W.type){case 100:case 102:{const oe=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(oe,W.id,0,`${g(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const oe=this.q([W.type,W.id]);this.j?.logOutgoing(oe,W.id,0,g(W.type));return}}}q(W,oe=void 0){const le=new n;return a(le,W),a(le,oe),this.r(le.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const oe=new c(W),le=$(oe),re=$(oe),ee=le[0];switch(ee){case 200:return this.j?.logIncoming(W.byteLength,0,0,f(ee)),this.t({type:le[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(W.byteLength,le[1],0,f(ee),re),this.t({type:le[0],id:le[1],data:re})}}t(W){if(W.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.$Nc)(this.d.values()),this.d.clear()}}e.$th=E,Oe([P.$ih],E.prototype,"onDidInitializePromise",null);class L{get connections(){const W=[];return this.f.forEach(oe=>W.push(oe)),W}constructor(W){this.a=new Map,this.f=new Set,this.g=new v.$Od,this.onDidAddConnection=this.g.event,this.h=new v.$Od,this.onDidRemoveConnection=this.h.event,this.j=new b.$Rc,this.j.add(W(({protocol:oe,onDidClientDisconnect:le})=>{const re=v.Event.once(oe.onMessage);this.j.add(re(ee=>{const B=new c(ee),K=$(B),N=new w(oe,K),O=new E(oe);this.a.forEach((T,q)=>N.registerChannel(q,T));const U={channelServer:N,channelClient:O,ctx:K};this.f.add(U),this.g.fire(U),this.j.add(le(()=>{N.dispose(),O.dispose(),this.f.delete(U),this.h.fire(U)}))}))}))}getChannel(W,oe){const le=this;return{call(re,ee,B){let K;if((0,y.$Nf)(oe)){const O=(0,D.$4b)(le.connections.filter(oe));K=O?Promise.resolve(O):v.Event.toPromise(v.Event.filter(le.onDidAddConnection,oe))}else K=oe.routeCall(le,re,ee);const N=K.then(O=>O.channelClient.getChannel(W));return x(N).call(re,ee,B)},listen(re,ee){if((0,y.$Nf)(oe))return le.k(W,oe,re,ee);const B=oe.routeEvent(le,re,ee).then(K=>K.channelClient.getChannel(W));return x(B).listen(re,ee)}}}k(W,oe,le,re){const ee=this;let B;const K=new v.$Od({onWillAddFirstListener:()=>{B=new b.$Rc;const N=new v.$Ud,O=new Map,U=q=>{const te=q.channelClient.getChannel(W).listen(le,re),H=N.add(te);O.set(q,H)},T=q=>{const z=O.get(q);z&&(z.dispose(),O.delete(q))};ee.connections.filter(oe).forEach(U),v.Event.filter(ee.onDidAddConnection,oe)(U,void 0,B),ee.onDidRemoveConnection(T,void 0,B),N.event(K.fire,K,B),B.add(N)},onDidRemoveLastListener:()=>{B?.dispose(),B=void 0}});return K.event}registerChannel(W,oe){this.a.set(W,oe);for(const le of this.f)le.channelServer.registerChannel(W,oe)}dispose(){this.j.dispose();for(const W of this.f)W.channelClient.dispose(),W.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$uh=L;class j{constructor(W,oe,le=null){const re=new n;a(re,oe),W.send(re.buffer),this.a=new E(W,le),this.d=new w(W,oe,le)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,oe){this.d.registerChannel(W,oe)}dispose(){this.a.dispose(),this.d.dispose()}}e.$vh=j;function x(J){return{call(W,oe,le){return J.then(re=>re.call(W,oe,le))},listen(W,oe){const le=new v.$Xd;return J.then(re=>le.input=re.listen(W,oe)),le.event}}}e.$wh=x;function ce(J){let W=!1;return{call(oe,le,re){return W?J.call(oe,le,re):(0,R.$Vg)(0).then(()=>W=!0).then(()=>J.call(oe,le,re))},listen(oe,le){if(W)return J.listen(oe,le);const re=new v.$Xd;return(0,R.$Vg)(0).then(()=>W=!0).then(()=>re.input=J.listen(oe,le)),re.event}}}e.$xh=ce;class X{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const oe of W.connections)if(await Promise.resolve(this.a(oe.ctx)))return Promise.resolve(oe);return await v.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.$yh=X;var ie;(function(J){function W(ee,B,K){const N=ee,O=K&&K.disableMarshalling,U=new Map;for(const T in N)le(T)&&U.set(T,v.Event.buffer(N[T],!0,void 0,B));return new class{listen(T,q,z){const te=U.get(q);if(te)return te;if(re(q)){const H=N[q];if(typeof H=="function")return H.call(N,z)}throw new C.$bb(`Event not found: ${q}`)}call(T,q,z){const te=N[q];if(typeof te=="function"){if(!O&&Array.isArray(z))for(let Y=0;Y<z.length;Y++)z[Y]=(0,A.$nh)(z[Y]);let H=te.apply(N,z);return H instanceof Promise||(H=Promise.resolve(H)),H}throw new C.$bb(`Method not found: ${q}`)}}}J.fromService=W;function oe(ee,B){const K=B&&B.disableMarshalling;return new Proxy({},{get(N,O){if(typeof O=="string")return B?.properties?.has(O)?B.properties.get(O):re(O)?function(U){return ee.listen(O,U)}:le(O)?ee.listen(O):async function(...U){let T;B&&!(0,y.$If)(B.context)?T=[B.context,...U]:T=U;const q=await ee.call(O,T);return K?q:(0,A.$nh)(q)};throw new C.$bb(`Property not found: ${String(O)}`)}})}J.toService=oe;function le(ee){return ee[0]==="o"&&ee[1]==="n"&&S.$2e(ee.charCodeAt(2))}function re(ee){return/^onDynamic/.test(ee)&&S.$2e(ee.charCodeAt(9))}})(ie||(e.ProxyChannel=ie={}));const he=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function _(J){if(Array.isArray(J))return J;if(J&&typeof J=="object"&&typeof J.toString=="function"){const W=J.toString();if(W!=="[object Object]")return W}return J}function de(J){return Array.isArray(J)?J.map(_):_(J)}function Z(J,W,oe,le,re,ee,B){B=de(B);const K=he[re],N=K[le%K.length];let O=[`%c[${J}]%c[${String(W).padStart(7," ")}]%c[len: ${String(oe).padStart(5," ")}]%c${String(le).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(ee)?(O=O.concat(B),O.push(")")):O.push(B),console.log.apply(console,O)}class ne{constructor(W,oe){this.d=W,this.f=oe,this.a=0,this.b=0}logOutgoing(W,oe,le,re,ee){this.b+=W,Z(this.d,this.b,W,oe,le,re,ee)}logIncoming(W,oe,le,re,ee){this.a+=W,Z(this.f,this.a,W,oe,le,re,ee)}}e.$zh=ne}),define(pe[106],be([1,0,15,5,2,43]),function(ue,e,D,R,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.ProtocolConstants=e.$Ah=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(P||(e.SocketDiagnosticsEventType=P={}));var C;(function(s){s.enableDiagnostics=!1,s.records=[];const t=new WeakMap;let a=0;function $(k,E){if(!t.has(k)){const L=String(++a);t.set(k,L)}return t.get(k)}function w(k,E,L,j){if(!s.enableDiagnostics)return;const x=$(k,E);if(j instanceof D.$ce||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const ce=D.$ce.alloc(j.byteLength);ce.set(j),s.records.push({timestamp:Date.now(),id:x,label:E,type:L,buff:ce})}else s.records.push({timestamp:Date.now(),id:x,label:E,type:L,data:j})}s.traceSocketEvent=w})(C||(e.SocketDiagnostics=C={}));var v;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v||(e.SocketCloseEventType=v={}));let b=null;function A(){return b||(b=D.$ce.alloc(0)),b}class S{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,a){if(t===0)return A();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const E=this.a[0];return a&&(this.a.shift(),this.b-=t),E}if(this.a[0].byteLength>t){const E=this.a[0].slice(0,t);return a&&(this.a[0]=this.a[0].slice(t),this.b-=t),E}const $=D.$ce.alloc(t);let w=0,k=0;for(;t>0;){const E=this.a[k];if(E.byteLength>t){const L=E.slice(0,t);$.set(L,w),w+=t,a&&(this.a[k]=E.slice(t),this.b-=t),t-=t}else $.set(E,w),w+=E.byteLength,a?(this.a.shift(),this.b-=E.byteLength):k++,t-=E.byteLength}return $}}e.$Ah=S;var y;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(y||(y={}));function u(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var g;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(g||(e.ProtocolConstants=g={}));class d{constructor(t,a,$,w){this.type=t,this.id=a,this.ack=$,this.data=w,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends r.$Sc{constructor(t){super(),this.f=this.B(new R.$Od),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new S,this.B(this.a.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const a=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=a.readUInt32BE(9),this.g.messageType=a.readUInt8(0),this.g.id=a.readUInt32BE(1),this.g.ack=a.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:u(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const $=this.g.messageType,w=this.g.id,k=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",a),this.f.fire(new d($,w,k,a)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=D.$ce.alloc(13);a.writeUInt8(t.type,0),a.writeUInt32BE(t.id,1),a.writeUInt32BE(t.ack,5),a.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:u(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(a,t.data)}g(t,a){const $=this.f===0;return this.d.push(t,a),this.f+=t.byteLength+a.byteLength,$}h(){const t=D.$ce.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,a){this.g(t,a)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class p extends r.$Sc{constructor(t){super(),this.f=new R.$Od,this.onMessage=this.f.event,this.g=new R.$Od,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new h(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(a=>{a.type===1&&this.f.fire(a.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new d(1,0,0,t))}}e.$Bh=p;class l extends I.$vh{static fromSocket(t,a){return new l(new p(t),a)}get onDidDispose(){return this.b.onDidDispose}constructor(t,a,$=null){super(t,a,$),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$Ch=l;class m{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new R.$Od({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$Dh=m;class c{constructor(t){this.data=t,this.next=null}}class n{constructor(){this.a=null,this.b=null}length(){let t=0,a=this.a;for(;a;)a=a.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let a=0,$=this.a;for(;$;)t[a++]=$.data,$=$.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const a=new c(t);if(!this.a){this.a=a,this.b=a;return}this.b.next=a,this.b=a}}class i{static{this.a=10}static{this.b=null}static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const t=Date.now();for(let a=0;a<i.a;a++)this.c[a]=t-1e3*a;setInterval(()=>{for(let a=i.a;a>=1;a--)this.c[a]=this.c[a-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),a=(1+i.a)*1e3;let $=0;for(let w=0;w<i.a;w++)t-this.c[w]<=a&&$++;return 1-$/i.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new m,this.onControlMessage=this.u.event,this.v=new m,this.onMessage=this.v.event,this.w=new m,this.onDidDispose=this.w.event,this.x=new m,this.onSocketClose=this.x.event,this.y=new m,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??i.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new n,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new r.$Rc,this.o=t.socket,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new d(5,0,0,A());this.p.write(t),this.p.flush()}sendPause(){const t=new d(7,0,0,A());this.p.write(t)}sendResume(){const t=new d(8,0,0,A());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,a){this.a=!0,this.r.dispose(),this.r=new r.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage($=>this.z($))),this.r.add(this.o.onClose($=>this.x.fire($))),this.q.acceptChunk(a)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new d(3,0,this.h,A());this.p.write(t);const a=this.b.toArray();for(let $=0,w=a.length;$<w;$++)this.p.write(a[$]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const a=this.b.peek();if(a&&a.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const a=Date.now();a-this.m>1e4&&(this.m=a,this.p.write(new d(6,0,0,A())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const a=this.b.toArray();for(let $=0,w=a.length;$<w;$++)this.p.write(a[$]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const a=++this.c;this.h=this.g;const $=new d(1,a,this.h,t);this.b.push($),this.a||(this.p.write($),this.B())}sendControl(t){const a=new d(2,0,0,t);this.p.write(a)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),a=Date.now()-t.writtenTime,$=Date.now()-this.q.lastReadTime,w=Date.now()-this.n;if(a>=2e4&&$>=2e4&&w>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:$});return}const k=Math.max(2e4-a,2e4-$,2e4-w,500);this.f=setTimeout(()=>{this.f=null,this.B()},k)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new d(3,0,this.h,A());this.p.write(t)}D(){this.h=this.g;const t=new d(9,0,this.h,A());this.p.write(t)}}e.$Eh=o}),define(pe[107],be([1,0,52,14,15,20,164,11,5,2,22,103,64,43]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;class g extends u.$sh{constructor(h){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",p=>r.$ce.wrap(Buffer.from(p,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$6p=g;class d{constructor(h,p){this.i=h,this.j=p,this.c=new Set,this.g=new Map,this.h=new v.$Od,this.onDidProcessExit=this.h.event;const l=p&&p.timeout?p.timeout:6e4;this.b=new R.$Rg(l),this.d=null,this.f=null}getChannel(h){const p=this;return{call(l,m,c){return p.k(h,l,m,c)},listen(l,m){return p.l(h,l,m)}}}k(h,p,l,m=I.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(C.$6());this.b.cancel();const c=this.n(h),n=(0,R.$Ig)(s=>c.call(p,l,s)),i=m.onCancellationRequested(()=>n.cancel()),o=(0,b.$Qc)(()=>n.cancel());return this.c.add(o),n.finally(()=>{i.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(h,p,l){if(!this.b)return v.Event.None;this.b.cancel();let m;const c=new v.$Od({onWillAddFirstListener:()=>{m=this.n(h).listen(p,l)(c.fire,c),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return c.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,A.$8m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,y.$Bl)(p.env),this.d=(0,D.fork)(this.i,h,p);const l=new v.$Od;v.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,P.$2p)(t)){(0,P.log)(t,`IPC Library: ${this.j.serverName}`);return}l.fire(r.$ce.wrap(Buffer.from(t,"base64")))});const c=this.j.useQueue?(0,S.$Dl)(this.d):this.d,n=t=>this.d&&this.d.connected&&c.send(t.buffer.toString("base64")),i=l.event,o={send:n,onMessage:i};this.f=new u.$th(o);const s=()=>this.o();process.once("exit",s),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,a)=>{process.removeListener("exit",s),this.c.forEach($=>(0,b.$Nc)($)),this.c.clear(),t!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:a})})}return this.f}n(h){let p=this.g.get(h);return p||(p=this.m.getChannel(h),this.g.set(h,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$7p=d}),define(pe[169],be([1,0,14,5,2,50,10]),function(ue,e,D,R,r,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=e.$6o=e.StorageState=e.$5o=e.StorageHint=void 0;var C;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(C||(e.StorageHint=C={}));function v(y){const u=y;return u?.changed instanceof Map||u?.deleted instanceof Set}e.$5o=v;var b;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(b||(e.StorageState=b={}));class A extends r.$Sc{static{this.a=100}constructor(u,g=Object.create(null)){super(),this.r=u,this.s=g,this.b=this.B(new R.$Rd),this.onDidChangeStorage=this.b.event,this.c=b.None,this.f=new Map,this.g=this.B(new D.$Sg(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(u=>this.u(u)))}u(u){this.b.pause();try{u.changed?.forEach((g,d)=>this.w(d,g)),u.deleted?.forEach(g=>this.w(g,void 0))}finally{this.b.resume()}}w(u,g){if(this.c===b.Closed)return;let d=!1;(0,P.$If)(g)?d=this.f.delete(u):this.f.get(u)!==g&&(this.f.set(u,g),d=!0),d&&this.b.fire({key:u,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===b.None&&(this.c=b.Initialized,this.s.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(u,g){const d=this.f.get(u);return(0,P.$If)(d)?g:d}getBoolean(u,g){const d=this.get(u);return(0,P.$If)(d)?g:d==="true"}getNumber(u,g){const d=this.get(u);return(0,P.$If)(d)?g:parseInt(d,10)}getObject(u,g){const d=this.get(u);return(0,P.$If)(d)?g:(0,I.$mh)(d)}async set(u,g,d=!1){if(this.c===b.Closed)return;if((0,P.$If)(g))return this.delete(u,d);const f=(0,P.$Bf)(g)||Array.isArray(g)?(0,I.$lh)(g):String(g);if(this.f.get(u)!==f)return this.f.set(u,f),this.j.set(u,f),this.h.delete(u),this.b.fire({key:u,external:d}),this.D()}async delete(u,g=!1){if(!(this.c===b.Closed||!this.f.delete(u)))return this.h.has(u)||this.h.add(u),this.j.delete(u),this.b.fire({key:u,external:g}),this.D()}async optimize(){if(this.c!==b.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=b.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const u={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(u).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(u){if(this.z)return this.D(u)}async D(u){return this.s.hint===C.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),u)}async whenFlushed(){if(this.z)return new Promise(u=>this.n.push(u))}isInMemory(){return this.s.hint===C.STORAGE_IN_MEMORY}}e.$6o=A;class S{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(u){u.insert?.forEach((g,d)=>this.a.set(d,g)),u.delete?.forEach(g=>this.a.delete(g))}async optimize(){}async close(){}}e.$7o=S}),define(pe[170],be([8,9]),function(ue,e){return ue.create("vs/base/node/zip",e)}),define(pe[171],be([8,9]),function(ue,e){return ue.create("vs/editor/common/languages",e)}),define(pe[172],be([1,0,49,4,154,42,155,171]),function(ue,e,D,R,r,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$ot=e.$nt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$mt=e.$lt=e.SymbolKinds=e.SymbolTag=e.$kt=e.$jt=e.SymbolKind=e.$it=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$ht=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$gt=e.$ft=e.$et=void 0;class v{constructor(ie,he,_){this.offset=ie,this.type=he,this.language=_,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$et=v;class b{constructor(ie,he){this.tokens=ie,this.endState=he,this._tokenizationResultBrand=void 0}}e.$ft=b;class A{constructor(ie,he){this.tokens=ie,this.endState=he,this._encodedTokenizationResultBrand=void 0}}e.$gt=A;var S;(function(X){X[X.Method=0]="Method",X[X.Function=1]="Function",X[X.Constructor=2]="Constructor",X[X.Field=3]="Field",X[X.Variable=4]="Variable",X[X.Class=5]="Class",X[X.Struct=6]="Struct",X[X.Interface=7]="Interface",X[X.Module=8]="Module",X[X.Property=9]="Property",X[X.Event=10]="Event",X[X.Operator=11]="Operator",X[X.Unit=12]="Unit",X[X.Value=13]="Value",X[X.Constant=14]="Constant",X[X.Enum=15]="Enum",X[X.EnumMember=16]="EnumMember",X[X.Keyword=17]="Keyword",X[X.Text=18]="Text",X[X.Color=19]="Color",X[X.File=20]="File",X[X.Reference=21]="Reference",X[X.Customcolor=22]="Customcolor",X[X.Folder=23]="Folder",X[X.TypeParameter=24]="TypeParameter",X[X.User=25]="User",X[X.Issue=26]="Issue",X[X.Snippet=27]="Snippet"})(S||(e.CompletionItemKind=S={}));var y;(function(X){const ie=new Map;ie.set(0,D.$Vj.symbolMethod),ie.set(1,D.$Vj.symbolFunction),ie.set(2,D.$Vj.symbolConstructor),ie.set(3,D.$Vj.symbolField),ie.set(4,D.$Vj.symbolVariable),ie.set(5,D.$Vj.symbolClass),ie.set(6,D.$Vj.symbolStruct),ie.set(7,D.$Vj.symbolInterface),ie.set(8,D.$Vj.symbolModule),ie.set(9,D.$Vj.symbolProperty),ie.set(10,D.$Vj.symbolEvent),ie.set(11,D.$Vj.symbolOperator),ie.set(12,D.$Vj.symbolUnit),ie.set(13,D.$Vj.symbolValue),ie.set(15,D.$Vj.symbolEnum),ie.set(14,D.$Vj.symbolConstant),ie.set(15,D.$Vj.symbolEnum),ie.set(16,D.$Vj.symbolEnumMember),ie.set(17,D.$Vj.symbolKeyword),ie.set(27,D.$Vj.symbolSnippet),ie.set(18,D.$Vj.symbolText),ie.set(19,D.$Vj.symbolColor),ie.set(20,D.$Vj.symbolFile),ie.set(21,D.$Vj.symbolReference),ie.set(22,D.$Vj.symbolCustomColor),ie.set(23,D.$Vj.symbolFolder),ie.set(24,D.$Vj.symbolTypeParameter),ie.set(25,D.$Vj.account),ie.set(26,D.$Vj.issues);function he(Z){let ne=ie.get(Z);return ne||(console.info("No codicon found for CompletionItemKind "+Z),ne=D.$Vj.symbolProperty),ne}X.toIcon=he;const _=new Map;_.set("method",0),_.set("function",1),_.set("constructor",2),_.set("field",3),_.set("variable",4),_.set("class",5),_.set("struct",6),_.set("interface",7),_.set("module",8),_.set("property",9),_.set("event",10),_.set("operator",11),_.set("unit",12),_.set("value",13),_.set("constant",14),_.set("enum",15),_.set("enum-member",16),_.set("enumMember",16),_.set("keyword",17),_.set("snippet",27),_.set("text",18),_.set("color",19),_.set("file",20),_.set("reference",21),_.set("customcolor",22),_.set("folder",23),_.set("type-parameter",24),_.set("typeParameter",24),_.set("account",25),_.set("issue",26);function de(Z,ne){let J=_.get(Z);return typeof J>"u"&&!ne&&(J=9),J}X.fromString=de})(y||(e.CompletionItemKinds=y={}));var u;(function(X){X[X.Deprecated=1]="Deprecated"})(u||(e.CompletionItemTag=u={}));var g;(function(X){X[X.None=0]="None",X[X.KeepWhitespace=1]="KeepWhitespace",X[X.InsertAsSnippet=4]="InsertAsSnippet"})(g||(e.CompletionItemInsertTextRule=g={}));var d;(function(X){X[X.Invoke=0]="Invoke",X[X.TriggerCharacter=1]="TriggerCharacter",X[X.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d||(e.CompletionTriggerKind=d={}));var f;(function(X){X[X.Automatic=0]="Automatic",X[X.Explicit=1]="Explicit"})(f||(e.InlineCompletionTriggerKind=f={}));class h{constructor(ie,he,_,de){this.range=ie,this.text=he,this.completionKind=_,this.isSnippetText=de}equals(ie){return I.$xs.lift(this.range).equalsRange(ie.range)&&this.text===ie.text&&this.completionKind===ie.completionKind&&this.isSnippetText===ie.isSnippetText}}e.$ht=h;var p;(function(X){X[X.Invoke=1]="Invoke",X[X.Auto=2]="Auto"})(p||(e.CodeActionTriggerType=p={}));var l;(function(X){X[X.Invoke=1]="Invoke",X[X.TriggerCharacter=2]="TriggerCharacter",X[X.ContentChange=3]="ContentChange"})(l||(e.SignatureHelpTriggerKind=l={}));var m;(function(X){X[X.Text=0]="Text",X[X.Read=1]="Read",X[X.Write=2]="Write"})(m||(e.DocumentHighlightKind=m={}));function c(X){return X&&R.URI.isUri(X.uri)&&I.$xs.isIRange(X.range)&&(I.$xs.isIRange(X.originSelectionRange)||I.$xs.isIRange(X.targetSelectionRange))}e.$it=c;var n;(function(X){X[X.File=0]="File",X[X.Module=1]="Module",X[X.Namespace=2]="Namespace",X[X.Package=3]="Package",X[X.Class=4]="Class",X[X.Method=5]="Method",X[X.Property=6]="Property",X[X.Field=7]="Field",X[X.Constructor=8]="Constructor",X[X.Enum=9]="Enum",X[X.Interface=10]="Interface",X[X.Function=11]="Function",X[X.Variable=12]="Variable",X[X.Constant=13]="Constant",X[X.String=14]="String",X[X.Number=15]="Number",X[X.Boolean=16]="Boolean",X[X.Array=17]="Array",X[X.Object=18]="Object",X[X.Key=19]="Key",X[X.Null=20]="Null",X[X.EnumMember=21]="EnumMember",X[X.Struct=22]="Struct",X[X.Event=23]="Event",X[X.Operator=24]="Operator",X[X.TypeParameter=25]="TypeParameter"})(n||(e.SymbolKind=n={})),e.$jt={[17]:(0,C.localize)(0,null),[16]:(0,C.localize)(1,null),[4]:(0,C.localize)(2,null),[13]:(0,C.localize)(3,null),[8]:(0,C.localize)(4,null),[9]:(0,C.localize)(5,null),[21]:(0,C.localize)(6,null),[23]:(0,C.localize)(7,null),[7]:(0,C.localize)(8,null),[0]:(0,C.localize)(9,null),[11]:(0,C.localize)(10,null),[10]:(0,C.localize)(11,null),[19]:(0,C.localize)(12,null),[5]:(0,C.localize)(13,null),[1]:(0,C.localize)(14,null),[2]:(0,C.localize)(15,null),[20]:(0,C.localize)(16,null),[15]:(0,C.localize)(17,null),[18]:(0,C.localize)(18,null),[24]:(0,C.localize)(19,null),[3]:(0,C.localize)(20,null),[6]:(0,C.localize)(21,null),[14]:(0,C.localize)(22,null),[22]:(0,C.localize)(23,null),[25]:(0,C.localize)(24,null),[12]:(0,C.localize)(25,null)};function i(X,ie){return(0,C.localize)(26,null,X,e.$jt[ie])}e.$kt=i;var o;(function(X){X[X.Deprecated=1]="Deprecated"})(o||(e.SymbolTag=o={}));var s;(function(X){const ie=new Map;ie.set(0,D.$Vj.symbolFile),ie.set(1,D.$Vj.symbolModule),ie.set(2,D.$Vj.symbolNamespace),ie.set(3,D.$Vj.symbolPackage),ie.set(4,D.$Vj.symbolClass),ie.set(5,D.$Vj.symbolMethod),ie.set(6,D.$Vj.symbolProperty),ie.set(7,D.$Vj.symbolField),ie.set(8,D.$Vj.symbolConstructor),ie.set(9,D.$Vj.symbolEnum),ie.set(10,D.$Vj.symbolInterface),ie.set(11,D.$Vj.symbolFunction),ie.set(12,D.$Vj.symbolVariable),ie.set(13,D.$Vj.symbolConstant),ie.set(14,D.$Vj.symbolString),ie.set(15,D.$Vj.symbolNumber),ie.set(16,D.$Vj.symbolBoolean),ie.set(17,D.$Vj.symbolArray),ie.set(18,D.$Vj.symbolObject),ie.set(19,D.$Vj.symbolKey),ie.set(20,D.$Vj.symbolNull),ie.set(21,D.$Vj.symbolEnumMember),ie.set(22,D.$Vj.symbolStruct),ie.set(23,D.$Vj.symbolEvent),ie.set(24,D.$Vj.symbolOperator),ie.set(25,D.$Vj.symbolTypeParameter);function he(_){let de=ie.get(_);return de||(console.info("No codicon found for SymbolKind "+_),de=D.$Vj.symbolProperty),de}X.toIcon=he})(s||(e.SymbolKinds=s={}));class t{static asEditOperation(ie){return r.$ys.replace(I.$xs.lift(ie.range),ie.text)}}e.$lt=t;class a{static{this.Comment=new a("comment")}static{this.Imports=new a("imports")}static{this.Region=new a("region")}static fromValue(ie){switch(ie){case"comment":return a.Comment;case"imports":return a.Imports;case"region":return a.Region}return new a(ie)}constructor(ie){this.value=ie}}e.$mt=a;var $;(function(X){function ie(he){return!he||typeof he!="object"?!1:typeof he.id=="string"&&typeof he.title=="string"}X.is=ie})($||(e.Command=$={}));var w;(function(X){X[X.Collapsed=0]="Collapsed",X[X.Expanded=1]="Expanded"})(w||(e.CommentThreadCollapsibleState=w={}));var k;(function(X){X[X.Unresolved=0]="Unresolved",X[X.Resolved=1]="Resolved"})(k||(e.CommentThreadState=k={}));var E;(function(X){X[X.Editing=0]="Editing",X[X.Preview=1]="Preview"})(E||(e.CommentMode=E={}));var L;(function(X){X[X.Published=0]="Published",X[X.Draft=1]="Draft"})(L||(e.CommentState=L={}));var j;(function(X){X[X.Type=1]="Type",X[X.Parameter=2]="Parameter"})(j||(e.InlayHintKind=j={}));class x{constructor(ie){this.b=ie,this.a=null}dispose(){this.a&&this.a.then(ie=>{ie&&ie.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$nt=x,e.$ot=new P.$9s;var ce;(function(X){X[X.None=0]="None",X[X.Option=1]="Option",X[X.Default=2]="Default",X[X.Preferred=3]="Preferred"})(ce||(e.ExternalUriOpenerPriority=ce={}))}),define(pe[173],be([8,9]),function(ue,e){return ue.create("vs/platform/configuration/common/configurationRegistry",e)}),define(pe[174],be([8,9]),function(ue,e){return ue.create("vs/platform/contextkey/common/contextkey",e)}),define(pe[175],be([8,9]),function(ue,e){return ue.create("vs/platform/contextkey/common/scanner",e)}),define(pe[176],be([8,9]),function(ue,e){return ue.create("vs/platform/environment/node/argv",e)}),define(pe[177],be([8,9]),function(ue,e){return ue.create("vs/platform/environment/node/argvHelper",e)}),define(pe[178],be([8,9]),function(ue,e){return ue.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(pe[179],be([8,9]),function(ue,e){return ue.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(pe[180],be([8,9]),function(ue,e){return ue.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(pe[181],be([8,9]),function(ue,e){return ue.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(pe[182],be([8,9]),function(ue,e){return ue.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(pe[183],be([8,9]),function(ue,e){return ue.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(pe[184],be([8,9]),function(ue,e){return ue.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(pe[185],be([8,9]),function(ue,e){return ue.create("vs/platform/extensions/common/extensionValidator",e)}),define(pe[186],be([8,9]),function(ue,e){return ue.create("vs/platform/files/common/fileService",e)}),define(pe[187],be([8,9]),function(ue,e){return ue.create("vs/platform/files/common/files",e)}),define(pe[188],be([8,9]),function(ue,e){return ue.create("vs/platform/files/common/io",e)}),define(pe[189],be([8,9]),function(ue,e){return ue.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(pe[190],be([8,9]),function(ue,e){return ue.create("vs/platform/languagePacks/common/languagePacks",e)}),define(pe[191],be([8,9]),function(ue,e){return ue.create("vs/platform/markers/common/markers",e)}),define(pe[192],be([8,9]),function(ue,e){return ue.create("vs/platform/request/common/request",e)}),define(pe[193],be([8,9]),function(ue,e){return ue.create("vs/platform/shell/node/shellEnv",e)}),define(pe[194],be([8,9]),function(ue,e){return ue.create("vs/platform/telemetry/common/telemetryService",e)}),define(pe[195],be([8,9]),function(ue,e){return ue.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(pe[196],be([8,9]),function(ue,e){return ue.create("vs/platform/terminal/common/terminalProfiles",e)}),define(pe[197],be([8,9]),function(ue,e){return ue.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(pe[198],be([8,9]),function(ue,e){return ue.create("vs/platform/workspace/common/workspace",e)}),define(pe[199],be([8,9]),function(ue,e){return ue.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(pe[200],be([8,9]),function(ue,e){return ue.create("vs/server/node/serverEnvironmentService",e)}),define(pe[201],be([8,9]),function(ue,e){return ue.create("vs/server/node/serverServices",e)}),define(pe[202],be([8,9]),function(ue,e){return ue.create("vs/workbench/api/common/extHostTelemetry",e)}),define(pe[203],be([8,9]),function(ue,e){return ue.create("vs/workbench/common/editor",e)}),define(pe[204],be([8,9]),function(ue,e){return ue.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(pe[205],be([8,9]),function(ue,e){return ue.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(pe[206],be([1,0,11,175]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.TokenType=void 0;var r;(function(b){b[b.LParen=0]="LParen",b[b.RParen=1]="RParen",b[b.Neg=2]="Neg",b[b.Eq=3]="Eq",b[b.NotEq=4]="NotEq",b[b.Lt=5]="Lt",b[b.LtEq=6]="LtEq",b[b.Gt=7]="Gt",b[b.GtEq=8]="GtEq",b[b.RegexOp=9]="RegexOp",b[b.RegexStr=10]="RegexStr",b[b.True=11]="True",b[b.False=12]="False",b[b.In=13]="In",b[b.Not=14]="Not",b[b.And=15]="And",b[b.Or=16]="Or",b[b.Str=17]="Str",b[b.QuotedStr=18]="QuotedStr",b[b.Error=19]="Error",b[b.EOF=20]="EOF"})(r||(e.TokenType=r={}));function I(...b){switch(b.length){case 1:return(0,R.localize)(0,null,b[0]);case 2:return(0,R.localize)(1,null,b[0],b[1]);case 3:return(0,R.localize)(2,null,b[0],b[1],b[2]);default:return}}const P=(0,R.localize)(3,null),C=(0,R.localize)(4,null);class v{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(I("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(I("&&"));break;case 124:this.h(124)?this.k(16):this.l(I("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const S=this.d,y=this.c.substring(this.d,this.e),u={type:19,offset:this.d,lexeme:y};this.g.push({offset:S,lexeme:y,additionalInfo:A}),this.f.push(u)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const S=this.c.substring(this.d,this.e),y=v.b.get(S);y?this.k(y):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(P);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,S=!1,y=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(C);return}const g=this.c.charCodeAt(A);if(S)S=!1;else if(g===47&&!y){A++;break}else g===91?y=!0:g===92?S=!0:g===93&&(y=!1);A++}for(;A<this.c.length&&v.a.has(this.c.charCodeAt(A));)A++;this.e=A;const u=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:u,offset:this.d})}r(){return this.e>=this.c.length}}e.$Li=v}),define(pe[207],be([1,0,5,2]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=e.$Qn=void 0;class r{constructor(){this.a=new D.$Od,this.b=new D.$Od,this.c=new D.$Od,this.d=new D.$Od}static{this.ChannelName="extensionhostdebugservice"}call(C,v,b){switch(v){case"close":return Promise.resolve(this.a.fire({sessionId:b[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:b[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:b[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:b[0],port:b[1],subId:b[2]}))}throw new Error("Method not implemented.")}listen(C,v,b){switch(v){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Qn=r;class I extends R.$Sc{constructor(C){super(),this.b=C}reload(C){this.b.call("reload",[C])}get onReload(){return this.b.listen("reload")}close(C){this.b.call("close",[C])}get onClose(){return this.b.listen("close")}attachSession(C,v,b){this.b.call("attach",[C,v,b])}get onAttachSession(){return this.b.listen("attach")}terminateSession(C,v){this.b.call("terminate",[C,v])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(C,v){return this.b.call("openExtensionDevelopmentHostWindow",[C,v])}}e.$Rn=I}),define(pe[208],be([1,0,4]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=e.$Tn=void 0;class R{constructor(P){this.a=P}listen(P,C,v){throw new Error("Invalid listen")}call(P,C,v){switch(C){case"download":return this.a.download(D.URI.revive(v[0]),D.URI.revive(v[1]))}throw new Error("Invalid call")}}e.$Tn=R;class r{constructor(P,C){this.a=P,this.b=C}async download(P,C){const v=this.b();v&&(P=v.transformOutgoingURI(P),C=v.transformOutgoingURI(C)),await this.a.call("download",[P,C])}}e.$Un=r}),define(pe[209],be([1,0,159,73,12,7,29,19,4]),function(ue,e,D,R,r,I,P,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=e.$hm=e.$gm=void 0,e.$gm=/^([^.]+\..+):(.+)$/;class b{get appRoot(){return(0,I.$mc)(r.$dg.asFileUri("").fsPath)}get userHome(){return v.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return v.URI.file((0,I.$jc)(this.userDataPath,"User"))}get tmpDir(){return v.URI.file(this.b.tmpDir)}get cacheHome(){return v.URI.file(this.userDataPath)}get stateResource(){return(0,C.$wg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:r.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,C.$wg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const u=(0,D.$fm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,I.$jc)(this.userDataPath,"logs",u)}return v.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.$wg)(v.URI.file((0,I.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,C.$wg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,C.$wg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,C.$wg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=P.env.VSCODE_PORTABLE;return u?v.URI.file((0,I.$jc)(u,"argv.json")):(0,C.$wg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return v.URI.file((0,I.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,I.$kc)(u):(0,I.$hc)((0,I.$jc)(r.$dg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const u=this.args["extensions-download-dir"];return u?v.URI.file((0,I.$kc)(u)):v.URI.file((0,I.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,I.$kc)(u);const g=P.env.VSCODE_EXTENSIONS;if(g)return g;const d=P.env.VSCODE_PORTABLE;return d?(0,I.$jc)(d,"extensions"):(0,C.$wg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(g=>/^[^:/?#]+?:\/\//.test(g)?v.URI.parse(g):v.URI.file((0,I.$hc)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?v.URI.parse(u):v.URI.file((0,I.$hc)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return A(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!P.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(u=>!e.$gm.test(u))}get extensionLogLevel(){const u=[];for(const g of this.args.log||[]){const d=e.$gm.exec(g);d&&d[1]&&d[2]&&u.push([d[1],d[2]])}return u.length?u:void 0}get serviceMachineIdResource(){return(0,C.$wg)(v.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const u=P.env.VSCODE_PORTABLE;return u?v.URI.file((0,I.$jc)(u,"policy.json")):(0,C.$wg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(u){this.args.continueOn=u}get args(){return this.a}constructor(u,g,d){this.a=u,this.b=g,this.c=d,this.editSessionId=this.args.editSessionId}}e.$hm=b,Oe([R.$ih],b.prototype,"appRoot",null),Oe([R.$ih],b.prototype,"userHome",null),Oe([R.$ih],b.prototype,"userDataPath",null),Oe([R.$ih],b.prototype,"appSettingsHome",null),Oe([R.$ih],b.prototype,"tmpDir",null),Oe([R.$ih],b.prototype,"cacheHome",null),Oe([R.$ih],b.prototype,"stateResource",null),Oe([R.$ih],b.prototype,"userRoamingDataHome",null),Oe([R.$ih],b.prototype,"userDataSyncHome",null),Oe([R.$ih],b.prototype,"sync",null),Oe([R.$ih],b.prototype,"machineSettingsResource",null),Oe([R.$ih],b.prototype,"workspaceStorageHome",null),Oe([R.$ih],b.prototype,"localHistoryHome",null),Oe([R.$ih],b.prototype,"keyboardLayoutResource",null),Oe([R.$ih],b.prototype,"argvResource",null),Oe([R.$ih],b.prototype,"isExtensionDevelopment",null),Oe([R.$ih],b.prototype,"untitledWorkspacesHome",null),Oe([R.$ih],b.prototype,"builtinExtensionsPath",null),Oe([R.$ih],b.prototype,"extensionsPath",null),Oe([R.$ih],b.prototype,"extensionDevelopmentLocationURI",null),Oe([R.$ih],b.prototype,"extensionDevelopmentKind",null),Oe([R.$ih],b.prototype,"extensionTestsLocationURI",null),Oe([R.$ih],b.prototype,"debugExtensionHost",null),Oe([R.$ih],b.prototype,"logLevel",null),Oe([R.$ih],b.prototype,"extensionLogLevel",null),Oe([R.$ih],b.prototype,"serviceMachineIdResource",null),Oe([R.$ih],b.prototype,"disableTelemetry",null),Oe([R.$ih],b.prototype,"disableWorkspaceTrust",null),Oe([R.$ih],b.prototype,"useInMemorySecretStorage",null),Oe([R.$ih],b.prototype,"policyFile",null);function A(y,u){return S(y["inspect-extensions"],y["inspect-brk-extensions"],5870,u,y.debugId,y.extensionEnvironment)}e.$im=A;function S(y,u,g,d,f,h){const l=Number(u||y)||(d?null:g),m=l?!!u:!1;let c;if(h)try{c=JSON.parse(h)}catch{}return{port:l,break:m,debugId:f,env:c}}e.$jm=S}),define(pe[65],be([1,0,297,3,176]),function(ue,e,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=void 0;const I={o:(0,r.localize)(0,null),e:(0,r.localize)(1,null),t:(0,r.localize)(2,null)};e.$Fl=["tunnel","serve-web"],e.$Gl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,r.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,r.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,r.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,r.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,r.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,r.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,r.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,r.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,r.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,r.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,r.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,r.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,r.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,r.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,r.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,r.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,r.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,r.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,r.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,r.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,r.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,r.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,r.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,r.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,r.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,r.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,r.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,r.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,r.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,r.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,r.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const P={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function C(d,f,h=P){const p=d.find(a=>a.length>0&&a[0]!=="-"),l={},m=["_"],c=[],n={};let i;for(const a in f){const $=f[a];$.type==="subcommand"?a===p&&(i=$):($.alias&&(l[a]=$.alias),$.type==="string"||$.type==="string[]"?(m.push(a),$.deprecates&&m.push(...$.deprecates)):$.type==="boolean"&&(c.push(a),$.deprecates&&c.push(...$.deprecates)),$.global&&(n[a]=$))}if(i&&p){const a=n;for(const E in i.options)a[E]=i.options[E];const $=d.filter(E=>E!==p),w=h.getSubcommandReporter?h.getSubcommandReporter(p):void 0,k=C($,a,w);return{[p]:k,_:[]}}const o=D(d,{string:m,boolean:c,alias:l}),s={},t=o;s._=o._.map(a=>String(a)).filter(a=>a.length>0),delete t._;for(const a in f){const $=f[a];if($.type==="subcommand")continue;$.alias&&delete t[$.alias];let w=t[a];if($.deprecates)for(const k of $.deprecates)t.hasOwnProperty(k)&&(w||(w=t[k],w&&h.onDeprecatedOption(k,$.deprecationMessage||(0,r.localize)(37,null,a))),delete t[k]);if(typeof w<"u"){if($.type==="string[]"){if(Array.isArray(w)||(w=[w]),!$.allowEmptyValue){const k=w.filter(E=>E.length>0);k.length!==w.length&&(h.onEmptyValue(a),w=k.length>0?k:void 0)}}else $.type==="string"&&(Array.isArray(w)?(w=w.pop(),h.onMultipleValues(a,w)):!w&&!$.allowEmptyValue&&(h.onEmptyValue(a),w=void 0));s[a]=w,$.deprecationMessage&&h.onDeprecatedOption(a,$.deprecationMessage)}delete t[a]}for(const a in t)h.onUnknownOption(a);return s}e.$Hl=C;function v(d,f){let h="";return f.args&&(Array.isArray(f.args)?h=` <${f.args.join("> <")}>`:h=` <${f.args}>`),f.alias?`-${f.alias} --${d}${h}`:`--${d}${h}`}function b(d,f){const h=[];for(const p in d){const l=d[p],m=v(p,l);h.push([m,l.description])}return A(h,f)}e.$Il=b;function A(d,f){const p=d.reduce((c,n)=>Math.max(c,n[0].length),12)+2+1;if(f-p<25)return d.reduce((c,n)=>c.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const l=f-p-1,m=[];for(const c of d){const n=c[0],i=y(c[1],l),o=S(p-n.length-2);m.push("  "+n+o+i[0]);for(let s=1;s<i.length;s++)m.push(S(p)+i[s])}return m}function S(d){return" ".repeat(d)}function y(d,f){const h=[];for(;d.length;){const p=d.length<f?d.length:d.lastIndexOf(" ",f),l=d.slice(0,p).trim();d=d.slice(p),h.push(l)}return h}function u(d,f,h,p,l){const m=process.stdout.isTTY&&process.stdout.columns||80,c=l?.noInputFiles!==!0?`[${(0,r.localize)(38,null)}...]`:"",n=[`${d} ${h}`];n.push(""),n.push(`${(0,r.localize)(39,null)}: ${f} [${(0,r.localize)(40,null)}]${c}`),n.push(""),l?.noPipe!==!0&&(R.$j?n.push((0,r.localize)(41,null,f)):n.push((0,r.localize)(42,null,f)),n.push(""));const i={},o=[];for(const s in p){const t=p[s];if(t.type==="subcommand")t.description&&o.push({command:s,description:t.description});else if(t.description&&t.cat){let a=i[t.cat];a||(i[t.cat]=a={}),a[s]=t}}for(const s in i){const t=s,a=i[t];a&&(n.push(I[t]),n.push(...b(a,m)),n.push(""))}return o.length&&(n.push((0,r.localize)(43,null)),n.push(...A(o.map(s=>[s.command,s.description]),m)),n.push("")),n.join(`
`)}e.$Jl=u;function g(d,f){return`${d||(0,r.localize)(44,null)}
${f||(0,r.localize)(45,null)}
${process.arch}`}e.$Kl=g}),define(pe[210],be([1,0,298,177,65]),function(ue,e,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Ml=e.$Ll=void 0;function I(S,y){const u=(l,m)=>{console.warn((0,R.localize)(0,null,l,m))},g=l=>{console.warn((0,R.localize)(1,null,l))},d=(l,m)=>{console.warn((0,R.localize)(2,null,l,m))},f=l=>({onUnknownOption:m=>{r.$Fl.includes(l)||console.warn((0,R.localize)(3,null,m,l))},onMultipleValues:u,onEmptyValue:g,onDeprecatedOption:d,getSubcommandReporter:r.$Fl.includes(l)?f:void 0}),h={onUnknownOption:l=>{console.warn((0,R.localize)(4,null,l))},onMultipleValues:u,onEmptyValue:g,onDeprecatedOption:d,getSubcommandReporter:f},p=(0,r.$Hl)(S,r.$Gl,y?h:void 0);return p.goto&&p._.forEach(l=>D(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(l),(0,R.localize)(5,null))),p}function P(S){const y=S.findIndex(u=>!/^-/.test(u));if(y>-1)return[...S.slice(0,y),...S.slice(y+1)]}function C(S){let[,...y]=S;process.env.VSCODE_DEV&&(y=P(y)||[]);const u=!A(process.env);return I(y,u)}e.$Ll=C;function v(S){let[,,...y]=S;return process.env.VSCODE_DEV&&(y=P(y)||[]),I(y,!0)}e.$Ml=v;function b(S,...y){const u=S.indexOf("--");return u===-1?S.push(...y):S.splice(u,0,...y),S}e.$Nl=b;function A(S){return S.VSCODE_CLI==="1"}e.$Ol=A}),function(){"use strict";function ue(e,D,R){function r(P,C){const v=I(P,C),b=[v];return e.isAbsolute(v)||b.unshift(R),e.resolve(...b)}function I(P,C){process.env.VSCODE_DEV&&(C="code-oss-dev");const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,C);const A=P["user-data-dir"];if(A)return A;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(S,"AppData","Roaming")}break;case"darwin":b=e.join(D.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,C)}return{getUserDataPath:r}}if(typeof define=="function")define(pe[211],be([77,28,29]),function(e,D,R){return ue(e,D,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=ue(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(pe[108],be([1,0,28,209,211]),function(ue,e,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=e.$lm=e.$km=void 0;class I extends R.$hm{constructor(b,A){super(b,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,r.getUserDataPath)(b,A.nameShort)},A)}}e.$km=I;function P(v,b){return(0,R.$jm)(v["inspect-ptyhost"],v["inspect-brk-ptyhost"],5877,b,v.extensionEnvironment)}e.$lm=P;function C(v,b){return(0,R.$jm)(v["inspect-sharedprocess"],v["inspect-brk-sharedprocess"],5879,b,v.extensionEnvironment)}e.$mm=C}),define(pe[212],be([1,0,10,181]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;function r(P,C,v,b){try{I(P,C,v,b)}catch(A){P.error(A?.message??A)}return C}e.$Bp=r;function I(P,C,v,b){const A=(S,y,u)=>{const g=S[y];if((0,D.$zf)(g)){const d=g,f=d.length;if(f>1&&d[0]==="%"&&d[f-1]==="%"){const h=d.substr(1,f-2);let p=v[h];p===void 0&&b&&(p=b[h]);const l=typeof p=="string"?p:p?.message,m=b?.[h],c=typeof m=="string"?m:m?.message;if(!l){c||P.warn(`[${C.name}]: ${(0,R.localize)(0,null,h)}`);return}if(u&&(y==="title"||y==="category")&&c&&c!==l){const n={value:l,original:c};S[y]=n}else S[y]=l}}else if((0,D.$Bf)(g))for(const d in g)g.hasOwnProperty(d)&&(d==="commands"?A(g,d,!0):A(g,d,u));else if(Array.isArray(g))for(let d=0;d<g.length;d++)A(g,d,u)};for(const S in C)C.hasOwnProperty(S)&&A(C,S)}}),define(pe[80],be([1,0,19,61,185,53]),function(ue,e,D,R,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function v(h){return h=h.trim(),h==="*"||P.test(h)}e.$Po=v;function b(h){if(!v(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=h.match(P);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.$Qo=b;function A(h){if(!h)return null;const p=h.majorBase,l=h.majorMustEqual,m=h.minorBase;let c=h.minorMustEqual;const n=h.patchBase;let i=h.patchMustEqual;h.hasCaret&&(p===0||(c=!1),i=!1);let o=0;if(h.preRelease){const s=C.exec(h.preRelease);if(s){const[,t,a,$]=s;o=Date.UTC(Number(t),Number(a)-1,Number($))}}return{majorBase:p,majorMustEqual:l,minorBase:m,minorMustEqual:c,patchBase:n,patchMustEqual:i,isMinimum:h.hasGreaterEquals,notBefore:o}}e.$Ro=A;function S(h,p,l){let m;typeof h=="string"?m=A(b(h)):m=h;let c;p instanceof Date?c=p.getTime():typeof p=="string"&&(c=new Date(p).getTime());let n;if(typeof l=="string"?n=A(b(l)):n=l,!m||!n)return!1;const i=m.majorBase,o=m.minorBase,s=m.patchBase;let t=n.majorBase,a=n.minorBase,$=n.patchBase;const w=n.notBefore;let k=n.majorMustEqual,E=n.minorMustEqual,L=n.patchMustEqual;return n.isMinimum?i>t?!0:i<t?!1:o>a?!0:o<a||c&&c<w?!1:s>=$:(i===1&&t===0&&(!k||!E||!L)&&(t=1,a=0,$=0,k=!0,E=!1,L=!1),i<t?!1:i>t?!k:o<a?!1:o>a?!E:s<$?!1:s>$?!L:!(c&&c<w))}e.$So=S;function y(h,p,l,m,c){const n=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return n.push([R.default.Error,r.localize(0,null)]),n;if(typeof m.name!="string")return n.push([R.default.Error,r.localize(1,null,"name")]),n;if(typeof m.version!="string")return n.push([R.default.Error,r.localize(2,null,"version")]),n;if(!m.engines)return n.push([R.default.Error,r.localize(3,null,"engines")]),n;if(typeof m.engines.vscode!="string")return n.push([R.default.Error,r.localize(4,null,"engines.vscode")]),n;if(typeof m.extensionDependencies<"u"&&!f(m.extensionDependencies))return n.push([R.default.Error,r.localize(5,null,"extensionDependencies")]),n;if(typeof m.activationEvents<"u"){if(!f(m.activationEvents))return n.push([R.default.Error,r.localize(6,null,"activationEvents")]),n;if(typeof m.main>"u"&&typeof m.browser>"u")return n.push([R.default.Error,r.localize(7,null,"activationEvents","main","browser")]),n}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&n.push([R.default.Warning,r.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return n.push([R.default.Error,r.localize(9,null,"main")]),n;{const s=(0,D.$wg)(l,m.main);(0,D.$qg)(s,l)||n.push([R.default.Warning,r.localize(10,null,s.path,l.path)])}}if(typeof m.browser<"u"){if(typeof m.browser!="string")return n.push([R.default.Error,r.localize(11,null,"browser")]),n;{const s=(0,D.$wg)(l,m.browser);(0,D.$qg)(s,l)||n.push([R.default.Warning,r.localize(12,null,s.path,l.path)])}}if(!I.valid(m.version))return n.push([R.default.Error,r.localize(13,null)]),n;const i=[];if(!u(h,p,m,c,i))for(const s of i)n.push([R.default.Error,s]);return n}e.$To=y;function u(h,p,l,m,c){return m||typeof l.main>"u"&&typeof l.browser>"u"?!0:d(h,p,l.engines.vscode,c)}e.$Uo=u;function g(h,p,l){return h==="*"||d(p,l,h)}e.$Vo=g;function d(h,p,l,m=[]){const c=A(b(l));if(!c)return m.push(r.localize(14,null,l)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return m.push(r.localize(15,null,l)),!1}else if(!c.majorMustEqual)return m.push(r.localize(16,null,l)),!1;return S(h,p,c)?!0:(m.push(r.localize(17,null,h,l)),!1)}function f(h){if(!Array.isArray(h))return!1;for(let p=0,l=h.length;p<l;p++)if(typeof h[p]!="string")return!1;return!0}}),define(pe[213],be([1,0,15,23]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=void 0;async function r(I,P,C){let v=C&&C.get("storage.serviceMachineId",-1)||null;if(v)return v;try{const A=(await P.readFile(I.serviceMachineIdResource)).value.toString();v=(0,R.$eg)(A)?A:null}catch{v=null}if(!v){v=(0,R.$fg)();try{await P.writeFile(I.serviceMachineIdResource,D.$ce.fromString(v))}catch{}}return C?.store("storage.serviceMachineId",v,-1,1),v}e.$dp=r}),define(pe[66],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class D{constructor(r,I=[],P=!1){this.ctor=r,this.staticArguments=I,this.supportsDelayedInstantiation=P}}e.$Nh=D}),define(pe[214],be([1,0,66]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=e.InstantiationType=void 0;const R=[];var r;(function(C){C[C.Eager=0]="Eager",C[C.Delayed=1]="Delayed"})(r||(e.InstantiationType=r={}));function I(C,v,b){v instanceof D.$Nh||(v=new D.$Nh(v,[],!!b)),R.push([C,v])}e.$Ar=I;function P(){return R}e.$Br=P}),define(pe[215],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=void 0;class D{constructor(I,P){this.key=I,this.data=P,this.incoming=new Map,this.outgoing=new Map}}e.$fq=D;class R{constructor(I){this.b=I,this.a=new Map}roots(){const I=[];for(const P of this.a.values())P.outgoing.size===0&&I.push(P);return I}insertEdge(I,P){const C=this.lookupOrInsertNode(I),v=this.lookupOrInsertNode(P);C.outgoing.set(v.key,v),v.incoming.set(C.key,C)}removeNode(I){const P=this.b(I);this.a.delete(P);for(const C of this.a.values())C.outgoing.delete(P),C.incoming.delete(P)}lookupOrInsertNode(I){const P=this.b(I);let C=this.a.get(P);return C||(C=new D(P,I),this.a.set(P,C)),C}lookup(I){return this.a.get(this.b(I))}isEmpty(){return this.a.size===0}toString(){const I=[];for(const[P,C]of this.a)I.push(`${P}
	(-> incoming)[${[...C.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...C.outgoing.keys()].join(",")}]
`);return I.join(`
`)}findCycleSlow(){for(const[I,P]of this.a){const C=new Set([I]),v=this.c(P,C);if(v)return v}}c(I,P){for(const[C,v]of I.outgoing){if(P.has(C))return[...P,C].join(" -> ");P.add(C);const b=this.c(v,P);if(b)return b;P.delete(C)}}}e.$gq=R}),define(pe[6],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e._util=void 0;var D;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function C(v){return v[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=C})(D||(e._util=D={})),e.$Ph=r("instantiationService");function R(P,C,v){C[D.DI_TARGET]===C?C[D.DI_DEPENDENCIES].push({id:P,index:v}):(C[D.DI_DEPENDENCIES]=[{id:P,index:v}],C[D.DI_TARGET]=C)}function r(P){if(D.serviceIds.has(P))return D.serviceIds.get(P);const C=function(v,b,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(C,v,A)};return C.toString=()=>P,D.serviceIds.set(P,C),C}e.$Qh=r;function I(P){return P}e.$Rh=I}),define(pe[24],be([1,0,10,4,6]),function(ue,e,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.ConfigurationTarget=e.$mi=e.$li=e.$ki=void 0,e.$ki=(0,r.$Qh)("configurationService");function I(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof R.URI)}e.$li=I;function P(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof R.URI)}e.$mi=P;var C;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(C||(e.ConfigurationTarget=C={}));function v(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ni=v;function b(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.$oi=b;function A(h,p){const l=Object.create(null);for(const m in h)S(l,m,h[m],p);return l}e.$pi=A;function S(h,p,l,m){const c=p.split("."),n=c.pop();let i=h;for(let o=0;o<c.length;o++){const s=c[o];let t=i[s];switch(typeof t){case"undefined":t=i[s]=Object.create(null);break;case"object":break;default:m(`Ignoring ${p} as ${c.slice(0,o+1).join(".")} is ${JSON.stringify(t)}`);return}i=t}if(typeof i=="object"&&i!==null)try{i[n]=l}catch{m(`Ignoring ${p} as ${c.join(".")} is ${JSON.stringify(i)}`)}else m(`Ignoring ${p} as ${c.join(".")} is ${JSON.stringify(i)}`)}e.$qi=S;function y(h,p){const l=p.split(".");u(h,l)}e.$ri=y;function u(h,p){const l=p.shift();if(p.length===0){delete h[l];return}if(Object.keys(h).indexOf(l)!==-1){const m=h[l];typeof m=="object"&&!Array.isArray(m)&&(u(m,p),Object.keys(m).length===0&&delete h[l])}}function g(h,p,l){function m(i,o){let s=i;for(const t of o){if(typeof s!="object"||s===null)return;s=s[t]}return s}const c=p.split("."),n=m(h,c);return typeof n>"u"?l:n}e.$si=g;function d(h,p,l){Object.keys(p).forEach(m=>{m!=="__proto__"&&(m in h?D.$Bf(h[m])&&D.$Bf(p[m])?d(h[m],p[m],l):l&&(h[m]=p[m]):h[m]=p[m])})}e.$ti=d;function f(h){return h.replace(/[\[\]]/g,"")}e.$ui=f}),define(pe[67],be([1,0,3,17,206,6,174,11]),function(ue,e,D,R,r,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.ContextKeyExprType=e.$Mi=void 0;const v=new Map;v.set("false",!1),v.set("true",!0),v.set("isMac",D.$k),v.set("isLinux",D.$l),v.set("isWindows",D.$j),v.set("isWeb",D.$p),v.set("isMacNative",D.$k&&!D.$p),v.set("isEdge",D.$H),v.set("isFirefox",D.$F),v.set("isChrome",D.$E),v.set("isSafari",D.$G);function b(K,N){if(v.get(K)!==void 0)throw(0,C.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");v.set(K,N)}e.$Mi=b;const A=Object.prototype.hasOwnProperty;var S;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const y={regexParsingWithErrorRecovery:!0},u=(0,P.localize)(0,null),g=(0,P.localize)(1,null),d=(0,P.localize)(2,null),f=(0,P.localize)(3,null),h=(0,P.localize)(4,null),p=(0,P.localize)(5,null),l=(0,P.localize)(6,null),m=(0,P.localize)(7,null);class c{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(N=y){this.k=N,this.d=new r.$Li,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(N){if(N===""){this.h.push({message:u,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(N).scan(),this.g=0,this.h=[];try{const O=this.l();if(!this.E()){const U=this.D(),T=U.type===17?p:void 0;throw this.h.push({message:h,offset:U.offset,lexeme:r.$Li.getLexeme(U),additionalInfo:T}),c.c}return O}catch(O){if(O!==c.c)throw O;return}}l(){return this.m()}m(){const N=[this.o()];for(;this.y(16);){const O=this.o();N.push(O)}return N.length===1?N[0]:n.or(...N)}o(){const N=[this.s()];for(;this.y(15);){const O=this.s();N.push(O)}return N.length===1?N[0]:n.and(...N)}s(){if(this.y(2)){const N=this.D();switch(N.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),a.INSTANCE;case 0:{this.z();const O=this.l();return this.A(1,f),O?.negate()}case 17:return this.z(),j.create(N.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",N)}}return this.t()}t(){const N=this.D();switch(N.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const O=this.l();return this.A(1,f),O}case 17:{const O=N.lexeme;if(this.z(),this.y(9)){const T=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),T.type!==10)throw this.B("REGEX",T);const q=T.lexeme,z=q.lastIndexOf("/"),te=z===q.length-1?void 0:this.w(q.substring(z+1));let H;try{H=new RegExp(q.substring(1,z),te)}catch{throw this.B("REGEX",T)}return _.create(O,H)}switch(T.type){case 10:case 19:{const q=[T.lexeme];this.z();let z=this.D(),te=0;for(let se=0;se<T.lexeme.length;se++)T.lexeme.charCodeAt(se)===40?te++:T.lexeme.charCodeAt(se)===41&&te--;for(;!this.E()&&z.type!==15&&z.type!==16;){switch(z.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let se=0;se<z.lexeme.length;se++)z.lexeme.charCodeAt(se)===40?te++:T.lexeme.charCodeAt(se)===41&&te--}if(te<0)break;q.push(r.$Li.getLexeme(z)),this.z(),z=this.D()}const H=q.join(""),Y=H.lastIndexOf("/"),V=Y===H.length-1?void 0:this.w(H.substring(Y+1));let Q;try{Q=new RegExp(H.substring(1,Y),V)}catch{throw this.B("REGEX",T)}return n.regex(O,Q)}case 18:{const q=T.lexeme;this.z();let z=null;if(!(0,R.$Ce)(q)){const te=q.indexOf("/"),H=q.lastIndexOf("/");if(te!==H&&te>=0){const Y=q.slice(te+1,H),V=q[H+1]==="i"?"i":"";try{z=new RegExp(Y,V)}catch{throw this.B("REGEX",T)}}}if(z===null)throw this.B("REGEX",T);return _.create(O,z)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,d);const T=this.u();return n.notIn(O,T)}switch(this.D().type){case 3:{this.z();const T=this.u();if(this.x().type===18)return n.equals(O,T);switch(T){case"true":return n.has(O);case"false":return n.not(O);default:return n.equals(O,T)}}case 4:{this.z();const T=this.u();if(this.x().type===18)return n.notEquals(O,T);switch(T){case"true":return n.not(O);case"false":return n.has(O);default:return n.notEquals(O,T)}}case 5:return this.z(),ie.create(O,this.u());case 6:return this.z(),he.create(O,this.u());case 7:return this.z(),ce.create(O,this.u());case 8:return this.z(),X.create(O,this.u());case 13:return this.z(),n.in(O,this.u());default:return n.has(O)}}case 20:throw this.h.push({message:l,offset:N.offset,lexeme:"",additionalInfo:m}),c.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const N=this.D();switch(N.type){case 17:case 18:return this.z(),N.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(N){return N.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(N){return this.C(N)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(N,O){if(this.C(N))return this.z();throw this.B(O,this.D())}B(N,O,U){const T=(0,P.localize)(8,null,N,r.$Li.getLexeme(O)),q=O.offset,z=r.$Li.getLexeme(O);return this.h.push({message:T,offset:q,lexeme:z,additionalInfo:U}),c.c}C(N){return this.D().type===N}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ni=c;class n{static false(){return t.INSTANCE}static true(){return a.INSTANCE}static has(N){return $.create(N)}static equals(N,O){return w.create(N,O)}static notEquals(N,O){return L.create(N,O)}static regex(N,O){return _.create(N,O)}static in(N,O){return k.create(N,O)}static notIn(N,O){return E.create(N,O)}static not(N){return j.create(N)}static and(...N){return ne.create(N,null,!0)}static or(...N){return J.create(N,null,!0)}static greater(N,O){return ce.create(N,O)}static greaterEquals(N,O){return X.create(N,O)}static smaller(N,O){return ie.create(N,O)}static smallerEquals(N,O){return he.create(N,O)}static{this.c=new c({regexParsingWithErrorRecovery:!1})}static deserialize(N){return N==null?void 0:this.c.parse(N)}}e.$Oi=n;function i(K){const N=new c({regexParsingWithErrorRecovery:!1});return K.map(O=>(N.parse(O),N.lexingErrors.length>0?N.lexingErrors.map(U=>({errorMessage:U.additionalInfo?(0,P.localize)(9,null,U.additionalInfo):(0,P.localize)(10,null),offset:U.offset,length:U.lexeme.length})):N.parsingErrors.length>0?N.parsingErrors.map(U=>({errorMessage:U.additionalInfo?`${U.message}. ${U.additionalInfo}`:U.message,offset:U.offset,length:U.lexeme.length})):[]))}e.$Pi=i;function o(K,N){const O=K?K.substituteConstants():void 0,U=N?N.substituteConstants():void 0;return!O&&!U?!0:!O||!U?!1:O.equals(U)}e.$Qi=o;function s(K,N){return K.cmp(N)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!1}serialize(){return"false"}keys(){return[]}map(N){return this}negate(){return a.INSTANCE}}e.$Ri=t;class a{static{this.INSTANCE=new a}constructor(){this.type=1}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!0}serialize(){return"true"}keys(){return[]}map(N){return this}negate(){return t.INSTANCE}}e.$Si=a;class ${static create(N,O=null){const U=v.get(N);return typeof U=="boolean"?U?a.INSTANCE:t.INSTANCE:new $(N,O)}constructor(N,O){this.key=N,this.c=O,this.type=2}cmp(N){return N.type!==this.type?this.type-N.type:oe(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=v.get(this.key);return typeof N=="boolean"?N?a.INSTANCE:t.INSTANCE:this}evaluate(N){return!!N.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(N){return N.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$Ti=$;class w{static create(N,O,U=null){if(typeof O=="boolean")return O?$.create(N,U):j.create(N,U);const T=v.get(N);return typeof T=="boolean"?O===(T?"true":"false")?a.INSTANCE:t.INSTANCE:new w(N,O,U)}constructor(N,O,U){this.c=N,this.d=O,this.f=U,this.type=4}cmp(N){return N.type!==this.type?this.type-N.type:le(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=v.get(this.c);if(typeof N=="boolean"){const O=N?"true":"false";return this.d===O?a.INSTANCE:t.INSTANCE}return this}evaluate(N){return N.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(N){return N.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Ui=w;class k{static create(N,O){return new k(N,O)}constructor(N,O){this.d=N,this.f=O,this.type=10,this.c=null}cmp(N){return N.type!==this.type?this.type-N.type:le(this.d,this.f,N.d,N.f)}equals(N){return N.type===this.type?this.d===N.d&&this.f===N.f:!1}substituteConstants(){return this}evaluate(N){const O=N.getValue(this.f),U=N.getValue(this.d);return Array.isArray(O)?O.includes(U):typeof U=="string"&&typeof O=="object"&&O!==null?A.call(O,U):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(N){return N.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$Vi=k;class E{static create(N,O){return new E(N,O)}constructor(N,O){this.d=N,this.f=O,this.type=11,this.c=k.create(N,O)}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(N){return N.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Wi=E;class L{static create(N,O,U=null){if(typeof O=="boolean")return O?j.create(N,U):$.create(N,U);const T=v.get(N);return typeof T=="boolean"?O===(T?"true":"false")?t.INSTANCE:a.INSTANCE:new L(N,O,U)}constructor(N,O,U){this.c=N,this.d=O,this.f=U,this.type=5}cmp(N){return N.type!==this.type?this.type-N.type:le(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=v.get(this.c);if(typeof N=="boolean"){const O=N?"true":"false";return this.d===O?t.INSTANCE:a.INSTANCE}return this}evaluate(N){return N.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(N){return N.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Xi=L;class j{static create(N,O=null){const U=v.get(N);return typeof U=="boolean"?U?t.INSTANCE:a.INSTANCE:new j(N,O)}constructor(N,O){this.c=N,this.d=O,this.type=3}cmp(N){return N.type!==this.type?this.type-N.type:oe(this.c,N.c)}equals(N){return N.type===this.type?this.c===N.c:!1}substituteConstants(){const N=v.get(this.c);return typeof N=="boolean"?N?t.INSTANCE:a.INSTANCE:this}evaluate(N){return!N.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(N){return N.mapNot(this.c)}negate(){return this.d||(this.d=$.create(this.c,this)),this.d}}e.$Yi=j;function x(K,N){if(typeof K=="string"){const O=parseFloat(K);isNaN(O)||(K=O)}return typeof K=="string"||typeof K=="number"?N(K):t.INSTANCE}class ce{static create(N,O,U=null){return x(O,T=>new ce(N,T,U))}constructor(N,O,U){this.c=N,this.d=O,this.f=U,this.type=12}cmp(N){return N.type!==this.type?this.type-N.type:le(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=he.create(this.c,this.d,this)),this.f}}e.$Zi=ce;class X{static create(N,O,U=null){return x(O,T=>new X(N,T,U))}constructor(N,O,U){this.c=N,this.d=O,this.f=U,this.type=13}cmp(N){return N.type!==this.type?this.type-N.type:le(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}e.$1i=X;class ie{static create(N,O,U=null){return x(O,T=>new ie(N,T,U))}constructor(N,O,U){this.c=N,this.d=O,this.f=U,this.type=14}cmp(N){return N.type!==this.type?this.type-N.type:le(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=X.create(this.c,this.d,this)),this.f}}e.$2i=ie;class he{static create(N,O,U=null){return x(O,T=>new he(N,T,U))}constructor(N,O,U){this.c=N,this.d=O,this.f=U,this.type=15}cmp(N){return N.type!==this.type?this.type-N.type:le(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=ce.create(this.c,this.d,this)),this.f}}e.$3i=he;class _{static create(N,O){return new _(N,O)}constructor(N,O){this.d=N,this.f=O,this.type=7,this.c=null}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.d<N.d)return-1;if(this.d>N.d)return 1;const O=this.f?this.f.source:"",U=N.f?N.f.source:"";return O<U?-1:O>U?1:0}equals(N){if(N.type===this.type){const O=this.f?this.f.source:"",U=N.f?N.f.source:"";return this.d===N.d&&O===U}return!1}substituteConstants(){return this}evaluate(N){const O=N.getValue(this.d);return this.f?this.f.test(O):!1}serialize(){const N=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${N}`}keys(){return[this.d]}map(N){return N.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=de.create(this)),this.c}}e.$4i=_;class de{static create(N){return new de(N)}constructor(N){this.c=N,this.type=8}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(N){return new de(this.c.map(N))}negate(){return this.c}}e.$5i=de;function Z(K){let N=null;for(let O=0,U=K.length;O<U;O++){const T=K[O].substituteConstants();if(K[O]!==T&&N===null){N=[];for(let q=0;q<O;q++)N[q]=K[q]}N!==null&&(N[O]=T)}return N===null?K:N}class ne{static create(N,O,U){return ne.d(N,O,U)}constructor(N,O){this.expr=N,this.c=O,this.type=6}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let O=0,U=this.expr.length;O<U;O++){const T=s(this.expr[O],N.expr[O]);if(T!==0)return T}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let O=0,U=this.expr.length;O<U;O++)if(!this.expr[O].equals(N.expr[O]))return!1;return!0}return!1}substituteConstants(){const N=Z(this.expr);return N===this.expr?this:ne.create(N,this.c,!1)}evaluate(N){for(let O=0,U=this.expr.length;O<U;O++)if(!this.expr[O].evaluate(N))return!1;return!0}static d(N,O,U){const T=[];let q=!1;for(const z of N)if(z){if(z.type===1){q=!0;continue}if(z.type===0)return t.INSTANCE;if(z.type===6){T.push(...z.expr);continue}T.push(z)}if(T.length===0&&q)return a.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];T.sort(s);for(let z=1;z<T.length;z++)T[z-1].equals(T[z])&&(T.splice(z,1),z--);if(T.length===1)return T[0];for(;T.length>1;){const z=T[T.length-1];if(z.type!==9)break;T.pop();const te=T.pop(),H=T.length===0,Y=J.create(z.expr.map(V=>ne.create([V,te],null,U)),null,H);Y&&(T.push(Y),T.sort(s))}if(T.length===1)return T[0];if(U){for(let z=0;z<T.length;z++)for(let te=z+1;te<T.length;te++)if(T[z].negate().equals(T[te]))return t.INSTANCE;if(T.length===1)return T[0]}return new ne(T,O)}}serialize(){return this.expr.map(N=>N.serialize()).join(" && ")}keys(){const N=[];for(const O of this.expr)N.push(...O.keys());return N}map(N){return new ne(this.expr.map(O=>O.map(N)),null)}negate(){if(!this.c){const N=[];for(const O of this.expr)N.push(O.negate());this.c=J.create(N,this,!0)}return this.c}}e.$6i=ne;class J{static create(N,O,U){return J.d(N,O,U)}constructor(N,O){this.expr=N,this.c=O,this.type=9}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let O=0,U=this.expr.length;O<U;O++){const T=s(this.expr[O],N.expr[O]);if(T!==0)return T}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let O=0,U=this.expr.length;O<U;O++)if(!this.expr[O].equals(N.expr[O]))return!1;return!0}return!1}substituteConstants(){const N=Z(this.expr);return N===this.expr?this:J.create(N,this.c,!1)}evaluate(N){for(let O=0,U=this.expr.length;O<U;O++)if(this.expr[O].evaluate(N))return!0;return!1}static d(N,O,U){let T=[],q=!1;if(N){for(let z=0,te=N.length;z<te;z++){const H=N[z];if(H){if(H.type===0){q=!0;continue}if(H.type===1)return a.INSTANCE;if(H.type===9){T=T.concat(H.expr);continue}T.push(H)}}if(T.length===0&&q)return t.INSTANCE;T.sort(s)}if(T.length!==0){if(T.length===1)return T[0];for(let z=1;z<T.length;z++)T[z-1].equals(T[z])&&(T.splice(z,1),z--);if(T.length===1)return T[0];if(U){for(let z=0;z<T.length;z++)for(let te=z+1;te<T.length;te++)if(T[z].negate().equals(T[te]))return a.INSTANCE;if(T.length===1)return T[0]}return new J(T,O)}}serialize(){return this.expr.map(N=>N.serialize()).join(" || ")}keys(){const N=[];for(const O of this.expr)N.push(...O.keys());return N}map(N){return new J(this.expr.map(O=>O.map(N)),null)}negate(){if(!this.c){const N=[];for(const O of this.expr)N.push(O.negate());for(;N.length>1;){const O=N.shift(),U=N.shift(),T=[];for(const q of B(O))for(const z of B(U))T.push(ne.create([q,z],null,!1));N.unshift(J.create(T,null,!1))}this.c=J.create(N,this,!0)}return this.c}}e.$7i=J;class W extends ${static{this.d=[]}static all(){return W.d.values()}constructor(N,O,U){super(N,null),this.f=O,typeof U=="object"?W.d.push({...U,key:N}):U!==!0&&W.d.push({key:N,description:U,type:O!=null?typeof O:void 0})}bindTo(N){return N.createKey(this.key,this.f)}getValue(N){return N.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(N){return w.create(this.key,N)}notEqualsTo(N){return L.create(this.key,N)}}e.$8i=W,e.$9i=(0,I.$Qh)("contextKeyService");function oe(K,N){return K<N?-1:K>N?1:0}function le(K,N,O,U){return K<O?-1:K>O?1:N<U?-1:N>U?1:0}function re(K,N){if(K.type===0||N.type===1)return!0;if(K.type===9)return N.type===9?ee(K.expr,N.expr):!1;if(N.type===9){for(const O of N.expr)if(re(K,O))return!0;return!1}if(K.type===6){if(N.type===6)return ee(N.expr,K.expr);for(const O of K.expr)if(re(O,N))return!0;return!1}return K.equals(N)}e.$0i=re;function ee(K,N){let O=0,U=0;for(;O<K.length&&U<N.length;){const T=K[O].cmp(N[U]);if(T<0)return!1;T===0&&O++,U++}return O===K.length}function B(K){return K.type===9?K.expr:[K]}}),define(pe[216],be([1,0,6]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=e.$sm=e.$rm=e.ID=void 0,e.ID="diagnosticsService",e.$rm=(0,D.$Qh)(e.ID);function R(I){return!!I.hostName&&!!I.errorMessage}e.$sm=R;class r{async getPerformanceInfo(P,C){return{}}async getSystemInfo(P,C){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(P,C){return""}async getWorkspaceFileExtensions(P){return{extensions:[]}}async reportWorkspaceStats(P){}}e.$tm=r}),define(pe[81],be([1,0,6]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=void 0,e.$Sn=(0,D.$Qh)("downloadService")}),define(pe[25],be([1,0,6]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Xh=void 0,e.$Xh=(0,D.$Qh)("environmentService"),e.$Yh=(0,D.$Rh)(e.$Xh)}),define(pe[30],be([1,0,179,6]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$bo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=void 0,e.$2n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$3n=new RegExp(e.$2n),e.$4n="__web_extension",e.$5n="skipWalkthrough",e.$6n="extensionsSync",e.$7n="dependecyOrPackExtensionInstall";function r(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$8n=r;function I(h){switch(h){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$9n=I;function P(h,p){switch(h){case 3:return p==="x64"?"win32-x64":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$0n=P;function C(h,p){return p==="web"&&!h.includes("web")}e.$$n=C;function v(h,p,l){return C(p,l)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===l}e.$_n=v;function b(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.$ao=b;var A;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var S;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var y;(function(h){h.Install="install",h.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var u;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(u||(e.InstallOperation=u={})),e.$bo=(0,R.$Qh)("extensionGalleryService");var g;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(g||(e.ExtensionManagementErrorCode=g={}));var d;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(d||(e.ExtensionSignaturetErrorCode=d={}));class f extends Error{constructor(p,l){super(p),this.code=l,this.name=l}}e.$co=f,e.$do=(0,R.$Qh)("extensionManagementService"),e.$eo="extensionsIdentifiers/disabled",e.$fo="extensionsIdentifiers/enabled",e.$go=(0,R.$Qh)("IGlobalExtensionEnablementService"),e.$ho=(0,R.$Qh)("IExtensionTipsService"),e.$io=(0,D.localize)(0,null),e.$jo={value:e.$io,original:"Extensions"},e.$ko={value:(0,D.localize)(1,null),original:"Preferences"}}),define(pe[217],be([1,0,5,2,22,4,51,30]),function(ue,e,D,R,r,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=e.$lp=void 0;function v(f,h){return f?I.URI.revive(h?h.transformIncoming(f):f):void 0}function b(f,h){return h?h.transformOutgoingURI(f):f}function A(f,h){h=h||P.$Nm;const p=f.manifest;return{...(0,P.$Qm)({...f,manifest:void 0},h),manifest:p}}function S(f,h){return f?.profileLocation?(0,P.$Qm)(f,h??P.$Nm):f}function y(f,h){return h?(0,r.$0m)(f,p=>p instanceof I.URI?h.transformOutgoingURI(p):void 0):f}class u{constructor(h,p){this.a=h,this.b=p,this.onInstallExtension=D.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=D.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,p){const l=this.b(h);switch(p){case"onInstallExtension":return D.Event.map(this.onInstallExtension,m=>({...m,profileLocation:m.profileLocation?b(m.profileLocation,l):m.profileLocation}));case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,m=>m.map(c=>({...c,local:c.local?y(c.local,l):c.local,profileLocation:c.profileLocation?b(c.profileLocation,l):c.profileLocation})));case"onUninstallExtension":return D.Event.map(this.onUninstallExtension,m=>({...m,profileLocation:m.profileLocation?b(m.profileLocation,l):m.profileLocation}));case"onDidUninstallExtension":return D.Event.map(this.onDidUninstallExtension,m=>({...m,profileLocation:m.profileLocation?b(m.profileLocation,l):m.profileLocation}));case"onDidUpdateExtensionMetadata":return D.Event.map(this.onDidUpdateExtensionMetadata,m=>y(m,l))}throw new Error("Invalid listen")}async call(h,p,l){const m=this.b(h);switch(p){case"zip":{const c=A(l[0],m),n=await this.a.zip(c);return b(n,m)}case"unzip":return this.a.unzip(v(l[0],m));case"install":return this.a.install(v(l[0],m),S(l[1],m));case"installFromLocation":return this.a.installFromLocation(v(l[0],m),v(l[1],m));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(l[0],v(l[1],m),v(l[2],m));case"getManifest":return this.a.getManifest(v(l[0],m));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(l[0]);case"installFromGallery":return this.a.installFromGallery(l[0],S(l[1],m));case"installGalleryExtensions":{const c=l[0];return this.a.installGalleryExtensions(c.map(({extension:n,options:i})=>({extension:n,options:S(i,m)??{}})))}case"uninstall":return this.a.uninstall(A(l[0],m),S(l[1],m));case"reinstallFromGallery":return this.a.reinstallFromGallery(A(l[0],m));case"getInstalled":return(await this.a.getInstalled(l[0],v(l[1],m))).map(n=>y(n,m));case"toggleAppliationScope":{const c=await this.a.toggleAppliationScope(A(l[0],m),v(l[1],m));return y(c,m)}case"copyExtensions":return this.a.copyExtensions(v(l[0],m),v(l[1],m));case"updateMetadata":{const c=await this.a.updateMetadata(A(l[0],m),l[1],v(l[2],m));return y(c,m)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(l[0],l[1],l[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$lp=u;class g extends R.$Sc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(h){super(),this.m=h,this.c=this.B(new D.$Od),this.f=this.B(new D.$Od),this.g=this.B(new D.$Od),this.h=this.B(new D.$Od),this.j=this.B(new D.$Od),this.B(this.m.listen("onInstallExtension")(p=>this.n(this.c,{...p,source:this.r(p.source)?I.URI.revive(p.source):p.source,profileLocation:I.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(p=>this.n(this.f,p.map(l=>({...l,local:l.local?A(l.local,null):l.local,source:this.r(l.source)?I.URI.revive(l.source):l.source,profileLocation:I.URI.revive(l.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(p=>this.n(this.g,{...p,profileLocation:I.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(p=>this.n(this.h,{...p,profileLocation:I.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(p=>this.j.fire(A(p,null))))}n(h,p){h.fire(p)}r(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(h){const p=await this.getTargetPlatform();return h.allTargetPlatforms.some(l=>(0,C.$_n)(l,h.allTargetPlatforms,p))}zip(h){return Promise.resolve(this.m.call("zip",[h]).then(p=>I.URI.revive(p)))}unzip(h){return Promise.resolve(this.m.call("unzip",[h]))}install(h,p){return Promise.resolve(this.m.call("install",[h,p])).then(l=>A(l,null))}installFromLocation(h,p){return Promise.resolve(this.m.call("installFromLocation",[h,p])).then(l=>A(l,null))}async installExtensionsFromProfile(h,p,l){return(await this.m.call("installExtensionsFromProfile",[h,p,l])).map(c=>A(c,null))}getManifest(h){return Promise.resolve(this.m.call("getManifest",[h]))}installFromGallery(h,p){return Promise.resolve(this.m.call("installFromGallery",[h,p])).then(l=>A(l,null))}async installGalleryExtensions(h){return(await this.m.call("installGalleryExtensions",[h])).map(l=>({...l,local:l.local?A(l.local,null):l.local,source:this.r(l.source)?I.URI.revive(l.source):l.source,profileLocation:I.URI.revive(l.profileLocation)}))}uninstall(h,p){return Promise.resolve(this.m.call("uninstall",[h,p]))}reinstallFromGallery(h){return Promise.resolve(this.m.call("reinstallFromGallery",[h])).then(p=>A(p,null))}getInstalled(h=null,p){return Promise.resolve(this.m.call("getInstalled",[h,p])).then(l=>l.map(m=>A(m,null)))}updateMetadata(h,p,l){return Promise.resolve(this.m.call("updateMetadata",[h,p,l])).then(m=>A(m,null))}toggleAppliationScope(h,p){return this.m.call("toggleAppliationScope",[h,p]).then(l=>A(l,null))}copyExtensions(h,p){return this.m.call("copyExtensions",[h,p])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(h,p,l){const m=await this.m.call("download",[h,p,l]);return I.URI.revive(m)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$mp=g;class d{constructor(h){this.a=h}listen(h,p){throw new Error("Invalid listen")}call(h,p,l){switch(p){case"getConfigBasedTips":return this.a.getConfigBasedTips(I.URI.revive(l[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$np=d}),define(pe[82],be([1,0,6]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=e.$ip=void 0,e.$ip=(0,D.$Qh)("IExtensionSignatureVerificationService");class R{b(){return this.a||(this.a=new Promise((I,P)=>ue(["node-vsce-sign"],async C=>I(C),P))),this.a}async verify(I,P,C){let v;try{v=await this.b()}catch{return!1}return v.verify(I,P,C)}}e.$jp=R}),define(pe[16],be([1,0,62,7,17,10,4,187,6,3,12,76]),function(ue,e,D,R,r,I,P,C,v,b,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileKind=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileOperationResult=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.FileChangeType=e.$rk=e.FileOperation=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.FileSystemProviderErrorCode=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.FileSystemProviderCapabilities=e.$bk=e.FilePermission=e.FileType=e.$ak=e.$_j=void 0,e.$_j=(0,v.$Qh)("fileService");function y(re){return re.create===!0}e.$ak=y;var u;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(u||(e.FileType=u={}));var g;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(g||(e.FilePermission=g={}));function d(re){const ee=re;return!!ee&&typeof ee.onDidChange=="function"}e.$bk=d;var f;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function h(re){return!!(re.capabilities&2)}e.$ck=h;function p(re){return!!(re.capabilities&8)}e.$dk=p;function l(re){return!!(re.capabilities&131072)}e.$ek=l;function m(re){return!!(re.capabilities&4)}e.$fk=m;function c(re){return!!(re.capabilities&16)}e.$gk=c;function n(re){return h(re)?!!(re.capabilities&16384):!1}e.$hk=n;function i(re){return h(re)?!!(re.capabilities&32768):!1}e.$ik=i;function o(re){return!!(re.capabilities&65536)}e.$jk=o;function s(re){return!!(re.capabilities&2048)}e.$kk=s;var t;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class a extends Error{static create(ee,B){const K=new a(ee.toString(),B);return k(K,B),K}constructor(ee,B){super(ee),this.code=B}}e.$lk=a;function $(re,ee){return a.create(re,ee)}e.$mk=$;function w(re){return re||$((0,C.localize)(0,null),t.Unknown)}e.$nk=w;function k(re,ee){return re.name=ee?`${ee} (FileSystemError)`:"FileSystemError",re}e.$ok=k;function E(re){if(!re)return t.Unknown;if(re instanceof a)return re.code;const ee=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!ee)return t.Unknown;switch(ee[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.$pk=E;function L(re){if(re instanceof he)return re.fileOperationResult;switch(E(re)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.$qk=L;var j;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(j||(e.FileOperation=j={}));class x{constructor(ee,B,K){this.resource=ee,this.operation=B,this.target=K}isOperation(ee){return this.operation===ee}}e.$rk=x;var ce;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(ce||(e.FileChangeType=ce={}));class X{static{this.a=null}constructor(ee,B){this.c=B,this.b=void 0,this.d=new S.$V(()=>{const K=D.$Wh.forUris(()=>this.c);return K.fill(this.rawAdded.map(N=>[N,!0])),K}),this.f=new S.$V(()=>{const K=D.$Wh.forUris(()=>this.c);return K.fill(this.rawUpdated.map(N=>[N,!0])),K}),this.g=new S.$V(()=>{const K=D.$Wh.forUris(()=>this.c);return K.fill(this.rawDeleted.map(N=>[N,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of ee){switch(K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}this.b!==X.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=X.a):this.b!==void 0&&(this.b=X.a))}}contains(ee,...B){return this.h(ee,{includeChildren:!1},...B)}affects(ee,...B){return this.h(ee,{includeChildren:!0},...B)}h(ee,B,...K){if(!ee)return!1;const N=K.length>0;return!!((!N||K.includes(1))&&(this.d.value.get(ee)||B.includeChildren&&this.d.value.findSuperstr(ee))||(!N||K.includes(0))&&(this.f.value.get(ee)||B.includeChildren&&this.f.value.findSuperstr(ee))||(!N||K.includes(2))&&(this.g.value.findSubstr(ee)||B.includeChildren&&this.g.value.findSuperstr(ee)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ee){return this.b===ee}hasCorrelation(){return typeof this.b=="number"}}e.$sk=X;function ie(re,ee,B){return!re||!ee||re===ee||ee.length>re.length?!1:(ee.charAt(ee.length-1)!==R.sep&&(ee+=R.sep),B?(0,r.$4e)(re,ee):re.indexOf(ee)===0)}e.$tk=ie;class he extends Error{constructor(ee,B,K){super(ee),this.fileOperationResult=B,this.options=K}}e.$uk=he;class _ extends he{constructor(ee,B,K,N){super(ee,B,N),this.fileOperationResult=B,this.size=K}}e.$vk=_;class de extends he{constructor(ee,B,K){super(ee,2,K),this.stat=B}}e.$wk=de;var Z;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Z||(e.FileOperationResult=Z={})),e.$xk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zk="files.associations",e.$Ak="files.exclude",e.$Bk="files.readonlyInclude",e.$Ck="files.readonlyExclude",e.$Dk="files.readonlyFromPermissions";var ne;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(ne||(e.FileKind=ne={})),e.$Ek="";function J(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}e.$Fk=J;async function W(re,ee){if(!ee.hasProvider(P.URI.from({scheme:re.scheme})))return new Promise(B=>{const K=ee.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===re.scheme&&N.added&&(K.dispose(),B())})})}e.$Gk=W;class oe{static{this.KB=1024}static{this.MB=oe.KB*oe.KB}static{this.GB=oe.MB*oe.KB}static{this.TB=oe.GB*oe.KB}static formatSize(ee){return(0,I.$Df)(ee)||(ee=0),ee<oe.KB?(0,C.localize)(1,null,ee.toFixed(0)):ee<oe.MB?(0,C.localize)(2,null,(ee/oe.KB).toFixed(2)):ee<oe.GB?(0,C.localize)(3,null,(ee/oe.MB).toFixed(2)):ee<oe.TB?(0,C.localize)(4,null,(ee/oe.GB).toFixed(2)):(0,C.localize)(5,null,(ee/oe.TB).toFixed(2))}}e.$Hk=oe;function le(re){const ee=typeof re=="string"||re?.scheme===A.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===A.Schemas.file?1024*oe.MB:ee?10*oe.MB:b.$p?50*oe.MB:1024*oe.MB}e.$Ik=le}),define(pe[109],be([1,0,15,11,188,16]),function(ue,e,D,R,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;async function P(A,S,y,u,g,d){let f;try{await C(A,S,y,u,g,d)}catch(h){f=h}finally{f&&g.errorTransformer&&(f=g.errorTransformer(f)),typeof f<"u"&&y.error(f),y.end()}}e.$Qp=P;async function C(A,S,y,u,g,d){v(d);const f=await A.open(S,{create:!1});try{v(d);let h=0,p=0,l=g&&typeof g.length=="number"?g.length:void 0,m=D.$ce.alloc(Math.min(g.bufferSize,typeof l=="number"?l:g.bufferSize)),c=g&&typeof g.position=="number"?g.position:0,n=0;do p=await A.read(f,c,m.buffer,n,m.byteLength-n),c+=p,n+=p,h+=p,typeof l=="number"&&(l-=p),n===m.byteLength&&(await y.write(u(m)),m=D.$ce.alloc(Math.min(g.bufferSize,typeof l=="number"?l:g.bufferSize)),n=0);while(p>0&&(typeof l!="number"||l>0)&&v(d)&&b(h,g));if(n>0){let i=n;typeof l=="number"&&(i=Math.min(n,l)),y.write(u(m.slice(0,i)))}}catch(h){throw(0,I.$nk)(h)}finally{await A.close(f)}}function v(A){if(A.isCancellationRequested)throw(0,R.$6)();return!0}function b(A,S){if(typeof S?.limits?.size=="number"&&A>S.limits.size)throw(0,I.$mk)((0,r.localize)(0,null),I.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(pe[54],be([1,0,79,2,7,3,4,16]),function(ue,e,D,R,r,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=e.$Xp=e.$Wp=e.$Vp=e.$Up=e.$Tp=e.$Sp=void 0;function v(h){return h.recursive===!0}e.$Sp=v;class b extends R.$Sc{static{this.a=5}constructor(p,l,m,c){super(),this.h=p,this.j=l,this.m=m,this.n=c,this.c=this.B(new R.$Tc),this.f=void 0,this.g=0}s(){const p=new R.$Rc;this.c.value=p,this.b=this.r(p),this.b.setVerboseLogging(this.m),p.add(this.b.onDidChangeFile(l=>this.h(l))),p.add(this.b.onDidLogMessage(l=>this.j(l))),p.add(this.b.onDidError(l=>this.t(l)))}t(p){this.n.restartOnError?this.g<b.a&&this.f?(this.w(`restarting watcher after error: ${p}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${p}`):this.w(p)}u(p){this.g++,this.s(),this.watch(p)}async watch(p){this.f=p,await this.b?.watch(p)}async setVerboseLogging(p){this.m=p,await this.b?.setVerboseLogging(p)}w(p){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${p}`})}y(p){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${p}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Tp=b;class A extends b{constructor(p,l,m){super(p,l,m,{type:"node.js",restartOnError:!1})}}e.$Up=A;class S extends b{constructor(p,l,m){super(p,l,m,{type:"universal",restartOnError:!0})}}e.$Vp=S;function y(h){return h.map(p=>({type:p.type,resource:P.URI.revive(p.resource),cId:p.cId}))}e.$Wp=y;function u(h){const p=new f;for(const l of h)p.processEvent(l);return p.coalesce()}e.$Xp=u;function g(h,p){return typeof p=="string"&&!p.startsWith(D.$tj)&&!(0,r.$ic)(p)?{base:h,pattern:p}:p}e.$Yp=g;function d(h,p){const l=[];for(const m of p)l.push((0,D.$xj)(g(h,m)));return l}e.$Zp=d;class f{constructor(){this.a=new Set,this.b=new Map}c(p){return I.$l?p.resource.fsPath:p.resource.fsPath.toLowerCase()}processEvent(p){const l=this.b.get(this.c(p));let m=!1;if(l){const c=l.type,n=p.type;l.resource.fsPath!==p.resource.fsPath&&(p.type===2||p.type===1)?m=!0:c===1&&n===2?(this.b.delete(this.c(p)),this.a.delete(l)):c===2&&n===1?l.type=0:c===1&&n===0||(l.type=n)}else m=!0;m&&(this.a.add(p),this.b.set(this.c(p),p))}coalesce(){const p=[],l=[];return Array.from(this.a).filter(m=>m.type!==2?(p.push(m),!1):!0).sort((m,c)=>m.resource.fsPath.length-c.resource.fsPath.length).filter(m=>l.some(c=>(0,C.$tk)(m.resource.fsPath,c,!I.$l))?!1:(l.push(m.resource.fsPath),!0)).concat(p)}}}),define(pe[218],be([1,0,15,39,11,5,2,48,23,16,54]),function(ue,e,D,R,r,I,P,C,v,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=e.$vN=void 0,e.$vN="localFilesystem";class S extends P.$Sc{constructor(u,g){super(),this.a=u,this.b=g,this.onDidChangeCapabilities=I.Event.None,this.f=this.B(new I.$Od),this.onDidChangeFile=this.f.event,this.g=this.B(new I.$Od),this.onDidWatchError=this.g.event,this.h=(0,v.$fg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(u){return this.a.call("stat",[u])}readdir(u){return this.a.call("readdir",[u])}async readFile(u,g){const{buffer:d}=await this.a.call("readFile",[u,g]);return d}readFileStream(u,g,d){const f=(0,C.$3d)(p=>D.$ce.concat(p.map(l=>D.$ce.wrap(l))).buffer),h=new P.$Rc;return h.add(this.a.listen("readFileStream",[u,g])(p=>{if(p instanceof D.$ce)f.write(p.buffer);else{if(p==="end")f.end();else{let l;if(p instanceof Error)l=p;else{const m=p;l=(0,b.$mk)(m.message??(0,R.$Bi)(m),m.code??b.FileSystemProviderErrorCode.Unknown)}f.error(l),f.end()}h.dispose()}})),h.add(d.onCancellationRequested(()=>{f.error((0,r.$6)()),f.end(),h.dispose()})),f}writeFile(u,g,d){return this.a.call("writeFile",[u,D.$ce.wrap(g),d])}open(u,g){return this.a.call("open",[u,g])}close(u){return this.a.call("close",[u])}async read(u,g,d,f,h){const[p,l]=await this.a.call("read",[u,g,h]);return d.set(p.buffer.slice(0,l),f),l}write(u,g,d,f,h){return this.a.call("write",[u,g,D.$ce.wrap(d),f,h])}mkdir(u){return this.a.call("mkdir",[u])}delete(u,g){return this.a.call("delete",[u,g])}rename(u,g,d){return this.a.call("rename",[u,g,d])}copy(u,g,d){return this.a.call("copy",[u,g,d])}cloneFile(u,g){return this.a.call("cloneFile",[u,g])}j(){this.B(this.a.listen("fileChange",[this.h])(u=>{if(Array.isArray(u)){const g=u;this.f.fire((0,A.$Wp)(g))}else{const g=u;this.g.fire(g)}}))}watch(u,g){const d=(0,v.$fg)();return this.a.call("watch",[this.h,d,u,g]),(0,P.$Qc)(()=>this.a.call("unwatch",[this.h,d]))}}e.$wN=S}),define(pe[219],be([1,0,27,14,20,40,2,97,7,3,19,4,168,21,54]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=void 0;class d extends P.$Sc{static{this.a=100}static{this.b=75}constructor(p,l,m,c){super(),this.m=p,this.n=l,this.r=m,this.s=c,this.c=this.B(new R.$0g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},n=>this.n(n))),this.f=this.B(new R.$9g(n=>this.z(n),d.b)),this.g=(0,g.$Zp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,g.$Zp)(this.m.path,this.m.includes):void 0,this.j=new r.$Yd,this.ready=this.t()}async t(){try{const p=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const l=await u.Promises.stat(p);this.B(await this.w(p,l.isDirectory()))}catch(p){p.code!=="ENOENT"?this.D(p):this.G(p)}}async u(p){let l=p.path;try{l=await u.Promises.realpath(p.path),p.path===l&&(l=await(0,y.$0p)(p.path)??p.path),p.path!==l&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${p.path}, real: ${l})`)}catch{}return l}async w(p,l){if(b.$k&&(0,I.$Yf)(p,"/Volumes/",!0))return this.D(`Refusing to watch ${p} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),P.$Sc.None;const m=new r.$Yd(this.j.token),c=new P.$Rc;try{const n=S.URI.file(this.m.path),i=(0,v.$nc)(p),o=(0,D.watch)(p);c.add((0,P.$Qc)(()=>{o.removeAllListeners(),o.close()})),this.G(`Started watching: '${p}'`);const s=new Set;if(l)try{for(const a of await u.Promises.readdir(p))s.add(a)}catch(a){this.D(a)}const t=new Map;c.add((0,P.$Qc)(()=>{for(const[,a]of t)a.dispose();t.clear()})),o.on("error",(a,$)=>{this.D(`Failed to watch ${p} for changes using fs.watch() (${a}, ${$})`),this.dispose()}),o.on("change",(a,$)=>{if(m.token.isCancellationRequested)return;this.G(`[raw] ["${a}"] ${$}`);let w="";if($&&(w=$.toString(),b.$k&&(w=(0,C.$pl)(w))),!(!w||a!=="change"&&a!=="rename"))if(l)if(a==="rename"){t.get(w)?.dispose();const k=setTimeout(async()=>{if(t.delete(w),w===i&&!await u.Promises.exists(p)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const E=await this.C((0,v.$jc)(p,w));if(m.token.isCancellationRequested)return;let L;E?s.has(w)?L=0:(L=1,s.add(w)):(s.delete(w),L=2),this.y({resource:(0,A.$wg)(n,w),type:L,cId:this.m.correlationId})},d.a);t.set(w,(0,P.$Qc)(()=>clearTimeout(k)))}else{let k;s.has(w)?k=0:(k=1,s.add(w)),this.y({resource:(0,A.$wg)(n,w),type:k,cId:this.m.correlationId})}else if(a==="rename"||w!==i){const k=setTimeout(async()=>{const E=await u.Promises.exists(p);m.token.isCancellationRequested||(E?(this.y({resource:n,type:0,cId:this.m.correlationId},!0),c.add(await this.w(p,!1))):(this.y({resource:n,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},d.a);c.clear(),c.add((0,P.$Qc)(()=>clearTimeout(k)))}else this.y({resource:n,type:0,cId:this.m.correlationId},!0)})}catch(n){await u.Promises.exists(p)&&!m.token.isCancellationRequested&&this.D(`Failed to watch ${p} for changes using fs.watch() (${n.toString()})`)}return(0,P.$Qc)(()=>{m.dispose(!0),c.dispose()})}y(p,l=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.resource.fsPath}`),!l&&this.g.some(m=>m(p.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${p.resource.fsPath}`):!l&&this.h&&this.h.length>0&&!this.h.some(m=>m(p.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${p.resource.fsPath}`):this.f.work(p))}z(p){const l=(0,g.$Xp)(p);if(l.length>0){if(this.s)for(const c of l)this.G(` >> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`);this.c.work(l)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(p){if(b.$l)return u.Promises.exists(p);try{const l=(0,v.$nc)(p);return(await u.Promises.readdir((0,v.$mc)(p))).some(c=>c===l)}catch(l){return this.G(l),!1}}setVerboseLogging(p){this.s=p}D(p){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${p}`})}F(p){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${p}`})}G(p){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${p}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$aq=d;async function f(h,p,l,m,c=512){const n=await u.Promises.open(h,"r"),i=Buffer.allocUnsafe(c),o=new r.$Yd(m);let s,t=!1;const a={path:h,excludes:[],recursive:!1},$=new d(a,w=>{(async()=>{for(const{type:k}of w)if(k===0){if(t)return;t=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:E}=await u.Promises.read(n,i,0,c,null);if(!E||o.token.isCancellationRequested)break;p(i.slice(0,E))}}catch(E){s=new Error(E),o.dispose(!0)}finally{t=!1}}})()});return await $.ready,l(),new Promise((w,k)=>{o.token.onCancellationRequested(async()=>{$.dispose();try{await u.Promises.close(n)}catch(E){s=new Error(E)}s?k(s):w()})})}e.$bq=f}),define(pe[220],be([1,0,5,79,2,3,219]),function(ue,e,D,R,r,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;class C extends r.$Sc{constructor(){super(...arguments),this.a=this.B(new D.$Od),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Od),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(b){const A=this.j(b),S=A.filter(u=>{const g=this.c.get(u.path);return g?!(0,R.$Bj)(g.request.excludes,u.excludes)||!(0,R.$Bj)(g.request.includes,u.includes):!0}),y=Array.from(this.c.values()).filter(({request:u})=>!A.find(g=>g.path===u.path&&(0,R.$Bj)(g.excludes,u.excludes)&&(0,R.$Bj)(g.includes,u.includes))).map(({request:u})=>u.path);S.length&&this.m(`Request to start watching: ${S.map(u=>`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"}, correlationId: ${typeof u.correlationId=="number"?u.correlationId:"<none>"})`).join(",")}`),y.length&&this.m(`Request to stop watching: ${y.join(",")}`);for(const u of y)this.h(u);for(const u of S)this.g(u)}g(b){const A=new P.$aq(b,y=>this.a.fire(y),y=>this.b.fire(y),this.f),S={request:b,instance:A};this.c.set(b.path,S)}async stop(){for(const[b]of this.c)this.h(b);this.c.clear()}h(b){const A=this.c.get(b);A&&(this.c.delete(b),A.instance.dispose())}j(b){const A=new Map;for(const S of b){const y=I.$l?S.path:S.path.toLowerCase();let u=A.get(S.correlationId);u||(u=new Map,A.set(S.correlationId,u)),u.set(y,S)}return Array.from(A.values()).map(S=>Array.from(S.values())).flat()}async setVerboseLogging(b){this.f=b;for(const[,A]of this.c)A.instance.setVerboseLogging(b)}m(b){this.f&&this.b.fire({type:"trace",message:this.n(b)})}n(b,A){return A?`[File Watcher (node.js)] ${b} (path: ${A.request.path})`:`[File Watcher (node.js)] ${b}`}}e.$cq=C}),define(pe[221],be([1,0,54,220]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;class r extends D.$Up{constructor(P,C,v){super(P,C,v),this.s()}r(P){return P.add(new R.$cq)}}e.$dq=r}),define(pe[222],be([1,0,12,43,107,54]),function(ue,e,D,R,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;class P extends I.$Vp{constructor(v,b,A){super(v,b,A),this.s()}r(v){const b=v.add(new r.$7p(D.$dg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(b.onDidProcessExit(({code:A,signal:S})=>this.t(`terminated by itself with code ${A}, signal: ${S}`))),R.ProxyChannel.toService((0,R.$xh)(b.getChannel("watcher")))}}e.$8p=P}),define(pe[83],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=void 0;class D{constructor(...r){this.a=new Map;for(const[I,P]of r)this.set(I,P)}set(r,I){const P=this.a.get(r);return this.a.set(r,I),P}has(r){return this.a.has(r)}get(r){return this.a.get(r)}}e.$Oh=D}),define(pe[110],be([1,0,14,11,2,66,215,6,83,96]),function(ue,e,D,R,r,I,P,C,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=void 0;const A=!1;class S extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class y{constructor(f=new v.$Oh,h=!1,p,l=A){this.f=f,this.g=h,this.h=p,this.i=l,this.o=new Set,this.f.set(C.$Ph,this),this._globalGraph=l?p?._globalGraph??new P.$gq(m=>m):void 0}createChild(f){return new y(f,this.g,this,this.i)}invokeFunction(f,...h){const p=g.traceInvocation(this.i,f);let l=!1;try{return f({get:c=>{if(l)throw(0,R.$8)("service accessor is only valid during the invocation of its target method");const n=this.m(c,p);if(!n)throw new Error(`[invokeFunction] unknown service '${c}'`);return n}},...h)}finally{l=!0,p.stop()}}createInstance(f,...h){let p,l;return f instanceof I.$Nh?(p=g.traceCreation(this.i,f.ctor),l=this.j(f.ctor,f.staticArguments.concat(h),p)):(p=g.traceCreation(this.i,f),l=this.j(f,h,p)),p.stop(),l}j(f,h=[],p){const l=C._util.getServiceDependencies(f).sort((n,i)=>n.index-i.index),m=[];for(const n of l){const i=this.m(n.id,p);i||this.u(`[createInstance] ${f.name} depends on UNKNOWN service ${n.id}.`,!1),m.push(i)}const c=l.length>0?l[0].index:h.length;if(h.length!==c){console.trace(`[createInstance] First service dependency of ${f.name} at position ${c+1} conflicts with ${h.length} static arguments`);const n=c-h.length;n>0?h=h.concat(new Array(n)):h=h.slice(0,c)}return Reflect.construct(f,h.concat(m))}k(f,h){if(this.f.get(f)instanceof I.$Nh)this.f.set(f,h);else if(this.h)this.h.k(f,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(f){const h=this.f.get(f);return!h&&this.h?this.h.l(f):h}m(f,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const p=this.l(f);return p instanceof I.$Nh?this.q(f,p,h.branch(f,!0)):(h.branch(f,!1),p)}q(f,h,p){if(this.o.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.o.add(f);try{return this.r(f,h,p)}finally{this.o.delete(f)}}r(f,h,p){const l=new P.$gq(n=>n.id.toString());let m=0;const c=[{id:f,desc:h,_trace:p}];for(;c.length;){const n=c.pop();if(l.lookupOrInsertNode(n),m++>1e3)throw new S(l);for(const i of C._util.getServiceDependencies(n.desc.ctor)){const o=this.l(i.id);if(o||this.u(`[createInstance] ${f} depends on ${i.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(i.id)),o instanceof I.$Nh){const s={id:i.id,desc:o,_trace:n._trace.branch(i.id,!0)};l.insertEdge(n,s),c.push(s)}}}for(;;){const n=l.roots();if(n.length===0){if(!l.isEmpty())throw new S(l);break}for(const{data:i}of n){if(this.l(i.id)instanceof I.$Nh){const s=this.s(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this.k(i.id,s)}l.removeNode(i)}}return this.l(f)}s(f,h,p=[],l,m){if(this.f.get(f)instanceof I.$Nh)return this.t(f,h,p,l,m);if(this.h)return this.h.s(f,h,p,l,m);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(f,h,p=[],l,m){if(l){const c=new y(void 0,this.g,this,this.i);c.c=String(f);const n=new Map,i=new D.$_g(()=>{const o=c.j(h,p,m);for(const[s,t]of n){const a=o[s];if(typeof a=="function")for(const $ of t)a.apply(o,$)}return n.clear(),o});return new Proxy(Object.create(null),{get(o,s){if(!i.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let $=n.get(s);return $||($=new b.$2c,n.set(s,$)),(k,E,L)=>{const j=$.push([k,E,L]);return(0,r.$Qc)(j)}}if(s in o)return o[s];const t=i.value;let a=t[s];return typeof a!="function"||(a=a.bind(t),o[s]=a),a},set(o,s,t){return i.value[s]=t,!0},getPrototypeOf(o){return h.prototype}})}else return this.j(h,p,m)}u(f,h){if(h&&console.warn(f),this.g)throw new Error(f)}}e.$hq=y;var u;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(u||(u={}));class g{static{this.all=new Set}static{this.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(f,h){return f?new g(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(f,h){return f?new g(1,h.name):g.c}static{this.f=0}constructor(f,h){this.type=f,this.name=h,this.g=Date.now(),this.h=[]}branch(f,h){const p=new g(3,f.toString());return this.h.push([f,h,p]),p}stop(){const f=Date.now()-this.g;g.f+=f;let h=!1;function p(m,c){const n=[],i=new Array(m+1).join("	");for(const[o,s,t]of c.h)if(s&&t){h=!0,n.push(`${i}CREATES -> ${o}`);const a=p(m+1,t);a&&n.push(a)}else n.push(`${i}uses -> ${o}`);return n.join(`
`)}const l=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(f>2||h)&&g.all.add(l.join(`
`))}}e.$iq=g}),define(pe[223],be([1,0,6]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.$3u=void 0,e.$3u=(0,D.$Qh)("labelService");var R;(function(r){r[r.SHORT=0]="SHORT",r[r.MEDIUM=1]="MEDIUM",r[r.LONG=2]="LONG"})(R||(e.Verbosity=R={}))});var Ae=this&&this.__param||function(ue,e){return function(D,R){e(D,R,ue)}};define(pe[84],be([1,0,20,2,3,190,30,6]),function(ue,e,D,R,r,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=e.$Vq=void 0;function v(A){return A.tags.find(S=>S.startsWith("lp-"))?.split("lp-")[1]}e.$Vq=v,e.$Wq=(0,C.$Qh)("languagePackService");let b=class extends R.$Sc{constructor(S){super(),this.c=S}async getAvailableLanguages(){const S=new D.$Yd;setTimeout(()=>S.cancel(),1e3);let y;try{y=await this.c.query({text:'category:"language packs"',pageSize:20},S.token)}catch{return[]}const g=y.firstPage.filter(d=>d.properties.localizedLanguages?.length&&d.tags.some(f=>f.startsWith("lp-"))).map(d=>{const f=d.properties.localizedLanguages?.[0],h=v(d);return{...this.f(h,f,d),extensionId:d.identifier.id,galleryExtension:d}});return g.push(this.f("en","English")),g}f(S,y,u){const g=y??S;let d;if(g!==S&&(d=`(${S})`),S.toLowerCase()===r.$w.toLowerCase()&&(d??="",d+=(0,I.localize)(0,null)),u?.installCount){d??="";const f=u.installCount;let h;f>1e6?h=`${Math.floor(f/1e5)/10}M`:f>1e3?h=`${Math.floor(f/1e3)}K`:h=String(f),d+=` $(cloud-download) ${h}`}return{id:S,label:g,description:d}}};e.$Xq=b,e.$Xq=b=Oe([Ae(0,P.$bo)],b)}),define(pe[13],be([1,0,39,5,60,2,26,3,19,10,4,67,6]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.log=e.$bj=e.LogLevel=e.$aj=e.$_i=e.$$i=void 0,e.$$i=(0,y.$Qh)("logService"),e.$_i=(0,y.$Qh)("loggerService");function u(){return new Date().toISOString()}function g(k){return(0,b.$Df)(k)}e.$aj=g;var d;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(d||(e.LogLevel=d={})),e.$bj=d.Info;function f(k,E,L){switch(E){case d.Trace:k.trace(L);break;case d.Debug:k.debug(L);break;case d.Info:k.info(L);break;case d.Warning:k.warn(L);break;case d.Error:k.error(L);break;case d.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=f;function h(k,E=!1){let L="";for(let j=0;j<k.length;j++){let x=k[j];if(x instanceof Error&&(x=(0,D.$Bi)(x,E)),typeof x=="object")try{x=JSON.stringify(x)}catch{}L+=(j>0?" ":"")+x}return L}class p extends I.$Sc{constructor(){super(...arguments),this.b=e.$bj,this.c=this.B(new R.$Od),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==d.Off&&this.b<=E}}e.$dj=p;class l extends p{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...L){this.f(d.Trace)&&this.g(d.Trace,h([E,...L],!0))}debug(E,...L){this.f(d.Debug)&&this.g(d.Debug,h([E,...L]))}info(E,...L){this.f(d.Info)&&this.g(d.Info,h([E,...L]))}warn(E,...L){this.f(d.Warning)&&this.g(d.Warning,h([E,...L]))}error(E,...L){if(this.f(d.Error))if(E instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=E.stack,this.g(d.Error,h(j))}else this.g(d.Error,h([E,...L]))}flush(){}}e.$ej=l;class m extends p{constructor(E=e.$bj){super(),this.setLevel(E),this.g=!C.$j}trace(E,...L){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,E,...L):console.log(`[main ${u()}]`,E,...L))}debug(E,...L){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,E,...L):console.log(`[main ${u()}]`,E,...L))}info(E,...L){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,E,...L):console.log(`[main ${u()}]`,E,...L))}warn(E,...L){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,E,...L):console.warn(`[main ${u()}]`,E,...L))}error(E,...L){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,E,...L):console.error(`[main ${u()}]`,E,...L))}dispose(){}flush(){}}e.$fj=m;class c extends p{constructor(E=e.$bj,L=!0){super(),this.g=L,this.setLevel(E)}trace(E,...L){this.f(d.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...L):console.log(E,...L))}debug(E,...L){this.f(d.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...L):console.log(E,...L))}info(E,...L){this.f(d.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...L):console.log(E,...L))}warn(E,...L){this.f(d.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...L):console.log(E,...L))}error(E,...L){this.f(d.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...L):console.error(E,...L))}dispose(){}flush(){}}e.$gj=c;class n extends p{constructor(E,L=e.$bj){super(),this.g=E,this.setLevel(L)}trace(E,...L){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(E),...L])}debug(E,...L){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(E),...L])}info(E,...L){this.f(d.Info)&&this.g.log(d.Info,[this.h(E),...L])}warn(E,...L){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(E),...L])}error(E,...L){this.f(d.Error)&&this.g.log(d.Error,[this.h(E),...L])}h(E){return typeof E=="string"?E:(0,D.$Bi)(E,this.f(d.Trace))}dispose(){}flush(){}}e.$hj=n;class i extends p{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const L of this.g)L.setLevel(E);super.setLevel(E)}trace(E,...L){for(const j of this.g)j.trace(E,...L)}debug(E,...L){for(const j of this.g)j.debug(E,...L)}info(E,...L){for(const j of this.g)j.info(E,...L)}warn(E,...L){for(const j of this.g)j.warn(E,...L)}error(E,...L){for(const j of this.g)j.error(E,...L)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose()}}e.$ij=i;class o extends I.$Sc{constructor(E,L,j){if(super(),this.h=E,this.j=L,this.b=new P.$Ac,this.c=this.B(new R.$Od),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$Od),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$Od),this.onDidChangeVisibility=this.g.event,j)for(const x of j)this.b.set(x.resource,{logger:void 0,info:x})}m(E){return(0,b.$zf)(E)?[...this.b.values()].find(L=>L.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,L){const j=this.n(E),x=(0,b.$zf)(E)?E:L?.id??(0,r.$Ei)(j.toString()).toString(16);let ce=this.b.get(j)?.logger;const X=L?.logLevel==="always"?d.Trace:L?.logLevel;ce||(ce=this.s(j,X??this.getLogLevel(j)??this.h,{...L,id:x}));const ie={logger:ce,info:{resource:j,id:x,logLevel:X,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId,when:L?.when}};return this.registerLogger(ie.info),this.b.set(j,ie),ce}n(E){return(0,b.$zf)(E)?(0,v.$wg)(this.j,`${E}.log`):E}setLogLevel(E,L){if(A.URI.isUri(E)){const j=E,x=L,ce=this.b.get(j);ce&&x!==ce.info.logLevel&&(ce.info.logLevel=x===this.h?void 0:x,ce.logger?.setLevel(x),this.b.set(ce.info.resource,ce),this.f.fire([j,x]))}else{this.h=E;for(const[j,x]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&x.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,L){const j=this.m(E);j&&L!==!j.info.hidden&&(j.info.hidden=!L,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,L]))}getLogLevel(E){let L;return E&&(L=this.b.get(E)?.info.logLevel),L??this.h}registerLogger(E){const L=this.b.get(E.resource);L?L.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const L=this.b.get(E);L&&(L.logger&&L.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[L.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$jj=o;class s{constructor(){this.onDidChangeLogLevel=new R.$Od().event}setLevel(E){}getLevel(){return d.Info}trace(E,...L){}debug(E,...L){}info(E,...L){}warn(E,...L){}error(E,...L){}critical(E,...L){}dispose(){}flush(){}}e.$kj=s;class t extends s{}e.$lj=t;function a(k){if(k.verbose)return d.Trace;if(typeof k.logLevel=="string"){const E=w(k.logLevel.toLowerCase());if(E!==void 0)return E}return e.$bj}e.$mj=a;function $(k){switch(k){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}e.$nj=$;function w(k){switch(k){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.$oj=w,e.$pj=new S.$8i("logLevel",$(d.Info))}),define(pe[224],be([1,0,18,14,11,5,2,7,54,13]),function(ue,e,D,R,r,I,P,C,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;class A extends P.$Sc{constructor(y,u){super(),this.a=y,this.b=u,this.c=this.B(new I.$Od),this.onDidChangeFile=this.c.event,this.g=this.B(new I.$Od),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new R.$Sg(0)),this.w=[],this.y=this.B(new R.$Sg(0))}watch(y,u){return u.recursive||this.b?.watcher?.forceUniversal?this.n(y,u):this.z(y,u)}n(y,u){const g={path:this.H(y),excludes:u.excludes,includes:u.includes,recursive:u.recursive,correlationId:u.correlationId},d=(0,D.$Ub)(this.j,g);return this.r(),(0,P.$Qc)(()=>{d(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(y=>(0,r.$1)(y))}s(){this.h||(this.h=this.B(this.t(u=>this.c.fire((0,v.$Wp)(u)),u=>this.G(u),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const u of this.j)(0,v.$Sp)(u)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const u of this.j)(0,v.$Sp)(u)&&y.includes(u.path)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(y,u){const g={path:this.H(y),excludes:u.excludes,includes:u.includes,recursive:!1,correlationId:u.correlationId},d=(0,D.$Ub)(this.w,g);return this.C(),(0,P.$Qc)(()=>{d(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(y=>(0,r.$1)(y))}D(){return this.u||(this.u=this.B(this.F(y=>this.c.fire((0,v.$Wp)(y)),y=>this.G(y),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)}))),this.u.watch(this.w)}G(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}H(y){return(0,C.$hc)(y.fsPath)}}e.$1p=A}),define(pe[111],be([1,0,18,14,15,20,5,60,47,2,62,12,41,19,48,186,16,109,13,11]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u,g,d,f,h,p,l){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;let c=class extends b.$Sc{static{m=this}constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new P.$Od),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new P.$Od),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new P.$Od),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new P.$Od),this.onDidRunOperation=this.r.event,this.X=this.B(new P.$Od),this.Y=this.B(new P.$Od),this.onDidFilesChange=this.Y.event,this.Z=this.B(new P.$Od),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new R.$4g)}registerProvider(i,o){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${i}`);const s=new b.$Rc;return this.h.set(i,o),this.c.fire({added:!0,scheme:i,provider:o}),s.add(o.onDidChangeFile(t=>{const a=new f.$sk(t,!this.S(o));this.X.fire(a),a.hasCorrelation()||this.Y.fire(a)})),typeof o.onDidWatchError=="function"&&s.add(o.onDidWatchError(t=>this.Z.fire(new Error(t)))),s.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:i}))),(0,b.$Qc)(()=>{this.c.fire({added:!1,scheme:i,provider:o}),this.h.delete(i),(0,b.$Nc)(s)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const o=[];this.f.fire({scheme:i,join(s){o.push(s)}}),!this.h.has(i)&&await R.Promises.settled(o)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,o){const s=this.h.get(i.scheme);return!!(s&&s.capabilities&o)}listCapabilities(){return v.Iterable.map(this.h,([i,o])=>({scheme:i,capabilities:o.capabilities}))}async j(i){if(!(0,u.$Ag)(i))throw new f.$uk((0,d.localize)(0,null,this.sb(i)),8);await this.activateProvider(i.scheme);const o=this.h.get(i.scheme);if(!o){const s=new l.$bb;throw s.message=(0,d.localize)(1,null,i.toString()),s}return o}async m(i){const o=await this.j(i);if((0,f.$fk)(o)||(0,f.$ck)(o)||(0,f.$gk)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const o=await this.j(i);if((0,f.$fk)(o)||(0,f.$ck)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,o){try{return await this.s(i,o)}catch(s){throw(0,f.$pk)(s)===f.FileSystemProviderErrorCode.FileNotFound?new f.$uk((0,d.localize)(2,null,this.sb(i)),1):(0,f.$nk)(s)}}async s(i,o){const s=await this.j(i),t=this.S(s),a=o?.resolveTo,$=o?.resolveSingleChildDescendants,w=o?.resolveMetadata,k=await s.stat(i);let E;return this.t(s,i,k,void 0,!!w,(L,j)=>(E||(E=A.$Wh.forUris(()=>!t),E.set(i,!0),a&&E.fill(!0,a)),E.get(L.resource)||E.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&$?j===1:!1))}async t(i,o,s,t,a,$){const{providerExtUri:w}=this.R(i),k={resource:o,name:w.basename(o),isFile:(s.type&f.FileType.File)!==0,isDirectory:(s.type&f.FileType.Directory)!==0,isSymbolicLink:(s.type&f.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&f.FilePermission.Readonly)||!!(i.capabilities&2048),locked:!!((s.permissions??0)&f.FilePermission.Locked),etag:(0,f.$Fk)({mtime:s.mtime,size:s.size}),children:void 0};if(k.isDirectory&&$(k,t)){try{const E=await i.readdir(o),L=await R.Promises.settled(E.map(async([j,x])=>{try{const ce=w.joinPath(o,j),X=a?await i.stat(ce):{type:x};return await this.t(i,ce,X,E.length,a,$)}catch(ce){return this.b.trace(ce),null}}));k.children=(0,D.$Hb)(L)}catch(E){this.b.trace(E),k.children=[]}return k}return k}async resolveAll(i){return R.Promises.settled(i.map(async o=>{try{return{stat:await this.s(o.resource,o.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(i){const o=await this.j(i),s=await o.stat(i);return this.t(o,i,s,void 0,!0,()=>!1)}async exists(i){const o=await this.j(i);try{return!!await o.stat(i)}catch{return!1}}async canCreateFile(i,o){try{await this.u(i,o)}catch(s){return s}return!0}async u(i,o){if(!o?.overwrite&&await this.exists(i))throw new f.$uk((0,d.localize)(3,null,this.sb(i)),3,o)}async createFile(i,o=r.$ce.fromString(""),s){await this.u(i,s);const t=await this.writeFile(i,o);return this.r.fire(new f.$rk(i,0,t)),t}async writeFile(i,o,s){const t=this.qb(await this.n(i),i),{providerExtUri:a}=this.R(t);let $=s;if((0,f.$ik)(t)&&!$?.atomic){const w=t.enforceAtomicWriteFile?.(i);w&&($={...s,atomic:w})}try{await this.w(t,i,$)||await this.U(t,a.dirname(i));let k;if((0,f.$ck)(t)&&!(o instanceof r.$ce))if((0,g.$1d)(o)){const E=await(0,g.$8d)(o,3);E.ended?k=r.$ce.concat(E.buffer):k=E}else k=(0,g.$5d)(o,E=>r.$ce.concat(E),3);else k=o;!(0,f.$fk)(t)||(0,f.$ck)(t)&&k instanceof r.$ce||(0,f.$ck)(t)&&(0,f.$ik)(t)&&$?.atomic?await this.hb(t,i,$,k):await this.db(t,i,$,k instanceof r.$ce?(0,r.$ne)(k):k),this.r.fire(new f.$rk(i,4))}catch(w){throw new f.$uk((0,d.localize)(4,null,this.sb(i),(0,f.$nk)(w).toString()),(0,f.$qk)(w),$)}return this.resolve(i,{resolveMetadata:!0})}async w(i,o,s){const t=!!s?.unlock;if(t&&!(i.capabilities&8192))throw new Error((0,d.localize)(5,null,this.sb(o)));if(!!s?.atomic){if(!(i.capabilities&32768))throw new Error((0,d.localize)(6,null,this.sb(o)));if(!(i.capabilities&2))throw new Error((0,d.localize)(7,null,this.sb(o)));if(t)throw new Error((0,d.localize)(8,null,this.sb(o)))}let $;try{$=await i.stat(o)}catch{return}if($.type&f.FileType.Directory)throw new f.$uk((0,d.localize)(9,null,this.sb(o)),0,s);if(this.rb(o,$),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==f.$Ek&&typeof $.mtime=="number"&&typeof $.size=="number"&&s.mtime<$.mtime&&s.etag!==(0,f.$Fk)({mtime:s.mtime,size:$.size}))throw new f.$uk((0,d.localize)(10,null),3,s);return $}async readFile(i,o,s){const t=await this.m(i);return o?.atomic?this.z(t,i,o,s):this.C(t,i,o,s)}async z(i,o,s,t){return new Promise((a,$)=>{this.cb.queueFor(o,this.R(i).providerExtUri).queue(async()=>{try{const w=await this.C(i,o,s,t);a(w)}catch(w){$(w)}})})}async C(i,o,s,t){const a=await this.D(i,o,{...s,preferUnbuffered:!0},t);return{...a,value:await(0,r.$oe)(a.value)}}async readFileStream(i,o,s){const t=await this.m(i);return this.D(t,i,o,s)}async D(i,o,s,t){const a=new I.$Yd(t);let $=s;(0,f.$hk)(i)&&i.enforceAtomicReadFile?.(o)&&($={...s,atomic:!0});const w=this.J(o,$).then(E=>E,E=>{throw a.dispose(!0),E});let k;try{return typeof $?.etag=="string"&&$.etag!==f.$Ek&&await w,$?.atomic&&(0,f.$hk)(i)||!((0,f.$fk)(i)||(0,f.$gk)(i))||(0,f.$ck)(i)&&$?.preferUnbuffered?k=this.I(i,o,$):(0,f.$gk)(i)?k=this.G(i,o,a.token,$):k=this.H(i,o,a.token,$),k.on("end",()=>a.dispose()),k.on("error",()=>a.dispose()),{...await w,value:k}}catch(E){throw k&&await(0,g.$6d)(k),this.F(E,o,$)}}F(i,o,s){const t=(0,d.localize)(11,null,this.sb(o),(0,f.$nk)(i).toString());return i instanceof f.$wk?new f.$wk(t,i.stat,s):i instanceof f.$vk?new f.$vk(t,i.fileOperationResult,i.size,i.options):new f.$uk(t,(0,f.$qk)(i),s)}G(i,o,s,t=Object.create(null)){const a=i.readFileStream(o,t,s);return(0,g.$_d)(a,{data:$=>$ instanceof r.$ce?$:r.$ce.wrap($),error:$=>this.F($,o,t)},$=>r.$ce.concat($))}H(i,o,s,t=Object.create(null)){const a=(0,r.$se)();return(0,h.$Qp)(i,o,a,$=>$,{...t,bufferSize:this.a,errorTransformer:$=>this.F($,o,t)},s),a}I(i,o,s){const t=(0,g.$3d)(a=>r.$ce.concat(a));return(async()=>{try{let a;s?.atomic&&(0,f.$hk)(i)?a=await i.readFile(o,{atomic:!0}):a=await i.readFile(o),typeof s?.position=="number"&&(a=a.slice(s.position)),typeof s?.length=="number"&&(a=a.slice(0,s.length)),this.L(o,a.byteLength,s),t.end(r.$ce.wrap(a))}catch(a){t.error(a),t.end()}})(),t}async J(i,o){const s=await this.resolve(i,{resolveMetadata:!0});if(s.isDirectory)throw new f.$uk((0,d.localize)(12,null,this.sb(i)),0,o);if(typeof o?.etag=="string"&&o.etag!==f.$Ek&&o.etag===s.etag)throw new f.$wk((0,d.localize)(13,null),s,o);return this.L(i,s.size,o),s}L(i,o,s){if(typeof s?.limits?.size=="number"&&o>s.limits.size)throw new f.$vk((0,d.localize)(14,null,this.sb(i)),7,o,s)}async canMove(i,o,s){return this.M(i,o,"move",s)}async canCopy(i,o,s){return this.M(i,o,"copy",s)}async M(i,o,s,t){if(i.toString()!==o.toString())try{const a=s==="move"?this.qb(await this.n(i),i):await this.m(i),$=this.qb(await this.n(o),o);await this.Q(a,i,$,o,s,t)}catch(a){return a}return!0}async move(i,o,s){const t=this.qb(await this.n(i),i),a=this.qb(await this.n(o),o),$=await this.N(t,i,a,o,"move",!!s),w=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new f.$rk(i,$==="move"?2:3,w)),w}async copy(i,o,s){const t=await this.m(i),a=this.qb(await this.n(o),o),$=await this.N(t,i,a,o,"copy",!!s),w=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new f.$rk(i,$==="copy"?3:2,w)),w}async N(i,o,s,t,a,$){if(o.toString()===t.toString())return a;const{exists:w,isSameResourceWithDifferentPathCase:k}=await this.Q(i,o,s,t,a,$);if(w&&!k&&$&&await this.del(t,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(t)),a==="copy"){if(i===s&&(0,f.$dk)(i))await i.copy(o,t,{overwrite:$});else{const E=await this.resolve(o);E.isDirectory?await this.P(i,E,s,t):await this.O(i,o,s,t)}return a}else return i===s?(await i.rename(o,t,{overwrite:$}),a):(await this.N(i,o,s,t,"copy",$),await this.del(o,{recursive:!0}),"copy")}async O(i,o,s,t){if((0,f.$fk)(i)&&(0,f.$fk)(s))return this.jb(i,o,s,t);if((0,f.$fk)(i)&&(0,f.$ck)(s))return this.pb(i,o,s,t);if((0,f.$ck)(i)&&(0,f.$fk)(s))return this.nb(i,o,s,t);if((0,f.$ck)(i)&&(0,f.$ck)(s))return this.lb(i,o,s,t)}async P(i,o,s,t){await s.mkdir(t),Array.isArray(o.children)&&await R.Promises.settled(o.children.map(async a=>{const $=this.R(s).providerExtUri.joinPath(t,a.name);return a.isDirectory?this.P(i,await this.resolve(a.resource),s,$):this.O(i,a.resource,s,$)}))}async Q(i,o,s,t,a,$){let w=!1;if(i===s){const{providerExtUri:E,isPathCaseSensitive:L}=this.R(i);if(L||(w=E.isEqual(o,t)),w&&a==="copy")throw new Error((0,d.localize)(15,null,this.sb(o),this.sb(t)));if(!w&&E.isEqualOrParent(t,o))throw new Error((0,d.localize)(16,null,this.sb(o),this.sb(t)))}const k=await this.exists(t);if(k&&!w){if(!$)throw new f.$uk((0,d.localize)(17,null,this.sb(o),this.sb(t)),4);if(i===s){const{providerExtUri:E}=this.R(i);if(E.isEqualOrParent(o,t))throw new Error((0,d.localize)(18,null,this.sb(o),this.sb(t)))}}return{exists:k,isSameResourceWithDifferentPathCase:w}}R(i){const o=this.S(i);return{providerExtUri:o?u.$mg:u.$og,isPathCaseSensitive:o}}S(i){return!!(i.capabilities&1024)}async createFolder(i){const o=this.qb(await this.j(i),i);await this.U(o,i);const s=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new f.$rk(i,0,s)),s}async U(i,o){const s=[],{providerExtUri:t}=this.R(i);for(;!t.isEqual(o,t.dirname(o));)try{if(!((await i.stat(o)).type&f.FileType.Directory))throw new Error((0,d.localize)(19,null,this.sb(o)));break}catch(a){if((0,f.$pk)(a)!==f.FileSystemProviderErrorCode.FileNotFound)throw a;s.push(t.basename(o)),o=t.dirname(o)}for(let a=s.length-1;a>=0;a--){o=t.joinPath(o,s[a]);try{await i.mkdir(o)}catch($){if((0,f.$pk)($)!==f.FileSystemProviderErrorCode.FileExists)throw $}}}async canDelete(i,o){try{await this.W(i,o)}catch(s){return s}return!0}async W(i,o){const s=this.qb(await this.j(i),i),t=!!o?.useTrash;if(t&&!(s.capabilities&4096))throw new Error((0,d.localize)(20,null,this.sb(i)));const a=o?.atomic;if(a&&!(s.capabilities&65536))throw new Error((0,d.localize)(21,null,this.sb(i)));if(t&&a)throw new Error((0,d.localize)(22,null,this.sb(i)));let $;try{$=await s.stat(i)}catch{}if($)this.rb(i,$);else throw new f.$uk((0,d.localize)(23,null,this.sb(i)),1);if(!!!o?.recursive){const k=await this.resolve(i);if(k.isDirectory&&Array.isArray(k.children)&&k.children.length>0)throw new Error((0,d.localize)(24,null,this.sb(i)))}return s}async del(i,o){const s=await this.W(i,o);let t=o;if((0,f.$jk)(s)&&!t?.atomic){const k=s.enforceAtomicDelete?.(i);k&&(t={...o,atomic:k})}const a=!!t?.useTrash,$=!!t?.recursive,w=t?.atomic??!1;await s.delete(i,{recursive:$,useTrash:a,atomic:w}),this.r.fire(new f.$rk(i,1))}async cloneFile(i,o){const s=await this.j(i),t=this.qb(await this.n(o),o);if(s===t&&this.R(s).providerExtUri.isEqual(i,o))return;if(s===t&&(0,f.$ek)(s))return s.cloneFile(i,o);await this.U(t,this.R(t).providerExtUri.dirname(o));const a=this.cb.queueFor(i,this.R(s).providerExtUri);return s===t&&(0,f.$dk)(s)?a.queue(()=>s.copy(i,o,{overwrite:!0})):a.queue(()=>this.O(s,i,t,o))}static{this.ab=0}createWatcher(i,o){return this.watch(i,{...o,correlationId:m.ab++})}watch(i,o={recursive:!1,excludes:[]}){const s=new b.$Rc;let t=!1,a=()=>{t=!0};s.add((0,b.$Qc)(()=>a())),(async()=>{try{const w=await this.bb(i,o);t?(0,b.$Nc)(w):a=()=>(0,b.$Nc)(w)}catch(w){this.b.error(w)}})();const $=o.correlationId;if(typeof $=="number"){const w=s.add(new P.$Od);return s.add(this.X.event(E=>{E.correlates($)&&w.fire(E)})),{onDidChange:w.event,dispose:()=>s.dispose()}}return s}async bb(i,o){const s=await this.j(i),t=(0,C.$Ei)([this.R(s).providerExtUri.getComparisonKey(i),o]);let a=this.$.get(t);return a||(a={count:0,disposable:s.watch(i,o)},this.$.set(t,a)),a.count+=1,(0,b.$Qc)(()=>{a&&(a.count--,a.count===0&&((0,b.$Nc)(a.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,i]of this.$)(0,b.$Nc)(i.disposable);this.$.clear()}async db(i,o,s,t){return this.cb.queueFor(o,this.R(i).providerExtUri).queue(async()=>{const a=await i.open(o,{create:!0,unlock:s?.unlock??!1});try{(0,g.$1d)(t)||(0,g.$2d)(t)?await this.eb(i,a,t):await this.fb(i,a,t)}catch($){throw(0,f.$nk)($)}finally{await i.close(a)}})}async eb(i,o,s){let t=0,a;if((0,g.$2d)(s)){if(s.buffer.length>0){const $=r.$ce.concat(s.buffer);await this.gb(i,o,$,$.byteLength,t,0),t+=$.byteLength}if(s.ended)return;a=s.stream}else a=s;return new Promise(($,w)=>{(0,g.$7d)(a,{onData:async k=>{a.pause();try{await this.gb(i,o,k,k.byteLength,t,0)}catch(E){return w(E)}t+=k.byteLength,setTimeout(()=>a.resume())},onError:k=>w(k),onEnd:()=>$()})})}async fb(i,o,s){let t=0,a;for(;(a=s.read())!==null;)await this.gb(i,o,a,a.byteLength,t,0),t+=a.byteLength}async gb(i,o,s,t,a,$){let w=0;for(;w<t;){const k=await i.write(o,a+w,s.buffer,$+w,t-w);w+=k}}async hb(i,o,s,t){return this.cb.queueFor(o,this.R(i).providerExtUri).queue(()=>this.ib(i,o,s,t))}async ib(i,o,s,t){let a;t instanceof r.$ce?a=t:(0,g.$1d)(t)?a=await(0,r.$oe)(t):(0,g.$2d)(t)?a=await(0,r.$pe)(t):a=(0,r.$me)(t),await i.writeFile(o,a.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(i,o,s,t){return this.cb.queueFor(t,this.R(s).providerExtUri).queue(()=>this.kb(i,o,s,t))}async kb(i,o,s,t){let a,$;try{a=await i.open(o,{create:!1}),$=await s.open(t,{create:!0,unlock:!1});const w=r.$ce.alloc(this.a);let k=0,E=0,L=0;do L=await i.read(a,k,w.buffer,E,w.byteLength-E),await this.gb(s,$,w,L,k,E),k+=L,E+=L,E===w.byteLength&&(E=0);while(L>0)}catch(w){throw(0,f.$nk)(w)}finally{await R.Promises.settled([typeof a=="number"?i.close(a):Promise.resolve(),typeof $=="number"?s.close($):Promise.resolve()])}}async lb(i,o,s,t){return this.cb.queueFor(t,this.R(s).providerExtUri).queue(()=>this.mb(i,o,s,t))}async mb(i,o,s,t){return s.writeFile(t,await i.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(i,o,s,t){return this.cb.queueFor(t,this.R(s).providerExtUri).queue(()=>this.ob(i,o,s,t))}async ob(i,o,s,t){const a=await s.open(t,{create:!0,unlock:!1});try{const $=await i.readFile(o);await this.gb(s,a,r.$ce.wrap($),$.byteLength,0,0)}catch($){throw(0,f.$nk)($)}finally{await s.close(a)}}async pb(i,o,s,t){const a=await(0,r.$oe)(this.H(i,o,I.CancellationToken.None));await this.hb(s,t,void 0,a)}qb(i,o){if(i.capabilities&2048)throw new f.$uk((0,d.localize)(25,null,this.sb(o)),6);return i}rb(i,o){if((o.permissions??0)&f.FilePermission.Readonly)throw new f.$uk((0,d.localize)(26,null,this.sb(i)),6)}sb(i){return i.scheme===S.Schemas.file?i.fsPath:i.toString(!0)}};e.$Rp=c,e.$Rp=c=m=Oe([Ae(0,p.$$i)],c)}),define(pe[68],be([1,0,27,299,14,26,15,5,40,2,7,3,19,48,21,189,16,109,224,39,222,221]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u,g,d,f,h,p,l,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0,(()=>{try{(0,R.gracefulify)(D)}catch(i){console.error(`Error enabling graceful-fs: ${(0,l.$Bi)(i)}`)}})();class n extends p.$1p{static{this.I=!1}constructor(o,s){super(o,s),this.onDidChangeCapabilities=C.Event.None,this.N=new I.$Ac(t=>y.$ng.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,S.$l&&(this.J|=1024)),this.J}async stat(o){try{const{stat:s,symbolicLink:t}=await g.SymlinkSupport.stat(this.H(o));return{type:this.M(s,t),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:f.FilePermission.Locked}}catch(s){throw this.fb(s)}}async L(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const s=await g.Promises.readdir(this.H(o),{withFileTypes:!0}),t=[];return await Promise.all(s.map(async a=>{try{let $;a.isSymbolicLink()?$=(await this.stat((0,y.$wg)(o,a.name))).type:$=this.M(a),t.push([a.name,$])}catch($){this.a.trace($)}})),t}catch(s){throw this.fb(s)}}M(o,s){let t;return s?.dangling?t=f.FileType.Unknown:o.isFile()?t=f.FileType.File:o.isDirectory()?t=f.FileType.Directory:t=f.FileType.Unknown,s&&(t|=f.FileType.SymbolicLink),t}async O(o){const s=this.H(o);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let t;for(;t=this.N.get(o);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await t.wait();const a=new r.$Tg;return this.N.set(o,a),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,b.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.N.get(o)===a&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.N.delete(o)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),a.open()})}async readFile(o,s){let t;try{s?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(o)})`),t=await this.O(o));const a=this.H(o);return await g.Promises.readFile(a)}catch(a){throw this.fb(a)}finally{t?.dispose()}}P(o){n.I&&this.a.trace(o)}readFileStream(o,s,t){const a=(0,u.$3d)($=>P.$ce.concat($.map(w=>P.$ce.wrap(w))).buffer);return(0,h.$Qp)(this,o,a,$=>$.buffer,{...s,bufferSize:256*1024},t),a}async writeFile(o,s,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(o)?this.R(o,(0,y.$wg)((0,y.$vg)(o),`${(0,y.$tg)(o)}${t.atomic.postfix}`),s,t):this.S(o,s,t)}async Q(o){try{const s=this.H(o),{symbolicLink:t}=await g.SymlinkSupport.stat(s);if(t)return!1}catch{}return!0}async R(o,s,t,a){const $=new b.$Rc;try{$.add(await this.O(o)),$.add(await this.O(s)),await this.S(s,t,a,!0);try{await this.rename(s,o,{overwrite:!0})}catch(w){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw w}}finally{$.dispose()}}async S(o,s,t,a){let $;try{const w=this.H(o);if(!t.create||!t.overwrite){if(await g.Promises.exists(w)){if(!t.overwrite)throw(0,f.$mk)((0,d.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,f.$mk)((0,d.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}$=await this.open(o,{create:!0,unlock:t.unlock},a),await this.write($,0,s,0,s.byteLength)}catch(w){throw await this.gb(o,w)}finally{typeof $=="number"&&await this.close($)}}static{this.Y=!0}static configureFlushOnWrite(o){n.Y=o}async open(o,s,t){const a=this.H(o);let $;(0,f.$ak)(s)&&!t&&($=await this.O(o));let w;try{if((0,f.$ak)(s)&&s.unlock)try{const{stat:E}=await g.SymlinkSupport.stat(a);E.mode&128||await g.Promises.chmod(a,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let k;if((0,f.$ak)(s)){if(S.$j)try{await g.Promises.truncate(a,0),k="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}k||(k="w")}else k="r";w=await g.Promises.open(a,k)}catch(k){throw $?.dispose(),(0,f.$ak)(s)?await this.gb(o,k):this.fb(k)}if(this.U.set(w,0),(0,f.$ak)(s)&&this.X.set(w,o),$){const k=this.W.get(w);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${w} (${a})`),this.W.set(w,$),k&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${w} (${a})`),k.dispose())}return w}async close(o){const s=this.W.get(o);try{if(this.U.delete(o),this.X.delete(o)&&n.Y)try{await g.Promises.fdatasync(o)}catch(t){n.configureFlushOnWrite(!1),this.a.error(t)}return await g.Promises.close(o)}catch(t){throw this.fb(t)}finally{s&&(this.W.get(o)===s&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.W.delete(o)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),s.dispose())}}async read(o,s,t,a,$){const w=this.Z(o,s);let k=null;try{k=(await g.Promises.read(o,t,a,$,w)).bytesRead}catch(E){throw this.fb(E)}finally{this.$(o,w,k)}return k}Z(o,s){return s===this.U.get(o)?null:s}$(o,s,t){const a=this.U.get(o);typeof a=="number"&&(typeof s=="number"||(typeof t=="number"?this.U.set(o,a+t):this.U.delete(o)))}async write(o,s,t,a,$){return(0,r.$ah)(()=>this.ab(o,s,t,a,$),100,3)}async ab(o,s,t,a,$){const w=this.Z(o,s);let k=null;try{k=(await g.Promises.write(o,t,a,$,w)).bytesWritten}catch(E){throw await this.gb(this.X.get(o),E)}finally{this.$(o,w,k)}return k}async mkdir(o){try{await g.Promises.mkdir(this.H(o))}catch(s){throw this.fb(s)}}async delete(o,s){try{const t=this.H(o);if(s.recursive){let a;s?.atomic!==!1&&s.atomic.postfix&&(a=(0,A.$jc)((0,A.$mc)(t),`${(0,A.$nc)(t)}${s.atomic.postfix}`)),await g.Promises.rm(t,g.RimRafMode.MOVE,a)}else try{await g.Promises.unlink(t)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let $=!1;try{const{stat:w,symbolicLink:k}=await g.SymlinkSupport.stat(t);$=w.isDirectory()&&!k}catch{}if($)await g.Promises.rmdir(t);else throw a}else throw a}}catch(t){throw this.fb(t)}}async rename(o,s,t){const a=this.H(o),$=this.H(s);if(a!==$)try{await this.bb(o,s,"move",t.overwrite),await g.Promises.rename(a,$)}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,d.localize)(2,null,(0,A.$nc)(a),(0,A.$nc)((0,A.$mc)($)),w.toString()))),this.fb(w)}}async copy(o,s,t){const a=this.H(o),$=this.H(s);if(a!==$)try{await this.bb(o,s,"copy",t.overwrite),await g.Promises.copy(a,$,{preserveSymlinks:!0})}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,d.localize)(3,null,(0,A.$nc)(a),(0,A.$nc)((0,A.$mc)($)),w.toString()))),this.fb(w)}}async bb(o,s,t,a){const $=this.H(o),w=this.H(s);let k=!1;if(!!(this.capabilities&1024)||(k=(0,v.$Xf)($,w,!0)),k){if(t==="copy")throw(0,f.$mk)((0,d.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const L=await this.L(o);if(!L)throw(0,f.$mk)((0,d.localize)(5,null),f.FileSystemProviderErrorCode.FileNotFound);const j=await this.L(s);if(j){if(!a)throw(0,f.$mk)((0,d.localize)(6,null),f.FileSystemProviderErrorCode.FileExists);L.type&f.FileType.File&&j.type&f.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,s){return this.cb(o,s,!1)}async cb(o,s,t){const a=this.H(o),$=this.H(s),w=!!(this.capabilities&1024);if((0,v.$Xf)(a,$,!w))return;const k=new b.$Rc;try{k.add(await this.O(o)),k.add(await this.O(s)),t&&await g.Promises.mkdir((0,A.$mc)($),{recursive:!0}),await g.Promises.copyFile(a,$)}catch(E){if(E.code==="ENOENT"&&!t)return this.cb(o,s,!0);throw this.fb(E)}finally{k.dispose()}}t(o,s,t){return new m.$8p(a=>o(a),a=>s(a),t)}F(o,s,t){return new c.$dq(a=>o(a),a=>s(a),t)}fb(o){if(o instanceof f.$lk)return o;let s=o,t;switch(o.code){case"ENOENT":t=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=f.FileSystemProviderErrorCode.Unknown;break;default:t=f.FileSystemProviderErrorCode.Unknown}return(0,f.$mk)(s,t)}async gb(o,s){let t=this.fb(s);if(o&&t.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await g.SymlinkSupport.stat(this.H(o));a.mode&128||(t=(0,f.$mk)(s,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return t}}e.$eq=n}),define(pe[225],be([1,0,5,68,2,15,48,20]),function(ue,e,D,R,r,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nr=e.$Mr=void 0;class v extends r.$Sc{constructor(S,y){super(),this.a=S,this.b=y,this.F=new Map,this.G=new Map}call(S,y,u){const g=this.c(S);switch(y){case"stat":return this.g(g,u[0]);case"readdir":return this.h(g,u[0]);case"open":return this.r(g,u[0],u[1]);case"close":return this.s(u[0]);case"read":return this.t(u[0],u[1],u[2]);case"readFile":return this.j(g,u[0],u[1]);case"write":return this.u(u[0],u[1],u[2],u[3],u[4]);case"writeFile":return this.n(g,u[0],u[1],u[2]);case"rename":return this.z(g,u[0],u[1],u[2]);case"copy":return this.C(g,u[0],u[1],u[2]);case"cloneFile":return this.D(g,u[0],u[1]);case"mkdir":return this.w(g,u[0]);case"delete":return this.y(g,u[0],u[1]);case"watch":return this.I(g,u[0],u[1],u[2],u[3]);case"unwatch":return this.J(u[0],u[1])}throw new Error(`IPC Command ${y} not found`)}listen(S,y,u){const g=this.c(S);switch(y){case"fileChange":return this.H(g,u[0]);case"readFileStream":return this.m(g,u[0],u[1])}throw new Error(`Unknown event ${y}`)}g(S,y){const u=this.f(S,y,!0);return this.a.stat(u)}h(S,y){const u=this.f(S,y);return this.a.readdir(u)}async j(S,y,u){const g=this.f(S,y,!0),d=await this.a.readFile(g,u);return I.$ce.wrap(d)}m(S,y,u){const g=this.f(S,y,!0),d=new C.$Yd,f=new D.$Od({onDidRemoveLastListener:()=>{d.cancel()}}),h=this.a.readFileStream(g,u,d.token);return(0,P.$7d)(h,{onData:p=>f.fire(I.$ce.wrap(p)),onError:p=>f.fire(p),onEnd:()=>{f.fire("end"),f.dispose(),d.dispose()}}),f.event}n(S,y,u,g){const d=this.f(S,y);return this.a.writeFile(d,u.buffer,g)}r(S,y,u){const g=this.f(S,y,!0);return this.a.open(g,u)}s(S){return this.a.close(S)}async t(S,y,u){const g=I.$ce.alloc(u),d=0,f=await this.a.read(S,y,g.buffer,d,u);return[g,f]}u(S,y,u,g,d){return this.a.write(S,y,u.buffer,g,d)}w(S,y){const u=this.f(S,y);return this.a.mkdir(u)}y(S,y,u){const g=this.f(S,y);return this.a.delete(g,u)}z(S,y,u,g){const d=this.f(S,y),f=this.f(S,u);return this.a.rename(d,f,g)}C(S,y,u,g){const d=this.f(S,y),f=this.f(S,u);return this.a.copy(d,f,g)}D(S,y,u){const g=this.f(S,y),d=this.f(S,u);return this.a.cloneFile(g,d)}H(S,y){const u=new D.$Od({onWillAddFirstListener:()=>{this.F.set(y,this.L(S,u))},onDidRemoveLastListener:()=>{(0,r.$Nc)(this.F.get(y)),this.F.delete(y)}});return u.event}async I(S,y,u,g,d){const f=this.F.get(y);if(f){const h=this.f(S,g),p=f.watch(u,h,d);this.G.set(y+u,p)}}async J(S,y){const u=S+y,g=this.G.get(u);g&&((0,r.$Nc)(g),this.G.delete(u))}dispose(){super.dispose();for(const[,S]of this.G)S.dispose();this.G.clear();for(const[,S]of this.F)S.dispose();this.F.clear()}}e.$Mr=v;class b extends r.$Sc{constructor(S,y,u,g){super(),this.c=S,this.f=u,this.g=g,this.a=new Map,this.b=this.B(new R.$eq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(y)}h(S){const y=this.B(new D.$Od);this.B(y.event(u=>{S.fire(u.map(g=>({resource:this.c.transformOutgoingURI(g.resource),type:g.type,cId:g.cId})))})),this.B(this.b.onDidChangeFile(u=>y.fire(u))),this.B(this.b.onDidWatchError(u=>S.fire(u)))}j(S){}m(S){}watch(S,y,u){const g=this.m(this.g);return Array.isArray(g)&&(u.excludes=[...u.excludes,...g]),this.a.set(S,this.b.watch(y,u)),(0,r.$Qc)(()=>{(0,r.$Nc)(this.a.get(S)),this.a.delete(S)})}dispose(){for(const[,S]of this.a)S.dispose();this.a.clear(),super.dispose()}}e.$Nr=b}),define(pe[112],be([1,0,4,5,13,2]),function(ue,e,D,R,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=e.$cr=void 0;class P extends r.$jj{constructor(S,y,u,g,d){super(y,u,g),this.r=S,this.t=d,this.B(d.listen("onDidChangeLogLevel",S)(f=>{(0,r.$aj)(f)?super.setLogLevel(f):super.setLogLevel(D.URI.revive(f[0]),f[1])})),this.B(d.listen("onDidChangeVisibility",S)(([f,h])=>super.setVisibility(D.URI.revive(f),h))),this.B(d.listen("onDidChangeLoggers",S)(({added:f,removed:h})=>{for(const p of f)super.registerLogger({...p,resource:D.URI.revive(p.resource)});for(const p of h)super.deregisterLogger(p.resource)}))}createConsoleMainLogger(){return new r.$hj({log:(S,y)=>{this.t.call("consoleLog",[S,y])}})}registerLogger(S){super.registerLogger(S),this.t.call("registerLogger",[S,this.r])}deregisterLogger(S){super.deregisterLogger(S),this.t.call("deregisterLogger",[S,this.r])}setLogLevel(S,y){super.setLogLevel(S,y),this.t.call("setLogLevel",[S,y])}setVisibility(S,y){super.setVisibility(S,y),this.t.call("setVisibility",[this.n(S),y])}s(S,y,u){return new C(this.t,S,y,u,this.r)}static setLogLevel(S,y,u){return S.call("setLogLevel",[y,u])}}e.$cr=P;class C extends r.$ej{constructor(S,y,u,g,d){super(g?.logLevel==="always"),this.r=S,this.s=y,this.m=!1,this.n=[],this.setLevel(u),this.r.call("createLogger",[y,g,d]).then(()=>{this.u(this.n),this.m=!0})}g(S,y){const u=[[S,y]];this.m?this.u(u):this.n.push(...u)}u(S){this.r.call("log",[this.s,S])}}class v{constructor(S,y){this.a=S,this.b=y}listen(S,y){const u=this.b(S);switch(y){case"onDidChangeLoggers":return R.Event.map(this.a.onDidChangeLoggers,g=>({added:[...g.added].map(d=>this.c(d,u)),removed:[...g.removed].map(d=>this.c(d,u))}));case"onDidChangeVisibility":return R.Event.map(this.a.onDidChangeVisibility,g=>[u.transformOutgoingURI(g[0]),g[1]]);case"onDidChangeLogLevel":return R.Event.map(this.a.onDidChangeLogLevel,g=>(0,r.$aj)(g)?g:[u.transformOutgoingURI(g[0]),g[1]])}throw new Error(`Event not found: ${y}`)}async call(S,y,u){const g=this.b(S);switch(y){case"setLogLevel":return(0,r.$aj)(u[0])?this.a.setLogLevel(u[0]):this.a.setLogLevel(D.URI.revive(g.transformIncoming(u[0][0])),u[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(d=>this.c(d,g)))}throw new Error(`Call not found: ${y}`)}c(S,y){return{...S,resource:y.transformOutgoingURI(S.resource)}}}e.$dr=v;class b extends I.$Sc{constructor(S,y){super(),y.call("setLogLevel",[S.getLogLevel()]),this.B(S.onDidChangeLogLevel(u=>y.call("setLogLevel",[u]))),y.call("getRegisteredLoggers").then(u=>{for(const g of u)S.registerLogger({...g,resource:D.URI.revive(g.resource)})}),this.B(y.listen("onDidChangeVisibility")(([u,g])=>S.setVisibility(D.URI.revive(u),g))),this.B(y.listen("onDidChangeLoggers")(({added:u,removed:g})=>{for(const d of u)S.registerLogger({...d,resource:D.URI.revive(d.resource)});for(const d of g)S.deregisterLogger(d.resource)}))}}e.$er=b}),define(pe[113],be([1,0,2,13]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NN=void 0;class r extends D.$Sc{constructor(P,C=[]){super(),this.a=new R.$ij([P,...C]),this.B(P.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(P){this.a.setLevel(P)}getLevel(){return this.a.getLevel()}trace(P,...C){this.a.trace(P,...C)}debug(P,...C){this.a.debug(P,...C)}info(P,...C){this.a.info(P,...C)}warn(P,...C){this.a.warn(P,...C)}error(P,...C){this.a.error(P,...C)}flush(){this.a.flush()}}e.$NN=r}),define(pe[226],be([1,0,16,13]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CN=void 0;var r;(function(b){b[b.Trace=0]="Trace",b[b.Debug=1]="Debug",b[b.Info=2]="Info",b[b.Warning=3]="Warning",b[b.Error=4]="Error",b[b.Critical=5]="Critical",b[b.Off=6]="Off"})(r||(r={}));async function I(b,A,S,y,u){try{const g=await new Promise((f,h)=>{ue(["@vscode/spdlog"],f,h)});g.setFlushOn(r.Trace);const d=await g.createAsyncRotatingLogger(b,A,S,y);return u?d.clearFormatters():d.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),d}catch(g){console.error(g)}return null}function P(b,A,S){switch(A){case R.LogLevel.Trace:b.trace(S);break;case R.LogLevel.Debug:b.debug(S);break;case R.LogLevel.Info:b.info(S);break;case R.LogLevel.Warning:b.warn(S);break;case R.LogLevel.Error:b.error(S);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function C(b,A){switch(A){case R.LogLevel.Trace:b.setLevel(r.Trace);break;case R.LogLevel.Debug:b.setLevel(r.Debug);break;case R.LogLevel.Info:b.setLevel(r.Info);break;case R.LogLevel.Warning:b.setLevel(r.Warning);break;case R.LogLevel.Error:b.setLevel(r.Error);break;case R.LogLevel.Off:b.setLevel(r.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class v extends R.$ej{constructor(A,S,y,u,g){super(),this.m=[],this.setLevel(g),this.n=this.s(A,S,y,u),this.B(this.onDidChangeLogLevel(d=>{this.r&&C(this.r,d)}))}async s(A,S,y,u){const g=y?6:1,d=30/g*D.$Hk.MB,f=await I(A,S,d,g,u);if(f){this.r=f,C(this.r,this.getLevel());for(const{level:h,message:p}of this.m)P(this.r,h,p);this.m=[]}}g(A,S){this.r?P(this.r,A,S):this.getLevel()<=A&&this.m.push({level:A,message:S})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$CN=v}),define(pe[114],be([1,0,23,13,226]),function(ue,e,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=void 0;class I extends R.$jj{s(C,v,b){return new r.$CN((0,D.$fg)(),C.fsPath,!b?.donotRotate,!!b?.donotUseFormatters,v)}}e.$DN=I}),define(pe[227],be([1,0,61,191,6]),function(ue,e,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(I||(e.MarkerTag=I={}));var P;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(P||(e.MarkerSeverity=P={})),function(v){function b(g,d){return d-g}v.compare=b;const A=Object.create(null);A[v.Error]=(0,R.localize)(0,null),A[v.Warning]=(0,R.localize)(1,null),A[v.Info]=(0,R.localize)(2,null);function S(g){return A[g]||""}v.toString=S;function y(g){switch(g){case D.default.Error:return v.Error;case D.default.Warning:return v.Warning;case D.default.Info:return v.Info;case D.default.Ignore:return v.Hint}}v.fromSeverity=y;function u(g){switch(g){case v.Error:return D.default.Error;case v.Warning:return D.default.Warning;case v.Info:return D.default.Info;case v.Hint:return D.default.Ignore}}v.toSeverity=u}(P||(e.MarkerSeverity=P={}));var C;(function(v){const b="";function A(y){return S(y,!0)}v.makeKey=A;function S(y,u){const g=[b];return y.source?g.push(y.source.replace("\xA6","\\\xA6")):g.push(b),y.code?typeof y.code=="string"?g.push(y.code.replace("\xA6","\\\xA6")):g.push(y.code.value.replace("\xA6","\\\xA6")):g.push(b),y.severity!==void 0&&y.severity!==null?g.push(P.toString(y.severity)):g.push(b),y.message&&u?g.push(y.message.replace("\xA6","\\\xA6")):g.push(b),y.startLineNumber!==void 0&&y.startLineNumber!==null?g.push(y.startLineNumber.toString()):g.push(b),y.startColumn!==void 0&&y.startColumn!==null?g.push(y.startColumn.toString()):g.push(b),y.endLineNumber!==void 0&&y.endLineNumber!==null?g.push(y.endLineNumber.toString()):g.push(b),y.endColumn!==void 0&&y.endColumn!==null?g.push(y.endColumn.toString()):g.push(b),g.push(b),g.join("\xA6")}v.makeKeyOptionalMessage=S})(C||(e.IMarkerData=C={})),e.$dt=(0,r.$Qh)("markerService")}),define(pe[69],be([1,0,5,47,2,6]),function(ue,e,D,R,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=void 0,e.$mn=(0,I.$Qh)("policy");class P extends r.$Sc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new D.$Od),this.onDidChange=this.h.event}async updatePolicyDefinitions(b){const A=Object.keys(this.f).length;return this.f={...b,...this.f},A!==Object.keys(this.f).length&&await this.j(b),R.Iterable.reduce(this.g.entries(),(S,[y,u])=>({...S,[y]:u}),{})}getPolicyValue(b){return this.g.get(b)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(b,[A,S])=>({...b,[A]:{definition:S,value:this.g.get(A)}}),{})}}e.$nn=P;class C{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$on=C}),define(pe[55],be([1,0,3,29]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;if(typeof D.$h.vscode<"u"&&typeof D.$h.vscode.context<"u"){const I=D.$h.vscode.context.configuration();if(I)r=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const I=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:I.version})}}else r={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"vscode",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverGreeting:[],serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webUrl:"https://vscode.dev",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json"},profileTemplatesUrl:"https://az764295.vo.msecnd.net/profile-templates/profile-templates.json",extensionRecommendations:{"ms-dotnettools.csdevkit":{onFileOpen:[{pathGlob:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}",important:!0},{languages:["csharp"],important:!0},{pathGlob:"{**/project.json,**/appsettings.json}"}]},"ms-python.python":{onFileOpen:[{pathGlob:"{**/*.py}",important:!0},{languages:["python"],important:!0},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.jupyter":{onFileOpen:[{pathGlob:"{**/*.py}",contentPattern:"^#\\s*%%$",important:!0,whenInstalled:["ms-python.python"]},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.datawrangler":{onFileOpen:[{pathGlob:"{**/*.ipynb}",contentPattern:"import\\s*pandas|from\\s*pandas",whenInstalled:["ms-toolsai.jupyter"]}]},"golang.Go":{onFileOpen:[{pathGlob:"**/*.go",important:!0},{languages:["go"],important:!0}]},"vscjava.vscode-java-pack":{onFileOpen:[{pathGlob:"{**/*.java}",important:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},{languages:["java"],important:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}]},"ms-vscode.PowerShell":{onFileOpen:[{pathGlob:"{**/*.ps1,**/*.psd1,**/*.psm1}",important:!0},{languages:["powershell"],important:!0},{pathGlob:"{**/*.ps.config,**/*.ps1.config}"}]},"ms-vscode.cpptools-extension-pack":{onFileOpen:[{pathGlob:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}",important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]},{languages:["c","cpp"],important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]}]},"ms-azuretools.vscode-docker":{onFileOpen:[{pathGlob:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}",important:!0},{languages:["dockerfile"],important:!0},{pathGlob:"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}"}]},"vue.volar":{onFileOpen:[{pathGlob:"{**/*.vue}",important:!0},{languages:["vue"],important:!0}]},"ms-vscode.makefile-tools":{onFileOpen:[{pathGlob:"{**/makefile,**/Makefile}",important:!0},{languages:["makefile"],important:!0}]},"ms-vscode.cmake-tools":{onFileOpen:[{pathGlob:"{**/CMakeLists.txt}",important:!0}]},"ms-azure-devops.azure-pipelines":{onFileOpen:[{pathGlob:"{**/azure-pipelines.yaml}",important:!0}]},"msazurermtools.azurerm-vscode-tools":{onFileOpen:[{pathGlob:"{**/azuredeploy.json}",important:!0}]},"ms-vscode-remote.remote-containers":{onFileOpen:[{pathGlob:"{**/devcontainer.json}",important:!0}]},"ms-azuretools.vscode-bicep":{onFileOpen:[{pathGlob:"{**/*.bicep}",important:!0,whenNotInstalled:["ms-azuretools.rad-vscode-bicep"]}]},"svelte.svelte-vscode":{onFileOpen:[{pathGlob:"{**/*.svelte}",important:!0}]},"ms-vscode.vscode-github-issue-notebooks":{onFileOpen:[{pathGlob:"{**/*.github-issues}",important:!0}]},"ms-playwright.playwright":{onFileOpen:[{pathGlob:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}",important:!0}]},"vscjava.vscode-gradle":{onFileOpen:[{pathGlob:"{**/gradlew,**/gradlew.bat,**/build.gradle,**/build.gradle.kts,**/settings.gradle,**/settings.gradle.kts}",important:!0}]},"REditorSupport.r":{onFileOpen:[{pathGlob:"{**/*.r}",important:!0},{languages:["r"],important:!0}]},"firefox-devtools.vscode-firefox-debug":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}"}]},"ms-edgedevtools.vscode-edge-devtools":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}"}]},"Ionide.Ionide-fsharp":{onFileOpen:[{pathGlob:"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}"}]},"dbaeumer.vscode-eslint":{onFileOpen:[{pathGlob:"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}"}]},"ms-vscode.vscode-typescript-tslint-plugin":{onFileOpen:[{pathGlob:"{**/tslint.json}"}]},"bmewburn.vscode-intelephense-client":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"xdebug.php-debug":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"rust-lang.rust-analyzer":{onFileOpen:[{pathGlob:"{**/*.rs,**/*.rslib}"}]},"DavidAnson.vscode-markdownlint":{onFileOpen:[{pathGlob:"{**/*.md}"}]},"EditorConfig.EditorConfig":{onFileOpen:[{pathGlob:"{**/.editorconfig}"}]},"HookyQR.beautify":{onFileOpen:[{pathGlob:"{**/.jsbeautifyrc}"}]},"donjayamanne.githistory":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"felipecaputo.git-project-manager":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"eamodio.gitlens":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"Shopify.ruby-lsp":{onFileOpen:[{pathGlob:"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}"}]},"DotJoshJohnson.xml":{onFileOpen:[{pathGlob:"{**/*.xml}"}]},"stylelint.vscode-stylelint":{onFileOpen:[{pathGlob:"{**/.stylelintrc,**/stylelint.config.js}"}]},"ms-mssql.mssql":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"mtxr.sqltools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"usqlextpublisher.usql-vscode-ext":{onFileOpen:[{pathGlob:"{**/*.usql}"}]},"ms-vscode.sublime-keybindings":{onFileOpen:[{pathGlob:"{**/.sublime-project,**/.sublime-workspace}"}]},"k--kato.intellij-idea-keybindings":{onFileOpen:[{pathGlob:"{**/.idea}"}]},"christian-kohler.npm-intellisense":{onFileOpen:[{pathGlob:"{**/package.json}"}]},"cake-build.cake-vscode":{onFileOpen:[{pathGlob:"{**/build.cake}"}]},"Angular.ng-template":{onFileOpen:[{pathGlob:"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}"}]},"vscjava.vscode-maven":{onFileOpen:[{pathGlob:"**/pom.xml"}]},"ms-azuretools.vscode-azureterraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"HashiCorp.terraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"vsciot-vscode.vscode-arduino":{onFileOpen:[{pathGlob:"**/*.ino"}]},"ms-kubernetes-tools.vscode-kubernetes-tools":{onFileOpen:[{pathGlob:"{**/Chart.yaml}"}]},"GoogleCloudTools.cloudcode":{onFileOpen:[{pathGlob:"{**/skaffold.yaml}"}]},"Oracle.oracledevtools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"betterthantomorrow.calva":{onFileOpen:[{pathGlob:"{**/*.clj,**/*.cljs}"}]},"Pivotal.vscode-boot-dev-pack":{onFileOpen:[{pathGlob:"{**/application.properties}"}]},"GitHub.copilot":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.py,**/*.go,**/*.rb}"}],onSettingsEditorOpen:{}},"GitHub.vscode-github-actions":{onFileOpen:[{pathGlob:"{**/.github/workflows/*.yml}",important:!0}]},"circleci.circleci":{onFileOpen:[{pathGlob:"{**/.circleci/config.yml}"}]},"mechatroner.rainbow-csv":{onFileOpen:[{pathGlob:"**/*.csv",important:!0}]},"tomoki1207.pdf":{onFileOpen:[{pathGlob:"**/*.pdf",important:!0}]}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csdevkit","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","Shopify.ruby-lsp","GitHub.copilot"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",contentPattern:"^\\s*url\\s*=\\s*https:\\/\\/github\\.com.*$"},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}},"pyproject-formatter":{configPath:"pyproject.toml",configName:"Python Formatter",recommendations:{"ms-python.black-formatter":{name:"Black Formatter",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?black"?\\s*[\\].])|("black\\s*["[(<=>!~;@])'},"ms-python.autopep8":{name:"Autopep8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?autopep8"?\\s*[\\].])|("autopep8\\s*["[(<=>!~;@])'}}},"pep8-formatter":{configPath:".pep8",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8"}}},"python-setup-cgf-formatter":{configPath:"setup.cfg",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"tox-ini-formatter":{configPath:"tox.ini",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"pyproject-linter":{configPath:"pyproject.toml",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?pylint"?\\s*[\\].])|("pylint\\s*["[(<=>!~;@])'},"charliermarsh.ruff":{name:"Ruff",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?ruff"?\\s*[\\].])|("ruff\\s*["[(<=>!~;@])'},"ms-python.mypy-type-checker":{name:"Mypy Type Checker",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?mypy"?\\s*[\\].])|("mypy\\s*["[(<=>!~;@])'},"ms-python.flake8":{name:"Flake8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?flake8"?\\s*[\\].])|("flake8\\s*["[(<=>!~;@])'}}},".pylintrc-linter":{configPath:".pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"pylintrc-linter":{configPath:"pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"mypy-ini-linter":{configPath:".mypy.ini",configName:"Python Linter",recommendations:{"ms-python.mypy-type-checker":{name:"Mypy Type Checker"}}},"tox-ini-linter":{configPath:"tox.ini",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}},".flake8-linter":{configPath:".flake8",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8"}}},"python-setup-cgf-linter":{configPath:"setup.cfg",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},azd:{friendlyName:"Azure Dev CLI",windowsPath:"%USERPROFILE%\\AppData\\Local\\Programs\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},"azd-user":{friendlyName:"Azure Dev CLI",windowsPath:"%ProgramFiles%\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],virtualWorkspaceExtensionTips:{"vscode-vfs":{friendlyName:"Remote Repositories",extensionId:"ms-vscode.remote-repositories",startEntry:{helpLink:"https://aka.ms/vscode-remote/remote-repositories",startConnectLabel:"Remote Repository",startCommand:"remoteHub.continueOn.openRepository",priority:5}}},remoteExtensionTips:{wsl:{friendlyName:"WSL",extensionId:"ms-vscode-remote.remote-wsl",supportedPlatforms:["Windows","Web"],startEntry:{helpLink:"https://aka.ms/vscode-remote/wsl",startConnectLabel:"WSL",startCommand:"remote-wsl.connect",priority:3}},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/ssh",startConnectLabel:"SSH ",startCommand:"opensshremotes.openEmptyWindowInCurrentWindow",priority:1}},"dev-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/containers",startConnectLabel:"Dev Container",startCommand:"remote-containers.reopenInContainer",priority:2}},"attached-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},codespaces:{friendlyName:"GitHub Codespaces",extensionId:"github.codespaces",startEntry:{helpLink:"https://aka.ms/vscode-remote-codespaces",startConnectLabel:"GitHub Codespace ",startCommand:"github.codespaces.connect",priority:4}},tunnel:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server",startEntry:{helpLink:"https://aka.ms/remote-tunnels-doc",startConnectLabel:"Tunnel",startCommand:"remote-tunnels.connectCurrentWindowToTunnel",priority:0}}},commandPaletteSuggestedCommandIds:["workbench.action.files.openFile","workbench.action.files.openFileFolder","workbench.action.files.openFolder","workbench.action.remote.showMenu","editor.action.formatDocument","editor.action.commentLine","workbench.action.tasks.runTask","workbench.action.openSettings2","workbench.action.selectTheme","workbench.action.openWalkthrough","workbench.action.openIssueReporter"],extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",serverDocumentationUrl:"https://aka.ms/vscode-server-doc",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",youTubeUrl:"https://aka.ms/vscode-youtube",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",serverLicenseUrl:"https://aka.ms/vscode-server-license",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=521839",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",nodejsRepository:"Microsoft/vscode-node",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05},{surveyId:"csharp.1",surveyUrl:"https://www.research.net/r/8KGJ9V8",languageId:"csharp",editCount:10,userProbability:.05}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","contribShareMenu","contribStatusBarItems","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-toolsai.vscode-ai-remote":["resolvers"],"ms-python.python":["contribEditorContentMenu","quickPickSortByLabel","portsAttributes","testObserver","quickPickItemTooltip","terminalDataWriteEvent","saveEditor"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging","languageConfigurationAutoClosingPairs"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal","notebookKernelSource"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["canonicalUriProvider","contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","shareProvider","scmActionButton","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-vscode-remote.remote-wsl":["resolvers","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers","tunnels","contribViewsWelcome"],"ms-vscode.remote-explorer":["contribRemoteHelp","contribViewsRemote","extensionsAny"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","tunnels","workspaceTrust","terminalDimensions","contribRemoteHelp","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"ms-vscode.vscode-speech":["speech"],"GitHub.vscode-pull-request-github":["contribCommentThreadAdditionalMenu","tokenInformation","contribShareMenu","fileComments","contribCommentPeekContext","codiconDecoration","diffCommand","contribCommentEditorActionsMenu","readonlyMessage","treeViewMarkdownMessage","shareProvider","quickDiffProvider"],"GitHub.copilot":["inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsAdditions"],"GitHub.copilot-chat":["handleIssueUri","interactive","interactiveUserActions","terminalDataWriteEvent","terminalExecuteCommandEvent","terminalSelection","terminalQuickFixProvider","chatVariables","chatAgents","chatAgents2","chatAgents2Additions","defaultChatAgent","readonlyMessage","chatProvider","mappedEditsProvider","aiRelatedInformation","codeActionAI","findTextInFiles","textSearchProvider"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-python.debugpy":["portsAttributes"],"ms-toolsai.jupyter-renderers":["contribNotebookStaticPreloads"],"ms-toolsai.jupyter":["notebookDeprecated","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow","notebookControllerAffinityHidden","contribNotebookStaticPreloads","quickPickItemTooltip","notebookExecution"],"dbaeumer.vscode-eslint":["notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-azuretools.vscode-azureresourcegroups":["authGetSessions"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"],"redhat.java":["documentPaste"],"ms-dotnettools.csdevkit":["inlineCompletionsAdditions"],"ms-dotnettools.vscodeintellicode-csharp":["inlineCompletionsAdditions"],"microsoft-IsvExpTools.powerplatform-vscode":["fileSearchProvider","textSearchProvider"],"microsoft-IsvExpTools.powerplatform-vscode-preview":["fileSearchProvider","textSearchProvider"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://*.github.com","https://login.microsoftonline.com","https://*.vscode.dev","https://*.github.dev","https://gh.io","https://portal.azure.com"],trustedExtensionAuthAccess:["vscode.git","vscode.github","ms-vscode.remote-repositories","github.remotehub","ms-vscode.azure-repos","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","ms-vsliveshare.vsliveshare","github.copilot","github.copilot-chat","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"],trustedExtensionProtocolHandlers:["vscode.git","vscode.github-authentication","vscode.microsoft-authentication"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{github:{scopes:["user:email"]},microsoft:{scopes:["openid","profile","email","offline_access"]}}},"editSessions.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},tunnelServerQualities:{stable:{serverApplicationName:"code-server"},exploration:{serverApplicationName:"code-server-exploration"},insider:{serverApplicationName:"code-server-insiders"}},tunnelApplicationName:"code-tunnel",tunnelApplicationConfig:{editorWebUrl:"https://vscode.dev",extension:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server"},authenticationProviders:{github:{scopes:["user:email","read:org"]}}},win32TunnelServiceMutex:"vscode-tunnelservice",win32TunnelMutex:"vscode-tunnel",commonlyUsedSettings:["files.autoSave","editor.fontSize","editor.fontFamily","GitHub.copilot.manageExtension","editor.tabSize","editor.renderWhitespace","editor.cursorStyle","editor.multiCursorModifier","editor.insertSpaces","editor.wordWrap","files.exclude","files.associations","workbench.editor.enablePreview"],builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.84.0",sha256:"a57691eb4440e549edba7472c0313e94f24d46ebe1ede18784b552fc5d11e596",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",sha256:"b9dab017506d9e6a469a0f82b392e4cb1d7a25a4843f1db8ba396cbee209cfc5",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.19",sha256:"926095d290dc7cdb9daf40ef5ae7591db12171ba1af1f61afcb5a368d0fc66aa",repo:"https://github.com/microsoft/vscode-remote-wsl-recommender",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],aiGeneratedWorkspaceTrust:{title:"This workspace was generated by GitHub Copilot",checkboxText:"Trust the contents of all files in this workspace",trustOption:"Yes, I trust the contents",dontTrustOption:"No, I don't trust the contents",startupTrustRequestLearnMore:"If you don't trust the contents of the files generated by GitHub Copilot, we recommend continuing in restricted mode. See [our docs](https://aka.ms/vscode-workspace-trust) to learn more. "},gitHubEntitlement:{providerId:"github",command:{title:"Install GitHub Copilot (Paid for by {{org}})",titleWithoutPlaceHolder:"Install GitHub Copilot",action:"workbench.extensions.installExtension",when:"workbench.accounts.experimental.showEntitlements"},entitlementUrl:"https://api.github.com/copilot_internal/user",extensionId:"github.copilot",enablementKey:"chat_enabled",confirmationAction:"Install",confirmationMessage:"Are you sure you want to install GitHub Copilot?"},version:"1.84.1",commit:"2b35e1e6d88f1ce073683991d1eff5284a32690f",date:"2023-11-06T12:04:26.825Z"},Object.keys(r).length===0&&Object.assign(r,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(pe[31],be([1,0,6]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.$qj=void 0,e.$qj=(0,D.$Qh)("productService"),e.$rj="vscode://schemas/vscode-product"}),define(pe[37],be([1,0,95,10]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=void 0;class r{constructor(){this.a=new Map}add(P,C){D.ok(R.$zf(P)),D.ok(R.$Bf(C)),D.ok(!this.a.has(P),"There is already an extension with this id"),this.a.set(P,C)}knows(P){return this.a.has(P)}as(P){return this.a.get(P)||null}}e.$kn=new r}),define(pe[228],be([1,0,5,37]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=void 0,e.$ln={JSONContribution:"base.contributions.json"};function r(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class I{constructor(){this.b=new D.$Od,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(v,b){this.a[r(v)]=b,this.b.fire(v)}notifySchemaChanged(v){this.b.fire(v)}getSchemaContributions(){return{schemas:this.a}}}const P=new I;R.$kn.add(e.$ln.JSONContribution,P)}),define(pe[56],be([1,0,18,5,10,173,24,228,37]),function(ue,e,D,R,r,I,P,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.ConfigurationScope=e.$pn=e.EditPresentationTypes=void 0;var b;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(b||(e.EditPresentationTypes=b={})),e.$pn={Configuration:"base.contributions.configuration"};var A;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn="vscode://schemas/settings/resourceLanguage",e.$xn="vscode://schemas/settings/configurationDefaults";const S=v.$kn.as(C.$ln.JSONContribution);class y{constructor(){this.h=new Set,this.i=new R.$Od,this.onDidSchemaChange=this.i.event,this.j=new R.$Od,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$wn,this.g),this.v()}registerConfiguration(n,i=!0){this.registerConfigurations([n],i)}registerConfigurations(n,i=!0){const o=new Set;this.n(n,i,o),S.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(n){const i=new Set;this.o(n,i),S.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:i})}updateConfigurations({add:n,remove:i}){const o=new Set;this.o(i,o),this.n(n,!1,o),S.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(n){const i=new Set;this.k(n,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}k(n,i){const o=[];for(const{overrides:s,source:t}of n)for(const a in s)if(i.add(a),e.$zn.test(a)){const $=this.a.get(a),w=$?.valuesSources??new Map;if(t)for(const j of Object.keys(s[a]))w.set(j,t);const k={...$?.value||{},...s[a]};this.a.set(a,{source:t,value:k,valuesSources:w});const E=(0,P.$ui)(a),L={type:"object",default:k,description:I.localize(1,null,E),$ref:e.$wn,defaultDefaultValue:k,source:r.$zf(t)?void 0:t,defaultValueSource:t};o.push(...d(a)),this.d[a]=L,this.b.properties[a]=L}else{this.a.set(a,{value:s[a],source:t});const $=this.d[a];$&&(this.w(a,$),this.r(a,$))}this.m(o)}deregisterDefaultConfigurations(n){const i=new Set;this.l(n,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}l(n,i){for(const{overrides:o,source:s}of n)for(const t in o){const a=this.a.get(t),$=r.$zf(s)?s:s?.id,w=r.$zf(a?.source)?a?.source:a?.source?.id;if($===w)if(i.add(t),this.a.delete(t),e.$zn.test(t))delete this.d[t],delete this.b.properties[t];else{const k=this.d[t];k&&(this.w(t,k),this.r(t,k))}}this.u()}deltaConfiguration(n){let i=!1;const o=new Set;n.removedDefaults&&(this.l(n.removedDefaults,o),i=!0),n.addedDefaults&&(this.k(n.addedDefaults,o),i=!0),n.removedConfigurations&&this.o(n.removedConfigurations,o),n.addedConfigurations&&this.n(n.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:i})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const i of n)this.h.add(i);this.u()}n(n,i,o){n.forEach(s=>{this.p(s,i,s.extensionInfo,s.restrictedProperties,void 0,o),this.c.push(s),this.q(s)})}o(n,i){const o=s=>{if(s.properties)for(const t in s.properties){i.add(t);const a=this.d[t];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[t],this.s(t,s.properties[t])}s.allOf?.forEach(t=>o(t))};for(const s of n){o(s);const t=this.c.indexOf(s);t!==-1&&this.c.splice(t,1)}}p(n,i=!0,o,s,t=3,a){t=r.$If(n.scope)?t:n.scope;const $=n.properties;if($)for(const k in $){const E=$[k];if(i&&l(k,E)){delete $[k];continue}if(E.source=o,E.defaultDefaultValue=$[k].default,this.w(k,E),e.$zn.test(k)?E.scope=void 0:(E.scope=r.$If(E.scope)?t:E.scope,E.restricted=r.$If(E.restricted)?!!s?.includes(k):E.restricted),$[k].hasOwnProperty("included")&&!$[k].included){this.f[k]=$[k],delete $[k];continue}else this.d[k]=$[k],$[k].policy?.name&&this.e.set($[k].policy.name,k);!$[k].deprecationMessage&&$[k].markdownDeprecationMessage&&($[k].deprecationMessage=$[k].markdownDeprecationMessage),a.add(k)}const w=n.allOf;if(w)for(const k of w)this.p(k,i,o,s,t,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const i=o=>{const s=o.properties;if(s)for(const a in s)this.r(a,s[a]);o.allOf?.forEach(i)};i(n)}r(n,i){switch(e.$qn.properties[n]=i,i.scope){case 1:e.$rn.properties[n]=i;break;case 2:e.$sn.properties[n]=i;break;case 6:e.$tn.properties[n]=i;break;case 3:e.$un.properties[n]=i;break;case 4:e.$vn.properties[n]=i;break;case 5:e.$vn.properties[n]=i,this.g.properties[n]=i;break}}s(n,i){switch(delete e.$qn.properties[n],i.scope){case 1:delete e.$rn.properties[n];break;case 2:delete e.$sn.properties[n];break;case 6:delete e.$tn.properties[n];break;case 3:delete e.$un.properties[n];break;case 4:case 5:delete e.$vn.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const i=`[${n}]`,o={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.$wn};this.w(i,o),e.$qn.properties[i]=o,e.$rn.properties[i]=o,e.$sn.properties[i]=o,e.$tn.properties[i]=o,e.$un.properties[i]=o,e.$vn.properties[i]=o}}v(){const n={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:e.$wn};e.$qn.patternProperties[e.$yn]=n,e.$rn.patternProperties[e.$yn]=n,e.$sn.patternProperties[e.$yn]=n,e.$tn.patternProperties[e.$yn]=n,e.$un.patternProperties[e.$yn]=n,e.$vn.patternProperties[e.$yn]=n,this.i.fire()}w(n,i){const o=this.a.get(n);let s=o?.value,t=o?.source;r.$Gf(s)&&(s=i.defaultDefaultValue,t=void 0),r.$Gf(s)&&(s=h(i.type)),i.default=s,i.defaultValueSource=t}}const u="\\[([^\\]]+)\\]",g=new RegExp(u,"g");e.$yn=`^(${u})+$`,e.$zn=new RegExp(e.$yn);function d(c){const n=[];if(e.$zn.test(c)){let i=g.exec(c);for(;i?.length;){const o=i[1].trim();o&&n.push(o),i=g.exec(c)}}return(0,D.$Mb)(n)}e.$An=d;function f(c){return c.reduce((n,i)=>`${n}[${i}]`,"")}e.$Bn=f;function h(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Cn=h;const p=new y;v.$kn.add(e.$pn.Configuration,p);function l(c,n){return c.trim()?e.$zn.test(c)?I.localize(7,null,c):p.getConfigurationProperties()[c]!==void 0?I.localize(8,null,c):n.policy?.name&&p.getPolicyConfigurations().get(n.policy?.name)!==void 0?I.localize(9,null,c,n.policy?.name,p.getPolicyConfigurations().get(n.policy?.name)):null:I.localize(6,null)}e.$Dn=l;function m(){const c=[],n=p.getConfigurationProperties();for(const i of Object.keys(n))c.push([i,n[i].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.$En=m}),define(pe[115],be([1,0,18,5,75,2,26,22,10,4,24,56,37]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=void 0;function u(i){return Object.isFrozen(i)?i:C.$9m(i)}class g{constructor(o={},s=[],t=[],a){this.b=o,this.c=s,this.d=t,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const o=this.raw.map(s=>{if(s instanceof g)return s;const t=new d("");return t.parseRaw(s),t.configurationModel});this.f=o.reduce((s,t)=>t===s?t:s.merge(t),o[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(o){return o?(0,A.$si)(this.contents,o):this.contents}inspect(o,s){const t=this.rawConfiguration.getValue(o),a=s?this.rawConfiguration.getOverrideValue(o,s):void 0,$=s?this.rawConfiguration.override(s).getValue(o):t;return{value:t,override:a,merged:$}}getOverrideValue(o,s){const t=this.i(s);return t?o?(0,A.$si)(t,o):t:void 0}getKeysForOverrideIdentifier(o){const s=[];for(const t of this.overrides)t.identifiers.includes(o)&&s.push(...t.keys);return D.$Mb(s)}getAllOverrideIdentifiers(){const o=[];for(const s of this.overrides)o.push(...s.identifiers);return D.$Mb(o)}override(o){let s=this.a.get(o);return s||(s=this.g(o),this.a.set(o,s)),s}merge(...o){const s=C.$8m(this.contents),t=C.$8m(this.overrides),a=[...this.keys],$=this.raw?.length?[...this.raw]:[this];for(const w of o)if($.push(...w.raw?.length?w.raw:[w]),!w.isEmpty()){this.h(s,w.contents);for(const k of w.overrides){const[E]=t.filter(L=>D.$ub(L.identifiers,k.identifiers));E?(this.h(E.contents,k.contents),E.keys.push(...k.keys),E.keys=D.$Mb(E.keys)):t.push(C.$8m(k))}for(const k of w.keys)a.indexOf(k)===-1&&a.push(k)}return new g(s,a,t,$.every(w=>w instanceof g)?void 0:$)}g(o){const s=this.i(o);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const a of D.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let $=this.contents[a];const w=s[a];w&&(typeof $=="object"&&typeof w=="object"?($=C.$8m($),this.h($,w)):$=w),t[a]=$}return new g(t,this.keys,this.overrides)}h(o,s){for(const t of Object.keys(s)){if(t in o&&v.$Bf(o[t])&&v.$Bf(s[t])){this.h(o[t],s[t]);continue}o[t]=C.$8m(s[t])}}i(o){let s=null,t=null;const a=$=>{$&&(t?this.h(t,$):t=C.$8m($))};for(const $ of this.overrides)$.identifiers.length===1&&$.identifiers[0]===o?s=$.contents:$.identifiers.includes(o)&&a($.contents);return a(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(o,s){this.j(o,s,!0)}setValue(o,s){this.j(o,s,!1)}removeValue(o){const s=this.keys.indexOf(o);s!==-1&&(this.keys.splice(s,1),(0,A.$ri)(this.contents,o),S.$zn.test(o)&&this.overrides.splice(this.overrides.findIndex(t=>D.$ub(t.identifiers,(0,S.$An)(o))),1))}j(o,s,t){(0,A.$qi)(this.contents,o,s,a=>console.error(a)),t=t||this.keys.indexOf(o)===-1,t&&this.keys.push(o),S.$zn.test(o)&&this.overrides.push({identifiers:(0,S.$An)(o),keys:Object.keys(this.contents[o]),contents:(0,A.$pi)(this.contents[o],a=>console.error(a))})}}e.$Fn=g;class d{constructor(o){this.f=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,s){if(!v.$If(o)){const t=this.g(o);this.parseRaw(t,s)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,s){this.a=o;const{contents:t,keys:a,overrides:$,restricted:w,hasExcludedProperties:k}=this.h(o,s);this.b=new g(t,a,$,k?[o]:void 0),this.c=w||[]}g(o){let s={},t=null,a=[];const $=[],w=[];function k(L){Array.isArray(a)?a.push(L):t!==null&&(a[t]=L)}const E={onObjectBegin:()=>{const L={};k(L),$.push(a),a=L,t=null},onObjectProperty:L=>{t=L},onObjectEnd:()=>{a=$.pop()},onArrayBegin:()=>{const L=[];k(L),$.push(a),a=L,t=null},onArrayEnd:()=>{a=$.pop()},onLiteralValue:k,onError:(L,j,x)=>{w.push({error:L,offset:j,length:x})}};if(o)try{r.$5m(o,E),s=a[0]||{}}catch(L){console.error(`Error while parsing settings file ${this.f}: ${L}`),this.d=[L]}return s}h(o,s){const t=y.$kn.as(S.$pn.Configuration).getConfigurationProperties(),a=this.i(o,t,!0,s);o=a.raw;const $=(0,A.$pi)(o,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),w=Object.keys(o),k=this.j(o,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:$,keys:w,overrides:k,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(o,s,t,a){let $=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:o,restricted:[],hasExcludedProperties:$};const w={},k=[];for(const E in o)if(S.$zn.test(E)&&t){const L=this.i(o[E],s,!1,a);w[E]=L.raw,$=$||L.hasExcludedProperties,k.push(...L.restricted)}else{const L=s[E],j=L?typeof L.scope<"u"?L.scope:3:void 0;L?.restricted&&k.push(E),!a.exclude?.includes(E)&&(a.include?.includes(E)||(j===void 0||a.scopes===void 0||a.scopes.includes(j))&&!(a.skipRestricted&&L?.restricted))?w[E]=o[E]:$=!0}return{raw:w,restricted:k,hasExcludedProperties:$}}j(o,s){const t=[];for(const a of Object.keys(o))if(S.$zn.test(a)){const $={};for(const w in o[a])$[w]=o[a][w];t.push({identifiers:(0,S.$An)(a),keys:Object.keys($),contents:(0,A.$pi)($,s)})}return t}}e.$Gn=d;class f extends I.$Sc{constructor(o,s,t,a){super(),this.c=o,this.f=s,this.g=a,this.b=this.B(new R.$Od),this.onDidChange=this.b.event,this.a=new d(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,$=>$.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,$=>($.isOperation(0)||$.isOperation(3)||$.isOperation(1)||$.isOperation(4))&&t.isEqual($.resource,o)))(()=>this.b.fire()))}async loadConfiguration(){try{const o=await this.g.readFile(this.c);return this.a.parse(o.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new g}}reparse(o){return o&&(this.f=o),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Hn=f;class h{constructor(o,s,t,a,$,w,k,E,L,j,x,ce,X){this.a=o,this.b=s,this.c=t,this.overrideIdentifiers=a,this.d=$,this.f=w,this.g=k,this.h=E,this.i=L,this.j=j,this.k=x,this.l=ce,this.m=X}get value(){return u(this.c)}n(o,s,t){const a=o.inspect(s,t);return{get value(){return u(a.value)},get override(){return u(a.override)},get merged(){return u(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class p{constructor(o,s,t,a,$=new g,w=new g,k=new P.$Ac,E=new g,L=new P.$Ac){this.c=o,this.d=s,this.f=t,this.g=a,this.h=$,this.i=w,this.j=k,this.l=E,this.m=L,this.a=null,this.b=new P.$Ac,this.n=null}getValue(o,s,t){return this.q(o,s,t).getValue(o)}updateValue(o,s,t={}){let a;t.resource?(a=this.m.get(t.resource),a||(a=new g,this.m.set(t.resource,a))):a=this.l,s===void 0?a.removeValue(o):a.setValue(o,s),t.resource||(this.a=null)}inspect(o,s,t){const a=this.q(o,s,t),$=this.u(s.resource,t),w=s.resource?this.m.get(s.resource)||this.l:this.l,k=new Set;for(const E of a.overrides)for(const L of E.identifiers)a.getOverrideValue(o,L)!==void 0&&k.add(L);return new h(o,s,a.getValue(o),k.size?[...k]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,$||void 0,w)}keys(o){const s=this.u(void 0,o);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(o){this.c=o,this.a=null,this.b.clear()}updatePolicyConfiguration(o){this.d=o}updateApplicationConfiguration(o){this.f=o,this.a=null,this.b.clear()}updateLocalUserConfiguration(o){this.g=o,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(o){this.h=o,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(o){this.i=o,this.a=null,this.b.clear()}updateFolderConfiguration(o,s){this.j.set(o,s),this.b.delete(o)}deleteFolderConfiguration(o){this.p.delete(o),this.b.delete(o)}compareAndUpdateDefaultConfiguration(o,s){const t=[];if(!s){const{added:a,updated:$,removed:w}=c(this.c,o);s=[...a,...$,...w]}for(const a of s)for(const $ of(0,S.$An)(a)){const w=this.c.getKeysForOverrideIdentifier($),k=o.getKeysForOverrideIdentifier($),E=[...k.filter(L=>w.indexOf(L)===-1),...w.filter(L=>k.indexOf(L)===-1),...w.filter(L=>!C.$_m(this.c.override($).getValue(L),o.override($).getValue(L)))];t.push([$,E])}return this.updateDefaultConfiguration(o),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(o){const{added:s,updated:t,removed:a}=c(this.d,o),$=[...s,...t,...a];return $.length&&this.updatePolicyConfiguration(o),{keys:$,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:s,updated:t,removed:a,overrides:$}=c(this.applicationConfiguration,o),w=[...s,...t,...a];return w.length&&this.updateApplicationConfiguration(o),{keys:w,overrides:$}}compareAndUpdateLocalUserConfiguration(o){const{added:s,updated:t,removed:a,overrides:$}=c(this.localUserConfiguration,o),w=[...s,...t,...a];return w.length&&this.updateLocalUserConfiguration(o),{keys:w,overrides:$}}compareAndUpdateRemoteUserConfiguration(o){const{added:s,updated:t,removed:a,overrides:$}=c(this.remoteUserConfiguration,o),w=[...s,...t,...a];return w.length&&this.updateRemoteUserConfiguration(o),{keys:w,overrides:$}}compareAndUpdateWorkspaceConfiguration(o){const{added:s,updated:t,removed:a,overrides:$}=c(this.workspaceConfiguration,o),w=[...s,...t,...a];return w.length&&this.updateWorkspaceConfiguration(o),{keys:w,overrides:$}}compareAndUpdateFolderConfiguration(o,s){const t=this.p.get(o),{added:a,updated:$,removed:w,overrides:k}=c(t,s),E=[...a,...$,...w];return(E.length||!t)&&this.updateFolderConfiguration(o,s),{keys:E,overrides:k}}compareAndDeleteFolderConfiguration(o){const s=this.p.get(o);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:t,updated:a,removed:$,overrides:w}=c(s,void 0);return{keys:[...t,...a,...$],overrides:w}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(o,s,t){let a=this.r(s,t);return s.overrideIdentifier&&(a=a.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(o)!==void 0&&(a=a.merge(this.d)),a}r({resource:o},s){let t=this.s();if(s&&o){const a=s.getFolder(o);a&&(t=this.t(a.uri)||t);const $=this.m.get(o);$&&(t=t.merge($))}return t}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(o){let s=this.b.get(o);if(!s){const t=this.s(),a=this.j.get(o);a?(s=t.merge(a),this.b.set(o,s)):s=t}return s}u(o,s){if(s&&o){const t=s.getFolder(o);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((o,s)=>{const{contents:t,overrides:a,keys:$}=this.j.get(s);return o.push([s,{contents:t,overrides:a,keys:$}]),o},[])}}allKeys(){const o=new Set;return this.c.keys.forEach(s=>o.add(s)),this.userConfiguration.keys.forEach(s=>o.add(s)),this.i.keys.forEach(s=>o.add(s)),this.j.forEach(s=>s.keys.forEach(t=>o.add(t))),[...o.values()]}v(){const o=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>o.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>o.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>o.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(t=>o.add(t))),[...o.values()]}w(o){const s=new Set;return this.c.getKeysForOverrideIdentifier(o).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(t=>s.add(t)),this.i.getKeysForOverrideIdentifier(o).forEach(t=>s.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(o).forEach(a=>s.add(a))),[...s.values()]}static parse(o){const s=this.x(o.defaults),t=this.x(o.policy),a=this.x(o.application),$=this.x(o.user),w=this.x(o.workspace),k=o.folders.reduce((E,L)=>(E.set(b.URI.revive(L[0]),this.x(L[1])),E),new P.$Ac);return new p(s,t,a,$,new g,w,k,new g,new P.$Ac)}static x(o){return new g(o.contents,o.keys,o.overrides)}}e.$In=p;function l(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const o=new Set,s=new Map;for(const a of i)a.keys.forEach($=>o.add($)),a.overrides.forEach(([$,w])=>{const k=(0,P.$xc)(s,$,new Set);w.forEach(E=>k.add(E))});const t=[];return s.forEach((a,$)=>t.push([$,[...a.values()]])),{keys:[...o.values()],overrides:t}}e.$Jn=l;class m{constructor(o,s,t,a){this.change=o,this.f=s,this.g=t,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const $ of o.keys)this.affectedKeys.add($);for(const[,$]of o.overrides)for(const w of $)this.affectedKeys.add(w);this.d=this.a;for(const $ of this.affectedKeys)this.d+=$+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(o,s){const t=this.a+o,a=this.d.indexOf(t);if(a<0)return!1;const $=a+t.length;if($>=this.d.length)return!1;const w=this.d.charCodeAt($);if(w!==this.b&&w!==this.c)return!1;if(s){const k=this.previousConfiguration?this.previousConfiguration.getValue(o,s,this.f?.workspace):void 0,E=this.g.getValue(o,s,this.h);return!C.$_m(k,E)}return!0}}e.$Kn=m;function c(i,o){const{added:s,removed:t,updated:a}=n(o?.rawConfiguration,i?.rawConfiguration),$=[],w=i?.getAllOverrideIdentifiers()||[],k=o?.getAllOverrideIdentifiers()||[];if(o){const E=k.filter(L=>!w.includes(L));for(const L of E)$.push([L,o.getKeysForOverrideIdentifier(L)])}if(i){const E=w.filter(L=>!k.includes(L));for(const L of E)$.push([L,i.getKeysForOverrideIdentifier(L)])}if(o&&i){for(const E of w)if(k.includes(E)){const L=n({contents:i.getOverrideValue(void 0,E)||{},keys:i.getKeysForOverrideIdentifier(E)},{contents:o.getOverrideValue(void 0,E)||{},keys:o.getKeysForOverrideIdentifier(E)});$.push([E,[...L.added,...L.removed,...L.updated]])}}return{added:s,removed:t,updated:a,overrides:$}}function n(i,o){const s=i?o?i.keys.filter($=>o.keys.indexOf($)===-1):[...i.keys]:[],t=o?i?o.keys.filter($=>i.keys.indexOf($)===-1):[...o.keys]:[],a=[];if(i&&o){for(const $ of o.keys)if(i.keys.indexOf($)!==-1){const w=(0,A.$si)(o.contents,$),k=(0,A.$si)(i.contents,$);C.$_m(w,k)||a.push($)}}return{added:s,removed:t,updated:a}}}),define(pe[229],be([1,0,18,5,2,22,10,115,56,13,69,37]),function(ue,e,D,R,r,I,P,C,v,b,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=e.$Ln=void 0;class y extends r.$Sc{constructor(){super(...arguments),this.a=this.B(new R.$Od),this.onDidChangeConfiguration=this.a.event,this.b=new C.$Fn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(S.$kn.as(v.$pn.Configuration).onDidUpdateConfiguration(({properties:f,defaultsOverrides:h})=>this.c(Array.from(f),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(f,h){this.h(f,S.$kn.as(v.$pn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:f})}f(){return{}}g(){this.b=new C.$Fn;const f=S.$kn.as(v.$pn.Configuration).getConfigurationProperties();this.h(Object.keys(f),f)}h(f,h){const p=this.f();for(const l of f){const m=p[l],c=h[l];m!==void 0?this.b.addValue(l,m):c?this.b.addValue(l,c.default):this.b.removeValue(l)}}}e.$Ln=y;class u{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new C.$Fn}async initialize(){return this.configurationModel}}e.$Mn=u;let g=class extends r.$Sc{get configurationModel(){return this.b}constructor(f,h,p){super(),this.c=f,this.f=h,this.g=p,this.a=this.B(new R.$Od),this.onDidChangeConfiguration=this.a.event,this.b=new C.$Fn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(f=>this.j(f))),this.B(this.c.onDidChangeConfiguration(async({properties:f})=>this.m(await this.h(f),!0))),this.b}async h(f){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",f);const h={},p=[],l=S.$kn.as(v.$pn.Configuration).getConfigurationProperties();for(const m of f){const c=l[m];if(!c){p.push(m);continue}if(c.policy){if(c.type!=="string"&&c.type!=="number"){this.g.warn(`Policy ${c.policy.name} has unsupported type ${c.type}`);continue}p.push(m),h[c.policy.name]={type:c.type}}}return(0,P.$Mf)(h)||await this.f.updatePolicyDefinitions(h),p}j(f){this.g.trace("PolicyConfiguration#onDidChangePolicies",f);const h=S.$kn.as(v.$pn.Configuration).getPolicyConfigurations(),p=(0,D.$Hb)(f.map(l=>h.get(l)));this.m(p,!0)}m(f,h){this.g.trace("PolicyConfiguration#update",f);const p=S.$kn.as(v.$pn.Configuration).getConfigurationProperties(),l=[],m=this.b.isEmpty();for(const c of f){const n=p[c]?.policy?.name;if(n){const i=this.f.getPolicyValue(n);(m?i!==void 0:!(0,I.$_m)(this.b.getValue(c),i))&&l.push([c,i])}else this.b.getValue(c)!==void 0&&l.push([c,void 0])}if(l.length){this.g.trace("PolicyConfiguration#changed",l);const c=this.b;this.b=new C.$Fn;for(const n of c.keys)this.b.setValue(n,c.getValue(n));for(const[n,i]of l)i===void 0?this.b.removeValue(n):this.b.setValue(n,i);h&&this.a.fire(this.b)}}};e.$Nn=g,e.$Nn=g=Oe([Ae(1,A.$mn),Ae(2,b.$$i)],g)}),define(pe[116],be([1,0,14,5,2,19,24,115,229,69]),function(ue,e,D,R,r,I,P,C,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=void 0;class A extends r.$Sc{constructor(y,u,g,d){super(),this.j=y,this.h=this.B(new R.$Od),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new v.$Ln),this.c=g instanceof b.$on?new v.$Mn:this.B(new v.$Nn(this.b,g,d)),this.f=this.B(new C.$Hn(this.j,{},I.$ng,u)),this.a=new C.$In(this.b.configurationModel,this.c.configurationModel,new C.$Fn,new C.$Fn),this.g=this.B(new D.$7g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:f,properties:h})=>this.n(f,h))),this.B(this.c.onDidChangeConfiguration(f=>this.r(f))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[y,u,g]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new C.$In(y,u,new C.$Fn,g)}getConfigurationData(){return this.a.toData()}getValue(y,u){const g=typeof y=="string"?y:void 0,d=(0,P.$li)(y)?y:(0,P.$li)(u)?u:{};return this.a.getValue(g,d,void 0)}updateValue(y,u,g,d){return Promise.reject(new Error("not supported"))}inspect(y){return this.a.inspect(y,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const y=await this.f.loadConfiguration();this.m(y)}m(y){const u=this.a.toData(),g=this.a.compareAndUpdateLocalUserConfiguration(y);this.s(g,u,2)}n(y,u){const g=this.a.toData(),d=this.a.compareAndUpdateDefaultConfiguration(y,u);this.s(d,g,7)}r(y){const u=this.a.toData(),g=this.a.compareAndUpdatePolicyConfiguration(y);this.s(g,u,7)}s(y,u,g){const d=new C.$Kn(y,{data:u},this.a);d.source=g,d.sourceConfig=this.t(g),this.h.fire(d)}t(y){switch(y){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$On=A}),define(pe[117],be([1,0,11,6]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.RemoteAuthorityResolverErrorCode=e.$Sk=e.$Rk=e.RemoteConnectionType=e.$Qk=void 0,e.$Qk=(0,R.$Qh)("remoteAuthorityResolverService");var r;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(r||(e.RemoteConnectionType=r={}));class I{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$Rk=I;class P{constructor(S,y){this.host=S,this.port=y,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sk=P;var C;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(C||(e.RemoteAuthorityResolverErrorCode=C={}));class v extends D.$bb{static isNotAvailable(S){return S instanceof v&&S._code===C.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof v&&S._code===C.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof v&&S._code===C.NoResolverFound}static isInvalidAuthority(S){return S instanceof v&&S._code===C.InvalidAuthority}static isHandled(S){return S instanceof v&&S.isHandled}constructor(S,y=C.Unknown,u){super(S),this._message=S,this._code=y,this._detail=u,this.isHandled=y===C.NotAvailable&&u===!0,Object.setPrototypeOf(this,v.prototype)}}e.$Tk=v;function b(A){const S=A.indexOf("+");return S===-1?A:A.substring(0,S)}e.$Uk=b}),define(pe[230],be([1,0,6]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QN=e.$PN=void 0,e.$PN=(0,D.$Qh)("IRemoteExtensionsScannerService"),e.$QN="remoteExtensionsScanner"}),define(pe[57],be([1,0,12]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=void 0;function R(b){return b.scheme===D.Schemas.vscodeRemote?b.authority:void 0}e.$Vk=R;function r(b){if(!b)return;const A=b.indexOf("+");return A<0?b:b.substr(0,A)}e.$Wk=r;function I(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.$Xk=I;function P(b){const{host:A,port:S}=v(b);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:S}}e.$Yk=P;function C(b,A){let{host:S,port:y}=v(b);return typeof y>"u"&&(y=A),{host:S,port:y}}e.$Zk=C;function v(b){const A=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const S=b.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const y=b.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:b,port:void 0}}}),define(pe[35],be([1,0,17,6,57]),function(ue,e,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.TargetPlatform=e.ExtensionType=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=void 0,e.$1l="extensions.user.cache",e.$2l="extensions.builtin.cache",e.$3l="undefined_publisher",e.$4l=["ui","workspace","web"];function I(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.$5l=I,e.$6l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(P||(e.ExtensionType=P={}));var C;(function(d){d.WIN32_X64="win32-x64",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(C||(e.TargetPlatform=C={}));class v{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,h){if(typeof f>"u"||f===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof f=="string"||typeof h=="string"){const p=typeof f=="string"?f:f.value,l=typeof h=="string"?h:h.value;return D.$3e(p,l)}return f._lower===h._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$7l=v;class b{get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const h of f)this.add(h)}add(f){this.c.add(v.toKey(f))}delete(f){return this.c.delete(v.toKey(f))}has(f){return this.c.has(v.toKey(f))}}e.$8l=b;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete(v.toKey(f))}get(f){return this.c.get(v.toKey(f))}has(f){return this.c.has(v.toKey(f))}set(f,h){this.c.set(v.toKey(f),h)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$9l=A;function S(d){return y(d)}e.$0l=S;function y(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.$$l=y;function u(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.$_l=u;function g(d,f){if(f){const h=`onResolveRemoteAuthority:${(0,r.$Wk)(f)}`;return!!d.activationEvents?.includes(h)}return!1}e.$am=g,e.$bm=(0,R.$Qh)("IBuiltinExtensionsScannerService")}),define(pe[231],be([1,0,11,35]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3E=e.$2E=void 0;class r{constructor(){this.a=new Map,this.b=new WeakMap}register(P,C){this.a.set(P,C)}readActivationEvents(P){return this.b.has(P)||this.b.set(P,this.c(P)),this.b.get(P)}createActivationEventsMap(P){const C=Object.create(null);for(const v of P){const b=this.readActivationEvents(v);b.length>0&&(C[R.$7l.toKey(v.identifier)]=b)}return C}c(P){if(typeof P.main>"u"&&typeof P.browser>"u")return[];const C=Array.isArray(P.activationEvents)?P.activationEvents.slice(0):[];if(!P.contributes)return C;for(const v in P.contributes){const b=this.a.get(v);if(!b)continue;const A=P.contributes[v],S=Array.isArray(A)?A:[A];try{b(S,C)}catch(y){(0,D.$1)(y)}}return C}}e.$2E=r,e.$3E=new r}),define(pe[232],be([1,0,2,35,16]),function(ue,e,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;class I extends D.$Sc{constructor(C,v,b,A,S){super(),this.a=C,this.b=v,this.c=b,this.f=S,this.B(A.onDidInstallExtensions(y=>this.g(y))),this.B(A.onDidUninstallExtension(y=>this.h(y)))}g(C){for(const v of C)v.local&&this.invalidate(v.profileLocation)}h(C){C.error||this.invalidate(C.profileLocation)}async invalidate(C){if(C)for(const v of this.a.profiles)this.c.extUri.isEqual(v.extensionsResource,C)&&await this.j(v);else await this.j(this.a.defaultProfile)}async j(C){try{await this.b.del(this.c.extUri.joinPath(C.cacheHome,R.$1l))}catch(v){(0,r.$qk)(v)!==1&&this.f.error(v)}}}e.$Kp=I}),define(pe[44],be([1,0,15,11,2,192,56,6,13,37]),function(ue,e,D,R,r,I,P,C,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0,e.$Wo=(0,C.$Qh)("requestService");class A{constructor(c){this.b=c}toJSON(){if(!this.a){const c=Object.create(null);for(const n in this.b)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?c[n]="*****":c[n]=this.b[n];this.a=c}return this.a}}class S extends r.$Sc{constructor(c){super(),this.b=0,this.a=c.createLogger("network",{name:(0,I.localize)(0,null),when:v.$pj.isEqualTo((0,v.$nj)(v.LogLevel.Trace)).serialize()})}async c(c,n,i){const o=`${c} #${++this.b}: ${n.url}`;this.a.trace(`${o} - begin`,n.type,new A(n.headers??{}));try{const s=await i();return this.a.trace(`${o} - end`,n.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${o} - error`,n.type,(0,R.$0)(s)),s}}}e.$Xo=S;function y(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}e.$Yo=y;function u(m){return m.res.statusCode===204}e.$Zo=u;async function g(m){return u(m)?null:(await(0,D.$oe)(m.stream)).toString()}e.$1o=g;async function d(m){if(!y(m))throw new Error("Server returned "+m.res.statusCode);return g(m)}e.$2o=d;async function f(m){if(!y(m))throw new Error("Server returned "+m.res.statusCode);if(u(m))return null;const n=(await(0,D.$oe)(m.stream)).toString();try{return JSON.parse(n)}catch(i){throw i.message+=`:
`+n,i}}e.$3o=f;function h(m){l(m)}e.$4o=h;let p;function l(m){const c=b.$kn.as(P.$pn.Configuration),n=p;p={id:"http",order:15,title:(0,I.localize)(1,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,I.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,I.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,I.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,I.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,I.localize)(6,null),(0,I.localize)(7,null),(0,I.localize)(8,null),(0,I.localize)(9,null)],default:"override",description:(0,I.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,I.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,I.localize)(12,null),restricted:!0}}},c.updateConfigurations({add:[p],remove:n?[n]:[]})}l(1)}),define(pe[233],be([1,0,20,12,16,44]),function(ue,e,D,R,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3N=void 0;let P=class{constructor(v,b){this.a=v,this.b=b}async download(v,b,A=D.CancellationToken.None){if(v.scheme===R.Schemas.file||v.scheme===R.Schemas.vscodeRemote){await this.b.copy(v,b);return}const S={type:"GET",url:v.toString(!0)},y=await this.a.request(S,A);if(y.res.statusCode===200)await this.b.writeFile(b,y.stream);else{const u=await(0,I.$2o)(y);throw new Error(`Expected 200, got back ${y.res.statusCode} instead.

${u}`)}}};e.$3N=P,e.$3N=P=Oe([Ae(0,I.$Wo),Ae(1,r.$_j)],P)}),define(pe[234],be([1,0,15,20]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=void 0;class r{constructor(C){this.a=C}listen(C,v){throw new Error("Invalid listen")}call(C,v,b,A=R.CancellationToken.None){switch(v){case"request":return this.a.request(b[0],A).then(async({res:S,stream:y})=>{const u=await(0,D.$oe)(y);return[{statusCode:S.statusCode,headers:S.headers},u]});case"resolveProxy":return this.a.resolveProxy(b[0])}throw new Error("Invalid call")}}e.$Zq=r;class I{constructor(C){this.a=C}async request(C,v){const[b,A]=await this.a.call("request",[C],v);return{res:b,stream:(0,D.$qe)(A)}}async resolveProxy(C){return this.a.call("resolveProxy",[C])}}e.$1q=I}),define(pe[235],be([1,0,85,10]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;function r(P,C){return P.protocol==="http:"?C.HTTP_PROXY||C.http_proxy||null:P.protocol==="https:"&&(C.HTTPS_PROXY||C.https_proxy||C.HTTP_PROXY||C.http_proxy)||null}async function I(P,C,v={}){const b=(0,D.parse)(P),A=v.proxyUrl||r(b,C);if(!A)return null;const S=(0,D.parse)(A);if(!/^https?:$/.test(S.protocol||""))return null;const y={host:S.hostname||"",port:(S.port?+S.port:0)||(S.protocol==="https"?443:80),auth:S.auth,rejectUnauthorized:(0,R.$Ff)(v.strictSSL)?v.strictSSL:!0};return b.protocol==="http:"?new(await new Promise((u,g)=>{ue(["http-proxy-agent"],u,g)})).HttpProxyAgent(A,y):new(await new Promise((u,g)=>{ue(["https-proxy-agent"],u,g)})).HttpsProxyAgent(A,y)}e.$2q=I}),define(pe[86],be([1,0,52,7,193,20,39,11,3,23,105,210,14,144]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=void 0;let g;async function d(h,p,l,m){return l["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):v.$j?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,S.$Ol)(m)&&!l["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,S.$Ol)(m)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=y.Promises.withAsyncBody(async(c,n)=>{const i=new I.$Yd;let o=1e4;const s=h.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(o=(0,u.$Pl)(s,1,120)*1e3);const t=setTimeout(()=>{i.dispose(!0),n(new Error((0,r.localize)(0,null)))},o);try{c(await f(p,i.token))}catch(a){!(0,C.$4)(a)&&!i.token.isCancellationRequested?n(new Error((0,r.localize)(1,null,(0,P.$Bi)(a)))):c({})}finally{clearTimeout(t),i.dispose()}})),g)}e.$Ul=d;async function f(h,p){const l=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",l);const m=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",m);const c=(0,b.$fg)().replace(/-/g,"").substr(0,12),n=new RegExp(c+"({.*})"+c),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",i);const o=await(0,A.$El)(v.OS,i);return h.trace("getUnixShellEnvironment#shell",o),new Promise((s,t)=>{if(p.isCancellationRequested)return t(new C.$5);const a=(0,R.$nc)(o);let $,w;const k=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?($=`& '${process.execPath}' ${k} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,w=["-Login","-Command"]):a==="nu"?($=`^'${process.execPath}' ${k} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,w=["-i","-l","-c"]):($=`'${process.execPath}' ${k} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,a==="tcsh"||a==="csh"?w=["-ic"]:w=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(w),$);const E=(0,D.spawn)(o,[...w,$],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});p.onCancellationRequested(()=>(E.kill(),t(new C.$5))),E.on("error",x=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,P.$Bi)(x)),t(x)});const L=[];E.stdout.on("data",x=>L.push(x));const j=[];E.stderr.on("data",x=>j.push(x)),E.on("close",(x,ce)=>{const X=Buffer.concat(L).toString("utf8");h.trace("getUnixShellEnvironment#raw",X);const ie=Buffer.concat(j).toString("utf8");if(ie.trim()&&h.trace("getUnixShellEnvironment#stderr",ie),x||ce)return t(new Error((0,r.localize)(2,null,x,ce)));const he=n.exec(X),_=he?he[1]:"{}";try{const de=JSON.parse(_);l?de.ELECTRON_RUN_AS_NODE=l:delete de.ELECTRON_RUN_AS_NODE,m?de.ELECTRON_NO_ATTACH_CONSOLE=m:delete de.ELECTRON_NO_ATTACH_CONSOLE,delete de.VSCODE_RESOLVING_ENVIRONMENT,delete de.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",de),s(de)}catch(de){h.error("getUnixShellEnvironment#errorCaught",(0,P.$Bi)(de)),t(de)}})})}}),define(pe[236],be([1,0,6]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=e.$EN=void 0,e.$EN=(0,D.$Qh)("stateReadService"),e.$FN=(0,D.$Qh)("stateService")}),define(pe[237],be([1,0,14,15,2,10,25,16,13]),function(ue,e,D,R,r,I,P,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IN=e.$HN=e.$GN=e.SaveStrategy=void 0;var b;(function(u){u[u.IMMEDIATE=0]="IMMEDIATE",u[u.DELAYED=1]="DELAYED"})(b||(e.SaveStrategy=b={}));class A extends r.$Sc{constructor(g,d,f,h){super(),this.h=g,this.j=f,this.m=h,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=d===0?void 0:this.B(new D.$Sg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(g){g.fileOperationResult!==1&&this.j.error(g)}}getItem(g,d){const f=this.a[g];return(0,I.$If)(f)?d:f}setItem(g,d){this.setItems([{key:g,data:d}])}setItems(g){let d=!1;for(const{key:f,data:h}of g)this.a[f]!==h&&((0,I.$If)(h)?(0,I.$Gf)(this.a[f])||(this.a[f]=void 0,d=!0):(this.a[f]=h,d=!0));d&&this.r()}removeItem(g){(0,I.$Gf)(this.a[g])||(this.a[g]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const g=JSON.stringify(this.a,null,4);if(g!==this.b)try{await this.m.writeFile(this.h,R.$ce.fromString(g),{atomic:{postfix:".vsctmp"}}),this.b=g}catch(d){this.j.error(d)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$GN=A;let S=class extends r.$Sc{constructor(g,d,f,h){super(),this.a=this.B(new A(d.stateResource,g,f,h))}async init(){await this.a.init()}getItem(g,d){return this.a.getItem(g,d)}};e.$HN=S,e.$HN=S=Oe([Ae(1,P.$Xh),Ae(2,v.$$i),Ae(3,C.$_j)],S);class y extends S{setItem(g,d){this.a.setItem(g,d)}setItems(g){this.a.setItems(g)}removeItem(g){this.a.removeItem(g)}close(){return this.a.close()}}e.$IN=y}),define(pe[118],be([1,0,3,29,23]),function(ue,e,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=void 0;function I(v){if(D.$u===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}function P(v,b,A,S,y,u,g,d,f){const h=Object.create(null);h["common.machineId"]=u,h["common.sqmId"]=g,h.sessionID=(0,r.$fg)()+Date.now(),h.commitHash=S,h.version=y,h["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,D.$i)(D.$u),h["common.nodePlatform"]=R.$dc,h["common.nodeArch"]=A,h["common.product"]=f||"desktop",d&&(h["common.msftInternal"]=d);let p=0;const l=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),D.$m&&(h["common.snap"]="true");const m=I(b);return m&&(h["common.platformDetail"]=m),h}e.$lo=P;function C(v){const b=R.env.USERDNSDOMAIN;if(!b)return!1;const A=b.toLowerCase();return v.some(S=>A===S)}e.$mo=C}),define(pe[238],be([1,0,18,11,2,22,16]),function(ue,e,D,R,r,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var C;(function(b){function A(S,y){return S.callstack<y.callstack?-1:S.callstack>y.callstack?1:0}b.compare=A})(C||(e.ErrorEvent=C={}));class v{static{this.ERROR_FLUSH_TIMEOUT=5*1e3}constructor(A,S=v.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new r.$Rc,this.c=A,this.d=S;const y=R.$X.addListener(u=>this.j(u));this.h.add((0,r.$Qc)(y)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(A){if(!A||A.code||(A.detail&&A.detail.stack&&(A=A.detail),R.$bb.isErrorNoTelemetry(A)||A instanceof P.$uk||typeof A?.message=="string"&&A.message.includes("Unable to read file")))return;const S=Array.isArray(A.stack)?A.stack.join(`
`):A.stack,y=A.message?A.message:(0,I.$an)(A);S&&this.k({msg:y,callstack:S})}k(A){const S=(0,D.$wb)(this.g,A,C.compare);S<0?(A.count=1,this.g.splice(~S,0,A)):(this.g[S].count||(this.g[S].count=0),this.g[S].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const A of this.g)this.c.publicLogError2("UnhandledError",A);this.g.length=0}}e.default=v}),define(pe[239],be([1,0,2]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sr=void 0;class R extends D.$Sc{constructor(I,P){super(),this.a=I,this.b=P}async call(I,P,C){switch(P){case"updateTelemetryLevel":{const{telemetryLevel:v}=C;return this.a.updateInjectedTelemetryLevel(v)}case"logTelemetry":{const{eventName:v,data:b}=C;return this.b?this.b.log(v,b):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${P} not found`)}listen(I,P,C){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.$Sr=R}),define(pe[32],be([1,0,6]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=void 0,e.$dl=(0,D.$Qh)("telemetryService"),e.$el=(0,D.$Qh)("customEndpointTelemetryService"),e.$fl="telemetry.currentSessionDate",e.$gl="telemetry.firstSessionDate",e.$hl="telemetry.lastSessionDate",e.$il="telemetry.machineId",e.$jl="telemetry.sqmId",e.$kl="telemetry",e.$ll="telemetry.telemetryLevel",e.$ml="telemetry.enableCrashReporter",e.$nl="telemetry.enableTelemetry";var R;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var r;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(r||(e.TelemetryConfiguration=r={}))}),define(pe[240],be([1,0,28,14,75,12,7,3,4,101,21,104,216,16,31,32]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=e.$Jr=e.$Ir=e.$Hr=void 0;const f=new Map;async function h(n,i){const o=`${n}::${i.join(":")}`,s=f.get(o);if(s)return s;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,$=new Map,w=2e4;function k(L,j,x,ce){const X=j.substring(L.length+1);return R.Promises.withAsyncBody(async ie=>{let he;try{he=await A.Promises.readdir(j,{withFileTypes:!0})}catch{ie();return}if(ce.count>=w){ce.count+=he.length,ce.maxReached=!0,ie();return}let _=he.length;if(_===0){ie();return}let de=he;ce.count+he.length>w&&(ce.maxReached=!0,_=w-ce.count,de=he.slice(0,_)),ce.count+=he.length;for(const Z of de)if(Z.isDirectory()){if(x.includes(Z.name)||await k(L,(0,P.$jc)(j,Z.name),x,ce),--_===0){ie();return}}else{const ne=Z.name.lastIndexOf(".");if(ne>=0){const J=Z.name.substring(ne+1);J&&a.set(J,(a.get(J)??0)+1)}for(const J of t)J.relativePathPattern?.test(X)!==!1&&J.filePattern.test(Z.name)&&$.set(J.tag,($.get(J.tag)??0)+1);if(--_===0){ie();return}}})}const E=R.Promises.withAsyncBody(async L=>{const j={count:0,maxReached:!1};await k(n,n,i,j);const x=await m(n);L({configFiles:p($),fileTypes:p(a),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:x})});return f.set(o,E),E}e.$Hr=h;function p(n){return Array.from(n.entries(),([i,o])=>({name:i,count:o})).sort((i,o)=>o.count-i.count)}function l(){const n={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/u.$Hk.GB).toFixed(2)}GB (${(D.freemem()/u.$Hk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(b.$Sm.value()*100)}%`},i=D.cpus();return i&&i.length>0&&(n.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),n}e.$Ir=l;async function m(n){try{const i=new Map,o=(0,P.$jc)(n,".vscode","launch.json"),s=await A.Promises.readFile(o),t=[],a=(0,r.$Xm)(s.toString(),t);if(t.length)return console.log(`Unable to parse ${o}`),[];if((0,r.$7m)(a)==="object"&&a.configurations)for(const $ of a.configurations){const w=$.type;w&&(i.has(w)?i.set(w,i.get(w)+1):i.set(w,1))}return p(i)}catch{return[]}}e.$Jr=m;let c=class{constructor(i,o){this.c=i,this.d=o}f(i){const o=[];return o.push(`OS Version:       ${i.os}`),o.push(`CPUs:             ${i.cpus}`),o.push(`Memory (System):  ${i.memory}`),o.push(`VM:               ${i.vmHint}`),o.join(`
`)}g(i){const o=[];o.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),o.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const s=D.cpus();return s&&s.length>0&&o.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),o.push(`Memory (System):  ${(D.totalmem()/u.$Hk.GB).toFixed(2)}GB (${(D.freemem()/u.$Hk.GB).toFixed(2)}GB free)`),C.$j||o.push(`Load (avg):       ${D.loadavg().map(t=>Math.round(t)).join(", ")}`),o.push(`VM:               ${Math.round(b.$Sm.value()*100)}%`),o.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${i.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.j(i.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(i,o){return Promise.all([(0,S.$Gr)(i.mainPID),this.k(i)]).then(async s=>{let[t,a]=s,$=this.m(i,t);return o.forEach(w=>{if((0,y.$sm)(w))$+=`
${w.errorMessage}`,a+=`
${w.errorMessage}`;else if($+=`

Remote: ${w.hostName}`,w.processes&&($+=`
${this.m(i,w.processes)}`),w.workspaceMetadata){a+=`
|  Remote: ${w.hostName}`;for(const k of Object.keys(w.workspaceMetadata)){const E=w.workspaceMetadata[k];let L=`${E.fileCount} files`;E.maxFilesReached&&(L=`more than ${L}`),a+=`|    Folder (${k}): ${L}`,a+=this.h(E)}}}),{processInfo:$,workspaceInfo:a}})}async getSystemInfo(i,o){const{memory:s,vmHint:t,os:a,cpus:$}=l(),w={os:a,memory:s,cpus:$,vmHint:t,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:o};return C.$j||(w.load=`${D.loadavg().map(k=>Math.round(k)).join(", ")}`),C.$l&&(w.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(w)}async getDiagnostics(i,o){const s=[];return(0,S.$Gr)(i.mainPID).then(async t=>(s.push(""),s.push(this.g(i)),s.push(""),s.push(this.m(i,t)),i.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(i))),o.forEach(a=>{if((0,y.$sm)(a))s.push(`
${a.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${a.hostName}`),s.push(this.f(a.machineInfo)),a.processes&&s.push(this.m(i,a.processes)),a.workspaceMetadata)for(const $ of Object.keys(a.workspaceMetadata)){const w=a.workspaceMetadata[$];let k=`${w.fileCount} files`;w.maxFilesReached&&(k=`more than ${k}`),s.push(`Folder (${$}): ${k}`),s.push(this.h(w))}}),s.push(""),s.push(""),s.join(`
`)))}h(i){const o=[];let t=0;const a=(E,L)=>{const j=` ${E}(${L})`;t+j.length>60?(o.push($),$="|                 ",t=$.length):t+=j.length,$+=j};let $="|      File types:";const w=10,k=i.fileTypes.length>w?w:i.fileTypes.length;for(let E=0;E<k;E++){const L=i.fileTypes[E];a(L.name,L.count)}if(o.push($),i.configFiles.length>=0&&($="|      Conf files:",t=0,i.configFiles.forEach(E=>{a(E.name,E.count)}),o.push($)),i.launchConfigFiles.length>0){let E="|      Launch Configs:";i.launchConfigFiles.forEach(L=>{const j=L.count>1?` ${L.name}(${L.count})`:` ${L.name}`;E+=j}),o.push(E)}return o.join(`
`)}j(i){const o=Math.max(...Object.keys(i).map(s=>s.length));return Object.keys(i).map(s=>`${s}:  ${" ".repeat(o-s.length)}  ${i[s]}`).join(`
                  `)}k(i){const o=[],s=[];return i.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(o.push(`|  Window (${t.title})`),t.folderURIs.forEach(a=>{const $=v.URI.revive(a);if($.scheme===I.Schemas.file){const w=$.fsPath;s.push(h(w,["node_modules",".git"]).then(k=>{let E=`${k.fileCount} files`;k.maxFilesReached&&(E=`more than ${E}`),o.push(`|    Folder (${(0,P.$nc)(w)}): ${E}`),o.push(this.h(k))}).catch(k=>{o.push(`|      Error: Unable to collect workspace stats for folder ${w} (${k.toString()})`)}))}else o.push(`|    Folder (${$.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(t=>o.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(i,o){const s=new Map;i.windows.forEach(a=>s.set(a.pid,`window [${a.id}] (${a.title})`)),i.pidToNames.forEach(({pid:a,name:$})=>s.set(a,$));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),o&&this.n(i.mainPID,s,t,o,0),t.join(`
`)}n(i,o,s,t,a){const $=a===0;let w;$?w=t.pid===i?`${this.d.applicationName} main`:"remote agent":o.has(t.pid)?w=o.get(t.pid):w=`${"  ".repeat(a)} ${t.name}`;const k=process.platform==="win32"?t.mem:D.totalmem()*(t.mem/100);s.push(`${t.load.toFixed(0).padStart(5," ")}	${(k/u.$Hk.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${w}`),Array.isArray(t.children)&&t.children.forEach(E=>this.n(i,o,s,E,a+1))}async getWorkspaceFileExtensions(i){const o=new Set;for(const{uri:s}of i.folders){const t=v.URI.revive(s);if(t.scheme!==I.Schemas.file)continue;const a=t.fsPath;try{(await h(a,["node_modules",".git"])).fileTypes.forEach(w=>o.add(w.name))}catch{}}return{extensions:[...o]}}async reportWorkspaceStats(i){for(const{uri:o}of i.folders){const s=v.URI.revive(o);if(s.scheme!==I.Schemas.file)continue;const t=s.fsPath;try{const a=await h(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),a.fileTypes.forEach($=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:$.name,count:$.count})}),a.launchConfigFiles.forEach($=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:$.name,count:$.count})}),a.configFiles.forEach($=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:$.name,count:$.count})})}catch{}}}};e.$Kr=c,e.$Kr=c=Oe([Ae(0,d.$dl),Ae(1,g.$qj)],c)}),define(pe[38],be([1,0,22,10,5,24,57,118,32]),function(ue,e,D,R,r,I,P,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=void 0;class b{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$no=b;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$oo=A,e.$po=new A;class S{async publicLog(t,a,$){}async publicLogError(t,a,$){}}e.$qo=S,e.$ro="telemetry",e.$so="extensionTelemetryLog",e.$to={log:()=>null,flush:()=>Promise.resolve(null)};function y(s,t){return r.Event.debounce(t.onDidChangeConfiguration,($,w)=>{const k=$?new Set([...$.affectedKeys,...w.affectedKeys]):w.affectedKeys;return{...w,affectedKeys:k}},1e3,!0)($=>{$.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,I.$ni)($.source),configurationKeys:Array.from($.affectedKeys)})})}e.$uo=y;function u(s,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!s.enableTelemetry)}e.$vo=u;function g(s,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.$wo=g;function d(s){const t=s.getValue(v.$ll),a=s.getValue(v.$ml);if(s.getValue(v.$nl)===!1||a===!1)return 0;switch(t??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$xo=d;function f(s){const t={},a={},$={};l(s,$);for(let w in $){w=w.length>150?w.substr(w.length-149):w;const k=$[w];typeof k=="number"?a[w]=k:typeof k=="boolean"?a[w]=k?1:0:typeof k=="string"?(k.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${k.length}`),t[w]=k.substring(0,8191)):typeof k<"u"&&k!==null&&(t[w]=k)}return{properties:t,measurements:a}}e.$yo=f;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(s){if(!s)return"none";const t=(0,P.$Wk)(s);return h.has(t)?t:"other"}e.$zo=p;function l(s,t,a=0,$){if(s)for(const w of Object.getOwnPropertyNames(s)){const k=s[w],E=$?$+w:w;Array.isArray(k)?t[E]=(0,D.$an)(k):k instanceof Date?t[E]=k.toISOString():(0,R.$Bf)(k)?a<2?l(k,t,a+1,E+"."):t[E]=(0,D.$an)(k):t[E]=k}}function m(s,t){const a=s.msftInternalDomains||[],$=t.getValue("telemetry.internalTesting");return(0,C.$mo)(a)||$}e.$Ao=m;function c(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.$Bo=c;function n(s,t){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let a=s;const $=[];for(const L of t)for(;;){const j=L.exec(s);if(!j)break;$.push([j.index,L.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,k=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(a="";;){const L=k.exec(s);if(!L)break;const j=$.some(([x,ce])=>L.index<ce&&x<k.lastIndex);!w.test(L[0])&&!j&&(a+=s.substring(E,L.index)+"<REDACTED: user-file-path>",E=k.lastIndex)}return E<s.length&&(a+=s.substr(E)),a}function i(s){if(!s)return s;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of t)if(a.regex.test(s))return`<REDACTED: ${a.label}>`;return s}function o(s,t){return(0,D.$0m)(s,a=>{if(a instanceof b||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let $=a.replaceAll("%20"," ");$=n($,t);for(const w of t)$=$.replace(w,"");return $=i($),$}})}e.$Co=o}),define(pe[36],be([1,0,17,30,35,3,4,11,29,38]),function(ue,e,D,R,r,I,P,C,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=void 0;function A(o,s){return o.uuid&&s.uuid?o.uuid===s.uuid:o.id===s.id?!0:(0,D.$Xe)(o.id,s.id)===0}e.$Do=A;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(s){const t=s.manifest?s.manifest.version:s.version,a=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new y(s.identifier,t,a)}static parse(s){const t=S.exec(s);return t&&t[1]&&t[2]?new y({id:t[1]},t[2],t[4]||void 0):null}constructor(s,t,a="undefined"){this.version=t,this.targetPlatform=a,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof y?A(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$Eo=y;const u=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(o){const s=u.exec(o);return s&&s[1]?[f(s[1]),s[2]]:[f(o),void 0]}e.$Fo=g;function d(o,s){return`${o}.${s}`}e.$Go=d;function f(o){return o.toLowerCase()}e.$Ho=f;function h(o,s){return f(d(o??r.$3l,s))}e.$Io=h;function p(o,s){const t=[],a=$=>{for(const w of t)if(w.some(k=>A(s(k),s($))))return w;return null};for(const $ of o){const w=a($);w?w.push($):t.push([$])}return t}e.$Jo=p;function l(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.$Ko=l;function m(o){return{id:new b.$no(o.identifier.id),name:new b.$no(o.name),galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$Lo=m,e.$Mo=new r.$7l("pprice.better-merge");function c(o,s){const t=[],a=s.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const $=a.shift();if($&&t.every(w=>!A(w.identifier,{id:$}))){const w=o.filter(k=>A(k.identifier,{id:$}));w.length===1&&(t.push(w[0]),a.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$No=c;async function n(o,s){if(!I.$l)return!1;let t;try{t=(await o.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await o.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch($){s.debug("Error while getting the os-release file.",(0,C.$0)($))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(o,s){const t=await n(o,s),a=(0,R.$0n)(t?"alpine":I.$u,v.$ec);return s.debug("ComputeTargetPlatform:",a),a}e.$Oo=i}),define(pe[119],be([1,0,20,11,12,19,53,4,180,30,36,35]),function(ue,e,D,R,r,I,P,C,v,b,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=void 0;const y=f=>(0,v.localize)(0,null,f),u=(0,v.localize)(1,null,"ms-dotnettools.csharp");function g(f,h){return h?`${f.publisher}.${f.name}@${f.version}`:`${f.publisher}.${f.name}`}let d=class{constructor(h,p,l){this.a=h,this.b=p,this.d=l}get f(){}async listExtensions(h,p,l){let m=await this.b.getInstalled(1,l);const c=S.$6l.map(i=>i.toLowerCase());if(p&&p!==""){if(c.indexOf(p.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}m=m.filter(i=>i.manifest.categories?i.manifest.categories.map(s=>s.toLowerCase()).indexOf(p.toLowerCase())>-1:!1)}else if(p===""){this.a.info("Possible Categories: "),c.forEach(i=>{this.a.info(i)});return}this.f&&this.a.info((0,v.localize)(2,null,this.f)),m=m.sort((i,o)=>i.identifier.id.localeCompare(o.identifier.id));let n;for(const i of m)n!==i.identifier.id&&(n=i.identifier.id,this.a.info(g(i.manifest,h)))}async installExtensions(h,p,l,m){const c=[];try{const n=[];h.length&&this.a.info(this.f?(0,v.localize)(3,null,this.f):(0,v.localize)(4,null));const i=[];let o=[];const s=(a,$,w)=>{o.push({id:a,version:$!=="prerelease"?$:void 0,installOptions:{...l,isBuiltin:w,installPreReleaseVersion:$==="prerelease"||l.installPreReleaseVersion}})};for(const a of h)if(a instanceof C.URI)i.push({vsix:a,installOptions:l});else{const[$,w]=(0,A.$Fo)(a);s($,w,!1)}for(const a of p)if(a instanceof C.URI)i.push({vsix:a,installOptions:{...l,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[$,w]=(0,A.$Fo)(a);s($,w,!0)}const t=await this.b.getInstalled(1,l.profileLocation);if(i.length&&await Promise.all(i.map(async({vsix:a,installOptions:$})=>{try{const w=await this.g(a,$,m,t);w&&n.push(w)}catch(w){this.a.error(w),c.push(a.toString())}})),o.length&&(o=o.filter(({id:a,version:$})=>{const w=t.find(k=>(0,A.$Do)(k.identifier,{id:a}));if(w){if(!m&&(!$||$==="prerelease"&&w.preRelease))return this.a.info((0,v.localize)(5,null,a,w.manifest.version,a)),!1;if($&&w.manifest.version===$)return this.a.info((0,v.localize)(6,null,`${a}@${$}`)),!1}return!0}),o.length)){const a=await this.h(o);await Promise.all(o.map(async $=>{const w=a.get($.id.toLowerCase());if(w)try{const k=await this.j($,w,t);k&&n.push(k)}catch(k){this.a.error(k.message||k.stack||k),c.push($.id)}else this.a.error(`${y($.version?`${$.id}@${$.version}`:$.id)}
${u}`),c.push($.id)}))}}catch(n){throw this.a.error((0,v.localize)(7,null,(0,R.$0)(n))),n}if(c.length)throw new Error((0,v.localize)(8,null,c.join(", ")))}async g(h,p,l,m){const c=await this.b.getManifest(h);if(!c)throw new Error("Invalid vsix");if(await this.l(c,l,p.profileLocation,m))try{return await this.b.install(h,p),this.a.info((0,v.localize)(9,null,(0,I.$tg)(h))),c}catch(i){if((0,R.$4)(i))return this.a.info((0,v.localize)(10,null,(0,I.$tg)(h))),null;throw i}return null}async h(h){const p=new Map,l=h.some(n=>n.installOptions.installPreReleaseVersion),m=await this.b.getTargetPlatform(),c=[];for(const n of h)b.$3n.test(n.id)&&c.push({...n,preRelease:l});if(c.length){const n=await this.d.getExtensions(c,{targetPlatform:m},D.CancellationToken.None);for(const i of n)p.set(i.identifier.id.toLowerCase(),i)}return p}async j({id:h,version:p,installOptions:l},m,c){const n=await this.d.getManifest(m,D.CancellationToken.None);if(n&&!this.k(n))return null;const i=c.find(o=>(0,A.$Do)(o.identifier,m.identifier));if(i){if(m.version===i.manifest.version)return this.a.info((0,v.localize)(11,null,p?`${h}@${p}`:h)),null;this.a.info((0,v.localize)(12,null,h,m.version))}try{l.isBuiltin?this.a.info(p?(0,v.localize)(13,null,h,p):(0,v.localize)(14,null,h)):this.a.info(p?(0,v.localize)(15,null,h,p):(0,v.localize)(16,null,h));const o=await this.b.installFromGallery(m,{...l,installGivenVersion:!!p});return this.a.info((0,v.localize)(17,null,h,o.manifest.version)),n}catch(o){if((0,R.$4)(o))return this.a.info((0,v.localize)(18,null,h)),null;throw o}}k(h){return!0}async l(h,p,l,m){if(!p){const c={id:(0,A.$Io)(h.publisher,h.name)},n=m.find(i=>(0,A.$Do)(c,i.identifier)&&(0,P.gt)(i.manifest.version,h.version));if(n)return this.a.info((0,v.localize)(19,null,n.identifier.id,n.manifest.version,h.version)),!1}return this.k(h)}async uninstallExtensions(h,p,l){const m=async n=>{if(n instanceof C.URI){const i=await this.b.getManifest(n);return g(i)}return n},c=[];for(const n of h){const i=await m(n),s=(await this.b.getInstalled(void 0,l)).filter(t=>(0,A.$Do)(t.identifier,{id:i}));if(!s.length)throw new Error(`${this.m(i)}
${u}`);if(s.some(t=>t.type===0)){this.a.info((0,v.localize)(20,null,i));return}if(!p&&s.some(t=>t.isBuiltin)){this.a.info((0,v.localize)(21,null,i));return}this.a.info((0,v.localize)(22,null,i));for(const t of s)await this.b.uninstall(t,{profileLocation:l}),c.push(t);this.f?this.a.info((0,v.localize)(23,null,i,this.f)):this.a.info((0,v.localize)(24,null,i))}}async locateExtension(h){const p=await this.b.getInstalled();h.forEach(l=>{p.forEach(m=>{if(m.identifier.id===l&&m.location.scheme===r.Schemas.file){this.a.info(m.location.fsPath);return}})})}m(h){return this.f?(0,v.localize)(25,null,h,this.f):(0,v.localize)(26,null,h)}};e.$kp=d,e.$kp=d=Oe([Ae(1,b.$do),Ae(2,b.$bo)],d)}),define(pe[241],be([1,0,5,2,26,36,35]),function(ue,e,D,R,r,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=void 0;class C extends R.$Sc{constructor(b,A,S,y,u,g,d){super(),this.f=b,this.g=A,this.h=S,this.j=y,this.m=u,this.n=g,this.r=d,this.a=this.B(new D.$Od),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new R.$1c),this.s().then(null,f=>d.error(f))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(b=>this.u(b.added))),this.B(this.j.onAddExtensions(b=>this.w(b))),this.B(this.j.onDidAddExtensions(b=>this.y(b))),this.B(this.j.onRemoveExtensions(b=>this.z(b))),this.B(this.j.onDidRemoveExtensions(b=>this.C(b))),this.B(this.n.onDidFilesChange(b=>this.D(b)))}async u(b){try{b.length&&await Promise.all(b.map(A=>(this.c.set(A.id,(0,R.$Pc)(this.n.watch(this.m.extUri.dirname(A.extensionsResource)),this.n.watch(A.extensionsResource))),this.G(A.extensionsResource))))}catch(A){throw this.r.error(A),A}}async w(b){for(const A of b.extensions)this.I(this.L(A.identifier,A.version),b.profileLocation)}async y(b){for(const A of b.extensions){const S=this.L(A.identifier,A.version);b.error?this.J(S,b.profileLocation):this.I(S,b.profileLocation)}}async z(b){for(const A of b.extensions)this.J(this.L(A.identifier,A.version),b.profileLocation)}async C(b){const A=[],S=[];for(const y of b.extensions){const u=this.L(y.identifier,y.version);b.error?this.I(u,b.profileLocation):(this.J(u,b.profileLocation),this.b.has(u)||(this.r.debug("Extension is removed from all profiles",y.identifier.id,y.version),S.push(this.f.scanInstalledExtensionAtLocation(y.location).then(g=>{g?A.push(g):this.r.info("Extension not found at the location",y.location.toString())},g=>this.r.error(g)))))}try{await Promise.all(S),A.length&&await this.H(A)}catch(y){this.r.error(y)}}D(b){for(const A of this.h.profiles)b.contains(A.extensionsResource,0,1)&&this.F(A.extensionsResource)}async F(b){const A=[],S=[],y=await this.j.scanProfileExtensions(b),u=new Set,g=new Set;for(const[d,f]of this.b)f.has(b)&&g.add(d);for(const d of y){const f=this.L(d.identifier,d.version);u.add(f),g.has(f)||(A.push(d.identifier),this.I(f,b))}for(const d of g)if(!u.has(d)){const f=this.M(d);f&&(S.push(f.identifier),this.J(d,b))}(A.length||S.length)&&this.a.fire({added:A.length?{extensions:A,profileLocation:b}:void 0,removed:S.length?{extensions:S,profileLocation:b}:void 0})}async G(b){const A=await this.j.scanProfileExtensions(b);for(const S of A)this.I(this.L(S.identifier,S.version),b)}async H(b){b||(b=(await this.f.scanAllUserInstalledExtensions()).filter(S=>!this.b.has(this.L(S.identifier,S.manifest.version)))),b.length&&await this.f.markAsUninstalled(...b)}I(b,A){let S=this.b.get(b);S||this.b.set(b,S=new r.$Bc(y=>this.m.extUri.getComparisonKey(y))),S.add(A)}J(b,A){const S=this.b.get(b);S&&S.delete(A),S?.size||this.b.delete(b)}L(b,A){return`${P.$7l.toKey(b.id)}@${A}`}M(b){const[A,S]=(0,I.$Fo)(b);return S?{identifier:{id:A},version:S}:void 0}}e.$Lp=C}),define(pe[242],be([1,0,213,38]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=void 0;async function r(I,P,C,v,b,A,S){const y={"X-Market-Client-Id":`VSCode ${I}`,"User-Agent":`VSCode ${I} (${P.nameShort})`};if((0,R.$vo)(P,C)&&(0,R.$xo)(v)===3){const u=await(0,D.$dp)(C,b,A);y["X-Market-User-Id"]=u,y["VSCode-SessionId"]=S.machineId||u}return y}e.$ep=r}),define(pe[120],be([1,0,87,18,14,2,12,7,21,25,30,36,13,84,4]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;let d=class extends u.$Xq{constructor(l,m,c,n){super(c),this.h=l,this.j=n,this.g=this.B(new f(m,n)),this.h.registerParticipant({postInstall:async i=>this.m(i),postUninstall:async i=>this.n(i)})}async getBuiltInExtensionTranslationsUri(l,m){const n=(await this.g.getLanguagePacks())[m];if(!n){this.j.warn(`No language pack found for ${m}`);return}const i=n.translations[l];return i?g.URI.file(i):void 0}async getInstalledLanguages(){const l=await this.g.getLanguagePacks(),m=Object.keys(l).map(c=>{const n=l[c];return{...this.f(c,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return m.push(this.f("en","English")),m.sort((c,n)=>c.label.localeCompare(n.label)),m}async m(l){l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",l.identifier.id),await this.update())}async n(l){const m=await this.g.getLanguagePacks();Object.keys(m).some(c=>m[c]&&m[c].extensions.some(n=>(0,S.$Do)(n.extensionIdentifier,l.identifier)))&&(this.j.info("Removing language packs from the extension",l.identifier.id),await this.update())}async update(){const[l,m]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),c=await this.g.update(m);return!(0,R.$ub)(Object.keys(l),Object.keys(c))}};e.$Yq=d,e.$Yq=d=Oe([Ae(0,A.$do),Ae(1,b.$Yh),Ae(2,A.$bo),Ae(3,y.$$i)],d);let f=class extends I.$Sc{constructor(l,m){super(),this.j=m,this.c={},this.f=(0,C.$jc)(l.userDataPath,"languagepacks.json"),this.g=new r.$2g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(l){return this.s(m=>{Object.keys(m).forEach(c=>delete m[c]),this.m(m,...l)}).then(()=>this.c)}m(l,...m){for(const c of m)c&&c.manifest&&c.manifest.contributes&&c.manifest.contributes.localizations&&c.manifest.contributes.localizations.length&&this.n(l,c);Object.keys(l).forEach(c=>this.r(l[c]))}n(l,m){const c=m.identifier,n=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const i of n)if(m.location.scheme===P.Schemas.file&&h(i)){let o=l[i.languageId];o||(o={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},l[i.languageId]=o);const s=o.extensions.filter(t=>(0,S.$Do)(t.extensionIdentifier,c))[0];s?s.version=m.manifest.version:o.extensions.push({extensionIdentifier:c,version:m.manifest.version});for(const t of i.translations)o.translations[t.id]=(0,C.$jc)(m.location.fsPath,t.path)}}r(l){if(l){const m=(0,D.createHash)("md5");for(const c of l.extensions)m.update(c.extensionIdentifier.uuid||c.extensionIdentifier.id).update(c.version);l.hash=m.digest("hex")}}s(l=()=>null){return this.g.queue(()=>{let m=null;return v.Promises.readFile(this.f,"utf8").then(void 0,c=>c.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(c)).then(c=>{try{return JSON.parse(c)}catch{return{}}}).then(c=>(m=l(c),c)).then(c=>{for(const i of Object.keys(c))c[i]||delete c[i];this.c=c,this.h=!0;const n=JSON.stringify(this.c);return this.j.debug("Writing language packs",n),v.Promises.writeFile(this.f,n)}).then(()=>m,c=>this.j.error(c))})}};f=Oe([Ae(0,b.$Yh),Ae(1,y.$$i)],f);function h(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const l of p.translations)if(typeof l.id!="string"||typeof l.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(pe[243],be([1,0,165,11,22,38]),function(ue,e,D,R,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AN=void 0;const P="https://mobile.events.data.microsoft.com/OneCollector/1.0",C="https://mobile.events.data.microsoft.com/ping";async function v(A,S,y){const u=await(0,D.$zC)("@microsoft/1ds-core-js","dist/ms.core.js"),g=await(0,D.$zC)("@microsoft/1ds-post-js","dist/ms.post.js"),d=new u.AppInsightsCore,f=new g.PostChannel,h={instrumentationKey:A,endpointUrl:P,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[f]]};if(y){h.extensionConfig={};const p={alwaysUseXhrOverride:!0,httpXHROverride:y};h.extensionConfig[f.identifier]=p}return d.initialize(h,[]),d.addTelemetryInitializer(p=>{S&&(p.ext=p.ext??{},p.ext.utc=p.ext.utc??{},p.ext.utc.flags=8462029)}),d}class b{constructor(S,y,u,g,d){this.e=S,this.f=y,this.g=u,this.h=d,this.c=P,this.d=C,this.g||(this.g={}),typeof g=="function"?this.a=g():this.a=g,this.b=null}i(S){if(this.a){if(typeof this.a!="string"){S(this.a);return}this.b||(this.b=v(this.a,this.e,this.h)),this.b.then(y=>{S(y)},y=>{(0,R.$1)(y),console.error(y)})}}log(S,y){if(!this.a)return;y=(0,r.$$m)(y,this.g),y=(0,I.$yo)(y);const u=this.f+"/"+S;try{this.i(g=>{g.pluginVersionString=y?.properties.version??"Unknown",g.track({name:u,baseData:{name:u,properties:y?.properties,measurements:y?.measurements}})})}catch{}}flush(){return this.a?new Promise(S=>{this.i(y=>{y.unload(!0,()=>{this.a=void 0,S(void 0)})})}):Promise.resolve(void 0)}}e.$AN=b}),define(pe[244],be([1,0,2,22,3,17,194,24,56,55,31,37,32,38]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=void 0;let g=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,p,l){this.k=p,this.l=l,this.d={},this.i=new D.$Rc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const m of this.f)this.j.push(new RegExp((0,I.$Ge)(m),"gi")),m.indexOf("\\")>=0&&this.j.push(new RegExp((0,I.$Ge)(m.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(m=>{(m.affectsConfiguration(y.$ll)||m.affectsConfiguration(y.$nl)||m.affectsConfiguration(y.$ml))&&this.m()}))}setExperimentProperty(h,p){this.d[h]=p}m(){let h=(0,u.$xo)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const l=p.usage?3:p.error?2:0;h=Math.min(h,l)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,p,l){this.g<p||(l=(0,R.$$m)(l,this.d),l=(0,u.$Co)(l,this.j),l=(0,R.$$m)(l,this.c),this.b.forEach(m=>m.log(h,l)))}publicLog(h,p){this.n(h,3,p)}publicLog2(h,p){this.publicLog(h,p)}publicLogError(h,p){this.h&&this.n(h,2,p)}publicLogError2(h,p){this.publicLogError(h,p)}};e.$5q=g,e.$5q=g=Oe([Ae(1,C.$ki),Ae(2,A.$qj)],g);function d(){const f=(0,P.localize)(0,null,b.default.nameLong),h=b.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=r.$p?"":(0,P.localize)(3,null),l=(0,P.localize)(4,null),m=(0,P.localize)(5,null),c=(0,P.localize)(6,null),n=(0,P.localize)(7,null),i=`
|       | ${l} | ${m} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,P.localize)(8,null);return`
${f} ${h} ${p}

&nbsp;

${n}
${i}

&nbsp;

${o}
`}S.$kn.as(v.$pn.Configuration).registerConfiguration({id:y.$kl,order:1,type:"object",title:(0,P.localize)(9,null),properties:{[y.$ll]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:d(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.$kn.as(v.$pn.Configuration).registerConfiguration({id:y.$kl,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[y.$nl]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,P.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,P.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${y.$ll}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(pe[245],be([1,0,24,6,31,32,244,38]),function(ue,e,D,R,r,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=e.$Qr=e.$Pr=void 0;let v=class extends P.$5q{constructor(A,S,y,u){super(A,y,u),this.o=S}publicLog(A,S){if(!(this.o<3))return super.publicLog(A,S)}publicLog2(A,S){return this.publicLog(A,S)}publicLogError(A,S){return this.o<2?Promise.resolve(void 0):super.publicLogError(A,S)}publicLogError2(A,S){return this.publicLogError(A,S)}async updateInjectedTelemetryLevel(A){if(A===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,A):A,this.o===0&&this.dispose()}};e.$Pr=v,e.$Pr=v=Oe([Ae(2,D.$ki),Ae(3,r.$qj)],v),e.$Qr=new class extends C.$oo{async updateInjectedTelemetryLevel(){}},e.$Rr=(0,R.$Rh)(I.$dl)}),define(pe[246],be([1,0,15,20,300,243]),function(ue,e,D,R,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BN=void 0;async function P(A,S){const y=await S.request(A,R.CancellationToken.None),u=(await(0,D.$oe)(y.stream)).toString(),g=y.res.statusCode??200;return{headers:y.res.headers,statusCode:g,responseData:u}}async function C(A){const S={method:A.type,headers:A.headers};return new Promise((u,g)=>{const d=r.request(A.url??"",S,f=>{f.on("data",function(h){u({headers:f.headers,statusCode:f.statusCode??200,responseData:h.toString()})}),f.on("error",function(h){g(h)})});d.write(A.data,f=>{f&&g(f)}),d.end()})}async function v(A,S,y){const u=typeof S.data=="string"?S.data:new TextDecoder().decode(S.data),g={type:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data).toString()},url:S.urlString,data:u};try{const d=A?await P(g,A):await C(g);y(d.statusCode,d.headers,d.responseData)}catch{y(0,{})}}class b extends I.$AN{constructor(S,y,u,g,d){const f={sendPOST:(h,p)=>{v(S,h,p)}};super(y,u,g,d,f)}}e.$BN=b}),define(pe[247],be([1,0,11,238]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class r extends R.default{i(){(0,D.setUnexpectedErrorHandler)(C=>console.error(C));const P=[];process.on("unhandledRejection",(C,v)=>{P.push(v),setTimeout(()=>{const b=P.indexOf(v);b>=0&&v.catch(A=>{P.splice(b,1),(0,D.$4)(A)||(console.warn(`rejected promise not handled within 1 second: ${A}`),A.stack&&console.warn(`stack trace: ${A.stack}`),C&&(0,D.$1)(C))})},1e3)}),process.on("rejectionHandled",C=>{const v=P.indexOf(C);v>=0&&P.splice(v,1)}),process.on("uncaughtException",C=>{(0,D.$Z)(C)||(0,D.$1)(C)})}}e.default=r}),define(pe[121],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var D;(function(R){R[R.Replace=1]="Replace",R[R.Append=2]="Append",R[R.Prepend=3]="Prepend"})(D||(e.EnvironmentVariableMutatorType=D={}))}),define(pe[122],be([1,0,3,121]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=void 0;const r=new Map([[R.EnvironmentVariableMutatorType.Append,"APPEND"],[R.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[R.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class I{constructor(A){this.collections=A,this.a=new Map,this.b=new Map,A.forEach((S,y)=>{this.d(S,y);const u=S.map.entries();let g=u.next();for(;!g.done;){const d=g.value[1],f=g.value[0];let h=this.a.get(f);if(h||(h=[],this.a.set(f,h)),h.length>0&&h[0].type===R.EnvironmentVariableMutatorType.Replace){g=u.next();continue}const p={extensionIdentifier:y,value:d.value,type:d.type,scope:d.scope,variable:d.variable,options:d.options};p.scope||delete p.scope,h.unshift(p),g=u.next()}})}async applyToProcessEnvironment(A,S,y){let u;D.$j&&(u={},Object.keys(A).forEach(g=>u[g.toLowerCase()]=g));for(const[g,d]of this.getVariableMap(S)){const f=D.$j&&u[g.toLowerCase()]||g;for(const h of d){const p=y?await y(h.value):h.value;if(h.options?.applyAtProcessCreation??!0)switch(h.type){case R.EnvironmentVariableMutatorType.Append:A[f]=(A[f]||"")+p;break;case R.EnvironmentVariableMutatorType.Prepend:A[f]=p+(A[f]||"");break;case R.EnvironmentVariableMutatorType.Replace:A[f]=p;break}if(h.options?.applyAtShellIntegration??!1){const l=`VSCODE_ENV_${r.get(h.type)}`;A[l]=(A[l]?A[l]+":":"")+g+"="+this.c(p)}}}}c(A){return A.replaceAll(":","\\x3a")}diff(A,S){const y=new Map,u=new Map,g=new Map;if(A.getVariableMap(S).forEach((d,f)=>{const h=this.getVariableMap(S).get(f),p=C(d,h);p&&y.set(f,p)}),this.getVariableMap(S).forEach((d,f)=>{const h=A.getVariableMap(S).get(f),p=C(d,h);p&&g.set(f,p)}),this.getVariableMap(S).forEach((d,f)=>{const h=A.getVariableMap(S).get(f),p=v(d,h);p&&u.set(f,p)}),!(y.size===0&&u.size===0&&g.size===0))return{added:y,changed:u,removed:g}}getVariableMap(A){const S=new Map;for(const y of this.a.values()){const u=y.filter(g=>P(g,A));u.length>0&&S.set(u[0].variable,u)}return S}getDescriptionMap(A){const S=new Map;for(const y of this.b.values()){const u=y.filter(g=>P(g,A,!0));for(const g of u)S.set(g.extensionIdentifier,g.description)}return S}d(A,S){if(!A.descriptionMap)return;const y=A.descriptionMap.entries();let u=y.next();for(;!u.done;){const g=u.value[1],d=u.value[0];let f=this.b.get(d);f||(f=[],this.b.set(d,f));const h={extensionIdentifier:S,scope:g.scope,description:g.description};h.scope||delete h.scope,f.push(h),u=y.next()}}}e.$ur=I;function P(b,A,S=!1){return b.scope?!!(b.scope.workspaceFolder&&A?.workspaceFolder&&b.scope.workspaceFolder.index===A.workspaceFolder.index):S?A===b.scope:!0}function C(b,A){if(!A)return b;const S=new Set;A.forEach(u=>S.add(u.extensionIdentifier));const y=[];return b.forEach(u=>{S.has(u.extensionIdentifier)||y.push(u)}),y.length===0?void 0:y}function v(b,A){if(!A)return;const S=new Map;A.forEach(u=>S.set(u.extensionIdentifier,u));const y=[];return b.forEach(u=>{const g=S.get(u.extensionIdentifier);g&&(u.type!==g.type||u.value!==g.value||u.scope?.workspaceFolder?.index!==g.scope?.workspaceFolder?.index)&&y.push(g)}),y.length===0?void 0:y}}),define(pe[88],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=e.$rr=e.$qr=e.$pr=e.$or=void 0;function D(v){return[...v.entries()]}e.$or=D;function R(v){return v?[...v.entries()]:[]}e.$pr=R;function r(v){return new Map(v)}e.$qr=r;function I(v){return new Map(v??[])}e.$rr=I;function P(v){return Array.from(v.entries()).map(b=>[b[0],D(b[1].map),R(b[1].descriptionMap)])}e.$sr=P;function C(v){return new Map(v.map(b=>[b[0],{map:r(b[1]),descriptionMap:I(b[2])}]))}e.$tr=C}),define(pe[248],be([1,0,14,20,5,2,13]),function(ue,e,D,R,r,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0;let C=class extends I.$Sc{constructor(b,A){super(),this.h=A,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new r.$Od),this.onCreateRequest=this.g.event,this.b=b===void 0?15e3:b,this.B((0,I.$Qc)(()=>{for(const S of this.f.values())(0,I.$Nc)(S)}))}createRequest(b){return new Promise((A,S)=>{const y=++this.a;this.c.set(y,A),this.g.fire({requestId:y,...b});const u=new R.$Yd;(0,D.$Vg)(this.b,u.token).then(()=>S(`Request ${y} timed out (${this.b}ms)`)),this.f.set(y,[(0,I.$Qc)(()=>u.cancel())])})}acceptReply(b,A){const S=this.c.get(b);S?(this.c.delete(b),(0,I.$Nc)(this.f.get(b)||[]),this.f.delete(b),S(A)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};e.$fr=C,e.$fr=C=Oe([Ae(1,P.$$i)],C)}),define(pe[89],be([1,0,6,67,37]),function(ue,e,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=e.$_q=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$$q=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$0q=void 0,e.$0q=new R.$8i("terminalTabFocusMode",!1,!0);var I;(function(c){c.AutomationProfile="terminal.integrated.automationProfile.",c.DefaultProfile="terminal.integrated.defaultProfile.",c.Profiles="terminal.integrated.profiles."})(I||(e.TerminalSettingPrefix=I={}));var P;(function(c){c.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",c.AutomationProfileLinux="terminal.integrated.automationProfile.linux",c.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",c.AutomationProfileWindows="terminal.integrated.automationProfile.windows",c.ProfilesWindows="terminal.integrated.profiles.windows",c.ProfilesMacOs="terminal.integrated.profiles.osx",c.ProfilesLinux="terminal.integrated.profiles.linux",c.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",c.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",c.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",c.UseWslProfiles="terminal.integrated.useWslProfiles",c.TabsDefaultColor="terminal.integrated.tabs.defaultColor",c.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",c.TabsEnabled="terminal.integrated.tabs.enabled",c.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",c.TabsHideCondition="terminal.integrated.tabs.hideCondition",c.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",c.TabsShowActions="terminal.integrated.tabs.showActions",c.TabsLocation="terminal.integrated.tabs.location",c.TabsFocusMode="terminal.integrated.tabs.focusMode",c.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",c.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",c.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",c.CopyOnSelection="terminal.integrated.copyOnSelection",c.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",c.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",c.FontFamily="terminal.integrated.fontFamily",c.FontSize="terminal.integrated.fontSize",c.LetterSpacing="terminal.integrated.letterSpacing",c.LineHeight="terminal.integrated.lineHeight",c.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",c.TabStopWidth="terminal.integrated.tabStopWidth",c.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",c.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",c.BellDuration="terminal.integrated.bellDuration",c.FontWeight="terminal.integrated.fontWeight",c.FontWeightBold="terminal.integrated.fontWeightBold",c.CursorBlinking="terminal.integrated.cursorBlinking",c.CursorStyle="terminal.integrated.cursorStyle",c.CursorStyleInactive="terminal.integrated.cursorStyleInactive",c.CursorWidth="terminal.integrated.cursorWidth",c.Scrollback="terminal.integrated.scrollback",c.DetectLocale="terminal.integrated.detectLocale",c.DefaultLocation="terminal.integrated.defaultLocation",c.GpuAcceleration="terminal.integrated.gpuAcceleration",c.TerminalTitleSeparator="terminal.integrated.tabs.separator",c.TerminalTitle="terminal.integrated.tabs.title",c.TerminalDescription="terminal.integrated.tabs.description",c.RightClickBehavior="terminal.integrated.rightClickBehavior",c.Cwd="terminal.integrated.cwd",c.ConfirmOnExit="terminal.integrated.confirmOnExit",c.ConfirmOnKill="terminal.integrated.confirmOnKill",c.EnableBell="terminal.integrated.enableBell",c.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",c.AllowChords="terminal.integrated.allowChords",c.AllowMnemonics="terminal.integrated.allowMnemonics",c.TabFocusMode="terminal.integrated.tabFocusMode",c.EnvMacOs="terminal.integrated.env.osx",c.EnvLinux="terminal.integrated.env.linux",c.EnvWindows="terminal.integrated.env.windows",c.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",c.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",c.ShowExitAlert="terminal.integrated.showExitAlert",c.SplitCwd="terminal.integrated.splitCwd",c.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",c.WordSeparators="terminal.integrated.wordSeparators",c.EnableFileLinks="terminal.integrated.enableFileLinks",c.UnicodeVersion="terminal.integrated.unicodeVersion",c.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",c.LocalEchoEnabled="terminal.integrated.localEchoEnabled",c.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",c.LocalEchoStyle="terminal.integrated.localEchoStyle",c.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",c.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",c.HideOnStartup="terminal.integrated.hideOnStartup",c.CustomGlyphs="terminal.integrated.customGlyphs",c.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",c.InheritEnv="terminal.integrated.inheritEnv",c.ShowLinkHover="terminal.integrated.showLinkHover",c.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",c.AutoReplies="terminal.integrated.autoReplies",c.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",c.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",c.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",c.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",c.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",c.EnableImages="terminal.integrated.enableImages",c.SmoothScrolling="terminal.integrated.smoothScrolling",c.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",c.FocusAfterRun="terminal.integrated.focusAfterRun",c.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",c.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",c.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",c.DevMode="terminal.integrated.developer.devMode"})(P||(e.TerminalSettingId=P={}));var C;(function(c){c.PowerShell="pwsh",c.Bash="bash",c.Fish="fish",c.Sh="sh",c.Csh="csh",c.Ksh="ksh",c.Zsh="zsh"})(C||(e.PosixShellType=C={}));var v;(function(c){c.CommandPrompt="cmd",c.PowerShell="pwsh",c.Wsl="wsl",c.GitBash="gitbash"})(v||(e.WindowsShellType=v={}));var b;(function(c){c[c.Api=0]="Api",c[c.Process=1]="Process",c[c.Sequence=2]="Sequence",c[c.Config=3]="Config"})(b||(e.TitleEventSource=b={}));var A;(function(c){c.LocalPty="localPty",c.PtyHost="ptyHost",c.PtyHostWindow="ptyHostWindow",c.Logger="logger",c.Heartbeat="heartbeat"})(A||(e.TerminalIpcChannels=A={}));var S;(function(c){c.Cwd="cwd",c.InitialCwd="initialCwd",c.FixedDimensions="fixedDimensions",c.Title="title",c.ShellType="shellType",c.HasChildProcesses="hasChildProcesses",c.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",c.OverrideDimensions="overrideDimensions",c.FailedShellIntegrationActivation="failedShellIntegrationActivation",c.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(S||(e.ProcessPropertyType=S={})),e.$$q=(0,D.$Qh)("ptyService");var y;(function(c){c[c.BeatInterval=5e3]="BeatInterval",c[c.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",c[c.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",c[c.SecondWaitMultiplier=1]="SecondWaitMultiplier",c[c.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(y||(e.HeartbeatConstants=y={}));var u;(function(c){c[c.Panel=1]="Panel",c[c.Editor=2]="Editor"})(u||(e.TerminalLocation=u={}));var g;(function(c){c.TerminalView="view",c.Editor="editor"})(g||(e.TerminalLocationString=g={}));var d;(function(c){c[c.GraceTime=6e4]="GraceTime",c[c.ShortGraceTime=6e3]="ShortGraceTime"})(d||(e.LocalReconnectConstants=d={}));var f;(function(c){c[c.HighWatermarkChars=1e5]="HighWatermarkChars",c[c.LowWatermarkChars=5e3]="LowWatermarkChars",c[c.CharCountAckSize=5e3]="CharCountAckSize"})(f||(e.FlowControlConstants=f={}));var h;(function(c){c.GitBash="Git Bash",c.Pwsh="PowerShell"})(h||(e.ProfileSource=h={}));var p;(function(c){c[c.Off=0]="Off",c[c.FinalTerm=1]="FinalTerm",c[c.VSCode=2]="VSCode"})(p||(e.ShellIntegrationStatus=p={}));var l;(function(c){c[c.Unknown=0]="Unknown",c[c.Shutdown=1]="Shutdown",c[c.Process=2]="Process",c[c.User=3]="User",c[c.Extension=4]="Extension"})(l||(e.TerminalExitReason=l={})),e.$_q={Backend:"workbench.contributions.terminal.processBackend"};class m{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(n){const i=this.b(n.remoteAuthority);if(this.a.has(i))throw new Error(`A terminal backend with remote authority '${i}' was already registered.`);this.a.set(i,n)}getTerminalBackend(n){return this.a.get(this.b(n))}b(n){return n?.toLowerCase()??""}}r.$kn.add(e.$_q.Backend,new m),e.$ar=(0,D.$Qh)("localPtyService"),e.$br=(0,D.$Qh)("terminalLogService")}),define(pe[249],be([1,0,3]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=e.$fN=e.$eN=void 0;function R(P){let C=P;C.includes("\\")&&(C=C.replace(/\\/g,"\\\\"));const v=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return C=C.replace(v,""),`'${C}'`}e.$eN=R;function r(P,C,v){if(!P)return"";if(!C)return P;C.match(/[\/\\]$/)&&(C=C.slice(0,C.length-1));const b=P.replace(/\\/g,"/").toLowerCase(),A=C.replace(/\\/g,"/").toLowerCase();return b.includes(A)?`~${v}${P.slice(C.length+1)}`:P}e.$fN=r;function I(P){return P.match(/^['"].*['"]$/)&&(P=P.substring(1,P.length-1)),D.OS===1&&P&&P[1]===":"?P[0].toUpperCase()+P.substring(1):P}e.$gN=I}),define(pe[250],be([1,0,49,4,196,98]),function(ue,e,D,R,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=e.$hr=e.$gr=void 0;function P(y,u){const g=[{name:null,description:(0,r.localize)(0,null)}];return g.push(...y.map(d=>({name:d.profileName,description:C(d)}))),u&&g.push(...u.map(d=>({name:d.title,description:v(d)}))),{values:g.map(d=>d.name),markdownDescriptions:g.map(d=>d.description)}}e.$gr=P;function C(y){let u=`$(${I.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:D.$Vj.terminal.id}) ${y.profileName}
- path: ${y.path}`;return y.args&&(typeof y.args=="string"?u+=`
- args: "${y.args}"`:u+=`
- args: [${y.args.length===0?"":`'${y.args.join("','")}'`}]`),y.overrideName!==void 0&&(u+=`
- overrideName: ${y.overrideName}`),y.color&&(u+=`
- color: ${y.color}`),y.env&&(u+=`
- env: ${JSON.stringify(y.env)}`),u}function v(y){return`$(${I.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:D.$Vj.terminal.id}) ${y.title}
- extensionIdentifier: ${y.extensionIdentifier}`}function b(y,u){if(!y&&!u)return!0;if(typeof y=="string"&&typeof u=="string")return y===u;if(Array.isArray(y)&&Array.isArray(u)){if(y.length!==u.length)return!1;for(let g=0;g<y.length;g++)if(y[g]!==u[g])return!1;return!0}return!1}e.$hr=b;function A(y,u){if(!y&&!u)return!0;if(!y||!u)return!1;if(I.ThemeIcon.isThemeIcon(y)&&I.ThemeIcon.isThemeIcon(u))return y.id===u.id&&y.color===u.color;if(typeof y=="object"&&"light"in y&&"dark"in y&&typeof u=="object"&&"light"in u&&"dark"in u){const g=y,d=u;if((R.URI.isUri(g.light)||S(g.light))&&(R.URI.isUri(g.dark)||S(g.dark))&&(R.URI.isUri(d.light)||S(d.light))&&(R.URI.isUri(d.dark)||S(d.dark)))return g.light.path===d.light.path&&g.dark.path===d.dark.path}if(R.URI.isUri(y)&&R.URI.isUri(u)||S(y)||S(u)){const g=y,d=u;return g.path===d.path&&g.scheme===d.scheme}return!1}e.$ir=A;function S(y){return y?typeof y.path=="string"&&typeof y.scheme=="string":!1}e.$jr=S}),define(pe[251],be([1,0,49,3,195,56,37,250]),function(ue,e,D,R,r,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=e.$lr=e.$kr=void 0,e.$kr={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$lr={type:"string",enum:Array.from((0,D.$Uj)(),f=>f.id),markdownEnumDescriptions:Array.from((0,D.$Uj)(),f=>`$(${f.id})`)};const v={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.$lr},color:{description:(0,r.localize)(3,null),...e.$kr},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},b={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...v}},A={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...v}};function S(f){const h=f===2?"linux":f===1?"osx":"windows";return(0,r.localize)(7,null,(0,R.$i)(f),'```json\n"terminal.integrated.profile.'+h+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const y={id:"terminal",order:100,title:(0,r.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},A],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},A],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},A],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:S(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(12,null),enum:["PowerShell","Git Bash"]},...v}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(13,null),type:"string"},id:{description:(0,r.localize)(14,null),type:"string"},title:{description:(0,r.localize)(15,null),type:"string"},...v}},{type:"null"},b]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:S(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(16,null),type:"string"},id:{description:(0,r.localize)(17,null),type:"string"},title:{description:(0,r.localize)(18,null),type:"string"},...v}},{type:"null"},b]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:S(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(19,null),type:"string"},id:{description:(0,r.localize)(20,null),type:"string"},title:{description:(0,r.localize)(21,null),type:"string"},...v}},{type:"null"},b]}},["terminal.integrated.useWslProfiles"]:{description:(0,r.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,r.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,r.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,r.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,r.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){P.$kn.as(I.$pn.Configuration).registerConfiguration(y),d()}e.$mr=u;let g;function d(f,h){const p=P.$kn.as(I.$pn.Configuration);let l;f&&(l=(0,C.$gr)(f?.profiles,h));const m=g;g={id:"terminal",order:100,title:(0,r.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(28,null),type:["string","null"],default:null,enum:f?.os===3?l?.values:void 0,markdownEnumDescriptions:f?.os===3?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(29,null),type:["string","null"],default:null,enum:f?.os===2?l?.values:void 0,markdownEnumDescriptions:f?.os===2?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(30,null),type:["string","null"],default:null,enum:f?.os===1?l?.values:void 0,markdownEnumDescriptions:f?.os===1?l?.markdownDescriptions:void 0}}},p.updateConfigurations({add:[g],remove:m?[m]:[]})}e.$nr=d}),define(pe[252],be([1,0,2,12,107,25,108]),function(ue,e,D,R,r,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VN=void 0;let C=class extends D.$Sc{constructor(b,A){super(),this.a=b,this.b=A}start(){const b={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.with({scheme:R.Schemas.file}).fsPath],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},A=(0,P.$lm)(this.b.args,this.b.isBuilt);A&&(A.break&&A.port?b.debugBrk=A.port:!A.break&&A.port&&(b.debug=A.port));const S=new r.$7p(R.$dg.asFileUri("bootstrap-fork").fsPath,b),y=new D.$Rc;return y.add(S),{client:S,store:y,onDidProcessExit:S.onDidProcessExit}}};e.$VN=C,e.$VN=C=Oe([Ae(1,I.$Xh)],C)}),define(pe[253],be([1,0,28,12,22,7,3,29,17,10,21,121,88,122]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=e.$wr=e.$vr=void 0;function g(){const s=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let t=0;return s&&s.length===4&&(t=parseInt(s[3])),t}e.$vr=g;async function d(s,t,a,$=C.env,w=A.Promises.exists){if(I.$ic(s))return await w(s)?s:void 0;if(t===void 0&&(t=C.cwd()),I.$mc(s)!=="."){const j=I.$jc(t,s);return await w(j)?j:void 0}const E=(0,r.$cn)($,"PATH");if(a===void 0&&(0,b.$zf)(E)&&(a=E.split(I.$tc)),a===void 0||a.length===0){const j=I.$jc(t,s);return await w(j)?j:void 0}for(const j of a){let x;if(I.$ic(j)?x=I.$jc(j,s):x=I.$jc(t,j,s),await w(x))return x;if(P.$j){let ce=x+".com";if(await w(ce)||(ce=x+".exe",await w(ce)))return ce}}const L=I.$jc(t,s);return await w(L)?L:void 0}e.$wr=d;function f(s,t,a,$,w){const k=P.$j&&(!t.windowsEnableConpty||g()<18309);if(!t.shellIntegration.enabled||!s.executable||s.isFeatureTerminal||s.hideFromUser||s.ignoreShellIntegration||k)return;const E=s.args,L=C.$dc==="win32"?I.$nc(s.executable).toLowerCase():I.$nc(s.executable),j=I.$mc(R.$dg.asFileUri("").fsPath);let x;const ce={VSCODE_INJECTION:"1"};if(t.shellIntegration.nonce&&(ce.VSCODE_NONCE=t.shellIntegration.nonce),P.$j){if(L==="pwsh.exe"||L==="powershell.exe")return!E||i(E)?x=l.get(p.WindowsPwsh):n(E)&&(x=l.get(p.WindowsPwshLogin)),x?(x=[...x],x[x.length-1]=(0,v.$De)(x[x.length-1],j,""),{newArgs:x,envMixin:ce}):void 0;$.warn(`Shell integration cannot be enabled for executable "${s.executable}" and args`,s.args);return}switch(L){case"bash":return!E||E.length===0?x=l.get(p.Bash):o(E)&&(ce.VSCODE_SHELL_LOGIN="1",h(t,ce),x=l.get(p.Bash)),x?(x=[...x],x[x.length-1]=(0,v.$De)(x[x.length-1],j),{newArgs:x,envMixin:ce}):void 0;case"fish":{const X=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ie=I.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return ce.XDG_DATA_DIRS=`${X}:${ie}`,h(t,ce),{newArgs:void 0,envMixin:ce}}case"pwsh":return!E||i(E)?x=l.get(p.Pwsh):n(E)&&(x=l.get(p.PwshLogin)),x?(x=[...x],x[x.length-1]=(0,v.$De)(x[x.length-1],j,""),{newArgs:x,envMixin:ce}):void 0;case"zsh":{if(!E||E.length===0?x=l.get(p.Zsh):o(E)?(x=l.get(p.ZshLogin),h(t,ce)):(E===l.get(p.Zsh)||E===l.get(p.ZshLogin))&&(x=E),!x)return;x=[...x],x[x.length-1]=(0,v.$De)(x[x.length-1],j);let X;try{X=D.userInfo().username}catch{X="unknown"}const ie=I.$jc(D.tmpdir(),`${X}-${w.applicationName}-zsh`);ce.ZDOTDIR=ie;const he=a?.ZDOTDIR??D.homedir()??"~";ce.USER_ZDOTDIR=he;const _=[];return _.push({source:I.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:I.$jc(ie,".zshrc")}),_.push({source:I.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:I.$jc(ie,".zprofile")}),_.push({source:I.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:I.$jc(ie,".zshenv")}),_.push({source:I.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:I.$jc(ie,".zlogin")}),{newArgs:x,envMixin:ce,filesToCopy:_}}}$.warn(`Shell integration cannot be enabled for executable "${s.executable}" and args`,s.args)}e.$xr=f;function h(s,t){if(P.$k&&s.environmentVariableCollections){const a=(0,y.$tr)(s.environmentVariableCollections),w=new u.$ur(a).getVariableMap({workspaceFolder:s.workspaceFolder}).get("PATH"),k=[];if(w)for(const E of w)E.type===S.EnvironmentVariableMutatorType.Prepend&&k.push(E.value);k.length>0&&(t.VSCODE_PATH_PREFIX=k.join(""))}}var p;(function(s){s.WindowsPwsh="windows-pwsh",s.WindowsPwshLogin="windows-pwsh-login",s.Pwsh="pwsh",s.PwshLogin="pwsh-login",s.Zsh="zsh",s.ZshLogin="zsh-login",s.Bash="bash"})(p||(p={}));const l=new Map;l.set(p.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(p.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(p.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),l.set(p.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),l.set(p.Zsh,["-i"]),l.set(p.ZshLogin,["-il"]),l.set(p.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const m=["-login","-l"],c=["-nol","-nologo"];function n(s){return typeof s=="string"?m.includes(s.toLowerCase()):s.length===1&&m.includes(s[0].toLowerCase())||s.length===2&&(m.includes(s[0].toLowerCase())||m.includes(s[1].toLowerCase()))&&(c.includes(s[0].toLowerCase())||c.includes(s[1].toLowerCase()))}function i(s){return typeof s=="string"?c.includes(s.toLowerCase()):s.length===0||s?.length===1&&c.includes(s[0].toLowerCase())}function o(s){return s==="string"&&m.includes(s.toLowerCase())||typeof s!="string"&&s.length===1&&m.includes(s[0].toLowerCase())}}),define(pe[254],be([1,0,52,49,7,3,10,21,102,253,77]),function(ue,e,D,R,r,I,P,C,v,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=void 0;let S,y=!0;function u(t,a,$,w,k=process.env,E,L,j,x){return E=E||{existsFile:C.SymlinkSupport.existsFile,readFile:C.Promises.readFile},I.$j?g($,E,k,L,w.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:w.getValue("terminal.integrated.profiles.windows"),typeof a=="string"?a:w.getValue("terminal.integrated.defaultProfile.windows"),x,j):i(E,L,$,t&&typeof t=="object"?{...t}:w.getValue(I.$l?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof a=="string"?a:w.getValue(I.$l?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),x,j,k)}e.$yr=u;async function g(t,a,$,w,k,E,L,j,x){const ce=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),X=`${process.env.windir}\\${ce?"Sysnative":"System32"}`;let ie=!1;(0,b.$vr)()>=16299&&(ie=!0),await p(j);const he=new Map;if(t){he.set("PowerShell",{source:"PowerShell",icon:R.$Vj.terminalPowershell,isAutoDetected:!0}),he.set("Windows PowerShell",{path:`${X}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.$Vj.terminalPowershell,isAutoDetected:!0}),he.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),he.set("Command Prompt",{path:`${X}\\cmd.exe`,icon:R.$Vj.terminalCmd,isAutoDetected:!0}),he.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),he.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:R.$Vj.terminalBash,isAutoDetected:!0});const de=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;he.set("Cmder",{path:`${X}\\cmd.exe`,args:["/K",de],requiresPath:process.env.CMDER_ROOT?de:{path:de,isUnsafe:!0},isAutoDetected:!0})}o(E,he);const _=await d(he.entries(),L,a,$,w,x);if(t&&k)try{const de=await c(`${X}\\${ie?"wsl":"bash"}.exe`,L);for(const Z of de)(!E||!(Z.profileName in E))&&_.push(Z)}catch{y&&(w?.info("WSL is not installed, so could not detect WSL profiles"),y=!1)}return _}async function d(t,a,$,w=process.env,k,E){const L=[];for(const[j,x]of t)L.push(f(j,x,a,$,w,k,E));return(await Promise.all(L)).filter(j=>!!j)}async function f(t,a,$,w,k=process.env,E,L){if(a===null)return;let j,x,ce;if("source"in a&&!("path"in a)){const _=S?.get(a.source);if(!_)return;j=_.paths,x=a.args||_.args,a.icon?ce=h(a.icon):_.icon&&(ce=_.icon)}else j=Array.isArray(a.path)?a.path:[a.path],x=I.$j||Array.isArray(a.args)?a.args:void 0,ce=h(a.icon);let X;if(L){const _=j.map(Z=>typeof Z=="string"?Z:Z.path),de=await L(_);X=new Array(j.length);for(let Z=0;Z<j.length;Z++)typeof j[Z]=="string"?X[Z]=de[Z]:X[Z]={path:de[Z],isUnsafe:!0}}else X=j.slice();let ie;if(a.requiresPath){let _;if((0,P.$zf)(a.requiresPath)?_=a.requiresPath:(_=a.requiresPath.path,a.requiresPath.isUnsafe&&(ie=_)),!await w.existsFile(_))return}const he=await s(t,$,X,w,k,x,a.env,a.overrideName,a.isAutoDetected,ie);if(!he){E?.debug("Terminal profile not validated",t,j);return}return he.isAutoDetected=a.isAutoDetected,he.icon=ce,he.color=a.color,he}function h(t){return typeof t=="string"?{id:t}:t}async function p(t){if(S&&!t)return;const[a,$]=await Promise.all([l(),t||m()]);S=new Map,S.set("Git Bash",{profileName:"Git Bash",paths:a,args:["--login","-i"]}),S.set("PowerShell",{profileName:"PowerShell",paths:$,icon:R.$Vj.terminalPowershell})}async function l(){const t=new Set,a=await(0,b.$wr)("git.exe");if(a){const k=(0,A.dirname)(a);t.add((0,A.resolve)(k,"../.."))}function $(k,E){E&&k.add(E)}$(t,process.env.ProgramW6432),$(t,process.env.ProgramFiles),$(t,process.env["ProgramFiles(X86)"]),$(t,`${process.env.LocalAppData}\\Program`);const w=[];for(const k of t)w.push(`${k}\\Git\\bin\\bash.exe`,`${k}\\Git\\usr\\bin\\bash.exe`,`${k}\\usr\\bin\\bash.exe`);return w.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),w.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),w}async function m(){const t=[];for await(const a of(0,v.$yl)())t.push(a.exePath);return t}async function c(t,a){const $=[],w=await new Promise((L,j)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(x,ce)=>{if(x)return j("Problem occurred when getting wsl distros");L(ce)})});if(!w)return[];const k=new RegExp(/[\r?\n]/),E=w.split(k).filter(L=>L.trim().length>0&&L!=="");for(const L of E){if(L===""||L.startsWith("docker-desktop"))continue;const j=`${L} (WSL)`,x={profileName:j,path:t,args:["-d",`${L}`],isDefault:j===a,icon:n(L),isAutoDetected:!1};$.push(x)}return $}function n(t){return t.includes("Ubuntu")?R.$Vj.terminalUbuntu:t.includes("Debian")?R.$Vj.terminalDebian:R.$Vj.terminalLinux}async function i(t,a,$,w,k,E,L,j){const x=new Map;if($){const ce=(await t.readFile("/etc/shells")).toString(),X=(E||ce.split(`
`)).map(he=>{const _=he.indexOf("#");return _===-1?he:he.substring(0,_)}).filter(he=>he.trim().length>0),ie=new Map;for(const he of X){let _=(0,r.$nc)(he),de=ie.get(_)||0;de++,de>1&&(_=`${_} (${de})`),ie.set(_,de),x.set(_,{path:he,isAutoDetected:!0})}}return o(w,x),await d(x.entries(),k,t,j,a,L)}function o(t,a){if(t)for(const[$,w]of Object.entries(t))w===null||typeof w!="object"||!("path"in w)&&!("source"in w)?a.delete($):(w.icon=w.icon||a.get($)?.icon,a.set($,w))}async function s(t,a,$,w,k,E,L,j,x,ce){if($.length===0)return Promise.resolve(void 0);const X=$.shift();if(X==="")return s(t,a,$,w,k,E,L,j,x);const ie=typeof X!="string"&&X.isUnsafe,he=typeof X=="string"?X:X.path,_={profileName:t,path:he,args:E,env:L,overrideName:j,isAutoDetected:x,isDefault:t===a,isUnsafePath:ie,requiresUnsafePath:ce};if((0,r.$nc)(he)===he){const Z=k.PATH?k.PATH.split(r.$tc):void 0,ne=await(0,b.$wr)(he,void 0,Z,void 0,w.existsFile);return ne?(_.path=ne,_.isFromPath=!0,_):s(t,a,$,w,k,E)}return await w.existsFile((0,r.$hc)(he))?_:s(t,a,$,w,k,E,L,j,x)}}),define(pe[255],be([1,0,5,2,3,43,24,13,112,86,248,89,251,254,105,59]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;var f;(function(p){p[p.MaxRestarts=5]="MaxRestarts"})(f||(f={}));let h=class extends R.$Sc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(l,m,c,n){super(),this.M=l,this.N=m,this.O=c,this.P=n,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new D.$Od),this.onPtyHostExit=this.u.event,this.w=this.B(new D.$Od),this.onPtyHostStart=this.w.event,this.y=this.B(new D.$Od),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new D.$Od),this.onPtyHostResponsive=this.z.event,this.C=this.B(new D.$Od),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new D.$Od),this.onProcessData=this.D.event,this.F=this.B(new D.$Od),this.onProcessReady=this.F.event,this.G=this.B(new D.$Od),this.onProcessReplay=this.G.event,this.H=this.B(new D.$Od),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new D.$Od),this.onDidRequestDetach=this.I.event,this.J=this.B(new D.$Od),this.onDidChangeProperty=this.J.event,this.L=this.B(new D.$Od),this.onProcessExit=this.L.event,(0,y.$mr)(),this.B(this.M),this.B((0,R.$Qc)(()=>this.W())),this.j=this.B(new A.$fr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&D.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(r.$j)return process.env;try{return await(0,b.$Ul)(this.N,this.O,{_:[]},process.env)}catch(l){return this.O.error("ptyHost was unable to resolve shell environment",l),{}}}U(){const l=this.M.start(),m=l.client;this.O.getLevel()===C.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),I.ProxyChannel.toService(m.getChannel(S.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(l.onDidProcessExit(i=>{this.u.fire(i.code),!this.m&&!this.q.isDisposed&&(this.n<=f.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${i.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${i.code}, giving up`))}));const n=I.ProxyChannel.toService(m.getChannel(S.TerminalIpcChannels.PtyHost));return this.B(n.onProcessData(i=>this.D.fire(i))),this.B(n.onProcessReady(i=>this.F.fire(i))),this.B(n.onProcessExit(i=>this.L.fire(i))),this.B(n.onDidChangeProperty(i=>this.J.fire(i))),this.B(n.onProcessReplay(i=>this.G.fire(i))),this.B(n.onProcessOrphanQuestion(i=>this.H.fire(i))),this.B(n.onDidRequestDetach(i=>this.I.fire(i))),this.B(new v.$er(this.P,m.getChannel(S.TerminalIpcChannels.Logger))),this.a=l,this.b=n,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async i=>{i.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[l,n]}async createProcess(l,m,c,n,i,o,s,t,a,$,w){const k=setTimeout(()=>this.$(),S.HeartbeatConstants.CreateProcessTimeout),E=await this.f.createProcess(l,m,c,n,i,o,s,t,a,$,w);return clearTimeout(k),E}updateTitle(l,m,c){return this.f.updateTitle(l,m,c)}updateIcon(l,m,c,n){return this.f.updateIcon(l,m,c,n)}attachToProcess(l){return this.f.attachToProcess(l)}detachFromProcess(l,m){return this.f.detachFromProcess(l,m)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(l){return this.f.start(l)}shutdown(l,m){return this.f.shutdown(l,m)}input(l,m){return this.f.input(l,m)}processBinary(l,m){return this.f.processBinary(l,m)}resize(l,m,c){return this.f.resize(l,m,c)}clearBuffer(l){return this.f.clearBuffer(l)}acknowledgeDataEvent(l,m){return this.f.acknowledgeDataEvent(l,m)}setUnicodeVersion(l,m){return this.f.setUnicodeVersion(l,m)}getInitialCwd(l){return this.f.getInitialCwd(l)}getCwd(l){return this.f.getCwd(l)}async getLatency(){const l=new d.$Kd,m=await this.f.getLatency();return l.stop(),[{label:"ptyhostservice<->ptyhost",latency:l.elapsed()},...m]}orphanQuestionReply(l){return this.f.orphanQuestionReply(l)}installAutoReply(l,m){return this.f.installAutoReply(l,m)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(l){return this.f.uninstallAutoReply(l)}getDefaultSystemShell(l){return this.g?.getDefaultSystemShell(l)??(0,g.$El)(l??r.OS,process.env)}async getProfiles(l,m,c,n=!1){const i=await this.S();return(0,u.$yr)(m,c,n,this.N,i,void 0,this.O,this.bb.bind(this,l))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(l,m){return this.f.getWslPath(l,m)}getRevivedPtyNewId(l,m){return this.f.getRevivedPtyNewId(l,m)}setTerminalLayoutInfo(l){return this.f.setTerminalLayoutInfo(l)}async getTerminalLayoutInfo(l){return this.g?.getTerminalLayoutInfo(l)}async requestDetachInstance(l,m){return this.f.requestDetachInstance(l,m)}async acceptDetachInstanceReply(l,m){return this.f.acceptDetachInstanceReply(l,m)}async freePortKillProcess(l){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(l)}async serializeTerminalState(l){return this.f.serializeTerminalState(l)}async reviveTerminalProcesses(l,m,c){return this.f.reviveTerminalProcesses(l,m,c)}async refreshProperty(l,m){return this.f.refreshProperty(l,m)}async updateProperty(l,m,c){return this.f.updateProperty(l,m,c)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(l){this.ab(),this.s=setTimeout(()=>this.Y(),l?S.HeartbeatConstants.ConnectingBeatInterval:S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier+S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${S.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(l,m){return this.j.createRequest({workspaceId:l,originalText:m})}async acceptPtyHostResolvedVariables(l,m){this.j.acceptReply(l,m)}};e.$zr=h,e.$zr=h=Oe([Ae(1,P.$ki),Ae(2,C.$$i),Ae(3,C.$_i)],h)}),define(pe[34],be([1,0,6]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=void 0,e.$Jk=(0,D.$Qh)("IUriIdentityService")}),define(pe[123],be([1,0,34,214,16,19,145,5,2]),function(ue,e,D,R,r,I,P,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0;class b{static{this._clock=0}constructor(y){this.uri=y,this.time=b._clock++}touch(){return this.time=b._clock++,this}}let A=class{constructor(y){this.g=y,this.c=new v.$Rc,this.f=2**16;const u=new Map,g=d=>{let f=u.get(d.scheme);return f===void 0&&(f=y.hasProvider(d)&&!this.g.hasCapability(d,1024),u.set(d.scheme,f)),f};this.c.add(C.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(d=>{u.delete(d.scheme)})),this.extUri=new I.$lg(g),this.d=new P.$Cr((d,f)=>this.extUri.compare(d,f,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,I.$xg)(y));const u=this.d.get(y);return u?u.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new b(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((g,d)=>g[1].time<d[1].time?1:g[1].time>d[1].time?-1:0);b._clock=0,this.d.clear();const u=this.f*.5;for(let g=0;g<u;g++)this.d.set(y[g][0],y[g][1].touch())}};e.$Dr=A,e.$Dr=A=Oe([Ae(0,r.$_j)],A),(0,R.$Ar)(D.$Jk,A,1)}),define(pe[90],be([1,0,198,7,62,19,4,6,12]),function(ue,e,D,R,r,I,P,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.WorkbenchState=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=void 0,e.$Zh=(0,C.$Qh)("contextService");function b(s){const t=s;return typeof t?.id=="string"&&P.URI.isUri(t.uri)}e.$1h=b;function A(s){return typeof s?.id=="string"&&!b(s)&&!y(s)}e.$2h=A,e.$3h={id:"ext-dev"},e.$4h={id:"empty-window"};function S(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,R.$nc)(s)}:t?e.$3h:e.$4h;const a=s;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.$5h=S;function y(s){const t=s;return typeof t?.id=="string"&&P.URI.isUri(t.configPath)}e.$6h=y;function u(s){const t=s;if(t?.uri)return{id:t.id,uri:P.URI.revive(t.uri)};const a=s;if(a?.configPath)return{id:a.id,configPath:P.URI.revive(a.configPath)};if(s?.id)return{id:s.id}}e.$7h=u;var g;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function d(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$8h=d;function f(s){const t=s;return!!(t&&typeof t=="object"&&P.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$9h=f;class h{constructor(t,a,$,w,k){this.h=t,this.j=$,this.k=w,this.l=k,this.c=r.$Wh.forUris(this.l,()=>!0),this.folders=a}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=r.$Wh.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$0h=h;class p{constructor(t,a){this.raw=a,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,I.$wg)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$$h=p;function l(s){return new p({uri:s,index:0,name:(0,I.$sg)(s)},{uri:s.toString()})}e.$_h=l,e.$ai="code-workspace",e.$bi=`.${e.$ai}`,e.$ci=[{name:(0,D.localize)(0,null),extensions:[e.$ai]}],e.$di="workspace.json";function m(s,t){return I.$ng.isEqualOrParent(s,t.untitledWorkspacesHome)}e.$ei=m;function c(s){let t;return P.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===v.Schemas.tmp}e.$fi=c,e.$gi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(s){return s.id===e.$gi}e.$hi=n;function i(s,t){return!m(s,t)&&!c(s)}e.$ii=i;function o(s){return(typeof s=="string"?(0,R.$oc)(s):(0,I.$ug)(s))===e.$bi}e.$ji=o}),define(pe[33],be([1,0,60,5,2,19,4,197,25,16,6,13,90,26,34,14,23,17,10]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u,g,d,f,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.ProfileResourceType=void 0;var l;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(l||(e.ProfileResourceType=l={}));function m(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&P.URI.isUri(t.location)&&P.URI.isUri(t.globalStorageHome)&&P.URI.isUri(t.settingsResource)&&P.URI.isUri(t.keybindingsResource)&&P.URI.isUri(t.tasksResource)&&P.URI.isUri(t.snippetsHome)&&P.URI.isUri(t.extensionsResource))}e.$Kk=m,e.$Lk=(0,A.$Qh)("IUserDataProfilesService");function c(s,t){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:P.URI.revive(s.location).with({scheme:t}),globalStorageHome:P.URI.revive(s.globalStorageHome).with({scheme:t}),settingsResource:P.URI.revive(s.settingsResource).with({scheme:t}),keybindingsResource:P.URI.revive(s.keybindingsResource).with({scheme:t}),tasksResource:P.URI.revive(s.tasksResource).with({scheme:t}),snippetsHome:P.URI.revive(s.snippetsHome).with({scheme:t}),extensionsResource:P.URI.revive(s.extensionsResource).with({scheme:t}),cacheHome:P.URI.revive(s.cacheHome).with({scheme:t}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.$Mk=c;function n(s,t,a,$,w,k){return{id:s,name:t,location:a,isDefault:!1,shortName:w?.shortName,icon:w?.icon,globalStorageHome:k&&w?.useDefaultFlags?.globalState?k.globalStorageHome:(0,I.$wg)(a,"globalStorage"),settingsResource:k&&w?.useDefaultFlags?.settings?k.settingsResource:(0,I.$wg)(a,"settings.json"),keybindingsResource:k&&w?.useDefaultFlags?.keybindings?k.keybindingsResource:(0,I.$wg)(a,"keybindings.json"),tasksResource:k&&w?.useDefaultFlags?.tasks?k.tasksResource:(0,I.$wg)(a,"tasks.json"),snippetsHome:k&&w?.useDefaultFlags?.snippets?k.snippetsHome:(0,I.$wg)(a,"snippets"),extensionsResource:k&&w?.useDefaultFlags?.extensions?k.extensionsResource:(0,I.$wg)(a,"extensions.json"),cacheHome:(0,I.$wg)($,s),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}e.$Nk=n;let i=class extends r.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,a,$,w){super(),this.t=t,this.u=a,this.w=$,this.y=w,this.f=!0,this.h=this.B(new R.$Od),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$Od),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$Od),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$Od),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new u.$Ac,emptyWindows:new Map},this.profilesHome=(0,I.$wg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,I.$wg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),a=[t];if(this.f)try{for(const k of this.O()){if(!k.name||!(0,p.$zf)(k.name)||!k.location){this.y.warn("Skipping the invalid stored profile",k.location||k.name);continue}a.push(n((0,I.$tg)(k.location),k.name,k.location,this.g,{shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags},t))}}catch(k){this.y.error(k)}const $=new u.$Ac,w=new Map;if(a.length)try{const k=this.Q();if(k.workspaces)for(const[E,L]of Object.entries(k.workspaces)){const j=P.URI.parse(E),x=a.find(ce=>ce.id===L);x&&$.set(j,x)}if(k.emptyWindows)for(const[E,L]of Object.entries(k.emptyWindows)){const j=a.find(x=>x.id===L);j&&w.set(E,j)}}catch(k){this.y.error(k)}this.z={profiles:a,workspaces:$,emptyWindows:w}}return this.z}D(){const t=n("__default__profile__",(0,C.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const a="Temp",$=new RegExp(`${(0,h.$Ge)(a)}\\s(\\d+)`);let w=0;for(const E of this.profiles){const L=$.exec(E.name),j=L?parseInt(L[1]):0;w=j>w?j:w}const k=`${a} ${w+1}`;return this.createProfile((0,D.$Ei)((0,f.$fg)()).toString(16),k,{transient:!0},t)}async createNamedProfile(t,a,$){return this.createProfile((0,D.$Ei)((0,f.$fg)()).toString(16),t,a,$)}async createProfile(t,a,$,w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=await this.F(t,a,$);return w&&await this.setProfileForWorkspace(w,k),k}async F(t,a,$){if(!(0,p.$zf)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.r.get(a);return w||(w=(async()=>{try{const k=this.profiles.find(j=>j.name===a||j.id===t);if(k)return k;const E=n(t,a,(0,I.$wg)(this.profilesHome,t),this.g,$,this.defaultProfile);await this.u.createFolder(E.location);const L=[];return this.j.fire({profile:E,join(j){L.push(j)}}),await d.Promises.settled(L),this.I([E],[],[]),E}finally{this.r.delete(a)}})(),this.r.set(a,w)),w}async updateProfile(t,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let $=this.profiles.find(w=>w.id===t.id);if(!$)throw new Error(`Profile '${t.name}' does not exist`);return $=n($.id,a.name??$.name,$.location,this.g,{shortName:a.shortName??$.shortName,icon:a.icon===null?void 0:a.icon??$.icon,transient:a.transient??$.isTransient,useDefaultFlags:a.useDefaultFlags??$.useDefaultFlags},this.defaultProfile),this.I([],[],[$]),$}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(w=>w.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);const $=[];this.m.fire({profile:a,join(w){$.push(w)}});try{await Promise.allSettled($)}catch(w){this.y.error(w)}for(const w of[...this.C.emptyWindows.keys()])a.id===this.C.emptyWindows.get(w)?.id&&this.C.emptyWindows.delete(w);for(const w of[...this.C.workspaces.keys()])a.id===this.C.workspaces.get(w)?.id&&this.C.workspaces.delete(w);this.M(),this.I([],[a],[]);try{await this.u.del(a.cacheHome,{recursive:!0})}catch(w){(0,b.$qk)(w)!==1&&this.y.error(w)}}async setProfileForWorkspace(t,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const $=this.profiles.find(w=>w.id===a.id);if(!$)throw new Error(`Profile '${a.name}' does not exist`);this.L(t,$)}unsetWorkspace(t,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,a)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(a=>a.isDirectory&&this.profiles.every($=>!this.w.extUri.isEqual($.location,a.resource))).map(a=>this.u.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(a=>!this.H(a));await Promise.allSettled(t.map(a=>this.removeProfile(a)))}getProfileForWorkspace(t){const a=this.G(t);return P.URI.isUri(a)?this.s.workspaces.get(a)??this.C.workspaces.get(a):this.s.emptyWindows.get(a)??this.C.emptyWindows.get(a)}G(t){return(0,y.$1h)(t)?t.uri:(0,y.$6h)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,t.location))||[...this.s.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,t.location))||[...this.C.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,t.location))||[...this.C.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,t.location)))}I(t,a,$){const w=[...this.profiles,...t],k=[];this.s.profiles=[];for(let E of w)E.isDefault||a.some(L=>E.id===L.id)||(E=$.find(L=>E.id===L.id)??E,E.isTransient?this.s.profiles.push(E):k.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(k),this.z=void 0,this.J(t,a,$)}J(t,a,$){this.h.fire({added:t,removed:a,updated:$,all:this.profiles})}L(t,a,$){$=a?.isTransient?!0:$,$||this.L(t,void 0,!0);const w=this.G(t),k=$?this.s:this.C;P.URI.isUri(w)?(k.workspaces.delete(w),a&&k.workspaces.set(w,a)):(k.emptyWindows.delete(w),a&&k.emptyWindows.set(w,a)),$||this.M()}M(){const t={};for(const[$,w]of this.C.workspaces.entries())t[$.toString()]=w.id;const a={};for(const[$,w]of this.C.emptyWindows.entries())a[$.toString()]=w.id;this.R({workspaces:t,emptyWindows:a}),this.z=void 0}N(t){const a={},$=this.D();if(t.workspaces)for(const[k,E]of Object.entries(t.workspaces)){const L=P.URI.parse(E);a[k]=this.w.extUri.isEqual(L,$.location)?$.id:this.w.extUri.basename(L)}const w={};if(t.emptyWindows)for(const[k,E]of Object.entries(t.emptyWindows)){const L=P.URI.parse(E);w[k]=this.w.extUri.isEqual(L,$.location)?$.id:this.w.extUri.basename(L)}return{workspaces:a,emptyWindows:w}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$Ok=i,e.$Ok=i=Oe([Ae(0,v.$Xh),Ae(1,b.$_j),Ae(2,g.$Jk),Ae(3,S.$$i)],i);class o extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$Pk=o}),define(pe[256],be([1,0,18,14,20,11,5,2,3,10,4,178,30,36,35,13,31,32,34,33]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u,g,d,f,h,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=e.$vp=e.$up=e.$tp=void 0;let m=class extends C.$Sc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,a,$,w,k,E){super(),this.z=t,this.C=a,this.D=$,this.F=w,this.G=k,this.H=E,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new P.$Od),this.s=this.B(new P.$Od),this.t=this.B(new P.$Od),this.u=this.B(new P.$Od),this.w=this.B(new P.$Od),this.y=[],this.B((0,C.$Qc)(()=>{this.j.forEach(({task:L})=>L.cancel()),this.m.forEach(L=>L.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const a=await this.getTargetPlatform();return t.allTargetPlatforms.some($=>(0,y.$_n)($,t.allTargetPlatforms,a))}async installFromGallery(t,a={}){try{const w=(await this.installGalleryExtensions([{extension:t,options:a}])).find(({identifier:k})=>(0,u.$Do)(k,t.identifier));if(w?.local)return w?.local;throw w?.error?w.error:n(new Error(`Unknown error while installing extension ${t.identifier.id}`))}catch($){throw n($)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new y.$co(S.localize(0,null),y.ExtensionManagementErrorCode.Internal);const a=[],$=[];await Promise.allSettled(t.map(async({extension:w,options:k})=>{try{const E=await this.O(w,!!k?.installGivenVersion,!!k?.installPreReleaseVersion);$.push({...E,options:k})}catch(E){a.push({identifier:w.identifier,operation:2,source:w,error:E})}})),$.length&&a.push(...await this.I($));for(const w of a)w.error&&(this.F.error("Failed to install extension.",w.identifier.id),this.F.error(w.error),w.source&&!A.URI.isUri(w.source)&&i(this.C,"extensionGallery:install",{extensionData:(0,u.$Lo)(w.source),error:w.error}));return a}async uninstall(t,a={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.Q(t,a)}async toggleAppliationScope(t,a){if((0,g.$0l)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let $=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(a,this.H.defaultProfile.extensionsResource)||($=await this.ab(t,this.H.defaultProfile.extensionsResource,a));for(const w of this.H.profiles){const k=(await this.getInstalled(1,w.extensionsResource)).find(E=>(0,u.$Do)(E.identifier,t.identifier));k?this.w.fire(k):this.u.fire({identifier:t.identifier,profileLocation:w.extensionsResource})}return $}else{const $=this.D.extUri.isEqual(a,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(t,a,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:$.identifier,operation:2,local:$,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),$}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.X(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const a=[];return await Promise.allSettled(t.map(async $=>{try{const w=await this.J($,(k,E)=>t.some(L=>(0,u.$Ho)(E.identifier.id)===(0,u.$Io)(L.manifest.publisher,L.manifest.name))?!1:this.L(k,E));a.push(...w)}catch(w){a.push({identifier:{id:(0,u.$Io)($.manifest.publisher,$.manifest.name)},operation:2,source:$.extension,error:w})}})),this.s.fire(a),a}async J({manifest:t,extension:a,options:$},w){const k=$.isApplicationScoped||$.isBuiltin||(0,g.$0l)(t),E={...$,installOnlyNewlyAddedFromExtensionPack:A.URI.isUri(a)?$.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:k,profileLocation:k?this.H.defaultProfile.extensionsResource:$.profileLocation??this.Y()},L=he=>`${u.$Eo.create(he).toString()}${E.profileLocation?`-${E.profileLocation.toString()}`:""}`;if(!A.URI.isUri(a)){const he=this.j.get(L(a));if(he)return this.F.info("Extensions is already requested to install",a.identifier.id),await he.task.waitUntilTaskIsFinished(),[]}const j=[],x=[],ce=[],X=this.Z(t,a,E);A.URI.isUri(a)||this.j.set(L(a),{task:X,waitingTasks:[]}),this.n.fire({identifier:X.identifier,source:a,profileLocation:E.profileLocation}),this.F.info("Installing extension:",X.identifier.id),j.push({task:X,manifest:t});let ie=!1;try{if(E.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",X.identifier.id);else try{const _=await this.N(X.identifier,t,!!E.installOnlyNewlyAddedFromExtensionPack,!!E.installPreReleaseVersion,E.profileLocation),de=await this.getInstalled(void 0,E.profileLocation),Z={...E,donotIncludePackAndDependencies:!0,context:{...E.context,[y.$7n]:!0}};for(const{gallery:ne,manifest:J}of(0,D.$Mb)(_,({gallery:W})=>W.identifier.id)){ie=ie||!!J.extensionDependencies?.some(le=>(0,u.$Do)({id:le},X.identifier));const W=L(ne),oe=this.j.get(W);if(oe){if(w(X,oe.task)){const le=oe.task.identifier;this.F.info("Waiting for already requested installing extension",le.id,X.identifier.id),oe.waitingTasks.push(X),x.push(P.Event.toPromise(P.Event.filter(this.onDidInstallExtensions,re=>re.some(ee=>(0,u.$Do)(ee.identifier,le)))).then(re=>{if(this.F.info("Finished waiting for already requested installing extension",le.id,X.identifier.id),!re.find(B=>(0,u.$Do)(B.identifier,le))?.local)throw new Error(`Extension ${le.id} is not installed`)}))}}else if(!de.some(({identifier:le})=>(0,u.$Do)(le,ne.identifier))){const le=this.Z(J,ne,Z);this.j.set(W,{task:le,waitingTasks:[X]}),this.n.fire({identifier:le.identifier,source:ne,profileLocation:E.profileLocation}),this.F.info("Installing extension:",le.identifier.id,X.identifier.id),j.push({task:le,manifest:J})}}}catch(_){if(A.URI.isUri(X.source))(0,D.$Lb)(t.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",X.identifier.id,_.message),(0,D.$Lb)(t.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",X.identifier.id,_.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",X.identifier.id),_}const he=j.reduce((_,{task:de,manifest:Z})=>(_.set(de.identifier.id.toLowerCase(),{task:de,manifest:Z}),_),new Map);for(;he.size;){let _;const de=[...he.values()].filter(({manifest:Z})=>!Z.extensionDependencies?.some(ne=>he.has(ne.toLowerCase())));de.length?_=he.size===1?de:de.filter(({task:Z})=>!(Z===X&&!ie)):(this.F.info("Found extensions with circular dependencies",de.map(({task:Z})=>Z.identifier.id)),_=[...he.values()]),await this.M(_.map(async({task:Z})=>{const ne=new Date().getTime();try{const J=await Z.run();if(await this.M(this.y.map(W=>W.postInstall(J,Z.source,E,r.CancellationToken.None))),!A.URI.isUri(Z.source)){const W=Z.operation===3,oe=W?void 0:(new Date().getTime()-Z.source.lastUpdated)/1e3;if(i(this.C,W?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,u.$Lo)(Z.source),verificationStatus:Z.verificationStatus,duration:new Date().getTime()-ne,durationSinceUpdate:oe}),v.$p&&Z.operation!==3)try{await this.z.reportStatistic(J.manifest.publisher,J.manifest.name,J.manifest.version,"install")}catch{}}ce.push({local:J,identifier:Z.identifier,operation:Z.operation,source:Z.source,context:Z.options.context,profileLocation:Z.profileLocation,applicationScoped:J.isApplicationScoped})}catch(J){throw A.URI.isUri(Z.source)||i(this.C,Z.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,u.$Lo)(Z.source),verificationStatus:Z.verificationStatus,duration:new Date().getTime()-ne,error:J}),this.F.error("Error while installing the extension:",Z.identifier.id),J}finally{he.delete(Z.identifier.id.toLowerCase())}}))}return x.length&&await this.M(x),ce.forEach(({identifier:_})=>this.F.info("Extension installed successfully:",_.id)),ce}catch(he){if(j.forEach(({task:_})=>_.cancel()),ce.length)try{const _=await Promise.allSettled(ce.map(({local:de})=>this.$(de,{versionOnly:!0,profileLocation:E.profileLocation}).run()));for(let de=0;de<_.length;de++){const Z=_[de],{identifier:ne}=ce[de];Z.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",ne.id):this.F.warn("Rollback: Error while uninstalling extension",ne.id,(0,I.$0)(Z.reason))}}catch(_){this.F.warn("Error while rolling back extensions",(0,I.$0)(_),ce.map(({identifier:de})=>de.id))}return j.map(({task:_})=>({identifier:_.identifier,operation:2,source:_.source,context:E.context,profileLocation:E.profileLocation,error:he}))}finally{for(const{task:he}of j)he.source&&!A.URI.isUri(he.source)&&this.j.delete(L(he.source))}}L(t,a){for(const[,{task:$,waitingTasks:w}]of this.j.entries())if($===t&&(w.includes(a)||w.some(k=>this.L(k,a)))||$===a&&w[0]&&!this.L(t,w[0]))return!1;return!0}async M(t){const a=[],$=[],w=await Promise.allSettled(t);for(const k of w)k.status==="fulfilled"?a.push(k.value):$.push(k.reason);if($.length)throw c($);return a}async N(t,a,$,w,k){if(!this.z.isEnabled())return[];const E=await this.getInstalled(void 0,k),L=[],j=[],x=async(ce,X)=>{L.push(ce);const ie=X.extensionDependencies||[],he=[...ie];if(X.extensionPack){const _=$?E.find(de=>(0,u.$Do)(de.identifier,ce)):void 0;for(const de of X.extensionPack)_&&_.manifest.extensionPack&&_.manifest.extensionPack.some(Z=>(0,u.$Do)({id:Z},{id:de}))||he.every(Z=>!(0,u.$Do)({id:Z},{id:de}))&&he.push(de)}if(he.length){const _=he.filter(de=>L.every(Z=>!(0,u.$Do)(Z,{id:de})));if(_.length){const de=await this.z.getExtensions(_.map(Z=>({id:Z,preRelease:w})),r.CancellationToken.None);for(const Z of de){if(L.find(W=>(0,u.$Do)(W,Z.identifier)))continue;const ne=ie.some(W=>(0,u.$Do)({id:W},Z.identifier));let J;try{J=await this.O(Z,!1,w)}catch(W){if(ne)throw W;this.F.info("Skipping the packed extension as it cannot be installed",Z.identifier.id,(0,I.$0)(W));continue}j.push({gallery:J.extension,manifest:J.manifest}),await x(J.extension.identifier,J.manifest)}}}};return await x(t,a),j}async O(t,a,$){let w;const k=await this.getExtensionsControlManifest();if(k.malicious.some(j=>(0,u.$Do)(t.identifier,j)))throw new y.$co(S.localize(1,null,t.identifier.id),y.ExtensionManagementErrorCode.Malicious);const E=k.deprecated[t.identifier.id.toLowerCase()];if(E?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${E.extension.id}' extension instead.`),w=(await this.z.getExtensions([{id:E.extension.id,preRelease:E.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},r.CancellationToken.None))[0],!w)throw new y.$co(S.localize(2,null,t.identifier.id,E.extension.id),y.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const j=await this.getTargetPlatform();throw new y.$co(S.localize(3,null,t.identifier.id,this.G.nameLong,(0,y.$8n)(j)),y.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(w=await this.P(t,a,$),!w)throw!$&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],r.CancellationToken.None))[0]?new y.$co(S.localize(4,null,t.identifier.id),y.ExtensionManagementErrorCode.ReleaseVersionNotFound):new y.$co(S.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),y.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",w.identifier.id);const L=await this.z.getManifest(w,r.CancellationToken.None);if(L===null)throw new y.$co(`Missing manifest for extension ${w.identifier.id}`,y.ExtensionManagementErrorCode.Invalid);if(L.version!==w.version)throw new y.$co(`Cannot install '${w.identifier.id}' extension because of version mismatch in Marketplace`,y.ExtensionManagementErrorCode.Invalid);return{extension:w,manifest:L}}async P(t,a,$){const w=await this.getTargetPlatform();let k=null;return!a&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==$&&(k=(await this.z.getExtensions([{...t.identifier,preRelease:$}],{targetPlatform:w,compatible:!0},r.CancellationToken.None))[0]||null),!k&&await this.z.isExtensionCompatible(t,$,w)&&(k=t),k||(a?k=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:w,compatible:!0},r.CancellationToken.None))[0]||null:k=await this.z.getCompatibleExtension(t,$,w)),k}async Q(t,a){const $={...a,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:a.profileLocation??this.Y()},w=ce=>`${ce.id.toLowerCase()}${$.versionOnly?`-${t.manifest.version}`:""}${$.profileLocation?`@${$.profileLocation.toString()}`:""}`,k=this.m.get(w(t.identifier));if(k)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),k.waitUntilTaskIsFinished();const E=ce=>{const X=this.$(ce,$);return this.m.set(w(X.extension.identifier),X),$.profileLocation?this.F.info("Uninstalling extension from the profile:",`${ce.identifier.id}@${ce.manifest.version}`,$.profileLocation.toString()):this.F.info("Uninstalling extension:",`${ce.identifier.id}@${ce.manifest.version}`),this.t.fire({identifier:ce.identifier,profileLocation:$.profileLocation,applicationScoped:ce.isApplicationScoped}),X},L=(ce,X)=>{X?$.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${ce.identifier.id}@${ce.manifest.version}`,$.profileLocation.toString(),X.message):this.F.error("Failed to uninstall extension:",`${ce.identifier.id}@${ce.manifest.version}`,X.message):$.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${ce.identifier.id}@${ce.manifest.version}`,$.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${ce.identifier.id}@${ce.manifest.version}`),i(this.C,"extensionGallery:uninstall",{extensionData:(0,u.$Ko)(ce),error:X}),this.u.fire({identifier:ce.identifier,error:X?.code,profileLocation:$.profileLocation,applicationScoped:ce.isApplicationScoped})},j=[],x=[];try{j.push(E(t));const ce=await this.getInstalled(1,$.profileLocation);if($.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const X=this.U(t,ce);for(const ie of X)this.m.has(w(ie.identifier))?this.F.info("Extensions is already requested to uninstall",ie.identifier.id):j.push(E(ie))}$.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.R(j.map(X=>X.extension),ce,t),await this.M(j.map(async X=>{try{if(await X.run(),await this.M(this.y.map(ie=>ie.postUninstall(X.extension,$,r.CancellationToken.None))),X.extension.identifier.uuid)try{await this.z.reportStatistic(X.extension.manifest.publisher,X.extension.manifest.name,X.extension.manifest.version,"uninstall")}catch{}L(X.extension)}catch(ie){const he=ie instanceof y.$co?ie:new y.$co((0,I.$0)(ie),y.ExtensionManagementErrorCode.Internal);throw L(X.extension,he),he}finally{x.push(X)}}))}catch(ce){const X=ce instanceof y.$co?ce:new y.$co((0,I.$0)(ce),y.ExtensionManagementErrorCode.Internal);for(const ie of j){try{ie.cancel()}catch{}x.includes(ie)||L(ie.extension,X)}throw X}finally{for(const ce of j)this.m.delete(w(ce.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",ce.extension.identifier.id)}}R(t,a,$){for(const w of t){const k=this.W(w,a);if(k.length){const E=k.filter(L=>!t.some(j=>(0,u.$Do)(j.identifier,L.identifier)));if(E.length)throw new Error(this.S(w,E,$))}}}S(t,a,$){return $===t?a.length===1?S.localize(6,null,$.manifest.displayName||$.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?S.localize(7,null,$.manifest.displayName||$.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):S.localize(8,null,$.manifest.displayName||$.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?S.localize(9,null,$.manifest.displayName||$.manifest.name,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?S.localize(10,null,$.manifest.displayName||$.manifest.name,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):S.localize(11,null,$.manifest.displayName||$.manifest.name,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}U(t,a,$=[]){if($.indexOf(t)!==-1)return[];$.push(t);const w=t.manifest.extensionPack?t.manifest.extensionPack:[];if(w.length){const k=a.filter(L=>!L.isBuiltin&&w.some(j=>(0,u.$Do)({id:j},L.identifier))),E=[];for(const L of k)E.push(...this.U(L,a,$));return[...k,...E]}return[]}W(t,a){return a.filter($=>$.manifest.extensionDependencies&&$.manifest.extensionDependencies.some(w=>(0,u.$Do)({id:w},t.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const t=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$tp=m,e.$tp=m=Oe([Ae(0,y.$bo),Ae(1,h.$dl),Ae(2,p.$Jk),Ae(3,d.$$i),Ae(4,f.$qj),Ae(5,l.$Lk)],m);function c(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((a,$)=>new Error(`${a.message}${a.message?",":""}${$ instanceof Error?$.message:$}`),new Error(""))}e.$up=c;function n(s){if(s instanceof y.$co)return s;const t=new y.$co(s.message,y.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}e.$vp=n;function i(s,t,{extensionData:a,verificationStatus:$,duration:w,error:k,durationSinceUpdate:E}){let L,j;(0,b.$Hf)($)&&($===!0?$="Verified":($===!1||(L=y.ExtensionManagementErrorCode.Signature,j=$),$="Unverified")),k&&(k instanceof y.$co?(L=k.code,k.code===y.ExtensionManagementErrorCode.Signature&&(j=k.message)):L=y.ExtensionManagementErrorCode.Internal),s.publicLog(t,{...a,verificationStatus:$,success:!k,duration:w,errorcode:L,errorcodeDetail:j,durationSinceUpdate:E})}class o{constructor(){this.d=new R.$Tg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,R.$Ig)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,R.$Ig)(t=>new Promise((a,$)=>{const w=t.onCancellationRequested(()=>{w.dispose(),$(new I.$5)})})),this.d.open()),this.g.cancel()}}e.$wp=o}),define(pe[45],be([1,0,14,15,2,5,26,4,30,36,16,6,13,33,34,10,11,32]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u,g,d,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p||(e.ExtensionsProfileScanningErrorCode=p={}));class l extends Error{constructor(o,s){super(o),this.code=s}}e.$xp=l,e.$yp=(0,S.$Qh)("IExtensionsProfileScannerService");let m=class extends r.$Sc{constructor(o,s,t,a,$,w){super(),this.j=o,this.m=s,this.n=t,this.r=a,this.s=$,this.t=w,this.b=this.B(new I.$Od),this.onAddExtensions=this.b.event,this.c=this.B(new I.$Od),this.onDidAddExtensions=this.c.event,this.f=this.B(new I.$Od),this.onRemoveExtensions=this.f.event,this.g=this.B(new I.$Od),this.onDidRemoveExtensions=this.g.event,this.h=new P.$Ac}scanProfileExtensions(o,s){return this.u(o,void 0,s)}async addExtensionsToProfile(o,s){const t=[],a=[];try{return await this.u(s,$=>{const w=[];for(const k of $)o.some(([E])=>(0,b.$Do)(E.identifier,k.identifier)&&E.manifest.version!==k.version)?t.push(k):w.push(k);for(const[k,E]of o){const L=w.findIndex(x=>(0,b.$Do)(x.identifier,k.identifier)&&x.version===k.manifest.version),j={identifier:k.identifier,version:k.manifest.version,location:k.location,metadata:E};L===-1?(a.push(j),w.push(j)):w.splice(L,1,j)}return a.length&&this.b.fire({extensions:a,profileLocation:s}),t.length&&this.f.fire({extensions:t,profileLocation:s}),w}),a.length&&this.c.fire({extensions:a,profileLocation:s}),t.length&&this.g.fire({extensions:t,profileLocation:s}),a}catch($){throw a.length&&this.c.fire({extensions:a,error:$,profileLocation:s}),t.length&&this.g.fire({extensions:t,error:$,profileLocation:s}),$}}async updateMetadata(o,s){const t=[];return await this.u(s,a=>{const $=[];for(const w of a){const k=o.find(([E])=>(0,b.$Do)(E.identifier,w.identifier)&&E.manifest.version===w.version);k&&(w.metadata={...w.metadata,...k[1]},t.push(w)),$.push(w)}return $}),t}async removeExtensionFromProfile(o,s){const t=[];try{await this.u(s,a=>{const $=[];for(const w of a)(0,b.$Do)(w.identifier,o.identifier)?t.push(w):$.push(w);return t.length&&this.f.fire({extensions:t,profileLocation:s}),$}),t.length&&this.g.fire({extensions:t,profileLocation:s})}catch(a){throw t.length&&this.g.fire({extensions:t,error:a,profileLocation:s}),a}}async u(o,s,t){return this.F(o).queue(async()=>{let a=[],$;try{const w=await this.m.readFile(o);$=JSON.parse(w.value.toString().trim()||"[]")}catch(w){if((0,A.$qk)(w)!==1)throw w;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&($=await this.D()),!$&&t?.bailOutWhenFileNotFound)throw new l((0,f.$0)(w),"ERROR_PROFILE_NOT_FOUND")}if($){Array.isArray($)||this.w(o);let w=!1;for(const k of $){c(k)||this.w(o);let E;if((0,d.$zf)(k.relativeLocation)&&k.relativeLocation)E=this.z(k.relativeLocation);else if((0,d.$zf)(k.location))E=this.z(k.location),w=!0,k.relativeLocation=k.location,k.location=E.toJSON();else{E=C.URI.revive(k.location);const L=this.y(E);L&&(w=!0,k.relativeLocation=L)}a.push({identifier:k.identifier,location:E,version:k.version,metadata:k.metadata})}w&&await this.m.writeFile(o,R.$ce.fromString(JSON.stringify($)))}if(s){a=s(a);const w=a.map(k=>({identifier:k.identifier,version:k.version,location:k.location.toJSON(),relativeLocation:this.y(k.location),metadata:k.metadata}));await this.m.writeFile(o,R.$ce.fromString(JSON.stringify(w)))}return a})}w(o){const s=new l(`Invalid extensions content in ${o.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(o)).value.toString()}catch($){if((0,A.$qk)($)===1)return;throw $}this.t.info("Migrating extensions from old default profile location",o.toString());let a;try{const $=JSON.parse(t);Array.isArray($)&&$.every(w=>c(w))?a=$:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",$)}catch($){this.t.error($)}if(a)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,R.$ce.fromString(JSON.stringify(a)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch($){if((0,A.$qk)($)===3)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw $}try{await this.m.del(o)}catch($){(0,A.$qk)($)!==1&&this.t.error($)}try{await this.m.del(s)}catch($){(0,A.$qk)($)!==1&&this.t.error($)}return a})()),this.C}F(o){let s=this.h.get(o);return s||(s=new D.$2g,this.h.set(o,s)),s}};e.$zp=m,e.$zp=m=Oe([Ae(1,A.$_j),Ae(2,u.$Lk),Ae(3,g.$Jk),Ae(4,h.$dl),Ae(5,y.$$i)],m);function c(i){return(0,d.$Bf)(i)&&(0,v.$ao)(i.identifier)&&(n(i.location)||(0,d.$zf)(i.location)&&i.location)&&((0,d.$Gf)(i.relativeLocation)||(0,d.$zf)(i.relativeLocation))&&i.version&&(0,d.$zf)(i.version)}function n(i){return i?(0,d.$zf)(i.path)&&(0,d.$zf)(i.scheme):!1}}),define(pe[58],be([1,0,18,14,22,15,11,75,162,2,12,7,3,19,53,61,10,4,182,25,36,35,80,16,6,13,31,5,50,45,33,34,212]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u,g,d,f,h,p,l,m,c,n,i,o,s,t,a,$,w,k,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$Fp=e.$Ep=e.$Dp=e.$Cp=e.Translations=void 0;var j;(function(de){function Z(ne,J){if(ne===J)return!0;const W=Object.keys(ne),oe=new Set;for(const le of Object.keys(J))oe.add(le);if(W.length!==oe.size)return!1;for(const le of W){if(ne[le]!==J[le])return!1;oe.delete(le)}return oe.size===0}de.equals=Z})(j||(e.Translations=j={})),e.$Cp=(0,o.$Qh)("IExtensionsScannerService");let x=class extends b.$Sc{constructor(Z,ne,J,W,oe,le,re,ee,B,K,N,O){super(),this.systemExtensionsLocation=Z,this.userExtensionsLocation=ne,this.r=J,this.s=W,this.t=oe,this.u=le,this.w=re,this.y=ee,this.z=B,this.C=K,this.D=N,this.F=O,this.g=this.B(new a.$Od),this.onDidChangeCache=this.g.event,this.h=(0,u.$wg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ie,this.s,this.h)),this.m=this.B(this.F.createInstance(ie,this.s,this.h)),this.n=this.B(this.F.createInstance(X,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,m.$Oo)(this.w,this.y)),this.G}async scanAllExtensions(Z,ne,J){const[W,oe]=await Promise.all([this.scanSystemExtensions(Z),this.scanUserExtensions(ne)]),le=J?await this.scanExtensionsUnderDevelopment(Z,[...W,...oe]):[];return this.L(W,oe,le,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Z){const ne=[];ne.push(this.M(!!Z.useCache,Z.language)),ne.push(this.N(Z.language,!!Z.checkControlFile));const[J,W]=await Promise.all(ne);return this.J([...J,...W],0,Z,!1)}async scanUserExtensions(Z){const ne=Z.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",ne);const J=this.D.extUri.isEqual(Z.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.P(ne,!!Z.profileLocation,1,!Z.includeUninstalled,Z.language,!0,J),oe=Z.useCache&&!W.devMode&&W.excludeObsolete?this.m:this.n;let le;try{le=await oe.scanExtensions(W)}catch(re){if(re instanceof w.$xp&&re.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),le=await oe.scanExtensions(W);else throw re}return le=await this.J(le,1,Z,!0),this.y.trace("Scanned user extensions:",le.length),le}async scanExtensionsUnderDevelopment(Z,ne){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const J=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(W=>W.scheme===A.Schemas.file).map(async W=>{const oe=await this.P(W,!1,1,!0,Z.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(oe)).map(re=>(re.type=ne.find(ee=>(0,m.$Do)(ee.identifier,re.identifier))?.type??re.type,this.n.validate(re,oe)))}))).flat();return this.J(J,"development",Z,!0)}return[]}async scanExistingExtension(Z,ne,J){const W=await this.P(Z,!1,ne,!0,J.language,!0,void 0),oe=await this.n.scanExtension(W);return!oe||!J.includeInvalid&&!oe.isValid?null:oe}async scanOneOrMultipleExtensions(Z,ne,J){const W=await this.P(Z,!1,ne,!0,J.language,!0,void 0),oe=await this.n.scanOneOrMultipleExtensions(W);return this.J(oe,ne,J,!0)}async scanMetadata(Z){const ne=(0,u.$wg)(Z,"package.json"),J=(await this.w.readFile(ne)).value.toString();return JSON.parse(J).__metadata}async updateMetadata(Z,ne){const J=(0,u.$wg)(Z,"package.json"),W=(await this.w.readFile(J)).value.toString(),oe=JSON.parse(W);ne.isMachineScoped===!1&&delete ne.isMachineScoped,ne.isBuiltin===!1&&delete ne.isBuiltin,oe.__metadata={...oe.__metadata,...ne},await this.w.writeFile((0,u.$wg)(Z,"package.json"),I.$ce.fromString(JSON.stringify(oe,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Z){if(Z instanceof w.$xp&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Z}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Z=await this.scanUserExtensions({includeInvalid:!0});if(Z.length)await this.u.addExtensionsToProfile(Z.map(ne=>[ne,ne.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,I.$ce.fromString(JSON.stringify([])))}catch(ne){(0,i.$qk)(ne)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,P.$0)(ne))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Z){this.y.error(Z)}finally{this.H=void 0}})()),this.H}async J(Z,ne,J,W){return J.includeAllVersions||(Z=this.L(ne===0?Z:void 0,ne===1?Z:void 0,ne==="development"?Z:void 0,await this.getTargetPlatform(),W)),J.includeInvalid||(Z=Z.filter(oe=>oe.isValid)),Z.sort((oe,le)=>{const re=S.$nc(oe.location.fsPath),ee=S.$nc(le.location.fsPath);return re<ee?-1:re>ee?1:0})}L(Z,ne,J,W,oe){const le=(ee,B,K)=>{if(ee.isValid&&!B.isValid)return!1;if(ee.isValid===B.isValid){if(oe&&g.gt(ee.manifest.version,B.manifest.version))return this.y.debug(`Skipping extension ${B.location.path} with lower version ${B.manifest.version} in favour of ${ee.location.path} with version ${ee.manifest.version}`),!1;if(g.eq(ee.manifest.version,B.manifest.version)){if(ee.type===0)return this.y.debug(`Skipping extension ${B.location.path} in favour of system extension ${ee.location.path} with same version`),!1;if(ee.targetPlatform===W)return this.y.debug(`Skipping extension ${B.location.path} from different target platform ${B.targetPlatform}`),!1}}return K?this.y.warn(`Overwriting user extension ${ee.location.path} with ${B.location.path}.`):this.y.debug(`Overwriting user extension ${ee.location.path} with ${B.location.path}.`),!0},re=new c.$9l;return Z?.forEach(ee=>{const B=re.get(ee.identifier.id);(!B||le(B,ee,!1))&&re.set(ee.identifier.id,ee)}),ne?.forEach(ee=>{const B=re.get(ee.identifier.id);if(!B&&Z&&ee.type===0){this.y.debug(`Skipping obsolete system extension ${ee.location.path}.`);return}(!B||le(B,ee,!1))&&re.set(ee.identifier.id,ee)}),J?.forEach(ee=>{const B=re.get(ee.identifier.id);(!B||le(B,ee,!0))&&re.set(ee.identifier.id,ee),re.set(ee.identifier.id,ee)}),[...re.values()]}async M(Z,ne){this.y.trace("Started scanning system extensions");const J=await this.P(this.systemExtensionsLocation,!1,0,!0,ne,!0,void 0),oe=await(Z&&!J.devMode?this.j:this.n).scanExtensions(J);return this.y.trace("Scanned system extensions:",oe.length),oe}async N(Z,ne){const J=this.z.isBuilt?[]:this.C.builtInExtensions;if(!J?.length)return[];this.y.trace("Started scanning dev system extensions");const W=ne?await this.O():{},oe=[],le=h.URI.file(S.$hc(S.$jc(A.$dg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ee of J){const B=W[ee.name]||"marketplace";switch(B){case"disabled":break;case"marketplace":oe.push((0,u.$wg)(le,ee.name));break;default:oe.push(h.URI.file(B));break}}const re=await Promise.all(oe.map(async ee=>this.n.scanExtension(await this.P(ee,!1,0,!0,Z,!0,void 0))));return this.y.trace("Scanned dev system extensions:",re.length),(0,D.$Hb)(re)}async O(){try{const Z=await this.w.readFile(this.r);return JSON.parse(Z.value.toString())}catch{return{}}}async P(Z,ne,J,W,oe,le,re){const ee=await this.f(oe??y.$w),B=await this.Q(Z),K=ne&&!this.D.extUri.isEqual(Z,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,N=K?await this.Q(K):void 0;return new ce(Z,B,K,N,ne,re,J,W,le,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,oe,ee)}async Q(Z){try{const ne=await this.w.stat(Z);if(typeof ne.mtime=="number")return ne.mtime}catch{}}};e.$Dp=x,e.$Dp=x=Oe([Ae(4,k.$Lk),Ae(5,w.$yp),Ae(6,i.$_j),Ae(7,s.$$i),Ae(8,l.$Xh),Ae(9,t.$qj),Ae(10,E.$Jk),Ae(11,o.$Ph)],x);class ce{constructor(Z,ne,J,W,oe,le,re,ee,B,K,N,O,U,T,q){this.location=Z,this.mtime=ne,this.applicationExtensionslocation=J,this.applicationExtensionslocationMtime=W,this.profile=oe,this.profileScanOptions=le,this.type=re,this.excludeObsolete=ee,this.validate=B,this.productVersion=K,this.productDate=N,this.productCommit=O,this.devMode=U,this.language=T,this.translations=q}static createNlsConfiguration(Z){return{language:Z.language,pseudo:Z.language==="pseudo",devMode:Z.devMode,translations:Z.translations}}static equals(Z,ne){return(0,u.$pg)(Z.location,ne.location)&&Z.mtime===ne.mtime&&(0,u.$pg)(Z.applicationExtensionslocation,ne.applicationExtensionslocation)&&Z.applicationExtensionslocationMtime===ne.applicationExtensionslocationMtime&&Z.profile===ne.profile&&r.$_m(Z.profileScanOptions,ne.profileScanOptions)&&Z.type===ne.type&&Z.excludeObsolete===ne.excludeObsolete&&Z.validate===ne.validate&&Z.productVersion===ne.productVersion&&Z.productDate===ne.productDate&&Z.productCommit===ne.productCommit&&Z.devMode===ne.devMode&&Z.language===ne.language&&j.equals(Z.translations,ne.translations)}}e.$Ep=ce;let X=class extends b.$Sc{constructor(Z,ne,J,W,oe){super(),this.f=Z,this.g=ne,this.h=J,this.j=W,this.m=oe}async scanExtensions(Z){const ne=Z.profile?await this.r(Z):await this.n(Z);let J={};if(Z.excludeObsolete&&Z.type===1)try{const W=(await this.j.readFile(this.f)).value.toString();J=JSON.parse(W)}catch{}return(0,f.$Mf)(J)?ne:ne.filter(W=>!J[m.$Eo.create(W).toString()])}async n(Z){const ne=await this.j.resolve(Z.location);if(!ne.children?.length)return[];const J=await Promise.all(ne.children.map(async W=>{if(!W.isDirectory||Z.type===1&&(0,u.$tg)(W.resource).indexOf(".")===0)return null;const oe=new ce(W.resource,Z.mtime,Z.applicationExtensionslocation,Z.applicationExtensionslocationMtime,Z.profile,Z.profileScanOptions,Z.type,Z.excludeObsolete,Z.validate,Z.productVersion,Z.productDate,Z.productCommit,Z.devMode,Z.language,Z.translations);return this.scanExtension(oe)}));return(0,D.$Hb)(J).sort((W,oe)=>W.location.path<oe.location.path?-1:1)}async r(Z){let ne=await this.s(Z.location,()=>!0,Z);if(Z.applicationExtensionslocation&&!this.h.extUri.isEqual(Z.location,Z.applicationExtensionslocation)){ne=ne.filter(W=>!W.metadata?.isApplicationScoped);const J=await this.s(Z.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,Z);ne.push(...J)}return ne}async s(Z,ne,J){const W=await this.g.scanProfileExtensions(Z,J.profileScanOptions);if(!W.length)return[];const oe=await Promise.all(W.map(async le=>{if(ne(le)){const re=new ce(le.location,J.mtime,J.applicationExtensionslocation,J.applicationExtensionslocationMtime,J.profile,J.profileScanOptions,J.type,J.excludeObsolete,J.validate,J.productVersion,J.productDate,J.productCommit,J.devMode,J.language,J.translations);return this.scanExtension(re,le.metadata)}return null}));return(0,D.$Hb)(oe)}async scanOneOrMultipleExtensions(Z){try{if(await this.j.exists((0,u.$wg)(Z.location,"package.json"))){const ne=await this.scanExtension(Z);return ne?[ne]:[]}else return await this.scanExtensions(Z)}catch(ne){return this.m.error(`Error scanning extensions at ${Z.location.path}:`,(0,P.$0)(ne)),[]}}async scanExtension(Z,ne){try{let J=await this.scanExtensionManifest(Z.location);if(J){J.publisher||(J.publisher=c.$3l),ne=ne??J.__metadata,delete J.__metadata;const W=(0,m.$Io)(J.publisher,J.name),oe=ne?.id?{id:W,uuid:ne.id}:{id:W},le=ne?.isSystem?0:Z.type,re=le===0||!!ne?.isBuiltin;J=await this.t(Z.location,J,ce.createNlsConfiguration(Z));const ee={type:le,identifier:oe,manifest:J,location:Z.location,isBuiltin:re,targetPlatform:ne?.targetPlatform??"undefined",metadata:ne,isValid:!0,validations:[]};return Z.validate?this.validate(ee,Z):ee}}catch(J){Z.type!==0&&this.m.error(J)}return null}validate(Z,ne){let J=!0;const W=(0,n.$To)(ne.productVersion,ne.productDate,ne.location,Z.manifest,Z.isBuiltin);for(const[oe,le]of W)oe===d.default.Error&&(J=!1,this.m.error(this.z(ne.location,le)));return Z.isValid=J,Z.validations=W,Z}async scanExtensionManifest(Z){const ne=(0,u.$wg)(Z,"package.json");let J;try{J=(await this.j.readFile(ne)).value.toString()}catch(oe){return(0,i.$qk)(oe)!==1&&this.m.error(this.z(Z,(0,p.localize)(0,null,ne.path,oe.message))),null}let W;try{W=JSON.parse(J)}catch{const le=[];(0,C.$Xm)(J,le);for(const re of le)this.m.error(this.z(Z,(0,p.localize)(1,null,ne.path,re.offset,re.length,(0,v.$Ap)(re.error))));return null}return(0,C.$7m)(W)!=="object"?(this.m.error(this.z(Z,(0,p.localize)(2,null,ne.path))),null):W}async t(Z,ne,J){const W=await this.u(Z,ne,J);if(W)try{const oe=[],le=await this.w(W.default,oe);if(oe.length>0)return oe.forEach(ee=>{this.m.error(this.z(Z,(0,p.localize)(3,null,W.default?.path,(0,v.$Ap)(ee.error))))}),ne;if((0,C.$7m)(W)!=="object")return this.m.error(this.z(Z,(0,p.localize)(4,null,W.default?.path))),ne;const re=W.values||Object.create(null);return(0,L.$Bp)(this.m,ne,re,le)}catch{}return ne}async u(Z,ne,J){const W=(0,u.$wg)(Z,"package.nls.json"),oe=(B,K)=>{K.forEach(N=>{this.m.error(this.z(Z,(0,p.localize)(5,null,B?.path,(0,v.$Ap)(N.error))))})},le=B=>{this.m.error(this.z(Z,(0,p.localize)(6,null,B?.path)))},re=`${ne.publisher}.${ne.name}`,ee=J.translations[re];if(ee)try{const B=h.URI.file(ee),K=(await this.j.readFile(B)).value.toString(),N=[],O=(0,C.$Xm)(K,N);return N.length>0?(oe(B,N),{values:void 0,default:W}):(0,C.$7m)(O)!=="object"?(le(B),{values:void 0,default:W}):{values:O.contents?O.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.j.exists(W))return;let K;try{K=await this.y(Z,J)}catch{return}if(!K.localized)return{values:void 0,default:K.original};try{const N=(await this.j.readFile(K.localized)).value.toString(),O=[],U=(0,C.$Xm)(N,O);return O.length>0?(oe(K.localized,O),{values:void 0,default:K.original}):(0,C.$7m)(U)!=="object"?(le(K.localized),{values:void 0,default:K.original}):{values:U,default:K.original}}catch{return{values:void 0,default:K.original}}}}async w(Z,ne){if(Z)try{const J=(await this.j.readFile(Z)).value.toString();return(0,C.$Xm)(J,ne)}catch{}}y(Z,ne){return new Promise((J,W)=>{const oe=le=>{const re=(0,u.$wg)(Z,`package.nls.${le}.json`);this.j.exists(re).then(ee=>{ee&&J({localized:re,original:(0,u.$wg)(Z,"package.nls.json")});const B=le.lastIndexOf("-");B===-1?J({localized:(0,u.$wg)(Z,"package.nls.json"),original:null}):(le=le.substring(0,B),oe(le))})};if(ne.devMode||ne.pseudo||!ne.language)return J({localized:(0,u.$wg)(Z,"package.nls.json"),original:null});oe(ne.language)})}z(Z,ne){return`[${Z.path}]: ${ne}`}};X=Oe([Ae(1,w.$yp),Ae(2,E.$Jk),Ae(3,i.$_j),Ae(4,s.$$i)],X);let ie=class extends X{constructor(Z,ne,J,W,oe,le,re){super(ne,W,oe,le,re),this.G=Z,this.H=J,this.D=this.B(new R.$Sg(3e3)),this.F=this.B(new a.$Od),this.onDidChangeCache=this.F.event}async scanExtensions(Z){const ne=this.M(Z),J=await this.I(ne);if(this.C=Z,J&&J.input&&ce.equals(J.input,this.C))return this.m.debug("Using cached extensions scan result",Z.location.toString()),this.D.trigger(()=>this.L()),J.result.map(oe=>(oe.location=h.URI.revive(oe.location),oe));const W=await super.scanExtensions(Z);return await this.J(ne,{input:Z,result:W}),W}async I(Z){try{const ne=await this.j.readFile(Z),J=JSON.parse(ne.value.toString());return{result:J.result,input:(0,$.$nh)(J.input)}}catch(ne){this.m.debug("Error while reading the extension cache file:",Z.path,(0,P.$0)(ne))}return null}async J(Z,ne){try{await this.j.writeFile(Z,I.$ce.fromString(JSON.stringify(ne)))}catch(J){this.m.debug("Error while writing the extension cache file:",Z.path,(0,P.$0)(J))}}async L(){if(!this.C)return;const Z=this.M(this.C),ne=await this.I(Z);if(!ne)return;const J=ne.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!r.$_m(W,J))try{this.m.info("Invalidating Cache",J,W),await this.j.del(Z),this.F.fire()}catch(oe){this.m.error(oe)}}M(Z){const ne=this.N(Z);return this.h.extUri.joinPath(ne.cacheHome,Z.type===0?c.$2l:c.$1l)}N(Z){return Z.type===0?this.H.defaultProfile:Z.profile?this.h.extUri.isEqual(Z.location,this.G.extensionsResource)?this.G:this.H.profiles.find(ne=>this.h.extUri.isEqual(Z.location,ne.extensionsResource))??this.G:this.H.defaultProfile}};ie=Oe([Ae(2,k.$Lk),Ae(3,w.$yp),Ae(4,E.$Jk),Ae(5,i.$_j),Ae(6,s.$$i)],ie);function he(de,Z){const ne=(0,m.$Go)(de.manifest.publisher,de.manifest.name);return{id:ne,identifier:new c.$7l(ne),isBuiltin:de.type===0,isUserBuiltin:de.type===1&&de.isBuiltin,isUnderDevelopment:Z,extensionLocation:de.location,uuid:de.identifier.uuid,targetPlatform:de.targetPlatform,...de.manifest}}e.$Fp=he;class _ extends x{constructor(Z,ne,J,W,oe,le,re,ee,B,K,N,O){super(Z,ne,(0,u.$wg)(J,".vscode-oss-dev","extensions","control.json"),W,oe,le,re,ee,B,K,N,O),this.R=(async()=>{if(y.$z)try{const U=await this.w.readFile(h.URI.file(y.$z));return JSON.parse(U.value.toString())}catch{}return Object.create(null)})()}f(Z){return this.R}}e.$Gp=_}),define(pe[257],be([1,0,52,14,39,5,2,12,7,21,13,33]),function(ue,e,D,R,r,I,P,C,v,b,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=void 0;let y=class extends P.$Sc{constructor(g,d){super(),this.b=g,this.f=d,this.a=new R.$1g(5)}async postUninstall(g){const d=this.g(g,"uninstall");d&&(this.f.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(d.script,"uninstall",d.args,!0,g),this.f.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(f){this.f.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.f.error(f)}}));try{await b.Promises.rm(this.m(g))}catch(f){this.f.error("Error while removing extension storage path",g.identifier.id),this.f.error(f)}}g(g,d){const f=`vscode:${d}`;if(g.location.scheme===C.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[f]=="string"){const h=g.manifest.scripts[f].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(g.identifier.id,g.manifest.version,`${f} should be a node script`),null):{script:(0,v.$jc)(g.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(g,d,f,h,p){return new Promise((l,m)=>{const c=this.j(g,d,f,p);let n;const i=o=>{n&&(clearTimeout(n),n=null),o?m(o):l(void 0)};c.on("error",o=>{i((0,r.$Bi)(o)||"Unknown")}),c.on("exit",(o,s)=>{i(o?`post-${d} process exited with code ${o}`:void 0)}),h&&(n=setTimeout(()=>{n=null,c.kill(),m("timed out")},5e3))})}j(g,d,f,h){const p={silent:!0,execArgv:void 0},l=(0,D.fork)(g,[`--type=extension-post-${d}`,...f],p);l.stdout.setEncoding("utf8"),l.stderr.setEncoding("utf8");const m=I.Event.fromNodeEventEmitter(l.stdout,"data"),c=I.Event.fromNodeEventEmitter(l.stderr,"data");m(o=>this.f.info(h.identifier.id,h.manifest.version,`post-${d}`,o)),c(o=>this.f.error(h.identifier.id,h.manifest.version,`post-${d}`,o));const n=I.Event.any(I.Event.map(m,o=>({data:`%c${o}`,format:[""]})),I.Event.map(c,o=>({data:`%c${o}`,format:["color: red"]})));return I.Event.debounce(n,(o,s)=>o?{data:o.data+s.data,format:[...o.format,...s.format]}:{data:s.data,format:s.format},100)(o=>{console.group(h.identifier.id),console.log(o.data,...o.format),console.groupEnd()}),l}m(g){return(0,v.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};e.$Ip=y,e.$Ip=y=Oe([Ae(0,S.$Lk),Ae(1,A.$$i)],y)}),define(pe[124],be([1,0,13,33,34,32,45,16,25,4]),function(ue,e,D,R,r,I,P,C,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MN=void 0;let A=class extends P.$zp{constructor(y,u,g,d,f,h){super(b.URI.file(y.extensionsPath),u,g,d,f,h)}};e.$MN=A,e.$MN=A=Oe([Ae(0,v.$Yh),Ae(1,C.$_j),Ae(2,R.$Lk),Ae(3,r.$Jk),Ae(4,I.$dl),Ae(5,D.$$i)],A)}),define(pe[258],be([1,0,14,5,2,41,10,169,6,33]),function(ue,e,D,R,r,I,P,C,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$0o=e.$9o=e.$8o=void 0,e.$8o="__$__isNewStorageMarker",e.$9o="__$__targetStorageMarker",e.$0o=(0,v.$Qh)("storageService");var A;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var S;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var y;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(y||(e.StorageTarget=y={}));function u(p){const l=p.get(e.$9o);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}e.$$o=u;class g extends r.$Sc{static{this.a=60*1e3}constructor(l={flushInterval:g.a}){super(),this.m=l,this.b=this.B(new R.$Rd),this.c=this.B(new R.$Rd),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$Od),this.onWillSaveState=this.f.event,this.h=this.B(new D.$7g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new r.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(l,m,c){return R.Event.filter(this.b.event,n=>n.scope===l&&(m===void 0||n.key===m),c)}n(){this.j.value=(0,D.$$g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,r.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.O()}finally{(0,I.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(l,m){const{key:c,external:n}=m;if(c===e.$9o){switch(l){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:l})}else this.b.fire({scope:l,key:c,target:this.J(l)[c],external:n})}w(l){this.f.fire({reason:l})}get(l,m,c){return this.P(m)?.get(l,c)}getBoolean(l,m,c){return this.P(m)?.getBoolean(l,c)}getNumber(l,m,c){return this.P(m)?.getNumber(l,c)}getObject(l,m,c){return this.P(m)?.getObject(l,c)}storeAll(l,m){this.y(()=>{for(const c of l)this.store(c.key,c.value,c.scope,c.target,m)})}store(l,m,c,n,i=!1){if((0,P.$If)(m)){this.remove(l,c,i);return}this.y(()=>{this.z(l,c,n),this.P(c)?.set(l,m,i)})}remove(l,m,c=!1){this.y(()=>{this.z(l,m,void 0),this.P(m)?.delete(l,c)})}y(l){this.b.pause(),this.c.pause();try{l()}finally{this.b.resume(),this.c.resume()}}keys(l,m){const c=[],n=this.J(l);for(const i of Object.keys(n))n[i]===m&&c.push(i);return c}z(l,m,c,n=!1){const i=this.J(m);typeof c=="number"?i[l]!==c&&(i[l]=c,this.P(m)?.set(e.$9o,JSON.stringify(i),n)):typeof i[l]=="number"&&(delete i[l],this.P(m)?.set(e.$9o,JSON.stringify(i),n))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(l){switch(l){case-1:return this.I;case 0:return this.G;default:return this.D}}L(l){const m=this.P(l);return m?u(m):Object.create(null)}isNew(l){return this.getBoolean(e.$8o,l)===!0}async flush(l=A.NONE){this.f.fire({reason:l});const m=this.P(-1),c=this.P(0),n=this.P(1);switch(l){case A.NONE:await D.Promises.settled([m?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await D.Promises.settled([m?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const l=this.P(-1)?.items??new Map,m=this.P(0)?.items??new Map,c=this.P(1)?.items??new Map;return h(l,m,c,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(l){return await this.flush(),this.P(l)?.optimize()}async switch(l,m){return this.w(A.NONE),(0,b.$Kk)(l)?this.R(l,m):this.S(l,m)}M(l,m){return!(l.id===m.id||d(m)&&d(l))}N(l,m,c){this.y(()=>{const n=new Set;for(const[i,o]of l)n.add(i),m.get(i)!==o&&this.u(c,{key:i,external:!0});for(const[i]of m.items)n.has(i)||this.u(c,{key:i,external:!0})})}}e.$_o=g;function d(p){return p.isDefault||!!p.useDefaultFlags?.globalState}e.$ap=d;class f extends g{constructor(){super(),this.U=this.B(new C.$6o(new C.$7o,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new C.$6o(new C.$7o,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new C.$6o(new C.$7o,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(l=>this.u(1,l))),this.B(this.W.onDidChangeStorage(l=>this.u(0,l))),this.B(this.U.onDidChangeStorage(l=>this.u(-1,l)))}P(l){switch(l){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(l){switch(l){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(l){return!1}}e.$bp=f;async function h(p,l,m,c,n,i){const o=j=>{try{return JSON.parse(j)}catch{return j}},s=new Map,t=new Map;p.forEach((j,x)=>{s.set(x,j),t.set(x,o(j))});const a=new Map,$=new Map;l.forEach((j,x)=>{a.set(x,j),$.set(x,o(j))});const w=new Map,k=new Map;m.forEach((j,x)=>{w.set(x,j),k.set(x,o(j))}),console.group(c!==n?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const E=[];if(s.forEach((j,x)=>{E.push({key:x,value:j})}),console.table(E),console.groupEnd(),console.log(t),c!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const j=[];a.forEach((x,ce)=>{j.push({key:ce,value:x})}),console.table(j),console.groupEnd(),console.log($)}console.group(`Storage: Workspace (path: ${i})`);const L=[];w.forEach((j,x)=>{L.push({key:x,value:j})}),console.table(L),console.groupEnd(),console.log(k)}e.$cp=h}),define(pe[125],be([1,0,18,20,11,3,29,10,4,24,25,30,36,80,16,13,31,44,242,258,32,59]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u,g,d,f,h,p,l,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=e.$gp=e.$fp=void 0;const n=I.$p?"web":(0,S.$0n)(I.$u,P.$ec),i="X-Market-Search-Activity-Id";var o;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished",N[N.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(o||(o={}));function s(...N){return String(N.reduce((O,U)=>O|U,0))}var t;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},$={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},k={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class E{constructor(O=k){this.d=O}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(O,U=this.d.pageSize){return new E({...this.d,pageNumber:O,pageSize:U})}withFilter(O,...U){const T=[...this.d.criteria,...U.length?U.map(q=>({filterType:O,value:q})):[{filterType:O}]];return new E({...this.d,criteria:T})}withSortBy(O){return new E({...this.d,sortBy:O})}withSortOrder(O){return new E({...this.d,sortOrder:O})}withFlags(...O){return new E({...this.d,flags:O.reduce((U,T)=>U|T,0)})}withAssetTypes(...O){return new E({...this.d,assetTypes:O})}withSource(O){return new E({...this.d,source:O})}get raw(){const{criteria:O,pageNumber:U,pageSize:T,sortBy:q,sortOrder:z,flags:te,assetTypes:H}=this.d;return{filters:[{criteria:O,pageNumber:U,pageSize:T,sortBy:q,sortOrder:z}],assetTypes:H,flags:te}}get searchText(){const O=this.d.criteria.filter(U=>U.filterType===t.SearchText)[0];return O&&O.value?O.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(O=>String(O.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function L(N,O){const U=(N||[]).filter(T=>T.statisticName===O)[0];return U?U.value:0}function j(N){const O="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(T=>T.assetType.indexOf(O)===0).reduce((T,q)=>{const z=X(N,q.assetType);return z&&T.push([q.assetType.substring(O.length),z]),T},[])}function x(N){if(N.properties){const O=N.properties.filter(q=>q.key===a.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),T=O.filter(q=>U.test(q.value))[0];return T?{uri:T.value,fallbackUri:T.value}:null}return X(N,a.Repository)}function ce(N){return{uri:`${N.fallbackAssetUri}/${a.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${a.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function X(N,O){return N.files.filter(T=>T.assetType===O)[0]?{uri:`${N.assetUri}/${O}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${O}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}:null}function ie(N,O){const U=N.properties?N.properties.filter(q=>q.key===O):[],T=U.length>0&&U[0].value;return T?T.split(",").map(q=>(0,y.$Ho)(q)):[]}function he(N){const O=N.properties?N.properties.filter(U=>U.key===$.Engine):[];return O.length>0&&O[0].value||""}function _(N){const O=N.properties?N.properties.filter(U=>U.key===$.PreRelease):[];return O.length>0&&O[0].value==="true"}function de(N){const O=N.properties?N.properties.filter(T=>T.key===$.LocalizedLanguages):[],U=O.length>0&&O[0].value||"";return U?U.split(","):[]}function Z(N){return N.properties?.find(O=>O.key===$.SponsorLink)?.value}function ne(N){return N.indexOf("preview")!==-1}function J(N){return N.targetPlatform?(0,S.$9n)(N.targetPlatform):"undefined"}function W(N){const O=(0,D.$Mb)(N.versions.map(J)),U=!!N.tags?.includes(S.$4n),T=O.indexOf("web");return U?T===-1&&O.push("web"):T!==-1&&O.splice(T,1),O}function oe(N,O){for(let U=0;U<N.length;U++){const T=N[U];if(T.version===N[U-1]?.version){let q=U;if(J(T)===O)for(;q>0&&N[q-1].version===T.version;)q--;q!==U&&(N.splice(U,1),N.splice(q,0,T))}}return N}e.$fp=oe;function le(N,O,U){N.telemetryData={index:O,querySource:U,queryActivityId:N.queryContext?.[i]}}function re(N,O,U,T){const q=N.versions[0],z={manifest:X(O,a.Manifest),readme:X(O,a.Details),changelog:X(O,a.Changelog),license:X(O,a.License),repository:x(O),download:ce(O),icon:X(O,a.Icon),signature:X(O,a.Signature),coreTranslations:j(O)};return{identifier:{id:(0,y.$Io)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:O.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,publisherSponsorLink:Z(q),description:N.shortDescription||"",installCount:L(N.statistics,"install"),rating:L(N.statistics,"averagerating"),ratingCount:L(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:U,assets:z,properties:{dependencies:ie(O,$.Dependency),extensionPack:ie(O,$.ExtensionPack),engine:he(O),localizedLanguages:de(O),targetPlatform:J(O),isPreReleaseVersion:_(O)},hasPreReleaseVersion:_(q),hasReleaseVersion:!0,preview:ne(N.flags),isSigned:!!z.signature,queryContext:T}}let ee=class{constructor(O,U,T,q,z,te,H,Y){this.k=U,this.l=T,this.n=q,this.o=z,this.q=te,this.u=H,this.w=Y;const V=H.extensionsGallery,Q=V?.servicePPEUrl&&Y.getValue("_extensionsGallery.enablePPE");this.d=Q?V.servicePPEUrl:V?.serviceUrl,this.g=Q?void 0:V?.searchUrl,this.h=V?.controlUrl,this.j=(0,p.$ep)(H.version,H,this.n,this.w,this.q,O,this.o)}x(O=""){return`${this.d}${O}`}isEnabled(){return!!this.d}async getExtensions(O,U,T){const q=R.CancellationToken.isCancellationToken(U)?{}:U,z=R.CancellationToken.isCancellationToken(U)?U:T,te=[],H=[],Y=[],V=[];let Q=!0;for(const Ee of O){Ee.uuid?H.push(Ee.uuid):te.push(Ee.id);const Ce=!!(Ee.version||Ee.preRelease);Y.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Ce}),Ee.version&&V.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),Q=Q&&!!Ee.hasPreRelease&&!Ce}if(!H.length&&!te.length)return[];let se=new E().withPage(1,O.length);H.length&&(se=se.withFilter(t.ExtensionId,...H)),te.length&&(se=se.withFilter(t.ExtensionName,...te)),(q.queryAllVersions||Q)&&(se=se.withFlags(se.flags,o.IncludeVersions)),q.source&&(se=se.withSource(q.source));const{extensions:me}=await this.z(se,{targetPlatform:q.targetPlatform??n,includePreRelease:Y,versions:V,compatible:!!q.compatible},z);return q.source&&me.forEach((Ee,Ce)=>le(Ee,Ce,q.source)),me}async getCompatibleExtension(O,U,T){if((0,S.$$n)(O.allTargetPlatforms,T))return null;if(await this.isExtensionCompatible(O,U,T))return O;const q=new E().withFlags(o.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,O.identifier.uuid),{extensions:z}=await this.z(q,{targetPlatform:T,compatible:!0,includePreRelease:U},R.CancellationToken.None);return z[0]||null}async isExtensionCompatible(O,U,T){if(!(0,S.$_n)(O.properties.targetPlatform,O.allTargetPlatforms,T)||!U&&O.properties.isPreReleaseVersion)return!1;let q=O.properties.engine;if(!q){const z=await this.getManifest(O,R.CancellationToken.None);if(!z)throw new Error("Manifest was not found");q=z.engines.vscode}return(0,u.$Vo)(q,this.u.version,this.u.date)}async y(O,U,T,q,z){if(!(0,S.$_n)(J(O),q,z)||U!=="any"&&_(O)!==(U==="prerelease"))return!1;if(T)try{const te=await this.E(O);if(!(0,u.$Vo)(te,this.u.version,this.u.date))return!1}catch(te){return this.l.error(`Error while getting the engine for the version ${O.version}.`,(0,r.$0)(te)),!1}return!0}async query(O,U){let T=O.text||"";const q=O.pageSize??50;let z=new E().withPage(1,q);T?(T=T.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Q,se,me)=>(z=z.withFilter(t.Category,me||se),"")),T=T.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Q,se,me)=>(z=z.withFilter(t.Tag,me||se),"")),T=T.replace(/\bfeatured(\s+|\b|$)/g,()=>(z=z.withFilter(t.Featured),"")),T=T.trim(),T&&(T=T.length<200?T:T.substring(0,200),z=z.withFilter(t.SearchText,T)),z=z.withSortBy(0)):O.ids?z=z.withFilter(t.ExtensionId,...O.ids):O.names?z=z.withFilter(t.ExtensionName,...O.names):z=z.withSortBy(4),typeof O.sortBy=="number"&&(z=z.withSortBy(O.sortBy)),typeof O.sortOrder=="number"&&(z=z.withSortOrder(O.sortOrder)),O.source&&(z=z.withSource(O.source));const te=async(Q,se)=>{const{extensions:me,total:Ee}=await this.z(Q,{targetPlatform:n,compatible:!1,includePreRelease:!!O.includePreRelease},se);return me.forEach((Ce,Le)=>le(Ce,(Q.pageNumber-1)*Q.pageSize+Le,O.source)),{extensions:me,total:Ee}},{extensions:H,total:Y}=await te(z,U),V=async(Q,se)=>{if(se.isCancellationRequested)throw new r.$5;const{extensions:me}=await te(z.withPage(Q+1),se);return me};return{firstPage:H,total:Y,pageSize:z.pageSize,getPage:V}}async z(O,U,T){const q=O.flags;O.flags&o.IncludeLatestVersionOnly&&O.flags&o.IncludeVersions&&(O=O.withFlags(O.flags&~o.IncludeVersions,o.IncludeLatestVersionOnly)),!(O.flags&o.IncludeLatestVersionOnly)&&!(O.flags&o.IncludeVersions)&&(O=O.withFlags(O.flags,o.IncludeLatestVersionOnly)),U.versions?.length&&(O=O.withFlags(O.flags&~o.IncludeLatestVersionOnly,o.IncludeVersions)),O=O.withFlags(O.flags,o.IncludeAssetUri,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeStatistics,o.IncludeVersionProperties);const{galleryExtensions:z,total:te,context:H}=await this.B(O,T);if(!(O.flags&o.IncludeLatestVersionOnly)){const se=[];for(const me of z){const Ee=await this.A(me,U,H);Ee&&se.push(Ee)}return{extensions:se,total:te}}const V=[],Q=new Map;for(let se=0;se<z.length;se++){const me=z[se],Ee={id:(0,y.$Io)(me.publisher.publisherName,me.extensionName),uuid:me.extensionId},Ce=(0,C.$Ff)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(Fe=>(0,y.$Do)(Fe,Ee))?.includePreRelease;if(U.compatible&&(0,S.$$n)(W(me),U.targetPlatform))continue;const Le=await this.A(me,U,H);!Le||Le.properties.isPreReleaseVersion&&(!Ce||!Le.hasReleaseVersion)||!Le.properties.isPreReleaseVersion&&Le.properties.targetPlatform!==U.targetPlatform&&Le.hasPreReleaseVersion?Q.set(me.extensionId,se):V.push([se,Le])}if(Q.size){const se=new c.$Kd,me=new E().withFlags(q&~o.IncludeLatestVersionOnly,o.IncludeVersions).withPage(1,Q.size).withFilter(t.ExtensionId,...Q.keys()),{extensions:Ee}=await this.z(me,U,T);this.o.publicLog2("galleryService:additionalQuery",{duration:se.elapsed(),count:Q.size});for(const Ce of Ee){const Le=Q.get(Ce.identifier.uuid);V.push([Le,Ce])}}return{extensions:V.sort((se,me)=>se[0]-me[0]).map(([,se])=>se),total:te}}async A(O,U,T){const q={id:(0,y.$Io)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},z=U.versions?.find(V=>(0,y.$Do)(V,q))?.version,te=(0,C.$Ff)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(V=>(0,y.$Do)(V,q))?.includePreRelease,H=W(O),Y=oe(O.versions,U.targetPlatform);if(U.compatible&&(0,S.$$n)(H,U.targetPlatform))return null;for(let V=0;V<Y.length;V++){const Q=Y[V];if(!(z&&Q.version!==z)){if(await this.y(Q,te?"any":"release",U.compatible,H,U.targetPlatform))return re(O,Q,H,T);if(z&&Q.version===z)return null}}return z||U.compatible?null:re(O,O.versions[0],H)}async B(O,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");O=O.withFlags(O.flags,o.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(o.Unpublished));const T=await this.j,q=JSON.stringify(O.raw),z={...T,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(q.length)},te=new c.$Kd;let H,Y,V=0;try{if(H=await this.k.request({type:"POST",url:this.g&&O.criteria.some(se=>se.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:q,headers:z},U),H.res.statusCode&&H.res.statusCode>=400&&H.res.statusCode<500)return{galleryExtensions:[],total:V};const Q=await(0,h.$3o)(H);if(Q){const se=Q.results[0],me=se.extensions,Ee=se.resultMetadata&&se.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return V=Ee&&Ee.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:me,total:V,context:{[i]:H.res.headers.activityid}}}return{galleryExtensions:[],total:V}}catch(Q){throw Y=Q,Q}finally{this.o.publicLog2("galleryService:query",{...O.telemetryData,requestBodySize:String(q.length),duration:te.elapsed(),success:!!H&&(0,h.$Yo)(H),responseBodySize:H?.res.headers["Content-Length"],statusCode:H?String(H.res.statusCode):void 0,errorCode:Y?(0,r.$4)(Y)?"canceled":(0,r.$0)(Y).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(V)})}}async reportStatistic(O,U,T,q){if(!this.isEnabled())return;const z=I.$p?this.x(`/itemName/${O}.${U}/version/${T}/statType/${q==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${O}/extensions/${U}/${T}/stats?statType=${q}`),te=I.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Y={...await this.j,Accept:te};try{await this.k.request({type:"POST",url:z,headers:Y},R.CancellationToken.None)}catch{}}async download(O,U,T){this.l.trace("ExtensionGalleryService#download",O.identifier.id);const q=(0,y.$Lo)(O),z=new Date().getTime(),te=se=>this.o.publicLog("galleryService:downloadVSIX",{...q,duration:se}),H=T===2?"install":T===3?"update":"",Y=H?{uri:`${O.assets.download.uri}${v.URI.parse(O.assets.download.uri).query?"&":"?"}${H}=true`,fallbackUri:`${O.assets.download.fallbackUri}${v.URI.parse(O.assets.download.fallbackUri).query?"&":"?"}${H}=true`}:O.assets.download,V=O.queryContext?.[i]?{[i]:O.queryContext[i]}:void 0,Q=await this.D(Y,V?{headers:V}:void 0);await this.q.writeFile(U,Q.stream),te(new Date().getTime()-z)}async downloadSignatureArchive(O,U){if(!O.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",O.identifier.id);const T=await this.D(O.assets.signature);await this.q.writeFile(U,T.stream)}async getReadme(O,U){if(O.assets.readme){const T=await this.D(O.assets.readme,{},U);return await(0,h.$2o)(T)||""}return""}async getManifest(O,U){if(O.assets.manifest){const T=await this.D(O.assets.manifest,{},U),q=await(0,h.$2o)(T);return q?JSON.parse(q):null}return null}async C(O,U){const T=X(O,a.Manifest);if(!T)throw new Error("Manifest was not found");const q={"Accept-Encoding":"gzip"},z=await this.D(T,{headers:q});return await(0,h.$3o)(z)}async getCoreTranslation(O,U){const T=O.assets.coreTranslations.filter(q=>q[0]===U.toUpperCase())[0];if(T){const q=await this.D(T[1]),z=await(0,h.$2o)(q);return z?JSON.parse(z):null}return null}async getChangelog(O,U){if(O.assets.changelog){const T=await this.D(O.assets.changelog,{},U);return await(0,h.$2o)(T)||""}return""}async getAllCompatibleVersions(O,U,T){let q=new E().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1);O.identifier.uuid?q=q.withFilter(t.ExtensionId,O.identifier.uuid):q=q.withFilter(t.ExtensionName,O.identifier.id);const{galleryExtensions:z}=await this.B(q,R.CancellationToken.None);if(!z.length)return[];const te=W(z[0]);if((0,S.$$n)(te,T))return[];const H=[];await Promise.all(z[0].versions.map(async Q=>{try{await this.y(Q,U?"any":"release",!0,te,T)&&H.push(Q)}catch{}}));const Y=[],V=new Set;for(const Q of oe(H,T))V.has(Q.version)||(V.add(Q.version),Y.push({version:Q.version,date:Q.lastUpdated,isPreReleaseVersion:_(Q)}));return Y}async D(O,U={},T=R.CancellationToken.None){const q=await this.j,z={type:"GET"},te={...q,...U.headers||{}};U={...U,...z,headers:te};const H=O.uri,Y=O.fallbackUri,V={...U,url:H};try{const Q=await this.k.request(V,T);if(Q.res.statusCode===200)return Q;const se=await(0,h.$2o)(Q);throw new Error(`Expected 200, got back ${Q.res.statusCode} instead.

${se}`)}catch(Q){if((0,r.$4)(Q))throw Q;const se=(0,r.$0)(Q);this.o.publicLog2("galleryService:cdnFallback",{url:H,message:se});const me={...U,url:Y};return this.k.request(me,T)}}async E(O){let U=he(O);if(!U){const T=await this.C(O,R.CancellationToken.None);if(!T)throw new Error("Manifest was not found");U=T.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const O=await this.k.request({type:"GET",url:this.h},R.CancellationToken.None);if(O.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,h.$3o)(O),T=[],q={},z=[];if(U){for(const te of U.malicious)T.push({id:te});if(U.migrateToPreRelease)for(const[te,H]of Object.entries(U.migrateToPreRelease))(!H.engine||(0,u.$Vo)(H.engine,this.u.version,this.u.date))&&(q[te.toLowerCase()]={disallowInstall:!0,extension:{id:H.id,displayName:H.displayName,autoMigrate:{storage:!!H.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[te,H]of Object.entries(U.deprecated))H&&(q[te.toLowerCase()]=(0,C.$Ff)(H)?{}:H);if(U.search)for(const te of U.search)z.push(te)}return{malicious:T,deprecated:q,search:z}}};ee=Oe([Ae(1,h.$Wo),Ae(2,d.$$i),Ae(3,A.$Xh),Ae(4,m.$dl),Ae(5,g.$_j),Ae(6,f.$qj),Ae(7,b.$ki)],ee);let B=class extends ee{constructor(O,U,T,q,z,te,H,Y){super(O,U,T,q,z,te,H,Y)}};e.$gp=B,e.$gp=B=Oe([Ae(0,l.$0o),Ae(1,h.$Wo),Ae(2,d.$$i),Ae(3,A.$Xh),Ae(4,m.$dl),Ae(5,g.$_j),Ae(6,f.$qj),Ae(7,b.$ki)],B);let K=class extends ee{constructor(O,U,T,q,z,te,H){super(void 0,O,U,T,q,z,te,H)}};e.$hp=K,e.$hp=K=Oe([Ae(0,h.$Wo),Ae(1,d.$$i),Ae(2,A.$Xh),Ae(3,m.$dl),Ae(4,g.$_j),Ae(5,f.$qj),Ae(6,b.$ki)],K)}),define(pe[259],be([1,0,5,2,33,51]),function(ue,e,D,R,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UN=e.$TN=void 0;class P{constructor(b,A){this.a=b,this.b=A}listen(b,A){const S=this.b(b);switch(A){case"onDidChangeProfiles":return D.Event.map(this.a.onDidChangeProfiles,y=>({all:y.all.map(u=>(0,I.$Om)({...u},S)),added:y.added.map(u=>(0,I.$Om)({...u},S)),removed:y.removed.map(u=>(0,I.$Om)({...u},S)),updated:y.updated.map(u=>(0,I.$Om)({...u},S))}))}throw new Error(`Invalid listen ${A}`)}async call(b,A,S){const y=this.b(b);switch(A){case"createProfile":{const u=await this.a.createProfile(S[0],S[1],S[2]);return(0,I.$Om)({...u},y)}case"updateProfile":{let u=(0,r.$Mk)((0,I.$Pm)(S[0],y),this.a.profilesHome.scheme);return u=await this.a.updateProfile(u,S[1]),(0,I.$Om)({...u},y)}case"removeProfile":{const u=(0,r.$Mk)((0,I.$Pm)(S[0],y),this.a.profilesHome.scheme);return this.a.removeProfile(u)}}throw new Error(`Invalid call ${A}`)}}e.$TN=P;class C extends R.$Sc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(b,A,S){super(),this.profilesHome=A,this.f=S,this.a=[],this.b=this.B(new D.$Od),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=b.map(y=>(0,r.$Mk)(y,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(y=>{const u=y.added.map(f=>(0,r.$Mk)(f,this.profilesHome.scheme)),g=y.removed.map(f=>(0,r.$Mk)(f,this.profilesHome.scheme)),d=y.updated.map(f=>(0,r.$Mk)(f,this.profilesHome.scheme));this.a=y.all.map(f=>(0,r.$Mk)(f,this.profilesHome.scheme)),this.b.fire({added:u,removed:g,updated:d,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(b){this.c=b}isEnabled(){return this.c}async createNamedProfile(b,A,S){const y=await this.f.call("createNamedProfile",[b,A,S]);return(0,r.$Mk)(y,this.profilesHome.scheme)}async createProfile(b,A,S,y){const u=await this.f.call("createProfile",[b,A,S,y]);return(0,r.$Mk)(u,this.profilesHome.scheme)}async createTransientProfile(b){const A=await this.f.call("createTransientProfile",[b]);return(0,r.$Mk)(A,this.profilesHome.scheme)}async setProfileForWorkspace(b,A){await this.f.call("setProfileForWorkspace",[b,A])}removeProfile(b){return this.f.call("removeProfile",[b])}async updateProfile(b,A){const S=await this.f.call("updateProfile",[b,A]);return(0,r.$Mk)(S,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$UN=C}),define(pe[126],be([1,0,4,25,16,13,236,34,33,10,237]),function(ue,e,D,R,r,I,P,C,v,b,A){"use strict";var S,y;Object.defineProperty(e,"__esModule",{value:!0}),e.$LN=e.$KN=e.$JN=void 0;let u=class extends v.$Ok{static{S=this}static{this.a="profileAssociationsMigration"}constructor(h,p,l,m,c){super(l,m,p,c),this.U=h,this.W=l}O(){return this.U.getItem(S.b,[]).map(p=>({...p,location:(0,b.$zf)(p.location)?this.w.extUri.joinPath(this.profilesHome,p.location):D.URI.revive(p.location)}))}Q(){const h=this.U.getItem(S.c,{});return this.U.getItem(S.a,!1)?h:this.N(h)}S(){return this.w.extUri.joinPath(D.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$JN=u,e.$JN=u=S=Oe([Ae(0,P.$EN),Ae(1,C.$Jk),Ae(2,R.$Yh),Ae(3,r.$_j),Ae(4,I.$$i)],u);let g=y=class extends u{constructor(h,p,l,m,c){super(h,p,l,m,c),this.$=h}P(h){h.length?this.$.setItem(y.b,h.map(p=>({...p,location:this.w.extUri.basename(p.location)}))):this.$.removeItem(y.b)}O(){const h=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(h),this.$.setItem("userDataProfilesMigration",!0)),h}R(h){h.emptyWindows||h.workspaces?this.$.setItem(y.c,h):this.$.removeItem(y.c)}Q(){const h="workspaceAndProfileInfo",p=this.$.getItem(h,void 0);if(p){this.$.removeItem(h);const m=p.reduce((c,{workspace:n,profile:i})=>(c[D.URI.revive(n).toString()]=D.URI.revive(i).toString(),c),{});this.$.setItem(y.c,{workspaces:m})}const l=super.Q();return this.$.getItem(y.a,!1)||(this.R(l),this.$.setItem(y.a,!0)),l}};e.$KN=g,e.$KN=g=y=Oe([Ae(0,P.$FN),Ae(1,C.$Jk),Ae(2,R.$Yh),Ae(3,r.$_j),Ae(4,I.$$i)],g);let d=class extends g{constructor(h,p,l,m){super(new A.$IN(0,p,m,l),h,p,l,m)}async init(){return await this.$.init(),super.init()}};e.$LN=d,e.$LN=d=Oe([Ae(0,C.$Jk),Ae(1,R.$Yh),Ae(2,r.$_j),Ae(3,I.$$i)],d)}),define(pe[127],be([1,0,6]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xm=e.$wm=void 0,e.$wm=(0,D.$Qh)("extensionHostStatusService");class R{constructor(){this.a=new Map}setExitInfo(I,P){this.a.set(I,P)}getExitInfo(I){return this.a.get(I)||null}}e.$xm=R}),define(pe[260],be([1,0,5,14]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=void 0;function r(P){let C=0,v=0,b=0;P>=1e3&&(b=Math.floor(P/1e3),P-=b*1e3),b>=60&&(v=Math.floor(b/60),b-=v*60),v>=60&&(C=Math.floor(v/60),v-=C*60);const A=C?`${C}h`:"",S=v?`${v}m`:"",y=b?`${b}s`:"",u=P?`${P}ms`:"";return`${A}${S}${y}${u}`}class I{constructor(C,v,b,A){this.i=C,this.j=v,this.a=new D.$Od,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=b,this.protocol=A,this.e=!1,this.f=new R.$8g(()=>{this.k(`The reconnection grace time of ${r(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new R.$8g(()=>{this.k(`The reconnection short grace time of ${r(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${r(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(C){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${C}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${r(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const C=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),C.end(),this.a.fire(void 0)}acceptReconnection(C,v,b){this.d=C,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(v,b),this.protocol.endAcceptReconnection()}}e.$Fm=I}),define(pe[128],be([1,0,27,12,7,151,55]),function(ue,e,D,R,r,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.$ol=void 0;const C=r.$jc(R.$dg.asFileUri("").fsPath,"nls.metadata.json"),v=new Map;function b(y){return new Promise(u=>D.exists(y,u))}function A(y,u){return b(C).then(g=>{if(!g||!P.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const d=`${y}||${u}`;let f=v.get(d);return f||(f=I.getNLSConfiguration(P.default.commit,u,C,y,y).then(h=>(S.is(h)&&(h._languagePackSupport=!0),h)),v.set(d,f)),f})}e.$ol=A;var S;(function(y){function u(g){const d=g;return d&&typeof d._languagePackId=="string"}y.is=u})(S||(e.InternalNLSConfiguration=S={}))}),define(pe[129],be([1,0,19,4,25,45,58,16,6,13,31,34,33,128]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zN=void 0;let g=class extends P.$Dp{constructor(f,h,p,l,m,c,n,i){super(R.URI.file(m.builtinExtensionsPath),R.URI.file(m.extensionsPath),(0,D.$wg)(m.userHome,".vscode-oss-dev","extensions","control.json"),f.defaultProfile,f,h,p,l,m,c,n,i),this.R=m}async f(f){const h=await(0,u.$ol)(f,this.R.userDataPath);if(u.InternalNLSConfiguration.is(h))try{const p=await this.w.readFile(R.URI.file(h._translationsConfigFile));return JSON.parse(p.value.toString())}catch{}return Object.create(null)}};e.$zN=g,e.$zN=g=Oe([Ae(0,y.$Lk),Ae(1,I.$yp),Ae(2,C.$_j),Ae(3,b.$$i),Ae(4,r.$Yh),Ae(5,A.$qj),Ae(6,S.$Jk),Ae(7,v.$Ph)],g)}),define(pe[261],be([1,0,262,27,7,23,12,21]),function(ue,e,D,R,r,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=e.$Gm=e.ServerConnectionTokenType=void 0;const v=/^[0-9A-Za-z_-]+$/;var b;(function(f){f[f.None=0]="None",f[f.Optional=1]="Optional",f[f.Mandatory=2]="Mandatory"})(b||(e.ServerConnectionTokenType=b={}));class A{constructor(){this.type=0}validate(h){return!0}}e.$Gm=A;class S{constructor(h){this.value=h,this.type=2}validate(h){return h===this.value}}e.$Hm=S;class y{constructor(h){this.message=h}}e.$Im=y;async function u(f,h){const p=f["without-connection-token"],l=f["connection-token"],m=f["connection-token-file"];if(p)return typeof l<"u"||typeof m<"u"?new y("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new A;if(typeof m<"u"){if(typeof l<"u")return new y("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let c;try{c=R.readFileSync(m).toString().replace(/\r?\n$/,"")}catch{return new y(`Unable to read the connection token file at '${m}'.`)}return v.test(c)?new S(c):new y(`The connection token defined in '${m} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof l<"u"?v.test(l)?new S(l):new y(`The connection token '${l} does not adhere to the characters 0-9, a-z, A-Z or -.`):new S(await h())}e.$Jm=u;async function g(f){return u(f,async()=>{if(!f["user-data-dir"])return(0,I.$fg)();const p=r.$jc(f["user-data-dir"],"token");try{const c=(await C.Promises.readFile(p)).toString().replace(/\r?\n$/,"");if(v.test(c))return c}catch{}const l=(0,I.$fg)();try{await C.Promises.writeFile(p,l,{mode:384})}catch{}return l})}e.$Km=g;function d(f,h,p){if(f.validate(p.query[P.$9f]))return!0;const l=D.parse(h.headers.cookie||"");return f.validate(l[P.$8f])}e.$Lm=d}),define(pe[46],be([1,0,200,108,65,6,25,73]),function(ue,e,D,R,r,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=e.$om=e.$nm=void 0,e.$nm={host:{type:"string",cat:"o",args:"ip-address",description:D.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:D.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:D.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:D.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:D.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:D.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:D.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:D.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:D.localize(8,null)},"user-data-dir":r.$Gl["user-data-dir"],"enable-smoke-test-driver":r.$Gl["enable-smoke-test-driver"],"disable-telemetry":r.$Gl["disable-telemetry"],"disable-workspace-trust":r.$Gl["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:r.$Gl.log,logsPath:r.$Gl.logsPath,"force-disable-user-env":r.$Gl["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:D.localize(9,null)},"default-workspace":{type:"string",description:D.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":r.$Gl["extensions-dir"],"extensions-download-dir":r.$Gl["extensions-download-dir"],"builtin-extensions-dir":r.$Gl["builtin-extensions-dir"],"install-extension":r.$Gl["install-extension"],"install-builtin-extension":r.$Gl["install-builtin-extension"],"uninstall-extension":r.$Gl["uninstall-extension"],"list-extensions":r.$Gl["list-extensions"],"locate-extension":r.$Gl["locate-extension"],"show-versions":r.$Gl["show-versions"],category:r.$Gl.category,force:r.$Gl.force,"do-not-sync":r.$Gl["do-not-sync"],"pre-release":r.$Gl["pre-release"],"start-server":{type:"boolean",cat:"e",description:D.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:r.$Gl.help,version:r.$Gl.version,"locate-shell-integration-path":r.$Gl["locate-shell-integration-path"],compatibility:{type:"string"},_:r.$Gl._},e.$om=(0,I.$Rh)(P.$Xh);class v extends R.$km{get userRoamingDataHome(){return this.appSettingsHome}get args(){return super.args}}e.$pm=v,Oe([C.$ih],v.prototype,"userRoamingDataHome",null)}),define(pe[263],be([1,0,27,21,77,85,262,87,40,63,3,13,46,7,12,23,31,44,20,4,15,10,57]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u,g,d,f,h,p,l,m,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1N=e.$ZN=e.CacheControl=e.$YN=void 0;const i={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function o(w,k,E,L){k.writeHead(E,{"Content-Type":"text/plain"}),k.end(L)}e.$YN=o;var s;(function(w){w[w.NO_CACHING=0]="NO_CACHING",w[w.ETAG=1]="ETAG",w[w.NO_EXPIRY=2]="NO_EXPIRY"})(s||(e.CacheControl=s={}));async function t(w,k,E,L,j,x){try{const ce=await R.Promises.stat(w);if(k===1){const X=`W/"${[ce.ino,ce.size,ce.mtime.getTime()].join("-")}"`;if(L.headers["if-none-match"]===X)return j.writeHead(304),void j.end();x.Etag=X}else k===2?x["Cache-Control"]="public, max-age=31536000":k===0&&(x["Cache-Control"]="no-store");x["Content-Type"]=i[(0,u.$oc)(w)]||(0,b.$Vr)(w)||"text/plain",j.writeHead(200,x),(0,D.createReadStream)(w).pipe(j)}catch(ce){return ce.code!=="ENOENT"?(E.error(ce),console.error(ce.toString())):console.error(`File not found: ${w}`),j.writeHead(404,{"Content-Type":"text/plain"}),void j.end("Not found")}}e.$ZN=t;const a=(0,u.$mc)(g.$dg.asFileUri("").fsPath);let $=class{constructor(k,E,L,j,x){this.f=k,this.g=E,this.h=L,this.i=j,this.j=x,this.a=this.j.extensionsGallery?.resourceUrlTemplate?l.URI.parse(this.j.extensionsGallery.resourceUrlTemplate):void 0;const ce=(0,n.$Xk)(x);this.b=`${ce}/static`,this.c=`${ce}/callback`,this.d=`${ce}/web-extension-resource`}async handle(k,E,L){try{const j=L.pathname;return j.startsWith(this.b)&&j.charCodeAt(this.b.length)===47?this.k(k,E,L):j==="/"?this.n(k,E,L):j===this.c?this.p(E):j.startsWith(this.d)&&j.charCodeAt(this.d.length)===47?this.m(k,E,L):o(k,E,404,"Not found.")}catch(j){return this.h.error(j),console.error(j.toString()),o(k,E,500,"Internal Server Error.")}}async k(k,E,L){const j=Object.create(null),ce=decodeURIComponent(L.pathname).substring(this.b.length+1),X=(0,u.$jc)(a,ce);return(0,v.$Yf)(X,a,!A.$l)?t(X,this.g.isBuilt?2:1,this.h,k,E,j):o(k,E,400,"Bad request.")}l(k){const E=k.authority.indexOf(".");return E!==-1?k.authority.substring(E+1):void 0}async m(k,E,L){if(!this.a)return o(k,E,500,"No extension gallery service configured.");const j=decodeURIComponent(L.pathname),x=(0,u.$hc)(j.substring(this.d.length+1)),ce=l.URI.parse(x).with({scheme:this.a.scheme,authority:x.substring(0,x.indexOf("/")),path:x.substring(x.indexOf("/")+1)});if(this.l(this.a)!==this.l(ce))return o(k,E,403,"Request Forbidden");const X={},ie=J=>{const W=k.headers[J];W&&((0,c.$zf)(W)||W[0])?X[J]=(0,c.$zf)(W)?W:W[0]:J!==J.toLowerCase()&&ie(J.toLowerCase())};ie("X-Client-Name"),ie("X-Client-Version"),ie("X-Machine-Id"),ie("X-Client-Commit");const he=await this.i.request({type:"GET",url:ce.toString(!0),headers:X},p.CancellationToken.None),_=he.res.statusCode||500;if(_!==200){let J=null;try{J=await(0,h.$2o)(he)}catch{}return o(k,E,_,J||`Request failed with status ${_}`)}const de=Object.create(null),Z=J=>{const W=he.res.headers[J];W?de[J]=W:J!==J.toLowerCase()&&Z(J.toLowerCase())};Z("Cache-Control"),Z("Content-Type"),E.writeHead(200,de);const ne=await(0,m.$oe)(he.stream);return void E.end(ne.buffer)}async n(k,E,L){const j=L.query[g.$9f];if(typeof j=="string"){const B=Object.create(null);B["Set-Cookie"]=P.serialize(g.$8f,j,{sameSite:"lax",maxAge:60*60*24*7});const K=Object.create(null);for(const O in L.query)O!==g.$9f&&(K[O]=L.query[O]);const N=I.format({pathname:"/",query:K});return B.Location=N,E.writeHead(302,B),void E.end()}const x=B=>{const K=k.headers[B];return Array.isArray(K)?K[0]:K},ce=!this.g.isBuilt&&this.g.args["use-test-resolver"],X=ce?"test+test":x("x-original-host")||x("x-forwarded-host")||k.headers.host;if(!X)return o(k,E,400,"Bad request.");function ie(B){return JSON.stringify(B).replace(/"/g,"&quot;")}let he;this.g.args["enable-smoke-test-driver"]&&(he=!1);const _=B=>B&&l.URI.file(r.resolve(B)).with({scheme:g.Schemas.vscodeRemote,authority:X}),de=g.$dg.asFileUri(this.g.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,Z=!this.g.isBuilt&&this.g.args["github-auth"]?{id:(0,d.$fg)(),providerId:"github",accessToken:this.g.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,ne={embedderIdentifier:"server-distro",extensionsGallery:this.a?{...this.j.extensionsGallery,resourceUrlTemplate:this.a.with({scheme:"http",authority:X,path:`${this.d}/${this.a.authority}${this.a.path}`}).toString(!0)}:void 0};if(!this.g.isBuilt)try{const B=JSON.parse((await R.Promises.readFile((0,u.$jc)(a,"product.overrides.json"))).toString());Object.assign(ne,B)}catch{}const J={remoteAuthority:X,_wrapWebWorkerExtHostInIframe:he,developmentOptions:{enableSmokeTestDriver:this.g.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.h.getLevel()},settingsSyncOptions:!this.g.isBuilt&&this.g.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.g.args["disable-workspace-trust"],folderUri:_(this.g.args["default-folder"]),workspaceUri:_(this.g.args["default-workspace"]),productConfiguration:ne,callbackRoute:this.c},W=this.j.extensionsGallery?.nlsBaseUrl,oe={WORKBENCH_WEB_CONFIGURATION:ie(J),WORKBENCH_AUTH_SESSION:Z?ie(Z):"",WORKBENCH_WEB_BASE_URL:this.b,WORKBENCH_NLS_BASE_URL:W?`${W}${W.endsWith("/")?"":"/"}${this.j.commit}/${this.j.version}/`:""};if(ce){const B=[];for(const K of["vscode-test-resolver","github-authentication"]){const N=JSON.parse((await R.Promises.readFile(g.$dg.asFileUri(`${g.$$f}/${K}/package.json`).fsPath)).toString());B.push({extensionPath:K,packageJSON:N})}oe.WORKBENCH_BUILTIN_EXTENSIONS=ie(B)}let le;try{le=(await R.Promises.readFile(de)).toString().replace(/\{\{([^}]+)\}\}/g,(K,N)=>oe[N]??"undefined")}catch{return E.writeHead(404,{"Content-Type":"text/plain"}),void E.end("Not found")}const ee={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.o(le).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=' ${ce?"":`http://${X}`};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==0&&(ee["Set-Cookie"]=P.serialize(g.$8f,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),E.writeHead(200,ee),void E.end(le)}o(k){const E=/<script>([\s\S]+?)<\/script>/img,L=[];let j;for(;j=E.exec(k);){const x=C.createHash("sha256"),ce=j[1].replace(/\r\n/g,`
`),X=x.update(Buffer.from(ce)).digest().toString("base64");L.push(`'sha256-${X}'`)}return L}async p(k){const E=g.$dg.asFileUri("vs/code/browser/workbench/callback.html").fsPath,L=(await R.Promises.readFile(E)).toString(),j=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.o(L).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return k.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":j}),void k.end(L)}};e.$1N=$,e.$1N=$=Oe([Ae(1,y.$om),Ae(2,S.$$i),Ae(3,h.$Wo),Ae(4,f.$qj)],$)}),define(pe[264],be([1,0,6]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GM=void 0,e.$GM=(0,D.$Qh)("IExtHostInitDataService")}),define(pe[265],be([1,0,6]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rM=e.$qM=void 0,e.$qM=(0,D.$Qh)("IExtHostRpcService");class R{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.dispose=I.dispose.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.$rM=R}),define(pe[70],be([1,0,51]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=void 0;function R(I){return{transformIncoming:P=>P.scheme==="vscode-remote"?{scheme:"file",path:P.path,query:P.query,fragment:P.fragment}:P.scheme==="file"?{scheme:"vscode-local",path:P.path,query:P.query,fragment:P.fragment}:P,transformOutgoing:P=>P.scheme==="file"?{scheme:"vscode-remote",authority:I,path:P.path,query:P.query,fragment:P.fragment}:P.scheme==="vscode-local"?{scheme:"file",path:P.path,query:P.query,fragment:P.fragment}:P,transformOutgoingScheme:P=>P==="file"?"vscode-remote":P==="vscode-local"?"file":P}}function r(I){return new D.$Mm(R(I))}e.$Er=r}),define(pe[266],be([1,0,3,41,4,70,51,104,240,7,19]),function(ue,e,D,R,r,I,P,C,v,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=void 0;class S{static{this.a=1}constructor(u,g,d,f){this.b=u,this.c=g,this.d=d,this.e=f}async call(u,g,d){switch(g){case"getEnvironmentData":{const f=d,h=(0,I.$Er)(f.remoteAuthority);let p=await this.f(f.profile);return p=(0,P.$Om)(p,h),p}case"getExtensionHostExitInfo":{const f=d;return this.e.getExitInfo(f.reconnectionToken)}case"getDiagnosticInfo":{const f=d,h={machineInfo:(0,v.$Ir)()},p=f.includeProcesses?(0,C.$Gr)(process.pid):Promise.resolve();let l=[];const m={};if(f.folders){const c=(0,I.$Er)("");l=f.folders.map(i=>r.URI.revive(c.transformIncoming(i))).filter(i=>i.scheme==="file").map(i=>(0,v.$Hr)(i.fsPath,["node_modules",".git"]).then(o=>{m[(0,b.$nc)(i.fsPath)]=o}))}return Promise.all([p,...l]).then(([c,n])=>(h.processes=c||void 0,h.workspaceMetadata=f.folders?m:void 0,h))}}throw new Error(`IPC Command ${g} not found`)}listen(u,g,d){throw new Error("Not supported")}async f(u){return u&&!this.d.profiles.some(g=>g.id===u)&&await this.d.createProfile(u,u),{pid:process.pid,connectionToken:this.b.type!==0?this.b.value:"",appRoot:r.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,A.$wg)(this.c.logsHome,`exthost${S.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:D.OS,arch:process.arch,marks:R.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(g=>({...g}))}}}}e.$Lr=S}),define(pe[267],be([1,0,4,70,68,7,225]),function(ue,e,D,R,r,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=void 0;class C extends P.$Mr{constructor(A,S){super(new r.$eq(A),A),this.N=S,this.M=new Map,this.B(this.a)}c(A){let S=this.M.get(A.remoteAuthority);return S||(S=(0,R.$Er)(A.remoteAuthority),this.M.set(A.remoteAuthority,S)),S}f(A,S,y=!1){if(y&&S.path==="/vscode-resource"&&S.query){const u=JSON.parse(S.query).requestResourcePath;return D.URI.from({scheme:"file",path:u})}return D.URI.revive(A.transformIncoming(S))}L(A,S){return new v(A,S,this.b,this.N)}}e.$Or=C;class v extends P.$Nr{constructor(A,S,y,u){super(A,S,y,u)}j(A){const S=A.args["file-watcher-polling"];if(S){const y=S.split(I.$tc),u=Number(y[0]);if(u>0)return{usePolling:y.length>1?y.slice(1):!0,pollingInterval:u}}}m(A){if(A.extensionsPath)return[I.$gc.join(A.extensionsPath,"**")]}}}),define(pe[91],be([1,0,203,10,4,2,6,37,16,12,39,157,61]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lE=e.$kE=e.$jE=e.EditorsOrder=e.$iE=e.CloseDirection=e.$hE=e.$gE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$fE=e.$eE=e.$dE=e.$cE=e.$bE=e.$aE=e.$_D=e.$$D=e.EditorInputCapabilities=e.$0D=e.SaveReason=e.Verbosity=e.$9D=e.$8D=e.$7D=e.$6D=e.$5D=e.$4D=e.$3D=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$2D=e.$1D=e.$ZD=e.$YD=e.$XD=void 0,e.$XD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$YD={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$ZD="workbench.editor.sidebysideEditor",e.$1D="workbench.editors.textDiffEditor",e.$2D="workbench.editors.binaryResourceDiffEditor";var u;(function(ee){ee[ee.PROGRAMMATIC=1]="PROGRAMMATIC",ee[ee.USER=2]="USER",ee[ee.EDIT=3]="EDIT",ee[ee.NAVIGATION=4]="NAVIGATION",ee[ee.JUMP=5]="JUMP"})(u||(e.EditorPaneSelectionChangeReason=u={}));var g;(function(ee){ee[ee.IDENTICAL=1]="IDENTICAL",ee[ee.SIMILAR=2]="SIMILAR",ee[ee.DIFFERENT=3]="DIFFERENT"})(g||(e.EditorPaneSelectionCompareResult=g={}));function d(ee){const B=ee;return!!B&&typeof B.getSelection=="function"&&!!B.onDidChangeSelection}e.$3D=d;function f(ee,B,K){for(const N of K.visibleEditorPanes)if(N.group.id===B&&ee.matches(N.input))return N.getViewState()}e.$4D=f;function h(ee){if(a(ee))return!1;const B=ee;return r.URI.isUri(B?.resource)}e.$5D=h;function p(ee){if(a(ee))return!1;const B=ee;return B?.original!==void 0&&B.modified!==void 0}e.$6D=p;function l(ee){if(a(ee)||p(ee))return!1;const B=ee;return B?.primary!==void 0&&B.secondary!==void 0}e.$7D=l;function m(ee){if(a(ee))return!1;const B=ee;return B?B.resource===void 0||B.resource.scheme===b.Schemas.untitled||B.forceUntitled===!0:!1}e.$8D=m;function c(ee){if(a(ee))return!1;const B=ee;return r.URI.isUri(B?.base?.resource)&&r.URI.isUri(B?.input1?.resource)&&r.URI.isUri(B?.input2?.resource)&&r.URI.isUri(B?.result?.resource)}e.$9D=c;var n;(function(ee){ee[ee.SHORT=0]="SHORT",ee[ee.MEDIUM=1]="MEDIUM",ee[ee.LONG=2]="LONG"})(n||(e.Verbosity=n={}));var i;(function(ee){ee[ee.EXPLICIT=1]="EXPLICIT",ee[ee.AUTO=2]="AUTO",ee[ee.FOCUS_CHANGE=3]="FOCUS_CHANGE",ee[ee.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i||(e.SaveReason=i={}));class o{constructor(){this.a=new Map}registerSource(B,K){let N=this.a.get(B);return N||(N={source:B,label:K},this.a.set(B,N)),N.source}getSourceLabel(B){return this.a.get(B)?.label??B}}e.$0D=new o;var s;(function(ee){ee[ee.None=0]="None",ee[ee.Readonly=2]="Readonly",ee[ee.Untitled=4]="Untitled",ee[ee.Singleton=8]="Singleton",ee[ee.RequiresTrust=16]="RequiresTrust",ee[ee.CanSplitInGroup=32]="CanSplitInGroup",ee[ee.ForceDescription=64]="ForceDescription",ee[ee.CanDropIntoEditor=128]="CanDropIntoEditor",ee[ee.MultipleEditors=256]="MultipleEditors",ee[ee.Scratchpad=512]="Scratchpad",ee[ee.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(s||(e.EditorInputCapabilities=s={}));class t extends I.$Sc{}e.$$D=t;function a(ee){return ee instanceof t}e.$_D=a;function $(ee){const B=ee;return r.URI.isUri(B?.preferredResource)}function w(ee){const B=ee;return a(B?.primary)&&a(B?.secondary)}e.$aE=w;function k(ee){const B=ee;return a(B?.modified)&&a(B?.original)}e.$bE=k;function E(ee,B,K,N,O){return re(N,[(0,S.$Ai)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const U={...K,limits:{size:Number.MAX_VALUE}};ee.openEditor(B,U)}}),(0,S.$Ai)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>O.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:y.default.Warning})}e.$cE=E;function L(ee){return a(ee?.editor)}e.$dE=L;function j(ee){const B=ee;return L(ee)&&B?.group!==void 0}e.$eE=j;function x(ee){const B=ee;return typeof B?.groupId=="number"&&a(B.editor)}e.$fE=x;var ce;(function(ee){ee[ee.UNKNOWN=0]="UNKNOWN",ee[ee.REPLACE=1]="REPLACE",ee[ee.MOVE=2]="MOVE",ee[ee.UNPIN=3]="UNPIN"})(ce||(e.EditorCloseContext=ce={}));var X;(function(ee){ee[ee.GROUP_ACTIVE=0]="GROUP_ACTIVE",ee[ee.GROUP_INDEX=1]="GROUP_INDEX",ee[ee.GROUP_LABEL=2]="GROUP_LABEL",ee[ee.GROUP_LOCKED=3]="GROUP_LOCKED",ee[ee.EDITOR_OPEN=4]="EDITOR_OPEN",ee[ee.EDITOR_CLOSE=5]="EDITOR_CLOSE",ee[ee.EDITOR_MOVE=6]="EDITOR_MOVE",ee[ee.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ee[ee.EDITOR_LABEL=8]="EDITOR_LABEL",ee[ee.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ee[ee.EDITOR_PIN=10]="EDITOR_PIN",ee[ee.EDITOR_STICKY=11]="EDITOR_STICKY",ee[ee.EDITOR_DIRTY=12]="EDITOR_DIRTY",ee[ee.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(X||(e.GroupModelChangeKind=X={}));var ie;(function(ee){ee[ee.PRIMARY=1]="PRIMARY",ee[ee.SECONDARY=2]="SECONDARY",ee[ee.BOTH=3]="BOTH",ee[ee.ANY=4]="ANY"})(ie||(e.SideBySideEditor=ie={}));class he{getOriginalUri(B,K){if(!B)return;if(c(B))return e.$hE.getOriginalUri(B.result,K);if(K?.supportSideBySide){const{primary:O,secondary:U}=this.a(B);if(O&&U){if(K?.supportSideBySide===ie.BOTH)return{primary:this.getOriginalUri(O,{filterByScheme:K.filterByScheme}),secondary:this.getOriginalUri(U,{filterByScheme:K.filterByScheme})};if(K?.supportSideBySide===ie.ANY)return this.getOriginalUri(O,{filterByScheme:K.filterByScheme})??this.getOriginalUri(U,{filterByScheme:K.filterByScheme});B=K.supportSideBySide===ie.PRIMARY?O:U}}if(p(B)||l(B)||c(B))return;const N=$(B)?B.preferredResource:B.resource;return!N||!K||!K.filterByScheme?N:this.b(N,K.filterByScheme)}a(B){return w(B)||l(B)?{primary:B.primary,secondary:B.secondary}:k(B)||p(B)?{primary:B.modified,secondary:B.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(B,K){if(!B)return;if(c(B))return e.$hE.getCanonicalUri(B.result,K);if(K?.supportSideBySide){const{primary:O,secondary:U}=this.a(B);if(O&&U){if(K?.supportSideBySide===ie.BOTH)return{primary:this.getCanonicalUri(O,{filterByScheme:K.filterByScheme}),secondary:this.getCanonicalUri(U,{filterByScheme:K.filterByScheme})};if(K?.supportSideBySide===ie.ANY)return this.getCanonicalUri(O,{filterByScheme:K.filterByScheme})??this.getCanonicalUri(U,{filterByScheme:K.filterByScheme});B=K.supportSideBySide===ie.PRIMARY?O:U}}if(p(B)||l(B)||c(B))return;const N=B.resource;return!N||!K||!K.filterByScheme?N:this.b(N,K.filterByScheme)}b(B,K){if(Array.isArray(K)){if(K.some(N=>B.scheme===N))return B}else if(K===B.scheme)return B}}var _;(function(ee){ee[ee.UNKNOWN=0]="UNKNOWN",ee[ee.KEYBOARD=1]="KEYBOARD",ee[ee.MOUSE=2]="MOUSE"})(_||(e.EditorCloseMethod=_={}));function de(ee,B,K,N){if(!ee.isSticky(B))return!1;switch(N.preventPinnedEditorClose){case"keyboardAndMouse":return K===_.MOUSE||K===_.KEYBOARD;case"mouse":return K===_.MOUSE;case"keyboard":return K===_.KEYBOARD}return!1}e.$gE=de,e.$hE=new he;var Z;(function(ee){ee[ee.LEFT=0]="LEFT",ee[ee.RIGHT=1]="RIGHT"})(Z||(e.CloseDirection=Z={}));class ne{constructor(){this.c=new Map,this.d=new Map}start(B){const K=this.a=B.get(P.$Ph);for(const[N,O]of this.c)this.e(N,O,K);this.c.clear()}e(B,K,N){const O=N.createInstance(K);this.d.set(B,O)}registerFileEditorFactory(B){if(this.b)throw new Error("Can only register one file editor factory.");this.b=B}getFileEditorFactory(){return(0,R.$Kf)(this.b)}registerEditorSerializer(B,K){if(this.c.has(B)||this.d.has(B))throw new Error(`A editor serializer with type ID '${B}' was already registered.`);return this.a?this.e(B,K,this.a):this.c.set(B,K),(0,I.$Qc)(()=>{this.c.delete(B),this.d.delete(B)})}getEditorSerializer(B){return this.d.get(typeof B=="string"?B:B.typeId)}}C.$kn.add(e.$XD.EditorFactory,new ne);async function J(ee,B,K){return!ee||!ee.length?[]:await Promise.all(ee.map(async N=>{const O=r.URI.revive(N.fileUri);if(!O){K.info("Cannot resolve the path because it is not valid.",N);return}if(!await B.canHandleResource(O)){K.info("Cannot resolve the path because it cannot be handled",N);return}let T=N.exists,q=N.type;if(typeof T!="boolean"||typeof q!="number")try{q=(await B.stat(O)).isDirectory?v.FileType.Directory:v.FileType.Unknown,T=!0}catch(te){K.error(te),T=!1}if(!T&&N.openOnlyIfExists){K.info("Cannot resolve the path because it does not exist",N);return}if(q===v.FileType.Directory){K.info("Cannot resolve the path because it is a directory",N);return}const z={...N.options,pinned:!0};return T?{resource:O,options:z}:{resource:O,options:z,forceUntitled:!0}}))}e.$iE=J;var W;(function(ee){ee[ee.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ee[ee.SEQUENTIAL=1]="SEQUENTIAL"})(W||(e.EditorsOrder=W={}));function oe(ee){const B=ee;if(!B)return!1;const K=B;if(K.modified)return oe(K.modified);const N=B;return!!(N.contributionsState&&N.viewState&&Array.isArray(N.cursorState))}e.$jE=oe;function le(ee){return(0,A.$Ci)(ee)}e.$kE=le;function re(ee,B,K){const N=(0,A.$Di)(ee,B);return N.forceMessage=K?.forceMessage,N.forceSeverity=K?.forceSeverity,N.allowDialog=K?.allowDialog,N}e.$lE=re}),define(pe[130],be([1,0,15,79,47,63,12,7,3,67]),function(ue,e,D,R,r,I,P,C,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AI=e.$zI=e.$yI=e.$xI=e.CellStatusbarAlignment=e.$wI=e.$vI=e.$uI=e.NotebookEditorPriority=e.$tI=e.$sI=e.$rI=e.$qI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$pI=e.$oI=e.$nI=e.$mI=e.CellKind=e.$lI=e.$kI=e.$jI=void 0,e.$jI="workbench.editor.notebook",e.$kI="workbench.editor.notebookTextDiffEditor",e.$lI="workbench.editor.interactive";var A;(function(_){_[_.Markup=1]="Markup",_[_.Code=2]="Code"})(A||(e.CellKind=A={})),e.$mI=["application/json","application/javascript","text/html","image/svg+xml",I.$Tr.latex,I.$Tr.markdown,"image/png","image/jpeg",I.$Tr.text],e.$nI=[I.$Tr.latex,I.$Tr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",I.$Tr.text],e.$oI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$pI="_notAvailable";var S;(function(_){_[_.Running=1]="Running",_[_.Idle=2]="Idle"})(S||(e.NotebookRunState=S={}));var y;(function(_){_[_.Unconfirmed=1]="Unconfirmed",_[_.Pending=2]="Pending",_[_.Executing=3]="Executing"})(y||(e.NotebookCellExecutionState=y={}));var u;(function(_){_[_.Unconfirmed=1]="Unconfirmed",_[_.Pending=2]="Pending",_[_.Executing=3]="Executing"})(u||(e.NotebookExecutionState=u={}));var g;(function(_){_[_.WithHardKernelDependency=0]="WithHardKernelDependency",_[_.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",_[_.Pure=2]="Pure",_[_.Never=3]="Never"})(g||(e.NotebookRendererMatch=g={}));var d;(function(_){_.Always="always",_.Never="never",_.Optional="optional"})(d||(e.RendererMessagingSpec=d={}));var f;(function(_){_[_.ModelChange=1]="ModelChange",_[_.Move=2]="Move",_[_.ChangeCellLanguage=5]="ChangeCellLanguage",_[_.Initialize=6]="Initialize",_[_.ChangeCellMetadata=7]="ChangeCellMetadata",_[_.Output=8]="Output",_[_.OutputItem=9]="OutputItem",_[_.ChangeCellContent=10]="ChangeCellContent",_[_.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",_[_.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",_[_.ChangeCellMime=13]="ChangeCellMime",_[_.Unknown=100]="Unknown"})(f||(e.NotebookCellsChangeType=f={}));var h;(function(_){_[_.Handle=0]="Handle",_[_.Index=1]="Index"})(h||(e.SelectionStateType=h={}));var p;(function(_){_[_.Replace=1]="Replace",_[_.Output=2]="Output",_[_.Metadata=3]="Metadata",_[_.CellLanguage=4]="CellLanguage",_[_.DocumentMetadata=5]="DocumentMetadata",_[_.Move=6]="Move",_[_.OutputItems=7]="OutputItems",_[_.PartialMetadata=8]="PartialMetadata",_[_.PartialInternalMetadata=9]="PartialInternalMetadata"})(p||(e.CellEditType=p={}));var l;(function(_){_.scheme=P.Schemas.vscodeNotebookCell;const de=["W","X","Y","Z","a","b","c","d","e","f"],Z=new RegExp(`^[${de.join("")}]+`),ne=7;function J(B,K){const N=K.toString(ne),U=`${N.length<de.length?de[N.length-1]:"z"}${N}s${(0,D.$we)(D.$ce.fromString(B.scheme),!0,!0)}`;return B.with({scheme:_.scheme,fragment:U})}_.generate=J;function W(B){if(B.scheme!==_.scheme)return;const K=B.fragment.indexOf("s");if(K<0)return;const N=parseInt(B.fragment.substring(0,K).replace(Z,""),ne),O=(0,D.$ve)(B.fragment.substring(K+1)).toString();if(!isNaN(N))return{handle:N,notebook:B.with({scheme:O,fragment:null})}}_.parse=W;function oe(B,K){return B.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`op${K??""},${B.scheme!==P.Schemas.file?B.scheme:""}`})}_.generateCellOutputUri=oe;function le(B){if(B.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const K=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(B.fragment);if(!K)return;const N=K[1]&&K[1]!==""?K[1]:void 0,O=K[2];return{outputId:N,notebook:B.with({scheme:O||P.Schemas.file,fragment:null})}}_.parseCellOutputUri=le;function re(B,K,N){return _.generate(B,K).with({scheme:N})}_.generateCellPropertyUri=re;function ee(B,K){if(B.scheme===K)return _.parse(B.with({scheme:_.scheme}))}_.parseCellPropertyUri=ee})(l||(e.CellUri=l={}));const m=_=>v.$j?_.replace(/\//g,"\\"):_;class c{constructor(de=[],Z=e.$mI){this.e=Z,this.d=[...new Set(de)].map(ne=>({pattern:ne,matches:R.$xj(m(ne))}))}sort(de){const Z=new Map(r.Iterable.map(de,J=>[J,m(J)]));let ne=[];for(const{matches:J}of this.d)for(const[W,oe]of Z)if(J(oe)){ne.push(W),Z.delete(W);break}return Z.size&&(ne=ne.concat([...Z.keys()].sort((J,W)=>this.e.indexOf(J)-this.e.indexOf(W)))),ne}prioritize(de,Z){const ne=this.f(de);if(ne===-1){this.d.unshift({pattern:de,matches:R.$xj(m(de))});return}const J=new Set(Z.map(oe=>this.f(oe,ne)));J.delete(-1);const W=Array.from(J).sort();this.d.splice(ne+1,0,...W.map(oe=>this.d[oe]));for(let oe=W.length-1;oe>=0;oe--)this.d.splice(W[oe],1)}toArray(){return this.d.map(de=>de.pattern)}f(de,Z=this.d.length){const ne=m(de);for(let J=0;J<Z;J++)if(this.d[J].matches(ne))return J;return-1}}e.$qI=c;function n(_,de,Z,ne=(J,W)=>J===W){const J=[];function W(re,ee,B){if(ee===0&&B.length===0)return;const K=J[J.length-1];K&&K.start+K.deleteCount===re?(K.deleteCount+=ee,K.toInsert.push(...B)):J.push({start:re,deleteCount:ee,toInsert:B})}let oe=0,le=0;for(;;){if(oe===_.length){W(oe,0,de.slice(le));break}if(le===de.length){W(oe,_.length-oe,[]);break}const re=_[oe],ee=de[le];if(ne(re,ee)){oe+=1,le+=1;continue}Z(ee)?(W(oe,1,[]),oe+=1):(W(oe,0,[ee]),le+=1)}return J}e.$rI=n,e.$sI=new b.$8i("notebookEditorCursorAtBoundary","none"),e.$tI=new b.$8i("notebookEditorCursorAtLineBoundary","none");var i;(function(_){_.default="default",_.option="option"})(i||(e.NotebookEditorPriority=i={}));function o(_){const de=_;return!!((typeof de.include=="string"||R.$yj(de.include))&&(typeof de.exclude=="string"||R.$yj(de.exclude)))}e.$uI=o;function s(_,de,Z){if(Array.isArray(_.viewType)&&_.viewType.indexOf(de)>=0||_.viewType===de)return!0;if(_.filenamePattern){const ne=o(_.filenamePattern)?_.filenamePattern.include:_.filenamePattern,J=o(_.filenamePattern)?_.filenamePattern.exclude:void 0;if(R.$wj(ne,(0,C.$nc)(Z.fsPath).toLowerCase()))return!(J&&R.$wj(J,(0,C.$nc)(Z.fsPath).toLowerCase()))}return!1}e.$vI=s,e.$wI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var t;(function(_){_[_.Left=1]="Left",_[_.Right=2]="Right"})(t||(e.CellStatusbarAlignment=t={}));class a{static{this.d="notebook/"}static create(de){return`${a.d}${de}`}static parse(de){if(de.startsWith(a.d))return de.substring(a.d.length)}}e.$xI=a;function $(_){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(_)}e.$yI=$;const w=new TextDecoder;function k(_){const de=[];let Z=!1;for(const oe of _)(de.length===0||Z)&&(de.push(oe),Z=!0);let ne=j(de);const J=D.$ce.concat(de.map(oe=>D.$ce.wrap(oe))),W=he(J);return ne=ne||W.byteLength!==J.byteLength,{data:W,didCompression:ne}}e.$zI=k,e.$AI=`${String.fromCharCode(27)}[A`;const E=e.$AI.split("").map(_=>_.charCodeAt(0)),L=10;function j(_){let de=!1;return _.forEach((Z,ne)=>{if(ne===0||Z.length<e.$AI.length)return;const J=_[ne-1],W=Z.subarray(0,e.$AI.length);if(W[0]===E[0]&&W[1]===E[1]&&W[2]===E[2]){const oe=J.lastIndexOf(L);if(oe===-1)return;de=!0,_[ne-1]=J.subarray(0,oe),_[ne]=Z.subarray(e.$AI.length)}}),de}function x(_){let de=_;do _=de,de=_.replace(/[^\n]\x08/gm,"");while(de.length<_.length);return _}function ce(_){for(_=_.replace(/\r+\n/gm,`
`);_.search(/\r[^$]/g)>-1;){const de=_.match(/^(.*)\r+/m)[1];let Z=_.match(/\r+(.*)$/m)[1];Z=Z+de.slice(Z.length,de.length),_=_.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Z)}return _}const X="\b".charCodeAt(0),ie="\r".charCodeAt(0);function he(_){return!_.buffer.includes(X)&&!_.buffer.includes(ie)?_:D.$ce.fromString(ce(x(w.decode(_.buffer))))}}),define(pe[131],be([1,0,18,11,100,26,63,17,10,4,23,35,16,117,130]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u,g){"use strict";var d,f,h,p,l,m,c,n,i,o,s,t,a,$,w,k,E,L;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$fM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.TestRunProfileKind=e.TestResultState=e.$YL=e.$XL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$WL=e.$VL=e.$UL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$TL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.ColorThemeKind=e.$NL=e.$ML=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$LL=e.DebugConsoleMode=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$FL=e.$EL=e.FileChangeType=e.$DL=e.$CL=e.$BL=e.$AL=e.InlineCompletionTriggerKind=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.ConfigurationTarget=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$dL=e.ViewBadge=e.ProgressLocation=e.$cL=e.$bL=e.TaskScope=e.ShellQuoting=e.$aL=e.$_K=e.$$K=e.TaskPanelKind=e.TaskRevealKind=e.$0K=e.TerminalLocation=e.$9K=e.$8K=e.$7K=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$6K=e.$5K=e.$4K=e.$3K=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$2K=e.StatusBarAlignment=e.ViewColumn=e.$1K=e.$ZK=e.$YK=e.$XK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$WK=e.$VK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.LanguageStatusSeverity=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.CodeActionTriggerKind=e.$JK=e.$IK=e.SymbolTag=e.SymbolKind=e.$HK=e.DocumentHighlightKind=e.$GK=e.$FK=e.$EK=e.$DK=e.DiagnosticSeverity=e.DiagnosticTag=e.$CK=e.$BK=e.FileEditType=e.$AK=e.$zK=e.$yK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function j(M){return Object.assign(M,{apply:function(...ae){if(ae.length===0)return Reflect.construct(M,[]);{const we=ae.length===1?[]:ae[1];return Reflect.construct(M,we,ae[0].constructor)}},call:function(...ae){if(ae.length===0)return Reflect.construct(M,[]);{const[we,...je]=ae;return Reflect.construct(M,je,we.constructor)}}})}var x;(function(M){M[M.Top=0]="Top",M[M.Bottom=1]="Bottom"})(x||(e.TerminalOutputAnchor=x={}));var ce;(function(M){M[M.TerminalCommand=0]="TerminalCommand",M[M.Opener=1]="Opener",M[M.Command=3]="Command"})(ce||(e.TerminalQuickFixType=ce={}));let X=d=class{static from(...F){let ae=F;return new d(function(){if(ae){for(const we of ae)we&&typeof we.dispose=="function"&&we.dispose();ae=void 0}})}#e;constructor(F){this.#e=F}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$rK=X,e.$rK=X=d=Oe([j],X);let ie=f=class{static Min(...F){if(F.length===0)throw new TypeError;let ae=F[0];for(let we=1;we<F.length;we++){const je=F[we];je.isBefore(ae)&&(ae=je)}return ae}static Max(...F){if(F.length===0)throw new TypeError;let ae=F[0];for(let we=1;we<F.length;we++){const je=F[we];je.isAfter(ae)&&(ae=je)}return ae}static isPosition(F){if(!F)return!1;if(F instanceof f)return!0;const{line:ae,character:we}=F;return typeof ae=="number"&&typeof we=="number"}static of(F){if(F instanceof f)return F;if(this.isPosition(F))return new f(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,ae){if(F<0)throw(0,R.$7)("line must be non-negative");if(ae<0)throw(0,R.$7)("character must be non-negative");this.c=F,this.e=ae}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,ae=0){if(F===null||ae===null)throw(0,R.$7)();let we;return typeof F>"u"?we=0:typeof F=="number"?we=F:(we=typeof F.lineDelta=="number"?F.lineDelta:0,ae=typeof F.characterDelta=="number"?F.characterDelta:0),we===0&&ae===0?this:new f(this.line+we,this.character+ae)}with(F,ae=this.character){if(F===null||ae===null)throw(0,R.$7)();let we;return typeof F>"u"?we=this.line:typeof F=="number"?we=F:(we=typeof F.line=="number"?F.line:this.line,ae=typeof F.character=="number"?F.character:this.character),we===this.line&&ae===this.character?this:new f(we,ae)}toJSON(){return{line:this.line,character:this.character}}};e.$sK=ie,e.$sK=ie=f=Oe([j],ie);let he=h=class{static isRange(F){return F instanceof h?!0:F?ie.isPosition(F.start)&&ie.isPosition(F.end):!1}static of(F){if(F instanceof h)return F;if(this.isRange(F))return new h(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,ae,we,je){let Ke,et;if(typeof F=="number"&&typeof ae=="number"&&typeof we=="number"&&typeof je=="number"?(Ke=new ie(F,ae),et=new ie(we,je)):ie.isPosition(F)&&ie.isPosition(ae)&&(Ke=ie.of(F),et=ie.of(ae)),!Ke||!et)throw new Error("Invalid arguments");Ke.isBefore(et)?(this.c=Ke,this.e=et):(this.c=et,this.e=Ke)}contains(F){return h.isRange(F)?this.contains(F.start)&&this.contains(F.end):ie.isPosition(F)?!(ie.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const ae=ie.Max(F.start,this.c),we=ie.Min(F.end,this.e);if(!ae.isAfter(we))return new h(ae,we)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const ae=ie.Min(F.start,this.c),we=ie.Max(F.end,this.end);return new h(ae,we)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,ae=this.end){if(F===null||ae===null)throw(0,R.$7)();let we;return F?ie.isPosition(F)?we=F:(we=F.start||this.start,ae=F.end||this.end):we=this.start,we.isEqual(this.c)&&ae.isEqual(this.end)?this:new h(we,ae)}toJSON(){return[this.start,this.end]}};e.$tK=he,e.$tK=he=h=Oe([j],he);let _=p=class extends he{static isSelection(F){return F instanceof p?!0:F?he.isRange(F)&&ie.isPosition(F.anchor)&&ie.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,ae,we,je){let Ke,et;if(typeof F=="number"&&typeof ae=="number"&&typeof we=="number"&&typeof je=="number"?(Ke=new ie(F,ae),et=new ie(we,je)):ie.isPosition(F)&&ie.isPosition(ae)&&(Ke=ie.of(F),et=ie.of(ae)),!Ke||!et)throw new Error("Invalid arguments");super(Ke,et),this.f=Ke,this.g=et}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$uK=_,e.$uK=_=p=Oe([j],_);const de=M=>{if(typeof M!="string"||M.length===0||!/^[0-9A-Za-z_\-]+$/.test(M))throw(0,R.$7)("connectionToken")};class Z{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,ae,we){if(typeof F!="string"||F.length===0)throw(0,R.$7)("host");if(typeof ae!="number"||ae===0||Math.round(ae)!==ae)throw(0,R.$7)("port");typeof we<"u"&&de(we),this.host=F,this.port=Math.round(ae),this.connectionToken=we}}e.$vK=Z;class ne{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,ae){this.makeConnection=F,this.connectionToken=ae,typeof ae<"u"&&de(ae)}}e.$wK=ne;class J extends Error{static NotAvailable(F,ae){return new J(F,u.RemoteAuthorityResolverErrorCode.NotAvailable,ae)}static TemporarilyNotAvailable(F){return new J(F,u.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,ae=u.RemoteAuthorityResolverErrorCode.Unknown,we){super(F),this._message=F,this._code=ae,this._detail=we,Object.setPrototypeOf(this,J.prototype)}}e.$xK=J;var W;(function(M){M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(W||(e.EndOfLine=W={}));var oe;(function(M){M[M.Replace=1]="Replace",M[M.Append=2]="Append",M[M.Prepend=3]="Prepend"})(oe||(e.EnvironmentVariableMutatorType=oe={}));let le=l=class{static isTextEdit(F){return F instanceof l?!0:F?he.isRange(F)&&typeof F.newText=="string":!1}static replace(F,ae){return new l(F,ae)}static insert(F,ae){return l.replace(new he(F,F),ae)}static delete(F){return l.replace(F,"")}static setEndOfLine(F){const ae=new l(new he(new ie(0,0),new ie(0,0)),"");return ae.newEol=F,ae}get range(){return this.c}set range(F){if(F&&!he.isRange(F))throw(0,R.$7)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,R.$7)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,R.$7)("newEol");this.f=F}constructor(F,ae){this.c=F,this.e=ae}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$yK=le,e.$yK=le=l=Oe([j],le);let re=m=class{static isNotebookCellEdit(F){return F instanceof m?!0:F?Mt.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,ae){return new m(F,ae)}static insertCells(F,ae){return new m(new Mt(F,F),ae)}static deleteCells(F){return new m(F,[])}static updateCellMetadata(F,ae){const we=new m(new Mt(F,F),[]);return we.newCellMetadata=ae,we}static updateNotebookMetadata(F){const ae=new m(new Mt(0,0),[]);return ae.newNotebookMetadata=F,ae}constructor(F,ae){this.range=F,this.newCells=ae}};e.$zK=re,e.$zK=re=m=Oe([j],re);class ee{static isSnippetTextEdit(F){return F instanceof ee?!0:F?he.isRange(F.range)&&N.isSnippetString(F.snippet):!1}static replace(F,ae){return new ee(F,ae)}static insert(F,ae){return ee.replace(new he(F,F),ae)}constructor(F,ae){this.range=F,this.snippet=ae}}e.$AK=ee;var B;(function(M){M[M.File=1]="File",M[M.Text=2]="Text",M[M.Cell=3]="Cell",M[M.CellReplace=5]="CellReplace",M[M.Snippet=6]="Snippet"})(B||(e.FileEditType=B={}));let K=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,ae,we,je){this.c.push({_type:1,from:F,to:ae,options:we,metadata:je})}createFile(F,ae,we){this.c.push({_type:1,from:void 0,to:F,options:ae,metadata:we})}deleteFile(F,ae,we){this.c.push({_type:1,from:F,to:void 0,options:ae,metadata:we})}e(F,ae,we){this.c.push({_type:3,metadata:we,uri:F,edit:{editType:5,metadata:ae},notebookMetadata:ae})}f(F,ae,we,je){const Ke=ae.start,et=ae.end;(Ke!==et||we.length>0)&&this.c.push({_type:5,uri:F,index:Ke,count:et-Ke,cells:we,metadata:je})}g(F,ae,we,je){this.c.push({_type:3,metadata:je,uri:F,edit:{editType:3,index:ae,metadata:we}})}replace(F,ae,we,je){this.c.push({_type:2,uri:F,edit:new le(ae,we),metadata:je})}insert(F,ae,we,je){this.replace(F,new he(ae,ae),we,je)}delete(F,ae,we){this.replace(F,ae,"",we)}has(F){return this.c.some(ae=>ae._type===2&&ae.uri.toString()===F.toString())}set(F,ae){if(ae)for(const we of ae){if(!we)continue;let je,Ke;Array.isArray(we)?(je=we[0],Ke=we[1]):je=we,re.isNotebookCellEdit(je)?je.newCellMetadata?this.g(F,je.range.start,je.newCellMetadata,Ke):je.newNotebookMetadata?this.e(F,je.newNotebookMetadata,Ke):this.f(F,je.range,je.newCells,Ke):ee.isSnippetTextEdit(je)?this.c.push({_type:6,uri:F,range:je.range,edit:je.snippet,metadata:Ke}):this.c.push({_type:2,uri:F,edit:je,metadata:Ke})}else{for(let we=0;we<this.c.length;we++){const je=this.c[we];switch(je._type){case 2:case 6:case 3:case 5:je.uri.toString()===F.toString()&&(this.c[we]=void 0);break}}(0,D.$Ib)(this.c)}}get(F){const ae=[];for(const we of this.c)we._type===2&&we.uri.toString()===F.toString()&&ae.push(we.edit);return ae}entries(){const F=new I.$Ac;for(const ae of this.c)if(ae._type===2){let we=F.get(ae.uri);we||(we=[ae.uri,[]],F.set(ae.uri,we)),we[1].push(ae.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$BK=K,e.$BK=K=Oe([j],K);let N=c=class{static isSnippetString(F){return F instanceof c?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=c.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,ae=this.e++){if(typeof F=="function"){const we=new c;we.e=this.e,F(we),this.e=we.e,F=we.value}else F=c.c(F);return this.value+="${",this.value+=ae,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,ae=this.e++){const we=F.map(je=>je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ae,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(F,ae){if(typeof ae=="function"){const we=new c;we.e=this.e,ae(we),this.e=we.e,ae=we.value}else typeof ae=="string"&&(ae=ae.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,ae&&(this.value+=":",this.value+=ae),this.value+="}",this}};e.$CK=N,e.$CK=N=c=Oe([j],N);var O;(function(M){M[M.Unnecessary=1]="Unnecessary",M[M.Deprecated=2]="Deprecated"})(O||(e.DiagnosticTag=O={}));var U;(function(M){M[M.Hint=3]="Hint",M[M.Information=2]="Information",M[M.Warning=1]="Warning",M[M.Error=0]="Error"})(U||(e.DiagnosticSeverity=U={}));let T=n=class{static isLocation(F){return F instanceof n?!0:F?he.isRange(F.range)&&b.URI.isUri(F.uri):!1}constructor(F,ae){if(this.uri=F,ae)if(he.isRange(ae))this.range=he.of(ae);else if(ie.isPosition(ae))this.range=new he(ae,ae);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$DK=T,e.$DK=T=n=Oe([j],T);let q=class{static is(F){return F?typeof F.message=="string"&&F.location&&he.isRange(F.location.range)&&b.URI.isUri(F.location.uri):!1}constructor(F,ae){this.location=F,this.message=ae}static isEqual(F,ae){return F===ae?!0:!F||!ae?!1:F.message===ae.message&&F.location.range.isEqual(ae.location.range)&&F.location.uri.toString()===ae.location.uri.toString()}};e.$EK=q,e.$EK=q=Oe([j],q);let z=class{constructor(F,ae,we=U.Error){if(!he.isRange(F))throw new TypeError("range must be set");if(!ae)throw new TypeError("message must be set");this.range=F,this.message=ae,this.severity=we}toJSON(){return{severity:U[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,ae){return F===ae?!0:!F||!ae?!1:F.message===ae.message&&F.severity===ae.severity&&F.code===ae.code&&F.severity===ae.severity&&F.source===ae.source&&F.range.isEqual(ae.range)&&(0,D.$ub)(F.tags,ae.tags)&&(0,D.$ub)(F.relatedInformation,ae.relatedInformation,q.isEqual)}};e.$FK=z,e.$FK=z=Oe([j],z);let te=class{constructor(F,ae){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=ae}};e.$GK=te,e.$GK=te=Oe([j],te);var H;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(H||(e.DocumentHighlightKind=H={}));let Y=class{constructor(F,ae=H.Text){this.range=F,this.kind=ae}toJSON(){return{range:this.range,kind:H[this.kind]}}};e.$HK=Y,e.$HK=Y=Oe([j],Y);var V;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(V||(e.SymbolKind=V={}));var Q;(function(M){M[M.Deprecated=1]="Deprecated"})(Q||(e.SymbolTag=Q={}));let se=i=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,ae,we,je,Ke){this.name=F,this.kind=ae,this.containerName=Ke,typeof we=="string"&&(this.containerName=we),je instanceof T?this.location=je:we instanceof he&&(this.location=new T(je,we)),i.validate(this)}toJSON(){return{name:this.name,kind:V[this.kind],location:this.location,containerName:this.containerName}}};e.$IK=se,e.$IK=se=i=Oe([j],se);let me=o=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(o.validate)}constructor(F,ae,we,je,Ke){this.name=F,this.detail=ae,this.kind=we,this.range=je,this.selectionRange=Ke,this.children=[],o.validate(this)}};e.$JK=me,e.$JK=me=o=Oe([j],me);var Ee;(function(M){M[M.Invoke=1]="Invoke",M[M.Automatic=2]="Automatic"})(Ee||(e.CodeActionTriggerKind=Ee={}));let Ce=class{constructor(F,ae){this.title=F,this.kind=ae}};e.$KK=Ce,e.$KK=Ce=Oe([j],Ce);let Le=class{static{s=this}static{this.c="."}constructor(F){this.value=F}append(F){return new s(this.value?this.value+s.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+s.c)}};e.$LK=Le,e.$LK=Le=s=Oe([j],Le),Le.Empty=new Le(""),Le.QuickFix=Le.Empty.append("quickfix"),Le.Refactor=Le.Empty.append("refactor"),Le.RefactorExtract=Le.Refactor.append("extract"),Le.RefactorInline=Le.Refactor.append("inline"),Le.RefactorMove=Le.Refactor.append("move"),Le.RefactorRewrite=Le.Refactor.append("rewrite"),Le.Source=Le.Empty.append("source"),Le.SourceOrganizeImports=Le.Source.append("organizeImports"),Le.SourceFixAll=Le.Source.append("fixAll"),Le.Notebook=Le.Empty.append("notebook");let Fe=class{constructor(F,ae){if(this.range=F,this.parent=ae,ae&&!ae.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$MK=Fe,e.$MK=Fe=Oe([j],Fe);class $e{constructor(F,ae,we,je,Ke,et){this.kind=F,this.name=ae,this.detail=we,this.uri=je,this.range=Ke,this.selectionRange=et}}e.$NK=$e;class ke{constructor(F,ae){this.fromRanges=ae,this.from=F}}e.$OK=ke;class ye{constructor(F,ae){this.fromRanges=ae,this.to=F}}e.$PK=ye;var Me;(function(M){M[M.Information=0]="Information",M[M.Warning=1]="Warning",M[M.Error=2]="Error"})(Me||(e.LanguageStatusSeverity=Me={}));let Ue=class{constructor(F,ae){this.range=F,this.command=ae}get isResolved(){return!!this.command}};e.$QK=Ue,e.$QK=Ue=Oe([j],Ue);let Ze=t=class{#e;static isMarkdownString(F){return F instanceof t?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,ae=!1){this.#e=new r.$4j(F,{supportThemeIcons:ae})}get value(){return this.#e.value}set value(F){this.#e.value=F}get isTrusted(){return this.#e.isTrusted}set isTrusted(F){this.#e.isTrusted=F}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(F){this.#e.supportThemeIcons=F}get supportHtml(){return this.#e.supportHtml}set supportHtml(F){this.#e.supportHtml=F}get baseUri(){return this.#e.baseUri}set baseUri(F){this.#e.baseUri=F}appendText(F){return this.#e.appendText(F),this}appendMarkdown(F){return this.#e.appendMarkdown(F),this}appendCodeblock(F,ae){return this.#e.appendCodeblock(ae??"",F),this}};e.$RK=Ze,e.$RK=Ze=t=Oe([j],Ze);let We=class{constructor(F,ae){this.label=F,this.documentation=ae}};e.$SK=We,e.$SK=We=Oe([j],We);let Xe=class{constructor(F,ae){this.label=F,this.documentation=ae,this.parameters=[]}};e.$TK=Xe,e.$TK=Xe=Oe([j],Xe);let Qe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$UK=Qe,e.$UK=Qe=Oe([j],Qe);var ge;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(ge||(e.SignatureHelpTriggerKind=ge={}));var Pe;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(Pe||(e.InlayHintKind=Pe={}));let Ie=class{constructor(F){this.value=F}};e.$VK=Ie,e.$VK=Ie=Oe([j],Ie);let Ne=class{constructor(F,ae,we){this.position=F,this.label=ae,this.kind=we}};e.$WK=Ne,e.$WK=Ne=Oe([j],Ne);var ze;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze||(e.CompletionTriggerKind=ze={}));var He;(function(M){M[M.Text=0]="Text",M[M.Method=1]="Method",M[M.Function=2]="Function",M[M.Constructor=3]="Constructor",M[M.Field=4]="Field",M[M.Variable=5]="Variable",M[M.Class=6]="Class",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Unit=10]="Unit",M[M.Value=11]="Value",M[M.Enum=12]="Enum",M[M.Keyword=13]="Keyword",M[M.Snippet=14]="Snippet",M[M.Color=15]="Color",M[M.File=16]="File",M[M.Reference=17]="Reference",M[M.Folder=18]="Folder",M[M.EnumMember=19]="EnumMember",M[M.Constant=20]="Constant",M[M.Struct=21]="Struct",M[M.Event=22]="Event",M[M.Operator=23]="Operator",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue"})(He||(e.CompletionItemKind=He={}));var Be;(function(M){M[M.Deprecated=1]="Deprecated"})(Be||(e.CompletionItemTag=Be={}));let Ve=class{constructor(F,ae){this.label=F,this.kind=ae}toJSON(){return{label:this.label,kind:this.kind&&He[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$XK=Ve,e.$XK=Ve=Oe([j],Ve);let Je=class{constructor(F=[],ae=!1){this.items=F,this.isIncomplete=ae}};e.$YK=Je,e.$YK=Je=Oe([j],Je);let Ge=class{constructor(F,ae,we){this.insertText=F,this.range=ae,this.command=we}};e.$ZK=Ge,e.$ZK=Ge=Oe([j],Ge);let Ye=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$1K=Ye,e.$1K=Ye=Oe([j],Ye);var it;(function(M){M[M.Active=-1]="Active",M[M.Beside=-2]="Beside",M[M.One=1]="One",M[M.Two=2]="Two",M[M.Three=3]="Three",M[M.Four=4]="Four",M[M.Five=5]="Five",M[M.Six=6]="Six",M[M.Seven=7]="Seven",M[M.Eight=8]="Eight",M[M.Nine=9]="Nine"})(it||(e.ViewColumn=it={}));var _e;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(_e||(e.StatusBarAlignment=_e={}));function st(M,F){return`${S.$7l.toKey(M)}.${F}`}e.$2K=st;var ot;(function(M){M[M.Off=0]="Off",M[M.On=1]="On",M[M.Relative=2]="Relative"})(ot||(e.TextEditorLineNumbersStyle=ot={}));var vt;(function(M){M[M.Manual=1]="Manual",M[M.AfterDelay=2]="AfterDelay",M[M.FocusOut=3]="FocusOut"})(vt||(e.TextDocumentSaveReason=vt={}));var dt;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(dt||(e.TextEditorRevealType=dt={}));var ft;(function(M){M[M.Keyboard=1]="Keyboard",M[M.Mouse=2]="Mouse",M[M.Command=3]="Command"})(ft||(e.TextEditorSelectionChangeKind=ft={}));var Tt;(function(M){M[M.Undo=1]="Undo",M[M.Redo=2]="Redo"})(Tt||(e.TextDocumentChangeReason=Tt={}));var Ut;(function(M){M[M.OpenOpen=0]="OpenOpen",M[M.ClosedClosed=1]="ClosedClosed",M[M.OpenClosed=2]="OpenClosed",M[M.ClosedOpen=3]="ClosedOpen"})(Ut||(e.DecorationRangeBehavior=Ut={})),function(M){function F(ae){switch(ae){case"keyboard":return M.Keyboard;case"mouse":return M.Mouse;case"api":return M.Command}}M.fromValue=F}(ft||(e.TextEditorSelectionChangeKind=ft={}));var yt;(function(M){M[M.Other=0]="Other",M[M.Comment=1]="Comment",M[M.String=2]="String",M[M.RegEx=3]="RegEx"})(yt||(e.SyntaxTokenType=yt={})),function(M){function F(ae){switch(ae){case M.Other:return"other";case M.Comment:return"comment";case M.String:return"string";case M.RegEx:return"regex"}return"other"}M.toString=F}(yt||(e.SyntaxTokenType=yt={}));let Et=class{constructor(F,ae){if(ae&&!b.URI.isUri(ae))throw(0,R.$7)("target");if(!he.isRange(F)||F.isEmpty)throw(0,R.$7)("range");this.range=F,this.target=ae}};e.$3K=Et,e.$3K=Et=Oe([j],Et);let ct=class{constructor(F,ae,we,je){this.red=F,this.green=ae,this.blue=we,this.alpha=je}};e.$4K=ct,e.$4K=ct=Oe([j],ct);let kt=class{constructor(F,ae){if(ae&&!(ae instanceof ct))throw(0,R.$7)("color");if(!he.isRange(F)||F.isEmpty)throw(0,R.$7)("range");this.range=F,this.color=ae}};e.$5K=kt,e.$5K=kt=Oe([j],kt);let Ot=class{constructor(F){if(!F||typeof F!="string")throw(0,R.$7)("label");this.label=F}};e.$6K=Ot,e.$6K=Ot=Oe([j],Ot);var mt;(function(M){M[M.RGB=0]="RGB",M[M.HEX=1]="HEX",M[M.HSL=2]="HSL"})(mt||(e.ColorFormat=mt={}));var zt;(function(M){M[M.Error=0]="Error",M[M.Warning=1]="Warning",M[M.Information=2]="Information"})(zt||(e.SourceControlInputBoxValidationType=zt={}));var Ft;(function(M){M[M.Unknown=0]="Unknown",M[M.Shutdown=1]="Shutdown",M[M.Process=2]="Process",M[M.User=3]="User",M[M.Extension=4]="Extension"})(Ft||(e.TerminalExitReason=Ft={}));class nt{constructor(F,ae,we){if(this.startIndex=F,this.length=ae,this.tooltip=we,typeof F!="number"||F<0)throw(0,R.$7)("startIndex");if(typeof ae!="number"||ae<1)throw(0,R.$7)("length");if(we!==void 0&&typeof we!="string")throw(0,R.$7)("tooltip")}}e.$7K=nt;class lt{constructor(F){this.uri=F}}e.$8K=lt;class gt{constructor(F){this.terminalCommand=F}}e.$9K=gt;var jt;(function(M){M[M.Panel=1]="Panel",M[M.Editor=2]="Editor"})(jt||(e.TerminalLocation=jt={}));class qt{constructor(F){if(this.options=F,typeof F!="object")throw(0,R.$7)("options")}}e.$0K=qt;var Bt;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(Bt||(e.TaskRevealKind=Bt={}));var Ct;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(Ct||(e.TaskPanelKind=Ct={}));let It=class{static{a=this}static{this.Clean=new a("clean","Clean")}static{this.Build=new a("build","Build")}static{this.Rebuild=new a("rebuild","Rebuild")}static{this.Test=new a("test","Test")}static from(F){switch(F){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}constructor(F,ae){if(this.label=ae,typeof F!="string"||typeof ae!="string")throw(0,R.$7)("name");this.c=F}get id(){return this.c}};e.$$K=It,e.$$K=It=a=Oe([j],It);function At(M){let F="";for(let ae=0;ae<M.length;ae++)F+=M[ae].replace(/,/g,",,")+",";return F}let Lt=class{constructor(F,ae,we){if(typeof F!="string")throw(0,R.$7)("process");this.e=[],this.c=F,ae!==void 0&&(Array.isArray(ae)?(this.e=ae,this.f=we):this.f=ae)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,R.$7)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const ae of this.e)F.push(ae);return At(F)}};e.$_K=Lt,e.$_K=Lt=Oe([j],Lt);let pt=class{constructor(F,ae,we){if(this.f=[],Array.isArray(ae)){if(!F)throw(0,R.$7)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,R.$7)("command");this.e=F,this.f=ae,this.g=we}else{if(typeof F!="string")throw(0,R.$7)("commandLine");this.c=F,this.g=ae}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,R.$7)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,R.$7)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ae of this.f)F.push(typeof ae=="string"?ae:ae.value);return At(F)}};e.$aL=pt,e.$aL=pt=Oe([j],pt);var Wt;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(Wt||(e.ShellQuoting=Wt={}));var ve;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace"})(ve||(e.TaskScope=ve={}));class De{constructor(F){this.c=F}computeId(){return"customExecution"+(0,A.$fg)()}set callback(F){this.c=F}get callback(){return this.c}}e.$bL=De;let fe=class{static{$=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(F,ae,we,je,Ke,et){this.j=!1,this.k=this.definition=F;let tt;typeof ae=="string"?(this.m=this.name=ae,this.t=this.source=we,this.execution=je,tt=Ke,this.j=!0):ae===ve.Global||ae===ve.Workspace?(this.target=ae,this.m=this.name=we,this.t=this.source=je,this.execution=Ke,tt=et):(this.target=ae,this.m=this.name=we,this.t=this.source=je,this.execution=Ke,tt=et),typeof tt=="string"?(this.o=[tt],this.q=!0):Array.isArray(tt)?(this.o=tt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(F){this.h=F}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Lt?this.k={type:$.e,id:this.n.computeId()}:this.n instanceof pt?this.k={type:$.f,id:this.n.computeId()}:this.n instanceof De?this.k={type:$.c,id:this.n.computeId()}:this.k={type:$.g,id:(0,A.$fg)()}}get definition(){return this.k}set definition(F){if(F==null)throw(0,R.$7)("Kind can't be undefined or null");this.z(),this.k=F}get scope(){return this.l}set target(F){this.z(),this.l=F}get name(){return this.m}set name(F){if(typeof F!="string")throw(0,R.$7)("name");this.z(),this.m=F}get execution(){return this.n}set execution(F){F===null&&(F=void 0),this.z(),this.n=F;const ae=this.k.type;($.g===ae||$.e===ae||$.f===ae||$.c===ae)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(F){if(Array.isArray(F))this.z(),this.o=F,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.z(),this.r=F}get source(){return this.t}set source(F){if(typeof F!="string"||F.length===0)throw(0,R.$7)("source must be a string of length > 0");this.z(),this.t=F}get group(){return this.u}set group(F){F===null&&(F=void 0),this.z(),this.u=F}get detail(){return this.y}set detail(F){F===null&&(F=void 0),this.y=F}get presentationOptions(){return this.w}set presentationOptions(F){F==null&&(F=Object.create(null)),this.z(),this.w=F}get runOptions(){return this.x}set runOptions(F){F==null&&(F=Object.create(null)),this.z(),this.x=F}};e.$cL=fe,e.$cL=fe=$=Oe([j],fe);var G;(function(M){M[M.SourceControl=1]="SourceControl",M[M.Window=10]="Window",M[M.Notification=15]="Notification"})(G||(e.ProgressLocation=G={}));var Se;(function(M){function F(ae){const we=ae;return(0,v.$Df)(we.value)?we.tooltip&&!(0,v.$zf)(we.tooltip)?(console.log("INVALID view badge, invalid tooltip",we.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",we.value),!1)}M.isViewBadge=F})(Se||(e.ViewBadge=Se={}));let Re=w=class{static isTreeItem(F,ae){const we=F;if(we.checkboxState!==void 0){const je=(0,v.$Df)(we.checkboxState)?we.checkboxState:(0,v.$Bf)(we.checkboxState)&&(0,v.$Df)(we.checkboxState.state)?we.checkboxState.state:void 0,Ke=!(0,v.$Df)(we.checkboxState)&&(0,v.$Bf)(we.checkboxState)?we.checkboxState.tooltip:void 0;if(je===void 0||je!==Te.Checked&&je!==Te.Unchecked||Ke!==void 0&&!(0,v.$zf)(Ke))return console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1}if(F instanceof w)return!0;if(we.label!==void 0&&!(0,v.$zf)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,v.$zf)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,v.$zf)(we.iconPath)&&!b.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,v.$zf)(we.iconPath.id))){const je=we.iconPath;if(!je||!(0,v.$zf)(je.light)&&!b.URI.isUri(je.light)&&!(0,v.$zf)(je.dark)&&!b.URI.isUri(je.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}return we.description!==void 0&&!(0,v.$zf)(we.description)&&typeof we.description!="boolean"?(console.log("INVALID tree item, invalid description",we.description),!1):we.resourceUri!==void 0&&!b.URI.isUri(we.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1):we.tooltip!==void 0&&!(0,v.$zf)(we.tooltip)&&!(we.tooltip instanceof Ze)?(console.log("INVALID tree item, invalid tooltip",we.tooltip),!1):we.command!==void 0&&!we.command.command?(console.log("INVALID tree item, invalid command",we.command),!1):we.collapsibleState!==void 0&&we.collapsibleState<qe.None&&we.collapsibleState>qe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1):we.contextValue!==void 0&&!(0,v.$zf)(we.contextValue)?(console.log("INVALID tree item, invalid contextValue",we.contextValue),!1):we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1):!0}constructor(F,ae=qe.None){this.collapsibleState=ae,b.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$dL=Re,e.$dL=Re=w=Oe([j],Re);var qe;(function(M){M[M.None=0]="None",M[M.Collapsed=1]="Collapsed",M[M.Expanded=2]="Expanded"})(qe||(e.TreeItemCollapsibleState=qe={}));var Te;(function(M){M[M.Unchecked=0]="Unchecked",M[M.Checked=1]="Checked"})(Te||(e.TreeItemCheckboxState=Te={}));let xe=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$eL=xe,e.$eL=xe=Oe([j],xe);class at extends xe{}e.$fL=at;class Dt extends at{#e;constructor(F){super(""),this.#e=F}asFile(){return this.#e}}e.$gL=Dt;class bt{constructor(F,ae,we,je){this.name=F,this.uri=ae,this._itemId=we,this.c=je}data(){return this.c()}}e.$hL=bt;let rt=class{#e=new Map;constructor(F){for(const[ae,we]of F??[]){const je=this.#e.get(this.#t(ae));je?je.push(we):this.#e.set(this.#t(ae),[we])}}get(F){return this.#e.get(this.#t(F))?.[0]}set(F,ae){this.#e.set(this.#t(F),[ae])}forEach(F,ae){for(const[we,je]of this.#e)for(const Ke of je)F.call(ae,Ke,we,this)}*[Symbol.iterator](){for(const[F,ae]of this.#e)for(const we of ae)yield[F,we]}#t(F){return F.toLowerCase()}};e.$iL=rt,e.$iL=rt=Oe([j],rt);let ht=class{constructor(F){this.insertText=F}};e.$jL=ht,e.$jL=ht=Oe([j],ht);let Xt=class{constructor(F,ae){this.label=ae,this.insertText=F}};e.$kL=Xt,e.$kL=Xt=Oe([j],Xt);let Rt=class{constructor(F,ae){this.id=F,this.color=ae}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$lL=Rt,e.$lL=Rt=Oe([j],Rt),Rt.File=new Rt("file"),Rt.Folder=new Rt("folder");let Yt=class{constructor(F){this.id=F}};e.$mL=Yt,e.$mL=Yt=Oe([j],Yt);var Cn;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.WorkspaceFolder=3]="WorkspaceFolder"})(Cn||(e.ConfigurationTarget=Cn={}));let Zt=class{get base(){return this.c}set base(F){this.c=F,this.e=b.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,ae){if(typeof F!="string"&&(!F||!b.URI.isUri(F)&&!b.URI.isUri(F.uri)))throw(0,R.$7)("base");if(typeof ae!="string")throw(0,R.$7)("pattern");typeof F=="string"?this.baseUri=b.URI.file(F):b.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=ae}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$nL=Zt,e.$nL=Zt=Oe([j],Zt);const In=new WeakMap;function ui(M,F){In.set(M,F)}e.$oL=ui;let Ht=class{constructor(F,ae,we,je){this.enabled=typeof F=="boolean"?F:!0,typeof ae=="string"&&(this.condition=ae),typeof we=="string"&&(this.hitCondition=we),typeof je=="string"&&(this.logMessage=je)}get id(){return this.c||(this.c=In.get(this)??(0,A.$fg)()),this.c}};e.$pL=Ht,e.$pL=Ht=Oe([j],Ht);let xt=class extends Ht{constructor(F,ae,we,je,Ke){if(super(ae,we,je,Ke),F===null)throw(0,R.$7)("location");this.location=F}};e.$qL=xt,e.$qL=xt=Oe([j],xt);let _t=class extends Ht{constructor(F,ae,we,je,Ke){super(ae,we,je,Ke),this.functionName=F}};e.$rL=_t,e.$rL=_t=Oe([j],_t);let en=class extends Ht{constructor(F,ae,we,je,Ke,et,tt){if(super(je,Ke,et,tt),!ae)throw(0,R.$7)("dataId");this.label=F,this.dataId=ae,this.canPersist=we}};e.$sL=en,e.$sL=en=Oe([j],en);let tn=class{constructor(F,ae,we){this.command=F,this.args=ae||[],this.options=we}};e.$tL=tn,e.$tL=tn=Oe([j],tn);let nn=class{constructor(F,ae){this.port=F,this.host=ae}};e.$uL=nn,e.$uL=nn=Oe([j],nn);let sn=class{constructor(F){this.path=F}};e.$vL=sn,e.$vL=sn=Oe([j],sn);let rn=class{constructor(F){this.implementation=F}};e.$wL=rn,e.$wL=rn=Oe([j],rn);let on=class{constructor(F,ae,we){this.session=F,this.threadId=ae,this.frameId=we}};e.$xL=on,e.$xL=on=Oe([j],on);let an=class{constructor(F,ae){this.session=F,this.threadId=ae}};e.$yL=an,e.$yL=an=Oe([j],an);let cn=class{constructor(F,ae){this.range=F,this.expression=ae}};e.$zL=cn,e.$zL=cn=Oe([j],cn);var An;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(An||(e.InlineCompletionTriggerKind=An={}));let ln=class{constructor(F,ae){this.range=F,this.text=ae}};e.$AL=ln,e.$AL=ln=Oe([j],ln);let un=class{constructor(F,ae,we=!0){this.range=F,this.variableName=ae,this.caseSensitiveLookup=we}};e.$BL=un,e.$BL=un=Oe([j],un);let hn=class{constructor(F,ae){this.range=F,this.expression=ae}};e.$CL=hn,e.$CL=hn=Oe([j],hn);let fn=class{constructor(F,ae){this.frameId=F,this.stoppedLocation=ae}};e.$DL=fn,e.$DL=fn=Oe([j],fn);var Ln;(function(M){M[M.Changed=1]="Changed",M[M.Created=2]="Created",M[M.Deleted=3]="Deleted"})(Ln||(e.FileChangeType=Ln={}));let dn=k=class extends Error{static FileExists(F){return new k(F,y.FileSystemProviderErrorCode.FileExists,k.FileExists)}static FileNotFound(F){return new k(F,y.FileSystemProviderErrorCode.FileNotFound,k.FileNotFound)}static FileNotADirectory(F){return new k(F,y.FileSystemProviderErrorCode.FileNotADirectory,k.FileNotADirectory)}static FileIsADirectory(F){return new k(F,y.FileSystemProviderErrorCode.FileIsADirectory,k.FileIsADirectory)}static NoPermissions(F){return new k(F,y.FileSystemProviderErrorCode.NoPermissions,k.NoPermissions)}static Unavailable(F){return new k(F,y.FileSystemProviderErrorCode.Unavailable,k.Unavailable)}constructor(F,ae=y.FileSystemProviderErrorCode.Unknown,we){super(b.URI.isUri(F)?F.toString(!0):F),this.code=we?.name??"Unknown",(0,y.$ok)(this,ae),Object.setPrototypeOf(this,k.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}};e.$EL=dn,e.$EL=dn=k=Oe([j],dn);let mn=class{constructor(F,ae,we){this.start=F,this.end=ae,this.kind=we}};e.$FL=mn,e.$FL=mn=Oe([j],mn);var Rn;(function(M){M[M.Comment=1]="Comment",M[M.Imports=2]="Imports",M[M.Region=3]="Region"})(Rn||(e.FoldingRangeKind=Rn={}));var Nn;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(Nn||(e.CommentThreadCollapsibleState=Nn={}));var On;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(On||(e.CommentMode=On={}));var Fn;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(Fn||(e.CommentState=Fn={}));var jn;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(jn||(e.CommentThreadState=jn={}));class hi{constructor(F,ae=[]){this.tokenTypes=F,this.tokenModifiers=ae}}e.$GL=hi;function fi(M){return typeof M>"u"||(0,v.$Af)(M)}class gn{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,F){this.l=!0;for(let ae=0,we=F.tokenTypes.length;ae<we;ae++)this.j.set(F.tokenTypes[ae],ae);for(let ae=0,we=F.tokenModifiers.length;ae<we;ae++)this.k.set(F.tokenModifiers[ae],ae)}}push(F,ae,we,je,Ke){if(typeof F=="number"&&typeof ae=="number"&&typeof we=="number"&&typeof je=="number"&&(typeof Ke=="number"||typeof Ke>"u"))return typeof Ke>"u"&&(Ke=0),this.n(F,ae,we,je,Ke);if(he.isRange(F)&&typeof ae=="string"&&fi(we))return this.m(F,ae,we);throw(0,R.$7)()}m(F,ae,we){if(!this.l)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ae))throw new Error("`tokenType` is not in the provided legend");const je=F.start.line,Ke=F.start.character,et=F.end.character-F.start.character,tt=this.j.get(ae);let ut=0;if(we)for(const $t of we){if(!this.k.has($t))throw new Error("`tokenModifier` is not in the provided legend");const wt=this.k.get($t);ut|=1<<wt>>>0}this.n(je,Ke,et,tt,ut)}n(F,ae,we,je,Ke){if(this.f&&(F<this.c||F===this.c&&ae<this.e)){this.f=!1;const ut=this.g.length/5|0;let $t=0,wt=0;for(let Pt=0;Pt<ut;Pt++){let Nt=this.g[5*Pt],Gt=this.g[5*Pt+1];Nt===0?(Nt=$t,Gt+=wt):Nt+=$t,this.g[5*Pt]=Nt,this.g[5*Pt+1]=Gt,$t=Nt,wt=Gt}}let et=F,tt=ae;this.f&&this.h>0&&(et-=this.c,et===0&&(tt-=this.e)),this.g[this.h++]=et,this.g[this.h++]=tt,this.g[this.h++]=we,this.g[this.h++]=je,this.g[this.h++]=Ke,this.c=F,this.e=ae}static o(F){const ae=[],we=F.length/5|0;for(let tt=0;tt<we;tt++)ae[tt]=tt;ae.sort((tt,ut)=>{const $t=F[5*tt],wt=F[5*ut];if($t===wt){const Pt=F[5*tt+1],Nt=F[5*ut+1];return Pt-Nt}return $t-wt});const je=new Uint32Array(F.length);let Ke=0,et=0;for(let tt=0;tt<we;tt++){const ut=5*ae[tt],$t=F[ut+0],wt=F[ut+1],Pt=F[ut+2],Nt=F[ut+3],Gt=F[ut+4],li=$t-Ke,Oi=li===0?wt-et:wt,Kt=5*tt;je[Kt+0]=li,je[Kt+1]=Oi,je[Kt+2]=Pt,je[Kt+3]=Nt,je[Kt+4]=Gt,Ke=$t,et=wt}return je}build(F){return this.f?new $n(new Uint32Array(this.g),F):new $n(gn.o(this.g),F)}}e.$HL=gn;class $n{constructor(F,ae){this.resultId=ae,this.data=F}}e.$IL=$n;class di{constructor(F,ae,we){this.start=F,this.deleteCount=ae,this.data=we}}e.$JL=di;class mi{constructor(F,ae){this.resultId=ae,this.edits=F}}e.$KL=mi;var Mn;(function(M){M[M.Separate=0]="Separate",M[M.MergeWithParent=1]="MergeWithParent"})(Mn||(e.DebugConsoleMode=Mn={}));let pn=class{static{this.Back={iconPath:new Rt("arrow-left")}}constructor(){}};e.$LL=pn,e.$LL=pn=Oe([j],pn);var Tn;(function(M){M[M.Separator=-1]="Separator",M[M.Default=0]="Default"})(Tn||(e.QuickPickItemKind=Tn={}));var Un;(function(M){M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})(Un||(e.InputBoxValidationSeverity=Un={}));var zn;(function(M){M[M.UI=1]="UI",M[M.Workspace=2]="Workspace"})(zn||(e.ExtensionKind=zn={}));class gi{static validate(F){if(typeof F.badge=="string"){let ae=(0,C.$af)(F.badge,0);if(ae<F.badge.length&&(ae+=(0,C.$af)(F.badge,ae)),F.badge.length>ae)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!Rt.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,ae,we){this.badge=F,this.tooltip=ae,this.color=we}}e.$ML=gi;let bn=class{constructor(F){this.kind=F}};e.$NL=bn,e.$NL=bn=Oe([j],bn);var Bn;(function(M){M[M.Light=1]="Light",M[M.Dark=2]="Dark",M[M.HighContrast=3]="HighContrast",M[M.HighContrastLight=4]="HighContrastLight"})(Bn||(e.ColorThemeKind=Bn={}));class Mt{static isNotebookRange(F){return F instanceof Mt?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,ae){if(F<0)throw(0,R.$7)("start must be positive");if(ae<0)throw(0,R.$7)("end must be positive");F<=ae?(this.c=F,this.e=ae):(this.c=ae,this.e=F)}with(F){let ae=this.c,we=this.e;return F.start!==void 0&&(ae=F.start),F.end!==void 0&&(we=F.end),ae===this.c&&we===this.e?this:new Mt(ae,we)}}e.$OL=Mt;class Jt{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(ae=>Jt.isNotebookCellData(ae))}static isNotebookCellData(F){return!0}constructor(F,ae,we,je,Ke,et,tt){this.kind=F,this.value=ae,this.languageId=we,this.mime=je,this.outputs=Ke??[],this.metadata=et,this.executionSummary=tt,Jt.validate(this)}}e.$PL=Jt;class $i{constructor(F){this.cells=F}}e.$QL=$i;class St{static isNotebookCellOutputItem(F){return F instanceof St?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const ae={name:F.name,message:F.message,stack:F.stack};return St.json(ae,"application/vnd.code.notebook.error")}static stdout(F){return St.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return St.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,ae="application/octet-stream"){return new St(F,ae)}static#e=new TextEncoder;static text(F,ae=P.$Tr.text){const we=St.#e.encode(String(F));return new St(we,ae)}static json(F,ae="text/x-json"){const we=JSON.stringify(F,void 0,"	");return St.text(we,ae)}constructor(F,ae){this.data=F,this.mime=ae;const we=(0,P.$Xr)(ae,!0);if(!we)throw new Error(`INVALID mime type: ${ae}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}}e.$RL=St;class Qt{static isNotebookCellOutput(F){return F instanceof Qt?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,ae=!1){const we=new Set,je=new Set;for(let Ke=0;Ke<F.length;Ke++){const et=F[Ke],tt=(0,P.$Xr)(et.mime);if(!we.has(tt)||(0,g.$yI)(tt)){we.add(tt);continue}je.add(Ke),ae&&console.warn(`DUPLICATED mime type '${et.mime}' will be dropped`)}return je.size===0?F:F.filter((Ke,et)=>!je.has(et))}constructor(F,ae,we){this.items=Qt.ensureUniqueMimeTypes(F,!0),typeof ae=="string"?(this.id=ae,this.metadata=we):(this.id=(0,A.$fg)(),this.metadata=ae??we)}}e.$SL=Qt;var qn;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(qn||(e.NotebookCellKind=qn={}));var Hn;(function(M){M[M.Idle=1]="Idle",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(Hn||(e.NotebookCellExecutionState=Hn={}));var Vn;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(Vn||(e.NotebookCellStatusBarAlignment=Vn={}));var Wn;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(Wn||(e.NotebookEditorRevealType=Wn={}));class pi{constructor(F,ae){this.text=F,this.alignment=ae}}e.$TL=pi;var Gn;(function(M){M[M.Default=1]="Default",M[M.Preferred=2]="Preferred"})(Gn||(e.NotebookControllerAffinity=Gn={}));var Kn;(function(M){M[M.Default=1]="Default",M[M.Preferred=2]="Preferred",M[M.Hidden=-1]="Hidden"})(Kn||(e.NotebookControllerAffinity2=Kn={}));class bi{constructor(F,ae=[]){this.uri=F,this.provides=(0,D.$3b)(ae)}}e.$UL=bi;class wi{constructor(F){this.label=F}}e.$VL=wi;let wn=class{constructor(F,ae){this.label=F,this.timestamp=ae}};e.$WL=wn,e.$WL=wn=Oe([j],wn);var Jn;(function(M){M[M.Production=1]="Production",M[M.Development=2]="Development",M[M.Test=3]="Test"})(Jn||(e.ExtensionMode=Jn={}));var Qn;(function(M){M[M.Node=1]="Node",M[M.Webworker=2]="Webworker"})(Qn||(e.ExtensionRuntime=Qn={}));var Xn;(function(M){M[M.Other=0]="Other",M[M.Comment=1]="Comment",M[M.String=2]="String",M[M.RegEx=3]="RegEx"})(Xn||(e.StandardTokenType=Xn={}));class vi{constructor(F,ae){this.ranges=F,this.wordPattern=ae}}e.$XL=vi;class yi{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$YL=yi;var Yn;(function(M){M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(Yn||(e.TestResultState=Yn={}));var Zn;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(Zn||(e.TestRunProfileKind=Zn={}));let vn=class{constructor(F=void 0,ae=void 0,we=void 0,je=!1){this.include=F,this.exclude=ae,this.profile=we,this.continuous=je}};e.$ZL=vn,e.$ZL=vn=Oe([j],vn);let yn=E=class{static diff(F,ae,we){const je=new E(F);return je.expectedOutput=ae,je.actualOutput=we,je}constructor(F){this.message=F}};e.$1L=yn,e.$1L=yn=E=Oe([j],yn);let En=class{constructor(F){this.id=F}};e.$2L=En,e.$2L=En=Oe([j],En);let Vt=class{constructor(F,ae){this.covered=F,this.total=ae}};e.$3L=Vt,e.$3L=Vt=Oe([j],Vt);let kn=L=class{static fromDetails(F,ae){const we=new Vt(0,0),je=new Vt(0,0),Ke=new Vt(0,0);for(const tt of ae)if("branches"in tt){we.total+=1,we.covered+=tt.executionCount>0?1:0;for(const ut of tt.branches)je.total+=1,je.covered+=ut.executionCount>0?1:0}else Ke.total+=1,Ke.covered+=tt.executionCount>0?1:0;const et=new L(F,we,je.total>0?je:void 0,Ke.total>0?Ke:void 0);return et.detailedCoverage=ae,et}constructor(F,ae,we,je){this.uri=F,this.statementCoverage=ae,this.branchCoverage=we,this.functionCoverage=je}};e.$4L=kn,e.$4L=kn=L=Oe([j],kn);let Dn=class{constructor(F,ae,we=[]){this.executionCount=F,this.location=ae,this.branches=we}};e.$5L=Dn,e.$5L=Dn=Oe([j],Dn);let Sn=class{constructor(F,ae){this.executionCount=F,this.location=ae}};e.$6L=Sn,e.$6L=Sn=Oe([j],Sn);let Pn=class{constructor(F,ae){this.executionCount=F,this.location=ae}};e.$7L=Pn,e.$7L=Pn=Oe([j],Pn);var xn;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(xn||(e.ExternalUriOpenerPriority=xn={}));var _n;(function(M){M[M.Untrusted=0]="Untrusted",M[M.Trusted=1]="Trusted",M[M.Unspecified=2]="Unspecified"})(_n||(e.WorkspaceTrustState=_n={}));var ei;(function(M){M[M.Notify=1]="Notify",M[M.OpenBrowser=2]="OpenBrowser",M[M.OpenPreview=3]="OpenPreview",M[M.Silent=4]="Silent",M[M.Ignore=5]="Ignore",M[M.OpenBrowserOnce=6]="OpenBrowserOnce"})(ei||(e.PortAutoForwardAction=ei={}));class Ei{constructor(F,ae,we,je,Ke,et){this.kind=F,this.name=ae,this.detail=we,this.uri=je,this.range=Ke,this.selectionRange=et}}e.$8L=Ei;class ki{constructor(F){this.uri=F}}e.$9L=ki;class Di{constructor(F,ae){this.original=F,this.modified=ae}}e.$0L=Di;class Si{constructor(F,ae,we,je){this.base=F,this.input1=ae,this.input2=we,this.result=je}}e.$$L=Si;class Pi{constructor(F,ae){this.uri=F,this.viewType=ae}}e.$_L=Pi;class Ci{constructor(F){this.viewType=F}}e.$aM=Ci;class Ii{constructor(F,ae){this.uri=F,this.notebookType=ae}}e.$bM=Ii;class Ai{constructor(F,ae,we){this.original=F,this.modified=ae,this.notebookType=we}}e.$cM=Ai;class Li{constructor(){}}e.$dM=Li;class Ri{constructor(F,ae){this.uri=F,this.inputBoxUri=ae}}e.$eM=Ri;var ti;(function(M){M[M.Down=0]="Down",M[M.Up=1]="Up"})(ti||(e.InteractiveSessionVoteDirection=ti={}));var ni;(function(M){M[M.Action=1]="Action",M[M.Toolbar=2]="Toolbar"})(ni||(e.InteractiveSessionCopyKind=ni={}));var ii;(function(M){M[M.Unhelpful=0]="Unhelpful",M[M.Helpful=1]="Helpful",M[M.Undone=2]="Undone",M[M.Accepted=3]="Accepted"})(ii||(e.InteractiveEditorResponseFeedbackKind=ii={}));var si;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.Assistant=2]="Assistant",M[M.Function=3]="Function"})(si||(e.ChatMessageRole=si={}));var ri;(function(M){M[M.Short=1]="Short",M[M.Medium=2]="Medium",M[M.Full=3]="Full"})(ri||(e.ChatVariableLevel=ri={}));class Ni{constructor(F,ae){this.role=F,this.content=ae}}e.$fM=Ni;var oi;(function(M){M[M.Unhelpful=0]="Unhelpful",M[M.Helpful=1]="Helpful"})(oi||(e.ChatAgentResultFeedbackKind=oi={}));var ai;(function(M){M[M.SymbolInformation=1]="SymbolInformation",M[M.CommandInformation=2]="CommandInformation",M[M.SearchInformation=3]="SearchInformation",M[M.SettingInformation=4]="SettingInformation"})(ai||(e.RelatedInformationType=ai={}));var ci;(function(M){M[M.Started=1]="Started",M[M.Recognizing=2]="Recognizing",M[M.Recognized=3]="Recognized",M[M.Stopped=4]="Stopped"})(ci||(e.SpeechToTextStatus=ci={}))}),define(pe[268],be([1,0,6]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TM=void 0,e.$TM=(0,D.$Qh)("environmentVariableService")}),define(pe[269],be([1,0,7,4,64,3,249,10]),function(ue,e,D,R,r,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=e.$jN=e.$iN=void 0;function v(c,n){if(n)if(I.$j)for(const i in n){let o=i;for(const t in c)if(i.toLowerCase()===t.toLowerCase()){o=t;break}const s=n[i];s!==void 0&&b(c,o,s)}else Object.keys(n).forEach(i=>{const o=n[i];o!==void 0&&b(c,i,o)})}e.$iN=v;function b(c,n,i){typeof i=="string"?c[n]=i:delete c[n]}function A(c,n,i,o){c.TERM_PROGRAM="vscode",n&&(c.TERM_PROGRAM_VERSION=n),u(c,o)&&(c.LANG=g(i)),c.COLORTERM="truecolor"}e.$jN=A;function S(c,n){if(n)for(const i of Object.keys(n)){const o=n[i];o!=null&&(c[i]=o)}}async function y(c,n){return await Promise.all(Object.entries(n).map(async([i,o])=>{if(typeof o=="string")try{n[i]=await c(o)}catch{n[i]=o}})),n}function u(c,n){if(n==="on")return!0;if(n==="auto"){const i=c.LANG;return!i||i.search(/\.UTF\-8$/)===-1&&i.search(/\.utf8$/)===-1&&i.search(/\.euc.+/)===-1}return!1}e.$kN=u;function g(c){const n=c?c.split("-"):[],i=n.length;if(i===0)return"en_US.UTF-8";if(i===1){const o={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};n[0]in o&&n.push(o[n[0]])}else n[1]=n[1].toUpperCase();return n.join("_")+".UTF-8"}e.$lN=g;async function d(c,n,i,o,s,t){if(c.cwd){const $=typeof c.cwd=="object"?c.cwd.fsPath:c.cwd,w=await f($,i);return(0,P.$gN)(w||$)}let a;return!c.ignoreConfigurationCwd&&s&&(i&&(s=await f(s,i,t)),s&&(D.$ic(s)?a=s:o&&(a=D.$jc(o.fsPath,s)))),a||(a=o?o.fsPath:n||""),(0,P.$gN)(a)}e.$mN=d;async function f(c,n,i){if(n)try{return await n(c)}catch(o){i?.error("Could not resolve terminal cwd",o);return}return c}function h(c,n,i){if(i)return o=>i.resolveWithEnvironment(n,c,o)}e.$nN=h;async function p(c,n,i,o,s,t){const a={};if(c.strictEnv)S(a,c.env);else{S(a,t);const $={...n};i&&($&&await y(i,$),c.env&&await y(i,c.env)),(0,r.$Al)(a,"VSCODE_IPC_HOOK_CLI"),v(a,$),v(a,c.env),A(a,o,I.$w,s)}return a}e.$oN=p;async function l(c,n,i,o,s,t,a=I.$j){let $;if((0,C.$zf)(c)?$=c:($=c.fsPath,a&&t!==1?$=$.replace(/\\/g,"/"):!a&&t===1&&($=$.replace(/\//g,"\\"))),!n)return $;const w=$.includes(" "),k=$.includes("(")||$.includes(")"),E=D.$nc(n,".exe"),L=E==="pwsh"||i==="pwsh"||E==="powershell"||i==="powershell";if(L&&(w||$.includes("'")))return`& '${$.replace(/'/g,"''")}'`;if(k&&L)return`& '${$}'`;if(t===1){if(o!==void 0)return o==="gitbash"?(0,P.$eN)($.replace(/\\/g,"/")):o==="wsl"?s?.getWslPath($,"win-to-unix")||$:w?`"${$}"`:$;const j=n.toLowerCase();return j.includes("wsl")||j.includes("bash.exe")&&!j.toLowerCase().includes("git")?s?.getWslPath($,"win-to-unix")||$:w?`"${$}"`:$}return(0,P.$eN)($)}e.$pN=l;function m(c,n,i){const o=typeof c=="string"?R.URI.parse(c):c;let s=o?n.getWorkspaceFolder(o)??void 0:void 0;if(!s){const t=i.getLastActiveWorkspaceRoot();s=t?n.getWorkspaceFolder(t)??void 0:void 0}return s}e.$qN=m}),define(pe[71],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iJ=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(I){I.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var R;(function(I){I[I.IsSame=0]="IsSame",I[I.Disconnected=1]="Disconnected",I[I.IsChild=2]="IsChild",I[I.IsParent=3]="IsParent"})(R||(e.TestPosition=R={}));class r{static fromExtHostTestItem(P,C,v=P.parent){if(P._isRoot)return new r([C]);const b=[P.id];for(let A=v;A&&A.id!==C;A=A.parent)b.push(A.id);return b.push(C),new r(b.reverse())}static isRoot(P){return!P.includes("\0")}static root(P){const C=P.indexOf("\0");return C===-1?P:P.slice(0,C)}static fromString(P){return new r(P.split("\0"))}static join(P,C){return new r([...P.path,C])}static joinToString(P,C){return P.toString()+"\0"+C}static parentId(P){const C=P.lastIndexOf("\0");return C===-1?void 0:P.slice(0,C)}static localId(P){const C=P.lastIndexOf("\0");return C===-1?P:P.slice(C+1)}static isChild(P,C){return C.startsWith(P)&&C[P.length]==="\0"}static compare(P,C){return P===C?0:r.isChild(P,C)?2:r.isChild(C,P)?3:1}constructor(P,C=P.length){if(this.path=P,this.d=C,P.length===0||C<1)throw new Error("cannot create test with empty path")}get rootId(){return new r(this.path,1)}get parentId(){return this.d>1?new r(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let P=1;P<=this.d;P++)yield new r(this.path,P)}*idsToRoot(){for(let P=this.d;P>0;P--)yield new r(this.path,P)}compare(P){if(typeof P=="string")return r.compare(this.toString(),P);for(let C=0;C<P.d&&C<this.d;C++)if(P.path[C]!==this.path[C])return 1;return P.d>this.d?2:P.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let P=1;P<this.d;P++)this.c+="\0",this.c+=this.path[P]}return this.c}}e.$iJ=r}),define(pe[92],be([1,0,4,42,71]),function(ue,e,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$oJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$nJ=e.$mJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$lJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$kJ=e.$jJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var I;(function(w){w[w.Unset=0]="Unset",w[w.Queued=1]="Queued",w[w.Running=2]="Running",w[w.Passed=3]="Passed",w[w.Failed=4]="Failed",w[w.Skipped=5]="Skipped",w[w.Errored=6]="Errored"})(I||(e.TestResultState=I={}));var P;(function(w){w[w.Run=1]="Run",w[w.Debug=2]="Debug",w[w.Coverage=3]="Coverage"})(P||(e.ExtTestRunProfileKind=P={}));var C;(function(w){w[w.Run=2]="Run",w[w.Debug=4]="Debug",w[w.Coverage=8]="Coverage",w[w.HasNonDefaultProfile=16]="HasNonDefaultProfile",w[w.HasConfigurable=32]="HasConfigurable",w[w.SupportsContinuousRun=64]="SupportsContinuousRun"})(C||(e.TestRunProfileBitset=C={})),e.$jJ=[2,4,8,16,32,64];const v=w=>"runId"in w;e.$kJ=v;var b;(function(w){w.serialize=k=>({range:k.range.toJSON(),uri:k.uri.toJSON()}),w.deserialize=k=>({range:R.$xs.lift(k.range),uri:D.URI.revive(k.uri)})})(b||(e.IRichLocation=b={}));var A;(function(w){w[w.Error=0]="Error",w[w.Output=1]="Output"})(A||(e.TestMessageType=A={}));var S;(function(w){w.serialize=k=>({message:k.message,type:0,expected:k.expected,actual:k.actual,contextValue:k.contextValue,location:k.location&&b.serialize(k.location)}),w.deserialize=k=>({message:k.message,type:0,expected:k.expected,actual:k.actual,contextValue:k.contextValue,location:k.location&&b.deserialize(k.location)})})(S||(e.ITestErrorMessage=S={}));const y=(w,k)=>`${k?"s":"e"}${w}`;e.$lJ=y;var u;(function(w){w.serialize=k=>({message:k.message,type:1,offset:k.offset,length:k.length,location:k.location&&b.serialize(k.location)}),w.deserialize=k=>({message:k.message,type:1,offset:k.offset,length:k.length,location:k.location&&b.deserialize(k.location)})})(u||(e.ITestOutputMessage=u={}));var g;(function(w){w.serialize=k=>k.type===0?S.serialize(k):u.serialize(k),w.deserialize=k=>k.type===0?S.deserialize(k):u.deserialize(k)})(g||(e.ITestMessage=g={}));var d;(function(w){w.serializeWithoutMessages=k=>({state:k.state,duration:k.duration,messages:[]}),w.serialize=k=>({state:k.state,duration:k.duration,messages:k.messages.map(g.serialize)}),w.deserialize=k=>({state:k.state,duration:k.duration,messages:k.messages.map(g.deserialize)})})(d||(e.ITestTaskState=d={}));const f="\0",h=(w,k)=>w+f+k;e.$mJ=h;const p=w=>{const k=w.indexOf(f);return{ctrlId:w.slice(0,k),tagId:w.slice(k+1)}};e.$nJ=p;var l;(function(w){w.serialize=k=>({extId:k.extId,label:k.label,tags:k.tags,busy:k.busy,children:void 0,uri:k.uri?.toJSON(),range:k.range?.toJSON()||null,description:k.description,error:k.error,sortText:k.sortText}),w.deserialize=k=>({extId:k.extId,label:k.label,tags:k.tags,busy:k.busy,children:void 0,uri:k.uri?D.URI.revive(k.uri):void 0,range:k.range?R.$xs.lift(k.range):null,description:k.description,error:k.error,sortText:k.sortText})})(l||(e.ITestItem=l={}));var m;(function(w){w[w.NotExpandable=0]="NotExpandable",w[w.Expandable=1]="Expandable",w[w.BusyExpanding=2]="BusyExpanding",w[w.Expanded=3]="Expanded"})(m||(e.TestItemExpandState=m={}));var c;(function(w){w.serialize=k=>({expand:k.expand,item:l.serialize(k.item)}),w.deserialize=k=>({controllerId:r.$iJ.root(k.item.extId),expand:k.expand,item:l.deserialize(k.item)})})(c||(e.InternalTestItem=c={}));var n;(function(w){w.serialize=k=>{let E;return k.item&&(E={},k.item.label!==void 0&&(E.label=k.item.label),k.item.tags!==void 0&&(E.tags=k.item.tags),k.item.busy!==void 0&&(E.busy=k.item.busy),k.item.uri!==void 0&&(E.uri=k.item.uri?.toJSON()),k.item.range!==void 0&&(E.range=k.item.range?.toJSON()),k.item.description!==void 0&&(E.description=k.item.description),k.item.error!==void 0&&(E.error=k.item.error),k.item.sortText!==void 0&&(E.sortText=k.item.sortText)),{extId:k.extId,expand:k.expand,item:E}},w.deserialize=k=>{let E;return k.item&&(E={},k.item.label!==void 0&&(E.label=k.item.label),k.item.tags!==void 0&&(E.tags=k.item.tags),k.item.busy!==void 0&&(E.busy=k.item.busy),k.item.range!==void 0&&(E.range=k.item.range?R.$xs.lift(k.item.range):null),k.item.description!==void 0&&(E.description=k.item.description),k.item.error!==void 0&&(E.error=k.item.error),k.item.sortText!==void 0&&(E.sortText=k.item.sortText)),{extId:k.extId,expand:k.expand,item:E}}})(n||(e.ITestItemUpdate=n={}));const i=(w,k)=>{k.expand!==void 0&&(w.expand=k.expand),k.item!==void 0&&(w.item=w.item?Object.assign(w.item,k.item):k.item)};e.$oJ=i;var o;(function(w){w.serializeWithoutMessages=k=>({...c.serialize(k),ownComputedState:k.ownComputedState,computedState:k.computedState,tasks:k.tasks.map(d.serializeWithoutMessages)}),w.serialize=k=>({...c.serialize(k),ownComputedState:k.ownComputedState,computedState:k.computedState,tasks:k.tasks.map(d.serialize)}),w.deserialize=k=>({...c.deserialize(k),ownComputedState:k.ownComputedState,computedState:k.computedState,tasks:k.tasks.map(d.deserialize),retired:!0})})(o||(e.TestResultItem=o={}));var s;(function(w){w[w.Function=0]="Function",w[w.Statement=1]="Statement"})(s||(e.DetailType=s={}));var t;(function(w){w[w.Add=0]="Add",w[w.Update=1]="Update",w[w.DocumentSynced=2]="DocumentSynced",w[w.Remove=3]="Remove",w[w.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",w[w.Retire=5]="Retire",w[w.AddTag=6]="AddTag",w[w.RemoveTag=7]="RemoveTag"})(t||(e.TestDiffOpType=t={}));var a;(function(w){w.deserialize=k=>k.op===0?{op:k.op,item:c.deserialize(k.item)}:k.op===1?{op:k.op,item:n.deserialize(k.item)}:k.op===2?{op:k.op,uri:D.URI.revive(k.uri),docv:k.docv}:k,w.serialize=k=>k.op===0?{op:k.op,item:c.serialize(k.item)}:k.op===1?{op:k.op,item:n.serialize(k.item)}:k})(a||(e.TestsDiffOp=a={}));class ${constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(k){const E=this.o();for(const L of k)switch(L.op){case 0:this.j(c.deserialize(L.item),E);break;case 1:this.k(n.deserialize(L.item),E);break;case 3:this.l(L.itemId,E);break;case 5:this.m(L.itemId);break;case 4:this.updatePendingRoots(L.amount);break;case 6:this.c.set(L.tag.id,L.tag);break;case 7:this.c.delete(L.id);break}E.complete?.()}j(k,E){const L=r.$iJ.parentId(k.item.extId)?.toString();let j;if(!L)j=this.p(k),this.f.add(j),this.d.set(k.item.extId,j);else if(this.d.has(L)){const x=this.d.get(L);x.children.add(k.item.extId),j=this.p(k,x),this.d.set(k.item.extId,j)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(k)}`);return}return E.add?.(j),k.expand===2&&this.g++,j}k(k,E){const L=this.d.get(k.extId);if(L)return k.expand!==void 0&&(L.expand===2&&this.g--,k.expand===2&&this.g++),(0,e.$oJ)(L,k),E.update?.(L),L}l(k,E){const L=this.d.get(k);if(!L)return;const j=r.$iJ.parentId(L.item.extId)?.toString();j?this.d.get(j).children.delete(L.item.extId):this.f.delete(L);const x=[[k]];for(;x.length;)for(const ce of x.pop()){const X=this.d.get(ce);X&&(x.push(X.children),this.d.delete(ce),E.remove?.(X,X!==L),X.expand===2&&this.g--)}}m(k){}updatePendingRoots(k){this.h+=k}o(){return{}}}e.$pJ=$}),define(pe[132],be([1,0,14,5,2,95,92,71]),function(ue,e,D,R,r,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.TestItemEventOp=void 0;var v;(function(p){p[p.Upsert=0]="Upsert",p[p.SetTags=1]="SetTags",p[p.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",p[p.RemoveChild=3]="RemoveChild",p[p.SetProp=4]="SetProp",p[p.Bulk=5]="Bulk",p[p.DocumentSynced=6]="DocumentSynced"})(v||(e.TestItemEventOp=v={}));const b=(p,l)=>p===l,S=Object.entries({range:(p,l)=>p===l?!0:!p||!l?!1:p.equalsRange(l),busy:b,label:b,description:b,error:b,sortText:b,tags:(p,l)=>!(p.length!==l.length||p.some(m=>!l.includes(m)))}),y=(p,l)=>{let m;for(const[c,n]of S)n(p[c],l[c])||(m?m[c]=l[c]:m={[c]:l[c]});return m};class u extends r.$Sc{get root(){return this.s.root}constructor(l){super(),this.s=l,this.f=this.B(new D.$7g(()=>this.flushDiff(),200)),this.g=this.B(new R.$Od),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(l){this.h=l;for(const m of this.tree.values())this.I(m)}get resolveHandler(){return this.h}collectDiff(){const l=this.m;return this.m=[],l}pushDiff(l){switch(l.op){case 2:{for(const m of this.m)if(m.op===2&&m.uri===l.uri){m.docv=l.docv;return}break}case 1:{const m=this.m[this.m.length-1];if(m){if(m.op===1&&m.item.extId===l.item.extId){(0,P.$oJ)(m.item,l.item);return}if(m.op===0&&m.item.item.extId===l.item.extId){(0,P.$oJ)(m.item,l.item);return}}break}}this.m.push(l),this.f.isScheduled()||this.f.schedule()}expand(l,m){const c=this.tree.get(l);if(c){if((c.expandLevels===void 0||m>c.expandLevels)&&(c.expandLevels=m),c.expand===1){const n=this.L(c);return n.isOpen()?this.J(c,m-1):n.wait().then(()=>this.J(c,m-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.J(c,m-1)):this.J(c,m-1)}}dispose(){for(const l of this.tree.values())this.s.getApiFor(l.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(l,m){switch(m.op){case 3:this.N(C.$iJ.joinToString(l.fullId,m.id));break;case 0:this.y(m.item,l);break;case 5:for(const c of m.ops)this.u(l,c);break;case 1:this.z(m.new,m.old,l.fullId.toString());break;case 2:this.I(l);break;case 4:this.pushDiff({op:1,item:{extId:l.fullId.toString(),item:m.update}});break;case 6:this.w(l.actual.uri);break;default:(0,I.$4c)(m)}}w(l){l&&this.pushDiff({op:2,uri:l,docv:this.s.getDocumentVersion(l)})}y(l,m){const c=C.$iJ.fromExtHostTestItem(l,this.root.id,m?.actual),n=this.s.getApiFor(l);n.parent&&n.parent!==m?.actual&&this.s.getChildren(n.parent).delete(l.id);let i=this.tree.get(c.toString());if(!i){i={fullId:c,actual:l,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},l.tags.forEach(this.C,this),this.tree.set(i.fullId.toString(),i),this.F(l,m),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:i.expand,item:this.s.toITestItem(l)}}),this.H(l,i,m);return}if(i.actual===l){this.G(l,i,m);return}if(i.actual.uri?.toString()!==l.uri?.toString())return this.N(c.toString()),this.y(l,m);const o=this.s.getChildren(i.actual),s=i.actual,t=y(this.s.toITestItem(s),this.s.toITestItem(l));this.s.getApiFor(s).listener=void 0,i.actual=l,i.expand=0,t&&(t.hasOwnProperty("tags")&&(this.z(l.tags,s.tags,c.toString()),delete t.tags),this.u(i,{op:4,update:t})),this.H(l,i,m);for(const[a,$]of o)this.s.getChildren(l).get($.id)||this.N(C.$iJ.joinToString(c,$.id));this.w(i.actual.uri)}z(l,m,c){const n=new Set(m.map(i=>i.id));for(const i of l)n.delete(i.id)||this.C(i);this.pushDiff({op:1,item:{extId:c,item:{tags:l.map(i=>(0,P.$mJ)(this.s.controllerId,i.id))}}}),n.forEach(this.D,this)}C(l){const m=this.j.get(l.id);m?m.refCount++:(this.j.set(l.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,P.$mJ)(this.s.controllerId,l.id)}}))}D(l){const m=this.j.get(l);m&&!--m.refCount&&(this.j.delete(l),this.pushDiff({op:7,id:(0,P.$mJ)(this.s.controllerId,l)}))}F(l,m){this.s.getApiFor(l).parent=m&&m.actual!==this.root?m.actual:void 0}G(l,m,c){this.F(l,c);const n=this.s.getApiFor(l);n.parent=c?.actual,n.listener=i=>this.u(m,i),this.I(m)}H(l,m,c){this.G(l,m,c);for(const[n,i]of this.s.getChildren(l))this.y(i,m)}I(l){let m;this.h?l.resolveBarrier?m=l.resolveBarrier.isOpen()?3:2:m=l.actual.canResolveChildren?1:0:m=0,m!==l.expand&&(l.expand=m,this.pushDiff({op:1,item:{extId:l.fullId.toString(),expand:m}}),m===1&&l.expandLevels!==void 0&&this.L(l))}J(l,m){if(m<0)return;const c=[];for(const[n,i]of this.s.getChildren(l.actual)){const o=this.expand(C.$iJ.joinToString(l.fullId,i.id),m);(0,D.$Hg)(o)&&c.push(o)}if(c.length)return Promise.all(c).then(()=>{})}L(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this.h){const i=new D.$Tg;return i.open(),i}l.expand=2,this.M(l);const m=l.resolveBarrier=new D.$Tg,c=i=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,i)};let n;try{n=this.h(l.actual===this.root?void 0:l.actual)}catch(i){c(i)}return(0,D.$Hg)(n)?n.catch(c).then(()=>{m.open(),this.I(l)}):(m.open(),this.I(l)),l.resolveBarrier}M(l){this.pushDiff({op:1,item:{extId:l.fullId.toString(),expand:l.expand}})}N(l){const m=this.tree.get(l);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:l});const c=[m];for(;c.length;){const n=c.pop();if(n){this.s.getApiFor(n.actual).listener=void 0;for(const i of n.actual.tags)this.D(i.id);this.tree.delete(n.fullId.toString());for(const[i,o]of this.s.getChildren(n.actual))c.push(this.tree.get(C.$iJ.joinToString(n.fullId,o.id)))}}}flushDiff(){const l=this.collectDiff();l.length&&this.g.fire(l)}}e.$gM=u;class g extends Error{constructor(l){super(`Attempted to insert a duplicate test item ID ${l}`)}}e.$hM=g;class d extends Error{constructor(l){super(`TestItem with ID "${l}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$iM=d;class f extends Error{constructor(l,m,c){super(`TestItem with ID "${l}" is from controller "${m}" and cannot be added as a child of an item from controller "${c}".`)}}e.$jM=f;const h=(p,l,m)=>{let c=new Map;return{get size(){return c.size},forEach(n,i){for(const o of c.values())n.call(i,o,this)},[Symbol.iterator](){return c.entries()},replace(n){const i=new Map,o=new Set(c.keys()),s={op:5,ops:[]};for(const t of n){if(!(t instanceof m))throw new d(t.id);const a=l(t).controllerId;if(a!==p.controllerId)throw new f(t.id,a,p.controllerId);if(i.has(t.id))throw new g(t.id);i.set(t.id,t),o.delete(t.id),s.ops.push({op:0,item:t})}for(const t of o.keys())s.ops.push({op:3,id:t});p.listener?.(s),c=i},add(n){if(!(n instanceof m))throw new d(n.id);c.set(n.id,n),p.listener?.({op:0,item:n})},delete(n){c.delete(n)&&p.listener?.({op:3,id:n})},get(n){return c.get(n)},toJSON(){return Array.from(c.values())}}};e.$kM=h}),define(pe[133],be([1,0,132]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=e.$lM=void 0;const R=new WeakMap,r=(P,C)=>{const v={controllerId:C};return R.set(P,v),v};e.$lM=r;const I=P=>{const C=R.get(P);if(!C)throw new D.$iM(P?.id||"<unknown>");return C};e.$mM=I}),define(pe[270],be([1,0,24,6]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FD=e.$ED=e.$DD=e.$CD=e.$BD=e.$AD=e.$zD=e.$yD=e.$xD=e.$wD=e.$vD=e.$uD=e.$tD=e.$sD=e.$rD=e.$qD=e.$pD=e.$oD=e.$nD=e.$mD=e.$lD=e.$kD=e.$jD=e.$iD=e.$hD=void 0,e.$hD=".vscode",e.$iD="settings",e.$jD=`${e.$hD}/${e.$iD}.json`,e.$kD="vscode://schemas/settings/default",e.$lD="vscode://schemas/settings/user",e.$mD="vscode://schemas/settings/profile",e.$nD="vscode://schemas/settings/machine",e.$oD="vscode://schemas/settings/workspace",e.$pD="vscode://schemas/settings/folder",e.$qD="vscode://schemas/launch",e.$rD="vscode://schemas/tasks",e.$sD=[1],e.$tD=[2,3,4,5,6],e.$uD=[3,4,5],e.$vD=[1,...e.$uD],e.$wD=[2,3,4,5,6],e.$xD=[3,4,5,6],e.$yD=[4,5,6],e.$zD="tasks",e.$AD="launch",e.$BD=Object.create(null),e.$BD[e.$zD]=`${e.$hD}/${e.$zD}.json`,e.$BD[e.$AD]=`${e.$hD}/${e.$AD}.json`,e.$CD=Object.create(null),e.$CD[e.$zD]=`${e.$zD}.json`,e.$DD=(0,R.$Rh)(D.$ki),e.$ED=`{
	"version": "2.0.0",
	"tasks": []
}`,e.$FD="workbench.settings.applyToAllProfiles"}),define(pe[134],be([1,0,6]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dN=e.VariableKind=e.$cN=void 0,e.$cN=(0,D.$Qh)("configurationResolverService");var R;(function(I){I.Unknown="unknown",I.Env="env",I.Config="config",I.Command="command",I.Input="input",I.ExtensionInstallFolder="extensionInstallFolder",I.WorkspaceFolder="workspaceFolder",I.Cwd="cwd",I.WorkspaceFolderBasename="workspaceFolderBasename",I.UserHome="userHome",I.LineNumber="lineNumber",I.SelectedText="selectedText",I.File="file",I.FileWorkspaceFolder="fileWorkspaceFolder",I.RelativeFile="relativeFile",I.RelativeFileDirname="relativeFileDirname",I.FileDirname="fileDirname",I.FileExtname="fileExtname",I.FileBasename="fileBasename",I.FileBasenameNoExtension="fileBasenameNoExtension",I.FileDirnameBasename="fileDirnameBasename",I.ExecPath="execPath",I.ExecInstallFolder="execInstallFolder",I.PathSeparator="pathSeparator"})(R||(e.VariableKind=R={}));class r extends Error{constructor(P,C){super(C),this.variable=P}}e.$dN=r}),define(pe[271],be([1,0,7,29,10,22,3,166,204,134,17]),function(ue,e,D,R,r,I,P,C,v,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=void 0;class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(u,g,d,f){this.h=new Map,this.a=u,this.b=g,this.g=d,f&&(this.c=f.then(h=>this.i(h)))}i(u){if(P.$j){const g=Object.create(null);return Object.keys(u).forEach(d=>{g[d.toLowerCase()]=u[d]}),g}return u}resolveWithEnvironment(u,g,d){return this.l({env:this.i(u),userHome:void 0},g?g.uri:void 0,d)}async resolveAsync(u,g){const d={env:await this.c,userHome:await this.g};return this.l(d,u?u.uri:void 0,g)}async j(u,g,d,f){const h=I.$8m(g);P.$j&&h.windows?Object.keys(h.windows).forEach(l=>h[l]=h.windows[l]):P.$k&&h.osx?Object.keys(h.osx).forEach(l=>h[l]=h.osx[l]):P.$l&&h.linux&&Object.keys(h.linux).forEach(l=>h[l]=h.linux[l]),delete h.windows,delete h.osx,delete h.linux;const p={env:await this.c,userHome:await this.g};return this.l(p,u?u.uri:void 0,h,d,f)}async resolveAnyAsync(u,g,d){return this.j(u,g,d)}async resolveAnyMap(u,g,d){const f=new Map;return{newConfig:await this.j(u,g,d,f),resolvedVariables:f}}resolveWithInteractionReplace(u,g,d,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(u,g,d,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(u,g){if(this.h.has(u))throw new Error("Variable "+u+" is contributed twice.");this.h.set(u,g)}async l(u,g,d,f,h){if(r.$zf(d))return this.m(u,g,d,f,h);if(Array.isArray(d))return Promise.all(d.map(p=>this.l(u,g,p,f,h)));if(r.$Bf(d)){const p=Object.create(null),l=await Promise.all(Object.keys(d).map(async m=>[await this.m(u,g,m,f,h),await this.l(u,g,d[m],f,h)]));for(const[m,c]of l)p[m]=c;return p}return d}m(u,g,d,f,h){return(0,A.$Ue)(d,S.VARIABLE_REGEXP,async(p,l)=>{if(l.includes(S.VARIABLE_LHS))return p;let m=await this.o(u,p,l,g,f);return h?.set(l,m),m!==p&&r.$zf(m)&&m.match(S.VARIABLE_REGEXP)&&(m=await this.m(u,g,m,f,h)),m})}n(u){return this.b?this.b.getUriLabel(u,{noPrefix:!0}):u.fsPath}async o(u,g,d,f,h){let p;const l=d.split(":");l.length>1&&(d=l[0],p=l[1]);const m=i=>{const o=this.a.getFilePath();if(o)return(0,C.$wv)(o);throw new b.$dN(i,(0,v.localize)(0,null,g))},c=i=>{const o=m(i);if(this.a.getWorkspaceFolderPathForFile){const s=this.a.getWorkspaceFolderPathForFile();if(s)return(0,C.$wv)(s)}throw new b.$dN(i,(0,v.localize)(1,null,g,D.$nc(o)))},n=i=>{if(p){const o=this.a.getFolderUri(p);if(o)return o;throw new b.$dN(i,(0,v.localize)(2,null,g,p))}if(f)return f;throw this.a.getWorkspaceFolderCount()>1?new b.$dN(i,(0,v.localize)(3,null,g)):new b.$dN(i,(0,v.localize)(4,null,g))};switch(d){case"env":if(p){if(u.env){const i=u.env[P.$j?p.toLowerCase():p];if(r.$zf(i))return i}return""}throw new b.$dN(b.VariableKind.Env,(0,v.localize)(5,null,g));case"config":if(p){const i=this.a.getConfigurationValue(f,p);if(r.$If(i))throw new b.$dN(b.VariableKind.Config,(0,v.localize)(6,null,g,p));if(r.$Bf(i))throw new b.$dN(b.VariableKind.Config,(0,v.localize)(7,null,g,p));return i}throw new b.$dN(b.VariableKind.Config,(0,v.localize)(8,null,g));case"command":return this.p(b.VariableKind.Command,g,p,h,"command");case"input":return this.p(b.VariableKind.Input,g,p,h,"input");case"extensionInstallFolder":if(p){const i=await this.a.getExtension(p);if(!i)throw new b.$dN(b.VariableKind.ExtensionInstallFolder,(0,v.localize)(9,null,g,p));return this.n(i.extensionLocation)}throw new b.$dN(b.VariableKind.ExtensionInstallFolder,(0,v.localize)(10,null,g));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,C.$wv)(this.n(n(b.VariableKind.WorkspaceFolder)));case"cwd":return f||p?(0,C.$wv)(this.n(n(b.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,C.$wv)(D.$nc(this.n(n(b.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(u.userHome)return u.userHome;throw new b.$dN(b.VariableKind.UserHome,(0,v.localize)(11,null,g))}case"lineNumber":{const i=this.a.getLineNumber();if(i)return i;throw new b.$dN(b.VariableKind.LineNumber,(0,v.localize)(12,null,g))}case"selectedText":{const i=this.a.getSelectedText();if(i)return i;throw new b.$dN(b.VariableKind.SelectedText,(0,v.localize)(13,null,g))}case"file":return m(b.VariableKind.File);case"fileWorkspaceFolder":return c(b.VariableKind.FileWorkspaceFolder);case"relativeFile":return f||p?D.$lc(this.n(n(b.VariableKind.RelativeFile)),m(b.VariableKind.RelativeFile)):m(b.VariableKind.RelativeFile);case"relativeFileDirname":{const i=D.$mc(m(b.VariableKind.RelativeFileDirname));if(f||p){const o=D.$lc(this.n(n(b.VariableKind.RelativeFileDirname)),i);return o.length===0?".":o}return i}case"fileDirname":return D.$mc(m(b.VariableKind.FileDirname));case"fileExtname":return D.$oc(m(b.VariableKind.FileExtname));case"fileBasename":return D.$nc(m(b.VariableKind.FileBasename));case"fileBasenameNoExtension":{const i=D.$nc(m(b.VariableKind.FileBasenameNoExtension));return i.slice(0,i.length-D.$oc(i).length)}case"fileDirnameBasename":return D.$nc(D.$mc(m(b.VariableKind.FileDirnameBasename)));case"execPath":{const i=this.a.getExecPath();return i||g}case"execInstallFolder":{const i=this.a.getAppRoot();return i||g}case"pathSeparator":return D.sep;default:try{const i=p?`${d}:${p}`:d;return this.p(b.VariableKind.Unknown,g,i,h,void 0)}catch{return g}}}}p(u,g,d,f,h){if(d&&f){const p=h===void 0?f[d]:f[h+":"+d];if(typeof p=="string")return p;throw new b.$dN(u,(0,v.localize)(14,null,g))}return g}}e.$rN=S}),define(pe[272],be([1,0,6,91]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uC=e.$tC=e.OpenEditorContext=e.GroupsOrder=e.$sC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$rC=void 0,e.$rC=(0,D.$Qh)("editorGroupsService");var r;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(r||(e.GroupDirection=r={}));var I;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(I||(e.GroupOrientation=I={}));var P;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(P||(e.GroupLocation=P={}));var C;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EXPAND=1]="EXPAND",g[g.EVEN=2]="EVEN"})(C||(e.GroupsArrangement=C={}));var v;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(v||(e.MergeGroupMode=v={}));function b(g){const d=g;return(0,R.$_D)(d?.editor)&&(0,R.$_D)(d?.replacement)}e.$sC=b;var A;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var S;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function y(g){const d=g;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.$tC=y;function u(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$uC=u}),define(pe[135],be([1,0,6,272]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yC=e.$xC=e.$wC=e.$vC=void 0,e.$vC=(0,D.$Qh)("editorService"),e.$wC=-1,e.$xC=-2;function r(I){const P=I;return typeof I=="number"||(0,R.$tC)(P)}e.$yC=r}),define(pe[273],be([1,0,270,117,90,88,134,91,135,12,223,268,89]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uN=e.$tN=void 0,e.$tN="remoteterminal";let u=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(d,f,h,p,l,m,c,n,i,o){this.a=d,this.b=f,this.c=h,this.d=p,this.e=l,this.f=m,this.g=c,this.h=n,this.i=i,this.j=o}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(d,f,h,p,l,m,c,n){await this.c.whenRemoteConfigurationLoaded();const i=Object.create(null),o=h?this.d.getWorkspaceFolder(h)??void 0:void 0;let s;try{s=(await this.e.resolveAnyMap(o,{shellLaunchConfig:d,configuration:f})).resolvedVariables}catch(x){this.h.error(x)}if(s)for(const[x,ce]of s.entries())(/^config:/.test(x)||x==="selectedText"||x==="lineNumber")&&(i[x]=ce);const t=[];for(const[x,ce]of this.f.collections.entries())t.push([x,(0,I.$or)(ce.map),(0,I.$pr)(ce.descriptionMap)]);const a=await this.g.resolveAuthority(this.a),$=a.options&&a.options.extensionHostEnv,w=this.d.getWorkspace(),k=w.folders,E=h?this.d.getWorkspaceFolder(h):null,L=C.$hE.getOriginalUri(this.i.activeEditor,{supportSideBySide:C.SideBySideEditor.PRIMARY,filterByScheme:[b.Schemas.file,b.Schemas.vscodeUserData,b.Schemas.vscodeRemote]}),j={configuration:f,resolvedVariables:i,envVariableCollections:t,shellLaunchConfig:d,workspaceId:w.id,workspaceName:this.j.getWorkspaceLabel(w),workspaceFolders:k,activeWorkspaceFolder:E,activeFileResource:L,shouldPersistTerminal:l,options:p,cols:m,rows:c,unicodeVersion:n,resolverEnv:$};return await this.b.call("$createProcess",j)}requestDetachInstance(d,f){return this.b.call("$requestDetachInstance",[d,f])}acceptDetachInstanceReply(d,f){return this.b.call("$acceptDetachInstanceReply",[d,f])}attachToProcess(d){return this.b.call("$attachToProcess",[d])}detachFromProcess(d,f){return this.b.call("$detachFromProcess",[d,f])}listProcesses(){return this.b.call("$listProcesses")}getLatency(){return this.b.call("$getLatency")}getPerformanceMarks(){return this.b.call("$getPerformanceMarks")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(d,f){return this.b.call("$processBinary",[d,f])}start(d){return this.b.call("$start",[d])}input(d,f){return this.b.call("$input",[d,f])}acknowledgeDataEvent(d,f){return this.b.call("$acknowledgeDataEvent",[d,f])}setUnicodeVersion(d,f){return this.b.call("$setUnicodeVersion",[d,f])}shutdown(d,f){return this.b.call("$shutdown",[d,f])}resize(d,f,h){return this.b.call("$resize",[d,f,h])}clearBuffer(d){return this.b.call("$clearBuffer",[d])}getInitialCwd(d){return this.b.call("$getInitialCwd",[d])}getCwd(d){return this.b.call("$getCwd",[d])}orphanQuestionReply(d){return this.b.call("$orphanQuestionReply",[d])}sendCommandResult(d,f,h){return this.b.call("$sendCommandResult",[d,f,h])}freePortKillProcess(d){return this.b.call("$freePortKillProcess",[d])}installAutoReply(d,f){return this.b.call("$installAutoReply",[d,f])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(d){return this.b.call("$getDefaultSystemShell",[d])}getProfiles(d,f,h){return this.b.call("$getProfiles",[this.d.getWorkspace().id,d,f,h])}acceptPtyHostResolvedVariables(d,f){return this.b.call("$acceptPtyHostResolvedVariables",[d,f])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(d,f){return this.b.call("$getWslPath",[d,f])}setTerminalLayoutInfo(d){const h={workspaceId:this.d.getWorkspace().id,tabs:d?d.tabs:[]};return this.b.call("$setTerminalLayoutInfo",h)}updateTitle(d,f,h){return this.b.call("$updateTitle",[d,f,h])}updateIcon(d,f,h,p){return this.b.call("$updateIcon",[d,f,h,p])}refreshProperty(d,f){return this.b.call("$refreshProperty",[d,f])}updateProperty(d,f,h){return this.b.call("$updateProperty",[d,f,h])}getTerminalLayoutInfo(){const f={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",f)}reviveTerminalProcesses(d,f,h){return this.b.call("$reviveTerminalProcesses",[d,f,h])}getRevivedPtyNewId(d){return this.b.call("$getRevivedPtyNewId",[d])}serializeTerminalState(d){return this.b.call("$serializeTerminalState",[d])}};e.$uN=u,e.$uN=u=Oe([Ae(2,D.$DD),Ae(3,r.$Zh),Ae(4,P.$cN),Ae(5,S.$TM),Ae(6,R.$Qk),Ae(7,y.$br),Ae(8,v.$vC),Ae(9,A.$3u)],u)}),define(pe[274],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.ExtHostConnectionType=void 0;var D;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class R{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(S){this.pipeName=S,this.type=1}serialize(S){S[R.ENV_KEY]=this.pipeName}}e.$ym=R;class r{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(S){S[r.ENV_KEY]="1"}}e.$zm=r;class I{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(S){S[I.ENV_KEY]="1"}}e.$Am=I;function P(A){delete A[R.ENV_KEY],delete A[r.ENV_KEY],delete A[I.ENV_KEY]}function C(A,S){P(S),A.serialize(S)}e.$Bm=C;function v(A){if(A[R.ENV_KEY])return b(A,new R(A[R.ENV_KEY]));if(A[r.ENV_KEY])return b(A,new r);if(A[I.ENV_KEY])return b(A,new I);throw new Error("No connection information defined in environment!")}e.$Cm=v;function b(A,S){return P(A),S}}),define(pe[275],be([1,0,15]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$dm=e.$cm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var R;(function(b){b[b.Desktop=1]="Desktop",b[b.Web=2]="Web"})(R||(e.UIKind=R={}));var r;(function(b){b[b.VersionMismatch=55]="VersionMismatch",b[b.UnexpectedError=81]="UnexpectedError"})(r||(e.ExtensionHostExitCode=r={}));var I;(function(b){b[b.Initialized=0]="Initialized",b[b.Ready=1]="Ready",b[b.Terminate=2]="Terminate"})(I||(e.MessageType=I={}));function P(b){const A=D.$ce.alloc(1);switch(b){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$cm=P;function C(b,A){if(b.byteLength!==1)return!1;switch(b.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$dm=C;var v;(function(b){b.Start="START_NATIVE_LOG",b.End="END_NATIVE_LOG"})(v||(e.NativeLogMarkers=v={}))}),define(pe[276],be([1,0,6,5,13,264,275,57,38,22,4,2,202]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=e.$JM=e.$IM=e.$HM=void 0;let u=class extends S.$Sc{constructor(h,p){super(),this.s=h,this.t=p,this.a=this.B(new R.$Od),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new R.$Od),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=p.createLogger(this.m,{id:v.$so,name:(0,y.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(p.onDidChangeLogLevel(l=>{(0,r.$aj)(l)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===r.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(h,p,l){const m=this.getTelemetryDetails(),c=new g(p,l,h,this.n,this.j,this.getBuiltInCommonProperties(h),{isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled}),n=this.r.get(h.identifier.value)??[];return this.r.set(h.identifier.value,[...n,c]),c.apiTelemetryLogger}$initializeTelemetryLevel(h,p,l){this.f=h,this.g=p,this.c=l??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(h){const p=Object.create(null);switch(p["common.extname"]=`${h.publisher}.${h.name}`,p["common.extversion"]=h.version,p["common.vscodemachineid"]=this.s.telemetryInfo.machineId,p["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,p["common.vscodeversion"]=this.s.version,p["common.isnewappinstall"]=d(this.s.telemetryInfo.firstSessionDate),p["common.product"]=this.s.environment.appHost,this.s.uiKind){case P.UIKind.Web:p["common.uikind"]="web";break;case P.UIKind.Desktop:p["common.uikind"]="desktop";break;default:p["common.uikind"]="unknown"}return p["common.remotename"]=(0,C.$Wk)((0,v.$zo)(this.s.remote.authority)),p}$onDidChangeTelemetryLevel(h){this.h=this.getTelemetryConfiguration(),this.f=h;const p=this.getTelemetryDetails();this.r.forEach((l,m)=>{const c=l.filter(n=>!n.isDisposed);c.length===0?this.r.delete(m):this.r.set(m,c)}),this.r.forEach(l=>{for(const m of l)m.updateTelemetryEnablements(p.isUsageEnabled,p.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(h,p){const m=this.r.get(h.value)?.filter(n=>!n.isDisposed);if(!m)return this.r.delete(h.value),!1;let c=!1;for(const n of m)n.ignoreUnhandledExtHostErrors||(n.logError(p),c=!0);return c}};e.$HM=u,e.$HM=u=Oe([Ae(0,I.$GM),Ae(1,r.$_i)],u);class g{static validateSender(h){if(typeof h!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof h.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof h.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof h.flush<"u"&&typeof h.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(h,p,l,m,c,n,i){this.g=l,this.h=m,this.i=c,this.j=n,this.a=new R.$Od,this.ignoreUnhandledExtHostErrors=p?.ignoreUnhandledErrors??!1,this.b=p?.ignoreBuiltInCommonProperties??!1,this.c=p?.additionalCommonProperties,this.f=h,this.d={isUsageEnabled:i.isUsageEnabled,isErrorsEnabled:i.isErrorsEnabled}}updateTelemetryEnablements(h,p){this.e&&(this.d={isUsageEnabled:h,isErrorsEnabled:p},this.a.fire(this.e))}mixInCommonPropsAndCleanData(h){let p="properties"in h?h.properties??{}:h;return p=(0,v.$Co)(p,[]),this.c&&(p=(0,b.$$m)(p,this.c)),this.b||(p=(0,b.$$m)(p,this.j)),"properties"in h?h.properties=p:h=p,h}k(h,p){this.f&&(this.g.publisher==="vscode"?h=this.g.name+"/"+h:h=this.g.identifier.value+"/"+h,p=this.mixInCommonPropsAndCleanData(p||{}),this.i||this.f?.sendEventData(h,p),this.h.trace(h,p))}logUsage(h,p){this.d.isUsageEnabled&&this.k(h,p)}logError(h,p){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof h=="string")this.k(h,p);else{const l={name:h.name,message:h.message,stack:h.stack,cause:h.cause},m=(0,v.$Co)(l,[]),c=new Error(m.message,{cause:m.cause});c.stack=m.stack,c.name=m.name,p=this.mixInCommonPropsAndCleanData(p||{}),this.i||this.f.sendErrorData(c,p),this.h.trace("exception",p)}}get apiTelemetryLogger(){if(!this.e){const h=this,p={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h.d.isUsageEnabled},get isErrorsEnabled(){return h.d.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h.a.event.bind(h)};this.e=Object.freeze(p)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let h=this.f;this.f=void 0,Promise.resolve(h.flush()).then(h=void 0),this.e=void 0}else this.f=void 0}}e.$IM=g;function d(f){const h=Date.now()-new Date(f).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.$JM=d,e.$KM=(0,D.$Qh)("IExtHostTelemetry")}),define(pe[277],be([1,0,5,4,36,231,35,6]),function(ue,e,D,R,r,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=e.$oF=e.ActivationKind=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.ExtensionHostStartup=e.$iF=e.$hF=e.$gF=e.$fF=void 0,e.$fF=Object.freeze({identifier:new P.$7l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$gF="extensions.webWorker",e.$hF=(0,C.$Qh)("extensionService");class v{constructor(c){this.dependency=c}}e.$iF=v;var b;(function(m){m[m.EagerAutoStart=1]="EagerAutoStart",m[m.EagerManualStart=2]="EagerManualStart",m[m.Lazy=3]="Lazy"})(b||(e.ExtensionHostStartup=b={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(c,n,i){this.c=c,this.d=n.slice(0),this.e=i.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:I.$3E.createActivationEventsMap(this.d)}}set(c,n,i){if(this.c>c)throw new Error(`ExtensionHostExtensions: invalid versionId ${c} (current: ${this.c})`);const o=[],s=[],t=[],a=[],$=S(this.d),w=S(n),k=(ce,X)=>ce.extensionLocation.toString()===X.extensionLocation.toString()||ce.isBuiltin===X.isBuiltin||ce.isUserBuiltin===X.isUserBuiltin||ce.isUnderDevelopment===X.isUnderDevelopment;for(const ce of this.d){const X=w.get(ce.identifier);if(!X){o.push(ce.identifier),$.delete(ce.identifier);continue}if(!k(ce,X)){o.push(ce.identifier),$.delete(ce.identifier);continue}}for(const ce of n){const X=$.get(ce.identifier);if(!X){s.push(ce);continue}if(!k(X,ce)){o.push(X.identifier),$.delete(X.identifier);continue}}const E=new P.$8l(this.e),L=new P.$8l(i);for(const ce of this.e)L.has(ce)||t.push(ce);for(const ce of i)E.has(ce)||a.push(ce);const j=I.$3E.createActivationEventsMap(s),x={versionId:c,toRemove:o,toAdd:s,addActivationEvents:j,myToRemove:t,myToAdd:a};return this.delta(x),x}delta(c){if(this.c>=c.versionId)return null;const{toRemove:n,toAdd:i,myToRemove:o,myToAdd:s}=c,t=new P.$8l(n),a=new P.$8l(o);for(let $=0;$<this.d.length;$++)t.has(this.d[$].identifier)&&(this.d.splice($,1),$--);for(let $=0;$<this.e.length;$++)a.has(this.e[$])&&(this.e.splice($,1),$--);for(const $ of i)this.d.push($);for(const $ of s)this.e.push($);return c}containsExtension(c){for(const n of this.e)if(P.$7l.equals(n,c))return!0;return!1}}e.$jF=A;function S(m){const c=new P.$9l;for(const n of m)c.set(n.identifier,n);return c}function y(m,c){return m.enabledApiProposals?m.enabledApiProposals.includes(c):!1}e.$kF=y;function u(m,c){if(!y(m,c))throw new Error(`Extension '${m.identifier.value}' CANNOT use API proposal: ${c}.
Its package.json#enabledApiProposals-property declares: ${m.enabledApiProposals?.join(", ")??"[]"} but NOT ${c}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${m.identifier.value}`)}e.$lF=u;class g{constructor(c,n,i,o){this.codeLoadingTime=c,this.activateCallTime=n,this.activateResolvedTime=i,this.activationReason=o}}e.$mF=g;class d{constructor(c,n){this.description=c,this.value=n}}e.$nF=d;var f;(function(m){m[m.Normal=0]="Normal",m[m.Immediate=1]="Immediate"})(f||(e.ActivationKind=f={}));function h(m){return{type:m.isBuiltin?0:1,isBuiltin:m.isBuiltin||m.isUserBuiltin,identifier:{id:(0,r.$Io)(m.publisher,m.name),uuid:m.uuid},manifest:m,location:m.extensionLocation,targetPlatform:m.targetPlatform,validations:[],isValid:!0}}e.$oF=h;function p(m,c){return{identifier:new P.$7l((0,r.$Go)(m.manifest.publisher,m.manifest.name)),isBuiltin:m.type===0,isUserBuiltin:m.type===1&&m.isBuiltin,isUnderDevelopment:!!c,extensionLocation:m.location,...m.manifest,uuid:m.identifier.uuid,targetPlatform:m.targetPlatform}}e.$pF=p;class l{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(c){return Promise.resolve(void 0)}activationEventIsDone(c){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(c){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(c,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(c){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$qF=l}),define(pe[136],be([1,0,18,15,150,74,100,26,143,50,63,22,10,4,42,172,227,133,91,130,71,92,135,131,277]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u,g,d,f,h,p,l,m,c,n,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$pM=e.$oM=e.MarkdownString=e.$nM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(ve){function De(G){const{selectionStartLineNumber:Se,selectionStartColumn:Re,positionLineNumber:qe,positionColumn:Te}=G,xe=new i.$sK(Se-1,Re-1),at=new i.$sK(qe-1,Te-1);return new i.$uK(xe,at)}ve.to=De;function fe(G){const{anchor:Se,active:Re}=G;return{selectionStartLineNumber:Se.line+1,selectionStartColumn:Se.character+1,positionLineNumber:Re.line+1,positionColumn:Re.character+1}}ve.from=fe})(s||(e.Selection=s={}));var t;(function(ve){function De(G){if(!G)return;const{start:Se,end:Re}=G;return{startLineNumber:Se.line+1,startColumn:Se.character+1,endLineNumber:Re.line+1,endColumn:Re.character+1}}ve.from=De;function fe(G){if(!G)return;const{startLineNumber:Se,startColumn:Re,endLineNumber:qe,endColumn:Te}=G;return new i.$tK(Se-1,Re-1,qe-1,Te-1)}ve.to=fe})(t||(e.Range=t={}));var a;(function(ve){function De(fe){switch(fe){case 1:return i.StandardTokenType.Comment;case 0:return i.StandardTokenType.Other;case 3:return i.StandardTokenType.RegEx;case 2:return i.StandardTokenType.String}}ve.to=De})(a||(e.TokenType=a={}));var $;(function(ve){function De(G){return new i.$sK(G.lineNumber-1,G.column-1)}ve.to=De;function fe(G){return{lineNumber:G.line+1,column:G.character+1}}ve.from=fe})($||(e.Position=$={}));var w;(function(ve){function De(Se,Re,qe){return(0,D.$Hb)((0,D.$3b)(Se).map(Te=>fe(Te,Re,qe)))}ve.from=De;function fe(Se,Re,qe){if(typeof Se=="string")return{$serialized:!0,language:Se,isBuiltin:qe?.isBuiltin};if(Se)return{$serialized:!0,language:Se.language,scheme:G(Se.scheme,Re),pattern:He.from(Se.pattern)??void 0,exclusive:Se.exclusive,notebookType:Se.notebookType,isBuiltin:qe?.isBuiltin}}function G(Se,Re){return Re&&typeof Se=="string"?Re.transformOutgoingScheme(Se):Se}})(w||(e.DocumentSelector=w={}));var k;(function(ve){function De(G){switch(G){case i.DiagnosticTag.Unnecessary:return 1;case i.DiagnosticTag.Deprecated:return 2}}ve.from=De;function fe(G){switch(G){case 1:return i.DiagnosticTag.Unnecessary;case 2:return i.DiagnosticTag.Deprecated;default:return}}ve.to=fe})(k||(e.DiagnosticTag=k={}));var E;(function(ve){function De(G){let Se;return G.code&&((0,y.$zf)(G.code)||(0,y.$Df)(G.code)?Se=String(G.code):Se={value:String(G.code.value),target:G.code.target}),{...t.from(G.range),message:G.message,source:G.source,code:Se,severity:j.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(L.from),tags:Array.isArray(G.tags)?(0,D.$Hb)(G.tags.map(k.from)):void 0}}ve.from=De;function fe(G){const Se=new i.$FK(t.to(G),G.message,j.to(G.severity));return Se.source=G.source,Se.code=(0,y.$zf)(G.code)?G.code:G.code?.value,Se.relatedInformation=G.relatedInformation&&G.relatedInformation.map(L.to),Se.tags=G.tags&&(0,D.$Hb)(G.tags.map(k.to)),Se}ve.to=fe})(E||(e.Diagnostic=E={}));var L;(function(ve){function De(G){return{...t.from(G.location.range),message:G.message,resource:G.location.uri}}ve.from=De;function fe(G){return new i.$EK(new i.$DK(G.resource,t.to(G)),G.message)}ve.to=fe})(L||(e.DiagnosticRelatedInformation=L={}));var j;(function(ve){function De(G){switch(G){case i.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case i.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case i.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case i.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}ve.from=De;function fe(G){switch(G){case f.MarkerSeverity.Info:return i.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return i.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return i.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return i.DiagnosticSeverity.Hint;default:return i.DiagnosticSeverity.Error}}ve.to=fe})(j||(e.DiagnosticSeverity=j={}));var x;(function(ve){function De(G){return typeof G=="number"&&G>=i.ViewColumn.One?G-1:G===i.ViewColumn.Beside?n.$xC:n.$wC}ve.from=De;function fe(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}ve.to=fe})(x||(e.ViewColumn=x={}));function ce(ve){return typeof ve.range<"u"}function X(ve){return ve.length===0?!0:!!ce(ve[0])}e.$nM=X;var ie;(function(ve){function De(Te){return Te.map(ve.from)}ve.fromMany=De;function fe(Te){return Te&&typeof Te=="object"&&typeof Te.language=="string"&&typeof Te.value=="string"}function G(Te){let xe;if(fe(Te)){const{language:rt,value:ht}=Te;xe={value:"```"+rt+`
`+ht+"\n```\n"}}else i.$RK.isMarkdownString(Te)?xe={value:Te.value,isTrusted:Te.isTrusted,supportThemeIcons:Te.supportThemeIcons,supportHtml:Te.supportHtml,baseUri:Te.baseUri}:typeof Te=="string"?xe={value:Te}:xe={value:""};const at=Object.create(null);xe.uris=at;const Dt=rt=>{try{let ht=u.URI.parse(rt,!0);ht=ht.with({query:Se(ht.query,at)}),at[rt]=ht}catch{}return""},bt=new v.marked.Renderer;return bt.link=Dt,bt.image=rt=>typeof rt=="string"?Dt(P.$$j(rt).href):"",(0,v.marked)(xe.value,{renderer:bt}),xe}ve.from=G;function Se(Te,xe){if(!Te)return Te;let at;try{at=(0,b.$mh)(Te)}catch{}if(!at)return Te;let Dt=!1;return at=(0,S.$0m)(at,bt=>{if(u.URI.isUri(bt)){const rt=`__uri_${Math.random().toString(16).slice(2,8)}`;return xe[rt]=bt,Dt=!0,rt}else return}),Dt?JSON.stringify(at):Te}function Re(Te){const xe=new i.$RK(Te.value,Te.supportThemeIcons);return xe.isTrusted=Te.isTrusted,xe.supportHtml=Te.supportHtml,xe.baseUri=Te.baseUri?u.URI.from(Te.baseUri):void 0,xe}ve.to=Re;function qe(Te){if(Te)return typeof Te=="string"?Te:ve.from(Te)}ve.fromStrict=qe})(ie||(e.MarkdownString=ie={}));function he(ve){return X(ve)?ve.map(De=>({range:t.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?ie.fromMany(De.hoverMessage):De.hoverMessage?ie.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):ve.map(De=>({range:t.from(De)}))}e.$oM=he;function _(ve){return typeof ve>"u"?ve:typeof ve=="string"?u.URI.file(ve):ve}e.$pM=_;var de;(function(ve){function De(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?_(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}ve.from=De})(de||(e.ThemableDecorationAttachmentRenderOptions=de={}));var Z;(function(ve){function De(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?_(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?de.from(fe.before):void 0,after:fe.after?de.from(fe.after):void 0}}ve.from=De})(Z||(e.ThemableDecorationRenderOptions=Z={}));var ne;(function(ve){function De(fe){if(typeof fe>"u")return fe;switch(fe){case i.DecorationRangeBehavior.OpenOpen:return 0;case i.DecorationRangeBehavior.ClosedClosed:return 1;case i.DecorationRangeBehavior.OpenClosed:return 2;case i.DecorationRangeBehavior.ClosedOpen:return 3}}ve.from=De})(ne||(e.DecorationRangeBehavior=ne={}));var J;(function(ve){function De(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?ne.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?Z.from(fe.light):void 0,dark:fe.dark?Z.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?_(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?de.from(fe.before):void 0,after:fe.after?de.from(fe.after):void 0}}ve.from=De})(J||(e.DecorationRenderOptions=J={}));var W;(function(ve){function De(G){return{text:G.newText,eol:G.newEol&&ge.from(G.newEol),range:t.from(G.range)}}ve.from=De;function fe(G){const Se=new i.$yK(t.to(G.range),G.text);return Se.newEol=typeof G.eol>"u"?void 0:ge.to(G.eol),Se}ve.to=fe})(W||(e.TextEdit=W={}));var oe;(function(ve){function De(G,Se){const Re={edits:[]};if(G instanceof i.$BK){const qe=new C.$Bc;for(const Te of G._allEntries())Te._type===1&&u.URI.isUri(Te.to)&&Te.from===void 0&&qe.add(Te.to);for(const Te of G._allEntries())if(Te._type===1){let xe;Te.options?.contents&&(ArrayBuffer.isView(Te.options.contents)?xe={type:"base64",value:(0,R.$we)(R.$ce.wrap(Te.options.contents))}:xe={type:"dataTransferItem",id:Te.options.contents._itemId}),Re.edits.push({oldResource:Te.from,newResource:Te.to,options:{...Te.options,contents:xe},metadata:Te.metadata})}else Te._type===2?Re.edits.push({resource:Te.uri,textEdit:W.from(Te.edit),versionId:qe.has(Te.uri)?void 0:Se?.getTextDocumentVersion(Te.uri),metadata:Te.metadata}):Te._type===6?Re.edits.push({resource:Te.uri,textEdit:{range:t.from(Te.range),text:Te.edit.value,insertAsSnippet:!0},versionId:qe.has(Te.uri)?void 0:Se?.getTextDocumentVersion(Te.uri),metadata:Te.metadata}):Te._type===3?Re.edits.push({metadata:Te.metadata,resource:Te.uri,cellEdit:Te.edit,notebookMetadata:Te.notebookMetadata,notebookVersionId:Se?.getNotebookDocumentVersion(Te.uri)}):Te._type===5&&Re.edits.push({metadata:Te.metadata,resource:Te.uri,notebookVersionId:Se?.getNotebookDocumentVersion(Te.uri),cellEdit:{editType:1,index:Te.index,count:Te.count,cells:Te.cells.map(st.from)}})}return Re}ve.from=De;function fe(G){const Se=new i.$BK,Re=new C.$Ac;for(const qe of G.edits)if(qe.textEdit){const Te=qe,xe=u.URI.revive(Te.resource),at=t.to(Te.textEdit.range),Dt=Te.textEdit.text,bt=Te.textEdit.insertAsSnippet;let rt;bt?rt=i.$AK.replace(at,new i.$CK(Dt)):rt=i.$yK.replace(at,Dt);const ht=Re.get(xe);ht?ht.push(rt):Re.set(xe,[rt])}else Se.renameFile(u.URI.revive(qe.oldResource),u.URI.revive(qe.newResource),qe.options);for(const[qe,Te]of Re)Se.set(qe,Te);return Se}ve.to=fe})(oe||(e.WorkspaceEdit=oe={}));var le;(function(ve){const De=Object.create(null);De[i.SymbolKind.File]=0,De[i.SymbolKind.Module]=1,De[i.SymbolKind.Namespace]=2,De[i.SymbolKind.Package]=3,De[i.SymbolKind.Class]=4,De[i.SymbolKind.Method]=5,De[i.SymbolKind.Property]=6,De[i.SymbolKind.Field]=7,De[i.SymbolKind.Constructor]=8,De[i.SymbolKind.Enum]=9,De[i.SymbolKind.Interface]=10,De[i.SymbolKind.Function]=11,De[i.SymbolKind.Variable]=12,De[i.SymbolKind.Constant]=13,De[i.SymbolKind.String]=14,De[i.SymbolKind.Number]=15,De[i.SymbolKind.Boolean]=16,De[i.SymbolKind.Array]=17,De[i.SymbolKind.Object]=18,De[i.SymbolKind.Key]=19,De[i.SymbolKind.Null]=20,De[i.SymbolKind.EnumMember]=21,De[i.SymbolKind.Struct]=22,De[i.SymbolKind.Event]=23,De[i.SymbolKind.Operator]=24,De[i.SymbolKind.TypeParameter]=25;function fe(Se){return typeof De[Se]=="number"?De[Se]:6}ve.from=fe;function G(Se){for(const Re in De)if(De[Re]===Se)return Number(Re);return i.SymbolKind.Property}ve.to=G})(le||(e.SymbolKind=le={}));var re;(function(ve){function De(G){switch(G){case i.SymbolTag.Deprecated:return 1}}ve.from=De;function fe(G){switch(G){case 1:return i.SymbolTag.Deprecated}}ve.to=fe})(re||(e.SymbolTag=re={}));var ee;(function(ve){function De(G){return{name:G.name,kind:le.from(G.kind),tags:G.tags&&G.tags.map(re.from),containerName:G.containerName,location:U.from(G.location)}}ve.from=De;function fe(G){const Se=new i.$IK(G.name,le.to(G.kind),G.containerName,U.to(G.location));return Se.tags=G.tags&&G.tags.map(re.to),Se}ve.to=fe})(ee||(e.WorkspaceSymbol=ee={}));var B;(function(ve){function De(G){const Se={name:G.name||"!!MISSING: name!!",detail:G.detail,range:t.from(G.range),selectionRange:t.from(G.selectionRange),kind:le.from(G.kind),tags:G.tags?.map(re.from)??[]};return G.children&&(Se.children=G.children.map(De)),Se}ve.from=De;function fe(G){const Se=new i.$JK(G.name,G.detail,le.to(G.kind),t.to(G.range),t.to(G.selectionRange));return(0,D.$Lb)(G.tags)&&(Se.tags=G.tags.map(re.to)),G.children&&(Se.children=G.children.map(fe)),Se}ve.to=fe})(B||(e.DocumentSymbol=B={}));var K;(function(ve){function De(G){const Se=new i.$NK(le.to(G.kind),G.name,G.detail||"",u.URI.revive(G.uri),t.to(G.range),t.to(G.selectionRange));return Se._sessionId=G._sessionId,Se._itemId=G._itemId,Se}ve.to=De;function fe(G,Se,Re){if(Se=Se??G._sessionId,Re=Re??G._itemId,Se===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Re,name:G.name,detail:G.detail,kind:le.from(G.kind),uri:G.uri,range:t.from(G.range),selectionRange:t.from(G.selectionRange),tags:G.tags?.map(re.from)}}ve.from=fe})(K||(e.CallHierarchyItem=K={}));var N;(function(ve){function De(fe){return new i.$OK(K.to(fe.from),fe.fromRanges.map(G=>t.to(G)))}ve.to=De})(N||(e.CallHierarchyIncomingCall=N={}));var O;(function(ve){function De(fe){return new i.$PK(K.to(fe.to),fe.fromRanges.map(G=>t.to(G)))}ve.to=De})(O||(e.CallHierarchyOutgoingCall=O={}));var U;(function(ve){function De(G){return{range:G.range&&t.from(G.range),uri:G.uri}}ve.from=De;function fe(G){return new i.$DK(u.URI.revive(G.uri),t.to(G.range))}ve.to=fe})(U||(e.location=U={}));var T;(function(ve){function De(G){const Se=G,Re=G;return{originSelectionRange:Se.originSelectionRange?t.from(Se.originSelectionRange):void 0,uri:Se.targetUri?Se.targetUri:Re.uri,range:t.from(Se.targetRange?Se.targetRange:Re.range),targetSelectionRange:Se.targetSelectionRange?t.from(Se.targetSelectionRange):void 0}}ve.from=De;function fe(G){return{targetUri:u.URI.revive(G.uri),targetRange:t.to(G.range),targetSelectionRange:G.targetSelectionRange?t.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?t.to(G.originSelectionRange):void 0}}ve.to=fe})(T||(e.DefinitionLink=T={}));var q;(function(ve){function De(G){return{range:t.from(G.range),contents:ie.fromMany(G.contents)}}ve.from=De;function fe(G){return new i.$GK(G.contents.map(ie.to),t.to(G.range))}ve.to=fe})(q||(e.Hover=q={}));var z;(function(ve){function De(G){return{range:t.from(G.range),expression:G.expression}}ve.from=De;function fe(G){return new i.$zL(t.to(G.range),G.expression)}ve.to=fe})(z||(e.EvaluatableExpression=z={}));var te;(function(ve){function De(G){if(G instanceof i.$AL)return{type:"text",range:t.from(G.range),text:G.text};if(G instanceof i.$BL)return{type:"variable",range:t.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof i.$CL)return{type:"expression",range:t.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}ve.from=De;function fe(G){switch(G.type){case"text":return{range:t.to(G.range),text:G.text};case"variable":return{range:t.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:t.to(G.range),expression:G.expression}}}ve.to=fe})(te||(e.InlineValue=te={}));var H;(function(ve){function De(G){return{frameId:G.frameId,stoppedLocation:t.from(G.stoppedLocation)}}ve.from=De;function fe(G){return new i.$DL(G.frameId,t.to(G.stoppedLocation))}ve.to=fe})(H||(e.InlineValueContext=H={}));var Y;(function(ve){function De(G){return{range:t.from(G.range),kind:G.kind}}ve.from=De;function fe(G){return new i.$HK(t.to(G.range),G.kind)}ve.to=fe})(Y||(e.DocumentHighlight=Y={}));var V;(function(ve){function De(fe){switch(fe){case 1:return i.CompletionTriggerKind.TriggerCharacter;case 2:return i.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return i.CompletionTriggerKind.Invoke}}ve.to=De})(V||(e.CompletionTriggerKind=V={}));var Q;(function(ve){function De(fe){return{triggerKind:V.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}ve.to=De})(Q||(e.CompletionContext=Q={}));var se;(function(ve){function De(G){switch(G){case i.CompletionItemTag.Deprecated:return 1}}ve.from=De;function fe(G){switch(G){case 1:return i.CompletionItemTag.Deprecated}}ve.to=fe})(se||(e.CompletionItemTag=se={}));var me;(function(ve){const De=new Map([[i.CompletionItemKind.Method,0],[i.CompletionItemKind.Function,1],[i.CompletionItemKind.Constructor,2],[i.CompletionItemKind.Field,3],[i.CompletionItemKind.Variable,4],[i.CompletionItemKind.Class,5],[i.CompletionItemKind.Interface,7],[i.CompletionItemKind.Struct,6],[i.CompletionItemKind.Module,8],[i.CompletionItemKind.Property,9],[i.CompletionItemKind.Unit,12],[i.CompletionItemKind.Value,13],[i.CompletionItemKind.Constant,14],[i.CompletionItemKind.Enum,15],[i.CompletionItemKind.EnumMember,16],[i.CompletionItemKind.Keyword,17],[i.CompletionItemKind.Snippet,27],[i.CompletionItemKind.Text,18],[i.CompletionItemKind.Color,19],[i.CompletionItemKind.File,20],[i.CompletionItemKind.Reference,21],[i.CompletionItemKind.Folder,23],[i.CompletionItemKind.Event,10],[i.CompletionItemKind.Operator,11],[i.CompletionItemKind.TypeParameter,24],[i.CompletionItemKind.Issue,26],[i.CompletionItemKind.User,25]]);function fe(Re){return De.get(Re)??9}ve.from=fe;const G=new Map([[0,i.CompletionItemKind.Method],[1,i.CompletionItemKind.Function],[2,i.CompletionItemKind.Constructor],[3,i.CompletionItemKind.Field],[4,i.CompletionItemKind.Variable],[5,i.CompletionItemKind.Class],[7,i.CompletionItemKind.Interface],[6,i.CompletionItemKind.Struct],[8,i.CompletionItemKind.Module],[9,i.CompletionItemKind.Property],[12,i.CompletionItemKind.Unit],[13,i.CompletionItemKind.Value],[14,i.CompletionItemKind.Constant],[15,i.CompletionItemKind.Enum],[16,i.CompletionItemKind.EnumMember],[17,i.CompletionItemKind.Keyword],[27,i.CompletionItemKind.Snippet],[18,i.CompletionItemKind.Text],[19,i.CompletionItemKind.Color],[20,i.CompletionItemKind.File],[21,i.CompletionItemKind.Reference],[23,i.CompletionItemKind.Folder],[10,i.CompletionItemKind.Event],[11,i.CompletionItemKind.Operator],[24,i.CompletionItemKind.TypeParameter],[25,i.CompletionItemKind.User],[26,i.CompletionItemKind.Issue]]);function Se(Re){return G.get(Re)??i.CompletionItemKind.Property}ve.to=Se})(me||(e.CompletionItemKind=me={}));var Ee;(function(ve){function De(fe,G){const Se=new i.$XK(fe.label);return Se.insertText=fe.insertText,Se.kind=me.to(fe.kind),Se.tags=fe.tags?.map(se.to),Se.detail=fe.detail,Se.documentation=P.$6j(fe.documentation)?ie.to(fe.documentation):fe.documentation,Se.sortText=fe.sortText,Se.filterText=fe.filterText,Se.preselect=fe.preselect,Se.commitCharacters=fe.commitCharacters,g.$xs.isIRange(fe.range)?Se.range=t.to(fe.range):typeof fe.range=="object"&&(Se.range={inserting:t.to(fe.range.insert),replacing:t.to(fe.range.replace)}),Se.keepWhitespace=typeof fe.insertTextRules>"u"?!1:!!(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Se.insertText=new i.$CK(fe.insertText):(Se.insertText=fe.insertText,Se.textEdit=Se.range instanceof i.$tK?new i.$yK(Se.range,Se.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Se.additionalTextEdits=fe.additionalTextEdits.map(Re=>W.to(Re))),Se.command=G&&fe.command?G.fromInternal(fe.command):void 0,Se}ve.to=De})(Ee||(e.CompletionItem=Ee={}));var Ce;(function(ve){function De(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:ie.fromStrict(G.documentation)}}ve.from=De;function fe(G){return{label:G.label,documentation:P.$6j(G.documentation)?ie.to(G.documentation):G.documentation}}ve.to=fe})(Ce||(e.ParameterInformation=Ce={}));var Le;(function(ve){function De(G){return{label:G.label,documentation:ie.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(Ce.from):[],activeParameter:G.activeParameter}}ve.from=De;function fe(G){return{label:G.label,documentation:P.$6j(G.documentation)?ie.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(Ce.to):[],activeParameter:G.activeParameter}}ve.to=fe})(Le||(e.SignatureInformation=Le={}));var Fe;(function(ve){function De(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(Le.from):[]}}ve.from=De;function fe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(Le.to):[]}}ve.to=fe})(Fe||(e.SignatureHelp=Fe={}));var $e;(function(ve){function De(fe,G){const Se=new i.$WK($.to(G.position),typeof G.label=="string"?G.label:G.label.map(ke.to.bind(void 0,fe)),G.kind&&ye.to(G.kind));return Se.textEdits=G.textEdits&&G.textEdits.map(W.to),Se.tooltip=P.$6j(G.tooltip)?ie.to(G.tooltip):G.tooltip,Se.paddingLeft=G.paddingLeft,Se.paddingRight=G.paddingRight,Se}ve.to=De})($e||(e.InlayHint=$e={}));var ke;(function(ve){function De(fe,G){const Se=new i.$VK(G.label);return Se.tooltip=P.$6j(G.tooltip)?ie.to(G.tooltip):G.tooltip,d.Command.is(G.command)&&(Se.command=fe.fromInternal(G.command)),G.location&&(Se.location=U.to(G.location)),Se}ve.to=De})(ke||(e.InlayHintLabelPart=ke={}));var ye;(function(ve){function De(G){return G}ve.from=De;function fe(G){return G}ve.to=fe})(ye||(e.InlayHintKind=ye={}));var Me;(function(ve){function De(G){return{range:t.from(G.range),url:G.target,tooltip:G.tooltip}}ve.from=De;function fe(G){let Se;if(G.url)try{Se=typeof G.url=="string"?u.URI.parse(G.url,!0):u.URI.revive(G.url)}catch{}return new i.$3K(t.to(G.range),Se)}ve.to=fe})(Me||(e.DocumentLink=Me={}));var Ue;(function(ve){function De(G){const Se=new i.$6K(G.label);return G.textEdit&&(Se.textEdit=W.to(G.textEdit)),G.additionalTextEdits&&(Se.additionalTextEdits=G.additionalTextEdits.map(Re=>W.to(Re))),Se}ve.to=De;function fe(G){return{label:G.label,textEdit:G.textEdit?W.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Se=>W.from(Se)):void 0}}ve.from=fe})(Ue||(e.ColorPresentation=Ue={}));var Ze;(function(ve){function De(G){return new i.$4K(G[0],G[1],G[2],G[3])}ve.to=De;function fe(G){return[G.red,G.green,G.blue,G.alpha]}ve.from=fe})(Ze||(e.Color=Ze={}));var We;(function(ve){function De(G){return{range:t.from(G.range)}}ve.from=De;function fe(G){return new i.$MK(t.to(G.range))}ve.to=fe})(We||(e.SelectionRange=We={}));var Xe;(function(ve){function De(fe){switch(fe){case 2:return i.TextDocumentSaveReason.AfterDelay;case 1:return i.TextDocumentSaveReason.Manual;case 3:case 4:return i.TextDocumentSaveReason.FocusOut}}ve.to=De})(Xe||(e.TextDocumentSaveReason=Xe={}));var Qe;(function(ve){function De(G){switch(G){case i.TextEditorLineNumbersStyle.Off:return 0;case i.TextEditorLineNumbersStyle.Relative:return 2;case i.TextEditorLineNumbersStyle.On:default:return 1}}ve.from=De;function fe(G){switch(G){case 0:return i.TextEditorLineNumbersStyle.Off;case 2:return i.TextEditorLineNumbersStyle.Relative;case 1:default:return i.TextEditorLineNumbersStyle.On}}ve.to=fe})(Qe||(e.TextEditorLineNumbersStyle=Qe={}));var ge;(function(ve){function De(G){if(G===i.EndOfLine.CRLF)return 1;if(G===i.EndOfLine.LF)return 0}ve.from=De;function fe(G){if(G===1)return i.EndOfLine.CRLF;if(G===0)return i.EndOfLine.LF}ve.to=fe})(ge||(e.EndOfLine=ge={}));var Pe;(function(ve){function De(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case i.ProgressLocation.SourceControl:return 3;case i.ProgressLocation.Window:return 10;case i.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ve.from=De})(Pe||(e.ProgressLocation=Pe={}));var Ie;(function(ve){function De(G){const Se={start:G.start+1,end:G.end+1};return G.kind&&(Se.kind=Ne.from(G.kind)),Se}ve.from=De;function fe(G){const Se={start:G.start-1,end:G.end-1};return G.kind&&(Se.kind=Ne.to(G.kind)),Se}ve.to=fe})(Ie||(e.FoldingRange=Ie={}));var Ne;(function(ve){function De(G){if(G)switch(G){case i.FoldingRangeKind.Comment:return d.$mt.Comment;case i.FoldingRangeKind.Imports:return d.$mt.Imports;case i.FoldingRangeKind.Region:return d.$mt.Region}}ve.from=De;function fe(G){if(G)switch(G.value){case d.$mt.Comment.value:return i.FoldingRangeKind.Comment;case d.$mt.Imports.value:return i.FoldingRangeKind.Imports;case d.$mt.Region.value:return i.FoldingRangeKind.Region}}ve.to=fe})(Ne||(e.FoldingRangeKind=Ne={}));var ze;(function(ve){function De(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?t.from(fe.selection):void 0,override:typeof fe.override=="boolean"?p.$YD.id:void 0}}ve.from=De})(ze||(e.TextEditorOpenOptions=ze={}));var He;(function(ve){function De(Re){return Re instanceof i.$nL?Re.toJSON():typeof Re=="string"?Re:fe(Re)||G(Re)?new i.$nL(Re.baseUri??Re.base,Re.pattern).toJSON():Re}ve.from=De;function fe(Re){const qe=Re;return qe?u.URI.isUri(qe.baseUri)&&typeof qe.pattern=="string":!1}function G(Re){const qe=Re;return qe?typeof qe.base=="string"&&typeof qe.pattern=="string":!1}function Se(Re){return typeof Re=="string"?Re:new i.$nL(u.URI.revive(Re.baseUri),Re.pattern)}ve.to=Se})(He||(e.GlobPattern=He={}));var Be;(function(ve){function De(fe){if(fe){if(Array.isArray(fe))return fe.map(De);if(typeof fe=="string")return fe;{const G=fe;return{language:G.language,scheme:G.scheme,pattern:He.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}ve.from=De})(Be||(e.LanguageSelector=Be={}));var Ve;(function(ve){function De(G){return!!G&&typeof G=="object"&&"documents"in G&&Array.isArray(G.documents)&&G.documents.every(Se=>Array.isArray(Se)&&Se.every(Re=>Re&&typeof Re=="object"&&"uri"in Re&&u.URI.isUri(Re.uri)&&"version"in Re&&typeof Re.version=="number"&&"ranges"in Re&&Array.isArray(Re.ranges)&&Re.ranges.every(qe=>qe instanceof i.$tK)))}ve.is=De;function fe(G){return{documents:G.documents.map(Se=>Se.map(Re=>({uri:u.URI.from(Re.uri),version:Re.version,ranges:Re.ranges.map(qe=>t.from(qe))})))}}ve.from=fe})(Ve||(e.MappedEditsContext=Ve={}));var Je;(function(ve){function De(G){return{start:G.start,end:G.end}}ve.from=De;function fe(G){return new i.$OL(G.start,G.end)}ve.to=fe})(Je||(e.NotebookRange=Je={}));var Ge;(function(ve){function De(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}ve.to=De;function fe(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}ve.from=fe})(Ge||(e.NotebookCellExecutionSummary=Ge={}));var Ye;(function(ve){function De(fe){if(fe===l.NotebookCellExecutionState.Unconfirmed)return i.NotebookCellExecutionState.Pending;if(fe===l.NotebookCellExecutionState.Pending)return;if(fe===l.NotebookCellExecutionState.Executing)return i.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}ve.to=De})(Ye||(e.NotebookCellExecutionState=Ye={}));var it;(function(ve){function De(G){switch(G){case i.NotebookCellKind.Markup:return l.CellKind.Markup;case i.NotebookCellKind.Code:default:return l.CellKind.Code}}ve.from=De;function fe(G){switch(G){case l.CellKind.Markup:return i.NotebookCellKind.Markup;case l.CellKind.Code:default:return i.NotebookCellKind.Code}}ve.to=fe})(it||(e.NotebookCellKind=it={}));var _e;(function(ve){function De(G){const Se={metadata:G.metadata??Object.create(null),cells:[]};for(const Re of G.cells)i.$PL.validate(Re),Se.cells.push(st.from(Re));return Se}ve.from=De;function fe(G){const Se=new i.$QL(G.cells.map(st.to));return(0,y.$Mf)(G.metadata)||(Se.metadata=G.metadata),Se}ve.to=fe})(_e||(e.NotebookData=_e={}));var st;(function(ve){function De(G){return{cellKind:it.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:Ge.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(vt.from):[]}}ve.from=De;function fe(G){return new i.$PL(it.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(vt.to):void 0,G.metadata,G.internalMetadata?Ge.to(G.internalMetadata):void 0)}ve.to=fe})(st||(e.NotebookCellData=st={}));var ot;(function(ve){function De(G){return{mime:G.mime,valueBytes:R.$ce.wrap(G.data)}}ve.from=De;function fe(G){return new i.$RL(G.valueBytes.buffer,G.mime)}ve.to=fe})(ot||(e.NotebookCellOutputItem=ot={}));var vt;(function(ve){function De(G){return{outputId:G.id,items:G.items.map(ot.from),metadata:G.metadata}}ve.from=De;function fe(G){const Se=G.items.map(ot.to);return new i.$SL(Se,G.outputId,G.metadata)}ve.to=fe})(vt||(e.NotebookCellOutput=vt={}));var dt;(function(ve){function De(Se){return G(Se)?{include:He.from(Se.include)??void 0,exclude:He.from(Se.exclude)??void 0}:He.from(Se)??void 0}ve.from=De;function fe(Se){return G(Se)?{include:He.to(Se.include),exclude:He.to(Se.exclude)}:He.to(Se)}ve.to=fe;function G(Se){const Re=Se;return Re?!(0,y.$If)(Re.include)&&!(0,y.$If)(Re.exclude):!1}})(dt||(e.NotebookExclusiveDocumentPattern=dt={}));var ft;(function(ve){function De(fe,G,Se){const Re=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===i.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Re,Se),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}ve.from=De})(ft||(e.NotebookStatusBarItem=ft={}));var Tt;(function(ve){function De(fe,G,Se){const Re=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:G.toInternal(Re,Se),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}ve.from=De})(Tt||(e.NotebookKernelSourceAction=Tt={}));var Ut;(function(ve){function De(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}ve.from=De})(Ut||(e.NotebookDocumentContentOptions=Ut={}));var yt;(function(ve){function De(G){return{uri:G.uri,provides:G.provides}}ve.from=De;function fe(G){return new i.$UL(u.URI.revive(G.uri),G.provides)}ve.to=fe})(yt||(e.NotebookRendererScript=yt={}));var Et;(function(ve){function De(G){return{message:ie.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:t.from(G.location.range),uri:G.location.uri}}}ve.from=De;function fe(G){const Se=new i.$1L(typeof G.message=="string"?G.message:ie.to(G.message));return Se.actualOutput=G.actual,Se.expectedOutput=G.expected,Se.contextValue=G.contextValue,Se.location=G.location?U.to(G.location):void 0,Se}ve.to=fe})(Et||(e.TestMessage=Et={}));var ct;(function(ve){ve.namespace=c.$mJ,ve.denamespace=c.$nJ})(ct||(e.TestTag=ct={}));var kt;(function(ve){function De(G){const Se=(0,h.$mM)(G).controllerId;return{extId:m.$iJ.fromExtHostTestItem(G,Se).toString(),label:G.label,uri:u.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Re=>ct.namespace(Se,Re.id)),range:g.$xs.lift(t.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&ie.fromStrict(G.error)||null}}ve.from=De;function fe(G){return{parent:void 0,error:void 0,id:m.$iJ.fromString(G.extId).localId,label:G.label,uri:u.URI.revive(G.uri),tags:(G.tags||[]).map(Se=>{const{tagId:Re}=ct.denamespace(Se);return new i.$2L(Re)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:t.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}ve.toPlain=fe})(kt||(e.TestItem=kt={})),function(ve){function De(G){return{id:G.id}}ve.from=De;function fe(G){return new i.$2L(G.id)}ve.to=fe}(ct||(e.TestTag=ct={}));var Ot;(function(ve){const De=(G,Se)=>{const Re=[];for(const[Te,xe]of Se)m.$iJ.compare(xe.item.extId,Te)===2&&(Se.delete(Te),Re.push(xe));const qe={...kt.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(Te=>({state:Te.state,duration:Te.duration,messages:Te.messages.filter(xe=>xe.type===0).map(Et.to)})),children:Re.map(Te=>De(Te,Se))};for(const Te of qe.children)Te.parent=qe;return qe};function fe(G){const Se=[],Re=new Map;for(const qe of G.items){Re.set(qe.item.extId,qe);const Te=m.$iJ.root(qe.item.extId);G.request.targets.some(xe=>xe.controllerId===Te&&xe.testIds.includes(qe.item.extId))&&Se.push(qe)}return{completedAt:G.completedAt,results:Se.map(qe=>De(qe,Re))}}ve.to=fe})(Ot||(e.TestResults=Ot={}));var mt;(function(ve){function De(Re){return{covered:Re.covered,total:Re.covered}}function fe(Re){return"line"in Re?$.from(Re):t.from(Re)}function G(Re){return"branches"in Re?{count:Re.executionCount,location:fe(Re.location),type:1,branches:Re.branches.length?Re.branches.map(qe=>({count:qe.executionCount,location:qe.location&&fe(qe.location)})):void 0}:{type:0,count:Re.executionCount,location:fe(Re.location)}}ve.fromDetailed=G;function Se(Re){return{uri:Re.uri,statement:De(Re.statementCoverage),branch:Re.branchCoverage&&De(Re.branchCoverage),function:Re.functionCoverage&&De(Re.functionCoverage),details:Re.detailedCoverage?.map(G)}}ve.fromFile=Se})(mt||(e.TestCoverage=mt={}));var zt;(function(ve){function De(fe){switch(fe){case 1:return i.CodeActionTriggerKind.Invoke;case 2:return i.CodeActionTriggerKind.Automatic}}ve.to=De})(zt||(e.CodeActionTriggerKind=zt={}));var Ft;(function(ve){function De(G){const Se=new i.$8L(le.to(G.kind),G.name,G.detail||"",u.URI.revive(G.uri),t.to(G.range),t.to(G.selectionRange));return Se._sessionId=G._sessionId,Se._itemId=G._itemId,Se}ve.to=De;function fe(G,Se,Re){if(Se=Se??G._sessionId,Re=Re??G._itemId,Se===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Re,kind:le.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:t.from(G.range),selectionRange:t.from(G.selectionRange),tags:G.tags?.map(re.from)}}ve.from=fe})(Ft||(e.TypeHierarchyItem=Ft={}));var nt;(function(ve){function De(fe){if(fe)return{value:fe.value,tooltip:fe.tooltip}}ve.from=De})(nt||(e.ViewBadge=nt={}));var lt;(function(ve){function De(Re,qe,Te){const xe=qe.fileData;return xe?new i.$gL(new i.$hL(xe.name,u.URI.revive(xe.uri),xe.id,(0,I.$db)(()=>Te(xe.id)))):Re===A.$Tr.uriList&&qe.uriListData?new i.$fL(Se(qe.uriListData)):new i.$fL(qe.asString)}ve.to=De;async function fe(Re,qe){const Te=await qe.asString();if(Re===A.$Tr.uriList)return{asString:Te,fileData:void 0,uriListData:G(Te)};const xe=qe.asFile();return{asString:Te,fileData:xe?{name:xe.name,uri:xe.uri,id:xe._itemId??xe.id}:void 0}}ve.from=fe;function G(Re){return r.$7s.split(Re).map(qe=>{if(qe.startsWith("#"))return qe;try{return u.URI.parse(qe)}catch{}return qe})}function Se(Re){return r.$7s.create(Re.map(qe=>typeof qe=="string"?qe:u.URI.revive(qe)))}})(lt||(e.DataTransferItem=lt={}));var gt;(function(ve){function De(G,Se){const Re=G.items.map(([qe,Te])=>[qe,lt.to(qe,Te,Se)]);return new i.$iL(Re)}ve.toDataTransfer=De;async function fe(G){const Se={items:[]},Re=[];for(const[qe,Te]of G)Re.push((async()=>{Se.items.push([qe,await lt.from(qe,Te)])})());return await Promise.all(Re),Se}ve.from=fe})(gt||(e.DataTransfer=gt={}));var jt;(function(ve){function De(G){return{message:G.message,metadata:G.metadata,title:G.title,tooltip:G.tooltip}}ve.to=De;function fe(G){return{kind:"reply",message:G.message,metadata:G.metadata,title:G.title,tooltip:G.tooltip}}ve.from=fe})(jt||(e.ChatReplyFollowup=jt={}));var qt;(function(ve){function De(fe){return typeof fe=="string"?{title:fe,message:fe,kind:"reply"}:"commandId"in fe?{kind:"command",title:fe.title??"",commandId:fe.commandId??"",when:fe.when??"",args:fe.args}:jt.from(fe)}ve.from=De})(qt||(e.ChatFollowup=qt={}));var Bt;(function(ve){function De(G){const Se=new i.$fM(Ct.to(G.role),G.content);return Se.name=G.name,Se}ve.to=De;function fe(G){return{role:Ct.from(G.role),content:G.content,name:G.name}}ve.from=fe})(Bt||(e.ChatMessage=Bt={}));var Ct;(function(ve){function De(G){switch(G){case 0:return i.ChatMessageRole.System;case 1:return i.ChatMessageRole.User;case 2:return i.ChatMessageRole.Assistant;case 3:return i.ChatMessageRole.Function}}ve.to=De;function fe(G){switch(G){case i.ChatMessageRole.System:return 0;case i.ChatMessageRole.Assistant:return 2;case i.ChatMessageRole.Function:return 3;case i.ChatMessageRole.User:default:return 1}}ve.from=fe})(Ct||(e.ChatMessageRole=Ct={}));var It;(function(ve){function De(Se){const Re={};for(const qe of Object.keys(Se))Re[qe]=Se[qe].map(ve.to);return Re}ve.objectTo=De;function fe(Se){return{level:At.to(Se.level),value:Se.value,description:Se.description}}ve.to=fe;function G(Se){return{level:At.from(Se.level),value:Se.value,description:Se.description}}ve.from=G})(It||(e.ChatVariable=It={}));var At;(function(ve){function De(G){switch(G){case"short":return i.ChatVariableLevel.Short;case"medium":return i.ChatVariableLevel.Medium;case"full":default:return i.ChatVariableLevel.Full}}ve.to=De;function fe(G){switch(G){case i.ChatVariableLevel.Short:return"short";case i.ChatVariableLevel.Medium:return"medium";case i.ChatVariableLevel.Full:default:return"full"}}ve.from=fe})(At||(e.ChatVariableLevel=At={}));var Lt;(function(ve){function De(fe){switch(fe){case 1:return i.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return i.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return i.InteractiveEditorResponseFeedbackKind.Undone;case 3:return i.InteractiveEditorResponseFeedbackKind.Accepted}}ve.to=De})(Lt||(e.InteractiveEditorResponseFeedbackKind=Lt={}));var pt;(function(ve){function De(fe,G){return"placeholder"in G&&"resolvedContent"in G?{placeholder:G.placeholder}:"responseId"in G?{requestId:G.responseId}:"markdownContent"in G?((0,o.$lF)(fe,"chatAgents2Additions"),{content:ie.from(G.markdownContent)}):"content"in G?typeof G.content=="string"?G:((0,o.$lF)(fe,"chatAgents2Additions"),{content:ie.from(G.content)}):"documents"in G?{documents:G.documents.map(Se=>({uri:Se.uri,version:Se.version,ranges:Se.ranges.map(Re=>t.from(Re))}))}:"reference"in G?{reference:"uri"in G.reference?{uri:G.reference.uri,range:t.from(G.reference.range)}:G.reference}:"inlineReference"in G?{inlineReference:"uri"in G.inlineReference?{uri:G.inlineReference.uri,range:t.from(G.inlineReference.range)}:G.inlineReference,title:G.title}:("agentName"in G&&(0,o.$lF)(fe,"chatAgents2Additions"),G)}ve.from=De})(pt||(e.ChatResponseProgress=pt={}));var Wt;(function(ve){function De(fe,G,Se){return"terminalCommand"in fe?{terminalCommand:fe.terminalCommand}:"uri"in fe?{uri:fe.uri}:G.toInternal(fe,Se)}ve.from=De})(Wt||(e.TerminalQuickFix=Wt={}))}),define(pe[278],be([1,0,42,133,71,132,92,136,4]),function(ue,e,D,R,r,I,P,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=e.$DM=e.$CM=void 0;const b=(l,m,c,n)=>{let i=m;return{enumerable:!0,configurable:!1,get(){return i},set(o){if(!c(i,o)){const s=i;i=o,l.listener?.(n(o,s))}}}},A=(l,m)=>l===m,S={range:(l,m)=>l===m?!0:!l||!m?!1:l.isEqual(m),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(l,m)=>!(l.length!==m.length||l.some(c=>!m.find(n=>c.id===n.id)))},y=l=>m=>({op:4,update:l(m)}),u=(l,m)=>({range:(()=>{let c;const n=y(i=>({range:D.$xs.lift(C.Range.from(i))}));return{enumerable:!0,configurable:!1,get(){return c},set(i){l.listener?.({op:6}),S.range(c,i)||(c=i,l.listener?.(n(i)))}}})(),label:b(l,m,S.label,y(c=>({label:c}))),description:b(l,void 0,S.description,y(c=>({description:c}))),sortText:b(l,void 0,S.sortText,y(c=>({sortText:c}))),canResolveChildren:b(l,!1,S.canResolveChildren,c=>({op:2,state:c})),busy:b(l,!1,S.busy,y(c=>({busy:c}))),error:b(l,void 0,S.error,y(c=>({error:C.MarkdownString.fromStrict(c)||null}))),tags:b(l,[],S.tags,(c,n)=>({op:1,new:c.map(C.TestTag.from),old:n.map(C.TestTag.from)}))}),g=l=>{const m=r.$iJ.fromString(l.extId),c=new f(m.controllerId,m.localId,l.label,v.URI.revive(l.uri)||void 0);return c.range=C.Range.to(l.range||void 0),c.description=l.description||void 0,c.sortText=l.sortText||void 0,c.tags=l.tags.map(n=>C.TestTag.to({id:(0,P.$nJ)(n).tagId})),c},d=l=>{let m;for(const c of l.tests){const n=g(c.item);(0,R.$mM)(n).parent=m,m=n}return m};e.$CM=d;class f{constructor(m,c,n,i){if(c.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(c)} symbol`);const o=(0,R.$lM)(this,m);Object.defineProperties(this,{id:{value:c,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof h?void 0:o.parent}},children:{value:(0,I.$kM)(o,R.$mM,f),enumerable:!0,writable:!1},...u(o,n)})}}e.$DM=f;class h extends f{constructor(m,c){super(m,m,c,void 0),this._isRoot=!0}}e.$EM=h;class p extends I.$gM{constructor(m,c,n){super({controllerId:m,getDocumentVersion:i=>i&&n.getDocument(i)?.version,getApiFor:R.$mM,getChildren:i=>i.children,root:new h(m,c),toITestItem:C.TestItem.from})}}e.$FM=p}),define(pe[279],be([1,0,35,205,53]),function(ue,e,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ON=void 0;function I(P,C,v,b){const A=new D.$9l;return P.forEach(S=>{const y=A.get(S.identifier);y&&b.warn((0,R.localize)(0,null,y.extensionLocation.fsPath,S.extensionLocation.fsPath)),A.set(S.identifier,S)}),C.forEach(S=>{const y=A.get(S.identifier);if(y)if(y.isBuiltin){if(r.gte(y.version,S.version)){b.warn(`Skipping extension ${S.extensionLocation.path} in favour of the builtin extension ${y.extensionLocation.path}.`);return}S.isBuiltin=!0}else b.warn((0,R.localize)(1,null,y.extensionLocation.fsPath,S.extensionLocation.fsPath));else if(S.isBuiltin){b.warn(`Skipping obsolete builtin extension ${S.extensionLocation.path}`);return}A.set(S.identifier,S)}),v.forEach(S=>{b.info((0,R.localize)(2,null,S.extensionLocation.fsPath));const y=A.get(S.identifier);y&&y.isBuiltin&&(S.isBuiltin=!0),A.set(S.identifier,S)}),Array.from(A.values())}e.$ON=I}),define(pe[280],be([1,0,7,3,29,4,41,51,67,58,279,12]),function(ue,e,D,R,r,I,P,C,v,b,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SN=e.$RN=void 0;class y{constructor(d,f,h,p,l,m,c){this.c=d,this.d=h,this.f=p,this.g=l,this.h=m,this.i=c,this.a=Promise.resolve(),this.b=Promise.resolve();const n=f.args["install-builtin-extension"];if(n){l.trace("Installing builtin extensions passed via args...");const o={isMachineScoped:!!f.args["do-not-sync"],installPreReleaseVersion:!!f.args["pre-release"]};P.mark("code/server/willInstallBuiltinExtensions"),this.b=this.a=d.installExtensions([],this.j(n),o,!!f.args.force).then(()=>{P.mark("code/server/didInstallBuiltinExtensions"),l.trace("Finished installing builtin extensions")},s=>{l.error(s)})}const i=f.args["install-extension"];i&&(l.trace("Installing extensions passed via args..."),this.b=this.a.then(()=>d.installExtensions(this.j(i),[],{isMachineScoped:!!f.args["do-not-sync"],installPreReleaseVersion:!!f.args["pre-release"],isApplicationScoped:!0},!!f.args.force)).then(()=>{l.trace("Finished installing extensions")},o=>{l.error(o)}))}j(d){return d.map(f=>/\.vsix$/i.test(f)?I.URI.file((0,D.$ic)(f)?f:(0,D.$jc)((0,r.cwd)(),f)):f)}whenExtensionsReady(){return this.b}async scanExtensions(d,f,h,p){P.mark("code/server/willScanExtensions"),this.g.trace(`Scanning extensions using UI language: ${d}`),await this.a;const l=h?h.filter(c=>c.scheme===S.Schemas.file).map(c=>c.fsPath):void 0;f=f??this.d.defaultProfile.extensionsResource;const m=await this.k(f,d??R.$w,l,p);return this.g.trace("Scanned Extensions",m),this.r(m),P.mark("code/server/didScanExtensions"),m}async scanSingleExtension(d,f,h){await this.a;const p=d.scheme===S.Schemas.file?d.fsPath:null;if(!p)return null;const l=await this.o(p,f,h??R.$w);return l?(this.r([l]),l):null}async k(d,f,h,p){await this.q(f,p);const[l,m,c]=await Promise.all([this.m(f),this.n(d,f),this.l(f,h)]);return(0,A.$ON)(l,m,c,this.g)}async l(d,f){return f?(await Promise.all(f.map(h=>this.f.scanOneOrMultipleExtensions(I.URI.file((0,D.$kc)(h)),1,{language:d})))).flat().map(h=>(0,b.$Fp)(h,!0)):[]}async m(d){return(await this.f.scanSystemExtensions({language:d,useCache:!0})).map(h=>(0,b.$Fp)(h,!1))}async n(d,f){return(await this.f.scanUserExtensions({profileLocation:d,language:f,useCache:!0})).map(p=>(0,b.$Fp)(p,!1))}async o(d,f,h){const p=I.URI.file((0,D.$kc)(d)),l=f?0:1,m=await this.f.scanExistingExtension(p,l,{language:h});return m?(0,b.$Fp)(m,!1):null}async q(d,f){if(!(d===R.$g||!this.h.isEnabled())){try{if((await this.i.getInstalledLanguages()).find(p=>p.id===d)){this.g.trace(`Language Pack ${d} is already installed. Skipping language pack installation.`);return}}catch(h){this.g.error(h)}if(!f){this.g.trace(`No language pack id provided for language ${d}. Skipping language pack installation.`);return}this.g.trace(`Language Pack ${f} for language ${d} is not installed. It will be installed now.`);try{await this.c.installExtensions([f],[],{isMachineScoped:!0},!0)}catch(h){this.g.error(h)}}}r(d){const f=(n,i)=>n.replace(/file/g,"vscode-remote"),h=n=>{let i="";return i+=n.global?"g":"",i+=n.ignoreCase?"i":"",i+=n.multiline?"m":"",new RegExp(f(n.source,!0),i)},p=new class{mapDefined(n){return v.$Ti.create(n)}mapNot(n){return v.$Yi.create(n)}mapEquals(n,i){return n==="resourceScheme"&&typeof i=="string"?v.$Ui.create(n,f(i,!1)):v.$Ui.create(n,i)}mapNotEquals(n,i){return n==="resourceScheme"&&typeof i=="string"?v.$Xi.create(n,f(i,!1)):v.$Xi.create(n,i)}mapGreater(n,i){return v.$Zi.create(n,i)}mapGreaterEquals(n,i){return v.$1i.create(n,i)}mapSmaller(n,i){return v.$2i.create(n,i)}mapSmallerEquals(n,i){return v.$3i.create(n,i)}mapRegex(n,i){return n==="resourceScheme"&&i?v.$4i.create(n,h(i)):v.$4i.create(n,i)}mapIn(n,i){return v.$Vi.create(n,i)}mapNotIn(n,i){return v.$Wi.create(n,i)}},l=n=>{if(!n||!n.when||!/resourceScheme/.test(n.when))return;const i=v.$Oi.deserialize(n.when);if(!i)return;const o=i.map(p);n.when=o.serialize()},m=n=>{if(Array.isArray(n))for(const i of n)l(i);else l(n)},c=n=>{for(const i in n)m(n[i])};d.forEach(n=>{n.contributes&&(n.contributes.menus&&c(n.contributes.menus),n.contributes.keybindings&&m(n.contributes.keybindings),n.contributes.views&&c(n.contributes.views))})}}e.$RN=y;class u{constructor(d,f){this.a=d,this.b=f}listen(d,f){throw new Error("Invalid listen")}async call(d,f,h){const p=this.b(d);switch(f){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const l=h[0],m=h[1]?I.URI.revive(p.transformIncoming(h[1])):void 0,c=Array.isArray(h[2])?h[2].map(o=>I.URI.revive(p.transformIncoming(o))):void 0,n=h[3];return(await this.a.scanExtensions(l,m,c,n)).map(o=>(0,C.$Om)(o,p))}case"scanSingleExtension":{const l=await this.a.scanSingleExtension(I.URI.revive(p.transformIncoming(h[0])),h[1],h[2]);return l?(0,C.$Om)(l,p):null}}throw new Error("Invalid call")}}e.$SN=u}),define(pe[137],be([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uv=e.$tv=e.$sv=e.$rv=void 0;class D{static{this.count=0}constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++D.count}}e.$rv=D;const R=[];function r(C){const v=new D(C);return R[v.nid]=v,v}e.$sv=r;function I(C){return R[C].sid}e.$tv=I;class P{constructor(v){this.value=v}}e.$uv=P}),define(pe[281],be([1,0,137]),function(ue,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qK=e.$pK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$oK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(R||(e.TextEditorRevealType=R={}));var r;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput"})(r||(e.TabInputKind=r={}));var I;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(I||(e.TabModelOperationKind=I={}));var P;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(P||(e.WebviewEditorCapabilities=P={}));var C;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(C||(e.WebviewMessageArrayBufferViewType=C={}));var v;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(v||(e.CellOutputKind=v={}));var b;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(b||(e.NotebookEditorRevealType=b={}));var A;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class S{static{this.a=0}static mixin(f){return f._id=S.a++,f}}e.$oK=S;var y;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(y||(e.ISuggestDataDtoField=y={}));var u;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(u||(e.ISuggestResultDtoField=u={}));var g;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(g||(e.ExtHostTestingResource=g={})),e.$pK={MainThreadAuthentication:(0,D.$sv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$sv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$sv)("MainThreadChatProvider"),MainThreadChatAgents:(0,D.$sv)("MainThreadChatAgents"),MainThreadChatAgents2:(0,D.$sv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,D.$sv)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$sv)("MainThreadClipboard"),MainThreadCommands:(0,D.$sv)("MainThreadCommands"),MainThreadComments:(0,D.$sv)("MainThreadComments"),MainThreadConfiguration:(0,D.$sv)("MainThreadConfiguration"),MainThreadConsole:(0,D.$sv)("MainThreadConsole"),MainThreadDebugService:(0,D.$sv)("MainThreadDebugService"),MainThreadDecorations:(0,D.$sv)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$sv)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$sv)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$sv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$sv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$sv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$sv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$sv)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$sv)("MainThreadErrors"),MainThreadTreeViews:(0,D.$sv)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$sv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$sv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$sv)("MainThreadLanguages"),MainThreadLogger:(0,D.$sv)("MainThreadLogger"),MainThreadMessageService:(0,D.$sv)("MainThreadMessageService"),MainThreadOutputService:(0,D.$sv)("MainThreadOutputService"),MainThreadProgress:(0,D.$sv)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$sv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$sv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$sv)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$sv)("MainThreadSecretState"),MainThreadStorage:(0,D.$sv)("MainThreadStorage"),MainThreadSpeech:(0,D.$sv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,D.$sv)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$sv)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$sv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$sv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$sv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$sv)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$sv)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$sv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$sv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$sv)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$sv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,D.$sv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,D.$sv)("MainThreadExtensionService"),MainThreadSCM:(0,D.$sv)("MainThreadSCM"),MainThreadSearch:(0,D.$sv)("MainThreadSearch"),MainThreadShare:(0,D.$sv)("MainThreadShare"),MainThreadTask:(0,D.$sv)("MainThreadTask"),MainThreadWindow:(0,D.$sv)("MainThreadWindow"),MainThreadLabelService:(0,D.$sv)("MainThreadLabelService"),MainThreadNotebook:(0,D.$sv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$sv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$sv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$sv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$sv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$sv)("MainThreadInteractive"),MainThreadChat:(0,D.$sv)("MainThreadChat"),MainThreadInlineChat:(0,D.$sv)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$sv)("MainThreadTheming"),MainThreadTunnelService:(0,D.$sv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$sv)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$sv)("MainThreadTimeline"),MainThreadTesting:(0,D.$sv)("MainThreadTesting"),MainThreadLocalization:(0,D.$sv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$sv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$sv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$sv)("MainThreadIssueReporter")},e.$qK={ExtHostCommands:(0,D.$sv)("ExtHostCommands"),ExtHostConfiguration:(0,D.$sv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$sv)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$sv)("ExtHostDebugService"),ExtHostDecorations:(0,D.$sv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$sv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$sv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$sv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$sv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$sv)("ExtHostEditors"),ExtHostTreeViews:(0,D.$sv)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$sv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$sv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$sv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$sv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$sv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$sv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$sv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$sv)("ExtHostStatusBar"),ExtHostShare:(0,D.$sv)("ExtHostShare"),ExtHostExtensionService:(0,D.$sv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$sv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$sv)("ExtHostTerminalService"),ExtHostSCM:(0,D.$sv)("ExtHostSCM"),ExtHostSearch:(0,D.$sv)("ExtHostSearch"),ExtHostTask:(0,D.$sv)("ExtHostTask"),ExtHostWorkspace:(0,D.$sv)("ExtHostWorkspace"),ExtHostWindow:(0,D.$sv)("ExtHostWindow"),ExtHostWebviews:(0,D.$sv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$sv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$sv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$sv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$sv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$sv)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$sv)("ExtHostProgress"),ExtHostComments:(0,D.$sv)("ExtHostComments"),ExtHostSecretState:(0,D.$sv)("ExtHostSecretState"),ExtHostStorage:(0,D.$sv)("ExtHostStorage"),ExtHostUrls:(0,D.$sv)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$sv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$sv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$sv)("ExtHostOutputService"),ExtHosLabelService:(0,D.$sv)("ExtHostLabelService"),ExtHostNotebook:(0,D.$sv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$sv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$sv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$sv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$sv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$sv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$sv)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$sv)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$sv)("ExtHostChat"),ExtHostChatAgents:(0,D.$sv)("ExtHostChatAgents"),ExtHostChatAgents2:(0,D.$sv)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.$sv)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$sv)("ExtHostChatProvider"),ExtHostSpeech:(0,D.$sv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,D.$sv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$sv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$sv)("ExtHostTheming"),ExtHostTunnelService:(0,D.$sv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$sv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$sv)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$sv)("ExtHostTimeline"),ExtHostTesting:(0,D.$sv)("ExtHostTesting"),ExtHostTelemetry:(0,D.$sv)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$sv)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$sv)("ExtHostIssueReporter")}}),define(pe[282],be([1,0,10,131,136,22,281,18,13,50,42,99,4,2,6,265,278,15,137,39,59,38,276]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u,g,d,f,h,p,l,m,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=e.$OM=e.$NM=e.$MM=e.$LM=void 0;let i=class{#e;#t;#n;constructor(w,k,E){this.b=new Map,this.c=new Map,this.#e=w.getProxy(P.$pK.MainThreadCommands),this.d=k,this.#n=E,this.#t=w.getProxy(P.$pK.MainThreadTelemetry),this.converter=new o(this,L=>{const j=this.c.get(L);return j?.result===t.Void?j:void 0},k),this.f=[{processArgument(L){return(0,b.$nh)(L)}},{processArgument(L){return(0,I.$0m)(L,function(j){if(A.$xs.isIRange(j))return r.Range.to(j);if(S.$ws.isIPosition(j))return r.Position.to(j);if(A.$xs.isIRange(j.range)&&y.URI.isUri(j.uri))return r.location.to(j);if(j instanceof h.$ce)return j.buffer.buffer;if(!Array.isArray(j))return j})}}]}registerArgumentProcessor(w){this.f.push(w)}registerApiCommand(w){const k=this.registerCommand(!1,w.id,async(...E)=>{const L=w.args.map((x,ce)=>{if(!x.validate(E[ce]))throw new Error(`Invalid argument '${x.name}' when running '${w.id}', received: ${typeof E[ce]=="object"?JSON.stringify(E[ce],null,"	"):E[ce]} `);return x.convert(E[ce])}),j=await this.executeCommand(w.internalId,...L);return w.result.convert(j,E,this.converter)},void 0,{description:w.description,args:w.args,returns:w.result.description});return this.c.set(w.id,w),new R.$rK(()=>{k.dispose(),this.c.delete(w.id)})}registerCommand(w,k,E,L,j,x){if(this.d.trace("ExtHostCommands#registerCommand",k),!k.trim().length)throw new Error("invalid id");if(this.b.has(k))throw new Error(`command '${k}' already exists`);return this.b.set(k,{callback:E,thisArg:L,metadata:j,extension:x}),w&&this.#e.$registerCommand(k),new R.$rK(()=>{this.b.delete(k)&&w&&this.#e.$unregisterCommand(k)})}executeCommand(w,...k){return this.d.trace("ExtHostCommands#executeCommand",w),this.g(w,k,!0)}async g(w,k,E){if(this.b.has(w))return this.#e.$fireCommandActivationEvent(w),this.h(w,k,!1);{let L=!1;const j=(0,I.$0m)(k,function(x){if(x instanceof R.$sK)return r.Position.from(x);if(x instanceof R.$tK)return r.Range.from(x);if(x instanceof R.$DK)return r.location.from(x);if(R.$OL.isNotebookRange(x))return r.NotebookRange.from(x);if(x instanceof ArrayBuffer)return L=!0,h.$ce.wrap(new Uint8Array(x));if(x instanceof Uint8Array)return L=!0,h.$ce.wrap(x);if(x instanceof h.$ce)return L=!0,x;if(!Array.isArray(x))return x});try{const x=await this.#e.$executeCommand(w,L?new p.$uv(j):j,E);return(0,b.$nh)(x)}catch(x){if(x instanceof Error&&x.message==="$executeCommand:retry")return this.g(w,k,!1);throw x}}}async h(w,k,E){const L=this.b.get(w);if(!L)throw new Error("Unknown command");const{callback:j,thisArg:x,metadata:ce}=L;if(ce?.args)for(let ie=0;ie<ce.args.length;ie++)try{(0,D.$Qf)(k[ie],ce.args[ie].constraint)}catch{throw new Error(`Running the contributed command: '${w}' failed. Illegal argument '${ce.args[ie].name}' - ${ce.args[ie].description}`)}const X=m.$Kd.create();try{return await j.apply(x,k)}catch(ie){if(w===this.converter.delegatingCommandId){const he=this.converter.getActualCommand(...k);he&&(w=he.command)}if(this.d.error(ie,w,L.extension?.identifier),!E)throw ie;if(L.extension?.identifier){const he=this.#n.onExtensionError(L.extension.identifier,ie);this.d.trace("forwarded error to extension?",he,L.extension?.identifier)}throw new class extends Error{constructor(){super((0,l.$Bi)(ie)),this.id=w,this.source=L.extension?.displayName??L.extension?.name}}}finally{this.j(L,w,X.elapsed())}}j(w,k,E){w.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:w.extension.identifier.value,id:new c.$no(k),duration:E})}$executeContributedCommand(w,...k){this.d.trace("ExtHostCommands#$executeContributedCommand",w);const E=this.b.get(w);return E?(k=k.map(L=>this.f.reduce((j,x)=>x.processArgument(j,E.extension?.identifier),L)),this.h(w,k,!0)):Promise.reject(new Error(`Contributed command '${w}' does not exist.`))}getCommands(w=!1){return this.d.trace("ExtHostCommands#getCommands",w),this.#e.$getCommands().then(k=>(w&&(k=k.filter(E=>E[0]!=="_")),k))}$getContributedCommandMetadata(){const w=Object.create(null);for(const[k,E]of this.b){const{metadata:L}=E;L&&(w[k]=L)}return Promise.resolve(w)}};e.$LM=i,e.$LM=i=Oe([Ae(0,d.$qM),Ae(1,v.$$i),Ae(2,n.$KM)],i),e.$MM=(0,g.$Qh)("IExtHostCommands");class o{constructor(w,k,E){this.d=w,this.f=k,this.g=E,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(w,k){if(!w)return;const E={$ident:void 0,id:w.command,title:w.title,tooltip:w.tooltip};if(!w.command)return E;const L=this.f(w.command);if(L)E.id=L.internalId,E.arguments=L.args.map((j,x)=>j.convert(w.arguments&&w.arguments[x]));else if((0,C.$Lb)(w.arguments)){const j=`${w.command} /${++this.c}`;this.b.set(j,w),k.add((0,u.$Qc)(()=>{this.b.delete(j),this.g.trace("CommandsConverter#DISPOSE",j)})),E.$ident=j,E.id=this.delegatingCommandId,E.arguments=[j],this.g.trace("CommandsConverter#CREATE",w.command,j)}return E}fromInternal(w){return typeof w.$ident=="string"?this.b.get(w.$ident):{command:w.id,title:w.title,arguments:w.arguments}}getActualCommand(...w){return this.b.get(w[0])}h(...w){const k=this.getActualCommand(...w);return this.g.trace("CommandsConverter#EXECUTE",w[0],k?k.command:"MISSING"),k?this.d.executeCommand(k.command,...k.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${w[0]}`)}}e.$NM=o;class s{static{this.Uri=new s("uri","Uri of a text document",w=>y.URI.isUri(w),w=>w)}static{this.Position=new s("position","A position in a text document",w=>R.$sK.isPosition(w),r.Position.from)}static{this.Range=new s("range","A range in a text document",w=>R.$tK.isRange(w),r.Range.from)}static{this.Selection=new s("selection","A selection in a text document",w=>R.$uK.isSelection(w),r.Selection.from)}static{this.Number=new s("number","",w=>typeof w=="number",w=>w)}static{this.String=new s("string","",w=>typeof w=="string",w=>w)}static{this.StringArray=s.Arr(s.String)}static Arr(w){return new s(`${w.name}_array`,`Array of ${w.name}, ${w.description}`,k=>Array.isArray(k)&&k.every(E=>w.validate(E)),k=>k.map(E=>w.convert(E)))}static{this.CallHierarchyItem=new s("item","A call hierarchy item",w=>w instanceof R.$NK,r.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new s("item","A type hierarchy item",w=>w instanceof R.$8L,r.TypeHierarchyItem.from)}static{this.TestItem=new s("testItem","A VS Code TestItem",w=>w instanceof f.$DM,r.TestItem.from)}constructor(w,k,E,L){this.name=w,this.description=k,this.validate=E,this.convert=L}optional(){return new s(this.name,`(optional) ${this.description}`,w=>w==null||this.validate(w),w=>w===void 0?void 0:w===null?null:this.convert(w))}with(w,k){return new s(w??this.name,k??this.description,this.validate,this.convert)}}e.$OM=s;class t{static{this.Void=new t("no result",w=>w)}constructor(w,k){this.description=w,this.convert=k}}e.$PM=t;class a{constructor(w,k,E,L,j){this.id=w,this.internalId=k,this.description=E,this.args=L,this.result=j}}e.$QM=a}),define(pe[283],be([1,0,11,2,12,218]),function(ue,e,D,R,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yN=e.$xN=void 0,e.$xN="remoteFilesystem";class P extends I.$wN{static register(v,b,A){const S=v.getConnection();if(!S)return R.$Sc.None;const y=new R.$Rc,u=(async()=>{try{const g=await v.getRawEnvironment();g?b.registerProvider(r.Schemas.vscodeRemote,y.add(new P(g,S))):A.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(g){A.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,D.$0)(g))}})();return y.add(b.onWillActivateFileSystemProvider(g=>{g.scheme===r.Schemas.vscodeRemote&&g.join(u)})),y}constructor(v,b){super(b.getChannel(e.$xN),{pathCaseSensitive:v.os===3})}}e.$yN=P}),define(pe[93],be([1,0,27,14,7,10,21,170,301,302]),function(ue,e,D,R,r,I,P,C,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.zip=e.$pp=e.$op=void 0,e.$op="end of central directory record signature not found";const A=new RegExp(e.$op);class S extends Error{constructor(i,o){let s=o.message;switch(i){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=i,this.cause=o}}e.$pp=S;function y(n){const i=n.externalFileAttributes>>16||33188;return[448,56,7].map(o=>i&o).reduce((o,s)=>o+s,i&61440)}function u(n){if(n instanceof S)return n;let i;return A.test(n.message)&&(i="CorruptZip"),new S(i,n)}function g(n,i,o,s,t,a){const $=r.$mc(i),w=r.$jc(s,$);if(!w.startsWith(s))return Promise.reject(new Error(C.localize(0,null,i)));const k=r.$jc(s,i);let E;return a.onCancellationRequested(()=>{E?.destroy()}),Promise.resolve(P.Promises.mkdir(w,{recursive:!0})).then(()=>new Promise((L,j)=>{if(!a.isCancellationRequested)try{E=(0,D.createWriteStream)(k,{mode:o}),E.once("close",()=>L()),E.once("error",j),n.once("error",j),n.pipe(E)}catch(x){j(x)}}))}function d(n,i,o,s){let t=(0,R.$Ig)(()=>Promise.resolve()),a=0;const $=s.onCancellationRequested(()=>{t.cancel(),n.close()});return new Promise((w,k)=>{const E=new R.$Pg,L=j=>{j.isCancellationRequested||(a++,n.readEntry())};n.once("error",k),n.once("close",()=>t.then(()=>{s.isCancellationRequested||n.entryCount===a?w():k(new S("Incomplete",new Error(C.localize(1,null,a,n.entryCount))))},k)),n.readEntry(),n.on("entry",j=>{if(s.isCancellationRequested)return;if(!o.sourcePathRegex.test(j.fileName)){L(s);return}const x=j.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test(x)){const ie=r.$jc(i,x);t=(0,R.$Ig)(he=>P.Promises.mkdir(ie,{recursive:!0}).then(()=>L(he)).then(void 0,k));return}const ce=h(n,j),X=y(j);t=(0,R.$Ig)(ie=>E.queue(()=>ce.then(he=>g(he,x,X,i,o,ie).then(()=>L(ie)))).then(null,k))})}).finally(()=>$.dispose())}function f(n,i=!1){return new Promise((o,s)=>{(0,v.open)(n,i?{lazyEntries:!0}:void 0,(t,a)=>{t?s(u(t)):o((0,I.$Kf)(a))})})}function h(n,i){return new Promise((o,s)=>{n.openReadStream(i,(t,a)=>{t?s(u(t)):o((0,I.$Kf)(a))})})}function p(n,i){return new Promise((o,s)=>{const t=new b.ZipFile;i.forEach($=>{$.contents?t.addBuffer(typeof $.contents=="string"?Buffer.from($.contents,"utf8"):$.contents,$.path):$.localPath&&t.addFile($.localPath,$.path)}),t.end();const a=(0,D.createWriteStream)(n);t.outputStream.pipe(a),t.outputStream.once("error",s),a.once("error",s),a.once("finish",()=>o(n))})}e.zip=p;function l(n,i,o={},s){const t=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let a=f(n,!0);return o.overwrite&&(a=a.then($=>P.Promises.rm(i).then(()=>$))),a.then($=>d($,i,{sourcePathRegex:t},s))}e.$rp=l;function m(n,i){return f(n).then(o=>new Promise((s,t)=>{o.on("entry",a=>{a.fileName===i&&h(o,a).then($=>s($),$=>t($))}),o.once("close",()=>t(new Error(C.localize(2,null,i))))}))}function c(n,i){return m(n,i).then(o=>new Promise((s,t)=>{const a=[];o.once("error",t),o.on("data",$=>a.push($)),o.on("end",()=>s(Buffer.concat(a)))}))}e.$sp=c}),define(pe[284],be([1,0,14,11,2,12,19,53,10,23,21,93,24,25,30,36,82,16,13]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u,g,d,f,h,p){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=void 0;let m=class extends r.$Sc{static{l=this}static{this.c=".sigzip"}constructor(n,i,o,s,t,a){super(),this.h=i,this.j=o,this.m=s,this.n=t,this.r=a,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(n,i,o){await this.g;const s=(0,P.$wg)(this.extensionsDownloadDir,this.z(n));try{await this.w(n,s,a=>this.j.download(n,a,i))}catch(a){throw new g.$co(a.message,g.ExtensionManagementErrorCode.Download)}let t=!1;if(o&&this.t(n)){const a=await this.u(n);try{t=await this.n.verify(s.fsPath,a.fsPath,this.r.getLevel()===p.LogLevel.Trace)}catch($){const w=$;if(t=w.code,w.output&&this.r.trace(`Extension signature verification details for ${n.identifier.id} ${n.version}:
${w.output}`),t===g.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===g.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new g.$co(S.$op,g.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(a)}catch($){this.r.error($)}}}return t===!0?this.r.info(`Extension signature is verified: ${n.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${n.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${n.identifier.id}`),{location:s,verificationStatus:t}}t(n){if(!n.isSigned)return!1;const i=this.m.getValue("extensions.verifySignature");return(0,v.$Ff)(i)?i:!0}async u(n){await this.g;const i=(0,P.$wg)(this.extensionsDownloadDir,`${this.z(n)}${l.c}`);return await this.w(n,i,o=>this.j.downloadSignatureArchive(n,o)),i}async w(n,i,o){if(await this.h.exists(i))return;if(i.scheme!==I.Schemas.file){await o(i);return}const s=(0,P.$wg)(this.extensionsDownloadDir,`.${(0,b.$fg)()}`);await this.h.exists(s)||await o(s);try{await A.Promises.rename(s.fsPath,i.fsPath,2*60*1e3)}catch(t){try{await this.h.del(s)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,i.path);else throw this.r.info(`Rename failed because of ${(0,R.$0)(t)}. Deleted the file from downloaded location`,s.path),t}}async delete(n){await this.g,await this.h.del(n)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const i=[],o=[],s=[];for(const $ of n.children)if($.name.endsWith(l.c))s.push($.resource);else{const w=d.$Eo.parse($.name);w&&o.push([w,$])}const t=(0,d.$Jo)(o,([$])=>$),a=[];for(const $ of t)$.sort((w,k)=>C.rcompare(w[0].version,k[0].version)),i.push(...$.slice(1).map(w=>w[1].resource)),a.push($[0][1]);a.sort(($,w)=>$.mtime-w.mtime),i.push(...a.slice(0,Math.max(0,a.length-this.f)).map($=>$.resource)),i.push(...s),await D.Promises.settled(i.map($=>(this.r.trace("Deleting from cache",$.path),this.h.del($))))}}catch(n){this.r.error(n)}}z(n){return this.f?d.$Eo.create(n).toString().toLowerCase():(0,b.$fg)()}};e.$Hp=m,e.$Hp=m=l=Oe([Ae(0,u.$Yh),Ae(1,h.$_j),Ae(2,g.$bo),Ae(3,y.$ki),Ae(4,f.$ip),Ae(5,p.$$i)],m)}),define(pe[285],be([1,0,93,184]),function(ue,e,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;function r(I){return(0,D.$sp)(I,"extension/package.json").then(P=>{try{return JSON.parse(P.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}e.$Jp=r}),define(pe[138],be([1,0,14,15,20,39,11,5,60,2,26,12,7,19,53,10,4,23,21,93,183,81,25,256,30,36,45,58,284,257,285,232,241,80,16,6,13,31,32,34,33]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u,g,d,f,h,p,l,m,c,n,i,o,s,t,a,$,w,k,E,L,j,x,ce,X,ie,he,_,de){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=e.$Np=e.$Mp=void 0,e.$Mp=(0,ce.$Rh)(o.$do);const Z=".vsctmp";let ne=class extends i.$tp{constructor(B,K,N,O,U,T,q,z,te,H,Y,V){super(B,K,Y,N,H,V),this.fb=U,this.gb=T,this.hb=q,this.ib=te,this.eb=new Map,this.rb=new A.$Bc;const Q=this.B(z.createInstance(w.$Ip));this.bb=this.B(z.createInstance(J,me=>Q.postUninstall(me))),this.cb=this.B(new E.$Kp(V,te,Y,this,this.F)),this.db=this.B(z.createInstance($.$Hp));const se=this.B(new L.$Lp(this,this.fb,V,T,Y,te,N));this.B(se.onDidChangeExtensionsByAnotherSource(me=>this.qb(me))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,s.$Oo)(this.ib,this.F)),this.jb}async zip(B){this.F.trace("ExtensionManagementService#zip",B.identifier.id);const K=await this.pb(B),N=await(0,l.zip)((0,u.$wg)(this.db.extensionsDownloadDir,(0,h.$fg)()).fsPath,K);return f.URI.file(N)}async unzip(B){return this.F.trace("ExtensionManagementService#unzip",B.toString()),(await this.install(B)).identifier}async getManifest(B){const{location:K,cleanup:N}=await this.lb(B),O=y.$kc(K.fsPath);try{return await(0,k.$Jp)(O)}finally{await N()}}getInstalled(B,K=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(B??null,K)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(B){return this.bb.scanUserExtensionAtLocation(B)}async install(B,K={}){this.F.trace("ExtensionManagementService#install",B.toString());const{location:N,cleanup:O}=await this.lb(B);try{const U=await(0,k.$Jp)(y.$kc(N.fsPath)),T=(0,s.$Io)(U.publisher,U.name);if(U.engines&&U.engines.vscode&&!(0,j.$Vo)(U.engines.vscode,this.G.version,this.G.date))throw new Error(m.localize(0,null,T,this.G.version));const z=(await this.I([{manifest:U,extension:N,options:K}])).find(({identifier:te})=>(0,s.$Do)(te,{id:T}));if(z?.local)return z.local;throw z?.error?z.error:(0,i.$vp)(new Error(`Unknown error while installing extension ${T}`))}finally{await O()}}async installFromLocation(B,K){this.F.trace("ExtensionManagementService#installFromLocation",B.toString());const N=await this.bb.scanUserExtensionAtLocation(B);if(!N)throw new Error(`Cannot find a valid extension from the location ${B.toString()}`);return await this.ub([[N,void 0]],K),this.F.info("Successfully installed extension",N.identifier.id,K.toString()),N}async installExtensionsFromProfile(B,K,N){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",B,K.toString(),N.toString());const O=(await this.bb.scanExtensions(1,K)).filter(U=>B.some(T=>(0,s.$Do)(T,U.identifier)));if(O.length){const U=await Promise.all(O.map(T=>this.bb.scanMetadata(T,K)));await this.ub(O.map((T,q)=>[T,U[q]]),N),this.F.info("Successfully installed extensions",O.map(T=>T.identifier.id),N.toString())}return O}async updateMetadata(B,K,N=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",B.identifier.id),K.isPreReleaseVersion&&(K.preRelease=!0),K.isMachineScoped===!1&&(K.isMachineScoped=void 0),K.isBuiltin===!1&&(K.isBuiltin=void 0),K.pinned===!1&&(K.pinned=void 0),B=await this.bb.updateMetadata(B,K,N),this.cb.invalidate(N),this.w.fire(B),B}async reinstallFromGallery(B){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",B.identifier.id),!this.z.isEnabled())throw new Error(m.localize(1,null));const K=await this.getTargetPlatform(),[N]=await this.z.getExtensions([{...B.identifier,preRelease:B.preRelease}],{targetPlatform:K,compatible:!0},r.CancellationToken.None);if(!N)throw new Error(m.localize(2,null));await this.bb.setUninstalled(B);try{await this.bb.removeUninstalledExtension(B)}catch(O){throw new Error(m.localize(3,null,(0,I.$Bi)(O)))}return this.installFromGallery(N)}ab(B,K,N,O){return this.bb.copyExtension(B,K,N,O)}copyExtensions(B,K){return this.bb.copyExtensions(B,K)}markAsUninstalled(...B){return this.bb.setUninstalled(...B)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(B){this.F.error(B)}}async download(B,K,N){const{location:O}=await this.db.download(B,K,!N);return O}async lb(B){if(B.scheme===S.Schemas.file)return{location:B,async cleanup(){}};this.F.trace("Downloading extension from",B.toString());const K=(0,u.$wg)(this.db.extensionsDownloadDir,(0,h.$fg)());return await this.hb.download(B,K),this.F.info("Downloaded extension to",K.toString()),{location:K,cleanup:async()=>{try{await this.ib.del(K)}catch(O){this.F.error(O)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(B,K,N){if(f.URI.isUri(K))return new le(B,K,N,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const O=s.$Eo.create(K).toString();let U=this.eb.get(O);return U||(this.eb.set(O,U=new oe(B,K,N,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),U.waitUntilTaskIsFinished().finally(()=>this.eb.delete(O))),U}$(B,K){return new re(B,K.profileLocation,this.gb)}async pb(B){const K=async O=>{let U=await p.Promises.readdir(O);U=U.map(z=>y.$jc(O,z));const T=await Promise.all(U.map(z=>p.Promises.stat(z)));let q=Promise.resolve([]);return T.forEach((z,te)=>{const H=U[te];z.isFile()&&(q=q.then(Y=>[...Y,H])),z.isDirectory()&&(q=q.then(Y=>K(H).then(V=>[...Y,...V])))}),q};return(await K(B.location.fsPath)).map(O=>({path:`extension/${y.$lc(B.location.fsPath,O)}`,localPath:O}))}async qb({added:B,removed:K}){if(K){const N=B&&this.D.extUri.isEqual(K.profileLocation,B.profileLocation)?K.extensions.filter(O=>B.extensions.every(U=>!(0,s.$Do)(U,O))):K.extensions;for(const O of N)this.F.info("Extensions removed from another source",O.id,K.profileLocation.toString()),this.u.fire({identifier:O,profileLocation:K.profileLocation})}if(B){const O=(await this.bb.scanExtensions(1,B.profileLocation)).filter(U=>B.extensions.some(T=>(0,s.$Do)(T,U.identifier)));this.s.fire(O.map(U=>(this.F.info("Extensions added from another source",U.identifier.id,B.profileLocation.toString()),{identifier:U.identifier,local:U,profileLocation:B.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(K=>this.rb.add(K)));const B=await this.ib.resolve(this.fb.userExtensionsLocation);for(const K of B.children??[])K.isDirectory&&this.rb.add(K.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(K=>this.tb(K)))}async tb(B){if(!B.affects(this.fb.userExtensionsLocation,1))return;const K=[];for(const N of B.rawAdded){if(this.rb.has(N)||!this.D.extUri.isEqual(this.D.extUri.dirname(N),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(N,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(N).startsWith(".")||!(await this.ib.stat(N)).isDirectory)continue;const O=await this.bb.scanUserExtensionAtLocation(N);O&&O.installedTimestamp===void 0&&(this.rb.add(N),K.push(O))}K.length&&(await this.ub(K.map(N=>[N,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",K.map(N=>N.identifier.id)))}async ub(B,K){const N=B.map(O=>O[0]);await this.vb(N),await this.gb.addExtensionsToProfile(B,K),this.s.fire(N.map(O=>({local:O,identifier:O.identifier,operation:1,profileLocation:K})))}async vb(B){const K=await this.bb.getUninstalledExtensions();for(const N of B){const O=s.$Eo.create(N);K[O.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",O.id),await this.bb.setInstalled(O),this.F.info("Removed the extension from uninstalled list:",O.id))}}};e.$Np=ne,e.$Np=ne=Oe([Ae(0,o.$bo),Ae(1,he.$dl),Ae(2,X.$$i),Ae(3,n.$Yh),Ae(4,a.$Cp),Ae(5,t.$yp),Ae(6,c.$Sn),Ae(7,ce.$Ph),Ae(8,x.$_j),Ae(9,ie.$qj),Ae(10,_.$Jk),Ae(11,de.$Lk)],ne);let J=class extends b.$Sc{constructor(B,K,N,O,U,T){super(),this.j=B,this.m=K,this.n=N,this.s=O,this.t=U,this.u=T,this.h=this.B(new C.$Od),this.onExtract=this.h.event,this.c=(0,u.$wg)(this.n.userExtensionsLocation,".obsolete"),this.g=new D.$2g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(B,K){const N={includeInvalid:!0,profileLocation:K};let O=[];return B===null||B===0?O.push(...await this.n.scanAllExtensions({includeInvalid:!0},N,!1)):B===1&&O.push(...await this.n.scanUserExtensions(N)),O=B!==null?O.filter(U=>U.type===B):O,Promise.all(O.map(U=>this.F(U)))}async scanAllUserExtensions(B){const K=await this.n.scanUserExtensions({includeAllVersions:!B,includeInvalid:!0});return Promise.all(K.map(N=>this.F(N)))}async scanUserExtensionAtLocation(B){try{const K=await this.n.scanExistingExtension(B,1,{includeInvalid:!0});if(K)return await this.F(K)}catch(K){this.u.error(K)}return null}async extractUserExtension(B,K,N,O,U){const T=B.toString(),q=f.URI.file(y.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,h.$fg)()}`)),z=f.URI.file(y.$jc(this.n.userExtensionsLocation.fsPath,T));let te=await this.m.exists(z);if(te&&O){try{await this.y(B.id,z,"removeExisting")}catch{throw new o.$co(m.localize(4,null,z.fsPath,B.id),o.ExtensionManagementErrorCode.Delete)}te=!1}if(!te)try{try{this.u.trace(`Started extracting the extension from ${K} to ${z.fsPath}`),await(0,l.$rp)(K,q.fsPath,{sourcePath:"extension",overwrite:!0},U),this.u.info(`Extracted extension to ${z}:`,B.id)}catch(H){let Y=o.ExtensionManagementErrorCode.Extract;throw H instanceof l.$pp&&(H.type==="CorruptZip"?Y=o.ExtensionManagementErrorCode.CorruptZip:H.type==="Incomplete"&&(Y=o.ExtensionManagementErrorCode.IncompleteZip)),new o.$co(H.message,Y)}await this.n.updateMetadata(q,N);try{this.u.trace(`Started renaming the extension from ${q.fsPath} to ${z.fsPath}`),await this.C(q.fsPath,z.fsPath),this.u.info("Renamed to",z.fsPath)}catch(H){if(H.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",B.id);else throw this.u.info(`Rename failed because of ${(0,P.$0)(H)}. Deleted from extracted location`,q),H}this.h.fire(z)}catch(H){try{await this.m.del(q,{recursive:!0})}catch{}throw H}return this.D(z,1)}async scanMetadata(B,K){return K?(await this.w(B,K))?.metadata:this.n.scanMetadata(B.location)}async w(B,K){return(await this.s.scanProfileExtensions(K)).find(O=>(0,s.$Do)(O.identifier,B.identifier))}async updateMetadata(B,K,N){return N?await this.s.updateMetadata([[B,K]],N):await this.n.updateMetadata(B.location,K),this.D(B.location,B.type,N)}getUninstalledExtensions(){return this.z()}async setUninstalled(...B){const K=B.map(N=>s.$Eo.create(N));await this.z(N=>K.forEach(O=>{N[O.toString()]=!0,this.u.info("Marked extension as uninstalled",O.toString())}))}async setInstalled(B){await this.z(K=>delete K[B.toString()])}async removeExtension(B,K){if(this.t.extUri.isEqualOrParent(B.location,this.n.userExtensionsLocation))return this.y(B.identifier.id,B.location,K)}async removeUninstalledExtension(B){await this.removeExtension(B,"uninstalled"),await this.z(K=>delete K[s.$Eo.create(B).toString()])}async copyExtension(B,K,N,O){const U=await this.w(B,K),T=await this.w(B,N);return O={...U?.metadata,...O},T?await this.s.updateMetadata([[B,{...T.metadata,...O}]],N):await this.s.addExtensionsToProfile([[B,O]],N),this.D(B.location,B.type,N)}async copyExtensions(B,K){const N=await this.scanExtensions(1,B),O=await Promise.all(N.filter(U=>!U.isApplicationScoped).map(async U=>[U,await this.scanMetadata(U,B)]));await this.s.addExtensionsToProfile(O,K)}async y(B,K,N){this.u.trace(`Deleting ${N} extension from disk`,B,K.fsPath);const O=this.t.extUri.joinPath(this.t.extUri.dirname(K),`${this.t.extUri.basename(K)}.${(0,v.$Ei)((0,h.$fg)()).toString(16)}${Z}`);await this.C(K.fsPath,O.fsPath),await this.m.del(O,{recursive:!0}),this.u.info(`Deleted ${N} extension from disk`,B,K.fsPath)}async z(B){return this.g.queue(async()=>{let K;try{K=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(O){if((0,x.$qk)(O)!==1)throw O}let N={};if(K)try{N=JSON.parse(K)}catch{}return B&&(B(N),Object.keys(N).length?await this.m.writeFile(this.c,R.$ce.fromString(JSON.stringify(N))):await this.m.del(this.c)),N})}async C(B,K){try{await p.Promises.rename(B,K,2*60*1e3)}catch(N){throw new o.$co(N.message||m.localize(5,null,B,K),N.code||o.ExtensionManagementErrorCode.Rename)}}async D(B,K,N){if(N){const U=(await this.n.scanUserExtensions({profileLocation:N})).find(T=>this.t.extUri.isEqual(T.location,B));if(U)return this.F(U)}else{const O=await this.n.scanExistingExtension(B,K,{includeInvalid:!0});if(O)return this.F(O)}throw new Error(m.localize(6,null,B.path))}async F(B){const K=await this.m.resolve(B.location);let N,O;return K.children&&(N=K.children.find(({name:U})=>/^readme(\.txt|\.md|)$/i.test(U))?.resource,O=K.children.find(({name:U})=>/^changelog(\.txt|\.md|)$/i.test(U))?.resource),{identifier:B.identifier,type:B.type,isBuiltin:B.isBuiltin||!!B.metadata?.isBuiltin,location:B.location,manifest:B.manifest,targetPlatform:B.targetPlatform,validations:B.validations,isValid:B.isValid,readmeUrl:N,changelogUrl:O,publisherDisplayName:B.metadata?.publisherDisplayName||null,publisherId:B.metadata?.publisherId||null,isApplicationScoped:!!B.metadata?.isApplicationScoped,isMachineScoped:!!B.metadata?.isMachineScoped,isPreReleaseVersion:!!B.metadata?.isPreReleaseVersion,preRelease:!!B.metadata?.preRelease,installedTimestamp:B.metadata?.installedTimestamp,updated:!!B.metadata?.updated,pinned:!!B.metadata?.pinned}}async G(){const B=await this.getUninstalledExtensions();if(Object.keys(B).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(B));const K=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),N=new Set;for(const U of K)B[s.$Eo.create(U).toString()]||N.add(U.identifier.id.toLowerCase());try{const U=(0,s.$Jo)(K,T=>T.identifier);await D.Promises.settled(U.map(async T=>{const q=T.sort((z,te)=>g.rcompare(z.manifest.version,te.manifest.version))[0];N.has(q.identifier.id.toLowerCase())||await this.j(await this.F(q))}))}catch(U){this.u.error(U)}const O=K.filter(U=>U.metadata&&B[s.$Eo.create(U).toString()]);await Promise.allSettled(O.map(U=>this.removeUninstalledExtension(U)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let B;try{B=await this.m.resolve(this.n.userExtensionsLocation)}catch(K){(0,x.$qk)(K)!==1&&this.u.error(K);return}if(B?.children)try{await Promise.allSettled(B.children.map(async K=>{if(!(!K.isDirectory||!K.name.endsWith(Z))){this.u.trace("Deleting the temporarily deleted folder",K.resource.toString());try{await this.m.del(K.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",K.resource.toString())}catch(N){(0,x.$qk)(N)!==1&&this.u.error(N)}}}))}catch{}}};e.$Op=J,e.$Op=J=Oe([Ae(1,x.$_j),Ae(2,a.$Cp),Ae(3,t.$yp),Ae(4,_.$Jk),Ae(5,X.$$i)],J);class W extends i.$wp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,d.$Gf)(this.options.operation)?this.l:this.options.operation}constructor(B,K,N,O,U,T,q,z,te){super(),this.identifier=B,this.source=K,this.options=N,this.m=O,this.n=U,this.o=T,this.p=q,this.q=z,this.s=te,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(B){const[K,N]=await this.x(B);return this.j=K.isBuiltin||K.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[K,N]],this.j),K}async u({zipPath:B,key:K,metadata:N},O,U){let T=await this.v(K);return T||(this.s.trace("Extracting extension...",K.id),T=await this.m.extractUserExtension(K,B,N,O,U),this.s.info("Extracting extension completed.",K.id)),T}async v(B){return await this.w(B)?(this.s.trace("Removing the extension from uninstalled list:",B.id),await this.m.setInstalled(B),this.s.info("Removed the extension from uninstalled list:",B.id),(await this.m.scanAllUserExtensions(!0)).find(O=>s.$Eo.create(O).equals(B))):void 0}async w(B){return!!(await this.m.getUninstalledExtensions())[B.toString()]}}class oe extends W{constructor(B,K,N,O,U,T,q,z,te,H){super(K.identifier,K,N,U,T,q,z,te,H),this.y=K,this.z=O}async x(B){const N=(await this.m.scanExtensions(null,this.options.profileLocation)).find(q=>(0,s.$Do)(q.identifier,this.y.identifier));N&&(this.l=3);const O={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||N?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||N?.isMachineScoped,isBuiltin:this.options.isBuiltin||N?.isBuiltin,isSystem:N?.type===0?!0:void 0,updated:!!N,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,d.$Ff)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:N?.preRelease)};if(N?.manifest.version===this.y.version)return[await this.m.updateMetadata(N,O),O];const{location:U,verificationStatus:T}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=T,this.B(U.fsPath),[await this.u({zipPath:U.fsPath,key:s.$Eo.create(this.y),metadata:O},!1,B),O]}catch(q){try{await this.z.delete(U)}catch(z){this.s.warn("Error while deleting the downloaded file",U.toString(),(0,P.$0)(z))}throw q}}async B(B){try{await(0,k.$Jp)(B)}catch(K){throw new o.$co((0,i.$up)(K).message,o.ExtensionManagementErrorCode.Invalid)}}}e.$Pp=oe;class le extends W{constructor(B,K,N,O,U,T,q,z,te,H){super({id:(0,s.$Io)(B.publisher,B.name)},K,N,U,T,q,z,te,H),this.y=B,this.z=K,this.A=O}async h(B){const K=await super.h(B);return this.D(K,B),K}async x(B){const K=new s.$Eo(this.identifier,this.y.version),O=(await this.m.scanExtensions(1,this.options.profileLocation)).find(q=>(0,s.$Do)(this.identifier,q.identifier)),U={isApplicationScoped:this.options.isApplicationScoped||O?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||O?.isMachineScoped,isBuiltin:this.options.isBuiltin||O?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(O)if(this.l=3,K.equals(new s.$Eo(O.identifier,O.manifest.version)))try{await this.m.removeExtension(O,"existing")}catch{throw new Error(m.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&g.gt(O.manifest.version,this.y.version)&&await this.m.setUninstalled(O);else{const q=await this.v(K);if(q)try{await this.m.removeExtension(q,"existing")}catch{throw new Error(m.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:y.$kc(this.z.fsPath),key:K,metadata:U},!0,B),U]}async D(B,K){try{let[N]=await this.A.getExtensions([{id:B.identifier.id,version:B.manifest.version}],K);if(N||([N]=await this.A.getExtensions([{id:B.identifier.id}],K)),N){const O={id:N.identifier.uuid,publisherDisplayName:N.publisherDisplayName,publisherId:N.publisherId,isPreReleaseVersion:N.properties.isPreReleaseVersion,preRelease:N.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(B,O,this.options.profileLocation)}}catch{}}}class re extends i.$wp{constructor(B,K,N){super(),this.extension=B,this.j=K,this.k=N}async h(B){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(pe[72],be([1,0,87,78,28,286,15,11,5,2,7,3,23,43,106]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=void 0;class d{traceSocketEvent(E,L){g.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,L)}constructor(E,L=""){this.f=!0,this.debugLabel=L,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,C.$1)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const L=j=>{this.traceSocketEvent("read",j),E(P.$ce.wrap(j))};return this.socket.on("data",L),{dispose:()=>this.socket.off("data",L)}}onClose(E){const L=j=>{E({type:0,hadError:j,error:void 0})};return this.socket.on("close",L),{dispose:()=>this.socket.off("close",L)}}onEnd(E){const L=()=>{E()};return this.socket.on("end",L),{dispose:()=>this.socket.off("end",L)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,L=>{if(L){if(L.code==="EPIPE")return;(0,C.$1)(L)}})}catch(L){if(L.code==="EPIPE")return;(0,C.$1)(L)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,L)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$Fh=d;var f;(function(k){k[k.MinHeaderByteSize=2]="MinHeaderByteSize",k[k.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var h;(function(k){k[k.PeekHeader=1]="PeekHeader",k[k.ReadHeader=2]="ReadHeader",k[k.ReadBody=3]="ReadBody",k[k.Fin=4]="Fin"})(h||(h={}));class p extends b.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,L){this.socket.traceSocketEvent(E,L)}constructor(E,L,j,x){super(),this.f=this.B(new v.$Od),this.g=this.B(new v.$Od),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:L,inflateBytesLength:j?.byteLength||0,recordInflateBytes:x}),this.a=this.B(new l(this,L,j,x,this.f,(ce,X)=>this.m(ce,X))),this.B(this.a.onError(ce=>{console.error(ce),(0,C.$1)(ce),this.g.fire({type:0,hadError:!0,error:ce})})),this.b=new g.$Ah,this.B(this.socket.onData(ce=>this.n(ce))),this.B(this.socket.onClose(async ce=>{this.a.isProcessingReadQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(ce)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let L=0;for(;L<E.byteLength;)this.a.writeMessage(E.slice(L,Math.min(L+262144,E.byteLength)),{compressed:!0,opcode:2}),L+=262144}m(E,{compressed:L,opcode:j}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let x=2;E.byteLength<126?x+=0:E.byteLength<2**16?x+=2:x+=8;const ce=P.$ce.alloc(x),X=L?64:0,ie=j&15;if(ce.writeUInt8(128|X|ie,0),E.byteLength<126)ce.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){ce.writeUInt8(126,1);let he=1;ce.writeUInt8(E.byteLength>>>8&255,++he),ce.writeUInt8(E.byteLength>>>0&255,++he)}else{ce.writeUInt8(127,1);let he=1;ce.writeUInt8(0,++he),ce.writeUInt8(0,++he),ce.writeUInt8(0,++he),ce.writeUInt8(0,++he),ce.writeUInt8(E.byteLength>>>24&255,++he),ce.writeUInt8(E.byteLength>>>16&255,++he),ce.writeUInt8(E.byteLength>>>8&255,++he),ce.writeUInt8(E.byteLength>>>0&255,++he)}this.socket.write(P.$ce.concat([ce,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const L=this.b.peek(this.j.readLen),j=L.readUInt8(0),x=(j&128)>>>7,ce=(j&64)>>>6,X=j&15,ie=L.readUInt8(1),he=(ie&128)>>>7,_=ie&127;this.j.state=2,this.j.readLen=2+(he?4:0)+(_===126?2:0)+(_===127?8:0),this.j.fin=x,this.j.firstFrameOfMessage&&(this.j.compressed=!!ce),this.j.firstFrameOfMessage=!!x,this.j.mask=0,this.j.opcode=X,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const L=this.b.read(this.j.readLen),j=L.readUInt8(1),x=(j&128)>>>7;let ce=j&127,X=1;ce===126?ce=L.readUInt8(++X)*2**8+L.readUInt8(++X):ce===127&&(ce=L.readUInt8(++X)*0+L.readUInt8(++X)*0+L.readUInt8(++X)*0+L.readUInt8(++X)*0+L.readUInt8(++X)*2**24+L.readUInt8(++X)*2**16+L.readUInt8(++X)*2**8+L.readUInt8(++X));let ie=0;x&&(ie=L.readUInt8(++X)*2**24+L.readUInt8(++X)*2**16+L.readUInt8(++X)*2**8+L.readUInt8(++X)),this.j.state=3,this.j.readLen=ce,this.j.mask=ie,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const L=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",L),n(L,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",L),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(L,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(L,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Gh=p;class l extends b.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:P.$ce.alloc(0)}constructor(E,L,j,x,ce,X){super(),this.n=E,this.r=ce,this.s=X,this.a=this.B(new v.$Od),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new v.$Od),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new v.$Od),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,L?(this.b=this.B(new m(this.n,x,j,{windowBits:15})),this.f=this.B(new c(this.n,{windowBits:15})),this.B(this.b.onError(ie=>this.a.fire(ie))),this.B(this.f.onError(ie=>this.a.fire(ie)))):(this.b=null,this.f=null)}writeMessage(E,L){this.g.push({data:E,options:L}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:L}=this.g.shift();if(this.f&&L.compressed){const j=await this.w(this.f,E);this.s(j,L)}else this.s(E,{...L,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,L){return new Promise((j,x)=>{E.write(L),E.flush(ce=>j(ce))})}acceptFrame(E,L,j){this.h.push({data:E,isCompressed:L,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const L=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(L)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,L,j){return new Promise((x,ce)=>{E.write(L),j&&E.write(P.$ce.fromByteArray([0,0,255,255])),E.flush(X=>x(X))})}}class m extends b.$Sc{get recordedInflateBytes(){return this.j?P.$ce.concat(this.f):P.$ce.alloc(0)}constructor(E,L,j,x){super(),this.h=E,this.j=L,this.a=this.B(new v.$Od),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,I.createInflateRaw)(x),this.b.on("error",ce=>{this.h.traceSocketEvent("zlibInflateError",{message:ce?.message,code:ce?.code}),this.a.fire(ce)}),this.b.on("data",ce=>{this.h.traceSocketEvent("zlibInflateData",ce),this.g.push(P.$ce.wrap(ce))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent("zlibInflateWrite",E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const L=P.$ce.concat(this.g);this.g.length=0,E(L)})}}class c extends b.$Sc{constructor(E,L){super(),this.g=E,this.a=this.B(new v.$Od),this.onError=this.a.event,this.f=[],this.b=(0,I.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(P.$ce.wrap(j))})}write(E){this.g.traceSocketEvent("zlibDeflateWrite",E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let L=P.$ce.concat(this.f);this.f.length=0,L=L.slice(0,L.byteLength-4),E(L)})}}function n(k,E){if(E===0)return;const L=k.byteLength>>>2;for(let he=0;he<L;he++){const _=k.readUInt32BE(he*4);k.writeUInt32BE(_^E,he*4)}const j=L*4,x=k.byteLength-j,ce=E>>>24&255,X=E>>>16&255,ie=E>>>8&255;x>=1&&k.writeUInt8(k.readUInt8(j)^ce,j),x>=2&&k.writeUInt8(k.readUInt8(j+1)^X,j+1),x>=3&&k.writeUInt8(k.readUInt8(j+2)^ie,j+2)}e.$Hh=process.env.XDG_RUNTIME_DIR;const i={[2]:107,[1]:103};function o(){const k=(0,y.$fg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${k}-sock`;const E=process.platform!=="darwin"&&e.$Hh?e.$Hh:(0,r.tmpdir)(),L=(0,A.$jc)(E,`vscode-ipc-${k}.sock`);return t(L),L}e.$Ih=o;function s(k,E,L){const j=(0,D.createHash)("md5").update(k).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${L}-${E}-sock`;const x=L.substr(0,4),ce=E.substr(0,6),X=j.substr(0,8);let ie;return process.platform!=="darwin"&&e.$Hh&&!process.env.VSCODE_PORTABLE?ie=(0,A.$jc)(e.$Hh,`vscode-${X}-${x}-${ce}.sock`):ie=(0,A.$jc)(k,`${x}-${ce}.sock`),t(ie),ie}e.$Jh=s;function t(k){const E=i[S.$u];typeof E=="number"&&k.length>=E&&console.warn(`WARNING: IPC handle "${k}" is longer than ${E} chars, try a shorter --user-data-dir`)}class a extends u.$uh{static b(E){const L=v.Event.fromNodeEventEmitter(E,"connection");return v.Event.map(L,j=>({protocol:new g.$Bh(new d(j,"ipc-server-connection")),onDidClientDisconnect:v.Event.once(v.Event.fromNodeEventEmitter(j,"close"))}))}constructor(E){super(a.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Kh=a;function $(k){return new Promise((E,L)=>{const j=(0,R.createServer)();j.on("error",L),j.listen(k,()=>{j.removeListener("error",L),E(new a(j))})})}e.$Lh=$;function w(k,E){return new Promise((L,j)=>{const x=(0,R.createConnection)(k,()=>{x.removeListener("error",j),L(g.$Ch.fromSocket(new d(x,`ipc-client${E}`),E))});x.once("error",j)})}e.$Mh=w}),define(pe[139],be([1,0,85,14,15,11,10,24,25,86,13,44,235,286]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=e.$3q=void 0;let g=class extends S.$Xo{constructor(p,l,m,c){super(c),this.m=p,this.n=l,this.r=m,this.s(),this.B(p.onDidChangeConfiguration(n=>{n.affectsConfiguration("http")&&this.s()}))}s(){const p=this.m.getValue("http");this.f=p?.proxy,this.g=!!p?.proxyStrictSSL,this.h=p?.proxyAuthorization}async request(p,l){const{f:m,g:c}=this;let n;try{n=await(0,b.$Ul)(this.m,this.r,this.n.args,process.env)}catch(s){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,I.$0)(s)))}const i={...process.env,...n},o=p.agent?p.agent:await(0,y.$2q)(p.url||"",i,{proxyUrl:m,strictSSL:c});return p.agent=o,p.strictSSL=c,this.h&&(p.headers={...p.headers||{},"Proxy-Authorization":this.h}),this.c(p.isChromiumNetwork?"electron":"node",p,()=>f(p,l))}async resolveProxy(p){}};e.$3q=g,e.$3q=g=Oe([Ae(0,C.$ki),Ae(1,v.$Yh),Ae(2,A.$$i),Ae(3,A.$_i)],g);async function d(h){return((0,D.parse)(h.url).protocol==="https:"?await new Promise((m,c)=>{ue(["https"],m,c)}):await new Promise((m,c)=>{ue(["http"],m,c)})).request}async function f(h,p){return R.Promises.withAsyncBody(async(l,m)=>{const c=(0,D.parse)(h.url),n=h.getRawRequest?h.getRawRequest(h):await d(h),i={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,P.$Ff)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(i.auth=h.user+":"+h.password);const o=n(i,s=>{const t=(0,P.$Df)(h.followRedirects)?h.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&t>0&&s.headers.location)f({...h,url:s.headers.location,followRedirects:t-1},p).then(l,m);else{let a=s;!h.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(a=s.pipe((0,u.createGunzip)())),l({res:s,stream:(0,r.$re)(a)})}});o.on("error",m),h.timeout&&o.setTimeout(h.timeout),h.isChromiumNetwork&&o.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&o.write(h.data),o.end(),p.onCancellationRequested(()=>{o.abort(),m(new I.$5)})})}e.$4q=f}),define(pe[140],be([1,0,52,78,128,12,7,15,5,72,86,13,46,3,64,127,2,274,24]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u,g,d,f,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=void 0;async function l(s={},t,a,$,w,k){const E=await(0,r.$ol)(a,$.userDataPath);let L={};if(t)try{L=await(0,A.$Ul)(k,w,$.args,process.env)}catch(he){w.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",he)}const x={...process.env,...L,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(E,void 0,0),...s},ce=$.isBuilt?(0,P.$jc)($.appRoot,"bin"):(0,P.$jc)($.appRoot,"resources","server","bin-dev"),X=(0,P.$jc)(ce,"remote-cli");let ie=n(x,"PATH");return ie?ie=X+P.$tc+ie:ie=X,i(x,"PATH",ie),$.args["without-browser-env-var"]||(x.BROWSER=(0,P.$jc)(ce,"helpers",u.$j?"browser.cmd":"browser.sh")),o(x),x}e.$Dm=l;class m{constructor(t,a){this.socket=t,this.initialDataChunk=a}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let t,a,$;return this.socket instanceof b.$Fh?(t=!0,a=!1,$=C.$ce.alloc(0)):(t=!1,a=this.socket.permessageDeflate,$=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:t,permessageDeflate:a,inflateBytes:$.buffer.toString("base64")}}}let c=class{constructor(t,a,$,w,k,E,L,j){this.i=t,this.j=k,this.l=E,this.m=L,this.n=j,this.b=new v.$Od,this.onClose=this.b.event,this.c=!u.$j||!this.j.args["socket-path"],this.d=!1,this.f=a,this.g=null,this.h=new m($,w),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(t){this.l.info(`${this.o}${t}`)}q(t){this.l.error(`${this.o}${t}`)}async r(t,a){const $=new f.$Rc;$.add(a.socket),$.add((0,f.$Qc)(()=>{t.destroy()}));const w=()=>{$.dispose()};$.add(a.socket.onEnd(w)),$.add(a.socket.onClose(w)),$.add(v.Event.fromNodeEventEmitter(t,"end")(w)),$.add(v.Event.fromNodeEventEmitter(t,"close")(w)),$.add(v.Event.fromNodeEventEmitter(t,"error")(w)),$.add(a.socket.onData(k=>t.write(k.buffer))),$.add(v.Event.fromNodeEventEmitter(t,"data")(k=>{a.socket.write(C.$ce.wrap(k))})),a.initialDataChunk.byteLength>0&&t.write(a.initialDataChunk.buffer)}async s(t,a){await a.socketDrain();const $=a.toIExtHostSocketMessage();let w;a.socket instanceof b.$Fh?w=a.socket.socket:w=a.socket.socket.socket,t.send($,w)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const t={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(t)}acceptReconnection(t,a,$){this.f=t,this.p("The client has reconnected.");const w=new m(a,$);if(!this.g){this.h=w;return}this.s(this.g,w)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(t){try{let a=process.execArgv?process.execArgv.filter(X=>!/^--inspect(-brk)?=/.test(X)):[];t.port&&!process.pkg&&(a=[`--inspect${t.break?"-brk":""}=${t.port}`]);const $=await l(t.env,!0,t.language,this.j,this.l,this.n);(0,g.$Bl)($);let w;if(this.c)(0,h.$Bm)(new h.$zm,$),w=null;else{const{namedPipeServer:X,pipeName:ie}=await this.u();(0,h.$Bm)(new h.$ym(ie),$),w=X}const k={env:$,execArgv:a,silent:!0};k.execArgv.unshift("--dns-result-order=ipv4first");const E=["--type=extensionHost","--transformURIs"],L=this.j.args["use-host-proxy"];E.push(`--useHostProxy=${L?"true":"false"}`),this.g=D.fork(I.$dg.asFileUri("bootstrap-fork").fsPath,E,k);const j=this.g.pid;this.p(`<${j}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const x=v.Event.fromNodeEventEmitter(this.g.stdout,"data"),ce=v.Event.fromNodeEventEmitter(this.g.stderr,"data");if(x(X=>this.p(`<${j}> ${X}`)),ce(X=>this.p(`<${j}><stderr> ${X}`)),this.g.on("error",X=>{this.q(`<${j}> Extension Host Process had an error`),this.l.error(X),this.t()}),this.g.on("exit",(X,ie)=>{this.m.setExitInfo(this.i,{code:X,signal:ie}),this.p(`<${j}> Extension Host Process exited with code: ${X}, signal: ${ie}.`),this.t()}),w)w.on("connection",X=>{w.close(),this.r(X,this.h)});else{const X=ie=>{ie.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",X),this.s(this.g,this.h),this.h=null)};this.g.on("message",X)}}catch(a){console.error("ExtensionHostConnection errored"),a&&console.error(a)}}u(){return new Promise((t,a)=>{const $=(0,b.$Ih)(),w=R.createServer();w.on("error",a),w.listen($,()=>{w?.removeListener("error",a),t({pipeName:$,namedPipeServer:w})})})}};e.$Em=c,e.$Em=c=Oe([Ae(4,y.$om),Ae(5,S.$$i),Ae(6,d.$wm),Ae(7,p.$ki)],c);function n(s,t){const a=Object.keys(s).filter(w=>w.toLowerCase()===t.toLowerCase()),$=a.length>0?a[0]:t;return s[$]}function i(s,t,a){const $=Object.keys(s).filter(k=>k.toLowerCase()===t.toLowerCase()),w=$.length>0?$[0]:t;s[w]=a}function o(s){for(const t of Object.keys(s))s[t]===null&&delete s[t]}}),define(pe[287],be([1,0,83,13,66,116,24,44,139,38,32,30,125,138,82,110,55,2,111,68,12,16,31,46,119,84,120,11,4,7,29,233,81,34,123,65,3,58,129,33,45,69,126,124,113,114,199,288]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u,g,d,f,h,p,l,m,c,n,i,o,s,t,a,$,w,k,E,L,j,x,ce,X,ie,he,_,de,Z,ne,J,W,oe,le,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class ee extends h.$Sc{constructor(O,U){super(),this.a=O,this.b=U,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const O=await this.f();await O.invokeFunction(async U=>{const T=U.get(P.$ki),q=U.get(R.$$i);X.$j&&(T.getValue("security.restrictUNCAccess")===!1?(0,re.disableUNCAccessRestrictions)():(0,re.addUNCHostToAllowlist)(T.getValue("security.allowedUNCHosts")));try{await this.g(O.createInstance(o.$kp,new R.$gj(q.getLevel(),!1)))}catch(z){throw q.error(z),console.error((0,a.$0)(z)),z}})}async f(){const O=new D.$Oh,U={_serviceBrand:void 0,...f.default};O.set(n.$qj,U);const T=new i.$pm(this.a,U);O.set(i.$om,T);const q=new oe.$DN((0,R.$mj)(T),T.logsHome);O.set(R.$_i,q);const z=new W.$NN(this.B(q.createLogger("remoteCLI",{name:(0,le.localize)(0,null)})));O.set(R.$$i,z),z.trace(`Remote configuration data at ${this.b}`),z.trace("process arguments:",this.a);const te=this.B(new p.$Rp(z));O.set(c.$_j,te),te.registerProvider(m.Schemas.file,this.B(new l.$eq(z)));const H=new x.$Dr(te);O.set(j.$Jk,H);const Y=this.B(new ne.$LN(H,T,te,z));O.set(_.$Lk,Y);const V=this.B(new I.$On(Y.defaultProfile.settingsResource,te,new Z.$on,z));return O.set(P.$ki,V),await Promise.all([V.initialize(),Y.init()]),O.set(C.$Wo,new r.$Nh(v.$3q)),O.set(L.$Sn,new r.$Nh(E.$3N)),O.set(A.$dl,b.$po),O.set(S.$bo,new r.$Nh(y.$hp)),O.set(de.$yp,new r.$Nh(J.$MN)),O.set(ie.$Cp,new r.$Nh(he.$zN)),O.set(g.$ip,new r.$Nh(g.$jp)),O.set(u.$Mp,new r.$Nh(u.$Np)),O.set(s.$Wq,new r.$Nh(t.$Yq)),new d.$hq(O)}async g(O){if(this.a["list-extensions"])return O.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const U={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return O.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),U,!!this.a.force)}else{if(this.a["uninstall-extension"])return O.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["locate-extension"])return O.locateExtension(this.a["locate-extension"])}}h(O){return O.map(U=>/\.vsix$/i.test(U)?$.URI.file((0,w.$ic)(U)?U:(0,w.$jc)((0,k.cwd)(),U)):U)}}function B(N){setTimeout(()=>process.exit(N),0)}async function K(N,O,U){if(N.help){const q=f.default.serverApplicationName+(X.$j?".cmd":"");console.log((0,ce.$Jl)(f.default.nameLong,q,f.default.version,U,{noInputFiles:!0,noPipe:!0}));return}if(N.version){console.log((0,ce.$Kl)(f.default.version,f.default.commit));return}const T=new ee(N,O);try{await T.run(),B(0)}catch{B(1)}finally{T.dispose()}}e.run=K}),define(pe[289],be([1,0,72,303,27,282,4,13,90]),function(ue,e,D,R,r,I,P,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SM=e.$RM=void 0;class b{constructor(y,u,g){this.b=y,this.c=u,this.f=g,this.a=R.createServer((d,f)=>this.h(d,f)),this.g().catch(d=>(u.error(d),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",y=>this.c.error(y))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(y,u){const g=(f,h)=>{u.writeHead(f,{"content-type":"application/json"}),u.end(JSON.stringify(h||null),p=>p&&this.c.error(p))},d=[];y.setEncoding("utf8"),y.on("data",f=>d.push(f)),y.on("end",async()=>{try{const f=JSON.parse(d.join(""));let h;switch(f.type){case"open":h=await this.i(f);break;case"openExternal":h=await this.j(f);break;case"status":h=await this.l(f);break;case"extensionManagement":h=await this.k(f);break;default:g(404,`Unknown message type: ${f.type}`);break}g(200,h)}catch(f){const h=f instanceof Error?f.message:JSON.stringify(f);g(500,h),this.c.error("Error while processing pipe request",f)}})}async i(y){const{fileURIs:u,folderURIs:g,forceNewWindow:d,diffMode:f,mergeMode:h,addMode:p,forceReuseWindow:l,gotoLineMode:m,waitMarkerFilePath:c,remoteAuthority:n}=y,i=[];if(Array.isArray(g))for(const a of g)try{i.push({folderUri:P.URI.parse(a)})}catch{}if(Array.isArray(u))for(const a of u)try{(0,v.$ji)(a)?i.push({workspaceUri:P.URI.parse(a)}):i.push({fileUri:P.URI.parse(a)})}catch{}const o=c?P.URI.file(c):void 0,t={forceNewWindow:d,diffMode:f,mergeMode:h,addMode:p,gotoLineMode:m,forceReuseWindow:l,preferNewWindow:!l&&!o&&!p,waitMarkerFileURI:o,remoteAuthority:n};this.b.executeCommand("_remoteCLI.windowOpen",i,t)}async j(y){for(const u of y.uris){const g=P.URI.parse(u),d=g.scheme==="file"?g:u;await this.b.executeCommand("_remoteCLI.openExternal",d)}}async k(y){const u=d=>d?.map(f=>/\.vsix$/i.test(f)?P.URI.parse(f):f),g={list:y.list,install:u(y.install),uninstall:u(y.uninstall),force:y.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",g)}async l(y){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&r.existsSync(this.f)&&r.unlinkSync(this.f)}}e.$RM=b;let A=class extends b{constructor(y,u){super(y,u,(0,D.$Ih)())}};e.$SM=A,e.$SM=A=Oe([Ae(0,I.$MM),Ae(1,C.$$i)],A)}),define(pe[290],be([1,0,28,5,22,2,7,3,4,72,70,289,122,88,269,271,140]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u,g,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=void 0;class h extends d.$rN{constructor(m,c,n,i,o){super({getFolderUri:s=>{const t=c.filter(a=>a.name===s);if(t&&t.length>0)return t[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(s,t)=>i[`config:${t}`],getExecPath:()=>m.VSCODE_EXEC_PATH,getAppRoot:()=>m.VSCODE_CWD,getFilePath:()=>{if(n)return P.$hc(n.fsPath)},getSelectedText:()=>i.selectedText,getLineNumber:()=>i.lineNumber,getExtension:async s=>{const a=(await o.getInstalled()).find($=>$.identifier.id===s);return a&&{extensionLocation:a.location}}},void 0,Promise.resolve(D.homedir()),Promise.resolve(m))}}class p extends I.$Sc{constructor(m,c,n,i,o,s){super(),this.g=m,this.h=c,this.j=n,this.m=i,this.n=o,this.r=s,this.a=0,this.b=new Map,this.c=this.B(new R.$Od),this.onExecuteCommand=this.c.event}async call(m,c,n){switch(c){case"$restartPtyHost":return this.j.restartPtyHost.apply(this.j,n);case"$createProcess":{const i=(0,A.$Er)(m.remoteAuthority);return this.s(i,n)}case"$attachToProcess":return this.j.attachToProcess.apply(this.j,n);case"$detachFromProcess":return this.j.detachFromProcess.apply(this.j,n);case"$listProcesses":return this.j.listProcesses.apply(this.j,n);case"$getLatency":return this.j.getLatency.apply(this.j,n);case"$getPerformanceMarks":return this.j.getPerformanceMarks.apply(this.j,n);case"$orphanQuestionReply":return this.j.orphanQuestionReply.apply(this.j,n);case"$acceptPtyHostResolvedVariables":return this.j.acceptPtyHostResolvedVariables.apply(this.j,n);case"$start":return this.j.start.apply(this.j,n);case"$input":return this.j.input.apply(this.j,n);case"$acknowledgeDataEvent":return this.j.acknowledgeDataEvent.apply(this.j,n);case"$shutdown":return this.j.shutdown.apply(this.j,n);case"$resize":return this.j.resize.apply(this.j,n);case"$clearBuffer":return this.j.clearBuffer.apply(this.j,n);case"$getInitialCwd":return this.j.getInitialCwd.apply(this.j,n);case"$getCwd":return this.j.getCwd.apply(this.j,n);case"$processBinary":return this.j.processBinary.apply(this.j,n);case"$sendCommandResult":return this.u(n[0],n[1],n[2]);case"$installAutoReply":return this.j.installAutoReply.apply(this.j,n);case"$uninstallAllAutoReplies":return this.j.uninstallAllAutoReplies.apply(this.j,n);case"$getDefaultSystemShell":return this.w.apply(this,n);case"$getProfiles":return this.y.apply(this,n);case"$getEnvironment":return this.z();case"$getWslPath":return this.C(n[0],n[1]);case"$getTerminalLayoutInfo":return this.j.getTerminalLayoutInfo(n);case"$setTerminalLayoutInfo":return this.j.setTerminalLayoutInfo(n);case"$serializeTerminalState":return this.j.serializeTerminalState.apply(this.j,n);case"$reviveTerminalProcesses":return this.j.reviveTerminalProcesses.apply(this.j,n);case"$getRevivedPtyNewId":return this.j.getRevivedPtyNewId.apply(this.j,n);case"$setUnicodeVersion":return this.j.setUnicodeVersion.apply(this.j,n);case"$reduceConnectionGraceTime":return this.D();case"$updateIcon":return this.j.updateIcon.apply(this.j,n);case"$updateTitle":return this.j.updateTitle.apply(this.j,n);case"$updateProperty":return this.j.updateProperty.apply(this.j,n);case"$refreshProperty":return this.j.refreshProperty.apply(this.j,n);case"$requestDetachInstance":return this.j.requestDetachInstance(n[0],n[1]);case"$acceptDetachedInstance":return this.j.acceptDetachInstanceReply(n[0],n[1]);case"$freePortKillProcess":return this.j.freePortKillProcess.apply(this.j,n);case"$acceptDetachInstanceReply":return this.j.acceptDetachInstanceReply.apply(this.j,n)}throw new Error(`IPC Command ${c} not found`)}listen(m,c,n){switch(c){case"$onPtyHostExitEvent":return this.j.onPtyHostExit||R.Event.None;case"$onPtyHostStartEvent":return this.j.onPtyHostStart||R.Event.None;case"$onPtyHostUnresponsiveEvent":return this.j.onPtyHostUnresponsive||R.Event.None;case"$onPtyHostResponsiveEvent":return this.j.onPtyHostResponsive||R.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.j.onPtyHostRequestResolveVariables||R.Event.None;case"$onProcessDataEvent":return this.j.onProcessData;case"$onProcessReadyEvent":return this.j.onProcessReady;case"$onProcessExitEvent":return this.j.onProcessExit;case"$onProcessReplayEvent":return this.j.onProcessReplay;case"$onProcessOrphanQuestion":return this.j.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.j.onDidRequestDetach||R.Event.None;case"$onDidChangeProperty":return this.j.onDidChangeProperty}throw new Error(`IPC Command ${c} not found`)}async s(m,c){const n={name:c.shellLaunchConfig.name,executable:c.shellLaunchConfig.executable,args:c.shellLaunchConfig.args,cwd:typeof c.shellLaunchConfig.cwd=="string"||typeof c.shellLaunchConfig.cwd>"u"?c.shellLaunchConfig.cwd:v.URI.revive(m.transformIncoming(c.shellLaunchConfig.cwd)),env:c.shellLaunchConfig.env,useShellEnvironment:c.shellLaunchConfig.useShellEnvironment,reconnectionProperties:c.shellLaunchConfig.reconnectionProperties,type:c.shellLaunchConfig.type,isFeatureTerminal:c.shellLaunchConfig.isFeatureTerminal},i=await(0,f.$Dm)(c.resolverEnv,!!c.shellLaunchConfig.useShellEnvironment,C.$w,this.g,this.h,this.r);this.h.trace("baseEnv",i);const o=he=>({uri:v.URI.revive(m.transformIncoming(he.uri)),name:he.name,index:he.index,toResource:()=>{throw new Error("Not implemented")}}),s=c.workspaceFolders.map(o),t=c.activeWorkspaceFolder?o(c.activeWorkspaceFolder):void 0,a=c.activeFileResource?v.URI.revive(m.transformIncoming(c.activeFileResource)):void 0,$=new h(i,s,a,c.resolvedVariables,this.n),w=g.$nN(t,process.env,$),k=await g.$mN(n,D.homedir(),w,t?.uri,c.configuration["terminal.integrated.cwd"],this.h);n.cwd=k;const E=C.$j?"terminal.integrated.env.windows":C.$k?"terminal.integrated.env.osx":"terminal.integrated.env.linux",L=c.configuration[E],j=await g.$oN(n,L,w,this.m.version,c.configuration["terminal.integrated.detectLocale"],i);if(!n.strictEnv){const he=[];for(const[ne,J,W]of c.envVariableCollections)he.push([ne,{map:(0,u.$qr)(J),descriptionMap:(0,u.$rr)(W)}]);const _=new Map(he),de=new y.$ur(_),Z=t?t??void 0:void 0;await de.applyToProcessEnvironment(j,{workspaceFolder:Z},w)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:n,initialCwd:k,cols:c.cols,rows:c.rows,env:j});const x=(0,b.$Ih)();j.VSCODE_IPC_HOOK_CLI=x;const ce=await this.j.createProcess(n,k,c.cols,c.rows,c.unicodeVersion,j,i,c.options,c.shouldPersistTerminal,c.workspaceId,c.workspaceName),X={executeCommand:(he,..._)=>this.t(ce,he,_,m)},ie=new S.$RM(X,this.h,x);return this.j.onProcessExit(he=>he.id===ce&&ie.dispose()),{persistentTerminalId:ce,resolvedShellLaunchConfig:n}}t(m,c,n,i){let o,s;const t=new Promise((w,k)=>{o=w,s=k}),a=++this.a;this.b.set(a,{resolve:o,reject:s,uriTransformer:i});const $=(0,r.$0m)(n,w=>{if(w&&w.$mid===1)return i.transformOutgoing(w);if(w&&w instanceof v.URI)return i.transformOutgoingURI(w)});return this.c.fire({reqId:a,persistentProcessId:m,commandId:c,commandArgs:$}),t}u(m,c,n){const i=this.b.get(m);if(!i)return;this.b.delete(m);const o=(0,r.$0m)(n,s=>{if(s&&s.$mid===1)return i.uriTransformer.transformIncoming(s)});c?i.reject(o):i.resolve(o)}w(m){return this.j.getDefaultSystemShell(m)}async y(m,c,n,i){return this.j.getProfiles(m,c,n,i)||[]}z(){return{...process.env}}C(m,c){return this.j.getWslPath(m,c)}D(){return this.j.reduceConnectionGraceTime()}}e.$sN=p}),define(pe[291],be([1,0,28,5,2,12,7,101,21,43,24,116,207,81,208,25,125,30,82,119,217,138,16,111,68,66,110,83,84,120,13,55,31,44,234,139,118,32,38,247,89,255,34,123,266,267,239,245,290,70,46,273,283,127,58,129,45,33,69,246,114,126,124,113,112,201,280,230,259,252]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u,g,d,f,h,p,l,m,c,n,i,o,s,t,a,$,w,k,E,L,j,x,ce,X,ie,he,_,de,Z,ne,J,W,oe,le,re,ee,B,K,N,O,U,T,q,z,te,H,Y,V,Q,se,me,Ee,Ce,Le,Fe,$e,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XN=e.$WN=void 0;const ye="monacoworkbench";async function Me(Ie,Ne,ze,He){const Be=new a.$Oh,Ve=new We,Je={_serviceBrand:void 0,...E.default};Be.set(L.$qj,Je);const Ge=new K.$pm(Ne,Je);Be.set(d.$Xh,Ge),Be.set(d.$Yh,Ge);const Ye=new V.$DN((0,k.$mj)(Ge),Ge.logsHome);Be.set(k.$_i,Ye),Ve.registerChannel("logger",new Ee.$dr(Ye,nt=>Ze(nt.remoteAuthority)));const it=Ye.createLogger("remoteagent",{name:(0,Ce.localize)(0,null)}),_e=new me.$NN(it,[new Xe((0,k.$mj)(Ge))]);Be.set(k.$$i,_e),setTimeout(()=>Pe(Ge.logsHome.with({scheme:I.Schemas.file}).fsPath).then(null,nt=>_e.error(nt)),1e4),_e.onDidChangeLogLevel(nt=>(0,k.log)(_e,nt,`Log level changed to ${(0,k.$nj)(_e.getLevel())}`)),_e.trace(`Remote configuration data at ${ze}`),_e.trace("process arguments:",Ge.args),Array.isArray(Je.serverGreeting)&&_e.info(`

${Je.serverGreeting.join(`
`)}

`),Ve.registerChannel(y.$Qn.ChannelName,new y.$Qn);const st=new b.$yh(nt=>nt.clientId==="renderer"),ot=He.add(new i.$Rp(_e));Be.set(n.$_j,ot),ot.registerProvider(I.Schemas.file,He.add(new o.$eq(_e)));const vt=new J.$Dr(ot);Be.set(ne.$Jk,vt);const dt=new S.$On(Ge.machineSettingsResource,ot,new H.$on,_e);Be.set(A.$ki,dt);const ft=new Q.$LN(vt,Ge,ot,_e);Be.set(te.$Lk,ft),Ve.registerChannel("userDataProfiles",new $e.$TN(ft,nt=>Ze(nt.remoteAuthority)));const[,,Tt,Ut]=await Promise.all([dt.initialize(),ft.init(),(0,C.$Tm)(_e.error.bind(_e)),(0,C.$Um)(_e.error.bind(_e))]),yt=new U.$xm;Be.set(U.$wm,yt);const Et=new ce.$3q(dt,Ge,_e,Ye);Be.set(j.$Wo,Et);let ct=he.$to;const kt=(0,he.$Ao)(Je,dt);if((0,he.$vo)(Je,Ge)){!(0,he.$wo)(Je,Ge)&&Je.aiConfig?.ariaKey&&(ct=new Y.$BN(Et,kt,ye,null,Je.aiConfig.ariaKey),He.add((0,r.$Qc)(()=>ct?.flush())));const nt={appenders:[ct],commonProperties:(0,X.$lo)((0,D.release)(),(0,D.hostname)(),process.arch,Je.commit,Je.version+"-remote",Tt,Ut,kt,"remoteAgent"),piiPaths:(0,he.$Bo)(Ge)},lt=Ge.args["telemetry-level"];let gt=3;lt==="all"?gt=3:lt==="error"?gt=2:lt==="crash"?gt=1:lt!==void 0&&(gt=0),Be.set(re.$Rr,new s.$Nh(re.$Pr,[nt,gt]))}else Be.set(re.$Rr,re.$Qr);Be.set(h.$bo,new s.$Nh(f.$hp));const Ot=Ve.getChannel("download",st);Be.set(u.$Sn,new g.$Un(Ot,()=>Ze("renderer"))),Be.set(z.$yp,new s.$Nh(se.$MN)),Be.set(T.$Cp,new s.$Nh(q.$zN)),Be.set(p.$ip,new s.$Nh(p.$jp)),Be.set(c.$Mp,new s.$Nh(c.$Np));const mt=new t.$hq(Be);Be.set($.$Wq,mt.createInstance(w.$Yq));const zt=mt.createInstance(ke.$VN,{graceTime:108e5,shortGraceTime:3e5,scrollback:dt.getValue("terminal.integrated.persistentSessionScrollback")??100}),Ft=mt.createInstance(Z.$zr,zt);return Be.set(de.$$q,Ft),mt.invokeFunction(nt=>{const lt=nt.get(c.$Mp),gt=nt.get(T.$Cp),jt=nt.get(h.$bo),qt=nt.get($.$Wq),Bt=new W.$Lr(Ie,Ge,ft,yt);Ve.registerChannel("remoteextensionsenvironment",Bt);const Ct=new le.$Sr(nt.get(re.$Rr),ct);Ve.registerChannel("telemetry",Ct),Ve.registerChannel(N.$tN,new ee.$sN(Ge,_e,Ft,Je,lt,dt));const It=new Le.$RN(mt.createInstance(l.$kp,_e),Ge,ft,gt,_e,jt,qt);Ve.registerChannel(Fe.$QN,new Le.$SN(It,pt=>Ze(pt.remoteAuthority)));const At=new oe.$Or(_e,Ge);Ve.registerChannel(O.$xN,At),Ve.registerChannel("request",new x.$Zq(nt.get(j.$Wo)));const Lt=new m.$lp(lt,pt=>Ze(pt.remoteAuthority));return Ve.registerChannel("extensions",Lt),It.whenExtensionsReady().then(()=>lt.cleanUp()),He.add(new _.default(nt.get(ie.$dl))),{telemetryService:nt.get(ie.$dl)}}),{socketServer:Ve,instantiationService:mt}}e.$WN=Me;const Ue=Object.create(null);function Ze(Ie){return Ue[Ie]||(Ue[Ie]=(0,B.$Er)(Ie)),Ue[Ie]}class We extends b.$uh{constructor(){const Ne=new R.$Od;super(Ne.event),this.b=Ne}acceptConnection(Ne,ze){this.b.fire({protocol:Ne,onDidClientDisconnect:ze})}}e.$XN=We;class Xe extends k.$dj{constructor(Ne=k.$bj){super(),this.setLevel(Ne),this.g=!!process.stdout.isTTY}trace(Ne,...ze){this.f(k.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${Qe()}]\x1B[0m`,Ne,...ze):console.log(`[${Qe()}]`,Ne,...ze))}debug(Ne,...ze){this.f(k.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${Qe()}]\x1B[0m`,Ne,...ze):console.log(`[${Qe()}]`,Ne,...ze))}info(Ne,...ze){this.f(k.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${Qe()}]\x1B[0m`,Ne,...ze):console.log(`[${Qe()}]`,Ne,...ze))}warn(Ne,...ze){this.f(k.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${Qe()}]\x1B[0m`,Ne,...ze):console.warn(`[${Qe()}]`,Ne,...ze))}error(Ne,...ze){this.f(k.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${Qe()}]\x1B[0m`,Ne,...ze):console.error(`[${Qe()}]`,Ne,...ze))}dispose(){}flush(){}}function Qe(){const Ie=new Date;return`${ge(Ie.getHours())}:${ge(Ie.getMinutes())}:${ge(Ie.getSeconds())}`}function ge(Ie){return Ie<10?`0${Ie}`:String(Ie)}async function Pe(Ie){const Ne=P.$nc(Ie),ze=P.$mc(Ie),Ve=(await v.Promises.readdir(ze)).filter(Ge=>/^\d{8}T\d{6}$/.test(Ge)).sort().filter(Ge=>Ge!==Ne),Je=Ve.slice(0,Math.max(0,Ve.length-9));await Promise.all(Je.map(Ge=>v.Promises.rm(P.$jc(ze,Ge))))}}),define(pe[292],be([1,0,87,27,78,293,85,94,15,11,40,2,12,7,41,3,17,4,23,167,153,288,106,72,24,6,13,31,57,32,140,260,261,46,291,263]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y,u,g,d,f,h,p,l,m,c,n,i,o,s,t,a,$,w,k,E,L,j,x,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2N=void 0;const X=5*60*1e3;let ie=class extends S.$Sc{constructor(Z,ne,J,W,oe,le,re,ee){super(),this.n=Z,this.r=ne,this.s=J,this.t=oe,this.u=le,this.w=re,this.y=ee,this.h=_.create(this.u),this.j=(0,$.$Xk)(le),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=W?this.y.createInstance(ce.$1N,this.r):null,this.w.info("Extension host agent started."),this.L(!0)}async handleRequest(Z,ne){if(Z.method!=="GET")return(0,ce.$YN)(Z,ne,405,`Unsupported method ${Z.method}`);if(!Z.url)return(0,ce.$YN)(Z,ne,400,"Bad request.");const J=P.parse(Z.url,!0);let W=J.pathname;if(!W)return(0,ce.$YN)(Z,ne,400,"Bad request.");if(W.startsWith(this.j)&&W.charCodeAt(this.j.length)===47&&(W=W.substring(this.j.length)),W==="/version")return ne.writeHead(200,{"Content-Type":"text/plain"}),void ne.end(this.u.commit||"");if(W==="/delay-shutdown")return this.N(),ne.writeHead(200),void ne.end("OK");if(!(0,L.$Lm)(this.r,Z,J))return(0,ce.$YN)(Z,ne,403,"Forbidden.");if(W==="/vscode-remote-resource"){const oe=J.query.path;if(typeof oe!="string")return(0,ce.$YN)(Z,ne,400,"Bad request.");let le;try{le=h.URI.from({scheme:y.Schemas.file,path:oe}).fsPath}catch{return(0,ce.$YN)(Z,ne,400,"Bad request.")}const re=Object.create(null);this.t.isBuilt&&((0,A.$Yf)(le,this.t.builtinExtensionsPath,!d.$l)||(0,A.$Yf)(le,this.t.extensionsPath,!d.$l))&&(re["Cache-Control"]="public, max-age=31536000"),re.Vary="Origin";const ee=Z.headers.origin;return ee&&this.h.matches(ee)&&(re["Access-Control-Allow-Origin"]=ee),(0,ce.$ZN)(le,1,this.w,Z,ne,re)}if(this.g){this.g.handle(Z,ne,J);return}return ne.writeHead(404,{"Content-Type":"text/plain"}),void ne.end("Not found")}handleUpgrade(Z,ne){let J=(0,p.$fg)(),W=!1,oe=!1;if(Z.url){const N=P.parse(Z.url,!0).query;typeof N.reconnectionToken=="string"&&(J=N.reconnectionToken),N.reconnection==="true"&&(W=!0),N.skipWebSocketFrames==="true"&&(oe=!0)}if(Z.headers.upgrade===void 0||Z.headers.upgrade.toLowerCase()!=="websocket"){ne.end("HTTP/1.1 400 Bad Request");return}const le=Z.headers["sec-websocket-key"],re=D.createHash("sha1");re.update(le+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const B=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${re.digest("base64")}`];let K=!1;if(!oe&&!this.t.args["disable-websocket-compression"]&&Z.headers["sec-websocket-extensions"]){const N=Array.isArray(Z.headers["sec-websocket-extensions"])?Z.headers["sec-websocket-extensions"]:[Z.headers["sec-websocket-extensions"]];for(const O of N)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(O)){if(/\b(permessage-deflate)\b/.test(O)){K=!0,B.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(O)){K=!0,B.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}ne.write(B.join(`\r
`)+`\r
\r
`),ne.setTimeout(0),ne.setNoDelay(!0),oe?this.D(new i.$Fh(ne,`server-connection-${J}`),W,J):this.D(new i.$Gh(new i.$Fh(ne,`server-connection-${J}`),K,null,!0),W,J)}handleServerError(Z){this.w.error("Error occurred in server"),this.w.error(Z)}z(Z){let ne;return Z instanceof i.$Fh?ne=Z.socket:ne=Z.socket.socket,ne.remoteAddress||"<unknown>"}async C(Z,ne,J){const W=ne.getSocket();this.w.error(`${Z} ${J}.`);const oe={type:"error",reason:J};ne.sendControl(v.$ce.fromString(JSON.stringify(oe))),ne.dispose(),await W.drain(),W.dispose()}D(Z,ne,J){const W=this.z(Z),oe=`[${W}][${J.substr(0,8)}]`,le=new n.$Eh({socket:Z}),re=this.s?new this.s.validator:null,ee=this.s?new this.s.signer:null;let B;(function(U){U[U.WaitingForAuth=0]="WaitingForAuth",U[U.WaitingForConnectionType=1]="WaitingForConnectionType",U[U.Done=2]="Done",U[U.Error=3]="Error"})(B||(B={}));let K=0;const N=U=>{K=3,O.dispose(),this.C(oe,le,U)},O=le.onControlMessage(U=>{if(K===0){let T;try{T=JSON.parse(U.toString())}catch{return N("Malformed first message")}if(T.type!=="auth")return N("Invalid first message");if(this.r.type===2&&!this.r.validate(T.auth))return N("Unauthorized client refused: auth mismatch");let q=(0,p.$fg)();if(ee)try{q=ee.sign(T.data)}catch{}let z=(0,p.$fg)();if(re)try{z=re.createNewMessage(z)}catch{}const te={type:"sign",data:z,signedData:q};le.sendControl(v.$ce.fromString(JSON.stringify(te))),K=1}else if(K===1){let T;try{T=JSON.parse(U.toString())}catch{return N("Malformed second message")}if(T.type!=="connectionType")return N("Invalid second message");if(typeof T.signedData!="string")return N("Invalid second message field type");const q=T.commit,z=this.u.commit;if(q&&z&&q!==z)return N("Client refused: version mismatch");let te=!1;if(!re)te=!0;else if(this.r.validate(T.signedData))te=!0;else try{te=re.validate(T.signedData)==="ok"}catch{}if(!te){if(this.t.isBuilt)return N("Unauthorized client refused");this.w.error(`${oe} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const H in this.b)this.b[H].shortenReconnectionGraceTimeIfNecessary();for(const H in this.a)this.a[H].shortenReconnectionGraceTimeIfNecessary();K=2,O.dispose(),this.F(W,oe,le,Z,ne,J,T)}})}async F(Z,ne,J,W,oe,le,re){const ee=re.desiredConnectionType===1?`${ne}[ManagementConnection]`:re.desiredConnectionType===2?`${ne}[ExtensionHostConnection]`:ne;if(re.desiredConnectionType===1)if(oe){if(!this.b[le])return this.f.has(le)?this.C(ee,J,"Unknown reconnection token (seen before)"):this.C(ee,J,"Unknown reconnection token (never seen)");J.sendControl(v.$ce.fromString(JSON.stringify({type:"ok"})));const B=J.readEntireBuffer();J.dispose(),this.b[le].acceptReconnection(Z,W,B)}else{if(this.b[le])return this.C(ee,J,"Duplicate reconnection token");J.sendControl(v.$ce.fromString(JSON.stringify({type:"ok"})));const B=new E.$Fm(this.w,le,Z,J);this.n.acceptConnection(B.protocol,B.onClose),this.b[le]=B,this.f.add(le),B.onClose(()=>{delete this.b[le]})}else if(re.desiredConnectionType===2){const B=re.args||{language:"en"},K=await this.I(B);if(K.port&&this.w.trace(`${ee} - startParams debug port ${K.port}`),this.w.trace(`${ee} - startParams language: ${K.language}`),this.w.trace(`${ee} - startParams env: ${JSON.stringify(K.env)}`),oe){if(!this.a[le])return this.f.has(le)?this.C(ee,J,"Unknown reconnection token (seen before)"):this.C(ee,J,"Unknown reconnection token (never seen)");J.sendPause(),J.sendControl(v.$ce.fromString(JSON.stringify(K.port?{debugPort:K.port}:{})));const N=J.readEntireBuffer();J.dispose(),this.a[le].acceptReconnection(Z,W,N)}else{if(this.a[le])return this.C(ee,J,"Duplicate reconnection token");J.sendPause(),J.sendControl(v.$ce.fromString(JSON.stringify(K.port?{debugPort:K.port}:{})));const N=J.readEntireBuffer();J.dispose();const O=this.y.createInstance(k.$Em,le,Z,W,N);this.a[le]=O,this.f.add(le),O.onClose(()=>{delete this.a[le],this.J()}),O.start(K)}}else if(re.desiredConnectionType===3){const B=re.args;this.G(J,B)}else return this.C(ee,J,"Unknown initial data received")}async G(Z,ne){const J=Z.getSocket().socket,W=Z.readEntireBuffer();Z.dispose(),J.pause();const oe=await this.H(ne.host,ne.port);W.byteLength>0&&oe.write(W.buffer),oe.on("end",()=>J.end()),oe.on("close",()=>J.end()),oe.on("error",()=>J.destroy()),J.on("end",()=>oe.end()),J.on("close",()=>oe.end()),J.on("error",()=>oe.destroy()),oe.pipe(J),J.pipe(oe)}H(Z,ne){return new Promise((J,W)=>{const oe=r.createConnection({host:Z,port:ne,autoSelectFamily:!0},()=>{oe.removeListener("error",W),oe.pause(),J(oe)});oe.once("error",W)})}I(Z){return typeof Z.port=="number"?(0,m.$hg)(Z.port,10,5e3).then(ne=>(Z.port=ne,Z)):(Z.debugId=void 0,Z.port=void 0,Z.break=void 0,Promise.resolve(Z))}async J(){if(!this.t.args["enable-remote-auto-shutdown"])return;this.O(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.w.info("Last EH closed, waiting before shutting down"),this.L())}L(Z=!1){this.t.args["enable-remote-auto-shutdown"]&&(this.t.args["remote-auto-shutdown-without-delay"]&&!Z?this.M():this.m=setTimeout(()=>{this.m=void 0,this.M()},X))}M(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.w.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.w.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}N(){this.m&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.w.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.O(),this.L())}O(){this.m&&(console.log("Cancelling previous shutdown timeout"),this.w.info("Cancelling previous shutdown timeout"),clearTimeout(this.m),this.m=void 0)}};ie=Oe([Ae(4,j.$om),Ae(5,a.$qj),Ae(6,t.$$i),Ae(7,s.$Ph)],ie);async function he(de,Z,ne){const J=await(0,L.$Km)(Z);J instanceof L.$Im&&(console.warn(J.message),process.exit(1));function W(te){(0,b.setUnexpectedErrorHandler)(H=>{(0,b.$Z)(H)&&H.stack&&/unexpectedErrorHandler/.test(H.stack)||te(H)})}const oe=[];W(te=>{oe.push(te),console.error(te)});let le=!1;process.on("SIGPIPE",()=>{le||(le=!0,(0,b.$1)(new Error("Unexpected SIGPIPE")))});const re=new S.$Rc,{socketServer:ee,instantiationService:B}=await(0,x.$WN)(J,Z,ne,re);B.invokeFunction(te=>{const H=te.get(t.$$i);oe.forEach(Y=>H.error(Y)),oe.length=0,W(Y=>H.error(Y))}),B.invokeFunction(te=>{const H=te.get(o.$ki);d.$j&&(H.getValue("security.restrictUNCAccess")===!1?(0,c.disableUNCAccessRestrictions)():(0,c.addUNCHostToAllowlist)(H.getValue("security.allowedUNCHosts")))}),B.invokeFunction(te=>{const H=te.get(t.$$i);if(d.$j&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const Y=(0,u.$jc)(process.env.HOMEDRIVE,"node_modules"),V=(0,u.$mc)((0,u.$jc)(process.env.HOMEDRIVE,process.env.HOMEPATH)),Q=(0,u.$jc)(V,"node_modules");if(R.existsSync(Y)||R.existsSync(Q)){const se=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${Y}
* ${Q}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;H.warn(se),console.warn(se),process.exit(0)}}});const K=B.invokeFunction(te=>{const H=te.get(t.$$i);if(R.existsSync((0,u.$jc)(y.$dg.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(V){H.error(V)}return null}),N=R.existsSync(y.$dg.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(N&&de&&typeof de!="string"){const te=J.type!==0?`?${y.$9f}=${J.value}`:"";console.log(`Web UI available at http://localhost${de.port===80?"":`:${de.port}`}/${te}`)}const O=B.createInstance(ie,ee,J,K,N);g.mark("code/server/ready");const U=I.performance.now(),T=global.vscodeServerStartTime,q=global.vscodeServerListenTime,z=global.vscodeServerCodeLoadedTime;if(B.invokeFunction(async te=>{const H=te.get(w.$dl);if(H.publicLog2("serverStart",{startTime:T,startedTime:q,codeLoadedTime:z,readyTime:U}),d.$l){const Y=te.get(t.$$i),V=await(0,l.$gg)(Y.error.bind(Y));V&&H.publicLog2("serverPlatformInfo",{platformId:V.id,platformVersionId:V.version_id,platformIdLike:V.id_like})}}),Z["print-startup-performance"]){const te=C.$U.get();let H="";H+=`

### Load AMD-module
`,H+=C.$U.toMarkdownTable(["Module","Duration"],te.amdLoad),H+=`

### Load commonjs-module
`,H+=C.$U.toMarkdownTable(["Module","Duration"],te.nodeRequire),H+=`

### Invoke AMD-module factory
`,H+=C.$U.toMarkdownTable(["Module","Duration"],te.amdInvoke),H+=`

### Invoke commonjs-module
`,H+=C.$U.toMarkdownTable(["Module","Duration"],te.nodeEval),H+=`Start-up time: ${q-T}
`,H+=`Code loading time: ${z-T}
`,H+=`Initialized time: ${U-T}
`,H+=`
`,console.log(H)}return O}e.$2N=he;class _{static create(Z){const ne=Z.webEndpointUrlTemplate,J=Z.commit,W=Z.quality;if(!ne||!J||!W)return new _(null);const oe=(0,p.$fg)(),re=new URL(ne.replace("{{uuid}}",oe).replace("{{commit}}",J).replace("{{quality}}",W)).origin,ee=(0,f.$Ge)(re).replace(oe,"[a-zA-Z0-9\\-]+");try{const B=(0,f.$Oe)(`^${ee}$`,!0,{matchCase:!1});return new _(B)}catch{return new _(null)}}constructor(Z){this.a=Z}matches(Z){return this.a?this.a.test(Z):!1}}}),define(pe[304],be([1,0,28,27,12,287,292,65,7,293,46,55,41]),function(ue,e,D,R,r,I,P,C,v,b,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,y.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=b.performance.now();const u={onMultipleValues:(s,t)=>{console.error(`Option '${s}' can only be defined once. Using value ${t}.`)},onEmptyValue:s=>{console.error(`Ignoring option '${s}': Value must not be empty.`)},onUnknownOption:s=>{console.error(`Ignoring option '${s}': not supported for server.`)},onDeprecatedOption:(s,t)=>{console.warn(`Option '${s}' is deprecated: ${t}`)}},g=(0,C.$Hl)(process.argv.slice(2),A.$nm,u),d=g["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,v.$jc)(D.homedir(),S.default.serverDataFolderName||".vscode-remote"),f=(0,v.$jc)(d,"data"),h=(0,v.$jc)(f,"User"),p=(0,v.$jc)(h,"globalStorage"),l=(0,v.$jc)(h,"History"),m=(0,v.$jc)(f,"Machine");g["user-data-dir"]=f;const c=(0,v.$mc)(r.$dg.asFileUri("").fsPath),n=(0,v.$jc)(c,"extensions");g["builtin-extensions-dir"]=n,g["extensions-dir"]=g["extensions-dir"]||(0,v.$jc)(d,"extensions"),[d,g["extensions-dir"],f,h,m,p,l].forEach(s=>{try{R.existsSync(s)||R.mkdirSync(s,{mode:448})}catch(t){console.error(t)}});function i(){(0,I.run)(g,d,A.$nm)}e.spawnCli=i;function o(s){return(0,P.$2N)(s,g,d)}e.createServer=o})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/2b35e1e6d88f1ce073683991d1eff5284a32690f/core/vs/server/node/server.main.js.map
